unit ImportTextFormUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  fcOutlookList, fcButton, fcImgBtn, fcShapeBtn, TFlatSplitterUnit,
  StdCtrls, TFlatMemoUnit, ExtCtrls, ComCtrls, fcClearPanel, fcButtonGroup,
  fcOutlookBar, BPInt,TranslateUnit, RichEdit2,RichEdit, Menus,
  AnimatedMenus98,ClipBrd;

type
  TImportTextForm = class(TForm)
    fcOutlookBar1: TfcOutlookBar;
    Panel1: TPanel;
    fcOutlookBar1OutlookList1: TfcOutlookList;
    fcOutlookBar1fcShapeBtn1: TfcShapeBtn;
    ImageList1: TImageList;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    BPList: TBPList;
    TranslateStatus: TRichEdit98;
    Editor: TRichEdit98;
    FlatSplitter1: TFlatSplitter;
    ResSaveDialog: TSaveDialog;
    FindDialog: TFindDialog;
    ReplaceDialog: TReplaceDialog;
    EditorPopupMenu: TPopupMenu98;
    EditorCutItem: TMenuItem;
    EditorCopyItem: TMenuItem;
    EditorPasteItem: TMenuItem;
    EditorUndoItem: TMenuItem;
    EditorRedoItem: TMenuItem;
    N6: TMenuItem;
    N7: TMenuItem;
    EditorFintItem: TMenuItem;
    EditorReplaceItem: TMenuItem;
    MenuItemBitmaps1: TMenuItemBitmaps;
    MenuItemBitmaps2: TMenuItemBitmaps;
    MenuItemBitmaps3: TMenuItemBitmaps;
    MenuItemBitmaps4: TMenuItemBitmaps;
    MenuItemBitmaps5: TMenuItemBitmaps;
    MenuItemBitmaps6: TMenuItemBitmaps;
    MenuItemBitmaps7: TMenuItemBitmaps;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure fcOutlookBar1OutlookList1ItemClick(
      OutlookList: TfcCustomOutlookList; Item: TfcOutlookListItem);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure TranslateStatusMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure FindDialogFind(Sender: TObject);
    procedure ReplaceDialogReplace(Sender: TObject);
    procedure EditorUndoItemClick(Sender: TObject);
    procedure EditorRedoItemClick(Sender: TObject);
    procedure EditorCutItemClick(Sender: TObject);
    procedure EditorCopyItemClick(Sender: TObject);
    procedure EditorPasteItemClick(Sender: TObject);
    procedure EditorFintItemClick(Sender: TObject);
    procedure EditorReplaceItemClick(Sender: TObject);
    procedure EditorPopupMenuPopup(Sender: TObject);
  protected
    procedure WMChangeCBChain(var Msg: TWMChangeCBChain); message WM_CHANGECBCHAIN;
    procedure WMDrawClipboard(var Msg: TWMDrawClipboard); message WM_DRAWCLIPBOARD;
  private
    { Private declarations }
    FClipboardOwner:HWND;
    FFileName:String;
    FTranslator:TBPTranslator;
    FSuccess:Boolean;
    FFileSaved:Boolean;
    procedure InitForm;
    procedure DoneForm;
    procedure CreateFile;
    procedure OpenFile;
    procedure SaveFile;
    procedure TranslateFile;
    procedure ClipboardChanged;
  public
    { Public declarations }
    procedure LoadFromFile(fname:String);
  end;

var
  ImportTextForm: TImportTextForm;

implementation

uses MainUnit;


{$R *.DFM}

procedure TImportTextForm.TranslateFile;
 begin
  { hm }
   FFileSaved:=False;
   FTranslator.InitTranslator;
   FSuccess:=FTranslator.Translate;
   if FSuccess then
   begin
    ResSaveDialog.InitialDir:=ExtractFilePath(Application.ExeName);
    ResSaveDialog.FileName:=FTranslator.FileName;
          if ResSaveDialog.Execute then
            begin
              FTranslator.FileName:=ResSaveDialog.FileName;
              FTranslator.SaveResults;
              FFileSaved:=True;
            end;
    end;
 end;

procedure TImportTextForm.CreateFile;
 begin
  TranslateStatus.Clear;
  Editor.Clear;
  Editor.Modified:=False;
  FFileName:='';
 end;

procedure TImportTextForm.LoadFromFile(fname:String);
 begin
   FFileName:=FName;
   Editor.Lines.LoadFromFile(FName);
   TranslateStatus.Clear;
 end;

procedure TImportTextForm.OpenFile;
 begin
  if Editor.Modified then SaveFile;
  OpenDialog.InitialDir:=ExtractFilePath(Application.ExeName);
  if OpenDialog.Execute then
     begin
      FFileName:=OpenDialog.FileName;
      Editor.Lines.LoadFromFile(FFileName);
      TranslateStatus.Clear;
     end;
 end;

procedure TImportTextForm.SaveFile;
 begin
  if (FFileName<>'') then
   begin
     Editor.Lines.SaveToFile(FFileName);
   end
    else
   begin
     SaveDialog.InitialDir:=Application.ExeName;
     if SaveDialog.Execute then
       begin
        FFileName:=SaveDialog.FileName;
        Editor.Lines.SaveToFile(FFileName);
        Editor.Modified:=False;
       end;
   end;
 end;


procedure TImportTextForm.DoneForm;
 begin
   ChangeClipboardChain(Handle, FClipboardOwner);
   fcOutlookBar1OutlookList1.Items.Clear;
   FTranslator.Free;
 end;

procedure TImportTextForm.InitForm;
Var item:TfcOutlookListItem;
 begin
   FClipboardOwner:=SetClipboardViewer(Handle);
   fcOutlookBar1fcShapeBtn1.Caption:='';
   fcOutlookBar1fcShapeBtn1.Color:=clBtnFace;
   fcOutlookBar1OutLookList1.Items.Clear;
   item:=fcOutlookBar1OutlookList1.Items.Add;
   item.ImageIndex:=0;
   item.Text:='&';
   item:=fcOutlookBar1OutlookList1.Items.Add;
   item.ImageIndex:=1;
   item.Text:='&';
   item:=fcOutlookBar1OutlookList1.Items.Add;
   item.ImageIndex:=2;
   item.Text:='&';
   item:=fcOutlookBar1OutlookList1.Items.Add;
   item.ImageIndex:=3;
   item.Text:='&';
   item:=fcOutlookBar1OutlookList1.Items.Add;
   item.ImageIndex:=4;
   item.Text:='&';
   Editor.Modified:=False;
   FFileName:='';
   BPList.Debug:=BPViewMainForm.Debug;
   FTranslator:=TBPTranslator.Create(Editor,TranslateStatus,BPList);
   SendMessage(Editor.Handle,EM_EXLIMITTEXT,0,4096*1024);
 end;


procedure TImportTextForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action:=caFree;
end;

procedure TImportTextForm.FormCreate(Sender: TObject);
begin
  InitForm;
end;

procedure TImportTextForm.FormDestroy(Sender: TObject);
begin
  DoneForm;
end;

procedure TImportTextForm.fcOutlookBar1OutlookList1ItemClick(
  OutlookList: TfcCustomOutlookList; Item: TfcOutlookListItem);
begin
  case Item.ImageIndex of
   0:  { Create }
       CreateFile;
   1:  { Open   }
       OpenFile;
   2:  { Save   }
       SaveFile;
   3:  { Translate }
       begin
        BPViewMainForm.SetActiveAnimate(True);
        TranslateFile;
        if FSuccess and FFileSaved then
         begin
          BPViewMainForm.UpdateModelListItemClick(self);
          BPViewMainForm.QuerySave;
          BPViewMainForm.LoadFromFile(FTranslator.FileName);
         end;
        BPViewMainForm.SetActiveAnimate(False);
        if FSuccess then Close;
       end;
   4:  Close;
  end;
end;

procedure TImportTextForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
   if Editor.Modified then SaveFile;
   CanClose:=True;
end;

procedure TImportTextForm.TranslateStatusMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
Var s:String;
    i,l:Integer;
    s1,s2:String;
begin
  s:=TranslateStatus.Lines.Strings[TranslateStatus.Line];
  TranslateStatus.Col:=0;
  TranslateStatus.Line:=TranslateStatus.Line;
  TranslateStatus.SelLength:=Length(TranslateStatus.Lines.Strings[TranslateStatus.Line]);
  i:=pos('  ',s);
  if i>0 then s1:=Copy(s,pos('  ',s)+9,length(s));
  s2:='';
  while (s1[1]>='0') and (s1[1]<='9') do
    begin
      s2:=s2+s1[1];
      delete(s1,1,1);
    end;
  l:=StrToIntDef(s2,0);
  Editor.Line:=l;
  Editor.Col:=0;
  Editor.SelLength:=Length(Editor.Lines.Strings[Editor.Line]);
end;

procedure TImportTextForm.FindDialogFind(Sender: TObject);
var
  SearchStart: Integer;
  FS: TFindTextExW;
  Flags: Integer;
  W: WideString;
begin
  with TFindDialog(Sender) do
  begin
    if (frFindNext in Options) then
      SearchStart:= Editor.SelStart+Editor.SelLength
    else
      SearchStart:= Editor.SelStart;
    FS.chrg.cpMin:= SearchStart;
    FS.chrg.cpMax:= -1;
    W:= FindText;
    FS.lpstrText:= @W[1];
    if (frMatchCase in Options) then
      Flags:= FT_MATCHCASE
    else
      Flags:= 0;
    if (frWholeWord in Options) then
      Flags:= Flags or FT_WHOLEWORD;
    if (frDown in Options) then
      Flags:= Flags or FT_DOWNWARD;
    if (Editor.Perform(EM_FINDTEXTEX, Flags, Integer(@FS))>0) then
      begin
        Editor.SelStart := FS.chrgText.cpMin;
        Editor.SelLength := FS.chrgText.cpMax - FS.chrgText.cpMin;
      end
    else
      MessageBox(Handle, PChar(Format(' %s  ', [FindText])), 'Message',
                 mb_Ok+mb_IconInformation);
  end;
end;

procedure TImportTextForm.ReplaceDialogReplace(Sender: TObject);
var
  SearchStart: Integer;
  ReplCount: Integer;
  FS: TFindTextExW;
  Flags: Integer;
  W: wideString;
begin
  with ReplaceDialog do
  begin
    if (frReplaceAll in Options) then
      begin
        ReplCount:= 0;
        FS.chrg.cpMin:= Editor.SelStart;
        FS.chrg.cpMax:= -1;
        W:= FindText;
        FS.lpstrText:= @W[1];
        if (frMatchCase in Options) then
          Flags:= FT_MATCHCASE
        else
          Flags:= 0;
        if (frWholeWord in Options) then
          Flags:= Flags or FT_WHOLEWORD;
        if (frDown in Options) then
          Flags:= Flags or FT_DOWNWARD;
        while (Editor.Perform(EM_FINDTEXTEX, Flags, Integer(@FS))>-1) do
          begin
            Editor.SelStart := FS.chrgText.cpMin;
            Editor.SelLength := FS.chrgText.cpMax - FS.chrgText.cpMin;
            Editor.WideSelText:= ReplaceText;
            Inc(ReplCount);
            FS.chrg.cpMin:= Editor.SelStart+Length(ReplaceText);
          end;
        MessageBox(Handle, PChar(Format(' %d ', [ReplCount])), ' ',
                   mb_Ok+mb_IconInformation);
      end
    else
      begin
        if (frFindNext in Options) then
          SearchStart:= Editor.SelStart+Editor.SelLength
        else
          SearchStart:= Editor.SelStart;
        FS.chrg.cpMin:= SearchStart;
        FS.chrg.cpMax:= -1;
        W:= FindText;
        FS.lpstrText:= @W[1];
        if (frMatchCase in Options) then
          Flags:= FT_MATCHCASE
        else
          Flags:= 0;
        if (frWholeWord in Options) then
          Flags:= Flags or FT_WHOLEWORD;
        if (frDown in Options) then
          Flags:= Flags or FT_DOWNWARD;
        if (Editor.Perform(EM_FINDTEXTEX, Flags, Integer(@FS))>-1) then
          begin
            Editor.SelStart := FS.chrgText.cpMin;
            Editor.SelLength := FS.chrgText.cpMax - FS.chrgText.cpMin;
            Editor.WideSelText:=ReplaceText;
          end
        else
          MessageBox(Handle, PChar(Format(' %s  ', [FindText])), 'Message',
                     mb_Ok+mb_IconInformation);
      end;
  end;
end;

procedure TImportTextForm.EditorUndoItemClick(Sender: TObject);
begin
 if Editor.CanUndo then Editor.Undo;
end;

procedure TImportTextForm.EditorRedoItemClick(Sender: TObject);
begin
 if Editor.CanRedo then Editor.Redo;
end;

procedure TImportTextForm.EditorCutItemClick(Sender: TObject);
begin
 Editor.CutToClipboard;
end;

procedure TImportTextForm.EditorCopyItemClick(Sender: TObject);
begin
 Editor.CopyToClipboard;
end;

procedure TImportTextForm.EditorPasteItemClick(Sender: TObject);
begin
  Editor.PasteFromClipboard;
end;

procedure TImportTextForm.EditorFintItemClick(Sender: TObject);
begin
  FindDialog.Execute;
end;

procedure TImportTextForm.EditorReplaceItemClick(Sender: TObject);
begin
  ReplaceDialog.Execute;
end;

procedure TImportTextForm.ClipboardChanged;
var
  I: Integer;
  Format: Word;
  E: Boolean;
begin
  // check to see if we can paste what's on the clipboard
  E := False;
  for I := 0 to Clipboard.FormatCount - 1 do
  begin
    Format := Clipboard.Formats[I];
    if SendMessage(Editor.Handle, EM_CANPASTE, Format, 0) <> 0 then
    begin
      E := True;
      Break;
    end;
  end;
  EditorPasteItem.Enabled := E;
end;

procedure TImportTextForm.WMDrawClipboard(var Msg: TWMDrawClipboard);
begin
  SendMessage(FClipboardOwner, WM_DRAWCLIPBOARD, 0, 0);
  Msg.Result := 0;
  ClipboardChanged;
end;

procedure TImportTextForm.WMChangeCBChain(var Msg: TWMChangeCBChain);
begin
  if Msg.Remove = FClipboardOwner then FClipboardOwner := Msg.Next
  else SendMessage(FClipboardOwner, WM_CHANGECBCHAIN, Msg.Remove, Msg.Next);
  Msg.Result := 0;
end;


procedure TImportTextForm.EditorPopupMenuPopup(Sender: TObject);
begin
  EditorUndoItem.Enabled:=Editor.CanUndo;
  EditorRedoItem.Enabled:=Editor.CanRedo;
  EditorCopyItem.Enabled:=(Editor.SelLength>0);
  EditorCutItem.Enabled:=(Editor.SelLength>0);
end;

end.
