unit LinkPropDlgUnit;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, fcCombo, fcColorCombo, Dialogs, fcLabel, ComCtrls,
  BPDef;

type
  TLinkTypeDlg = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    LTColor: TfcColorCombo;
    Label1: TLabel;
    lsSolid: TSpeedButton;
    lsDot: TSpeedButton;
    lsDashDot: TSpeedButton;
    fcLabel11: TfcLabel;
    ColorDialog1: TColorDialog;
    LTTreeView: TTreeView;
    ShowLinkStream: TCheckBox;
    procedure LTTreeViewEditing(Sender: TObject; Node: TTreeNode;
      var AllowEdit: Boolean);
    procedure LTTreeViewChange(Sender: TObject; Node: TTreeNode);
    procedure LTColorChange(Sender: TObject);
    procedure LineStyleChange(Sender: TObject);
    procedure ShowLinkStreamClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure PrepareDlg;
  end;

var
  LinkTypeDlg: TLinkTypeDlg;

implementation

uses MainUnit;

{$R *.DFM}

procedure TLinkTypeDlg.PrepareDlg;
Var tmpL:PBPLinkTypes;
    lc:Integer;
    i:Integer;
    node,node1:TTreeNode;
 begin
    LTTreeView.Items.Clear;
    lc:=BPViewMainForm.BPFrame.BPGraph.Header.dwLinksTypesCount;
    tmpL:=BPViewMainForm.BPFrame.BPGraph.LTTree;
    for i:=0 to (lc-1) do
      begin
        node:=LTTreeView.Items.GetFirstNode;
        node:=LTTreeView.Items.Add(node,tmpL^.ssCaption);
        node.Data:=Pointer(tmpL);
        inc(tmpL);
        if (i=0) then node1:=node;
      end;
   LTTreeView.Selected:=node1;
 end;

procedure TLinkTypeDlg.LTTreeViewEditing(Sender: TObject; Node: TTreeNode;
  var AllowEdit: Boolean);
begin
 AllowEdit:=False;
end;

procedure TLinkTypeDlg.LTTreeViewChange(Sender: TObject; Node: TTreeNode);
Var tmpL:PBPLinkTypes;
begin
  if (Node=nil) then Exit;
  tmpL:=PBPLinkTypes(Node.Data);
  LTColor.SelectedColor:=tmpL^.dwColor;
  case (tmpL^.dwPenStyle) of
    psSolid:   lsSolid.Down:=True;
    psDot:     lsDot.Down:=True;
    psDashDot: lsDashDot.Down:=True;
    else       lsSolid.Down:=True;
  end;
  ShowLinkStream.Checked:=tmpl^.dbShowLinkType;
end;

procedure TLinkTypeDlg.LTColorChange(Sender: TObject);
Var tmpL:PBPLinkTypes;
begin
 if LTTreeView.Selected=nil then Exit;
 tmpL:=PBPLinkTypes(LTTreeView.Selected.Data);
 tmpL^.dwColor:=LTColor.SelectedColor;
end;

procedure TLinkTypeDlg.LineStyleChange(Sender: TObject);
Var i:Integer;
    tmpL:PBPLinkTypes;
begin
  if LTTreeView.Selected=nil then Exit;
  tmpL:=PBPLinkTypes(LTTreeView.Selected.Data);
  i:=(Sender as TSpeedButton).Tag-1;
 case i of
  0: tmpL^.dwPenStyle:=psSolid;
  1: tmpL^.dwPenStyle:=psDot;
  2: tmpL^.dwPenStyle:=psDashDot;
 end;
end;

procedure TLinkTypeDlg.ShowLinkStreamClick(Sender: TObject);
Var tmpL:PBPLinkTypes;
begin
  if LTTreeView.Selected=nil then Exit;
  tmpL:=PBPLinkTypes(LTTreeView.Selected.Data);
  tmpL^.dbShowLinkType:=ShowLinkStream.Checked;
end;

end.
