unit PrevUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  qrprntr, ExtCtrls;

type
  TPreviewForm = class(TForm)
    QRPreview: TQRPreview;
    CorrectTimer: TTimer;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CorrectTimerTimer(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  PreviewForm: TPreviewForm;

implementation

uses MainUnit;

{$R *.DFM}

procedure TPreviewForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
 Action:=BPViewMainForm.FPreviewCAction;
 if Action=caNone then Exit;
 BPViewMainForm.PageParamButton.Enabled:=True;
 BPViewMainForm.PreviewButton.Enabled:=True;
 BPViewMainForm.ImportButton.Enabled:=True;
 BPViewMainForm.BPPanel.Visible:=True;
 BPViewMainForm.BPFrame.Visible:=True;
 BPViewMainForm.DiscardDragsButton.Enabled:=True;
 BPViewMainForm.DiscardDragsItem.Enabled:=True;
 BPViewMainForm.SaveAsButton.Enabled:=True;
 BPViewMainForm.SaveItem.Enabled:=True;
 BPViewMainForm.SaveButton.Enabled:=True;
 BPViewMainForm.FormatSetupButton.Enabled:=True;
 BPViewMainForm.SetMenuEnabled(True,True,True,True);
 BPViewMainForm.PreviewToolbar.Visible:=False;
 BPViewMainForm.PageParamItem.Enabled:=True; {!!!}
 BPViewMainForm.PreviewItem.Enabled:=True;   {!!!}
 BPViewMainForm.N7.Enabled:=True;            {!!!}
 BPViewMainForm.N1.Enabled:=True;            {!!!}
 BPViewMainForm.SaveAsItem.Enabled:=True;  {!!!}
 BPViewMainForm.TextExportItem.Enabled:=True;
// BPViewMainForm.AFItem.Enabled:=True;  {!!!}
 BPViewMainForm.FontSetupItem.Enabled:=True;{!!!}
 BPViewMainForm.LevelUpItem.Enabled:=True;
 BPViewMainForm.ActivePreview:=False;
 BPViewMainForm.NodeTypeItem.Enabled:=True;
 BPViewMainForm.FontSizeItem.Enabled:=True;
 BPViewMainForm.QuitButton.Enabled:=True;
 BPViewMainForm.N13.Enabled:=True;
 BPViewMainForm.ToolBarButton.Enabled:=True;
 BPViewMainForm.ZoomBtn.Enabled:=True;
 BPViewMainForm.SetDefaultTabSheetButton.Enabled:=True;
 BPViewMainForm.EnableAnalizForm.Checked:=BPViewMainForm.EnableAnaliz;
end;

procedure TPreviewForm.CorrectTimerTimer(Sender: TObject);
begin
 CorrectTimer.Enabled:=False;
 QRPreview.Zoom:=50;
 BPViewMainForm.PreviewZoom.Text:='50';
 Invalidate;
end;

procedure TPreviewForm.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
Var zoom:Integer;
begin
 case Key of
   VK_PRIOR:  begin
               BPViewMainForm.PageEdit.ReadOnly:=False;
               if QRPreview.PageNumber > 1 then
                 begin
                  QRPreview.PageNumber:=QRPreview.PageNumber-1;
                  BPViewMainForm.PageEdit.Text:=IntToStr(QRPreview.PageNumber);
                 end;
               BPViewMainForm.PageEdit.ReadOnly:=True;
             end;
   VK_NEXT: begin
               BPViewMainForm.PageEdit.ReadOnly:=False;
               if QRPreview.PageNumber < QRPreview.QRPrinter.AvailablePages then
                 begin
                  QRPreview.PageNumber:=QRPreview.PageNumber+1;
                  BPViewMainForm.PageEdit.Text:=IntToStr(QRPreview.PageNumber);
                 end;
                BPViewMainForm.PageEdit.ReadOnly:=True;
              end;
   VK_HOME:   begin
                 BPViewMainForm.PageEdit.ReadOnly:=False;
                 BPViewMainForm.PageEdit.Text:=IntToStr(1);
                 QRPreview.PageNumber:=1;
                 BPViewMainForm.PageEdit.ReadOnly:=True;
              end;
   VK_END:    begin
                 BPViewMainForm.PageEdit.ReadOnly:=False;
                 QRPreview.PageNumber:=QRPreview.QRPrinter.AvailablePages;
                 BPViewMainForm.PageEdit.Text:=IntToStr(QRPreview.QRPrinter.AvailablePages);
                 BPViewMainForm.PageEdit.ReadOnly:=True;
              end;
   VK_INSERT: begin
                zoom:=QRPreview.Zoom;
                if zoom<400 then
                begin
                 zoom:=zoom+10;
                 QRPreview.Zoom:=zoom;
                 BPViewMainForm.PreviewZoom.Text:=IntToStr(zoom);
                end;
              end;
   VK_DELETE: begin
                zoom:=QRPreview.Zoom;
                if zoom>10 then
                 begin
                  zoom:=zoom-10;
                  QRPreview.Zoom:=zoom;
                  BPViewMainForm.PreviewZoom.Text:=IntToStr(zoom);
                 end;
              end;
   VK_ESCAPE:  BPViewMainForm.ClosePreviewTimer.Enabled:=True;
 end;
end;

end.
