unit FilePanel;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls,StdCtrls,AliGrid;

type
  TFilePanel = class(TPanel)
    fTopHeader:TLabel;
    fBottomPanel:TPanel;
    fFileViewer:TStringAlignGrid;
  private
    { Private declarations }
    fCurDir:String;
    procedure ReadDirectory;
    function  GetFileHighlight(fileext:String; dir:Boolean):TColor;
  protected
    { Protected declarations }
  public
    { Public declarations }
     constructor Create(AOwner: TComponent); override;
     destructor  Destroy; override;
  published
    { Published declarations }
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Custom', [TFilePanel]);
end;

constructor TFilePanel.Create(AOwner: TComponent);
begin
 inherited Create(AOwner);
 { Init internal variables }
 fCurDir:='C:\';
 Caption:='';
 BorderStyle:=bsSingle;
 { Init fTopHeader }
 fTopHeader:=TLabel.Create(self);
 fTopHeader.Parent:=self;
 fTopHeader.Align:=alTop;
 fTopHeader.Alignment:=taCenter;
 fTopHeader.Caption:=fCurDir;
 fTopHeader.Color:=clBtnShadow;
 fTopHeader.Font.Size:=10;
 fTopHeader.Font.Charset:=RUSSIAN_CHARSET;
 fTopHeader.Font.Style:=[fsBold];
 { Init fBottomPanel }
 fBottomPanel:=TPanel.Create(self);
 fBottomPanel.Parent:=self;
 fBottomPanel.Align:=alBottom;
 fBottomPanel.BorderStyle:=bsSingle;
 fBottomPanel.Caption:='';
 { Init fFileViewer}
 fFileViewer:=TStringAlignGrid.Create(self);
 fFileViewer.Parent:=self;
 fFileViewer.Align:=alClient;
{ fFileViewer.DefaultColWidth:=fFileViewer.ClientWidth div 2;}
 fFileViewer.DefaultColWidth:=192;
 fFileViewer.DefaultRowHeight:=18;
 fFileViewer.FixedCols:=0;
 fFileViewer.FixedRows:=1;
 fFileViewer.ColCount:=1;
 fFileViewer.RowCount:=1;
 fFileViewer.Cols[0].add('');
 fFileViewer.GridLineWidth:=0;
 fFileViewer.Color:=clGray;
 fFileViewer.Font.Size:=10;
 fFileViewer.Font.Style:=[fsBold];
 {Init FilePanel State}
 ReadDirectory;
end;

destructor  TFilePanel.Destroy;
begin
 fFileViewer.Destroy;
 fBottomPanel.Destroy;
 fTopHeader.Destroy;
 inherited Destroy;
end;

procedure TFilePanel.ReadDirectory;
Var SearchRec:TSearchRec;
    fFound:Integer;
    fDir:Boolean;
    s:String;
    fIndex:Integer;
begin
 fFound:=FindFirst(fCurDir+'*.*',faAnyFile,SearchRec);
 while fFound = 0 do
  begin
   s:=SearchRec.Name;
   fDir:=((SearchRec.Attr and faDirectory)= faDirectory);
   fFileViewer.RowCount:=fFileViewer.RowCount+1;
   if fDir then
    fIndex:=fFileViewer.Cols[0].Add(s)
   else fIndex:=fFileViewer.Cols[0].Add(LowerCase(s));
   fFileViewer.CellFont[0,fIndex].Color:=
    GetFileHighlight(UpperCase(ExtractFileExt(s)),fDir);
   fFound:=FindNext(SearchRec);
  end;
  FindClose(SearchRec);
  fFileViewer.FixedRows:=1;
end;

function  TFilePanel.GetFileHighlight(fileext:String; dir:Boolean):TColor;
begin
 if dir then Result:=clWhite
 else
   begin
     Result:=clSilver;
     if fileext='.BAT' then
                       begin
                        Result:=clAqua;
                       end;
     if fileext='.EXE' then
                       begin
                        Result:=clAqua;
                       end;
     if fileext='.COM' then
                       begin
                        Result:=clAqua;
                       end;
     if fileext='.TXT' then
                       begin
                        Result:=clLime;
                       end;
     if fileext='.INI' then
                       begin
                        Result:=clLime;
                       end;
     if fileext='.CFG' then
                       begin
                        Result:=clLime;
                       end;
   end;
end;

end.
