////////////////////////////////////////////////////////////////////////////////
// MENUS97_V3                                                                 //
////////////////////////////////////////////////////////////////////////////////
// Menu Style 97 pour D3 (D2 ?)                                               //
////////////////////////////////////////////////////////////////////////////////
// Version 3.06 Alpha                                                         //
// Date de cration           : 02/07/1997                                    //
// Date dernire modification : 06/08/1998                                    //
////////////////////////////////////////////////////////////////////////////////
// Stphane Chova        stephane.chova@hol.fr                                //
// Jean-Luc Mattei       jlucm@club-internet.fr / jlucm@mygale.org            //
// TSystemMenus97 original idea from                                          //
// * Sylvain Cresto                                                           //
// Portion of code from                                                       //
// * TSystemMenu      - Sylvain Cresto                                        //
//                      e-mail : sylvain.cresto@hol.fr                        //
// * TExplorerButton  - Fabrice Deville                                       //
//                      e-mail : fdev@tornado.be                              //
//                      WWW    : http://www.tornado.be/~fdev/                 //
// * TMSOfficeCaption - Warren F. Young                                       //
//                      e-mail : wfy@ee.ed.ac.uk or Warren.Young@ee.ed.ac.uk  //
//                      WWW    : http://www.ee.ed.ac.uk/~wfy/components.html  //
// Thanks to                                                                  //
// * Richard Alimi                                                            //
// * Ian Delisle                                                              //
// * Tom Deprez                                                               //
// * Phillip du Toit                                                          //
// * Torben Falck                                                             //
// * Riccardo Giomi                                                           //
// * Olivier Grosclaude                                                       //
// * Edwin Hagen                                                              //
// * Jrome Hersant                                                           //
// * Stefan Hoffmann                                                          //
// * Philip Hofstetter                                                        //
// * Steven Kamradt                                                           //
// * Konstantin L. Shustik                                                    //
// * Kevin Lu                                                                 //
// * Fritz Madden                                                             //
// * Alain Milandre                                                           //
// * Arturo Monge                                                             //
// * Walter Nogueira Freire                                                   //
// * Alexander Obukhov                                                        //
// * Carsten Paasch                                                           //
// * Bart Pelgrims                                                            //
// * Larry Pierce                                                             //
// * Saverio Pieri                                                            //
// * Laurent Pierre                                                           //
// * Christian Poisson                                                        //
// * Andre Santos                                                             //
// * Magnus Therkildsen                                                       //
// * Glen Verran                                                              //
// * to be continued ...                                                      //
////////////////////////////////////////////////////////////////////////////////
// IMPORTANT NOTICE :                                                         //
//                                                                            //
// This program is FreeWare                                                   //
//                                                                            //
// Please do not release modified versions of this source code.               //
// If you've made any changes that you think should have been there,          //
// feel free to submit them to me at jlucm@club-internet.fr                   //
////////////////////////////////////////////////////////////////////////////////
// NOTES :                                                                    //
//                                                                            //
//     * MENUS97 AND MSOFFICECAPTION (Warren F. Young) :                      //
//       MSOFFICECAPTION MUST BE CREATED BEFORE MENUS97 (IN CREATION ORDER)   //
//                                                                            //
//     * MENUS97 AND TOOLBARBUTTON97 (Jordan Russell)                         //
//       - If you're using ToolbarButton97 Version 1.54 or greater you must   //
//         change Click code :                                                //
//                                                                            //
//         Replace this code                                                  //
//                                                                            //
//          with DropdownMenu do begin                                        //
//            PopupComponent := Self;                                         //
//            { Starting with version 1.54, this avoids using the Popup method//
//              of TPopupMenu because it uses the "track right button" flag   //
//              (which disallowed the "click and drag" selecting motion many  //
//              people are accustomed to). }                                  //
//            if Assigned(OnPopup) then                                       //
//              OnPopup (DropdownMenu);                                       //
//            TrackPopupMenu (Handle, AlignFlags[Alignment] or                //
//                            ButtonFlags[NewStyleControls],                  //
//              PopupPoint.X, PopupPoint.Y, 0, DropdownList.Window, nil);     //
//          end;                                                              //
//        end                                                                 //
//                                                                            //
//        by this one                                                         //
//                                                                            //
//          with DropdownMenu do                                              //
//            Popup(PopupPoint.x, PopupPoint.y);                              //
//        end;                                                                //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////
// REVISIONS :                                                                //
//                                                                            //
//  - 3.01 : * Menu Editor Bug partially removed                              //
//           * SubMenuBannerText property allow banners on any menu / Submenu //
//           * SubMenuBkGnd property allow background bitmap on any menus     //
//             Compiler directive added in GetDefaultMenuFont to make it works//
//             with D2 (thanks to Bernd Schachinger)                          //
//           * AlwaysShowSelection propery allows Disabled Items visual       //
//             selection as in Word97 / Explorer 4                            //
//             (thanks to Magnus Therkildsen)                                 //
//           * Banner default Font Color is now clHighLight                   //
//             (thanks Konstantin L. Shustik for these modifications)         //
//           * Minor bugs, and warnings removed                               //
//             ToolbarButton97 popup problem found (with version greater than //
//             1.53 (see NOTE section)                                        //
//  - 3.02 : * Works better with large images (thanks to Carsten Paasch)      //
//           * Little modifications in WMDrawItem and WMMeasureItem methods   //
//           * Accelerator bug(s) removed :                                   //
//             - works when some items are not visible                        //
//             - works with SystemMenus                                       //
//             - works with Merged MDI Menus                                  //
//             (thanks to Fritz Madden)                                       //
//           * SubMenuBanners works now                                       //
//           * Keyboard behaviour is now standard with MDI                    //
//           * Background Bitmaps (begin to) work correctly                   //
//           * Menu painting problems when HideMenuBar set to true corrected  //
//           * MessageBeep removed ;-)                                        //
//  - 3.03 : * SetImages modified to handle imageSize changes under Win98     //
//             (thanks to Carsten Paasch)                                     //
//  - 3.04 : * "Menu index out of range"... error when deleting a menuitem    //
//             corrected. (thanks to Laurent Pierre)                          //
//           * Works under windows NT (thanks to Philip Hofstetter)           //
//           * Component icons have been added (thanks to Phillip du Toit)    //
//  - 3.05 : * Popup separators where not drawn when no background present, it//
//             have been corrected ;-) (thanks to Riccardo Giomi)             //
//  - 3.06 : * D4 support added                                               //
////////////////////////////////////////////////////////////////////////////////
// HOW TO USE :                                                               //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////

{$INCLUDE VERSIONS.INC}

unit Menus97_V3;

{$S-,W-,R-}
{$C PRELOAD}

interface

uses Windows, SysUtils, Classes, Messages, Controls, Menus, Graphics, StdCtrls,
     ExtCtrls, Buttons, Forms
     {$ifdef D4_OR_GREATER}
     , ImgList
     {$endif}
     ;

//{$R MENUS97_V3.RES}

type
  TItem97Look = (ilDefault, il3D);

  TMenuState = (msInactive, msActive, msActiveDrop);

  TMenuSpeedButton = class(TSpeedButton)
  private
    FM97Handle: THandle;
    FInDown: Boolean;
    FMenuState: TMenuState;
  protected
    procedure SetMenuState(Value : TMenuState);
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    procedure MouseMove(Shift: TShiftState; X, Y: Integer); override;
    procedure CMDialogChar(var Message: TCMDialogChar); message CM_DIALOGCHAR;
  public
    procedure Paint; override;
    property MenuState: TMenuState read FMenuState write SetMenuState;
  end;

  TCustomMenuBar97_V3 = class(TCustomPanel)
  private
    FInMenuBar: Boolean;
    FMenuOpen: Boolean;
    FActiveControl: Integer;
  protected
  public
    procedure CreateParams(var Params: TCreateParams); override;
    constructor Create(AOwner: TComponent); override;
    procedure WndProc(var Message: TMessage); override;
  end;

  TMenuBar97_V3 = class(TCustomMenuBar97_V3)
    property Align;
    property Alignment;
    property BevelInner;
    property BevelOuter;
    property BevelWidth;
    property BorderWidth;
    property BorderStyle;
    property DragCursor;
    property DragMode;
    property Enabled;
    property FullRepaint;
    property Caption;
    property Color;
    property Ctl3D;
    property Font;
    property Locked;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Visible;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnResize;
    property OnStartDrag;
  end;

  TMenus97Options = class;

  TMenuItem97 = class(TMenuItem)
  private
    FImageIndex: Integer;
    FLook: TItem97Look;
    FSubMenuBannerText: String;
    FSubMenuBkGndImage: TBitmap;
    FOnChange: TMenuChangeEvent;
    FInternalCommand: Word;
    procedure SetImageIndex(Value: Integer);
    procedure SetLook(Value: TItem97Look);
    procedure SetSubMenuBkGndImage(Value: TBitmap);
    function  IsSubMenuBkGndImageStored: Boolean;
  protected
    procedure DefineProperties(Filer: TFiler); override;
    function GetItem97(Index: Integer): TMenuItem97;
    procedure MenuChanged(Rebuild: Boolean); override;
  public
    procedure SetParentComponent(Value: TComponent); override;
    procedure SetOwnerDrawMode(Restore: Boolean; Menus97Options: TMenus97Options);
    function  GetOwnerDrawMode(Menus97Options: TMenus97Options): Boolean;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Insert(Index: Integer; Item: TMenuItem97);
    procedure Add(Item: TMenuItem97);
    property Items[Index: Integer]: TMenuItem97 read GetItem97; default;
    property OnChange: TMenuChangeEvent read FOnChange write FOnChange;
  published
    property ImageIndex: Integer read FImageIndex write SetImageIndex default -1;
    property Look: TItem97Look read FLook write SetLook default ilDefault;
    property SubMenuBannerText: String read FSubMenuBannerText write FSubMenuBannerText;
    property SubMenuBkGndImage: TBitmap read FSubMenuBkGndImage write SetSubMenuBkGndImage stored IsSubMenuBkGndImageStored;
  end;

  TDrawMenuItemEvent = function(Control: TMenu; Item: TMenuItem97; Rect: TRect; State: TOwnerDrawState): boolean of object;
  {$ifdef D4_OR_GREATER}
  TMeasureMenuItemEvent = procedure(Control: TMenu; Item: TMenuItem97; var Height, Width: LongWord) of object;
  {$else}
  TMeasureMenuItemEvent = procedure(Control: TMenu; Item: TMenuItem97; var Height, Width: Integer) of object;
  {$endif}
  TBannerJustification = (bjCenter, bjTop, bjBottom);
  TMenus97Look = (mlOffice97Look, mlIE4Look);
  THintEvent = function(Control: TMenu; Item: TMenuItem97; Hint: String): String of object;

  TMenus97Options = class(TPersistent)
  private
    FImages: TImageList;
    FImageChangeLink: TChangeLink;
    FCanvas: TCanvas;
    FMenu: TMenu;
    FFont: TFont;
    FBrush: TBrush;
    FItemHeight: Integer;
    FItemWidth: Integer;
    FNewTFormWndProcInstance: Pointer;
    FOldTFormWndProc: Pointer;
    FOnDrawItem: TDrawMenuItemEvent;
    FOnHint: THintEvent;
    FOnMeasureItem: TMeasureMenuItemEvent;
    FHiliteBar : TColor;
    FHiliteFont : TFont;
    FDefaultMargin: Integer;
    FDefaultHeight: Integer;
    FRadioBitmap : TBitmap;
    FCheckBitmap : TBitmap;
    FBanner: Boolean;
    FBannerText: String;
    FBannerFont: TFont;
    FBannerWidth: Integer;
    FBannerColor: TColor;
    FBannerEndColor: TColor;
    FBannerNumColors: Integer;
    FBannerJustification: TBannerJustification;
    FBannerImage: Integer;
    FMDIList: TList;
    FInitOk: Boolean;
    FMenus97Look: TMenus97Look;
    FBannerRect: TRect;
    FNeedBannerRect: Boolean;
    FDefaultFont: Boolean;
    FBannerBmp: TBitmap;
    FBkGndBmp: TBitmap;
    FNeedBkBmp: Boolean;
    FMenuBarSelID: Integer;
    FGrayedInactive: Boolean;
    FAlwaysShowSelection: Boolean;
    FMaxImageSize: TSize;
    FBkGndImage: TBitmap;
    Procedure SetImages (Value: TImageList);
    procedure SetInternalMenu(Value: TMenu); virtual;
    procedure SetFont(Value: TFont);
    procedure SetHiliteFont (Value : Tfont);
    procedure SetBannerFont(Value: TFont);
    procedure SetBrush(Value: TBrush);
    procedure SetMenus97Look(Value: TMenus97Look);
    procedure WMDrawItem(var Message: TWMDrawItem); message WM_DRAWITEM;
    procedure WMMeasureItem(var Message: TWMMeasureItem); message WM_MEASUREITEM;
    function  GetFormHandle: THandle;
    function  GetForm: TForm;
    procedure DrawDisabledImage(Var Rect : TRect; IndexImage : Integer);
    procedure DrawDisabledImageNT(Var Rect : TRect; IndexImage : Integer);
    procedure DrawDisabledImage95(Var Rect : TRect; IndexImage : Integer);
    function  CalcMenuWidth(Item: TMenuItem97): Integer;
    function  CalcMenuHeight(Item: TMenuItem97): Integer;
    function  ProcessAccel(Message: TWMMenuChar ): Integer; virtual;
    function  FindItemByCommand(Command: Word): TMenuItem97; virtual;
    procedure InternalModifyMenuTree(MenuItems : TMenuItem97; Level: Integer); virtual;
    procedure ReleaseMDIList;
    procedure FontChange(Sender: TObject); virtual;
    procedure HiliteFontChange(Sender: TObject); virtual;
    procedure BrushChange(Sender: TObject); virtual;
    procedure Draw3DItem(Item: TMenuItem97; Var Rect: TRect; State: TOwnerDrawState); virtual;
    procedure DrawItemText(Item: TMenuItem97; Var Rect: TRect; Text: String; State: TOwnerDrawState);
    function  CalcMenuRect(Item: TMenuItem97): TRect; virtual;
    procedure CalcBannerRect(Item: TMenuItem97); virtual;
    function  HasBanner(Item: TMenuItem97): boolean; virtual;
    function  GetBanner(Item: TMenuItem97): String; virtual;
    function  HasBkGnd(Item: TMenuItem97): boolean; virtual;
    function  GetBkGnd(Item: TMenuItem97): TBitmap; virtual;
    function  GetTextSize(ACanvas: TCanvas; Text: string ): TSize;
    function  IsFontStored: Boolean;
    procedure SetDefaultFont(Value: Boolean);
    procedure GetDefaultMenuFont(Var aFont: TFont);
    function  CalcMenuBarHeight: Integer; virtual;
    procedure GradientFill(DC: HDC; FBeginColor, FEndColor: TColor; R: TRect);
    procedure HookForm; virtual;
    procedure UnHookForm; virtual;
    function  WindowIsActive: Boolean; virtual;
    procedure CalcMaxImageSize;
    procedure SetBkGndImage(Value: TBitmap);
    function  IsBkGndImageStored: Boolean;
  protected
    property  InternalMenu: TMenu read FMenu write SetInternalMenu;
  public
    property  FormHandle: THandle read GetFormHandle;
    property  Form: TForm read GetForm;
    procedure ModifyMenuTree(MenuItems : TMenuItem97; Restore: Boolean); virtual;
    procedure DrawItem(Item: TMenuItem97; Rect: TRect; State: TOwnerDrawState); virtual;
    {$ifdef D4_OR_GREATER}
    procedure MeasureItem(Item: TMenuItem97; var Height, Width: LongWord); virtual;
    {$else}
    procedure MeasureItem(Item: TMenuItem97; var Height, Width: Integer); virtual;
    {$endif}
    procedure   Office97Mapping; virtual;
    constructor Create(AMenu: TMenu); virtual;
    destructor  Destroy; override;
    procedure   NewTFormWndProc(Var Message: TMessage); virtual;
    property DefaultHeight: Integer read FDefaultHeight;
    property BannerImage: Integer read FBannerImage write FBannerImage default -1;
    property BannerJustification: TBannerJustification read FBannerJustification write FBannerJustification;
    property BannerWidth: Integer read FBannerWidth write FBannerWidth;
    property BannerText: String read FBannerText write FBannerText;
    property BannerFont: TFont read FBannerFont write SetBannerFont;
    property BannerColor: TColor read FBannerColor write FBannerColor default clActiveCaption;
    property BannerEndColor: TColor read FBannerEndColor write FBannerEndColor default clBlack;
    property BannerNumColors: Integer read FBannerNumColors write FBannerNumColors default 16;
    property Banner: Boolean read FBanner write FBanner;
    property OnDrawItem: TDrawMenuItemEvent read FOnDrawItem write FOnDrawItem;
    property OnHint: THintEvent read FOnHint write FOnHint;
    property OnMeasureItem: TMeasureMenuItemEvent read FOnMeasureItem write FOnMeasureItem;
    property ItemHeight: Integer read FItemHeight write FItemHeight;
    property ItemWidth: Integer read FItemWidth write FItemWidth;
    property Images: TImageList read FImages write SetImages;
    property Font: TFont read FFont write SetFont stored IsFontStored;
    property Brush: TBrush read FBrush write SetBrush;
    property Canvas: TCanvas read FCanvas;
    property HiliteBar : Tcolor read FHiliteBar write FHiliteBar;
    property HiliteFont : TFont read FHiliteFont write SetHiliteFont stored IsFontStored;
    property Menus97Look: TMenus97Look read FMenus97Look write SetMenus97Look default mlOffice97Look;
    property DefaultFont: Boolean read FDefaultFont write SetDefaultFont default True;
    property GrayedInactive: Boolean read FGrayedInactive write FGrayedInactive default False;
    property AlwaysShowSelection: Boolean read FAlwaysShowSelection write FAlwaysShowSelection default True;
    property BkGndImage: TBitmap read FBkGndImage write SetBkGndImage stored IsBkGndImageStored;
  end;

  TMainMenus97Options = class(TMenus97Options)
  private
    FHideMenuBar: Boolean;
    FPushedButton: Boolean;
    FHitTest: Boolean;
    FHitPos: Integer;
    FToolBar: TCustomMenuBar97_V3;
    FMenuOpen: Boolean;
    FWindowIsActive: Boolean;
    function  WindowIsActive: Boolean; override;
    procedure SetHideMenuBar(Value: Boolean);
    procedure SetToolBar(Value: TCustomMenuBar97_V3);
    function  CalcMenuBarHeight: Integer; override;
  public
    procedure NewTFormWndProc(Var Message: TMessage); override;
    procedure DrawItem(Item: TMenuItem97; Rect: TRect; State: TOwnerDrawState); override;
    constructor Create(AMenu: TMenu); override;
    destructor  Destroy; override;
  published
    property ToolBar: TCustomMenuBar97_V3 read FToolBar write SetToolBar;
    property HideMenuBar: Boolean read FHideMenuBar write SetHideMenuBar default False;
    property DefaultHeight;
    property BannerImage;
    property BannerJustification;
    property BannerWidth;
    property BannerText;
    property BannerFont;
    property BannerColor;
    property BannerEndColor;
    property BannerNumColors;
    property Banner;
    property OnDrawItem;
    property OnHint;
    property OnMeasureItem;
    property ItemHeight;
    property ItemWidth;
    property Images;
    property Font;
    property Brush;
    property Canvas;
    property HiliteBar;
    property HiliteFont;
    property Menus97Look;
    property DefaultFont;
    property GrayedInactive;
    property AlwaysShowSelection;
    property BkGndImage;
  end;

  TPopupMenus97Options = class(TMenus97Options)
  private
    function  CalcMenuRect(Item: TMenuItem97): TRect; override;
    procedure CalcBannerRect(Item: TMenuItem97); override;
    function  HasBanner(Item: TMenuItem97): boolean; override;
    function  GetBanner(Item: TMenuItem97): String; override;
    function  HasBkGnd(Item: TMenuItem97): boolean; override;
    function  GetBkGnd(Item: TMenuItem97): TBitmap; override;
  public
    procedure NewTFormWndProc(Var Message: TMessage); override;
  published
    property DefaultHeight;
    property BannerImage;
    property BannerJustification;
    property BannerWidth;
    property BannerText;
    property BannerFont;
    property BannerColor;
    property BannerEndColor;
    property BannerNumColors;
    property Banner;
    property OnDrawItem;
    property OnHint;
    property OnMeasureItem;
    property ItemHeight;
    property ItemWidth;
    property Images;
    property Font;
    property Brush;
    property Canvas;
    property HiliteBar;
    property HiliteFont;
    property Menus97Look;
    property DefaultFont;
    property AlwaysShowSelection;
    property BkGndImage;
  end;

  TSystemMenuItem97State = (smTrue, smFalse, smDefault);

  TSystemMenus97Options = class;

  TSystemMenuItem97Options = class(TPersistent)
  private
    FMenuItem: TMenuItem97;
    FImageIndex: Integer;
    FVisible: TSystemMenuItem97State;
    FCaption: String;
    FCommand: Integer;
    procedure MenuItemFromCommand(MenuHandle: THandle; aOwner: TSystemMenus97Options);
  public
    constructor Create(Command: Integer);
    destructor Destroy; override;
    property MenuItem: TMenuItem97 read FMenuItem write FMenuItem stored False;
  published
    property ImageIndex: Integer read FImageIndex write FImageIndex default -2;
    property Visible: TSystemMenuItem97State read FVisible write FVisible default smDefault;
    property Caption: String read FCaption write FCaption;
  end;

  TSystemMenus97Options = class(TPopupMenus97Options)
  private
    FScItem: array[0..9] of TSystemMenuItem97Options;
    FSysMenuHandle: THandle;
    FInsertBefore: Integer;
    function  FindItemByCommand(Command: Word): TMenuItem97; override;
    procedure AddItemsToSytemMenu(MenuItems: TMenuItem97; MenuHandle: THandle);
    procedure ModifyMenuTree(MenuItems : TMenuItem97; Restore: Boolean); override;
    function  CalcMenuRect(Item: TMenuItem97): TRect; override;
    procedure CalcBannerRect(Item: TMenuItem97); override;
    procedure HookForm; override;
    procedure UnHookForm; override;
    function  ProcessAccel(Message: TWMMenuChar ): Integer; override;
  public
    constructor Create(AMenu: TMenu); override;
    destructor  Destroy; override;
    procedure NewTFormWndProc(Var Message: TMessage); override;
  published
    property scRestore: TSystemMenuItem97Options read FScItem[0] write FScItem[0];
    property scMove: TSystemMenuItem97Options read FScItem[1] write FScItem[1];
    property scSize: TSystemMenuItem97Options read FScItem[2] write FScItem[2];
    property scMinimize: TSystemMenuItem97Options read FScItem[3] write FScItem[3];
    property scMaximize: TSystemMenuItem97Options read FScItem[4] write FScItem[4];
    property scClose: TSystemMenuItem97Options read FScItem[5] write FScItem[5];
    property scNextWindow: TSystemMenuItem97Options read FScItem[6] write FScItem[6];
    property scPrevWindow: TSystemMenuItem97Options read FScItem[7] write FScItem[7];
    property scTaskList: TSystemMenuItem97Options read FScItem[8] write FScItem[8];
    property scScreenSave: TSystemMenuItem97Options read FScItem[9] write FScItem[9];
    property DefaultHeight;
    property BannerImage;
    property BannerJustification;
    property BannerWidth;
    property BannerText;
    property BannerFont;
    property BannerColor;
    property BannerEndColor;
    property BannerNumColors;
    property Banner;
    property OnDrawItem;
    property OnHint;
    property OnMeasureItem;
    property ItemHeight;
    property ItemWidth;
    property Images;
    property Font;
    property Brush;
    property Canvas;
    property HiliteBar;
    property HiliteFont;
    property Menus97Look;
    property DefaultFont;
    property AlwaysShowSelection;
    property BkGndImage;
  end;

  TMainMenu97_V3 = class(TMainMenu)
  private
    FMenus97Options: TMainMenus97Options;
    procedure SetMenus97Options(Value: TMainMenus97Options);
  protected
    procedure Loaded; override;
    procedure Notification (AComponent: TComponent; Operation: TOperation); override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor  Destroy; override;
  published
    property Menus97Options: TMainMenus97Options read FMenus97Options write SetMenus97Options;
  end;

  TPopupMenu97_V3 = class(TPopupMenu)
  private
    FMenus97Options: TPopupMenus97Options;
    procedure SetMenus97Options(Value: TPopupMenus97Options);
  protected
    procedure Loaded; override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Popup(X, Y: Integer); override;
  published
    property Menus97Options: TPopupMenus97Options read FMenus97Options write SetMenus97Options;
  end;

  TSystemMenu97_V3 = class(TPopupMenu)
  private
    FMenus97Options: TSystemMenus97Options;
    procedure SetMenus97Options(Value: TSystemMenus97Options);
  protected
    procedure Loaded; override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    property Menus97Options: TSystemMenus97Options read FMenus97Options write SetMenus97Options;
  end;

procedure AddItems97(AMenu: TMenu; MainItem: TMenuItem97; Items: array of TMenuItem97);
procedure InsertItems97(AMenu: TMenu; MainItem: TMenuItem97; Index: Integer; Items: array of TMenuItem97);
procedure InitMenuItems97(AMenu: TMenu; Items: array of TMenuItem97);
procedure InsertMenuItems97(AMenu: TMenu; Index: Integer; Items: array of TMenuItem97);
function NewMenu97(Owner: TComponent; const AName: string; Items: array of TMenuItem97): TMainMenu97_V3;
function NewPopupMenu97(Owner: TComponent; const AName: string;
  Alignment: TPopupAlignment; AutoPopup: Boolean; Items: array of TMenuitem97): TPopupMenu97_V3;
function NewSubMenu97(const ACaption: string; hCtx: Word; const AName: string;
  Items: array of TMenuItem97): TMenuItem97;
function NewItem97(const ACaption: string; AShortCut: TShortCut;
  AChecked, AEnabled: Boolean; AOnClick: TNotifyEvent; hCtx: Word;
  const AName: string): TMenuItem97;
function NewLine97: TMenuItem97;

procedure Register;

implementation

uses Consts, DsgnIntf, TypInfo, Menu97Edit, Dialogs;

Var CurrentHookControl: TCustomMenuBar97_V3;
    InternalActiveControl: TMenuSpeedButton;
    FTFormHookCount: Integer;
    FTFormHookList: TList;
    FOrgTFormWndProc: Pointer;

type

  {TCustomMenuItem97PropertyEditor}

  TCustomMenuItem97PropertyEditor = class(TPropertyEditor)
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
    destructor Destroy; override;
  end;

  { TCustomMenu97Editor }

  TCustomMenu97Editor = class(TDefaultEditor)
  private
    procedure DoForEach(PropertyEditor: TpropertyEditor);
  public
    procedure Edit; override;
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;

{TCustomMenuItem97PropertyEditor}

destructor TCustomMenuItem97PropertyEditor.Destroy;
begin
  //FMenu97Editor.Free;
  inherited Destroy;
end;

function FindMenuEditor(Menu: TMenu): TMenu97Editor;
Var i: Integer;
begin
  for i:= 0 to MenuEditorList.Count - 1 do begin
    if Assigned(MenuEditorList[i]) then begin
      if ( TMenu97Editor(MenuEditorList[i]).Menu = Menu ) then begin
        Result:= TMenu97Editor(MenuEditorList[i]);
        Exit;
      end;
    end;
  end;
  Result:= TMenu97Editor.Create(Application);
end;

procedure RemoveMenuEditor(Menu: TMenu);
Var i: Integer;
begin
  for i:= 0 to MenuEditorList.Count - 1 do begin
    if Assigned(MenuEditorList[i]) then begin
      if ( TMenu97Editor(MenuEditorList[i]).Menu = Menu ) then begin
        TMenu97Editor(MenuEditorList[i]).Hide;
        TMenu97Editor(MenuEditorList[i]).Free;
        Exit;
      end;
    end;
  end;
end;

procedure TCustomMenuItem97PropertyEditor.Edit;
Var Menu97Editor: TMenu97Editor;
    MenuOptions: TMenus97Options;
begin
  MenuOptions:= nil;
  if ( GetComponent(0) is TMainMenu97_V3 ) then
    MenuOptions:= TMainMenu97_V3(GetComponent(0)).Menus97Options;
  if ( GetComponent(0) is TPopupMenu97_V3 ) then
    MenuOptions:= TPopupMenu97_V3(GetComponent(0)).Menus97Options;
  if ( GetComponent(0) is TSystemMenu97_V3 ) then
    MenuOptions:= TSystemMenu97_V3(GetComponent(0)).Menus97Options;
  if ( MenuOptions = nil ) then
    Exit;
  Menu97Editor:= FindMenuEditor(TMenu(GetComponent(0)));
  Menu97Editor.Designer:= Designer;
  Menu97Editor.Options:= MenuOptions;
  Menu97Editor.Menu:= TMenu(GetComponent(0));
  Menu97Editor.Show;
end;

function TCustomMenuItem97PropertyEditor.GetAttributes : TpropertyAttributes;
begin
  Result:=[paDialog];
end;

{TCustomMenu97Editor}

procedure TCustomMenu97Editor.Edit;
Var
  Components: TComponentList;
Begin
  Components := TComponentList.Create;
  Components.Add(Component);
  GetComponentProperties(Components, [tkClass],
    Designer, DoForEach);
  Components.Free;
end;

procedure TCustomMenu97Editor.DoForEach(PropertyEditor: TPropertyEditor);
Var
  PropName: string;
begin
    PropName := PropertyEditor.GetName;
    if CompareText(PropName, 'Items') = 0 then
      PropertyEditor.Edit;
    PropertyEditor.Free;
end;

procedure TCustomMenu97Editor.ExecuteVerb(Index: Integer);
begin
  case Index of
    0: Edit;
  end;
end;

function TCustomMenu97Editor.GetVerb(Index: Integer): string;
begin
  case Index of
    0 : Result := 'Menu designer';
  end;
end;

function TCustomMenu97Editor.GetVerbCount: Integer;
begin
  Result := 1;
end;

procedure Register;
begin
  RegisterComponents('Travail', [TMenuBar97_V3, TMainMenu97_V3, TPopupMenu97_V3, TSystemMenu97_V3]);
  RegisterNoIcon([TMenuItem97]);
  RegisterPropertyEditor(TypeInfo(TMenuItem), TMainMenu97_V3, 'Items', TCustomMenuItem97PropertyEditor);
  RegisterPropertyEditor(TypeInfo(TMenuItem), TPopupMenu97_V3, 'Items', TCustomMenuItem97PropertyEditor);
  RegisterPropertyEditor(TypeInfo(TMenuItem), TSystemMenu97_V3, 'Items', TCustomMenuItem97PropertyEditor);
  RegisterComponentEditor(TMainMenu97_V3, TCustomMenu97Editor);
  RegisterComponentEditor(TPopupMenu97_V3, TCustomMenu97Editor);
  RegisterComponentEditor(TSystemMenu97_V3, TCustomMenu97Editor);
end;

{ TMenuSpeedButton }

procedure TMenuSpeedButton.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
Var
    Pt: TPoint;
begin
  if( Not FInDown ) then begin
    FInDown:= True;
    inherited MouseDown(Button, Shift, X, Y);
    if (Button = mbLeft) and Enabled then begin
      InternalActiveControl:= Self;
      Pt:= Point(Left, Top);
      Pt:= (Owner as TCustomMenuBar97_V3).ClientToScreen(Pt);
      TrackPopupMenu(THandle(Tag), TPM_LEFTALIGN, Pt.x, Pt.y + Height, 0, FM97Handle, nil);
    end;
  end;
end;

procedure TMenuSpeedButton.MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if( FInDown ) then begin
    FInDown:= False;
    inherited MouseUp(Button, Shift, X, Y);
    if (Button = mbLeft) and Enabled then begin
      MouseUp(Button, Shift, X, Y);
    end;
  end;
end;

procedure TMenuSpeedButton.SetMenuState(Value : TMenuState);
begin
  if ( FMenuState <> Value ) then begin
    FMenuState:= Value;
    Paint;
  end;
end;

procedure TMenuSpeedButton.Paint;
begin
  inherited Paint;
end;

procedure TMenuSpeedButton.MouseMove(Shift: TShiftState; X, Y: Integer);
begin
  inherited MouseMove(Shift, X, Y);
end;

procedure TMenuSpeedButton.CMDialogChar(var Message: TCMDialogChar);
begin
  with Message do
    if IsAccel(CharCode, Caption) and Enabled then
    begin
      MouseDown(mbLeft, [], 0, 0);
      Result := 1;
    end else
      inherited;
end;

{TCustomMenuBar97_V3}

constructor TCustomMenuBar97_V3.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  ControlStyle := [csAcceptsControls, csCaptureMouse, csClickEvents,
                   csSetCaption, csOpaque, csDoubleClicks, csReplicatable {$ifndef VER90}, csReflector {$endif}];
  FInMenuBar:= False;
  FMenuOpen:= False;
  FActiveControl:= 0;
  Caption:= '';
end;

procedure TCustomMenuBar97_V3.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
end;

procedure TCustomMenuBar97_V3.WndProc(var Message: TMessage);
begin
  case Message.Msg of
    //WM_KILLFOCUS  : if ( FInMenuBar ) then begin
    WM_GETDLGCODE : if ( FInMenuBar ) then begin
                      Message.Result:= DLGC_WANTARROWS;
                      Exit;
                    end;
    WM_SYSCOMMAND : if ( Message.wParam = SC_KEYMENU ) and ( Message.lParam = 0 ) then begin
      //case Message.wParam of
      //  VK_MENU : begin
      //                  if ( GetFocus <> Handle ) then begin
                      if FMenuOpen then
                        FMenuOpen:= False;
                      //else begin
                        FInMenuBar:= Not FInMenuBar;
                        if ( FInMenuBar ) then begin
                          FActiveControl:= 0;
                          (Controls[FActiveControl] as TMenuSpeedButton).Perform(CM_MOUSEENTER, 0, 0);
                          SetFocus;
                        end
                        else
                          (Controls[FActiveControl] as TMenuSpeedButton).Perform(CM_MOUSELEAVE, 0, 0);
                      //end;
                      Message.Result:= 0;
                      Exit;
                    end;
                  //end;
      //end;
    WM_KEYDOWN :
      if ( FInMenuBar ) then begin
        case Message.wParam of
          VK_LEFT : begin

                      (Controls[FActiveControl] as TMenuSpeedButton).Perform(CM_MOUSELEAVE, 0, 0);
                      FActiveControl:= (FActiveControl+ControlCount-1) mod ControlCount;
                      (Controls[FActiveControl] as TMenuSpeedButton).Perform(CM_MOUSEENTER, 0, 0);
                      Message.Result:= 0;
                      Exit;
                    end;
          VK_RIGHT : begin
                      (Controls[FActiveControl] as TMenuSpeedButton).Perform(CM_MOUSELEAVE, 0, 0);
                      FActiveControl:= (FActiveControl +1) mod ControlCount;
                      (Controls[FActiveControl] as TMenuSpeedButton).Perform(CM_MOUSEENTER, 0, 0);
                      Message.Result:= 0;
                      Exit;
                    end;
          VK_DOWN : begin
                      if Not FMenuOpen then
                        FMenuOpen:= True;
                      (Controls[FActiveControl] as TMenuSpeedButton).MouseDown(mbLeft, [], 0, 0);
                      Message.Result:= 0;
                      Exit;
                    end;
        end;
      end;
  end;
  inherited WndProc(Message);
end;

{ TMenuItem97 }

constructor TMenuItem97.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FLook:= ilDefault;
  FImageIndex:= -1;
  FSubMenuBannerText:= '';
  FSubMenuBkGndImage:= TBitmap.Create;
end;

destructor TMenuItem97.Destroy;
begin
  FSubMenuBkGndImage.Free;
  inherited Destroy;
end;

procedure TMenuItem97.SetImageIndex(Value: Integer);
begin
  FImageIndex:= Value;
  MenuChanged(False);
end;

procedure TMenuItem97.SetLook(Value: TItem97Look);
begin
  FLook:= Value;
  MenuChanged(False);
end;

procedure TMenuItem97.SetSubMenuBkGndImage(Value: TBitmap);
begin
  FSubMenuBkGndImage.Assign(Value);
  MenuChanged(False);
end;

function TMenuItem97.IsSubMenuBkGndImageStored: Boolean;
begin
  Result:= False;
  if Assigned(FSubMenuBkGndImage) then
    Result:= Not FSubMenuBkGndImage.Empty;
end;

procedure TMenuItem97.DefineProperties(Filer: TFiler);
begin
  inherited DefineProperties(Filer);
end;

function TMenuItem97.GetItem97(Index: Integer): TMenuItem97;
begin
  Result:= TMenuItem97(GetItem(Index));
end;

procedure TMenuItem97.Insert(Index: Integer; Item: TMenuItem97);
begin
  inherited Insert(Index, TMenuItem(Item));
end;

procedure TMenuItem97.Add(Item: TMenuItem97);
begin
  Insert(GetCount, Item);
end;

procedure TMenuItem97.MenuChanged(Rebuild: Boolean);
begin
  {$ifdef D4_OR_GREATER}
  if Assigned(FOnChange) then FOnChange(Self, TMenuItem(Self), Rebuild);
  {$else}
  if Assigned(FOnChange) then FOnChange(Self, Rebuild);
  {$endif}
  inherited MenuChanged(Rebuild);
end;

procedure TMenuItem97.SetParentComponent(Value: TComponent);
begin
  inherited SetParentComponent(Value);
end;

procedure TMenuItem97.SetOwnerDrawMode(Restore: Boolean; Menus97Options: TMenus97Options);
const
  EnableFlag  : array[Boolean] of Integer = (MF_GRAYED or MF_DISABLED, MF_ENABLED);
  BreakFlag : array[TMenuBreak] of Integer = (0, MF_MENUBREAK, MF_MENUBARBREAK);
begin
  //if ( Caption <> '-' ) then begin
    if ( Restore ) then
      ModifyMenu( Menus97Options.FMenu.Handle, Command,
                  MF_STRING or MF_BYCOMMAND or EnableFlag[Enabled] or BreakFlag[Break], Command, PChar(Caption))
    else
      //if ( Win32Platform <> VER_PLATFORM_WIN32_NT ) or ( Not GetOwnerDrawMode(Menus97Options) ) then
        ModifyMenu( Menus97Options.FMenu.Handle, Command,
                    MF_OWNERDRAW or MF_BYCOMMAND or EnableFlag[Enabled] or BreakFlag[Break], Command, Pointer(Menus97Options));
  //end;
end;

function TMenuItem97.GetOwnerDrawMode(Menus97Options: TMenus97Options) : Boolean;
Var
  MI: TMenuItemInfo;
begin
  MI.cbSize:= Sizeof(TMenuItemInfo);
  MI.fMask:= MIIM_TYPE;
  MI.fType:= 0;
  MI.cch:= 0;
  GetMenuItemInfo(Menus97Options.FMenu.Handle, Command, False, MI);
  Result:= ( MI.fType and MFT_OWNERDRAW ) <> MFT_OWNERDRAW;
end;

{ TMenus97Options }

constructor TMenus97Options.Create(AMenu: TMenu);
begin
  FMenu:= aMenu;
  FGrayedInactive:= False;
  FNewTFormWndProcInstance:= nil;
  FOldTFormWndProc:= nil;
  FImages:= nil;
  FImageChangeLink := TChangeLink.Create;
  FCanvas:= TCanvas.Create;
  FFont:= TFont.Create;
  FHiliteFont:= TFont.create;
  GetDefaultMenuFont(FFont);
  FHiliteFont.Assign(FFont);
  FBannerFont:= TFont.create;
  FBannerFont.Name:= 'Arial';
  FBannerFont.Color:= clHighlightText;
  FBannerFont.Size:= 12;
  FBannerImage:= -1;
  FBannerWidth:= 20;
  FBannerEndColor:= clBlack;
  FBannerColor:= clActiveCaption;
  FBannerBmp:= nil;
  FBkGndBmp:= nil;
  FBannerNumColors:= 16;
  FMenus97Look:= mlOffice97Look;
  FDefaultFont:= True;
  FNeedBannerRect:= True;
  FNeedBkBmp:= True;
  // Par dfaut les deux fontes sont identiques
  //FHiliteFont.Assign(FFont);
  FHiliteFont.Color:= clHighlightText;
  // Couleur de slection windows par dfaut
  // Standard Windows Color for selection
  FHiliteBar:= clHighlight;
  FBrush:= TBrush.Create;
  FBrush.Color:= clBtnFace;
  FOnDrawItem:= nil;
  FOnHint:= nil;
  FOnMeasureItem:= nil;
  FAlwaysShowSelection:= True;

  //Chargement de l'image pour l'option Checked & RadioItem.
  FCheckBitmap:=Tbitmap.Create;
  FRadioBitmap:=Tbitmap.Create;
  FCheckBitmap.LoadFromResourceName(HInstance,'CheckMark_V3');
  FRadioBitmap.LoadFromResourceName(HInstance,'RadioMark_V3');
  CalcMaxImageSize;
  FDefaultMargin:= GetSystemMetrics(SM_CXMENUCHECK);
  if ( FDefaultMargin < FCheckBitmap.Width ) then
    FDefaultMargin:= FCheckBitmap.Width + 4;
  FDefaultHeight:= GetSystemMetrics(SM_CYMENUCHECK);
  if ( FDefaultHeight < FCheckBitmap.Height ) then
    FDefaultHeight:= FCheckBitmap.Height + 4;
  FBkGndImage:= TBitmap.Create;
  FItemHeight:= 0;
  FItemWidth:= 0;
  FMDILIst:= TList.Create;
  FMDIList.Capacity:= 5;
  FFont.OnChange:= FontChange;
  FHiliteFont.OnChange:= HiliteFontChange;
  FBrush.OnChange:= BrushChange;
end;

destructor TMenus97Options.Destroy;
begin
  FBkGndImage.Free;
  ReleaseMDIList;
  FMDILIst.Free;
  if Assigned(FBannerBmp) then
    FBannerBmp.Free;
  if Assigned(FBkGndBmp) then
    FBkGndBmp.Free;
  FImageChangeLink.Free;
  FOnDrawItem:= nil;
  FOnMeasureItem:= nil;
  FFont.Free;
  FBannerFont.Free;
  FBrush.Free;
  FCanvas.Free;
  FMenu:= nil;
  FHiliteFont.Free;
  FCheckBitmap.free;
  FRadioBitmap.free;
  inherited Destroy;
end;

function TMenus97Options.GetForm: TForm;
begin
  Result:= nil;
  if ( FMenu.Owner is TForm ) and ( (FMenu.Owner as TForm).HandleAllocated ) then
    Result:= FMenu.Owner as TForm;
end;

function TMenus97Options.GetFormHandle: THandle;
begin
  Result:= 0;
  if ( FMenu.Owner is TForm ) and ( (FMenu.Owner as TForm).HandleAllocated ) then
    Result:= (FMenu.Owner as TForm).Handle;
end;

procedure TMenus97Options.HookForm;
begin
  // Si le menu est un MainMenu les messages arrivent  la fentre parente
  // donc on intercepte le gestionnaire d'vennements de la fentre parente

  // if We have a main menu we need to intercept TForm messages
  if Assigned(FNewTFormWndProcInstance) then Exit;
  if Assigned(FOldTFormWndProc) then Exit;
  if ( FormHandle <> 0 ) then begin
    Inc(FTFormHookCount);
    FTFormHookList.Add(Self);
    FNewTFormWndProcInstance:= MakeObjectInstance(NewTFormWndProc);
    // Keep the old DefaultProc
    FOldTFormWndProc:= Pointer(GetWindowLong(FormHandle, GWL_WNDPROC));
    if ( FTFormHookCount = 1 ) then
      FOrgTFormWndProc:= FOldTFormWndProc;
    // Set the new Proc
    SetWindowLong(FormHandle, GWL_WNDPROC, Longint(FNewTFormWndProcInstance));
  end;
end;

procedure TMenus97Options.UnHookForm;
Var i: Integer;
begin
  if Not Assigned(FNewTFormWndProcInstance) then Exit;
  if Not Assigned(FOldTFormWndProc) then Exit;
  if FormHandle <> 0 then begin
    Dec(FTFormHookCount);
    // We have to set back the old default Proc if needed
    if ( FTFormHookCount <> 0 ) and ( GetWindowLong(FormHandle, GWL_WNDPROC) = Longint(FNewTFormWndProcInstance) ) then
      SetWindowLong(FormHandle, GWL_WNDPROC, Longint(FOldTFormWndProc));
    // Added to keep HookChain valid
    for i:= FTFormHookList.Count - 1 downto 0 do begin
      if ( TMenus97Options(FTFormHookList[i]).FOldTFormWndProc = FNewTFormWndProcInstance ) then
        TMenus97Options(FTFormHookList[i]).FOldTFormWndProc:= FOldTFormWndProc;
    end;
    // This instance is no more in the list
    FTFormHookList.Remove(Self);
    // if there's no more instances of Menus97 we set back original proc
    if ( FTFormHookCount = 0 ) then begin
      SetWindowLong(FormHandle, GWL_WNDPROC, Longint(FOrgTFormWndProc));
      FTFormHookList.Clear;
    end;
    // and we release Our WndProc instance
    FreeObjectInstance(FNewTFormWndProcInstance);
  end;
  FNewTFormWndProcInstance:= nil;
  FOldTFormWndProc:= nil;
end;

function TMenus97Options.WindowIsActive: Boolean;
begin
  Result:= True;
end;

function TMenus97Options.CalcMenuBarHeight: Integer;
begin
  Result:= FItemHeight;
end;

procedure TMenus97Options.GetDefaultMenuFont(Var aFont: TFont);
Var
  NCMetrics: TNonClientMetrics;

begin
  NCMetrics.cbSize:= sizeof(NCMetrics);
  SystemParametersInfo(SPI_GETNONCLIENTMETRICS, 0, Pointer(@NCMetrics), 0);
  with ( NCMetrics.lfMenuFont ) do begin
    aFont.Height:= lfHeight;
    if ( lfWeight > 500 ) then
      aFont.Style:= [fsBold];
    if ( lfItalic <> 0 ) then
      aFont.Style:= aFont.Style + [fsItalic];
    if ( lfUnderline <> 0 ) then
      aFont.Style:= aFont.Style + [fsUnderline];
    if ( lfStrikeOut <> 0 ) then
      aFont.Style:= aFont.Style + [fsStrikeOut];
    {$ifdef VER100}
    aFont.CharSet:= TFontCharSet(lfCharSet);
    {$endif}
    aFont.Pitch:= TFontPitch(lfPitchAndFamily);
    aFont.Name:= StrPAS(lfFaceName);
  end;
end;

function TMenus97Options.IsFontStored: Boolean;
begin
  Result:= Not FDefaultFont;
end;

procedure TMenus97Options.SetDefaultFont(Value: Boolean);
begin
  if ( Value <> FDefaultFont ) then begin
    FDefaultFont:= Value;
    if ( Value ) then begin
      GetDefaultMenuFont(FFont);
      FHiliteFont.Assign(FFont);
    end;
  end;
end;

procedure TMenus97Options.ReleaseMDIList;
Var i: Integer;
begin
  for i:= 0 to FMDIList.Count - 1 do begin
    TMenuItem97(FMDIList.Items[i]).Free;
  end;
  FMDIList.Clear;
end;

procedure TMenus97Options.FontChange(Sender: TObject);
Var aFont: TFont;
begin
  FDefaultFont:= False;
  try
    aFont:= TFont.Create;
    GetDefaultMenuFont(aFont);
    if ( FHiliteFont = aFont ) then
      FHiliteFont.Assign(FFont);
  finally
    aFont.Free;
  end;
end;

procedure TMenus97Options.HiliteFontChange(Sender: TObject);
Var aFont: TFont;
begin
  FDefaultFont:= False;
  try
    aFont:= TFont.Create;
    GetDefaultMenuFont(aFont);
    if ( FFont = aFont ) then
      FFont.Assign(FHiliteFont);
  finally
    aFont.Free;
  end;
end;

procedure TMenus97Options.BrushChange(Sender: TObject);
begin
end;

procedure TMenus97Options.Draw3DItem(Item: TMenuItem97; Var Rect: TRect; State: TOwnerDrawState);
begin
  with Canvas do begin
    Brush:= FBrush;
    Fillrect(Rect);
    if ( odSelected in State ) then begin
      //if ( FPushedButton ) then
      //  Frame3D(Canvas,Rect,clBtnShadow,clBtnHighlight,1)
      //else
        Frame3D(Canvas,Rect,clBtnHighlight,clBtnShadow,1);
    end;
    if ( Item.ImageIndex >= 0 ) and ( FImages <> Nil ) then begin
      Inc(Rect.Left,3);
      Fimages.Draw(Canvas, Rect.Left, Rect.Top+1, Item.ImageIndex);
      Inc(Rect.Left, FImages.Width + 2);
    end
    else
      Inc(Rect.Left,5);
    Font:= FFont;
    DrawItemText(Item, Rect, Item.Caption, State);
  end;
end;

function TMenus97Options.FindItemByCommand(Command: Word): TMenuItem97;
var i: Integer;
begin
  Result:= TMenuItem97(InternalMenu.FindItem(Command, fkCommand));
  if ( Result = nil ) then begin
    if ( Form <> nil ) and Assigned(Form.WindowMenu) and (Form.FormStyle = fsMdiForm) then begin
      for i:= 0 to FMDIList.Count - 1 do begin
        if ( TMenuItem97(FMDIList.Items[i]).FInternalCommand = Command ) then begin
          Result:= TMenuItem97(FMDIList.Items[i]);
          Exit;
        end;
      end;
    end;
  end;
end;

procedure TMenus97Options.SetMenus97Look(Value: TMenus97Look);
begin
  if ( Value <> FMenus97Look ) then begin
    FMenus97Look:= Value;
    if (FMenu is TMainMenu97_V3) then DrawMenuBar(FormHandle);
  end;
end;

procedure TMenus97Options.SetBkGndImage(Value: TBitmap);
begin
  FBkGndImage.Assign(Value);
end;

function TMenus97Options.IsBkGndImageStored: Boolean;
begin
  Result:= False;
  if Assigned(FBkGndImage) then
    Result:= Not FBkGndImage.Empty;
end;

procedure TMenus97Options.SetImages (Value: TImageList);
begin
  if ( FImages <> Value ) then begin
    if Assigned (FImages) then
      Images.UnRegisterChanges(FImageChangeLink);
    FImages := Value;
    CalcMaxImagesize;
    if ( InternalMenu <> nil ) then begin
      ModifyMenuTree(TMenuItem97(InternalMenu.Items), True);
      ModifyMenuTree(TMenuItem97(InternalMenu.Items), False);
    end;
    {if ( FImages <> nil ) then begin
      FDefaultMargin:= FImages.Width + 4;
      FDefaultHeight:= FImages.Height + 4;
    end
    else begin
      FDefaultMargin:= FCheckBitmap.Width + 4;
      FDefaultHeight:= FCheckBitmap.Height + 4;
    end;}
  end;
end;

function TMenus97Options.CalcMenuHeight(Item: TMenuItem97): Integer;
begin
  Result:= FDefaultHeight;
  if ( Canvas.Handle = 0 ) then Exit;
  //if ( FImages <> nil ) then begin
  //  Result:= FImages.Height + 4;
  //end;
  Result:= FMaxImageSize.Cy + 4;
  if ( Item <> nil ) then
    if ( Result < GetTextSize(Canvas, Item.Caption).Cy+4 ) then
      Result:= GetTextSize(Canvas, Item.Caption).Cy+4;
end;


function TMenus97Options.GetTextSize(ACanvas: TCanvas; Text: string ): TSize;
var
  aRect: TRect;

begin
  aRect:= Rect(0, 0, 0, 0);
  DrawText( ACanvas.Handle, PChar(AnsiString(Text)), -1, aRect, DT_LEFT
            or DT_SINGLELINE or DT_EXPANDTABS or DT_CALCRECT );
  Result.cx := aRect.Right - aRect.Left;
  Result.cy := aRect.Bottom - aRect.Top + 2;
end;

procedure TMenus97Options.CalcMaxImageSize;
begin
  FMaxImageSize.Cx:= FCheckBitmap.Width;
  if ( FMaxImageSize.Cx < FRadioBitmap.Width ) then
    FMaxImageSize.Cx:= FRadioBitmap.Width;
  if ( FImages <> nil ) then begin
    if ( FMaxImageSize.Cx < FImages.Width ) then
      FMaxImageSize.Cx:= FImages.Width;
  end;
  FMaxImageSize.Cy:= FCheckBitmap.Height;
  if ( FMaxImageSize.Cy < FRadioBitmap.Height ) then
    FMaxImageSize.Cy:= FRadioBitmap.Height;
  if ( FImages <> nil ) then begin
    if ( FMaxImageSize.Cy < FImages.Height ) then
      FMaxImageSize.Cy:= FImages.Height;
  end;
  FDefaultMargin:= FMaxImageSize.Cx + 4;
  FDefaultHeight:= FMaxImageSize.Cy + 4;
end;

// Calcul de la largeur maxi du menu (avec accelerateurs et sous-menus)
// Max Menu Width Calculation
function TMenus97Options.CalcMenuWidth(Item: TMenuItem97): Integer;
Var
  i: Integer;
  MaxTextWithAccel: Integer;
  MaxText: Integer;
  MaxAccel: Integer;
  TmpTextWidth: Integer;
  TmpAccelWidth: Integer;
  ParentItem: TMenuItem97;

begin
  Result:= 0;
  if ( Canvas.Handle = 0 ) then Exit;
  MaxTextWithAccel:= 0;
  MaxText:= 0;
  MaxAccel:= 0;
  if (Item.Look = il3D) then begin
    Result:= GetTextSize(Canvas, Item.Caption).Cx + 5;
    if ( Item.ImageIndex >= 0 ) and ( FImages <> nil ) then
      Result:= Result + FImages.Width + 2;
  end
  else begin
    ParentItem:= TMenuItem97(Item.Parent);
    if ( ParentItem = nil ) then begin
      ParentItem:= Item;
      TmpTextWidth:= GetTextSize(Canvas, Item.Caption).Cx;
      TmpAccelWidth:= GetTextSize(Canvas, ShortCutToText(Item.ShortCut)).Cx;
      MaxTextWithAccel:= TmpTextWidth;
      MaxAccel:= TmpAccelWidth;
      MaxText:= TmpTextWidth;
    end;
    for i:= 0 to ParentItem.Count - 1 do begin
      TmpTextWidth:= GetTextSize(Canvas, ParentItem[i].Caption).Cx;
      if ( ParentItem[i].Count > 0 ) then
        TmpTextWidth:= TmpTextWidth + FDefaultMargin
      else
        if ( ParentItem.Count < 2 ) then
          TmpTextWidth:= TmpTextWidth + FDefaultMargin Div 2;
      TmpAccelWidth:= GetTextSize(Canvas, ShortCutToText(ParentItem[i].ShortCut)).Cx;
      if MaxText < TmpTextWidth then
        MaxText:= TmpTextWidth;
      if ( MaxTextWithAccel < TmpTextWidth ) and ( TmpAccelWidth > 0 ) then
        MaxTextWithAccel:= TmpTextWidth;
      if ( MaxAccel < TmpAccelWidth ) then
        MaxAccel:= TmpAccelWidth;
    end;
    if ( ( MaxTextWithAccel + MaxAccel + FDefaultMargin ) > MaxText ) and ( MaxAccel > 0 ) then
      Result:= MaxTextWithAccel + MaxAccel + 2*FDefaultMargin
    else
      Result:= MaxText + 1*FDefaultMargin;
  end;
  if pos('&', Item.Caption) > 0 then
    Result:= Result - Canvas.TextWidth('&');
  if ( HasBanner(Item) ) then 
    Result:= Result + FBannerWidth;
end;

function TMenus97Options.ProcessAccel( Message: TWMMenuChar ): Integer;

 function FindAccelerator(MenuItems: TMenuItem): Integer;
  var i, MenuPos: Integer;
      MI: TMenuItemInfo;
      MenuItem: TMenuItem;

  begin
    Result:= -1;
    // added for merged MDI menus
    if (InternalMenu.Handle = Message.Menu) and (Self is TMainMenus97Options) then begin
      for i:= 0 to GetMenuItemCount(InternalMenu.Handle) - 1 do begin
        MI.cbSize:= SizeOf(TMenuItemInfo);
        MI.fMask:= MIIM_ID;
        GetMenuItemInfo(HMENU(MenuItems.Handle), i, TRUE, MI);
        if ( MI.wID <> 0 ) and ( MI.wID < 60000 ) then begin
          MenuItem:= FindItemByCommand(MI.wID);
          if ( MenuItem <> nil ) then begin
            if ( IsAccel(Word(Message.User), MenuItem.Caption) ) then begin
              Result:= i;
              Exit;
            end;
          end;
        end;
      end;
    end;
    //Result:= -1;
    MenuPos:= 0;
    for i:= 0 to MenuItems.Count - 1 do begin
      if ( Result = -1 ) and (MenuItems[i].Enabled) and MenuItems[i].Visible then begin
        if ( MenuItems.Handle <> Message.Menu ) then
          Result:= FindAccelerator(MenuItems[i]);
        if ( MenuItems.Handle = Message.Menu ) then
          if ( IsAccel(Word(Message.User), MenuItems[i].Caption) ) then begin
            Result:= MenuPos;//MenuItems[i].MenuIndex
          end;
        Inc(MenuPos);
      end;
    end;
  end;

begin
  Result:= -1;
  if ( csDesigning in FMenu.ComponentState ) then Exit;
  if ( InternalMenu <> nil ) then
    Result:= FindAccelerator(InternalMenu.Items);
end;
{ function FindAccelerator(MenuItems: TMenuItem97): Integer;
  var i: Integer;

  begin
    Result:= -1;
    for i:= 0 to MenuItems.Count - 1 do begin
      if ( Result = -1 ) and (MenuItems[i].Enabled) then begin
        if ( MenuItems.Handle <> Message.Menu ) then
          Result:= FindAccelerator(MenuItems[i]);
        if ( MenuItems.Handle = Message.Menu ) then
          if ( IsAccel(Word(Message.User), MenuItems[i].Caption) ) then begin
            Result:= MenuItems[i].MenuIndex
          end;
      end;
    end;
  end;

begin
  Result:= -1;
  if ( csDesigning in FMenu.ComponentState ) then Exit;
  if ( InternalMenu <> nil ) then
    Result:= FindAccelerator(TMenuItem97(InternalMenu.Items));
end;}

procedure TMenus97Options.ModifyMenuTree(MenuItems : TMenuItem97; Restore: Boolean);
const
  EnableFlag  : array[Boolean] of Integer = (MF_GRAYED or MF_DISABLED, MF_ENABLED);
  BreakFlag : array[TMenuBreak] of Integer = (0, MF_MENUBREAK, MF_MENUBARBREAK);
Var
  i: Integer;
begin
  // Parcours de l'arborescence du menu pour dfinir tous les items
  // comme OWNERDRAWN
  // All Items are defined as OWNERDRAWN or back to MF_STRING
  if ( MenuItems = nil ) then Exit;
  for i:= 0 to MenuItems.Count - 1 do begin
    ModifyMenuTree(MenuItems[i], Restore);
    MenuItems[i].SetOwnerDrawMode(Restore, Self);
  end;
end;

procedure TMenus97Options.InternalModifyMenuTree(MenuItems : TMenuItem97; Level : Integer);
Var i: Integer;
begin
  if ( MenuItems = nil ) then Exit;
  for i:= 0 to MenuItems.Count - 1 do begin
    InternalModifyMenuTree(MenuItems[i], Level+1);
    if ( Menuitems[i].ImageIndex = 0 ) then begin
      if ( Level = 0 ) and ( Not ( FMenu is TPopupMenu97_V3 ) ) then begin
        Menuitems[i].Look:= il3D;
        Menuitems[i].ImageIndex:= -1;
      end
      else begin
        Menuitems[i].Look:= ilDefault;
        Menuitems[i].ImageIndex:= -1;
      end;
    end;
  end
end;

procedure TMenus97Options.Office97Mapping;
begin
  if ( Assigned ( FMenu ) ) then begin
    InternalModifyMenuTree(TMenuItem97(FMenu.Items), 0);
  end;
end;

procedure TMenus97Options.SetInternalMenu(Value: TMenu);
begin
  if ( FMenu <> Value ) then begin
    if ( Assigned ( FMenu ) ) then begin  // we need to restore Menu's original state
      ModifyMenuTree(TMenuItem97(FMenu.Items), True);
    end;
    FMenu:= Value;
    if ( FMenu <> nil ) then begin
      ModifyMenuTree(TMenuItem97(FMenu.Items), False);
    end;
  end;
end;

procedure TMenus97Options.WMDrawItem(var Message: TWMDrawItem);
var
  State     : TOwnerDrawState;
  SavedDC   : Integer;
  Item      : TMenuItem97;
begin
  if ( InternalMenu = nil ) then Exit;
  with Message.DrawItemStruct^ do begin
    if ( CtlType <> ODT_MENU ) then
      Exit;
    State := TOwnerDrawState(WordRec(LongRec(itemState).Lo).Lo);
    SavedDC:= SaveDC(hDC);
    try
      FCanvas.Handle:= hDC;
      FCanvas.Font:= FFont;
      FCanvas.Brush:= FBrush;
      if ( ItemID = FMenuBarSelID ) then
        State:= State + [odSelected];
      if (Integer(itemID) >= 0) and (odSelected in State) then begin
        FCanvas.Brush.Color := clHighlight;
        FCanvas.Font.Color := clHighlightText;
      end;
      Item:= FindItemByCommand(itemID);
      if ( Item <> nil ) then
        DrawItem(Item, rcItem, State);
      if odFocused in State then
        DrawFocusRect(hDC, rcItem);
    finally
      FCanvas.Handle := 0;
      RestoreDC(hDC, SavedDC);
    end;
  end;
  Message.Result:= longint(True);
end;

procedure TMenus97Options.DrawItemText(Item: TMenuItem97; Var Rect: TRect; Text: String; State: TOwnerDrawState);
begin
  if ( Item.Default ) then
    Canvas.Font.Style:= [fsBold];
  Canvas.Brush.Style := bsClear;
  if not (Item.Enabled) then begin
    OffsetRect(Rect,1,1);
    Canvas.Font.color:= clbtnHighlight;
  end;
  if ( Not WindowIsActive ) and GrayedInactive then
    Canvas.Font.color:= clBtnShadow;
  SetBkMode(Canvas.Handle, TRANSPARENT);
  DrawText( Canvas.Handle, PChar(AnsiString(Text)),-1, Rect,
            DT_LEFT or DT_VCENTER or DT_SINGLELINE or DT_EXPANDTABS);
  if ( Item.ShortCut <> 0 ) then begin
    Dec(Rect.Right,FDefaultMargin);
    DrawText( Canvas.Handle, PChar(ShortCutToText(Item.ShortCut)),-1,
              Rect, DT_RIGHT or DT_VCENTER or DT_SINGLELINE or DT_EXPANDTABS);
  end;
  if not (Item.Enabled) and ( not (FAlwaysShowSelection and (odSelected in State)) or (Item.Caption[1] = '-') ) then begin
    Canvas.Font.Color:= clBtnShadow;
    OffsetRect(Rect,-1,-1);
    DrawText( Canvas.Handle, PChar(AnsiString(Text)),-1, Rect,
              DT_LEFT or DT_VCENTER or DT_SINGLELINE or DT_EXPANDTABS);
    if ( Item.ShortCut <> 0 ) then
      DrawText( Canvas.Handle, PChar(ShortCutToText(Item.ShortCut)),
                -1, Rect, DT_RIGHT or DT_VCENTER or DT_SINGLELINE or DT_EXPANDTABS);
  end;
end;

function TMenus97Options.HasBanner(Item: TMenuItem97): boolean;
begin
  Result:= FBanner and ((Assigned(Item.Parent) and (Item.Parent is TMenuItem97)) or (Item.FInternalCommand <> 0)) and (GetBanner(Item) <> '');
end;

function TMenus97Options.GetBanner(Item: TMenuItem97): String;
begin
  Result:= '';
  if ( Item.FInternalCommand <> 0 ) then
    Result:= TMenuItem97(Form.WindowMenu).FSubMenuBannerText;
  if ( Item.Parent <> nil ) and ( Item.Parent <> InternalMenu.Items ) then
    Result:= TMenuItem97(Item.Parent).FSubMenuBannerText;
  if ( Item.Parent = InternalMenu.Items[0] ) and ( InternalMenu.Items[0].GroupIndex = 0) and ( Result = '' ) then
    Result:= BannerText;
end;

{function TMenus97Options.BannerItem(Item: TMenuItem): TMenuItem;
begin
  Result:= Item.Parent;
end;}

function TMenus97Options.HasBkGnd(Item: TMenuItem97): boolean;
begin
  //Result:= FBanner and ((Assigned(Item.Parent) and (Item.Parent is TMenuItem97)) or (Item.FInternalCommand <> 0)) and (GetBanner(Item) <> '');
  Result:= ((Assigned(Item.Parent) and (Item.Parent is TMenuItem97)) or (Item.FInternalCommand <> 0)) and Not(GetBkGnd(Item).Empty);
end;

function TMenus97Options.GetBkGnd(Item: TMenuItem97): TBitmap;
begin
  Result:= FBkGndImage;
  if ( Item.FInternalCommand <> 0 ) then
    Result:= TMenuItem97(Form.WindowMenu).FSubMenuBkGndImage;
  if ( Item.Parent <> nil ) and ( Item.Parent <> InternalMenu.Items ) then
    Result:= TMenuItem97(Item.Parent).FSubMenuBkGndImage;
end;

function TMenus97Options.CalcMenuRect(Item: TMenuItem97): TRect;
Var R1 : TRect;
    i: Integer;
    InternalHandle: THandle;
    InternalWinHandle: THandle;
begin
  if ( Item = nil ) or ( Item.Parent = nil ) then
    InternalHandle:= InternalMenu.Handle
  else
    InternalHandle:= Item.Parent.Handle;
  if ( Form.FormStyle = fsMDIChild ) then
    InternalWinHandle:= (Form.Owner as TForm).Handle
  else
    InternalWinHandle:= InternalMenu.WindowHandle;
  GetMenuItemRect(InternalWinHandle, InternalHandle, 0, R1);
  Result:= R1;
  for i:= 0 to GetMenuItemCount(InternalHandle) - 1 do begin
    GetMenuItemRect(InternalWinHandle, InternalHandle, i, R1);
    if ( R1.Bottom > Result.Bottom ) then
      Result.Bottom:= R1.Bottom;
    if ( R1.Right > Result.Right ) then
      Result.Right:= R1.Right;
  end;
end;

procedure TMenus97Options.CalcBannerRect(Item: TMenuItem97);
Var R1 : TRect;
    i: Integer;
    InternalHandle: THandle;
    InternalWinHandle: THandle;
begin
  if ( Item = nil ) or ( Item.Parent = nil ) then
    InternalHandle:= InternalMenu.Handle
  else
    InternalHandle:= Item.Parent.Handle;
  if ( Form.FormStyle = fsMDIChild ) then
    InternalWinHandle:= (Form.Owner as TForm).Handle
  else
    InternalWinHandle:= InternalMenu.WindowHandle;
  GetMenuItemRect(InternalWinHandle, InternalHandle, 0, R1);
  FBannerRect:= R1;
  for i:= 0 to GetMenuItemCount(InternalHandle) - 1 do begin
    GetMenuItemRect(InternalWinHandle, InternalHandle, i, R1);
    if ( R1.Bottom > FBannerRect.Bottom ) then
      FBannerRect.Bottom:= R1.Bottom;
  end;
  FBannerRect.Left:= FBannerRect.Left + FBannerWidth + 2;
  OffsetRect(FBannerRect, -FBannerRect.Left, -FBannerRect.Top);
  FBannerRect.Right:= FBannerRect.Left + FBannerWidth;
end;

// De larges portions du code de cette procedure
// proviennent de l'excellent TMSOfficeCaption
// de Warren F. Young.

procedure TMenus97Options.GradientFill(DC: HDC; FBeginColor, FEndColor: TColor; R: TRect);
var
  { Set up working variables }
  BeginRGBValue  : array[0..2] of Byte;    { Begin RGB values }
  RGBDifference  : array[0..2] of integer; { Difference between begin and end }
                                           { RGB values                       }
  ColorBand : TRect;    { Color band rectangular coordinates }
  I         : Integer;  { Color band index }
  Red       : Byte;     { Color band Red value }
  Green     : Byte;     { Color band Green value }
  Blue      : Byte;     { Color band Blue value }
  Brush, OldBrush     : HBrush;
begin
  { Extract the begin RGB values }
  { Set the Red, Green and Blue colors }
  BeginRGBValue[0] := GetRValue (ColorToRGB (FBeginColor));
  BeginRGBValue[1] := GetGValue (ColorToRGB (FBeginColor));
  BeginRGBValue[2] := GetBValue (ColorToRGB (FBeginColor));
  { Calculate the difference between begin and end RGB values }
  RGBDifference[0] := GetRValue (ColorToRGB (FEndColor)) - BeginRGBValue[0];
  RGBDifference[1] := GetGValue (ColorToRGB (FEndColor)) - BeginRGBValue[1];
  RGBDifference[2] := GetBValue (ColorToRGB (FEndColor)) - BeginRGBValue[2];

  { Calculate the color band's top and bottom coordinates }
  { for Left To Right fills }
  begin
    ColorBand.Left:= R.Left;
    ColorBand.Right:= R.Right;
  end;

  { Perform the fill }
  for I := 0 to BannerNumColors-1 do
  begin  { iterate through the color bands }
    { Calculate the color band's left and right coordinates }
    ColorBand.Top   := R.Top+ MulDiv (I    , R.Bottom-R.Top, BannerNumColors);
    ColorBand.Bottom:= R.Top+ MulDiv (I + 1, R.Bottom-R.Top, BannerNumColors);
    { Calculate the color band's color }
    if BannerNumColors > 1 then
    begin
      Red   := BeginRGBValue[0] + MulDiv (I, RGBDifference[0], BannerNumColors - 1);
      Green := BeginRGBValue[1] + MulDiv (I, RGBDifference[1], BannerNumColors - 1);
      Blue  := BeginRGBValue[2] + MulDiv (I, RGBDifference[2], BannerNumColors - 1);
    end
    else
    { Set to the Begin Color if set to only one color }
    begin
      Red   := BeginRGBValue[0];
      Green := BeginRGBValue[1];
      Blue  := BeginRGBValue[2];
    end;

    { Create a brush with the appropriate color for this band }
    Brush := CreateSolidBrush(RGB(Red,Green,Blue));
    { Select that brush into the temporary DC. }
    OldBrush := SelectObject(DC, Brush);
    try
      { Fill the rectangle using the selected brush -- PatBlt is faster than FillRect }
      PatBlt(DC, ColorBand.Left, ColorBand.Top, ColorBand.Right-ColorBand.Left, ColorBand.Bottom-ColorBand.Top, PATCOPY);
    finally
      { Clean up the brush }
      SelectObject(DC, OldBrush);
      DeleteObject(Brush);
    end;
  end;  { iterate through the color bands }
end;  { GradientFill }

procedure TMenus97Options.DrawItem(Item: TMenuItem97; Rect: TRect; State: TOwnerDrawState);

  function CalcButtonRect(ARect: TRect; BmpWidth, BmpHeight: Integer): TRect;
  begin
    InflateRect(ARect, -2, -2);
    ARect.Left:= ARect.Left - 2;
    ARect.Top := ARect.Top  - 2;
    ARect.Right:= ARect.Left + BmpWidth + 4;
    ARect.Bottom := ARect.Top + CalcMenuHeight(Item);//BmpHeight + 4;
    Result:= ARect;
  end;

  procedure DrawButton(Rect: TRect; Up: Boolean);
  begin
    if ( FMenus97Look = mlOffice97Look ) then begin
      Rect.Right:= Rect.Right + 1;
      Canvas.FillRect(Rect);
      Rect.Right:= Rect.Right - 1;
      if (Up) then
        Frame3D(Canvas,Rect,clBtnHighlight,clBtnShadow,1)
      else
        Frame3D(Canvas,Rect,clBtnShadow,clBtnHighLight,1);
    end;
  end;

  procedure DrawItemBkGnd;
  Var
    APen: TPen;
  begin
    APen:= nil;
    if ( Item.Caption[1] = '-' ) then
      Item.Enabled:= False;
    if HasBkGnd(Item) then begin
      //Canvas.BrushCopy( Bounds(Rect.Left,Rect.Top,Rect.Right - Rect.Left,Rect.Bottom - Rect.Top),FBkGndBmp,
      //                         Bounds(0,Rect.Top,FBkGndBmp.Width,Rect.Bottom - Rect.Top), FBkGndBmp.Canvas.Pixels[0,0]);
      Canvas.BrushCopy( Bounds(Rect.Left,Rect.Top, FMaxImageSize.Cx+7,Rect.Bottom - Rect.Top),FBkGndBmp,
                        Bounds(0,Rect.Top, FMaxImageSize.Cx+7,Rect.Bottom - Rect.Top), clWhite);
    end
    else begin
      if( Item.Enabled ) or FAlwaysShowSelection then begin
        Canvas.Brush:= FBrush;
        if ( odSelected in State ) and Not ( ( Item.Caption <> '' ) and ( Item.Caption[1] = '-' ) ) then
          Canvas.Brush.Color:=FHiliteBar;
        if Not HasBkGnd(Item) then
          Canvas.Fillrect(Rect);
        Canvas.Brush:= FBrush;
      end;
    end;
    if ( Item.Caption[1] = '-' ) then begin
      Item.Enabled:= False;
      try
        APen:= TPen.Create;
        APen.Style:= psSolid;
        APen.Color:= clBtnShadow;
        Canvas.Pen:= APen;
        Canvas.MoveTo ( Rect.Left+1, Rect.Top + ( Rect.Bottom - Rect.Top )  Div 2 );
        Canvas.LineTo ( Rect.Right-1, Rect.Top + ( Rect.Bottom - Rect.Top )  Div 2 );
        Canvas.Pen.Color:= clBtnHighlight;
        Canvas.MoveTo ( Rect.Left+1, Rect.Top + ( Rect.Bottom - Rect.Top )  Div 2 + 1 );
        Canvas.LineTo ( Rect.Right-1, Rect.Top + ( Rect.Bottom - Rect.Top )  Div 2 + 1 );
      finally
        APen.Free;
      end;
    end;
    if ( Item.Break = mbBarBreak ) then begin
      try
        APen:= TPen.Create;
        APen.Style:= psSolid;
        APen.Color:= clBtnShadow;
        Canvas.Pen:= APen;
        Canvas.MoveTo ( Rect.Left-3, FBannerRect.Top );
        Canvas.LineTo ( Rect.Left-3, FBannerRect.Bottom );
        Canvas.Pen.Color:= clBtnHighlight;
        Canvas.MoveTo ( Rect.Left-2, FBannerRect.Top );
        Canvas.LineTo ( Rect.Left-2, FBannerRect.Bottom );
      finally
        APen.Free;
      end;
    end;
    {if( Item.Enabled ) or FAlwaysShowSelection then begin
      Canvas.Brush:= FBrush;
      if ( odSelected in State ) and Not ( ( Item.Caption <> '' ) and ( Item.Caption[1] = '-' ) ) then
        Canvas.Brush.Color:=FHiliteBar;
      if Not HasBkGnd(Item) then
        Canvas.Fillrect(Rect);
      Canvas.Brush:= FBrush;
    end;}
  end;

  procedure DrawItem;
  begin
    with Item, Canvas do begin
      DrawItemBkGnd;
      if ( Item.Enabled ) or FAlwaysShowSelection then begin
        if ( odSelected in State ) and ( ( Checked and Item.Enabled ) or (( Item.ImageIndex >= 0 ) and (FImages <> nil)) ) then begin
          //if ( Item.ImageIndex >= 0 ) and ( FImages <> nil ) then
            DrawButton(CalcButtonRect(Rect, FMaxImageSize.Cx, FMaxImageSize.Cy), True)
          //else
          //  DrawButton(CalcButtonRect(Rect, FCheckBitmap.Width, FCheckBitmap.Height), True);
        end;
        if Item.Enabled then begin
          if (RadioItem) then begin
            if ( Not ( odSelected in State ) ) and ( Checked ) then begin
              //if ( Item.ImageIndex >= 0 ) and ( FImages <> nil ) then
                DrawButton(CalcButtonRect(Rect, FMaxImageSize.Cx, FMaxImageSize.Cy), Not Checked)
              //else
              //  DrawButton(CalcButtonRect(Rect, FRadioBitmap.Width, FRadioBitmap.Height), Not Checked);
            end;
            if ( Item.ImageIndex >= 0 ) and ( FImages <> nil ) then begin
              Fimages.Draw(Canvas, Rect.Left+2, Rect.Top+2, Item.ImageIndex);
            end
            else
              if ( Checked ) then begin
                BrushCopy( Bounds(Rect.Left+1,Rect.Top+1,FMaxImageSize.Cx,FMaxImageSize.Cy),FRadioBitmap,
                           Bounds(0,0,FRadioBitmap.Width,FRadioBitmap.Height),ClWhite);
              end;
          end
          else begin
            if ( Not ( odSelected in State ) ) and ( Checked ) then begin
              //if ( Item.ImageIndex >= 0 ) and ( FImages <> nil ) then
                DrawButton(CalcButtonRect(Rect, FMaxImageSize.Cx, FMaxImageSize.Cy), Not Checked)
              //else
              //  DrawButton(CalcButtonRect(Rect, FCheckBitmap.Width, FCheckBitmap.Height), False);
            end;
            if ( Item.ImageIndex >= 0 ) and ( FImages <> nil ) then
              Fimages.Draw(Canvas, Rect.Left+2, Rect.Top+2, Item.ImageIndex)
            else
              if ( Checked ) then
                brushCopy( Bounds(Rect.Left+1,Rect.Top+1,FMaxImageSize.Cx,FMaxImageSize.Cy),FcheckBitmap,
                           Bounds(0,0,FCheckBitmap.Width,FCheckBitmap.Height),ClWhite);
          end;
        end
        else begin
          if ( Item.Tag >= 0 ) and ( FImages <> nil ) then
            DrawDisabledImage(Rect, Item.Tag);
        end;
      end
      else begin
        if ( Item.ImageIndex >= 0 ) and ( FImages <> nil ) then
          DrawDisabledImage(Rect, Item.ImageIndex);
      end;
      if ( odSelected in State ) then
        Font:= FHiliteFont
      else
        Font:= FFont;
      {if ( FImages <> nil ) then
        Inc(Rect.Left, FImages.Width+7)
      else
        Inc(Rect.Left, FCheckBitmap.Width+7);}
      Inc(Rect.Left, FMaxImageSize.Cx + 7);
      if ( Item.Caption[1] = '-' ) then
        DrawItemText(Item, Rect, Copy(Item.Caption, 2, Length(Item.Caption)), State)
      else
        DrawItemText(Item, Rect, Item.Caption, State);
    end;
  end;

  procedure DrawMenuBkGnd;
  Var //Bmp : TBitmap;
      R1  : TRect;
  begin
    if HasBkGnd(Item) then begin
      if Not Assigned(FBkGndBmp) then begin
        R1:= CalcMenuRect(TMenuItem97(Item));
        R1.Left:= Rect.Left;
        //OffsetRect(R1, -R1.Left, -R1.Top);
        //Canvas.Brush.Color:= FBrush.color;
        //Canvas.Fillrect(R1);
        FBkGndBmp:= TBitmap.Create;
        try
          FBkGndBmp.Width:= Rect.Right - Rect.Left;
          FBkGndBmp.Height:= R1.Bottom - R1.Top;
          FBkGndBmp.Canvas.StretchDraw(Bounds(0, 0, FBkGndBmp.Width, FBkGndBmp.Height), GetBkGnd(TMenuItem97(Item)));
          Canvas.BrushCopy( Bounds(Rect.Left,Rect.Top,FBkGndBmp.Width,R1.Bottom - R1.Top),FBkGndBmp,
                              Bounds(0,0,FBkGndBmp.Width,R1.Bottom - R1.Top), clWhite);
          //Canvas.BrushCopy( Bounds(Rect.Left,Rect.Top,FBkGndBmp.Width,FBkGndBmp.Height),FBkGndBmp,
          //                    Bounds(0,0,FBkGndBmp.Width,FBkGndBmp.Height), FBkGndBmp.Canvas.Pixels[0,0]);
        finally
          //Bmp.Free;
        end;
      end;
    end;
  end;

  procedure DrawBanner;
  var
      R2: TRect;
      LogRec: TLOGFONT;
      OldFont, NewFont: HFONT;
  begin
    NewFont:= 0;
    OldFont:= 0;
    if HasBanner(Item) then begin
      if ( Rect.Left = FBannerRect.Left ) then
        Rect.Left:= Rect.Left + FBannerWidth + 2;
      R2:= FBannerRect;
      OffsetRect(R2, R2.Left, R2.Top);
      if Not Assigned(FBannerBmp) then begin
        try
          FBannerBmp:= TBitmap.Create;
          FBannerBmp.Width:= R2.Right - R2.Left;
          FBannerBmp.Height:= R2.Bottom - R2.Top;
          if ( BannerColor = BannerEndColor ) then begin
            FBannerBmp.Canvas.Brush.Color:= BannerColor;
            FBannerBmp.Canvas.FillRect(R2);
          end
          else
            GradientFill(FBannerBmp.Canvas.Handle, BannerColor, BannerEndColor, R2);
          FBannerBmp.Canvas.Font.Color:= FBannerFont.Color;
          GetObject(BannerFont.Handle, SizeOf(LogRec), @LogRec);
          LogRec.lfEscapement := 900;
          LogRec.lfOutPrecision := OUT_TT_ONLY_PRECIS;
          NewFont:= CreateFontIndirect(LogRec);
          OldFont:= SelectObject(FBannerBmp.Canvas.Handle,NewFont);
          if ( FBannerImage >= 0 ) then
            R2.Bottom:= R2.Bottom - 4 - FBannerBmp.Width; // Bitmaps Width.
          SetBkMode(FBannerBmp.Canvas.Handle, TRANSPARENT);
          case FBannerJustification of
            bjCenter : FBannerBmp.Canvas.TextOut(R2.Left + (R2.Right - R2.Left - GetTextSize(FBannerBmp.Canvas, GetBanner(Item)).Cy) Div 2,
                          R2.Bottom - 1 - (R2.Bottom - R2.Top - GetTextSize(FBannerBmp.Canvas, GetBanner(Item)).Cx) Div 2, GetBanner(Item));
            bjBottom : FBannerBmp.Canvas.TextOut(R2.Left + (R2.Right - R2.Left - GetTextSize(FBannerBmp.Canvas, GetBanner(Item)).Cy) Div 2,
                          R2.Bottom - 1, GetBanner(Item));
            bjTop    : FBannerBmp.Canvas.TextOut(R2.Left + (R2.Right - R2.Left - GetTextSize(FBannerBmp.Canvas, GetBanner(Item)).Cy) Div 2,
                          R2.Top + GetTextSize(FBannerBmp.Canvas, GetBanner(Item)).Cx + 1, GetBanner(Item));
          end;
        finally
          if ( NewFont <> 0 ) then
            DeleteObject(SelectObject(FBannerBmp.Canvas.Handle,OldFont));
        end;
      end;
      FCanvas.Draw(FBannerRect.Left, FBannerRect.Top, FBannerBmp);
    end;
  end;

begin
  if ( Item.Caption = '' ) then Item.Caption:= ' ';
  if ( odSelected in State ) then begin
    if Assigned(FOnHint) then
      Item.Hint:= FOnHint(InternalMenu, Item, Item.Hint);
    Application.Hint:= Item.Hint;
  end;
  if Assigned(FOnDrawItem) then begin
    if ( FOnDrawItem(InternalMenu, Item, Rect, State) ) then
      Exit;
  end;
  if ( FNeedBannerRect ) and HasBanner(Item) then begin
    if Assigned(FBannerBmp) then begin
      FBannerBmp.Free;
      FBannerBmp:= nil;
    end;
    FNeedBannerRect:= False;
    CalcBannerRect(TMenuItem97(Item));
  end;
  if ( HasBanner(Item) ) then
    DrawBanner;
  if ( FNeedBkBmp ) and HasBkGnd(Item) then begin
    if Assigned(FBkGndBmp) then begin
      FBkGndBmp.Free;
      FBkGndBmp:= nil;
    end;
    FNeedBkBmp:= False;
  end;
  if ( HasBkGnd(Item) ) then
    DrawMenuBkGnd;
  if (Item.Look = il3D) then
    Draw3DItem(Item, Rect, State)
  else
    DrawItem;
end;

procedure TMenus97Options.WMMeasureItem(var Message: TWMMeasureItem);
Var
  Item: TMenuItem97;
begin
  if ( InternalMenu = nil ) then Exit;
  with Message.MeasureItemStruct^ do begin
    if ( CtlType <> ODT_MENU ) then
      Exit;
    FCanvas.Handle:= GetDC(InternalMenu.WindowHandle);
    FCanvas.Font:= FFont;
    try
      Item:= FindItemByCommand(itemID);
      if ( Item <> nil ) then begin
        if ( FItemHeight = 0 ) then
          itemHeight:= CalcMenuHeight(Item)
        else
          itemHeight:=  FItemHeight;
        if ( FItemWidth = 0 ) then
          itemWidth:= CalcMenuWidth(Item)
        else
          itemWidth:= FItemWidth;
        MeasureItem(Item, itemHeight, itemWidth);
      end;
      Message.Result:= longint(True);
    finally
      ReleaseDC(InternalMenu.WindowHandle, FCanvas.Handle);
      FCanvas.Handle:= 0;
    end;
  end;
end;

{$ifdef D4_OR_GREATER}
procedure TMenus97Options.MeasureItem(Item: TMenuItem97; var Height, Width: LongWord);
{$else}
procedure TMenus97Options.MeasureItem(Item: TMenuItem97; var Height, Width: Integer);
{$endif}
begin
  if Assigned(FOnMeasureItem) then
    FOnMeasureItem(InternalMenu, Item, Height, Width)
end;

procedure TMenus97Options.NewTFormWndProc(Var Message: TMessage);
Var i, j: Integer;
    MI: TMenuItemInfo;
    Item: TMenuItem97;
    C: Array[0..100] of char;
    Tmp: String;
    Found: Boolean;
begin
  // Only used to handle WM_DRAWITEM and WM_MEASUREITEM from Menus
  if ( InternalMenu <> nil ) then begin
    case Message.Msg of
      WM_WININICHANGE : if ( FDefaultFont ) then begin
                          GetDefaultMenuFont(FFont);
                          FHiliteFont.Assign(FFont);
                        end;
      (*WM_NCMOUSEMOVE : begin
                         if ( Message.wParam <> HTMENU ) then begin
                           if ( FHitPos <> -1 ) then begin
                             FHitPos:= -1;
                             DrawMenuBar((Owner as TForm).Handle);
                           end;
                         end;
                       end;
      WM_NCHITTEST   : begin
                         Message.Result:= CallWindowProc(FOldTFormWndProc, (Owner as TForm).Handle, Message.Msg, Message.WParam, Message.LParam);
                         i:= -1;
                         if ( FHitTest ) then begin
                           if ( Message.Result = HTMENU ) then begin
                             if ( LoWord(Message.lParam) < 400 ) then i:= 0;
                             if ( LoWord(Message.lParam) > 401 ) then i:= 1;
                           end
                         end;
                         if ( FHitPos <> i ) then begin
                           FHitPos:= i;
                           DrawMenuBar((Owner as TForm).Handle);
                         end;
                         Exit;
                       end;*)
      //WM_RBUTTONDOWN : if Assigned(FOnRightButtonDown) then FOnRightButtonDown(InternalMenu);
      CM_MENUCHANGED : begin
                         if ( InternalMenu <> nil ) then
                           ModifyMenuTree(TMenuItem97(InternalMenu.Items), False);
                       end;
      WM_DRAWITEM    : if ( TWMDrawItem(Message).DrawItemStruct^.CtlType = ODT_MENU ) then
                         if ( TWMDrawItem(Message).DrawItemStruct^.itemData <> 0 ) then begin
                           TMenus97Options(TWMDrawItem(Message).DrawItemStruct^.itemData).Dispatch(Message);
                           Exit;
                         end;
      WM_MEASUREITEM : if ( TWMMeasureItem(Message).idCtl = 0 ) then
                         if ( TWMMeasureItem(Message).MeasureItemStruct^.itemData <> 0 ) then begin
                           TMenus97Options(TWMMeasureItem(Message).MeasureItemStruct^.itemData).Dispatch(Message);
                           Exit;
                         end;
      WM_MENUCHAR    : begin
                         i:=ProcessAccel( TWMMenuChar(Message) );
                         if ( i >= 0 ) then begin
                           Message.Result:= MAKELRESULT(i, 2);
                           Exit;
                         end;
                         if (Form.FormStyle = fsMDIForm) and (TWMMenuChar(Message).MenuFlag = MF_POPUP) then begin
                           for i:= 0 to Form.MDIChildCount - 1 do begin
                             Message.Result:= SendMessage(Form.MDIChildren[i].Handle, Message.Msg, Message.wParam, Message.lParam);
                             if ( Message.Result <> 0 ) then
                               Exit;
                           end;
                         end;
                         {i:=ProcessAccel( TWMMenuChar(Message) );
                         if ( i >= 0 ) then begin
                           Message.Result:= MAKELRESULT(i, 2);
                           Exit;
                         end;}
                       end;
      // Used for Var initialization :
      // FInitOk       : MDI WindowMenu item initialization allowed
      // FPushedButton : MenuBarItems Look
      WM_ENTERMENULOOP : begin
                           FInitOk:= False;
                         end;
      // Used for MDI WindowsMenu Item initialization and MenuBarItem Look
      WM_INITMENUPOPUP : begin
                           //Message.Result:= CallWindowProc(FOldTFormWndProc, (Owner as TForm).Handle, Message.Msg, Message.WParam, Message.LParam);
                           //ModifyMenuTree(InternalMenu.Items, False);
                           //Message.Result:= 1;
                           if (Not FInitOk ) and ( Form <> nil ) and Assigned(Form.WindowMenu) and ( InternalMenu.FindItem(Message.wParam, fkHandle) <> nil ) and
                              (Form.FormStyle = fsMdiForm) and (Form.WindowMenu.Handle = Message.wParam) then begin
                             Message.Result:= 0;
                             for i:= Form.WindowMenu.Count+1 to GetMenuItemCount(HMenu(Message.wParam)) - 1 do begin
                               MI.cbSize:= Sizeof(TMenuItemInfo);
                               MI.fMask:= MIIM_TYPE or MIIM_STATE;
                               MI.fType:= MFT_STRING;
                               MI.cch:= 100;
                               MI.dwTypeData:= @C;
                               if ( GetMenuItemInfo(HMenu(Message.wParam), i, TRUE, MI)) then begin
                                 Item:= TMenuItem97.Create(nil);
                                 Tmp:= StrPAS(C);
                                 Item.ShortCut:= 0;
                                 if ( Pos(#9, Tmp) <> 0 ) then begin
                                   Item.Caption:= Copy(Tmp, 1, Pos(#9, Tmp)-1);
                                   Tmp:= Copy(Tmp, Pos(#9, Tmp)+1, Length(Tmp)-Pos(#9, Tmp)+1);
                                   Item.ShortCut:= TextToShortCut(Tmp);
                                 end
                                 else
                                   Item.Caption:= Tmp;
                                 Item.Enabled:= True;
                                 Item.Checked:= (MI.fState and MFS_CHECKED) = MFS_CHECKED;
                                 Item.Default:= (MI.fState and MFS_DEFAULT) = MFS_DEFAULT;
                                 Item.RadioItem:= False;
                                 Item.ImageIndex:= -2;
                                 MI.fMask:= MIIM_ID;
                                 GetMenuItemInfo(HMenu(Message.wParam), i, TRUE, MI);
                                 Item.FInternalCommand:= MI.wID;
                                 //Item.FInternalParent:= TMenuItem97((FMenu.Owner As TForm).WindowMenu);
                                 Found:= False;
                                 for j:= 0 to FMDIList.Count - 1 do begin
                                   if ( TMenuItem97(FMDIList.Items[j]).FInternalCommand = MI.wID ) then begin
                                     Found:= True;
                                     TMenuItem97(FMDIList.Items[j]).Checked:= Item.Checked;
                                   end;
                                 end;
                                 if ( Not Found ) then begin
                                   //if Item.Owner = nil then (FMenu.Owner As TForm).WindowMenu.InsertComponent(Item);
                                   //AddItems97(FMenu, TMenuItem97((FMenu.Owner As TForm).WindowMenu), [Item]);
                                   FMDIList.Insert(0, Item);
                                 end
                                 else
                                   Item.Free;
                                 ModifyMenu( HMenu(Message.wParam), MI.wID,
                                               MF_OWNERDRAW or MF_BYCOMMAND, MI.wID, Pointer(Self));
                               end;
                             end;
                             FInitOk:= True;
                           end
                           else begin
                             if ( FMenu is TMainMenu97_V3 ) then begin
                               Message.Result:= CallWindowProc(FOldTFormWndProc, FormHandle, Message.Msg, Message.WParam, Message.LParam);
                               //ModifyMenuTree(TMenuItem97(InternalMenu.Items), False);
                               FNeedBannerRect:= True;
                               FNeedBkBmp:= True;
                               Exit;
                             end;
                           end;
                           FNeedBannerRect:= True;
                           FNeedBkBmp:= True;
                         end;
    end;
  end;
  // else we call the old DefaultProc.
  Message.Result:= CallWindowProc(FOldTFormWndProc, FormHandle, Message.Msg, Message.WParam, Message.LParam);
end;

procedure TMenus97Options.SetFont(Value: TFont);
begin
  FDefaultFont:= False;
  FFont.Assign(Value);
end;

procedure TMenus97Options.SetBannerFont(Value: TFont);
begin
  FBannerFont.Assign(Value);
end;

procedure TMenus97Options.SetHiliteFont(Value: TFont);
begin
  FDefaultFont:= False;
  FHiliteFont.Assign(Value);
end;

procedure TMenus97Options.SetBrush(Value: TBrush);
begin
  FBrush.Assign(Value);
end;

procedure TMenus97Options.DrawDisabledImage(Var Rect : TRect; IndexImage : Integer);
begin
// DrawState API havn't been implmented yet in Win NT 4 & 5
// so we need to use old way to draw disabled images
//
  if ( Win32Platform = VER_PLATFORM_WIN32_NT ) then begin
    DrawDisabledImageNT(Rect, IndexImage);
  end
  else
    DrawDisabledImage95(Rect, IndexImage);
end;

// De larges portions du code de cette procedure
// proviennent de l'excellent TExplorerButton
// de Fabrice Deville.

procedure TMenus97Options.DrawDisabledImageNT(Var Rect : TRect; IndexImage : Integer);

var
  MonoBmp: TBitmap;
  Bmp    : TBitmap;

begin
  MonoBmp:= TBitmap.Create;
  Bmp    := TBitmap.Create;
  try
    Fimages.GetBitmap(IndexImage,Bmp);

    MonoBmp.Assign(Bmp);
    MonoBmp.Canvas.Brush.Color := clBlack;
    MonoBmp.Monochrome := True;

    Canvas.Brush.Color := clBtnHighlight;
    SetTextColor(Canvas.Handle, clBlack);
    SetBkColor(Canvas.Handle, clWhite);
    BitBlt(Canvas.Handle, Rect.Left+1, Rect.Top+1, Bmp.Width, Bmp.Height,
            MonoBmp.Canvas.Handle, 0, 0, $00E20746);
    Canvas.Brush.Color := clBtnShadow;
    SetTextColor(Canvas.Handle, clBlack);
    SetBkColor(Canvas.Handle, clWhite);
    BitBlt(Canvas.Handle, Rect.Left, Rect.Top, Bmp.Width, Bmp.Height,
            MonoBmp.Canvas.Handle, 0, 0, $00E20746);
  finally
    SetBkMode(Canvas.Handle, TRANSPARENT);
    MonoBmp.Free;
    Bmp.Free;
  end
end;

procedure TMenus97Options.DrawDisabledImage95(Var Rect : TRect; IndexImage : Integer);
var
  Bmp    : TBitmap;

begin
  Bmp    := TBitmap.Create;
  try
    Fimages.GetBitmap(IndexImage,Bmp);
    DrawState(Canvas.Handle, 0, nil, MakeLong(Bmp.Handle, 0), 0, Rect.Left+1, Rect.Top+1, Bmp.Width, Bmp.Height, DST_BITMAP or DSS_DISABLED);
  finally
    Bmp.Free;
  end
end;

{Main Menu Hook(s)}

{ MainMenus97_V3 Hook }

var
  MenuHook: HHOOK;

// This Hook is used to handle events in Modal MenuLoop

function MenuGetMsgHook(nCode: Integer; wParam: Longint; var Msg: TMsg): Longint; stdcall;
Var Control: TMenuSpeedButton;
    Pt: TPoint;
    i: Integer;
begin
  if (nCode = MSGF_MENU) and (CurrentHookControl <> nil) then begin
    with CurrentHookControl do begin
      case Msg.Message of
        WM_LBUTTONDOWN :
          begin
            Pt:= SmallPointToPoint(TSmallPoint(Msg.lParam));
            Pt:= CurrentHookControl.ScreenToClient(Pt);
            Control := ControlAtPos(Pt, False) as TMenuSpeedButton;
            if ( Control <> nil ) and ( Control = InternalActiveControl ) and ( Control.Parent = CurrentHookControl ) then begin
              Keybd_Event(VK_ESCAPE, 0, 0, Msg.lParam);
              InternalActiveControl.MouseUp(mbLeft, [], Pt.x, Pt.y);
              CurrentHookControl.FMenuOpen:= False;
              Result:= 1;
              Exit;
            end;
          end;
        WM_MOUSEMOVE :
          begin
            Pt:= SmallPointToPoint(TSmallPoint(Msg.lParam));
            Pt:= CurrentHookControl.ScreenToClient(Pt);
            Control := ControlAtPos(Pt, False) as TMenuSpeedButton;
            i:= 0;
            if ( Control <> nil ) then
              if ( Control <> InternalActiveControl ) and ( Control.Parent = CurrentHookControl ) then begin
                InternalActiveControl.MouseUp(mbLeft, [], Pt.x, Pt.y);
                InternalActiveControl:= Control;
                while ( i < CurrentHookControl.ControlCount ) and ( CurrentHookControl.Controls[i] <> TControl(InternalActiveControl) ) do Inc(i);
                CurrentHookControl.FActiveControl:= i;
                CurrentHookControl.FActiveControl:= InternalActiveControl.ComponentIndex;
                PostMessage(CurrentHookControl.Handle, WM_LBUTTONDOWN, MK_LBUTTON, MakeLong(Pt.x, Pt.y));
                Result:= 1;
                Exit;
              end;
          end;
        WM_SYSKEYDOWN :
          case Msg.wParam of
            VK_MENU : begin
                        CurrentHookControl.FMenuOpen:= False;
                      end;
          end;
        WM_KEYDOWN :
          case Msg.wParam of
            VK_ESCAPE : begin
                        CurrentHookControl.FMenuOpen:= False;
                      end;
            VK_LEFT  : begin
                         i:= 0;
                         while ( i < CurrentHookControl.ControlCount ) and ( CurrentHookControl.Controls[i] <> TControl(InternalActiveControl) ) do Inc(i);
                         if ( i <= 0 ) then
                           i:= CurrentHookControl.ControlCount - 1
                         else
                           Dec(i);
                         CurrentHookControl.FActiveControl:= i;
                         Control:= CurrentHookControl.Controls[i] as TMenuSpeedButton;
                         if ( Control <> nil ) and ( Control <> InternalActiveControl ) and ( Control.Parent = CurrentHookControl ) then begin
                           InternalActiveControl.MouseUp(mbLeft, [], InternalActiveControl.Left, InternalActiveControl.Top);
                           InternalActiveControl:= Control;
                           PostMessage(CurrentHookControl.Handle, WM_LBUTTONDOWN, MK_LBUTTON, MakeLong(InternalActiveControl.Left, InternalActiveControl.Top));
                           Result:= 1;
                           Exit;
                         end;
                       end;
            VK_RIGHT : begin
                         i:= 0;
                         while ( i < CurrentHookControl.ControlCount ) and ( CurrentHookControl.Controls[i] <> TControl(InternalActiveControl) ) do Inc(i);
                         if ( i >= CurrentHookControl.ControlCount - 1 ) then
                           i:= 0
                         else
                           Inc(i);
                         CurrentHookControl.FActiveControl:= i;
                         Control:= CurrentHookControl.Controls[i] as TMenuSpeedButton;
                         if ( Control <> nil ) and ( Control <> InternalActiveControl ) and ( Control.Parent = CurrentHookControl ) then begin
                           InternalActiveControl.MouseUp(mbLeft, [], InternalActiveControl.Left, InternalActiveControl.Top);
                           InternalActiveControl:= Control;
                           PostMessage(CurrentHookControl.Handle, WM_LBUTTONDOWN, MK_LBUTTON, MakeLong(InternalActiveControl.Left, InternalActiveControl.Top));
                           Result:= 1;
                           Exit;
                         end;
                       end;
          end;
      end;
    end;
  end;
  Result:= CallNextHookEx(MenuHook, nCode, wParam, Longint(@Msg));
end;

procedure HookMenuHooks;
begin
  begin
    if MenuHook = 0 then
      MenuHook := SetWindowsHookEx(WH_MSGFILTER, @MenuGetMsgHook, 0, GetCurrentThreadID);
  end;
end;

procedure UnHookMenuHooks;
begin
  if MenuHook <> 0 then UnHookWindowsHookEx(MenuHook);
  MenuHook := 0;
end;

{TMainMenus97Options}

constructor TMainMenus97Options.Create(AMenu: TMenu);
begin
  inherited Create(AMenu);
  FHideMenuBar:= False;
  FHitTest:= True;
  FHitPos:= -1;
  FToolBar:= nil;
  FMenuOpen:= False;
end;

destructor TMainMenus97Options.Destroy;
Var i: Integer;
begin
  UnHookMenuHooks;
  Application.OnMessage:= nil;
  if ( FToolBar <> nil ) then begin
    for i:= FToolBar.ControlCount - 1 downto 0 do
      FToolBar.Controls[i].Free;
  end;
  inherited Destroy;
end;

procedure TMainMenus97Options.NewTFormWndProc(Var Message: TMessage);
Var R, WR: TRect;
    i: Integer;
    MI: TMenuItemInfo;
    Item: TMenuItem;
    XPos: Integer;
    TmpMenuBarHeight: Integer;
    TmpRgn: HRGN;
    DC: HDC;
    //OldSelID: Integer;
    //Pt: TPoint;
begin
  if ( InternalMenu <> nil ) then begin
    case Message.Msg of
      WM_NCACTIVATE : begin
                        //Message.Result:= CallWindowProc(FOldTFormWndProc, FormHandle, Message.Msg, Message.WParam, Message.LParam);
                        //FWindowIsActive:= TWMNCActivate(Message).Active;
                        if ( Not FHideMenuBar ) then begin
                          FWindowIsActive:= TWMNCActivate(Message).Active;
                          ReDrawWindow(FormHandle,nil,0,RDW_FRAME or RDW_INVALIDATE or RDW_UPDATENOW)
                        end;
                        {else
                          if ( FToolBar <> nil ) then
                            FToolBar.Refresh;
                        Exit;}
                      end;
      {WM_ACTIVATE : begin
                        Message.Result:= CallWindowProc(FOldTFormWndProc, FormHandle, Message.Msg, Message.WParam, Message.LParam);
                        FWindowIsActive:= TWMActivate(Message).Active <> WA_INACTIVE;
                        if ( Not FHideMenuBar ) then
                          ReDrawWindow(FormHandle,nil,0,RDW_FRAME or RDW_INVALIDATE or RDW_UPDATENOW)
                        else
                          if ( FToolBar <> nil ) then
                            FToolBar.Refresh;
                        Exit;
                      end;}
      WM_NCPAINT : begin
                     if ( HideMenuBar ) and (Application.MainForm = Form) then begin
                       R:= CalcMenuRect(TMenuItem97(InternalMenu.Items[0]));
                       DC := GetWindowDC(FormHandle);
                       GetWindowRect(FormHandle, WR);
                       TmpRgn := CreateRectRgnIndirect(WR);
                       try
                         if SelectClipRgn(DC, Message.wParam) = ERROR then
                           SelectClipRgn(DC, TmpRgn);
                         Windows.GetClientRect(FormHandle, WR);
                         ExcludeClipRect(DC, R.Left, R.Top, R.Left + WR.Right, R.Bottom + 2);
                         GetClipRgn(DC, TmpRgn);
                         Message.Result := CallWindowProc(FOldTFormWndProc, FormHandle, Message.Msg, TmpRgn, Message.LParam);
                       finally
                         DeleteObject(TmpRgn);
                         ReleaseDC(FormHandle, DC);
                       end;
                       Exit;
                     end;
                   end;
      WM_GETDLGCODE : if ( FToolBar <> nil ) and ( FToolBar.FInMenuBar ) then begin
                        Message.Result:= DLGC_WANTARROWS;
                        Exit;
                      end;
      WM_KEYDOWN : case Message.wParam of
                     VK_LEFT,
                     VK_RIGHT,
                     VK_DOWN,
                     VK_ESCAPE : if ( FToolBar <> nil ) and ( FToolBar.FInMenuBar ) then begin
                                   FToolBar.WndProc(Message);
                                   Message.Result:= 0;
                                 end;
                   end;
      // Handle Alt Key if OwnerMenuBar is choosen
      WM_SYSCOMMAND : if ( FToolBar <> nil ) then begin
                        if ( Message.wParam = SC_KEYMENU ) and ( Message.lParam = 0 ) then begin
                          FToolBar.WndProc(Message);
                          Message.Result:= 0;
                          //SendMessage(FToolBar.Handle, WM_SYSKEYDOWN, VK_MENU, 0);
                          Exit;
                        end;
                      end;
      // Used to remove MenuBar
      WM_NCCALCSIZE : begin
                        Message.Result:= CallWindowProc(FOldTFormWndProc, FormHandle, Message.Msg, Message.WParam, Message.LParam);
                        if FHideMenuBar and (Application.MainForm = Form) then begin
                          R:= TWMNCCalcSize(Message).CalcSize_Params.rgrc[0];
                          OffsetRect(R, 0, -GetSystemMetrics(SM_CYMENU));
                          R.Bottom:= R.Bottom + GetSystemMetrics(SM_CYMENU);
                          TWMNCCalcSize(Message).CalcSize_Params.rgrc[0]:= R;
                        end;
                        Exit;
                      end;
      // Used to remove MenuBar
      WM_NCHITTEST   : begin
                         Message.Result:= CallWindowProc(FOldTFormWndProc, FormHandle, Message.Msg, Message.WParam, Message.LParam);
                         if FHideMenuBar and ( Message.Result = HTMENU ) then
                           Message.Result:= HTTRANSPARENT;
                         {else begin
                           OldSelID:= FMenuBarSelID;
                           if ( InternalMenu <> nil ) then begin
                             Pt.x:= TSmallPoint(Message.lParam).x;
                             Pt.y:= TSmallPoint(Message.lParam).y;
                             FMenuBarSelID:= Integer(MenuItemFromPoint((Owner as TForm).Handle, InternalMenu.Handle, Pt));
                             if ( FMenuBarSelID >= 0 ) and ( FMenuBarSelID <= InternalMenu.Items.Count - 1 ) then
                               FMenuBarSelID:= InternalMenu.Items[FMenuBarSelID].Command;
                             if ( OldSelID <> FMenuBarSelID ) then
                               DrawMenuBar((Owner as TForm).Handle);
                           end;
                         end;}
                         Exit;
                       end;
      // Used to handle MenuBar accelerator keys before Menu
      WM_MENUCHAR    : begin
                         i:=ProcessAccel( TWMMenuChar(Message) );
                         if ( i >= 0 ) then begin
                           if ( InternalMenu.Items.Handle <> TWMMenuChar(Message).Menu ) then begin
                             Message.Result:= MAKELRESULT(i, 2);
                             Exit;
                           end
                           (*else begin
                             if ( FToolBar <> nil ) and ( FToolBar.ControlCount > i ) then begin
                               InternalActiveControl:= (FToolBar.Controls[i] as TMenuSpeedButton);
                               InternalActiveControl.MouseDown(mbLeft, [], InternalActiveControl.Left+1, InternalActiveControl.Top+1);
                               Exit;
                             end;
                           end;*)
                         end;
                       end;
      //WM_PAINT :
      // Used for MDI Menus / Menu Modifications and many more
      // WM_WINDOWPOSCHANGING is the FirstMessage Sent when DrawMenuBar is called
      // Avoid calling DrawMenuBar in :
      // - WM_WINDOWPOSCHANGING,
      // - WM_WINDOWPOSCHANGED,
      // - WM_NCPAINT,
      // - WM_NCCALCSIZE
      WM_WINDOWPOSCHANGING :
                     begin
                       XPos:= 0;
                       TmpMenuBarHeight:= FItemHeight;
                       if ( InternalMenu <> nil ) and ((Not FHideMenuBar) or (FToolBar<>nil)) then begin
                         if ( Form <> nil ) and (( Form.FormStyle = fsMdiForm ) or ( Form.FormStyle = fsNormal )) then begin
                           Message.Result:= CallWindowProc(FOldTFormWndProc, Form.Handle, Message.Msg, Message.WParam, Message.LParam);
                           if ( InternalMenu <> nil ) and ( InternalActiveControl = nil ) then begin
                             if ( FToolBar <> nil ) then begin
                               for i:= GetMenuItemCount(HMenu(InternalMenu.Handle)) to FToolBar.ControlCount - 1 do
                                 FToolBar.Controls[i].Visible:= False;
                               TmpMenuBarHeight:= CalcMenuBarHeight;
                             end;
                             for i:= 0 to GetMenuItemCount(HMenu(InternalMenu.Handle)) - 1 do begin
                               MI.fMask:= MIIM_ID;
                               MI.cbSize:= Sizeof(TMenuItemInfo);
                               GetMenuItemInfo(InternalMenu.Handle, i, TRUE, MI);
                               if ( MI.wID <> 0 ) and ( MI.wID < 60000 ) then begin
                                 Item:= InternalMenu.FindItem(MI.wID, fkCommand);
                                 if ( Item = nil ) or ( Item.Parent.Handle <> InternalMenu.Handle) then begin
                                   ModifyMenu( InternalMenu.Handle, MI.wID,
                                                 MF_OWNERDRAW or MF_BYCOMMAND, MI.wID, Pointer(Self));
                                 end
                               end;
                               Item:= FindItemByCommand(MI.wID);
                               if (FToolBar <> nil ) and ( Item <> nil ) then begin
                                 ToolBar.Height:= TmpMenuBarHeight+1;
                                 if ( i > FToolBar.ControlCount - 1 ) then
                                   with TMenuSpeedButton.Create(FToolBar) do begin
                                     Parent:= FToolBar;
                                     {$ifndef VER90}
                                     Flat:= True;
                                     {$endif}
                                     AllowAllUp:= True;
                                     GroupIndex:= 0;
                                     FM97Handle:= FormHandle;
                                     FInDown:= False;
                                   end;
                                 with FToolBar.Controls[i] as TMenuSpeedButton do begin
                                   Visible:= True;
                                   Left:= XPos;
                                   Height:= TmpMenuBarHeight;
                                   Width:= Length(Item.Caption) * 6;
                                   XPos:= XPos + Width;
                                   Caption:= Item.Caption;
                                   Tag:= Item.Handle;
                                   Hint:= Item.Caption;
                                 end;
                               end;
                             end;
                           end;
                           ModifyMenuTree(TMenuItem97(InternalMenu.Items), False);
                           Exit;
                         end;
                       end;
                     end;
      // Used for Var initialization :
      // FInitOk       : MDI WindowMenu item initialization allowed
      // FPushedButton : MenuBarItems Look
      WM_ENTERMENULOOP : begin
                           FPushedButton:= False;
                           FHitTest:= False;
                           FMenuOpen:= True;
                           if ( FToolBar <> nil ) then begin
                             HookMenuHooks;
                             CurrentHookControl:= FToolBar;
                             if ( InternalActiveControl = nil ) and ( FToolBar.ControlCount > 0 ) and ( Not FToolBar.FInMenuBar ) then begin
                               InternalActiveControl:= (FToolBar.Controls[0] as TMenuSpeedButton);
                               InternalActiveControl.Perform(CM_MOUSEENTER, 0, 0);
                             end;
                           end;
                         end;
      WM_EXITMENULOOP  : begin
                           FHitTest:= True;
                           FMenuOpen:= False;
                           if ( FToolBar <> nil ) then begin
                             UnHookMenuHooks;
                             if ( InternalActiveControl <> nil ) and ( InternalActiveControl.FInDown ) then begin
                               InternalActiveControl.MouseUp(mbLeft, [], InternalActiveControl.Left+1, InternalActiveControl.Top+1);
                               if ( FToolBar.FInMenuBar ) then
                                 InternalActiveControl.Perform(CM_MOUSEENTER, 0, 0);
                             end;
                           end;
                           CurrentHookControl:= nil;
                           InternalActiveControl:= nil;
                         end;
      // Used for Updating MenuBarItem Look (Leaving popup with ESC key)
      WM_MENUSELECT    : begin
                           if (Message.lParam = 0) and ( HiWord(Message.wParam) = $FFFF ) then begin
                             FNeedBannerRect:= True;
                             FNeedBkBmp:= True;
                           end;
                           if (Not FHideMenuBar) and (Message.lParam = FMenu.Handle) and Not ( ( ( HiWord(Message.wParam) and MF_MOUSESELECT ) = MF_MOUSESELECT ) ) then begin
                             if (Self is TMainMenus97Options) and ( FPushedButton ) then begin
                               FPushedButton:= False;
                               DrawMenuBar(FormHandle);
                             end;
                           end;
                           if (Message.lParam = 0) and ( HiWord(Message.wParam) = $FFFF ) then begin
                             if (FHideMenuBar) and ( FToolBar <> nil ) then begin
                               FToolBar.FMenuOpen:= False;
                               Message.Msg:= WM_SYSCOMMAND;
                               Message.wParam:= SC_KEYMENU;
                               Message.lParam:= 0;
                               Exit
                             end;
                           end;
                         end;
      // Used for MDI WindowsMenu Item initialization and MenuBarItem Look
      WM_INITMENUPOPUP : begin
                           Message.Result:= 1;
                           if (Not FHideMenuBar) and ( Not FPushedButton ) and ( HiWord(Message.lParam) = 0 ) then begin
                             FPushedButton:= True;
                             DrawMenuBar(FormHandle);
                           end;
                         end;
    end;
  end;
  // else we call the old DefaultProc.
  inherited NewTFormWndProc(Message);
end;

function TMainMenus97Options.WindowIsActive: Boolean;
begin
  Result:= FWindowIsActive;
  //Result := (FormHandle = GetActiveWindow);
  {If (MyOwner.FormStyle = fsMDIChild)
    then if Application <> nil
    then if Application.Mainform <> nil
    then if MyOwner = Application.Mainform.ActiveMDIChild
    then if Application.Mainform.HandleAllocated
    then if Application.Mainform.Handle = GetActiveWindow
      then result := true;}
end;

procedure TMainMenus97Options.SetToolBar(Value: TCustomMenuBar97_V3);
Var i: Integer;
begin
  if ( FToolBar = Value ) then Exit;
  FToolBar:= Value;
  if ( Value <> nil ) then begin
    for i:= FToolBar.ControlCount - 1 downto 0 do
      FToolBar.Controls[i].Free;
    FHideMenuBar:= True;
    DrawMenuBar(FormHandle);
  end;
end;

procedure TMainMenus97Options.SetHideMenuBar(Value: Boolean);
begin
  if ( Value <> FHideMenuBar ) and ( FToolBar = nil ) then begin
    FHideMenuBar:= Value;
    DrawMenuBar(FormHandle);
  end;
end;

function TMainMenus97Options.CalcMenuBarHeight: Integer;
begin
  Result:= FItemHeight;
  if ( FItemHeight <> 0 ) then Exit;
  if ( InternalMenu = nil ) then Exit;
  FCanvas.Handle:= GetDC(InternalMenu.WindowHandle);
  FCanvas.Font:= FFont;
  try
    Result:= CalcMenuHeight(TMenuItem97(InternalMenu.Items[0]))
  finally
    ReleaseDC(InternalMenu.WindowHandle, FCanvas.Handle);
    FCanvas.Handle:= 0;
  end;
end;

procedure TMainMenus97Options.DrawItem(Item: TMenuItem97; Rect: TRect; State: TOwnerDrawState);
begin
  if ( FHideMenuBar ) and ( Item.Parent = nil ) then Exit;
  inherited DrawItem(Item, Rect, State);;
end;

(*procedure TMainMenus97Options.Draw3DItem(Item: TMenuItem97; Var Rect: TRect; State: TOwnerDrawState);
begin
  //if ( FHideMenuBar ) then Exit;
  //inherited Draw3DItem(Item: TMenuItem97; Var Rect: TRect; State: TOwnerDrawState);
  with Canvas do begin
    Brush:= FBrush;
    Fillrect(Rect);
    if ( odSelected in State ) then begin
      if ( FPushedButton ) then
        Frame3D(Canvas,Rect,clBtnShadow,clBtnHighlight,1)
      else
        Frame3D(Canvas,Rect,clBtnHighlight,clBtnShadow,1);
    end;
    if ( Item.ImageIndex >= 0 ) and ( FImages <> Nil ) then begin
      Inc(Rect.Left,3);
      Fimages.Draw(Canvas, Rect.Left, Rect.Top+1, Item.ImageIndex);
      Inc(Rect.Left, FImages.Width + 2);
    end
    else
      Inc(Rect.Left,5);
    Font:= FFont;
    DrawItemText(Item, Rect, Item.Caption);
  end;
end;*)

{TPopupMenus97Options}

procedure TPopupMenus97Options.NewTFormWndProc(Var Message: TMessage);
var
  I: Integer;
  MenuItem: TMenuItem97;
  FindKind: TFindItemKind;
  ContextID: Integer;
begin
  try
    case Message.Msg of
      WM_DRAWITEM    : if ( TWMDrawItem(Message).DrawItemStruct^.CtlType = ODT_MENU ) then
                         if ( TWMDrawItem(Message).DrawItemStruct^.itemData <> 0 ) then begin
                           TPopupMenus97Options(TWMDrawItem(Message).DrawItemStruct^.itemData).Dispatch(Message);
                           Exit;
                         end;
      WM_MEASUREITEM : if ( TWMMeasureItem(Message).idCtl = 0 ) then
                         if ( TWMMeasureItem(Message).MeasureItemStruct^.itemData <> 0 ) then begin
                            TPopupMenus97Options(TWMMeasureItem(Message).MeasureItemStruct^.itemData).Dispatch(Message);
                            Exit;
                         end;
      WM_MENUCHAR    : begin
                           i:=ProcessAccel( TWMMenuChar(Message) );
                           if ( i >= 0 ) then begin
                             Message.Result:= MAKELRESULT(i, 2);
                             Exit;
                           end;
                       end;
      WM_INITMENUPOPUP : begin
                           inherited NewTFormWndProc(Message);
                           with TWMInitMenuPopup(Message) do
                             FMenu.DispatchPopup(MenuPopup);
                           Message.Result:= 0;
                           ModifyMenuTree(TMenuItem97(InternalMenu.Items), False);
                           FNeedBannerRect:= True;
                           FNeedBkBmp:= True;
                           Exit;
                         end;
      WM_INITMENU,
      CM_MENUCHANGED : begin
                         inherited NewTFormWndProc(Message);
                         ModifyMenuTree(TMenuItem97(InternalMenu.Items), False);
                         Exit;
                       end;
      WM_COMMAND:
        begin
          //MessageBeep(MB_OK);
          if FMenu.DispatchCommand(Message.wParam) then Exit;
        end;
      WM_MENUSELECT:
        with TWMMenuSelect(Message) do
        begin
          if (Message.lParam = 0) and ( HiWord(Message.wParam) = $FFFF ) then begin
            FNeedBannerRect:= True;
            FNeedBkBmp:= True;
          end;
          FindKind := fkCommand;
          if MenuFlag and MF_POPUP <> 0 then FindKind := fkHandle;
          MenuItem:= TMenuItem97(FMenu.FindItem(IDItem, FindKind));
          if MenuItem <> nil then begin
            Application.Hint := MenuItem.Hint;
            Exit;
          end;
          Application.Hint := '';
        end;
      WM_HELP:
        with PHelpInfo(Message.LParam)^ do
        begin
          if FMenu.Handle = hItemHandle then begin
            ContextID := FMenu.GetHelpContext(iCtrlID, True);
            if ContextID = 0 then
              ContextID := FMenu.GetHelpContext(hItemHandle, False);
            if Screen.ActiveForm = nil then Exit;
            if (biHelp in Screen.ActiveForm.BorderIcons) then
              Application.HelpCommand(HELP_CONTEXTPOPUP, ContextID)
            else
              Application.HelpContext(ContextID);
            Exit;
          end;
        end;
    end;
    inherited NewTFormWndProc(Message);
  except
    Application.HandleException(Self);
  end;
end;

function TPopupMenus97Options.HasBanner(Item: TMenuItem97): boolean;
begin
  Result:= FBanner and ( GetBanner(Item) <> '' );
end;

function TPopupMenus97Options.GetBanner(Item: TMenuItem97): String;
begin
  Result:= '';
  if ( Item.Parent <> nil ) and ( Item.Parent <> InternalMenu.Items ) then
    Result:= TMenuItem97(Item.Parent).FSubMenuBannerText
  else
    Result:= BannerText;
end;

function TPopupMenus97Options.HasBkGnd(Item: TMenuItem97): boolean;
begin
  Result:= Not(GetBkGnd(Item).Empty);
end;

function TPopupMenus97Options.GetBkGnd(Item: TMenuItem97): TBitmap;
begin
  Result:= FBkGndImage;
  if ( Item.Parent <> nil ) and ( Item.Parent <> InternalMenu.Items ) then
    Result:= TMenuItem97(Item.Parent).FSubMenuBkGndImage
end;

function TPopupMenus97Options.CalcMenuRect(Item: TMenuItem97): TRect;
Var R1 : TRect;
    i: Integer;
    InternalHandle: THandle;
begin
  if ( Item = nil ) or ( Item.Parent = nil ) or ( Item.Parent = InternalMenu.Items ) then
    InternalHandle:= InternalMenu.Handle
  else
    InternalHandle:= Item.Parent.Handle;
  GetMenuItemRect(InternalMenu.WindowHandle, InternalHandle, 0, R1);
  Result:= R1;
  for i:= 0 to GetMenuItemCount(InternalHandle) - 1 do begin
    GetMenuItemRect(InternalMenu.WindowHandle, InternalHandle, i, R1);
    if ( R1.Bottom > Result.Bottom ) then
      Result.Bottom:= R1.Bottom;
    if ( R1.Right > Result.Right ) then
      Result.Right:= R1.Right;
  end;
end;

procedure TPopupMenus97Options.CalcBannerRect(Item: TMenuItem97);
Var R1 : TRect;
    i: Integer;
    InternalHandle: THandle;
begin
  if ( Item = nil ) or ( Item.Parent = nil ) or ( Item.Parent = InternalMenu.Items ) then
    InternalHandle:= InternalMenu.Handle
  else
    InternalHandle:= Item.Parent.Handle;

  GetMenuItemRect(InternalMenu.WindowHandle, InternalHandle, 0, R1);
  FBannerRect:= R1;
  for i:= 0 to GetMenuItemCount(InternalHandle) - 1 do begin
    GetMenuItemRect(InternalMenu.WindowHandle, InternalHandle, i, R1);
    if ( R1.Bottom > FBannerRect.Bottom ) then
      FBannerRect.Bottom:= R1.Bottom;
  end;
  FBannerRect.Left:= FBannerRect.Left + FBannerWidth + 2;
  OffsetRect(FBannerRect, -FBannerRect.Left, -FBannerRect.Top);
  FBannerRect.Right:= FBannerRect.Left + FBannerWidth;
end;

{ TSystemMenuItem97Options }

constructor TSystemMenuItem97Options.Create(Command: Integer);
begin
  inherited Create;
  FMenuItem:= TMenuItem97.Create(nil);
  FMenuItem.Enabled:= True;
  FMenuItem.Caption:= '';
  FMenuItem.Look:= ilDefault;
  FMenuItem.FImageIndex:= -1;
  FImageIndex:= -1;
  FVisible:= smDefault;
  FCaption:= '';
  FCommand:= Command;
end;

destructor TSystemMenuItem97Options.Destroy;
begin
  FMenuItem.Free;
  inherited Destroy;
end;

procedure TSystemMenuItem97Options.MenuItemFromCommand(MenuHandle: THandle; aOwner: TSystemMenus97Options);
const
  IBreaks: array[TMenuBreak] of Longint = (MFT_STRING, MFT_MENUBREAK, MFT_MENUBARBREAK);
  IChecks: array[Boolean] of Longint = (MFS_UNCHECKED, MFS_CHECKED);
  IDefaults: array[Boolean] of Longint = (0, MFS_DEFAULT);
  IEnables: array[Boolean] of Longint = (MFS_DISABLED or MFS_GRAYED, MFS_ENABLED);
  IRadios: array[Boolean] of Longint = (MFT_STRING, MFT_RADIOCHECK);
  ISeparators: array[Boolean] of Longint = (MFT_STRING, MFT_SEPARATOR);
var C: Array[0..100] of char;
    MI: TMenuItemInfo;
    Tmp: String;
    Exists: Boolean;
    i: Integer;
begin
  if ( Visible = smFalse ) then begin
    DeleteMenu(MenuHandle, FCommand, MF_BYCOMMAND);
  end;
  MI.cbSize:= Sizeof(TMenuItemInfo);
  MI.fMask:= MIIM_TYPE or MIIM_STATE;
  MI.fType:= MFT_STRING;
  MI.cch:= 100;
  MI.dwTypeData:= @C;
  Exists:= GetMenuItemInfo(MenuHandle, FCommand, FALSE, MI);
  if ( Exists or ( Visible = smTrue ) ) then begin
    Tmp:= StrPAS(C);
    if ( FCaption <> '' ) or ( ( Visible = smTrue ) and ( Not Exists ) ) then begin
      Tmp:= FCaption;
      i:= Pos('#9', Tmp);
      if ( i <> 0 ) then begin
        Tmp[i]:= #9;
        Delete(Tmp, i+1, 1);
      end;
      MI.fState:= MFS_ENABLED;
    end;
    FMenuItem.ShortCut:= 0;
    if ( Pos(#9, Tmp) <> 0 ) then begin
      FMenuItem.Caption:= Copy(Tmp, 1, Pos(#9, Tmp)-1);
      Tmp:= Copy(Tmp, Pos(#9, Tmp)+1, Length(Tmp)-Pos(#9, Tmp)+1);
      FMenuItem.ShortCut:= TextToShortCut(Tmp);
    end
    else
      FMenuItem.Caption:= Tmp;
    FMenuItem.Enabled:= (MI.fState and MFS_ENABLED) = MFS_ENABLED;
    FMenuItem.Checked:= (MI.fState and MFS_CHECKED) = MFS_CHECKED;
    FMenuItem.Default:= (MI.fState and MFS_DEFAULT) = MFS_DEFAULT;
    FMenuItem.RadioItem:= (MI.hbmpChecked = 0);
    FMenuItem.FImageIndex:= FImageIndex;
    if ( Not Exists ) then begin
      MI.cbSize := SizeOf(TMenuItemInfo);
      MI.fMask := MIIM_CHECKMARKS or MIIM_DATA or MIIM_ID or
                  MIIM_STATE or MIIM_SUBMENU or MIIM_TYPE;
      MI.fType := IRadios[FMenuItem.RadioItem] or IBreaks[FMenuItem.Break] or
      ISeparators[FCaption = '-'];
      MI.fState := IChecks[FMenuItem.Checked] or IEnables[FMenuItem.Enabled] or IDefaults[FMenuItem.Default];
      MI.wID := FCommand;
      MI.hSubMenu := 0;
      MI.hbmpChecked := 0;
      MI.hbmpUnchecked := 0;
      MI.dwTypeData := PChar(AnsiString(FCaption));
      InsertMenuItem(MenuHandle, aOwner.FInsertBefore, False, MI);
    end;
    MI.cbSize:= Sizeof(TMenuItemInfo);
    MI.fMask:= MIIM_TYPE;
    MI.fType:= 0;
    MI.cch:= 0;
    GetMenuItemInfo(MenuHandle, FCommand, FALSE, MI);
    if ( ( MI.fType and MFT_OWNERDRAW ) <> MFT_OWNERDRAW ) then
      ModifyMenu(MenuHandle, FCommand, MF_OWNERDRAW or MF_BYCOMMAND or IEnables[FMenuItem.Enabled] or IBreaks[FMenuItem.Break], FCommand, Pointer(aOwner))
  end
end;

{ TSystemMenu97_V3 }

constructor TSystemMenus97Options.Create(aMenu : TMenu);
begin
  inherited Create(aMenu);
  FSysMenuHandle:= 0;
  FScItem[0]:= TSystemMenuItem97Options.Create(SC_RESTORE);
  FScItem[1]:= TSystemMenuItem97Options.Create(SC_MOVE);
  FScItem[2]:= TSystemMenuItem97Options.Create(SC_SIZE);
  FScItem[3]:= TSystemMenuItem97Options.Create(SC_MINIMIZE);
  FScItem[4]:= TSystemMenuItem97Options.Create(SC_MAXIMIZE);
  FScItem[5]:= TSystemMenuItem97Options.Create(SC_CLOSE);
  FScItem[6]:= TSystemMenuItem97Options.Create(SC_NEXTWINDOW);
  FScItem[7]:= TSystemMenuItem97Options.Create(SC_PREVWINDOW);
  FScItem[8]:= TSystemMenuItem97Options.Create(SC_TASKLIST);
  FScItem[9]:= TSystemMenuItem97Options.Create(SC_SCREENSAVE);
  FInsertBefore:= SC_CLOSE;
end;

destructor TSystemMenus97Options.Destroy;
Var i: Integer;
begin
  for i:= 0 to 9 do
    FScItem[i].Free;
  inherited Destroy;
end;

procedure TSystemMenus97Options.HookForm;
begin
  if ( FormHandle <> 0 ) then begin
    if ( Form.FormStyle = fsMDIChild ) then
      FInsertBefore:= SC_NEXTWINDOW
    else
      FInsertBefore:= SC_CLOSE;
    FSysMenuHandle:= GetSystemMenu(FormHandle, FALSE);
  end;
  inherited HookForm;
end;

procedure TSystemMenus97Options.UnHookForm;
begin
  GetSystemMenu(FormHandle, TRUE);
  FSysMenuHandle:= 0;
  inherited UnHookForm;
end;

function TSystemMenus97Options.ProcessAccel(Message: TWMMenuChar ): Integer;

  function FindAccelerator: Integer;
  var i: Integer;
      MI: TMenuItemInfo;
      MenuItem: TMenuItem;

  begin
    Result:= -1;
    if (FSysMenuHandle = Message.Menu) then begin
      for i:= 0 to GetMenuItemCount(FSysMenuHandle) - 1 do begin
        MI.cbSize:= SizeOf(TMenuItemInfo);
        MI.fMask:= MIIM_ID;
        GetMenuItemInfo(FSysMenuHandle, i, TRUE, MI);
        if ( MI.wID <> 0 ) then begin
          MenuItem:= FindItemByCommand(MI.wID);
          if ( MenuItem <> nil ) then begin
            if ( IsAccel(Word(Message.User), MenuItem.Caption) ) then begin
              Result:= i;
              Exit;
            end;
          end;
        end;
      end;
    end;
  end;

begin
  Result:= -1;
  if ( csDesigning in FMenu.ComponentState ) then Exit;
  if ( InternalMenu <> nil ) then
    Result:= FindAccelerator;
  if ( Result = -1 ) then
    inherited ProcessAccel(Message);
end;

procedure TSystemMenus97Options.ModifyMenuTree(MenuItems : TMenuItem97; Restore: Boolean);
Var i: Integer;
begin
  GetSystemMenu(FormHandle, TRUE);
  FSysMenuHandle:=GetSystemMenu(FormHandle, FALSE);
  for i:= 0 to 9 do
    FScItem[i].MenuItemFromCommand(FSysMenuHandle, Self);
  AddItemsToSytemMenu(TMenuItem97(InternalMenu.Items), FSysMenuHandle);
  if Assigned(InternalMenu) and (InternalMenu.Items.Count>0) then
    InsertMenu(FSysMenuHandle, FInsertBefore, MF_BYCOMMAND or MF_SEPARATOR, 55000, PChar(0));
end;

function TSystemMenus97Options.FindItemByCommand(Command: Word): TMenuItem97;
Var i: Integer;
begin
  Result:= TMenuItem97(InternalMenu.FindItem(Command, fkCommand));
  if ( Result = nil ) then begin
    for i:= 0 to 9 do begin
      if ( Command = FScItem[i].FCommand ) then begin
        Result:= FScItem[i].MenuItem;
        Exit;
      end;
    end;
  end;
  if ( Result = nil ) then
    inherited FindItemByCommand(Command);
end;

function TSystemMenus97Options.CalcMenuRect(Item: TMenuItem97): TRect;
Var R1 : TRect;
    i: Integer;
    InternalHandle: THandle;
begin
  if ( Item = nil ) or ( Item.Parent = nil ) or ( Item.Parent = InternalMenu.Items ) then
    InternalHandle:= FSysMenuHandle
  else
    InternalHandle:= Item.Parent.Handle;
  GetMenuItemRect(InternalMenu.WindowHandle, InternalHandle, 0, R1);
  Result:= R1;
  for i:= 0 to GetMenuItemCount(InternalHandle) - 1 do begin
    GetMenuItemRect(InternalMenu.WindowHandle, InternalHandle, i, R1);
    if ( R1.Bottom > Result.Bottom ) then
      Result.Bottom:= R1.Bottom;
    if ( R1.Right > Result.Right ) then
      Result.Right:= R1.Right;
  end;
end;

procedure TSystemMenus97Options.CalcBannerRect(Item: TMenuItem97);
Var R1 : TRect;
    i: Integer;
    InternalHandle: THandle;
begin
  if (Item = nil ) or ( Item.Parent = nil ) then
    InternalHandle:= FSysMenuHandle
  else
    InternalHandle:= Item.Parent.Handle;
  GetMenuItemRect(InternalMenu.WindowHandle, InternalHandle, 0, R1);
  FBannerRect:= R1;
  for i:= 0 to GetMenuItemCount(InternalHandle) - 1 do begin
    GetMenuItemRect(InternalMenu.WindowHandle, InternalHandle, i, R1);
    if ( R1.Bottom > FBannerRect.Bottom ) then
      FBannerRect.Bottom:= R1.Bottom;
  end;
  FBannerRect.Left:= FBannerRect.Left + FBannerWidth + 2;
  OffsetRect(FBannerRect, -FBannerRect.Left, -FBannerRect.Top);
  FBannerRect.Right:= FBannerRect.Left + FBannerWidth;
end;

procedure TSystemMenus97Options.NewTFormWndProc(Var Message: TMessage);
var
  MenuItem: TMenuItem97;
begin
  case Message.Msg of
    WM_SYSCOMMAND     : begin
                          if (InternalMenu <> nil ) then begin
                            MenuItem:= TMenuItem97(InternalMenu.FindItem(Message.wParam, fkCommand));
                            if ( FMenu.FindItem(Message.wParam, fkCommand) <> nil ) then begin
                              Message.wParam:= MakeLong(Message.wParam, 0);
                              Message.lParam:= MenuItem.Handle;
                              Message.Msg:= WM_COMMAND;
                              inherited NewTFormWndProc(Message);
                              Exit;
                            end;
                            if MenuItem <> Nil then MenuItem.Click;
                          end;
                        end;
    WM_INITMENUPOPUP : begin
                           with TWMInitMenuPopup(Message) do
                             FMenu.DispatchPopup(MenuPopup);
                           Message.Result:= 0;
                           FNeedBannerRect:= True;
                           FNeedBkBmp:= True;
                           Exit;
                         end;
    WM_INITMENU,
    CM_MENUCHANGED   : begin
                         inherited NewTFormWndProc(Message);
                         Exit;
                       end;
  end;
  inherited NewTFormWndProc(Message);
end;

procedure TSystemMenus97Options.AddItemsToSytemMenu(MenuItems: TMenuItem97; MenuHandle: THandle);
const
  IBreaks: array[TMenuBreak] of Longint = (MFT_STRING, MFT_MENUBREAK, MFT_MENUBARBREAK);
  IChecks: array[Boolean] of Longint = (MFS_UNCHECKED, MFS_CHECKED);
  IDefaults: array[Boolean] of Longint = (0, MFS_DEFAULT);
  IEnables: array[Boolean] of Longint = (MFS_DISABLED or MFS_GRAYED, MFS_ENABLED);
  IRadios: array[Boolean] of Longint = (MFT_STRING, MFT_RADIOCHECK);
  ISeparators: array[Boolean] of Longint = (MFT_STRING, MFT_SEPARATOR);
var
  i: Integer;
  MenuItemInfo: TMenuItemInfo;
  aCaption: string;
begin
  for i:= 0 to MenuItems.Count - 1 do begin
    with ( MenuItems[i] ) do begin
      if Visible then begin
        aCaption := Caption;
        if Count > 0 then
          MenuItemInfo.hSubMenu := 0//;CreatePopupMenu
        else
          if (ShortCut <> scNone) and ((Parent = nil) or
             (Parent.Parent <> nil) or not (Parent.Owner is TMainMenu)) then
            aCaption := aCaption + #9 + ShortCutToText(ShortCut);
        MenuItemInfo.cbSize := SizeOf(TMenuItemInfo);
        MenuItemInfo.fMask := MIIM_CHECKMARKS or MIIM_DATA or MIIM_ID or
                              MIIM_STATE or MIIM_SUBMENU or MIIM_TYPE;
        MenuItemInfo.fType := IRadios[RadioItem] or IBreaks[Break] or
        ISeparators[Caption = '-'];
        MenuItemInfo.fState := IChecks[Checked] or IEnables[Enabled] or IDefaults[Default];
        MenuItemInfo.wID := Command;
        MenuItemInfo.hSubMenu := 0;
        MenuItemInfo.hbmpChecked := 0;
        MenuItemInfo.hbmpUnchecked := 0;
        MenuItemInfo.dwTypeData := PChar(AnsiString(aCaption));
        if Count > 0 then MenuITemInfo.hSubMenu := CreatePopupMenu;
        InsertMenuItem(MenuHandle, FInsertBefore, False, MenuItemInfo);
        ModifyMenu(MenuHandle, Command, MF_OWNERDRAW or MF_BYCOMMAND or IEnables[Enabled] or IBreaks[Break], Command, Pointer(Self));
        AddItemsToSytemMenu(MenuItems[i], MenuHandle);
      end
    end;
  end;
end;

{ TMainMenu97_V3 }

constructor TMainMenu97_V3.Create(aOwner: TComponent);
begin
  inherited Create(aOwner);
  FMenus97Options:= TMainMenus97Options.Create(Self);
end;

destructor TMainMenu97_V3.Destroy;
begin
  RemoveMenuEditor(Self);
  FMenus97Options.UnHookForm;
  FMenus97Options.ModifyMenuTree(TMenuItem97(Items), True);
  FMenus97Options.Free;
  inherited Destroy;
end;

procedure TMainMenu97_V3.Loaded;
begin
  inherited Loaded;
  FMenus97Options.HookForm;
  FMenus97Options.ModifyMenuTree(TMenuItem97(Items), False);
end;

procedure TMainMenu97_V3.SetMenus97Options(Value: TMainMenus97Options);
begin
  FMenus97Options.Assign(Value);
end;

procedure TMainMenu97_V3.Notification (AComponent: TComponent; Operation: TOperation);
begin
  inherited Notification (AComponent, Operation);
end;

{ TPopupMenu97_V3 }

constructor TPopupMenu97_V3.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FMenus97Options:= TPopupMenus97Options.Create(Self);
end;

destructor TPopupMenu97_V3.Destroy;
begin
  RemoveMenuEditor(Self);
  FMenus97Options.UnHookForm;
  FMenus97Options.ModifyMenuTree(TMenuItem97(Items), True);
  FMenus97Options.Free;
  inherited Destroy;
end;

procedure TPopupMenu97_V3.Loaded;
begin
  inherited Loaded;
  FMenus97Options.HookForm;
  FMenus97Options.ModifyMenuTree(TMenuItem97(Items), False);
end;

procedure TPopupMenu97_V3.SetMenus97Options(Value: TPopupMenus97Options);
begin
  FMenus97Options.Assign(Value);
end;

procedure TPopupMenu97_V3.Popup(X, Y: Integer);
const
  Flags: array[TPopupAlignment] of Word = (TPM_LEFTALIGN, TPM_RIGHTALIGN,
    TPM_CENTERALIGN);
begin
  TrackPopupMenu(Items.Handle, Flags[Alignment] or TPM_RIGHTBUTTON, X, Y,
    0 { reserved}, (Owner as TForm).Handle, nil);
end;

{TSystemMenu97_V3}

constructor TSystemMenu97_V3.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FMenus97Options:= TSystemMenus97Options.Create(Self);
end;

destructor TSystemMenu97_V3.Destroy;
begin
  RemoveMenuEditor(Self);
  FMenus97Options.UnHookForm;
  FMenus97Options.ModifyMenuTree(TMenuItem97(Items), True);
  FMenus97Options.Free;
  inherited Destroy;
end;

procedure TSystemMenu97_V3.Loaded;
begin
  inherited Loaded;
  FMenus97Options.HookForm;
  FMenus97Options.ModifyMenuTree(TMenuItem97(Items), False);
end;

procedure TSystemMenu97_V3.SetMenus97Options(Value: TSystemMenus97Options);
begin
  FMenus97Options.Assign(Value);
end;

{ Menu building functions }

procedure AddItems97(AMenu: TMenu; MainItem: TMenuItem97; Items: array of TMenuItem97);
var
  I: Integer;

  procedure SetOwner(Item: TMenuItem97);
  var
    I: Integer;
  begin
    if Item.Owner = nil then AMenu.Owner.InsertComponent(Item);
    for I := 0 to Item.Count - 1 do
      SetOwner(Item[I]);
  end;

begin
  for I := Low(Items) to High(Items) do
  begin
    SetOwner(Items[I]);
    MainItem.Add(Items[I]);
  end;
end;

procedure InsertItems97(AMenu: TMenu; MainItem: TMenuItem97; Index: Integer; Items: array of TMenuItem97);
var
  I: Integer;

  procedure SetOwner(Item: TMenuItem97);
  var
    I: Integer;
  begin
    if Item.Owner = nil then AMenu.Owner.InsertComponent(Item);
    for I := 0 to Item.Count - 1 do
      SetOwner(Item[I]);
  end;

begin
  for I := Low(Items) to High(Items) do
  begin
    SetOwner(Items[I]);
    MainItem.Insert(Index, Items[I]);
  end;
end;

procedure InitMenuItems97(AMenu: TMenu; Items: array of TMenuItem97);
var
  I: Integer;

  procedure SetOwner(Item: TMenuItem97);
  var
    I: Integer;
  begin
    if Item.Owner = nil then AMenu.Owner.InsertComponent(Item);
    for I := 0 to Item.Count - 1 do
      SetOwner(Item[I]);
  end;

begin
  for I := Low(Items) to High(Items) do
  begin
    SetOwner(Items[I]);
    AMenu.Items.Add(Items[I]);
  end;
end;

procedure InsertMenuItems97(AMenu: TMenu; Index: Integer; Items: array of TMenuItem97);
var
  I: Integer;

  procedure SetOwner(Item: TMenuItem97);
  var
    I: Integer;
  begin
    if Item.Owner = nil then AMenu.Owner.InsertComponent(Item);
    for I := 0 to Item.Count - 1 do
      SetOwner(Item[I]);
  end;

begin
  for I := Low(Items) to High(Items) do
  begin
    SetOwner(Items[I]);
    if ( Index = -1 ) then
      AMenu.Items.Add(Items[I])
    else
      AMenu.Items.Insert(Index, Items[I]);
  end;
end;

function NewMenu97(Owner: TComponent; const AName: string; Items: array of TMenuItem97): TMainMenu97_V3;
begin
  Result := TMainMenu97_V3.Create(Owner);
  Result.Name := AName;
  InitMenuItems97(Result, Items);
end;

function NewPopupMenu97(Owner: TComponent; const AName: string;
  Alignment: TPopupAlignment; AutoPopup: Boolean; Items: array of TMenuItem97): TPopupMenu97_V3;
begin
  Result := TPopupMenu97_V3.Create(Owner);
  Result.Name := AName;
  Result.AutoPopup := AutoPopup;
  Result.Alignment := Alignment;
  InitMenuItems97(Result, Items);
end;

function NewSubMenu97(const ACaption: string; hCtx: Word; const AName: string;
  Items: array of TMenuItem97): TMenuItem97;
var
  I: Integer;
begin
  Result := TMenuItem97.Create(nil);
  for I := Low(Items) to High(Items) do
    Result.Add(Items[I]);
  Result.Caption := ACaption;
  Result.HelpContext := hCtx;
  Result.Name := AName;
end;

function NewItem97(const ACaption: string; AShortCut: TShortCut;
  AChecked, AEnabled: Boolean; AOnClick: TNotifyEvent; hCtx: Word;
  const AName: string): TMenuItem97;
begin
  Result := TMenuItem97.Create(nil);
  with Result do
  begin
    Caption := ACaption;
    ShortCut := AShortCut;
    OnClick := AOnClick;
    HelpContext := hCtx;
    Checked := AChecked;
    Enabled := AEnabled;
    Name := AName;
  end;
end;

function NewLine97: TMenuItem97;
begin
  Result := TMenuItem97.Create(nil);
  Result.Caption := '-';
end;

initialization
  FTFormHookCount:= 0;
  FTFormHookList:= TList.Create;
  RegisterClasses([TMenuItem97]);
finalization
  FTFormHookList.Free;
end.
