{ ****************************************************** }
{                           }
{                  CoPyRiGhT (c) 1996 IGO                }
{   Freeware VCL Freeware VCL Freeware VCL Freeware VCL  }
{ ****************************************************** }

unit Money;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls;

type
  TGender = (gdMale,gdAvg,gdFemale);
  TCountry = (cnRussian,cnUSA);

  TMoneyStr = class(TLabel)
  private
    FGetMoney: LongInt;
    FGetGender: TGender;
    FGetMeasure1: String;
    FGetMeasure24: String;
    FGetMeasureFrom5: String;
    FCountry: TCountry;
    Diss: Integer;
    procedure SetMoney(Value: LongInt);
    procedure SetGender(Value: TGender);
    procedure SetMeasure1(Value: String);
    procedure SetMeasure24(Value: String);
    procedure SetMeasureFrom5(Value: String);
    procedure SetCountry(Value: TCountry);
  protected
    function GetCurrency(Value: LongInt): String;
    function ProcessAndReturn(SValue: String): String;
    function ProcessThree(SValue: String; NumThree: Integer): String;
    function ProcessDigit(SValue: String; NumThree: Integer): String;
  public
    constructor Create(AOwner: TComponent); override;
  published
    property MoneyNum: LongInt read FGetMoney write SetMoney;
    property Gender: TGender read FGetGender write SetGender default gdMale;
    property Measure1: String read FGetMeasure1 write SetMeasure1;
    property Measure24: String read FGetMeasure24 write SetMeasure24;
    property MeasureFrom5: String read FGetMeasureFrom5 write SetMeasureFrom5;
    property Country: TCountry read FCountry write SetCountry default cnRussian;
  end;

procedure Register;

const Digits: array [1..8,1..10] of String =
      (('','','','','','','','','',''),
       ('','','','','','','',
       '','',''),
       ('','','','','','','','','',''),
       ('','','','','','','','','',''),
       ('','one','two','three','four','five','six','seven','eight','nine'),
       ('ten','eleven','twelve','thirteen','fourteen','fiveteen','sixteen','seventeen','eightteen','nineteen'),
       ('','ten','twenty','thirty','fourty','fifty','sixty','seventy','eighty','ninety'),
       ('','one hundred','two hundreds','three hundreds','four hundreds','five hundreds','six hundreds',
       'seven hundreds','eight hundreds','nine hundreds'));
const NumWord: array [1..8,1..3] of String =
      (('','',''),
       ('','',''),
       ('','',''),
       ('','',''),
       ('thousand','thousands','thousands'),
       ('million','millions','millions'),
       ('billion','billions','billions'),
       ('trillion','trillions','trillions'));
const GenNum: array [1..4,1..3] of String =
      (('','',''),
       ('','',''),
       ('one','one','one'),
       ('two','two','two'));

implementation

procedure Register;
begin
  RegisterComponents('Samples', [TMoneyStr]);
end;

procedure TMoneyStr.SetCountry(Value: TCountry);
begin
     FCountry := Value;
     if FCountry = cnRussian then Diss := 0
     else Diss := 4;
     SetMoney(FGetMoney);
end;

constructor TMoneyStr.Create(AOwner: TComponent);
begin
     inherited Create(AOwner);
       WordWrap := True;
       AutoSize := False;
       FGetMoney := 0;
       FGetMeasure1 := '';
       FGetMeasure24 := '';
       FGetMeasureFrom5 := '';
end;

procedure TMoneyStr.SetMoney(Value: LongInt);
begin
     FGetMoney := Value;
     Caption := GetCurrency(Value);
end;

procedure TMoneyStr.SetMeasure1(Value: String);
begin
     FGetMeasure1 := Value;
     SetMoney(FGetMoney);
end;

procedure TMoneyStr.SetMeasure24(Value: String);
begin
     FGetMeasure24 := Value;
     SetMoney(FGetMoney);
end;

procedure TMoneyStr.SetMeasureFrom5(Value: String);
begin
     FGetMeasureFrom5 := Value;
     SetMoney(FGetMoney);
end;

procedure TMoneyStr.SetGender(Value: TGender);
begin
     FGetGender := Value;
     SetMoney(FGetMoney);
end;

function TMoneyStr.GetCurrency(Value: LongInt): String;
var
   ValStr: String;
begin
     ValStr := IntToStr(Value);
     GetCurrency := ProcessAndReturn(ValStr);
end;

function TMoneyStr.ProcessAndReturn(SValue: String): String;
var
   Threes: String;
   Counter,I,MirrorCounter,Lost: Integer;
   RetStr: String;
begin
     RetStr := '';
      if SValue <> '0' then begin
        Lost := Length(SValue) mod 3;
        case Lost of
             1: SValue := '00'+SValue;
             2: SValue := '0'+SValue;
        end;
        MirrorCounter := Length(SValue) div 3;
        for Counter := 1 to (Length(SValue) div 3) do begin
            Threes := '';
            for I:=2 downto 0 do Threes := Threes+SValue[Counter*3-I];
            RetStr := RetStr+ProcessThree(Threes,MirrorCounter);
            Dec(MirrorCounter);
        end;
      end;
     ProcessAndReturn := RetStr;
end;

function TMoneyStr.ProcessThree(SValue: String; NumThree: Integer): String;
var
   Counter,I: Integer;
   RetValue: String;
begin
     RetValue:='';
     Counter := 3;
       if SValue[2] = '1' then begin
          Counter := 1;
          case SValue[3] of
               '0': RetValue := Digits[2+Diss,1];
               '1': RetValue := Digits[2+Diss,2];
               '2': RetValue := Digits[2+Diss,3];
               '3': RetValue := Digits[2+Diss,4];
               '4': RetValue := Digits[2+Diss,5];
               '5': RetValue := Digits[2+Diss,6];
               '6': RetValue := Digits[2+Diss,7];
               '7': RetValue := Digits[2+Diss,8];
               '8': RetValue := Digits[2+Diss,9];
               '9': RetValue := Digits[2+Diss,10];
         end;
       end;
       {***************}
       for I := 1 to Counter do
           case SValue[I] of
                '1': case I of
                     1: RetValue := Digits[4+Diss,2]+' '+RetValue;
                     2: ;
                     3: if NumThree = 2 then RetValue := RetValue+GenNum[1+(Diss div 2),3]
                        else case FGetGender of
                                  gdMale: RetValue := RetValue+GenNum[1+(Diss div 2),1];
                                  gdAvg:  RetValue := RetValue+GenNum[1+(Diss div 2),2];
                                  gdFemale: RetValue := RetValue+GenNum[1+(Diss div 2),3];
                             end;
                     end;
                '2': case I of
                     1: RetValue := Digits[4+Diss,3]+' '+RetValue;
                     2: RetValue := RetValue+Digits[3+Diss,3]+' ';
                     3: if NumThree = 2 then RetValue := RetValue+GenNum[2+(Diss div 2),3]
                        else case FGetGender of
                                  gdMale..gdAvg: RetValue := RetValue+GenNum[2+(Diss div 2),2];
                                  gdFemale:  RetValue := RetValue+GenNum[2+(Diss div 2),3];
                             end;
                     end;
                '3': case I of
                     1: RetValue := Digits[4+Diss,4]+' '+RetValue;
                     2: RetValue := RetValue+Digits[3+Diss,4]+' ';
                     3: RetValue := RetValue+Digits[1+Diss,4];
                     end;
                '4':  case I of
                     1: RetValue := Digits[4+Diss,5]+' '+RetValue;
                     2: RetValue := RetValue+Digits[3+Diss,5]+' ';
                     3: RetValue := RetValue+Digits[1+Diss,5];
                     end;
                '5': case I of
                     1: RetValue := Digits[4+Diss,6]+' '+RetValue;
                     2: RetValue := RetValue+Digits[3+Diss,6]+' ';
                     3: RetValue := RetValue+Digits[1+Diss,6];
                     end;
                '6': case I of
                     1: RetValue := Digits[4+Diss,7]+' '+RetValue;
                     2: RetValue := RetValue+Digits[3+Diss,7]+' ';
                     3: RetValue := RetValue+Digits[1+Diss,7];
                     end;
                '7': case I of
                     1: RetValue := Digits[4+Diss,8]+' '+RetValue;
                     2: RetValue := RetValue+Digits[3+Diss,8]+' ';
                     3: RetValue := RetValue+Digits[1+Diss,8];
                     end;
                '8': case I of
                     1: RetValue := Digits[4+Diss,9]+' '+RetValue;
                     2: RetValue := RetValue+Digits[3+Diss,9]+' ';
                     3: RetValue := RetValue+Digits[1+Diss,9];
                     end;
                '9': case I of
                     1: RetValue := Digits[4+Diss,10]+' '+RetValue;
                     2: RetValue := RetValue+Digits[3+Diss,10]+' ';
                     3: RetValue := RetValue+Digits[1+Diss,10];
                     end;
           end;
     ProcessThree := RetValue+ProcessDigit(SValue,NumThree);
end;

function TMoneyStr.ProcessDigit(SValue: String; NumThree: Integer): String;
var
   ThreeName: String;
begin
     case NumThree of
          1:  if SValue[2] = '1' then ThreeName := FGetMeasureFrom5
              else case SValue[3] of
                        '1': ThreeName := FGetMeasure1;
                        '2'..'4': ThreeName := FGetMeasure24;
                   else ThreeName := FGetMeasureFrom5;
                   end;
          2:  if SValue[2] = '1' then ThreeName := NumWord[1+Diss,3]
              else case SValue[3] of
                   '1': ThreeName := NumWord[1+Diss,1];
                   '2'..'4': ThreeName := NumWord[1+Diss,2];
                   else ThreeName := NumWord[1+Diss,3];
                   end;
          3:  if SValue[2] = '1' then ThreeName := NumWord[2+Diss,3]
              else case SValue[3] of
                   '1': ThreeName := NumWord[2+Diss,1];
                   '2'..'4': ThreeName := NumWord[2+Diss,2];
                   else ThreeName := NumWord[2+Diss,3];
                   end;
          4:  if SValue[2] = '1' then ThreeName := NumWord[3+Diss,3]
              else case SValue[3] of
                   '1': ThreeName := NumWord[3+Diss,1];
                   '2'..'4': ThreeName := NumWord[3+Diss,2];
                   else ThreeName := NumWord[3+Diss,3];
                   end;
          5:  if SValue[2] = '1' then ThreeName := NumWord[4+Diss,3]
              else case SValue[3] of
                   '1': ThreeName := NumWord[4+Diss,1];
                   '2'..'4': ThreeName := NumWord[4+Diss,2];
                   else ThreeName := NumWord[4+Diss,3];
                   end;
     end;
     if (((SValue[2]<>'0') or (SValue[1]<>'0')) and ((SValue[3]='1') and (FCountry=cnUSA) and (SValue[2]<>'1'))) then
        ThreeName := ThreeName+'s';
     ProcessDigit := ' '+ThreeName+' ';
end;

end.
