unit CnvPatternFormUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ExtCtrls, StdCtrls, Db, DBTables;

type
  TCnvPatternForm = class(TForm)
    Label1: TLabel;
    PatternName: TLabel;
    Bevel1: TBevel;
    ProgressBar: TProgressBar;
    Label3: TLabel;
    Table: TTable;
    CloseTimer: TTimer;
    UpdateTimer: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure CloseTimerTimer(Sender: TObject);
    procedure UpdateTimerTimer(Sender: TObject);
  private
    { Private declarations }
    FPath:String;
  public
    { Public declarations }
  end;

var
  CnvPatternForm: TCnvPatternForm;

implementation

{$R *.DFM}

procedure TCnvPatternForm.FormCreate(Sender: TObject);
begin
  if ParamCount=0 then
   FPath:=ExtractFilePath(Application.ExeName)
  else
   FPath:=ParamStr(1);
end;

procedure TCnvPatternForm.FormShow(Sender: TObject);
begin
 UpdateTimer.Enabled:=True;
end;

procedure TCnvPatternForm.CloseTimerTimer(Sender: TObject);
begin
 CloseTimer.Enabled:=False;
 Close;
end;

procedure TCnvPatternForm.UpdateTimerTimer(Sender: TObject);
var res:Integer;
    f:TSearchRec;
    attr:Integer;
    i,j,k:Integer;
begin
  UpdateTimer.Enabled:=False;
  if (FPath[Length(FPath)]<>'\') then FPath:=FPath+'\';
  PatternName.Caption:='';
  ProgressBar.Position:=0;
  attr:=faArchive;
  i:=0;
  res:=FindFirst(FPath+'*.db',attr,f);
  while (res=0) do
    begin
      Table.Close;
      Table.DatabaseName:=FPath;
      Table.TableName:=ExtractFileName(f.Name);
      try
       Table.Open;
       j:=0;
       Table.First;
       while not(Table.EOF) do
        begin
         inc(j);
         Table.Next;
        end;
      finally
       Table.Close;
       if j=43 then inc(i);
      end;
      res:=FindNext(f);
    end;
  k:=0;
  FindClose(f);
  res:=FindFirst(FPath+'*.db',attr,f);
  while (res=0) do
    begin
      Table.Close;
      Table.DatabaseName:=FPath;
      Table.TableName:=ExtractFileName(f.Name);
      try
       Table.Open;
       j:=0;
       Table.First;
       while not(Table.EOF) do
        begin
         inc(j);
         Table.Next;
        end;
      finally
       if j=43 then
         begin
           inc(k);
           PatternName.Caption:=Table.TableName;
           ProgressBar.Position:=Round(k/i*100);
           Application.ProcessMessages;
           Table.Last;
           Table.Insert;
           Table.FieldByName('Level').AsInteger:=132;
           Table.FieldByName('Name').AsString:=' ';
           Table.FieldByName('FontName').AsString:='Times New Roman';
           Table.FieldByName('FontSize').AsInteger:=12;
           Table.FieldByName('FontColor').AsInteger:=Integer(clBlack);
           Table.FieldByName('Bold').AsBoolean:=False;
           Table.FieldByName('Italic').AsBoolean:=False;
           Table.FieldByName('Underline').AsBoolean:=False;
           Table.FieldByName('Align').AsInteger:=12;
           Table.FieldByName('Bullets').AsBoolean:=False;
           Table.FieldByName('FirstInd').AsInteger:=0;
           Table.FieldByName('LeftInd').AsInteger:=0;
           Table.FieldByName('RightInd').AsInteger:=152;
           Table.FieldByName('TabPos').AsInteger:=0;
           Table.FieldByName('SpaceBefore').AsInteger:=0;
           Table.FieldByName('SpaceAfter').AsInteger:=0;
           Table.FieldByName('SpaceLine').AsInteger:=0;
           Table.FieldByName('BackColor').AsInteger:=Integer(clWhite);
           Table.FieldByName('PageBreak').AsBoolean:=False;
           Table.FieldByName('LineSpacingRule').AsInteger:=0;
           Table.FieldByName('NoControlChar').AsBoolean:=True;
           Table.Post;
           sleep(1000);
         end;
       Table.Close;
      end;
      res:=FindNext(f);
    end;
  FindClose(f);
  CloseTimer.Enabled:=True;
end;

end.
