unit FontSetupUnit;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, ComCtrls, RichEdit2, RXCtrls,
  UnderlineComboBox, Spin;

type
  TFontSetupDialog = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    PageControl1: TPageControl;
    Button1: TButton;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    FontNameEdit: TEdit;
    FontStyleEdit: TEdit;
    FontSizeEdit: TEdit;
    FontName: TListBox;
    FontStyle: TListBox;
    FontSize: TListBox;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    FontColor: TColorComboBox;
    BackColor: TColorComboBox;
    Label7: TLabel;
    Bevel1: TBevel;
    DoubleStrikeOutCheckBox: TCheckBox;
    SuperScriptCheckBox: TCheckBox;
    SubScriptCheckBox: TCheckBox;
    Label8: TLabel;
    Bevel2: TBevel;
    ShadowCheckBox: TCheckBox;
    OutLineCheckBox: TCheckBox;
    EmbossCheckBox: TCheckBox;
    ImprintCheckBox: TCheckBox;
    SmallCapsCheckBox: TCheckBox;
    AllCapsCheckBox: TCheckBox;
    HiddenCheckBox: TCheckBox;
    Label9: TLabel;
    FontUnderline: TUnderlineComboBox;
    StrikeOutCheckBox: TCheckBox;
    Label10: TLabel;
    AnimationListBox: TListBox;
    Label11: TLabel;
    Bevel3: TBevel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label16: TLabel;
    AllowKernCheckBox: TCheckBox;
    KernEdit: TSpinEdit;
    ScaleHorzComboBox: TComboBox;
    SpacingComboBox: TComboBox;
    OffsetComboBox: TComboBox;
    SpacingEdit: TSpinEdit;
    OffsetEdit: TSpinEdit;
    Label15: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Bevel4: TBevel;
    Label19: TLabel;
    SampleFont: TRichEdit98;
    SampleInterval: TRichEdit98;
    SampleAnimation: TRichEdit98;
    procedure FontColorChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FontNameClick(Sender: TObject);
    procedure FontSizeClick(Sender: TObject);
    procedure FontStyleClick(Sender: TObject);
    procedure FontUnderlineChange(Sender: TObject);
    procedure StrikeOutCheckBoxClick(Sender: TObject);
    procedure DoubleStrikeOutCheckBoxClick(Sender: TObject);
    procedure AllCapsCheckBoxClick(Sender: TObject);
    procedure SmallCapsCheckBoxClick(Sender: TObject);
    procedure HiddenCheckBoxClick(Sender: TObject);
    procedure EmbossCheckBoxClick(Sender: TObject);
    procedure ImprintCheckBoxClick(Sender: TObject);
    procedure OutLineCheckBoxClick(Sender: TObject);
    procedure ShadowCheckBoxClick(Sender: TObject);
    procedure SuperScriptCheckBoxClick(Sender: TObject);
    procedure SubScriptCheckBoxClick(Sender: TObject);
    procedure AnimationListBoxClick(Sender: TObject);
    procedure ScaleHorzComboBoxChange(Sender: TObject);
    procedure KernEditChange(Sender: TObject);
    procedure AllowKernCheckBoxClick(Sender: TObject);
    procedure SpacingEditChange(Sender: TObject);
    procedure SpacingComboBoxChange(Sender: TObject);
    procedure OffsetEditChange(Sender: TObject);
    procedure OffsetComboBoxChange(Sender: TObject);
    procedure BackColorChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure  GetFontParams(var editor:TRichEdit98);
    procedure  SetFontParams(var editor:TRichEdit98);
  end;

var
  FontSetupDialog: TFontSetupDialog;

implementation

{$R *.DFM}

procedure TFontSetupDialog.FontColorChange(Sender: TObject);
begin
  SampleFont.SelectAll;
  SampleInterval.SelectAll;
  SampleAnimation.SelectAll;
  SampleFont.SelAttributes.Color:=FontColor.ColorValue;
  SampleInterval.SelAttributes.Color:=FontColor.ColorValue;
  SampleAnimation.SelAttributes.Color:=FontColor.ColorValue;
  SampleFont.SelLength:=0;
  SampleInterval.SelLength:=0;
  SampleAnimation.SelLength:=0;
end;

procedure TFontSetupDialog.FormCreate(Sender: TObject);
begin
 FontName.Items.Assign(Screen.Fonts);
 BackColor.ColorValue:=clWhite;
 SampleInterval.SelectAll;
 SampleFOnt.SelectAll;
 SampleAnimation.SelectAll;
 SampleFont.Paragraph.Alignment:=taCenter;
 SampleAnimation.Paragraph.Alignment:=taCenter;
 SampleInterval.Paragraph.Alignment:=taCenter;
 SampleFont.SelLength:=0;
 SampleAnimation.SelLength:=0;
 SampleInterval.SelLength:=0;
end;

procedure TFontSetupDialog.FontNameClick(Sender: TObject);
begin
 FontNameEdit.Text:=FontName.Items[FontName.ItemIndex];
 SampleFont.SelectAll;
 SampleInterval.SelectAll;
 SampleAnimation.SelectAll;
 SampleFont.SelText:=FontName.Items[FontName.ItemIndex];
 SampleInterval.SelText:=FontName.Items[FontName.ItemIndex];
 SampleAnimation.SelText:=FontName.Items[FontName.ItemIndex];
 SampleFont.Paragraph.Alignment:=taCenter;
 SampleAnimation.Paragraph.Alignment:=taCenter;
 SampleInterval.Paragraph.Alignment:=taCenter;
 SampleFont.SelectAll;
 SampleInterval.SelectAll;
 SampleAnimation.SelectAll;
 SampleFont.SelAttributes.Name:=FontNameEdit.Text;
 SampleInterval.SelAttributes.Name:=FontNameEdit.Text;
 SampleAnimation.SelAttributes.Name:=FontNameEdit.Text;
 SampleFont.SelLength:=0;
 SampleInterval.SelLength:=0;
 SampleAnimation.SelLength:=0;
end;

procedure TFontSetupDialog.FontSizeClick(Sender: TObject);
begin
  FontSizeEdit.Text:=FontSize.Items[FontSize.ItemIndex];
  SampleFont.SelectAll;
  SampleInterval.SelectAll;
  SampleAnimation.SelectAll;
  SampleFont.SelAttributes.Size:=StrToIntDef(FontSizeEdit.Text,10);
  SampleInterval.SelAttributes.Size:=StrToIntDef(FontSizeEdit.Text,10);
  SampleAnimation.SelAttributes.Size:=StrToIntDef(FontSizeEdit.Text,10);
  SampleFont.SelLength:=0;
  SampleInterval.SelLength:=0;
  SampleAnimation.SelLength:=0;
end;

procedure TFontSetupDialog.FontStyleClick(Sender: TObject);
begin
 FontStyleEdit.Text:=FontStyle.Items[FontStyle.ItemIndex];
 SampleFont.SelectAll;
 SampleInterval.SelectAll;
 SampleAnimation.SelectAll;
  case FontStyle.ItemIndex of
   0: begin
      SampleFont.SelAttributes.Style:=[];
      SampleInterval.SelAttributes.Style:=[];
      SampleAnimation.SelAttributes.Style:=[];
      end;
   1: begin
      SampleFont.SelAttributes.Style:=[fsItalic];
      SampleInterval.SelAttributes.Style:=[fsItalic];
      SampleAnimation.SelAttributes.Style:=[fsItalic];
      end;
   2: begin
      SampleFont.SelAttributes.Style:=[fsBold];
      SampleInterval.SelAttributes.Style:=[fsBold];
      SampleAnimation.SelAttributes.Style:=[fsBold];
      end;
   3: begin
      SampleFont.SelAttributes.Style:=[fsBold,fsItalic];
      SampleInterval.SelAttributes.Style:=[fsBold,fsItalic];
      SampleAnimation.SelAttributes.Style:=[fsBold,fsItalic];
      end;
  end;
 SampleFont.SelLength:=0;
 SampleInterval.SelLength:=0;
 SampleAnimation.SelLength:=0;
end;


procedure TFontSetupDialog.FontUnderlineChange(Sender: TObject);
begin
 SampleFont.SelectAll;
 SampleInterval.SelectAll;
 SampleAnimation.SelectAll;
 SampleFont.SelAttributes.UnderlineType:=FontUnderline.UnderlineValue;
 SampleInterval.SelAttributes.UnderlineType:=FontUnderline.UnderlineValue;
 SampleAnimation.SelAttributes.UnderlineType:=FontUnderline.UnderlineValue;
 SampleFont.SelLength:=0;
 SampleInterval.SelLength:=0;
 SampleAnimation.SelLength:=0;
end;

procedure TFontSetupDialog.StrikeOutCheckBoxClick(Sender: TObject);
begin
 SampleFont.SelectAll;
 SampleInterval.SelectAll;
 SampleAnimation.SelectAll;
 SampleFont.SelAttributes.StrikeOut:=StrikeOutCheckBox.Checked;
 SampleInterval.SelAttributes.StrikeOut:=StrikeOutCheckBox.Checked;
 SampleAnimation.SelAttributes.StrikeOut:=StrikeOutCheckBox.Checked;
 SampleFont.SelLength:=0;
 SampleInterval.SelLength:=0;
 SampleAnimation.SelLength:=0;
end;

procedure TFontSetupDialog.DoubleStrikeOutCheckBoxClick(Sender: TObject);
begin
 SampleFont.SelectAll;
 SampleInterval.SelectAll;
 SampleAnimation.SelectAll;
 SampleFont.SelAttributes.StrikeOut:=StrikeOutCheckBox.Checked;
 SampleInterval.SelAttributes.StrikeOut:=StrikeOutCheckBox.Checked;
 SampleAnimation.SelAttributes.StrikeOut:=StrikeOutCheckBox.Checked;
 SampleFont.SelLength:=0;
 SampleInterval.SelLength:=0;
 SampleAnimation.SelLength:=0;
end;

procedure TFontSetupDialog.AllCapsCheckBoxClick(Sender: TObject);
begin
 SampleFont.SelectAll;
 SampleInterval.SelectAll;
 SampleAnimation.SelectAll;
 SampleFont.SelAttributes.AllCaps:=AllCapsCheckBox.Checked;
 SampleInterval.SelAttributes.AllCaps:=AllCapsCheckBox.Checked;
 SampleAnimation.SelAttributes.AllCaps:=AllCapsCheckBox.Checked;
 SampleFont.SelLength:=0;
 SampleInterval.SelLength:=0;
 SampleAnimation.SelLength:=0;
end;

procedure TFontSetupDialog.SmallCapsCheckBoxClick(Sender: TObject);
begin
 SampleFont.SelectAll;
 SampleInterval.SelectAll;
 SampleAnimation.SelectAll;
 SampleFont.SelAttributes.SmallCaps:=SmallCapsCheckBox.Checked;
 SampleInterval.SelAttributes.SmallCaps:=SmallCapsCheckBox.Checked;
 SampleAnimation.SelAttributes.SmallCaps:=SmallCapsCheckBox.Checked;
 SampleFont.SelLength:=0;
 SampleInterval.SelLength:=0;
 SampleAnimation.SelLength:=0;
end;

procedure TFontSetupDialog.HiddenCheckBoxClick(Sender: TObject);
begin
 SampleFont.SelectAll;
 SampleInterval.SelectAll;
 SampleAnimation.SelectAll;
 SampleFont.SelAttributes.Hidden:=HiddenCheckBox.Checked;
 SampleInterval.SelAttributes.Hidden:=HiddenCheckBox.Checked;
 SampleAnimation.SelAttributes.Hidden:=HiddenCheckBox.Checked;
 SampleFont.SelLength:=0;
 SampleInterval.SelLength:=0;
 SampleAnimation.SelLength:=0;
end;

procedure TFontSetupDialog.EmbossCheckBoxClick(Sender: TObject);
begin
 SampleFont.SelectAll;
 SampleInterval.SelectAll;
 SampleAnimation.SelectAll;
 SampleFont.SelAttributes.Emboss:=EmbossCheckBox.Checked;
 SampleInterval.SelAttributes.Emboss:=EmbossCheckBox.Checked;
 SampleAnimation.SelAttributes.Emboss:=EmbossCheckBox.Checked;
 SampleFont.SelLength:=0;
 SampleInterval.SelLength:=0;
 SampleAnimation.SelLength:=0;
end;

procedure TFontSetupDialog.ImprintCheckBoxClick(Sender: TObject);
begin
 SampleFont.SelectAll;
 SampleInterval.SelectAll;
 SampleAnimation.SelectAll;
 SampleFont.SelAttributes.Imprint:=ImprintCheckBox.Checked;
 SampleInterval.SelAttributes.Imprint:=ImprintCheckBox.Checked;
 SampleAnimation.SelAttributes.Imprint:=ImprintCheckBox.Checked;
 SampleFont.SelLength:=0;
 SampleInterval.SelLength:=0;
 SampleAnimation.SelLength:=0;
end;

procedure TFontSetupDialog.OutLineCheckBoxClick(Sender: TObject);
begin
 SampleFont.SelectAll;
 SampleInterval.SelectAll;
 SampleAnimation.SelectAll;
 SampleFont.SelAttributes.Outline:=OutLineCheckBox.Checked;
 SampleInterval.SelAttributes.Outline:=OutLineCheckBox.Checked;
 SampleAnimation.SelAttributes.Outline:=OutLineCheckBox.Checked;
 SampleFont.SelLength:=0;
 SampleInterval.SelLength:=0;
 SampleAnimation.SelLength:=0;
end;

procedure TFontSetupDialog.ShadowCheckBoxClick(Sender: TObject);
begin
 SampleFont.SelectAll;
 SampleInterval.SelectAll;
 SampleAnimation.SelectAll;
 SampleFont.SelAttributes.Shadow:=ShadowCheckBox.Checked;
 SampleInterval.SelAttributes.Shadow:=ShadowCheckBox.Checked;
 SampleAnimation.SelAttributes.Shadow:=ShadowCheckBox.Checked;
 SampleFont.SelLength:=0;
 SampleInterval.SelLength:=0;
 SampleAnimation.SelLength:=0;
end;

procedure TFontSetupDialog.SuperScriptCheckBoxClick(Sender: TObject);
begin
SampleFont.SelectAll;
SampleInterval.SelectAll;
SampleAnimation.SelectAll;
SubScriptCheckBox.Checked:=False;
if SuperScriptCheckBox.Checked then
 begin
  SampleFont.SelAttributes.IndexKind:=ikSuperscript;
  SampleInterval.SelAttributes.IndexKind:=ikSuperscript;
  SampleAnimation.SelAttributes.IndexKind:=ikSuperscript;
 end
 else
 begin
  SampleFont.SelAttributes.IndexKind:=ikNone;
  SampleInterval.SelAttributes.IndexKind:=ikNone;
  SampleAnimation.SelAttributes.IndexKind:=ikNone;
 end;
SampleFont.SelLength:=0;
SampleInterval.SelLength:=0;
SampleAnimation.SelLength:=0;
end;

procedure TFontSetupDialog.SubScriptCheckBoxClick(Sender: TObject);
begin
SampleFont.SelectAll;
SampleInterval.SelectAll;
SampleAnimation.SelectAll;
SuperScriptCheckBox.Checked:=False;
if SubScriptCheckBox.Checked then
 begin
  SampleFont.SelAttributes.IndexKind:=ikSubscript;
  SampleInterval.SelAttributes.IndexKind:=ikSubscript;
  SampleAnimation.SelAttributes.IndexKind:=ikSubscript;
 end
 else
 begin
  SampleFont.SelAttributes.IndexKind:=ikNone;
  SampleInterval.SelAttributes.IndexKind:=ikNone;
  SampleAnimation.SelAttributes.IndexKind:=ikNone;
 end;
SampleFont.SelLength:=0;
SampleInterval.SelLength:=0;
SampleAnimation.SelLength:=0;
end;

procedure TFontSetupDialog.AnimationListBoxClick(Sender: TObject);
begin
 SampleAnimation.SelectAll;
 SampleFont.SelectAll;
 SampleInterval.SelectAll;
 case AnimationListBox.ItemIndex of
  0: begin
      SampleAnimation.SelAttributes.Animation:=aniNone;
      SampleInterval.SelAttributes.Animation:=aniNone;
      SampleFont.SelAttributes.Animation:=aniNone;
     end;
  1: begin
      SampleAnimation.SelAttributes.Animation:=aniRedAnts;
      SampleInterval.SelAttributes.Animation:=aniRedAnts;
      SampleFont.SelAttributes.Animation:=aniRedAnts;
     end;
  2: begin
      SampleAnimation.SelAttributes.Animation:=aniShimmer;
      SampleInterval.SelAttributes.Animation:=aniShimmer;
      SampleFont.SelAttributes.Animation:=aniShimmer;
     end;
  3: begin
      SampleAnimation.SelAttributes.Animation:=aniBlink;
      SampleInterval.SelAttributes.Animation:=aniBlink;
      SampleFont.SelAttributes.Animation:=aniBlink;
     end;
  4: begin
      SampleAnimation.SelAttributes.Animation:=aniLasVegas;
      SampleInterval.SelAttributes.Animation:=aniLasVegas;
      SampleFont.SelAttributes.Animation:=aniLasVegas;
     end;
  5: begin
      SampleAnimation.SelAttributes.Animation:=aniSparkle;
      SampleInterval.SelAttributes.Animation:=aniSparkle;
      SampleFont.SelAttributes.Animation:=aniSparkle;
     end;
  6: begin
      SampleAnimation.SelAttributes.Animation:=aniBlackAnts;
      SampleInterval.SelAttributes.Animation:=aniBlackAnts;
      SampleFont.SelAttributes.Animation:=aniBlackAnts;
     end;
 end;
 SampleAnimation.SelLength:=0;
 SampleFont.SelLength:=0;
 SampleInterval.SelLength:=0;
end;

procedure  TFontSetupDialog.GetFontParams(var editor:TRichEdit98);
 begin
   SampleFont.SelectAll;
   SampleFont.SelAttributes.Assign(editor.SelAttributes);
   SampleFont.SelLength:=0;
   SampleAnimation.SelectAll;
   SampleAnimation.SelAttributes.Assign(editor.SelAttributes);
   SampleAnimation.SelLength:=0;
   SampleInterval.SelectAll;
   SampleInterval.SelAttributes.Assign(editor.SelAttributes);
   SampleInterval.SelLength:=0;
 end;

procedure  TFontSetupDialog.SetFontParams(var editor:TRichEdit98);
 begin
 {}
 end;

procedure TFontSetupDialog.ScaleHorzComboBoxChange(Sender: TObject);
Var s:String;
    i:Integer;
begin
 s:=ScaleHorzComboBox.Text;
 s:=copy(s,1,length(s)-1);
 i:=StrToIntDef(s,100);
 SampleInterval.SelectAll;
 SampleFont.SelectAll;
 SampleAnimation.SelectAll;
 SampleFont.SelAttributes.Weight:=i;
 SampleInterval.SelAttributes.Weight:=i;
 SampleAnimation.SelAttributes.Weight:=i;
 SampleInterval.SelLength:=0;
 SampleFont.SelLength:=0;
 SampleAnimation.SelLength:=0;
end;

procedure TFontSetupDialog.KernEditChange(Sender: TObject);
begin
 if (not(AllowKernCheckBox.Checked)) then Exit;
 SampleInterval.SelectAll;
 SampleFont.SelectAll;
 SampleAnimation.SelectAll;
 SampleInterval.SelAttributes.Kerning:=KernEdit.Value;
 SampleAnimation.SelAttributes.Kerning:=KernEdit.Value;
 SampleFont.SelAttributes.Kerning:=KernEdit.Value;
 SampleInterval.SelLength:=0;
 SampleFont.SelLength:=0;
 SampleAnimation.SelLength:=0;
end;

procedure TFontSetupDialog.AllowKernCheckBoxClick(Sender: TObject);
begin
 if AllowKernCheckBox.Checked then
  begin
   KernEdit.Value:=12;
   KernEdit.Enabled:=True;
  end
 else
  begin
   KernEdit.Value:=0;
   KernEdit.Enabled:=False;
  end;
 KernEditChange(self);
end;

procedure TFontSetupDialog.SpacingEditChange(Sender: TObject);
Var i:SmallInt;
begin
  SampleInterval.SelectAll;
  SampleFont.SelectAll;
  SampleAnimation.SelectAll;
  if SpacingComboBox.Text='' then
   i:=SpacingEdit.Value
  else if SpacingComboBox.Text='' then i:=0 else
   i:=-SpacingEdit.Value;
  SampleInterval.SelAttributes.Spacing:=i;
  SampleAnimation.SelAttributes.Spacing:=i;
  SampleFont.SelAttributes.Spacing:=i;
  SampleInterval.SelLength:=0;
  SampleFont.SelLength:=0;
  SampleAnimation.SelLength:=0;
end;

procedure TFontSetupDialog.SpacingComboBoxChange(Sender: TObject);
begin
 if SpacingComboBox.Text='' then
  begin
   SpacingEdit.Value:=0;
   SpacingEdit.Enabled:=False;
  end
 else
  begin
   SpacingEdit.Value:=2;
   SpacingEdit.Enabled:=True;
  end;
 SpacingEditChange(self);
end;

procedure TFontSetupDialog.OffsetEditChange(Sender: TObject);
Var i:Integer;
begin
  SampleInterval.SelectAll;
  SampleFont.SelectAll;
  SampleAnimation.SelectAll;
  if OffsetComboBox.Text='' then
   i:=OffsetEdit.Value
  else if OffsetComboBox.Text='' then i:=0 else
   i:=-OffsetEdit.Value;
  SampleInterval.SelAttributes.Offset:=i;
  SampleAnimation.SelAttributes.Offset:=i;
  SampleFont.SelAttributes.Offset:=i;
  SampleInterval.SelLength:=0;
  SampleFont.SelLength:=0;
  SampleAnimation.SelLength:=0;
end;

procedure TFontSetupDialog.OffsetComboBoxChange(Sender: TObject);
begin
 if OffsetComboBox.Text='' then
  begin
   OffsetEdit.Value:=0;
   OffsetEdit.Enabled:=False;
  end
 else
  begin
   OffsetEdit.Value:=3;
   OffsetEdit.Enabled:=True;
  end;
 OffsetEditChange(self);
end;

procedure TFontSetupDialog.BackColorChange(Sender: TObject);
begin
  SampleInterval.SelectAll;
  SampleFont.SelectAll;
  SampleAnimation.SelectAll;
  SampleFont.SelAttributes.BackColor:=BackColor.ColorValue;
  SampleInterval.SelAttributes.BackColor:=BackColor.ColorValue;
  SampleAnimation.SelAttributes.BackColor:=BackColor.ColorValue;
  SampleInterval.SelLength:=0;
  SampleFont.SelLength:=0;
  SampleAnimation.SelLength:=0;

end;

end.
