unit SelAFTableDlgUnit;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, 
  Buttons, ExtCtrls, fcLabel, Dialogs, DBTables, Db;

type
  TSelAFTableDlg = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    Bevel1: TBevel;
    ListBox: TListBox;
    fcLabel1: TfcLabel;
    Button1: TButton;
    SaveDialog: TSaveDialog;
    ImportButton: TButton;
    ExportButton: TButton;
    OpenDialog: TOpenDialog;
    Table1: TTable;
    procedure Button1Click(Sender: TObject);
    procedure ExportButtonClick(Sender: TObject);
    procedure ImportButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure EnumAFTables(curTable:String);
  end;

var
  SelAFTableDlg: TSelAFTableDlg;

implementation

{$R *.DFM}

procedure TSelAFTableDlg.EnumAFTables(curTable:String);
Var sr:TSearchRec;
    err,attr:Integer;
    path,s:String;
 begin
    path:=ExtractFilePath(Application.ExeName)+'DOTS\'+'*.DB';
    attr:=faReadOnly;
    ListBox.Items.Clear;
    err:=FindFirst(path,attr,sr);
    while (err=0) do
     begin
       s:=sr.Name;
       s:=copy(s,1,length(s)-3);
       ListBox.Items.Append(s);
       err:=FindNext(sr);
     end;
    FindClose(sr);
    s:=curTable;
    s:=copy(s,1,length(s)-3);
    ListBox.ItemIndex:=ListBox.Items.IndexOf(s);
 end;

procedure TSelAFTableDlg.Button1Click(Sender: TObject);
Var s,s1,s2:String;
   source:String;
   dest:String;
   path:String;
begin
 { Create new tempalate }
 s:=ListBox.Items[ListBox.ItemIndex];
 path:=ExtractFilePath(Application.ExeName)+'DOTS\';
 SaveDialog.InitialDir:=path;
 if (not(FileExists(path+s+'.DB'))) then
  s:=' ';
 SaveDialog.Title:='   : '+s;
 if SaveDialog.Execute then
   begin
     s2:=ExtractFileName(SaveDialog.FileName);
     if (length(s2)>50) then
      begin
        Application.MessageBox('     50 ','  ',MB_OK or MB_ICONERROR);
      end
    else
    begin
     s1:=ExtractFileName(SaveDialog.FileName);
     s1:=copy(s1,1,length(s1)-3);
     source:=path+s+'.DB';
     dest:=path+s1+'.DB';
     CopyFile(PChar(source),PChar(Dest),LongBool(0));
     source:=path+s+'.PX';
     dest:=path+s1+'.PX';
     CopyFile(PChar(source),PChar(Dest),LongBool(0));
     source:=path+s+'.VAL';
     dest:=path+s1+'.VAL';
     CopyFile(PChar(source),PChar(Dest),LongBool(0));
     EnumAFTables(ExtractFileName(SaveDialog.FileName));
    end;
   end;
end;

procedure TSelAFTableDlg.ExportButtonClick(Sender: TObject);
Var s,s1:String;
   source:String;
   dest:String;
   path,path1:String;
begin
{ Export button }
 s:=ListBox.Items[ListBox.ItemIndex];
 path:=ExtractFilePath(Application.ExeName)+'DOTS\';
 SaveDialog.InitialDir:=path;
 SaveDialog.FileName:=s+'.DB';
 if (not(FileExists(path+s+'.DB'))) then
  s:=' ';
 SaveDialog.Title:=' : '+s;
 if SaveDialog.Execute then
   begin
     s1:=ExtractFileName(SaveDialog.FileName);
     path1:=ExtractFilePath(SaveDialog.FileName);
     s1:=copy(s1,1,length(s1)-3);
     source:=path+s+'.DB';
     dest:=path1+s1+'.DB';
     CopyFile(PChar(source),PChar(Dest),LongBool(0));
     source:=path+s+'.PX';
     dest:=path1+s1+'.PX';
     CopyFile(PChar(source),PChar(Dest),LongBool(0));
     source:=path+s+'.VAL';
     dest:=path1+s1+'.VAL';
     CopyFile(PChar(source),PChar(Dest),LongBool(0));
   end;
end;

procedure TSelAFTableDlg.ImportButtonClick(Sender: TObject);
Var s,s1:String;
   source:String;
   dest:String;
   path,path1:String;
   flag:Boolean;
   i:Integer;
begin
{ Import button click }
 s:=ListBox.Items[ListBox.ItemIndex];
 path:=ExtractFilePath(Application.ExeName)+'DOTS\';
 OpenDialog.InitialDir:=path;
 if (not(FileExists(path+s+'.DB'))) then
  s:=' ';
 OpenDialog.Title:=' : '+s;
 if OpenDialog.Execute then
   begin
     Table1.Close;
     Table1.DatabaseName:=ExtractFilePath(OpenDialog.FileName);
     Table1.TableName:=ExtractFileName(OpenDialog.FileName);
     try
     flag:=True;
     Table1.Open;
     table1.First;
     i:=0;
      while (not(table1.EOF)) do
       begin
         inc(i);
         table1.Next;
       end;
     Table1.Close;
     if (i<43) or (i>44)  then flag:=False;
     except
      flag:=False;
     end;
     if Flag then
     begin
     s1:=ExtractFileName(OpenDialog.FileName);
     path1:=ExtractFilePath(OpenDialog.FileName);
     s1:=copy(s1,1,length(s1)-3);
     source:=path1+s1+'.DB';
     dest:=path+s1+'.DB';
     CopyFile(PChar(source),PChar(Dest),LongBool(0));
     source:=path1+s1+'.PX';
     dest:=path+s1+'.PX';
     CopyFile(PChar(source),PChar(Dest),LongBool(0));
     source:=path1+s1+'.VAL';
     dest:=path+s1+'.VAL';
     CopyFile(PChar(source),PChar(Dest),LongBool(0));
     if (i=43) then
               begin
           Table1.Close;
           Table1.DatabaseName:=path;
           Table1.TableName:=s1+'.DB';
           Table1.Open;
           Table1.Last;
           Table1.Insert;
           Table1.FieldByName('Level').AsInteger:=132;
           Table1.FieldByName('Name').AsString:=' ';
           Table1.FieldByName('FontName').AsString:='Times New Roman';
           Table1.FieldByName('FontSize').AsInteger:=12;
           Table1.FieldByName('FontColor').AsInteger:=Integer(clBlack);
           Table1.FieldByName('Bold').AsBoolean:=False;
           Table1.FieldByName('Italic').AsBoolean:=False;
           Table1.FieldByName('Underline').AsBoolean:=False;
           Table1.FieldByName('Align').AsInteger:=12;
           Table1.FieldByName('Bullets').AsBoolean:=False;
           Table1.FieldByName('FirstInd').AsInteger:=0;
           Table1.FieldByName('LeftInd').AsInteger:=0;
           Table1.FieldByName('RightInd').AsInteger:=152;
           Table1.FieldByName('TabPos').AsInteger:=0;
           Table1.FieldByName('SpaceBefore').AsInteger:=0;
           Table1.FieldByName('SpaceAfter').AsInteger:=0;
           Table1.FieldByName('SpaceLine').AsInteger:=0;
           Table1.FieldByName('BackColor').AsInteger:=Integer(clWhite);
           Table1.FieldByName('PageBreak').AsBoolean:=False;
           Table1.FieldByName('LineSpacingRule').AsInteger:=0;
           Table1.FieldByName('NoControlChar').AsBoolean:=True;
           Table1.Post;
           Table1.Close;
         end;
     EnumAFTables(ExtractFileName(OpenDialog.FileName));
     end else
      Application.MessageBox('    ',' ',MB_OK or MB_ICONERROR);
   end;
end;

end.
