unit txthtml;

interface

Uses Windows,SysUtils,Classes,Graphics,Forms,StyleDef,StyleStr;

Type TTxtToHtmlConverter=class
     private
      {!}
       FRoot:PStyleRecord;
       FCSSFileName:String;
       incomment:boolean;
      {!}
       FSource:TStringList;
       FDest:TStringList;
       FStream:TStyleStream;
       FTitle:String;
       FLSEnabled:Boolean;
       FUL:Boolean;
       tablemode:boolean;
       FTableEnabled:Boolean;  {!!!}
       FBorderEnabled:Boolean; {!!!}
       FTableWidth:Word;       {!!!}
       FRowEnabled:Boolean;    {!!!}
       FColumnEnabled:Boolean; {!!!}
       FColumnWidth:Word;      {!!!}
       FBgColor:String;        {!!!}
       FStyle2Column:Boolean;  {!!!}
       FFirstColumnWidth:Word; {!!!}
       FIsDate:Boolean;        {!!!}
       FTextAlign:TTextAlign;  {!!!}
       FVerticalAlign:TVerticalAlign; {!!!}
       FIsNumber:Boolean;
       FIsLevel:Boolean;      {!!!}
       FEnableHeader:Boolean;  {!!!}
       FHeaderLine:String;     {!!!}
       FEnable2Header:Boolean; {!!!}
       F2HeaderLine,headerline:String;    {!!!}
       FEnableHeaderHeight:Boolean; {!!!}
       FHeaderHeight:Word;     {!!!}
       FHBgColor:String;
       FShowColumnHeaderAtLevel2:Boolean;
       FShowSystemChars:Boolean;
      procedure   Convert(razdl:TStrings;useJS:boolean);
      procedure   AddStyleTable(where:TStrings);
      procedure   AddStyleRecord(p:PStyleRecord;name:String;where:TStrings);
      function    ColorToWeb(Value:TColor):String;
      function    ColorToWebH(Value:TColor):String;
      function    IDToStyle(ind:Integer):String;
      function    GetParaID(Var source:String;Var dest:String;Var id:Integer):Boolean;
      function    GetFontID(Var source:String;Var dest:String;Var id:Integer):Boolean;

      function    CheckForSubHeader(Var dest:String):Boolean;
      function    CheckForRazdel(Var dest:String):Boolean;
      function    CheckForLevel(Var dest:String;Var level:Integer):Boolean;
      function    CheckForPrj(Var dest:String;Var level:Integer):Boolean;
      function    CheckForObrPrj(Var dest:String;Var level:Integer):Boolean;
      function    CheckForComment(Var dest:String):Boolean;
      function    CheckForCommentHeader(Var dest:String):Boolean;
      function    CheckForDirHeader(Var dest:String):Boolean;
      function    CheckForLinkName(Var dest:String):Boolean;
      function    CheckForIndex(Var dest:String):Boolean;
      function    IsNextLevel(var s1:string):Boolean;
      function   GetNotLevelString(s:String):string;
      function    IsDate(s:String):Boolean;
      function    GetFirstDate(s:String):String;
      function    GetSecondDate(s:String):String;
      function    IsNumber(value:String):Boolean;
      function    HasNext(Var s:String):Integer;
      procedure   CopySD(Var source:String;Var dest:String;count:Integer);
      function    CheckForDetail(Var dest:String):Boolean;
      function    CheckForLineComment(Var dest:String):Boolean;
      function    CheckForSecondLine(Var dest:String):Boolean;
      function    CheckForPosType(Var dest:String):Boolean;
      function    IDToCSSName(Value:integer):String;
      function    GetAlignString(ta:TTextAlign;tva:TVerticalAlign):String;
     public
      codepage:string;
      constructor Create;
      destructor  Destroy; override;
      procedure   Clear;
      procedure   OpenFile(FileName:String;razdl:TStrings;useJS:boolean);
      procedure   SaveFile(FileName:String);
      Procedure   SaveToWORD;
      property    CSSFileName:String read FCSSFileName write FCSSFileName;
      property    Title:String read FTitle write FTitle;
     end;

Const
       MIDRazdel=7;
       MIDLevel1=8;
       MIDLevel15=22;
       MIDObrPrj1=23;
       MIDObrPrj15=37;
       MIDPrjHeader=38;
       MIDComment=39;
       MIDCommentHeader=40;
       MIDDirHeader=41;
       MIDIndex=42;
       MIDLinkName=43;
       MIDPrjDetail=44;
       MIDPrjLevel1=45;
       MIDPrjLevel14=58;
       MIDSubHeader=60;
       MIDPosType=61;
       MIDSecondLine=62;
       MIDColumnHeader=59;
      start_com='(*';   { Definition start of multi-line comment block }
      end_com='*)';     { Definition end of multi-line comment block }
      start_comh='* ';
      start_linecomment='/* ';
      start_dirheader=':: ';
      start_index='@@ ';
      end_comh=' *';
// modified 25/07/2k by Alexey  Zabloczkiy
      start_linkname='~~ ';
      start_secondl='|| ';
      start_header=' ';
      start_razdel='$$ ';
      start_postype='## ';
      start_obrprj='.';
      start_detail2='// ';


      SLScale ='';

      LTag:array[0..62] of integer=
        (0,0,0,0,0,0,0,
         128, 126,125,124,123,122,121,120,119,
         118,117,116,115,114,113,112,
         111,110,109,108,107,106,105,104,103,102,
         101,99,98,97,96,0,0,0,0,0,
         0,0,111,110,109,108,107,106,105,104,103,
         102,101,99,98,97,0,127,0,0);

      TableTag:array[0..62] of integer=
         (0,0,0,0,0,0,0,
          99, { Partition }
          126,126,126,126,126,126,126,126,126,126,126,126,126,126,126, { Levels }
          97,97,97,97,97,97,97,97,97,97,97,97,97,97,97, { ObrPrj }
          99, 0,
          99,0,0,0,0,
          96,95,94,93,93,93,93,93,93,93,93,93,93,93,0, { Prj }
          130,99,99);
      systemchars:array[0..62] of string[4]=
      ('','','','','','','',' ',
      '','','','','','','','','','','','','','','',
      '.','.','.','.','.','.','.','.','.','.','.','.','.','.','.',
       '','','',':: ','@@ ','~~ ','',
       '','','','','','','','','','','','','','',
       '','$$ ','/// ','|| ');

      STNewName:array[0..62] of TStyleString=
         ('@page','ASSERT_SHEET','HEADER','PREAMBULA','POSTSCRIPTUM','SIGNATURE_SHEET','COORDINATE_SHEET',
          'PARTITION','LEVEL_1','LEVEL_2','LEVEL_3','LEVEL_4'
         ,'LEVEL_5','LEVEL_6','LEVEL_7','LEVEL_8','LEVEL_9'
         ,'LEVEL_10','LEVEL_11','LEVEL_12','LEVEL_13','LEVEL_14'
         ,'LEVEL_15','OBRPRJ_1','OBRPRJ_2'
         ,'OBRPRJ_3','OBRPRJ_4','OBRPRJ_5'
         ,'OBRPRJ_6','OBRPRJ_7','OBRPRJ_8'
         ,'OBRPRJ_9','OBRPRJ_10','OBRPRJ_11'
         ,'OBRPRJ_12','OBRPRJ_13','OBRPRJ_14'
         ,'OBRPRJ_15','PRJSUBHEADER','COMMENT',
         'COMMENT_HEADER','DIRECTION_HEADER','INDEX',
         'LINK_NAME','PRJ_DETAIL','PRJ_1','PRJ_2',
         'PRJ_3','PRJ_4','PRJ_5','PRJ_6','PRJ_7',
         'PRJ_8','PRJ_9','PRJ_10','PRJ_11','PRJ_12',
         'PRJ_13','PRJ_14','COLUMN_HEADER','SUBHEADER',
         'POSITION_TYPE','SECOND_COLUMN');

      STOldName:array[0..62] of TStyleString=
         ('@page',' ','','','',' ',' ',
          '',' 1',' 2',' 3',' 4'
         ,' 5',' 6',' 7',' 8',' 9'
         ,' 10',' 11',' 12',' 13',' 14'
         ,' 15','  1','  2'
         ,'  3','  4','  5'
         ,'  6','  7','  8'
         ,'  9','  10','  11'
         ,'  12','  13','  14'
         ,'  15','  ','',
         ' ',' ','',
         ' ','  ',' 1',' 2',
         ' 3',' 4',' 5',' 6',' 7',
         ' 8',' 9',' 10',' 11',' 12',
         ' 13',' 14',' ','',
         ' ','');



implementation
uses dialogs, logs, OleServer, Word97;
function TTxtToHtmlConverter.IsNumber(value:String):Boolean;
Var d:String;

 begin
   Result:=False;
   d:=Trim(value);
   if length(d)=0 then Exit;
   if (d[1] < '0') or (d[1] > '9') then Exit;
   Result:=True;
 end;

function  TTxtToHtmlConverter.IDToCSSName(Value:Integer):String;
Var len,i:Integer;
    flag:Boolean;
begin
            Result:=STNewName[value];
end;

function    TTxtToHtmlConverter.GetFirstDate(s:String):String;
var a:Integer;
    d:String;
 begin
    d:=TrimLeft(s);
    a:=pos('c',d);
    if a=0 then
    begin
     a:=1;
     Result:=copy(d,a,10);
    end
   else  Result:=copy(d,a+3,10);
 end;

function    TTxtToHtmlConverter.GetSecondDate(s:String):String;
var a:Integer;
    d:String;
 begin
    d:=TrimLeft(s);
    a:=pos(' ',d);
    if a=0 then
    begin
     a:=1;
     Result:=copy(d,a,10);
    end
    else  Result:=copy(d,a+3,10);
 end;

function    TTxtToHtmlConverter.IsDate(s:String):Boolean;
 begin
   Result:=False;
   if length(s)=0 then Exit;
   if pos('.',s)=0 then Exit;
   Result:=True;
 end;

function    TTxtToHtmlConverter.HasNext(Var s:String):Integer;
var i,j,k,l,m:Integer;
 begin
    Result:=0;
   result:=pos(start_linkname,s);
   if result>0 then exit;
   result:=pos(start_detail2,s);
   if result>0 then exit;
   result:=pos(start_index,s);
   if result>0 then exit;
   result:=pos(start_dirheader,s);
   if result>0 then exit;
   result:=pos(start_postype,s);
   if result>0 then exit;
   result:=pos(start_secondl,s);
   if result>0 then exit;
   result:=pos(start_linecomment,s);
   if result>0 then exit;
   result:=0;
 end;

function    TTxtToHtmlConverter.CheckForSubHeader(Var dest:String):Boolean;
Var j:Integer;
 begin
  {}
   j:=pos(start_header,dest);
   if j=1 then
    begin
      Result:=True;
      dest:=copy(dest,length(start_header)+1,length(dest));
    end
   else Result:=False;
 end;

function    TTxtToHtmlConverter.CheckForRazdel(Var dest:String):Boolean;
 begin
  {}
   Result:=False;
   if Length(dest)<2 then Exit;
   If pos(start_razdel,dest)=1 then
     begin
       dest:=copy(dest,length(start_razdel)+1,length(dest));
       Result:=True;
     end;
 end;

function TTxtToHtmlConverter.IsNextLevel(var s1:string):Boolean;
var ss:string;
    c:char;
begin
 ss:=s1;
 Result:=False;
 if length(s1)=0 then Exit;
 s1:=TrimLeft(s1);
 if length(s1)=0 then Exit;
 if (s1[1] >= '0') and (s1[1] <= '9') then
   begin
     Result:=True;
     while (length(s1)>0)and(((s1[1] >='0') and (s1[1] <='9'))or(s1[1]='.')) do
      begin
      c:=s1[1];
       s1:=copy(s1,2,length(s1)-1);
      end;
      if c<>'.' then result:=false;
   end;
if not result then s1:=ss;
end;


function    TTxtToHtmlConverter.GetNotLevelString(s:String):string;
var I:integer;
 begin
   result:='';  s:=TrimLeft(s);
   if length(s)=0 then Exit;
   i:=1;
   if s[i]='A' then inc(i);
   while (i<=length(s))and((s[i] in['0'..'9'])or(s[i]='.')) do
   inc(i);
   if (i>1)and((s[i-1]='.')or(s[1]='A')and(s[i-1] in ['0'..'9'])) then
   begin
       result:=copy(s,1,i-1);
   end;
 end;


function    TTxtToHtmlConverter.CheckForLevel(Var dest:String;Var level:Integer):Boolean;
Var s1:String;
    c:char;
 begin
    Result:=False;
   level:=0;
   s1:=dest;
 {   -   }
  if length(s1)=0 then Exit;
  if s1[1]='A' then delete(s1,1,1);
  if length(s1)=0 then Exit;
  if (s1[1] in ['0'..'9']) then
begin
   while (length(s1)>0)and((s1[1] in ['0'..'9'])or(s1[1]='.')) do
   begin
   result:=true;
   if (s1[1]='.')or(dest[1]='A') then inc(level);
   c:=s1[1];
   delete(s1,1,1);
   end;
if (c<>'.')and not((dest[1]='A')and(c in ['0'..'9'])) then result:=false;
if (level > 15) then level:=15;
end;
 end;

function    TTxtToHtmlConverter.CheckForPrj(Var dest:String;Var level:Integer):Boolean;
Var tmp:String;
    i:Integer;
 begin
  Result:=False;
  level:=0;
  if Length(dest)=0 then Exit;
  tmp:=dest;
  if tmp[1]='' then
                begin
                   dest:=copy(dest,2,length(dest)-1);
                   Result:=True;
                   level:=1;
                   Exit;
                end;
  if tmp[1]='' then
                begin
                   dest:=copy(dest,2,length(dest)-1);
                   Result:=True;
                   level:=2;
                   Exit;
                end;
  if tmp[1]='' then
                begin
                   dest:=copy(dest,2,length(dest)-1);
                   Result:=True;
                   level:=3;
                   Exit;
                end;
  {}
 end;

function    TTxtToHtmlConverter.CheckForObrPrj(Var dest:String;Var level:Integer):Boolean;
Var tmp,tmp1,tmp2:String;
      i:Integer;
 begin
 {}
 Result:=False;
 level:=0;
 if Length(dest)=0 then Exit;
 tmp:=dest;
 if (tmp[1]<>start_ObrPrj) then Exit;
 i:=1;
 while ((tmp[i]=start_ObrPrj) and (i<=Length(tmp))) do
  begin
    inc(level);
    inc(i);
  end;
 dest:=copy(dest,i+1,length(dest)-i);
 Result:=True;
 end;

function    TTxtToHtmlConverter.CheckForComment(Var dest:String):Boolean;
 begin
 {}
  Result:=False;
  if Length(dest)=0 then Exit;
  if pos(start_com,dest)=1 then
     begin
       dest:=copy(dest,3,length(dest));
       dest:=copy(dest,1,length(dest)-3);
       Result:=True;
     end;
 end;

function    TTxtToHtmlConverter.CheckForCommentHeader(Var dest:String):Boolean;
 begin
 {}
   Result:=False;
   if Length(dest)=0 then Exit;
   If pos(start_comh,dest)=1 then
     begin
       dest:=copy(dest,3,length(dest)-2);
       Result:=True;
     end;
 end;

function    TTxtToHtmlConverter.CheckForDirHeader(Var dest:String):Boolean;
 begin
 {}
   Result:=False;
   if Length(dest)=0 then Exit;
   If pos(start_dirheader,dest)=1 then
     begin
       dest:=copy(dest,4,length(dest)-3);
       Result:=True;
     end;
 end;

function    TTxtToHtmlConverter.CheckForLinkName(Var dest:String):Boolean;
 begin
 {}
    Result:=False;
    if Length(dest)<2 then Exit;
    If pos(start_linkname,dest)=1 then
     begin
       dest:=copy(dest,4,length(dest)-3);
       Result:=True;
     end;
 end;

function    TTxtToHtmlConverter.CheckForIndex(Var dest:String):Boolean;
 begin
 {}
   Result:=False;
   if Length(dest)=0 then Exit;
   If pos(start_index,dest)=1 then
     begin
       dest:=copy(dest,4,length(dest)-3);
       Result:=True;
     end;
 end;

procedure  TTxtToHtmlConverter.CopySD(Var source:String;Var dest:String;count:Integer);
 begin
 if count=0 then count:=length(dest)+1;
   source:=copy(dest,count,length(dest));
   dest:=copy(dest,1,count-1);
 end;

function  TTxtToHtmlConverter.GetParaID(Var source:String;Var dest:String;Var id:Integer):Boolean;
Var level:Integer;
    n:Integer;
 begin

  source:=TrimLeft(source);
  dest:=source;
  Result:=True;
  if CheckForSubHeader(dest) then
                             begin
                               ID:=MIDSubHeader;
                               n:=HasNext(dest);
                               CopySD(source,dest,n);
                               Exit;
                             end;
  if CheckForRazdel(dest) then
                             begin
                               ID:=MIDRazdel;
                               n:=HasNext(dest);
                               CopySD(source,dest,n);
                               Exit;
                             end;
  if CheckForLevel(dest,level) then
                             begin
                               ID:=MIDLevel1+level-1;
                               n:=HasNext(dest);
                               CopySD(source,dest,n);
                               Exit;
                             end;
  if CheckForPrj(dest,level) then
                             begin
                               ID:=MIDPrjLevel1+level-1;
                               n:=HasNext(dest);
                               CopySD(source,dest,n);
                               Exit;
                             end;
  if CheckForObrPrj(dest,level) then
                             begin
                               ID:=MIDObrPrj1+level-1;
                               n:=HasNext(dest);
                               CopySD(source,dest,n);
                               Exit;
                             end;
  if CheckForComment(dest) then
                             begin
                               ID:=MIDComment;
                               incomment:=true;
                               Exit;
                             end;
  if CheckForCommentHeader(dest) then
                             begin
                               ID:=MIDCommentHeader;
                               n:=HasNext(dest);
                               CopySD(source,dest,n);
                               Exit;
                             end;
  if CheckForDirHeader(dest) then
                             begin
                               ID:=MIDDirHeader;
                               n:=HasNext(dest);
                               CopySD(source,dest,n);
                               Exit;
                             end;
  if CheckForLinkName(dest) then
                             begin
                               ID:=MIDLinkName;
                               n:=HasNext(dest);
                               CopySD(source,dest,n);
                               Exit;
                             end;
  if CheckForIndex(dest) then
                             begin
                               ID:=MIDIndex;
                               n:=HasNext(dest);
                               CopySD(source,dest,n);
                               Exit;
                             end;
  ID:=MIDPrjHeader;
  n:=HasNext(dest);
  if (n<>0) then CopySD(source,dest,n);
 end;

function  TTxtToHtmlConverter.CheckForDetail(Var dest:String):Boolean;
var res:Integer;
 begin
   Result:=False;
       if (pos(start_detail2,dest)=1) then
          begin
            dest:=copy(dest,length(start_detail2)+1,length(dest));
            Result:=True;
          end;
end;
function  TTxtToHtmlConverter.CheckForLineComment(Var dest:String):Boolean;
var res:Integer;
 begin
   Result:=False;
       if (pos(start_linecomment,dest)=1) then
          begin
            dest:=copy(dest,length(start_linecomment)+1,length(dest));
            Result:=True;
          end;
end;

function  TTxtToHtmlConverter.CheckForSecondLine(Var dest:String):Boolean;
Var res:Integer;
 begin
   Result:=False;
   Res:=pos(start_secondl,dest);
   if (Res=1) then
     begin
      dest:=copy(dest,length(start_secondl)+1,length(dest));
      Result:=True;
     end;
 end;

function  TTxtToHtmlConverter.CheckForPosType(Var dest:String):Boolean;
 begin
  Result:=False;
  if pos(start_postype,dest)=1 then
    begin
      dest:=copy(dest,length(start_postype)+1,length(dest));
      Result:=True;
    end;
 end;


function  TTxtToHtmlConverter.GetFontID(Var source:String;Var dest:String;Var id:Integer):Boolean;
Var n,level:Integer;
 begin
   Result:=False;
   source:=TrimLeft(source);
   dest:=source;
     if CheckForPrj(dest,level) then
                             begin
                               ID:=MIDPrjLevel1+level-1;
                               n:=HasNext(dest);
                               CopySD(source,dest,n);
                               Exit;
                             end;
  if CheckForObrPrj(dest,level) then
                             begin
                               ID:=MIDObrPrj1+level-1;
                               n:=HasNext(dest);
                               CopySD(source,dest,n);
                               Exit;
                             end;

   if CheckForLinkName(dest)      then
                                  begin
                                   ID:=MIDLinkName;
                                   n:=HasNext(dest);
                                   if (n<>0) then CopySD(source,dest,n) else
                                   source:='';
                                   Result:=True;
                                   Exit;
                                  end;

   if CheckForDetail(dest)      then
                                  begin
                                   ID:=MIDPrjDetail;
                                   n:=HasNext(dest);
                                   if (n<>0) then CopySD(source,dest,n) else
                                   source:='';
                                   Result:=True;
                                   Exit;
                                  end;

   if CheckForIndex(dest)      then
                                  begin
                                   ID:=MIDIndex;
                                   n:=HasNext(dest);
                                   if (n<>0) then CopySD(source,dest,n) else
                                   source:='';
                                   Result:=True;
                                   Exit;
                                  end;
  if CheckForDirHeader(dest) then
                             begin
                               ID:=MIDDirHeader;
                               n:=HasNext(dest);
                                   if (n<>0) then CopySD(source,dest,n) else
                                   source:='';
                                   Result:=True;
                               Exit;
                             end;


   if CheckForPosType(dest)     then
                                  begin
                                   ID:=MIDPosType;
                                   n:=HasNext(dest);
                                   if (n<>0) then CopySD(source,dest,n) else
                                   source:='';
                                   Result:=True;
                                   Exit;
                                  end;

   if CheckForSecondLine(dest)  then
                                  begin
                                   ID:=MIDSecondLine;
                                   n:=HasNext(dest);
                                   if (n<>0) then CopySD(source,dest,n) else
                                   source:='';
                                   Result:=True;
                                   Exit;
                                  end;
   if CheckForlinecomment(dest)     then
                                  begin
                                   ID:=MIDComment;
                                   n:=HasNext(dest);
                                   if (n<>0) then CopySD(source,dest,n) else
                                   source:='';
                                   Result:=True;
                                   Exit;
                                  end;
 end;

function  TTxtToHtmlConverter.IDToStyle(ind:Integer):String;
Var p:PStyleRecord;
    i:Integer;
    j:Integer;
 begin
   Result:='';
      FLSEnabled:=False;
   FUL:=True;
   FTableEnabled:=False;  {!!!}
   FBorderEnabled:=False; {!!!}
   FTableWidth:=0;      {!!!}
   FRowEnabled:=False;    {!!!}
   FColumnEnabled:=False; {!!!}
   FColumnWidth:=0;      {!!!}
   FBgColor:='#FFFFFF';   {!!!}
   FHBgColor:='#FFFFFF';   {!!!}
   FStyle2Column:=False;
   FFirstColumnWidth:=0;
   FTextAlign:=taLeft;
   FVerticalAlign:=vaMiddle;
   FEnableHeader:=False;  {!!!}
   FHeaderLine:='';     {!!!}
   FEnable2Header:=False; {!!!}
   F2HeaderLine:='';    {!!!}
   FEnableHeaderHeight:=False; {!!!}
   FHeaderHeight:=0;     {!!!}
   FShowColumnHeaderAtLevel2:=false;
   if FRoot=nil then Exit;
   if ind<=0 then
      begin
        Result:=FRoot^.StyleName;
        FLSEnabled:=FRoot^.ListStyleEnabled;
        FUL:=(FRoot^.ListStyle<lsDecimal);
        FTableEnabled:=FRoot^.StartNewTable and tablemode; {!!!}
        FBorderEnabled:=FRoot^.ShowBorder and tablemode;   {!!!}
        if tablemode then FTableWidth:=FRoot^.TableWidth
                     else FTableWidth:=0;      {!!!}
        FRowEnabled:=FRoot^.StartNewRow and tablemode;     {!!!}
        FColumnEnabled:=tablemode;//FRoot^.StartNewColumn and tablemode; {!!!}
        if tablemode then FColumnWidth:=FRoot^.ColumnWidth      {!!!}
                     else FColumnWidth:=0;
        if FRoot^.BackColorEnabled then FBgColor:=ColorToWeb(FRoot^.BackColor);   {!!!}
        if FRoot^.BackColorEnabled then FHBgColor:=ColorToWebH(FRoot^.BackColor);   {!!!}
        FStyle2Column:=FRoot^.Style2Column and tablemode;
        if tablemode then FFirstColumnWidth:=FRoot^.FirstColumnWidth
                     else FFirstColumnWidth:=0;
        FTextAlign:=FRoot^.TextAlign;
        FVerticalAlign:=FRoot^.VerticalAlign;
        FEnableHeader:=FRoot^.ShowColumnHeader and tablemode;  {!!!}
        if tablemode then FHeaderLine:=FRoot^.ColumnHeader
             {!!!}   else FHeaderLine:='';
        FEnable2Header:=FRoot^.Show2ColumnHeader and tablemode; {!!!}
        if tablemode then F2HeaderLine:=FRoot^.Style2ColumnHeader    {!!!}
                     else F2HeaderLine:='';
        FEnableHeaderHeight:=FRoot^.EnableHeaderHeight and tablemode; {!!!}
        if tablemode then FHeaderHeight:=FRoot^.HeaderHeight     {!!!}
                     else FHeaderHeight:=0;
        FShowColumnHeaderAtLevel2:=FRoot^.ShowColumnHeaderAtLevel2 and tablemode;
        FShowSystemChars:=FRoot^.ShowSystemChars;
        Exit;
      end;
   p:=FRoot;
   i:=ind;
   if (i>62) then i:=62;
   for j:=1 to i do p:=p^.Next;
   Result:=p^.StyleName;
        FLSEnabled:=p^.ListStyleEnabled;
        FUL:=(p^.ListStyle<lsDecimal);
        FTableEnabled:=p^.StartNewTable and tablemode; {!!!}
        FBorderEnabled:=p^.ShowBorder and tablemode;   {!!!}
        if tablemode then FTableWidth:=p^.TableWidth
                     else FTableWidth:=0;      {!!!}
        FRowEnabled:=p^.StartNewRow and tablemode;     {!!!}
        FColumnEnabled:=tablemode;//p^.StartNewColumn and tablemode; {!!!}
        if tablemode then FColumnWidth:=p^.ColumnWidth      {!!!}
                     else FColumnWidth:=0;
        if p^.BackColorEnabled then FBgColor:=ColorToWeb(p^.BackColor);   {!!!}
        if p^.BackColorEnabled then FHBgColor:=ColorToWebH(p^.BackColor);   {!!!}
        FStyle2Column:=p^.Style2Column and tablemode;
        if tablemode then FFirstColumnWidth:=p^.FirstColumnWidth
                     else FFirstColumnWidth:=0;
        FTextAlign:=p^.TextAlign;
        FVerticalAlign:=p^.VerticalAlign;
        FEnableHeader:=p^.ShowColumnHeader and tablemode;  {!!!}
        if tablemode then FHeaderLine:=p^.ColumnHeader
             {!!!}   else FHeaderLine:='';
        FEnable2Header:=p^.Show2ColumnHeader and tablemode; {!!!}
        if tablemode then F2HeaderLine:=p^.Style2ColumnHeader    {!!!}
                     else F2HeaderLine:='';
        FEnableHeaderHeight:=p^.EnableHeaderHeight and tablemode; {!!!}
        if tablemode then FHeaderHeight:=p^.HeaderHeight     {!!!}
                     else FHeaderHeight:=0;
        FShowColumnHeaderAtLevel2:=p^.ShowColumnHeaderAtLevel2 and tablemode;
        FShowSystemChars:=p^.ShowSystemChars;
 end;

function  TTxtToHtmlConverter.ColorToWeb(Value:TColor):String;
Var r,g,b,a:DWORD;
 begin
   Result:='#';
   r:=(DWORD(Value) shr 16) and $FF;
   g:=(DWORD(Value) shr 8) and $FF;
   b:=DWORD(VALUE) and $FF;
   a:=r or (g shl 8) or (b shl 16);
   Result:=Result+IntToHex(a,6);
 end;


function  TTxtToHtmlConverter.ColorToWebH(Value:TColor):String;
Var r,g,b,a:DWORD;
 begin
   Result:='#';
   r:=((DWORD(Value) shr 16)-10) and $FF;
   g:=((DWORD(Value) shr 8)-10) and $FF;
   b:=(DWORD(VALUE)-10) and $FF;
   a:=r or (g shl 8) or (b shl 16);
   Result:=Result+IntToHex(a,6);
 end;


function TTxtToHtmlConverter.GetAlignString(ta:TTextAlign;tva:TVerticalAlign):String;
 begin
   Result:='ALIGN=';
   case ta of
    taCenter:   Result:=Result+'CENTER';
    taJustify:  Result:=Result+'JUSTIFY';
    taLeft:     Result:=Result+'LEFT';
    taRight:    Result:=Result+'RIGHT';
   end;
   Result:=Result+' VALIGN=';
   case tva of
     vaBaseline:  RESULT:=Result+'BASELINE';
     vaBottom:    RESULT:=Result+'BOTTOM';
     vaMiddle:    RESULT:=Result+'MIDDLE';
     vaSub:       RESULT:=Result+'SUB';
     vaSuper:     RESULT:=Result+'SUPER';
     vaTextBottom: RESULT:=Result+'TEXT-BOTTOM';
     vaTextTop:   RESULT:=Result+'TEXT-TOP';
     vaTop:       RESULT:=Result+'TOP';
   end;
 end;

procedure TTxtToHtmlConverter.AddStyleRecord(p:PStyleRecord;name:String;where:TStrings);
Var s:String;
 begin
   if p=nil then Exit;
{   if (p^.StyleName<>'@page') then
    FDest.Add('#'+StrToCSSName(p^.StyleName)+' {')
   else
    FDest.Add(p^.StyleName+' {');  }
   where.Add(name+' {');
   if p^.FontEnabled then
     where.Add('font-family : "'+p^.Font+'";');
   case (p^.FontSizeUnits) of
    fsuPt: s:='pt';
    fsuIn: s:='in';
    fsuMm: s:='mm';
    fsuCm: s:='cm';
    fsuPc: s:='pc';
    fsuPx: s:='px';
    fsuEm: s:='em';
    fsuEx: s:='ex';
   end;
   if p^.FontSizeEnabled then
     where.Add('font-size : '+IntToStr(p^.FontSize)+s+';');
   case (p^.FontWeight) of
    fwExtraLight:  s:='extra-light';
    fwLight:       s:='light';
    fwDemiLight:   s:='demi-light';
    fwMedium:      s:='medium';
    fwDemiBold:    s:='demi-bold';
    fwBold:        s:='bold';
    fwExtraBold:   s:='extra-bold';
    fwBorder:      s:='border';
    fwLighter:     s:='lighter';
   end;
   if p^.FontWeightEnabled then
     where.Add('font-weight : '+s+';');
   case (p^.FontStyle) of
     fsItalic:      s:='italic';
     fsOblique:     s:='oblique';
     fsSmallCaps:   s:='small-caps';
     fsNone:        s:='none';
   end;
   if p^.FontStyleEnabled then
     where.Add('font-style : '+s+';');
   case (p^.TextDecoration) of
    tdUnderline:    s:='underline';
    tdOverline:     s:='overline';
    tdLineThrough:  s:='line-through';
    tdBlink:        s:='blink';
    tdNone:         s:='none';
   end;
   if p^.TextDecorationEnabled then
     where.Add('text-decoration : '+s+';');
   case (p^.TextTransform) of
    ttCapitalize:    s:='capitalize';
    ttUppercase:     s:='uppercase';
    ttLowercase:     s:='lowercase';
    ttNone:          s:='none';
   end;
   if p^.TextTransformEnabled then
     where.Add('text-transform'+s+';');
   if p^.FontColorEnabled then
     where.Add('color : '+ColorToWeb(TColor(p^.FontColor))+';');
   if p^.BackColorEnabled then
     where.Add('background : '+ColorToWeb(TColor(p^.BackColor))+';');
   if p^.TextIndentEnabled then
     where.Add('text-indent : '+IntToStr(p^.TextIndent)+'pt;');
   if p^.LeadingSpaceEnabled then
     where.Add('margin-left : '+IntToStr(p^.LeadingSpace)+'pt;');
   if p^.WordSpacingEnabled then
     where.Add('word-spacing : '+IntToStr(p^.WordSpacing)+'pt;');
   if p^.LetterSpacingEnabled then
     where.Add('letter-spacing : '+IntToStr(p^.LetterSpacing)+'pt;');
   case (p^.VerticalAlign) of
     vaBaseline:   s:='baseline';
     vaBottom:     s:='bottom';
     vaMiddle:     s:='middle';
     vaSub:        s:='sub';
     vaSuper:      s:='super';
     vaTextBottom: s:='text-bottom';
     vaTextTop:    s:='text-top';
     vaTop:        s:='top';
   end;
   if p^.VerticalAlignEnabled then
     where.Add('verical-align : '+s+';');
   case (p^.TextAlign) of
     taCenter:     s:='center';
     taJustify:    s:='justify';
     taLeft:       s:='left';
     taRight:      s:='right';
   end;
   if p^.TextAlignEnabled then
     where.Add('text-align : '+s+';');
   case (p^.position) of
     pRelative:    s:='relative';
     pAbsolute:    s:='absolute';
     pStatic:      s:='static';
   end;
   if p^.PositionEnabled then
     where.Add('position : '+s+';');
   case (p^.LeftUnits) of
    fsuPt: s:='pt';
    fsuIn: s:='in';
    fsuMm: s:='mm';
    fsuCm: s:='cm';
    fsuPc: s:='pc';
    fsuPx: s:='px';
    fsuEm: s:='em';
    fsuEx: s:='ex';
   end;
   if p^.LeftPosEnabled then
     where.Add('left : '+IntToStr(p^.LeftPos)+s+';');
   case (p^.TopUnits) of
    fsuPt: s:='pt';
    fsuIn: s:='in';
    fsuMm: s:='mm';
    fsuCm: s:='cm';
    fsuPc: s:='pc';
    fsuPx: s:='px';
    fsuEm: s:='em';
    fsuEx: s:='ex';
   end;
   if p^.TopPosEnabled then
     where.Add('top : '+IntToStr(p^.TopPos)+s+';');
   case (p^.WidthUnits) of
    fsuPt: s:='pt';
    fsuIn: s:='in';
    fsuMm: s:='mm';
    fsuCm: s:='cm';
    fsuPc: s:='pc';
    fsuPx: s:='px';
    fsuEm: s:='em';
    fsuEx: s:='ex';
   end;
   if p^.WidthPosEnabled then
     where.Add('width : '+IntToStr(p^.WidthPos)+s+';');
   case (p^.HeightUnits) of
    fsuPt: s:='pt';
    fsuIn: s:='in';
    fsuMm: s:='mm';
    fsuCm: s:='cm';
    fsuPc: s:='pc';
    fsuPx: s:='px';
    fsuEm: s:='em';
    fsuEx: s:='ex';
   end;
   if p^.HeightPosEnabled then
     where.Add('height : '+IntToStr(p^.HeightPos)+s+';');
   if p^.ZIndexEnabled then
     where.Add('z-index : '+IntToStr(p^.ZIndex)+';');
   case (p^.Overflow) of
    oVisible:   s:='visible';
    oHidden:    s:='hidden';
    oScroll:    s:='scroll';
    oAuto:      s:='auto';
   end;
   if p^.OverflowEnabled then
     where.Add('overflow : '+s+';');
   case (p^.LeftMarginUnits) of
    fsuPt: s:='pt';
    fsuIn: s:='in';
    fsuMm: s:='mm';
    fsuCm: s:='cm';
    fsuPc: s:='pc';
    fsuPx: s:='px';
    fsuEm: s:='em';
    fsuEx: s:='ex';
   end;
   if p^.LeftMarginEnabled then
     where.Add('margin-left : '+IntToStr(p^.LeftMargin)+s+';');
   case (p^.RightMarginUnits) of
    fsuPt: s:='pt';
    fsuIn: s:='in';
    fsuMm: s:='mm';
    fsuCm: s:='cm';
    fsuPc: s:='pc';
    fsuPx: s:='px';
    fsuEm: s:='em';
    fsuEx: s:='ex';
   end;
   if p^.RightMarginEnabled then
     where.Add('margin-right : '+IntToStr(p^.RightMargin)+s+';');
   case (p^.TopMarginUnits) of
    fsuPt: s:='pt';
    fsuIn: s:='in';
    fsuMm: s:='mm';
    fsuCm: s:='cm';
    fsuPc: s:='pc';
    fsuPx: s:='px';
    fsuEm: s:='em';
    fsuEx: s:='ex';
   end;
   if p^.TopMarginEnabled then
     where.Add('margin-top : '+IntToStr(p^.TopMargin)+s+';');
   case (p^.BottomMarginUnits) of
    fsuPt: s:='pt';
    fsuIn: s:='in';
    fsuMm: s:='mm';
    fsuCm: s:='cm';
    fsuPc: s:='pc';
    fsuPx: s:='px';
    fsuEm: s:='em';
    fsuEx: s:='ex';
   end;
   if p^.BottomMarginEnabled then
     where.Add('margin-bottom : '+IntToStr(p^.BottomMargin)+s+';');
   case (p^.LeftBorder) of
    btDotted:    s:='dotted';
    btDashed:    s:='dashed';
    btSolid:     s:='solid';
    btDouble:    s:='double';
    btGroove:    s:='groove';
    btRidge:     s:='ridge';
    btInset:     s:='inset';
    btOutset:    s:='outset';
    btNone:      s:='none';
   end;
   if p^.LeftBorderEnabled then
     where.Add('border-left : '+s+';');
   case (p^.RightBorder) of
    btDotted:    s:='dotted';
    btDashed:    s:='dashed';
    btSolid:     s:='solid';
    btDouble:    s:='double';
    btGroove:    s:='groove';
    btRidge:     s:='ridge';
    btInset:     s:='inset';
    btOutset:    s:='outset';
    btNone:      s:='none';
   end;
   if p^.RightBorderEnabled then
     where.Add('border-right : '+s+';');
   case (p^.TopBorder) of
    btDotted:    s:='dotted';
    btDashed:    s:='dashed';
    btSolid:     s:='solid';
    btDouble:    s:='double';
    btGroove:    s:='groove';
    btRidge:     s:='ridge';
    btInset:     s:='inset';
    btOutset:    s:='outset';
    btNone:      s:='none';
   end;
   if p^.TopBorderEnabled then
     where.Add('border-top : '+s+';');
   case (p^.BottomBorder) of
    btDotted:    s:='dotted';
    btDashed:    s:='dashed';
    btSolid:     s:='solid';
    btDouble:    s:='double';
    btGroove:    s:='groove';
    btRidge:     s:='ridge';
    btInset:     s:='inset';
    btOutset:    s:='outset';
    btNone:      s:='none';
   end;
   if p^.BottomBorderEnabled then
     where.Add('border-bottom : '+s+';');
   if p^.TransitionEnabled then
     where.Add('filter : revealtrans(duration='+IntToStr(p^.TransitionDuration)+' transition='+IntToStr(p^.TransitionType)+');');
   case (p^.MarksType) of
    mtCrop:   s:='crop';
    mtCross:  s:='cross';
    mtNone:   s:='none';
   end;
   if p^.MarksEnabled then
     where.Add('marks : '+s+';');
   case (p^.orientation) of
     orAuto:        s:='auto';
     orLandscape:   s:='landscape';
     orPortrait:    s:='portrait';
   end;
   if p^.OrientationEnabled then
     where.Add('size : '+s+';');
   case (p^.PageBreakBefore) of
     pbAlways:      s:='always';
     pbAuto:        s:='auto';
     pbLeft:        s:='left';
     pbRight:       s:='right';
   end;
   if p^.PBBEnabled then
     where.Add('page-break-before : '+s+';');
   case (p^.PageBreakAfter) of
     pbAlways:      s:='always';
     pbAuto:        s:='auto';
     pbLeft:        s:='left';
     pbRight:       s:='right';
   end;
   if p^.PBAEnabled then
     where.Add('page-break-after : '+s+';');
   case (p^.PaddingUnits) of
    fsuPt: s:='pt';
    fsuIn: s:='in';
    fsuMm: s:='mm';
    fsuCm: s:='cm';
    fsuPc: s:='pc';
    fsuPx: s:='px';
    fsuEm: s:='em';
    fsuEx: s:='ex';
   end;
   if p^.PaddingEnabled then
     where.Add('padding : '+IntToStr(p^.Padding)+s+';');
   case (p^.LineHeightUnits) of
    fsuPt: s:='pt';
    fsuIn: s:='in';
    fsuMm: s:='mm';
    fsuCm: s:='cm';
    fsuPc: s:='pc';
    fsuPx: s:='px';
    fsuEm: s:='em';
    fsuEx: s:='ex';
   end;
   if p^.LineHeightEnabled then
     where.Add('line-height : '+IntToStr(p^.LineHeight)+s+';');
   case (p^.Visibility) of
     vtInherit:  s:='inherit';
     vtVisible:  s:='visible';
     vtHidden:   s:='hidden';
   end;
   if p^.VisibilityEnabled then
     where.Add('visibility : '+s+';');
   case (p^.ListStyle) of
     lsDisc:         s:='disc';
     lsCircle:       s:='circle';
     lsSquare:       s:='square';
     lsDecimal:      s:='decimal';
     lsLowerRoman:   s:='lower-roman';
     lsUpperRoman:   s:='upper-roman';
     lsLowerAlpha:   s:='lower-alpha';
     lsUpperAlpha:   s:='upper-alpha';
     lsNone:         s:='none';
   end;
   if p^.ListStyleEnabled then
     where.Add('list-style : '+s+';');
   case (p^.FloatType) of
    dtLeft:   s:='left';
    dtRight:  s:='right';
   end;
   if p^.FloatEnabled then
     where.Add('float : '+s+';');
   case (p^.ClearType) of
    dtLeft:   s:='left';
    dtRight:  s:='right';
   end;
   if p^.ClearEnabled then
     where.Add('clear : '+s+';');
   case (p^.WhiteSpace) of
    wsPre:        s:='pre';
    wsNowrap:     s:='nowrap';
    wsNormal:     s:='normal';
   end;
   if p^.WhiteSpaceEnabled then
     where.Add('white-space : '+s+';');
   where.Add('}');
 end;

procedure   TTxtToHtmlConverter.AddStyleTable(where:TStrings);
Var p:PStyleRecord;
    i:integer;
 begin
   where.Add('<STYLE>');
   p:=Froot;
   i:=0;
   while (p<>nil) do
     begin
       if i<>0 then
       AddStyleRecord(p,'#'+stNewName[i],where)
       else
       AddStyleRecord(p,stNewName[i],where);
       p:=p^.Next;
       inc(i);
     end;
   where.Add('</STYLE>');
 end;

constructor TTxtToHtmlConverter.Create;
 begin
   inherited Create;
   FRoot:=nil;
   FCSSFileName:=ExtractFilePath(Application.ExeName)+'default.afm';
   FSource:=TStringList.Create;
   FDest:=TStringList.Create;
   FStream:=TStyleStream.Create;
   FTitle:='MOP Intranet publication template';
 end;

destructor  TTxtToHtmlConverter.Destroy;
 begin
   Clear;
   FStream.Free;
   FSource.Free;
   FDest.Free;
   inherited Destroy;
 end;

procedure TTxtToHtmlConverter.Clear;
 begin
   FStream.ClearCSSList(FRoot);
   FRoot:=nil;
   FSource.Clear;
   FDest.Clear;
 end;

procedure   TTxtToHtmlConverter.Convert(razdl:TStrings;useJS:boolean);
Var ic,i,j:Integer;
    s,l,sn,ss:String;
    PIDFlag,PIDEnd:string;
    ind:Integer;
    res:Boolean;
    parafont:Boolean;
    newtag:Integer;
    tags:array[0..63] of Boolean;
    ultags:array[0..63] of Boolean;
    oldtags:array[0..63] of Integer;
    stekind:Integer;
    stekindtable:Integer; {!!!}
    newtabletag:Integer;  {!!!}
    oldtabletags:array[0..63] of Integer; {!!!}
    tagstable:array[0..128] of Boolean; {!!!}
    st:String; {!!!}
    trflags:array[0..63] of Boolean;
    lod:Integer;
    tdflags:array[0..63] of Boolean;
    firstpasstr,afterheader:Boolean;
    FOldColumnEnabled:Boolean;
    levs,nlevs:String;
    nlevsl:Integer;
    astr:String;
    slashp:Boolean;
    ttts:String;
    inspos:array[0..63] of Integer;
    flagfr:array[0..63] of Boolean;
    ncols:array[0..63] of Integer;
    ncolsf:array[0..63] of Integer;
    oldcolstr:String;
    isheader,next:boolean;
    headers,fstyle:TStringList;
    function mouseEvent(s:string):string;
    begin
    result:=' onMouseOver="onMove('''+s+''')" '+' onMouseOut="onOut()"';
    end;
    function ParaString(ind:integer;l:string):string;
    begin
                 if usejs then
             result:=(PIDFlag+STNewName[ind]+MouseEvent(IDToStyle(ind))+'>')
             else
             result:=(PIDFlag+STNewName[ind]+'>');
    result:=result+l;
    result:=result+PIDend;

    end;
function ProcessLink(nlevs:string;dosystem:boolean):string;
begin
if fileexists(nlevs) then
                   if (Uppercase(extractfileext(nlevs))='.GIF')or(Uppercase(extractfileext(nlevs))='.JPG')then
                   result:='<img align=center src="'+nlevs+'">'
                   else if dosystem then
                   result:='<a href="'+nlevs+'">'+systemchars[ind]+nlevs+'</a>'
                   else result:='<a href="'+nlevs+'">'+nlevs+'</a>'
                   else if dosystem then result:=systemchars[ind]+nlevs
                   else result:=nlevs;
end;
 begin
  {}
    for i:=0 to 63 do tags[i]:=False;
   for i:=0 to 63 do ultags[i]:=False;
   for i:=0 to 63 do oldtags[i]:=0;
   for i:=0  to 63 do oldtabletags[i]:=0; {!!!}
   for i:=0 to 128 do tagstable[i]:=False; {!!!}
   for i:=0 to 63 do trflags[i]:=False;   {!!!}
   for i:=0 to 63 do tdflags[i]:=False;   {!!!}
   for i:=0 to 63 do inspos[i]:=-1;       {!!!}
   for i:=0 to 63 do flagfr[i]:=False;    {!!!}
   for i:=0 to 63 do ncols[i]:=0;         {!!!}
   for i:=0 to 63 do ncolsf[i]:=0;        {!!!}
   lod:=0;                                {!!!}
   stekind:=-1;
   stekindtable:=-1;     {!!!}
   firstpasstr:=False;   {!!!}
   oldcolstr:='';        {!!!}
      if razdl<>nil then
   razdl.clear;
   FOldColumnEnabled:=False;
    FDest.Add('<HTML>');
   FDest.Add('<HEAD>');
   FDest.Add('<TITLE>'+FTitle+'</TITLE>');
   FDest.Add('<meta http-equiv="Content-Type" content="text/html; charset='+codepage+'">');
   if useJS  then
   begin
   FDest.Add('<script language="JavaScript">');
   FDest.Add('<!--');
   FDest.Add('	function onMove(estr)');
   FDest.Add('	{');
   FDest.Add('window.status=estr');
   FDest.Add('	}');
   FDest.Add('	function onOut()');
   FDest.Add('	{');
   FDest.Add('window.status=''''');
   FDest.Add('	}');
FDest.Add('// -->');
   FDest.Add('</script>');
   end;
   { Add Style Table}
   if not useJS then
   AddStyleTable(FDest)
   else
   begin
   FStyle:=TStringList.create;
      AddStyletable(FSTyle);
   FStyle.savetofile('style.css');
   FSTyle.free;
   FDest.add('<LINK rel="stylesheet" type="text/css" href="style.css">');
   end;
   headers:=TStringList.create;
   PIDFlag:='<P ID=';
   PIDEnd:='</P>';
   FDest.Add('</HEAD>');   
    FDest.Add('<BODY>');
   { Convert FSource }
   ic:=FSource.Count-1;
   tablemode:=false;
   for i:=1 to ic do
     begin
      s:=FSource.Strings[i];
       if s='<TABLE>' then begin  tablemode:=true;continue; end;
       if s='</TABLE>' then
       begin
          for j:=stekindtable downto 0 do  {!!!}
     begin                          {!!!}
//       FDest.Add('<BR>');
       if (inspos[stekindtable]<>-1) then
          FDest.Insert(inspos[stekindtable],'</TR>');
       FDest.Add('</TD>'); {temp}
       FDest.Add('</TR>'); {temp}
       FDest.ADD('</TABLE>');       {!!!}
     end;                           {!!!}
   for j:=stekind downto 0 do
     begin
       if ultags[oldtags[i]] then
         FDest.Add('</UL>')
            else
         FDest.Add('</OL>');
     end;
        stekindtable:=-1;
        stekind:=-1;
        PIDFlag:='<P ID=';
        PIDEnd:='</P>';
        tablemode:=false;continue;
        end;
       parafont:=True;
       slashp:=True;
       ttts:=Trim(s);
       if length(ttts)>0 then
       begin
       res:=GetParaID(s,l,ind);
        l:=trim(l);
      // if l='' then l:='&nbsp;';
       if (ind=MIDSubHeader) or (ind=MIDRazdel) then
         begin
           FOldColumnEnabled:=False;
         end;
       if (razdl<>nil) and(ind=MIDSubHeader) then
             begin
             FDest.add('<a NAME="RAZDEL'+inttostr(i)+'"></a>');
             razdl.addObject(copy(trim(FSource.Strings[i]),3,length(trim(FSource.Strings[i]))),TObject(i));
             end;
       FOldColumnEnabled:=False;
       isheader:=Tabletag[ind]=0;
       if isheader and tablemode then
       begin
       repeat
       sn:=STNewName[ind];
       ss:=IDToStyle(ind);
       if FShowSystemChars then l:=systemchars[ind]+l;
       headers.add(Parastring(ind,l));
       next:=GetFontID(s,l,ind);
       until  not next;
       end
       else
       while res do
        begin
          if parafont then
            begin
             sn:=STNewName[ind];
             ss:=IDToStyle(ind);
             astr:='';//GetAlignString(FTextAlign,FVerticalAlign);
              FIsNumber:=IsNumber(l);
              FIsLevel:=((ind>=MIDLevel1) and (ind<=MIDLevel15) or
                      (ind>=MIDPrjLevel1) and (ind<=MIDPrjLevel14)or
                      (ind>=MIDObrPrj1) and (ind<=MIDObrPrj15))and
                      FStyle2Column and (GetNotLevelstring(l)<>'');
             { Tag Table order  !!!}
             newtabletag:=TableTag[ind];
             if (stekindtable>=0) and (stekindtable<=63) then
              begin
                { Closing Table tags }
                if (((newtabletag>oldtabletags[stekindtable])or
                 (newtabletag=oldtabletags[stekindtable])and(headers.count>0))and
                    (tagstable[oldtabletags[stekindtable]])) then
                 begin
                  if (inspos[stekindtable]<>-1) then
                   begin
                     FDest.Insert(inspos[stekindtable],'</TR>');
                     inspos[stekindtable]:=-1;
                   end;
                   if (newtabletag=oldtabletags[stekindtable])and(headers.count>0)
                               then
                                       begin
                  FDest.Add('</TD>');
                  FDest.Add('</TR>');
                  FDest.Add('</TABLE>');
                  tagstable[oldtabletags[stekindtable]]:=False;
                  flagfr[stekindtable]:=False;
                  ncols[stekindtable]:=0;
                  ncolsf[stekindtable]:=0;
                  trflags[lod]:=false;
                  tdflags[lod]:=false;
                  dec(lod);
                  dec(stekindtable);
                  end
                     else
                   while (stekindtable>=0)and(newtabletag>oldtabletags[stekindtable]) do
                   begin
                  FDest.Add('</TD>');
                  FDest.Add('</TR>');
                  FDest.Add('</TABLE>');
                  tagstable[oldtabletags[stekindtable]]:=False;
                  flagfr[stekindtable]:=False;
                  ncols[stekindtable]:=0;
                  ncolsf[stekindtable]:=0;
                  trflags[lod]:=false;
                  tdflags[lod]:=false;
                  dec(lod);
                  dec(stekindtable);
                  end;
                  if stekindtable<0 then begin PIDFlag:='<P ID=';PIDEnd:='</P>';end;
                 FOldColumnEnabled:=False;
                 end;
              end;
             { Start Tag TD order !!! }
             { End Tag TD order !!! }
             if ((not(tagstable[newtabletag])) and FTableEnabled) then
                 begin
                   if ((lod>0)  and FOldColumnEnabled) then
                    begin
                     Fdest.add('</TD>');
                     if stekindtable>0 then
                     FDest.ADD('<TD WIDTH="'+IntToStr(FColumnWidth)+'%" BGCOLOR='+FBgColor+' '+astr+'>')
                     else
                     FDest.ADD('<TD BGCOLOR='+FBgColor+' '+astr+'>');
                    end
                    else if  (stekindtable>=0)and afterheader then begin
                    fdest.Delete(fdest.count-1);
//                    fdest.Delete(fdest.count-1);
                         end;
                    afterheader:=false;     
                                        for j:=0 to headers.count-1 do fdest.add(headers[j]);
                    headers.clear;
                   st:='<TABLE ';
                   if (stekindtable>=0) then st:=st+' HEIGHT="100%"';
                   if (stekindtable>=0) then st:=st+' WIDTH="100%"';
                   case FBorderEnabled of
                    False: st:=st+' BORDER=0';
                    True:  st:=st+' BORDER=1';
                   end;
                   st:=st+' BGCOLOR='+FBgColor;
                   st:=st+' CELLSPACING=0 CELLPADDING=0';
                   st:=st+'>';
                   FDest.ADD(st);
                   if FEnableHeader then
                    begin
                    if (StekindTable>=0) then
                     begin
                       if FShowColumnHeaderAtLevel2 then
                        begin
                          inspos[stekindtable+1]:=FDest.ADD('<TR>');
                          FDest.Insert(inspos[stekindtable+1],'<TR>');
                          inspos[stekindtable+1]:=inspos[stekindtable+1]+1;
                        end else FDest.ADD('<TR>');
                     end
                    else
                     begin
                      inspos[stekindtable+1]:=FDest.ADD('<TR>');
                      FDest.Insert(inspos[stekindtable+1],'<TR>');
                      inspos[stekindtable+1]:=inspos[stekindtable+1]+1;
                     end;
                    end
                   else
                     FDest.ADD('<TR>');
                   if fIslevel then
                     begin
                       if stekindtable>=0 then
                       FDest.ADD('<TD WIDTH="'+IntToStr(FFirstColumnWidth)+'%" BGCOLOR='+FBgColor+' '+astr+'>')
                       else
                       FDest.ADD('<TD BGCOLOR='+FBgColor+' '+astr+'>'); {temp}
                     end
                  else
                   begin
                   if stekindtable>0 then
                   FDest.ADD('<TD WIDTH="'+IntToStr(FColumnWidth)+'%" BGCOLOR='+FBgColor+' '+astr+'>')
                   else
                   FDest.ADD('<TD  BGCOLOR='+FBgColor+' '+astr+'>'); {temp}
                   end;
                   tagstable[newtabletag]:=True;
                   inc(stekindtable);
                   PIDFlag:='<FONT ID=';PIDEnd:='</FONT>';
                   flagfr[stekindtable]:=True;
                   ncols[stekindtable]:=0;
                   ncolsf[stekindtable]:=0;
                   inc(lod);
                   trflags[lod]:=true;
                   tdflags[lod]:=true;
                   oldtabletags[stekindtable]:=newtabletag;
                   firstpasstr:=false;
                 end;

             { End Tag Table order !!! }
             { Start Tag  TR order !!! }
             if (FRowEnabled  and (trflags[lod])) then
                 begin
                   if firstpasstr then
                   begin
                     flagfr[stekindtable]:=false;
                     ncols[stekindtable]:=0;
               //     FDest.ADD('<BR>');
                    FDest.ADD('</TD>'); {temp}
                    FDest.ADD('</TR>');
                    FDest.ADD('<TR>');
                 if fIsLevel then
                   begin
                       if stekindtable>0 then
                       FDest.ADD('<TD WIDTH="'+IntToStr(FFirstColumnWidth)+'%" BGCOLOR='+FBgColor+' '+astr+'>')
                       else
                       FDest.ADD('<TD  BGCOLOR='+FBgColor+' '+astr+'>');
                     end
                  else
                   begin
                   if stekindtable>0 then
                    FDest.ADD('<TD WIDTH="'+IntToStr(FColumnWidth)+'%" BGCOLOR='+FBgColor+' '+astr+'>')
                    else
                    FDest.ADD('<TD  BGCOLOR='+FBgColor+' '+astr+'>'); {temp}
                    end;
                //    FDest.ADD('<BR>');
                   end
                   else
                    firstpasstr:=true;
                   tdflags[lod]:=True;
                 end;
             { End Tag TR order !!! }
             if (FColumnEnabled and (not(FRowEnabled)) and (not(FTableEnabled))
                   and (tdflags[lod])) then
                  begin
                    FDest.ADD('</TD>'); {temp}
                    if stekindtable>0 then
                    FDest.ADD('<TD WIDTH="'+IntToStr(FColumnWidth)+'%" BGCOLOR='+FBgColor+' '+astr+'>')
                    else
                    FDest.ADD('<TD  BGCOLOR='+FBgColor+' '+astr+'>'); {temp}
                  end;
             newtag:=LTag[ind];
             if ((stekind>=0) and (stekind<=63)) then
             begin
             if ((newtag>Ltag[oldtags[stekind]]) and (tags[oldtags[stekind]])) then
                begin
                  if ultags[oldtags[stekind]] then
                   FDest.Add('</UL>')
                  else
                   FDest.Add('</OL>');
                  tags[oldtags[stekind]]:=False;
                  dec(stekind);
                end;
             end;
             if (not(tags[ind])) and FLSEnabled then
                begin
                  if FUL then
                   FDest.Add('<UL>')
                  else
                   FDest.Add('<OL>');
                  ultags[ind]:=FUL;
                  tags[ind]:=True;
                  inc(stekind); {!!!}
                  oldtags[stekind]:=ind;
                end;

             if (ind<>MIDPrjHeader)or not tablemode then
             if usejs  then
             FDest.Add(PIDFlag+sn+MouseEvent(ss)+'>')
             else
             FDest.Add(PIDFlag+sn+'>');
             if FLSEnabled then
                  FDest.Add('<LI ID='+sn+'>'+l)
               else
              begin
                 if fislevel then
                    begin
                   nlevs:=l;
                   levs:=getNotLevelString(nlevs);

                   nlevs:=copy(trim(nlevs),length(levs)+1,length(nlevs));
                   nlevsl:=Length(nlevs);
                   levs:=Trim(levs);
                   nlevs:=trim(nlevs);
                   //if nlevs='' then nlevs:='&nbsp;';
                   if fshowsystemchars then levs:=systemchars[ind]+levs;
                   if levs<>'0.' then
                   begin
                    FDest.Add(levs)
                   end
                   else
                   FDest.add('&nbsp;');
                   FDest.Add(PIDEnd);
                   FDest.Add('</TD>');
                   if stekindtable>0 then
                   FDest.ADD('<TD WIDTH="'+IntToStr(FColumnWidth)+'%" BGCOLOR='+FBgColor+' '+astr+'>')
                   else
                   FDest.ADD('<TD BGCOLOR='+FBgColor+' '+astr+'>'); {temp}
                   if useJS  then
                   FDest.Add(PIDFlag+sn+Mouseevent(ss)+'>')
                   else
                    FDest.Add(PIDFlag+sn+'>');
nlevs:=processlink(nlevs,false);
FDest.Add(nlevs);
                   ncols[stekindtable]:=ncols[stekindtable]+2;
                   if FEnable2Header and (flagfr[stekindtable] or (ncolsf[stekindtable]<ncols[stekindtable])) then
                       begin
                         if (((stekindtable>0) and FShowColumnHeaderAtLevel2) or
                            (stekindtable=0)) then
                         begin
                         headerline:=f2headerline;
                         IDToStyle(MIDColumnHeader);
                         if stekindtable>0 then
                         FDest.Insert(inspos[stekindtable],'<TD ALIGN=CENTER VALIGN=MIDDLE BGCOLOR='+FBgColor+' HEIGHT='+IntToStr(FHeaderHeight)+' WIDTH="'+IntToStr(FFirstColumnWidth)+'%">')
                         else
                         FDest.Insert(inspos[stekindtable],'<TD ALIGN=CENTER VALIGN=MIDDLE BGCOLOR='+FBgColor+' HEIGHT='+IntToStr(FHeaderHeight)+'>');
                         if useJS  then
                         FDest.Insert(inspos[stekindtable]+1,'<FONT ID=COLUMN_HEADER'+Mouseevent(' ')+'>')
                         else
                         FDest.Insert(inspos[stekindtable]+1,'<FONT ID=COLUMN_HEADER>');

                         if not(flagfr[stekindtable]) then
                          FDest.Insert(inspos[stekindtable]+2,levs)
                         else
                         FDest.Insert(inspos[stekindtable]+2,HeaderLine);
                         FDest.Insert(inspos[stekindtable]+3,'</FONT>');
                         FDest.Insert(inspos[stekindtable]+4,'</TD>');
                         inspos[stekindtable]:=inspos[stekindtable]+5;
                         ncolsf[stekindtable]:=ncolsf[stekindtable]+1;
                         IDToStyle(ind);
                         end;
                     end;
                   if FEnableHeader and (flagfr[stekindtable] or (ncolsf[stekindtable]<ncols[stekindtable])) then
                     begin
                      if (((stekindtable>0) and FShowColumnHeaderAtLevel2) or
                            (stekindtable=0)) then
                         begin
                      headerline:=fheaderline;
                      IDToStyle(MIDColumnHeader);
                      if stekindtable>0 then
                      FDest.Insert(inspos[stekindtable],'<TD ALIGN=CENTER VALIGN=MIDDLE BGCOLOR='+FBgColor+' HEIGHT='+IntToStr(FHeaderHeight)+' WIDTH="'+IntToStr(FColumnWidth)+'%">')
                      else
                      FDest.Insert(inspos[stekindtable],'<TD ALIGN=CENTER VALIGN=MIDDLE BGCOLOR='+FBgColor+' HEIGHT='+IntToStr(FHeaderHeight)+'>');
                      if usejs  then
                      FDest.Insert(inspos[stekindtable]+1,'<FONT ID=COLUMN_HEADER'+Mouseevent(' ')+'>')
                      else
                      FDest.Insert(inspos[stekindtable]+1,'<FONT ID=COLUMN_HEADER>');
                      if not(flagfr[stekindtable]) then
                          FDest.Insert(inspos[stekindtable]+2,nlevs)
                      else
                       if ((ind>=MIDLevel1) and (ind<MIDPrjHeader)) or
                          ((ind>=MIDPrjLevel1) and (ind<MIDSubHeader)) then
                       FDest.Insert(inspos[stekindtable]+2,oldcolstr)
                      else
                      FDest.Insert(inspos[stekindtable]+2,HeaderLine);
                      FDest.Insert(inspos[stekindtable]+3,'</FONT>');
                      FDest.Insert(inspos[stekindtable]+4,'</TD>');
                      inspos[stekindtable]:=inspos[stekindtable]+5;
                      ncolsf[stekindtable]:=ncolsf[stekindtable]+1;
                      IDToStyle(ind);
                         end;
                      end;
                 end
                  else
                   begin
                  nlevs:=l;
                   levs:=getNotLevelString(nlevs);
                   nlevs:=copy(trim(nlevs),length(levs)+1,length(nlevs));
                   nlevsl:=Length(nlevs);
                   levs:=Trim(levs);
                   nlevs:=trim(nlevs);
                   if fshowsystemchars then levs:=systemchars[ind]+levs;
                   l:=(nlevs);
                   l:=trim(levs+' '+l);
                   if (ind<>MIDPrjHeader)or not tablemode then FDest.Add(l)
                                                          else
                                                          begin
                                                          FDest.add('&nbsp;');
                                                          afterheader:=true;
                                                          end;
                   ncols[stekindtable]:=ncols[stekindtable]+1;
                   if FEnableHeader and (flagfr[stekindtable] or (ncolsf[stekindtable]<ncols[stekindtable])) then
                     begin
                     if (((stekindtable>0) and FShowColumnHeaderAtLevel2) or
                            (stekindtable=0)) then
                         begin
                      headerline:=fheaderline;
                      IDToStyle(MIDColumnHeader);
                      if stekindtable>0 then
                      FDest.Insert(inspos[stekindtable],'<TD ALIGN=CENTER VALIGN=MIDDLE BGCOLOR='+FBgColor+' HEIGHT='+IntToStr(FHeaderHeight)+' WIDTH="'+IntToStr(FColumnWidth)+'%">')
                      else
                      FDest.Insert(inspos[stekindtable],'<TD ALIGN=CENTER VALIGN=MIDDLE BGCOLOR='+FBgColor+' HEIGHT='+IntToStr(FHeaderHeight)+'>');
                      if usejs  then
                      FDest.Insert(inspos[stekindtable]+1,'<FONT ID=COLUMN_HEADER'+Mouseevent(' ')+'>')
                      else
                      FDest.Insert(inspos[stekindtable]+1,'<FONT ID=COLUMN_HEADER>');
                      if ((not(flagfr[stekindtable])) or (ind=MIDPrjHeader)and(tablemode)) then
                         begin
                          FDest.Insert(inspos[stekindtable]+2,l);
                          slashp:=false;
                         end
                         else
                       if ((ind>=MIDLevel1) and (ind<MIDPrjHeader)) or
                          ((ind>=MIDPrjLevel1) and (ind<MIDSubHeader)) then
                       FDest.Insert(inspos[stekindtable]+2,oldcolstr)
                      else
                      FDest.Insert(inspos[stekindtable]+2,HeaderLine);
                      FDest.Insert(inspos[stekindtable]+3,'</FONT>');
                      FDest.Insert(inspos[stekindtable]+4,'</TD>');
                      inspos[stekindtable]:=inspos[stekindtable]+5;
                      ncolsf[stekindtable]:=ncolsf[stekindtable]+1;
                      IDToStyle(ind);
                        end;
                      end;
                   end;

              end;
             parafont:=False;
             FOldColumnEnabled:=FColumnEnabled;
            end
           else
            begin
             ss:=IDToStyle(ind);
             { Start Tag TD order !!! }
             astr:='';//GetAlignString(FTextAlign,FVerticalAlign);
             if (ind=MIDSecondLine) then
               begin
                 FIsDate:=IsDate(l);
               end else FIsDate:=False;
             if (FColumnEnabled and (tdflags[lod])) then
              begin
                 //  FDest.ADD('<BR>');
                     if slashp then FDest.Add(PidEnd);
                     slashp:=False;
                     FDest.ADD('</TD>'); {temp}
                   if FStyle2Column and FIsDate then
                     FDest.ADD('<TD WIDTH="'+IntToStr(FFirstColumnWidth)+'%" BGCOLOR='+FBgColor+' '+astr+'>')
                    else
                     FDest.ADD('<TD WIDTH="'+IntToStr(FColumnWidth)+'%" BGCOLOR='+FBgColor+' '+astr+'>'); {temp}
                //   FDest.ADD('<BR>');
               end;
             { End Tag TD order !!! }
             if FColumnEnabled then
              begin
               if FIsDate and FStyle2Column then
                 begin
                  nlevs:=GetFirstDate(l);
                  levs:=GetSecondDate(l);
                  if usejs  then
                  FDest.Add(PIDFlag+IDToCSSName(ind)+Mouseevent(ss)+'>')
                  else
                  FDest.Add(PIDFlag+IDtoCSSName(ind)+'>');
                  FDest.Add(nlevs);
                  FDest.Add(PIDEnd);
                  FDest.ADD('</TD>');
                  if stekindtable>0 then
                  FDest.ADD('<TD WIDTH="'+IntToStr(FColumnWidth)+'%" BGCOLOR='+FBgColor+' '+astr+'>')
                  else
                  FDest.ADD('<TD BGCOLOR='+FBgColor+' '+astr+'>'); {temp}
                  if usejs  then
                  FDest.Add(PIDFlag+IDtoCSSName(ind)+Mouseevent(ss)+'>')
                  else
                  FDest.Add(PIDFlag+IDtoCSSName(ind)+'>');
                  FDest.Add(levs);
                  FDest.Add(PIDEnd);
                  ncols[stekindtable]:=ncols[stekindtable]+2;
                   if FEnable2Header and (flagfr[stekindtable] or (ncolsf[stekindtable]<ncols[stekindtable])) then
                       begin
                        if (((stekindtable>0) and FShowColumnHeaderAtLevel2) or
                            (stekindtable=0)) then
                         begin
                         headerline:=fheaderline;
                         IDToStyle(MIDColumnHeader);
                       if stekindtable>0 then
                       FDest.Insert(inspos[stekindtable],'<TD ALIGN=CENTER VALIGN=MIDDLE BGCOLOR='+FBgColor+' HEIGHT='+IntToStr(FHeaderHeight)+' WIDTH="'+IntToStr(FFirstColumnWidth)+'%">')
                       else
                       FDest.Insert(inspos[stekindtable],'<TD ALIGN=CENTER VALIGN=MIDDLE BGCOLOR='+FBgColor+' HEIGHT='+IntToStr(FHeaderHeight)+'>');
                         if usejs  then
                         FDest.Insert(inspos[stekindtable]+1,'<FONT ID=COLUMN_HEADER'+Mouseevent(' ')+'>')
                         else
                         FDest.Insert(inspos[stekindtable]+1,'<FONT ID=COLUMN_HEADER>');
                         if not(flagfr[stekindtable]) then
                          FDest.Insert(inspos[stekindtable]+2,nlevs)
                         else
                         FDest.Insert(inspos[stekindtable]+2,f2HeaderLine);
                         FDest.Insert(inspos[stekindtable]+3,'</FONT>');
                         FDest.Insert(inspos[stekindtable]+4,'</TD>');
                         inspos[stekindtable]:=inspos[stekindtable]+5;
                         ncolsf[stekindtable]:=ncolsf[stekindtable]+1;
                         IDToStyle(ind);
                         end;
                     end;
                   if FEnableHeader and (flagfr[stekindtable] or (ncolsf[stekindtable]<ncols[stekindtable])) then
                     begin
                      if (((stekindtable>0) and FShowColumnHeaderAtLevel2) or
                            (stekindtable=0)) then
                         begin
                         headerline:=fheaderline;
                         IDToStyle(MIDColumnHeader);
                      if stekindtable>0 then
                      FDest.Insert(inspos[stekindtable],'<TD ALIGN=CENTER VALIGN=MIDDLE BGCOLOR='+FBgColor+' HEIGHT='+IntToStr(FHeaderHeight)+' WIDTH="'+IntToStr(FColumnWidth)+'%">')
                      else
                      FDest.Insert(inspos[stekindtable],'<TD ALIGN=CENTER VALIGN=MIDDLE BGCOLOR='+FBgColor+' HEIGHT='+IntToStr(FHeaderHeight)+'>');
                      if usejs  then
                      FDest.Insert(inspos[stekindtable]+1,'<FONT ID=COLUMN_HEADER'+Mouseevent(' ')+'>')
                      else
                      FDest.Insert(inspos[stekindtable]+1,'<FONT ID=COLUMN_HEADER>');
                      if not(flagfr[stekindtable]) then
                          FDest.Insert(inspos[stekindtable]+2,levs)
                         else
                      FDest.Insert(inspos[stekindtable]+2,HeaderLine);
                      FDest.Insert(inspos[stekindtable]+3,'</FONT>');
                      FDest.Insert(inspos[stekindtable]+4,'</TD>');
                      inspos[stekindtable]:=inspos[stekindtable]+5;
                      ncolsf[stekindtable]:=ncolsf[stekindtable]+1;
                      IDToStyle(ind);
                         end;
                      end;
                 end
               else
                begin
                nlevs:=processlink(l,fshowsystemchars);
                if usejs  then
                 FDest.Add(PIDFlag+IDtoCSSName(ind)+Mouseevent(ss)+'>')
                 else
                 FDest.Add(PIDFlag+IDtoCSSName(ind)+'>');
                 FDest.Add(nlevs);
                  FDest.Add(PIDEND);
                 ncols[stekindtable]:=ncols[stekindtable]+1;
                   if FEnableHeader and (flagfr[stekindtable] or (ncolsf[stekindtable]<ncols[stekindtable])) then
                     begin
                     if (((stekindtable>0) and FShowColumnHeaderAtLevel2) or
                            (stekindtable=0)) then
                         begin
                         headerline:=fheaderline;
                         IDToStyle(MIDColumnHeader);
                      if stekindtable>0 then
                      FDest.Insert(inspos[stekindtable],'<TD ALIGN=CENTER VALIGN=MIDDLE BGCOLOR='+FBgColor+' HEIGHT='+IntToStr(FHeaderHeight)+' WIDTH="'+IntToStr(FColumnWidth)+'%">')
                      else
                      FDest.Insert(inspos[stekindtable],'<TD ALIGN=CENTER VALIGN=MIDDLE BGCOLOR='+FBgColor+' HEIGHT='+IntToStr(FHeaderHeight)+'>');
                      if usejs  then
                      FDest.Insert(inspos[stekindtable]+1,'<FONT ID=COLUMN_HEADER'+Mouseevent(' ')+'>')
                      else
                      FDest.Insert(inspos[stekindtable]+1,'<FONT ID=COLUMN_HEADER>');
                      if not(flagfr[stekindtable]) then
                          FDest.Insert(inspos[stekindtable]+2,l)
                         else
                      if (ind=MIDSecondLine) then
                      FDest.Insert(inspos[stekindtable]+2,SLScale)
                      else
                      FDest.Insert(inspos[stekindtable]+2,HeaderLine);
                      FDest.Insert(inspos[stekindtable]+3,'</FONT>');
                      FDest.Insert(inspos[stekindtable]+4,'</TD>');
                      inspos[stekindtable]:=inspos[stekindtable]+5;
                      ncolsf[stekindtable]:=ncolsf[stekindtable]+1;
                      IDToStyle(ind);
                         end;
                      end;
                end;
              end
              else
              begin
               slashp:=True;
               if usejs  then
               FDest.Add('<FONT ID='+IDtoCSSName(ind)+MouseEvent(ss)+'>')
               else
               FDest.Add('<FONT ID='+IDtoCSSName(ind)+'>');
               l:=processlink(l,fshowsystemchars);//fshowsystemchars
               FDest.Add(l);
               FDest.Add('</FONT>');
              end;
            end;
          oldcolstr:=l;
          res:=GetFontID(s,l,ind);
           l:=trim(l);
          if tablemode and(ind=MIDprjdetail) then delete(l,1,1);
          //if l='' then l:='&nbsp;';
        end;
        if slashp and (not isheader and (ind<>MIDPRJHeader)or not tablemode) then FDest.Add(PIDEnd);
      end;
     end;
   for i:=stekindtable downto 0 do  {!!!}
     begin                          {!!!}
//       FDest.Add('<BR>');
       if (inspos[stekindtable]<>-1) then
          FDest.Insert(inspos[stekindtable],'</TR>');
       FDest.Add('</TD>'); {temp}
       FDest.Add('</TR>'); {temp}
       FDest.ADD('</TABLE>');       {!!!}
     end;                           {!!!}
   for i:=stekind downto 0 do
     begin
       if ultags[oldtags[i]] then
         FDest.Add('</UL>')
            else
         FDest.Add('</OL>');
     end;
   FDest.Add('</BODY>');
   FDest.Add('</HTML>');
   headers.free;
 end;


procedure   TTxtToHtmlConverter.OpenFile(FileName:String;razdl:TStrings;useJS:boolean);
 begin
  Clear;
  FSource.LoadFromFile(FileName);
  FStream.OpenStream(FCSSFileName,stRead);
  FStream.ReadStream(FRoot);
  FStream.CloseStream;
  Convert(razdl,useJS);
  FDest.SaveToFile(ExtractFilePath(Application.ExeName)+'tst.htm');
 end;

procedure   TTxtToHtmlConverter.SaveFile(FileName:String);
 begin
   FDest.SaveToFile(FileName);
 end;
Procedure   TTxtToHtmlConverter.SaveToWORD;
var i,id:integer;
    wordDoc:TWordDocument;
    parastart:Olevariant;
begin
worddoc:=TWordDocument.create(nil);
try
 for i:=0 to fsource.count-1 do
 begin
 if (fsource[i]='<TABLE>') then id:=1
 else if (fsource[i]='</TABLE>') then id:=2
 else WordDoc.range(parastart).text:=trim(fsource[i]);
 WordDoc.Select;
 end;
 worddoc.SaveAs;
finally
worddoc.free;
end;
end;
end.
