unit PageSetupFormUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, dxPrint;

type
  TPageSetupForm = class(TForm)
    GroupBox1: TGroupBox;
    LeftEdit: TSpinEdit;
    RightEdit: TSpinEdit;
    TopEdit: TSpinEdit;
    BottomEdit: TSpinEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    OKButton: TButton;
    CancelButton: TButton;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Button1: TButton;
    ListBox1: TListBox;
    procedure CancelButtonClick(Sender: TObject);
    procedure OKButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DefaultButtonClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ListBox1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure Execute;
  end;

var
  PageSetupForm: TPageSetupForm;

implementation

uses MainFormUnit, DebugUnit;

{$R *.DFM}

procedure TPageSetupForm.Execute;
Var i,j:Integer;
 begin
  LeftEdit.Value:=MainForm.FPageLeft;
  RightEdit.Value:=MainForm.FPageRight;
  TopEdit.Value:=MainForm.FPageTop;
  BottomEdit.Value:=MainForm.FPageBottom;
  ListBox1.Clear;
  ListBox1.Items:=dxPrintDevice.Papers;
{  for i:=0 to ListBox1.Items.Count-1 do
    begin
      if :=(ListBox1.Items.Strings[i]);
      if j=i then ListBox1.Selected[i]:=True;
    end;}
  if dxPrintDevice.Orientation=poPortrait then
     RadioButton1.Checked:=True
  else
     RadioBUtton2.Checked:=True;
  SHowModal;
  if RadioButton1.Checked then
     dxPrintDevice.Orientation:=poPortrait
  else
     dxPrintDevice.Orientation:=poLandscape;
 end;

procedure TPageSetupForm.CancelButtonClick(Sender: TObject);
begin
 try
  ModalResult:=mrCancel;
 except
  on E:Exception do WriteLog('TPageSetupForm:CancelButtonClick',E);
 end;
end;

procedure TPageSetupForm.OKButtonClick(Sender: TObject);
begin
 try
 MainForm.FPageLeft:=LeftEdit.Value;
 MainForm.FPageRight:=RightEdit.Value;
 MainForm.FPageTop:=TopEdit.Value;
 MainForm.FPageBottom:=BottomEdit.Value;
 MainForm.CustomOrgChart1.SetPageParam(MainForm.FPageTop,MainForm.FPageBottom,
 MainForm.FPageLeft,MainForm.FPageRight);
 ModalResult:=mrOK;
 except
  on E:Exception do WriteLog('TPageSetupForm:OKButtonClick',E);
 end;
end;

procedure TPageSetupForm.FormCreate(Sender: TObject);
begin
 try
  LeftEdit.Value:=MainForm.FPageLeft;
  RightEdit.Value:=MainForm.FPageRight;
  TopEdit.Value:=MainForm.FPageTop;
  BottomEdit.Value:=MainForm.FPageBottom;
 except
  on E:Exception do WriteLog('TPageSetupForm:FormCreate',E);
 end;
end;

procedure TPageSetupForm.DefaultButtonClick(Sender: TObject);
begin
 try
  LeftEdit.Value:=25;
  RightEdit.Value:=20;
  TopEdit.Value:=20;
  BottomEdit.Value:=20;
 except
  on E:Exception do WriteLog('TPageSetupForm:DefaultButtonClick',E);
 end;
end;

procedure TPageSetupForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
 try
{ Action:=caFree;}
 except
  on E:Exception do
   begin
    WriteLog('TPageSetupForm:FormClose',E);
    Action:=caFree;
   end;
 end;
end;

procedure TPageSetupForm.ListBox1Click(Sender: TObject);
var ind:Integer;
begin
  Ind := TListBox(Sender).ItemIndex;
  dxPrintDevice.PaperIndex:=TdxPaperInfo(dxPrintDevice.Papers.Objects[Ind]).DMPaper;
{  dxPrintDevice.SelectPaper(ind);
  dxPrintDevice.Refresh;          }
    { dxPrintDevice.SelectPaper(i);}
end;

end.
