unit SetupLevelsFormUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Spin, Buttons, RXCtrls,OrgChart,Printers, ComCtrls,
  fcLabel, fcCombo, fcColorCombo;

type
  TLevelSetupForm = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Panel1: TPanel;
    GroupBox1: TGroupBox;
    LevelComboBox: TComboBox;
    useToAll: TCheckBox;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    GroupBox2: TGroupBox;
    FontSize: TComboBox;
    FontName: TComboBox;
    CBold: TCheckBox;
    CItalic: TCheckBox;
    CUnderline: TCheckBox;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    GroupBox3: TGroupBox;
    rNone: TSpeedButton;
    r1x: TSpeedButton;
    r2x: TSpeedButton;
    r3x: TSpeedButton;
    r4x: TSpeedButton;
    r2x3: TSpeedButton;
    r2x4: TSpeedButton;
    r2x5: TSpeedButton;
    r3x2: TSpeedButton;
    r4x2: TSpeedButton;
    r5x2: TSpeedButton;
    lsSolid: TSpeedButton;
    lsDot: TSpeedButton;
    lsDashDot: TSpeedButton;
    GroupBox4: TGroupBox;
    sNone: TSpeedButton;
    sLeftFramed: TSpeedButton;
    sLeftBoxed: TSpeedButton;
    sRightFramed: TSpeedButton;
    sRightBoxed: TSpeedButton;
    sBottom: TSpeedButton;
    sTop: TSpeedButton;
    sInverse: TSpeedButton;
    ShadowDepth: TSpinEdit;
    TabSheet4: TTabSheet;
    TabSheet5: TTabSheet;
    GroupBox7: TGroupBox;
    ssHTree: TSpeedButton;
    ssVTree: TSpeedButton;
    GroupBox6: TGroupBox;
    HInterval: TSpinEdit;
    VInterval: TSpinEdit;
    GroupBox8: TGroupBox;
    LineDepth: TSpinEdit;
    GroupBox10: TGroupBox;
    NumbersOnly: TCheckBox;
    NoControlChar: TCheckBox;
    TabSheet6: TTabSheet;
    GroupBox5: TGroupBox;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    DefWidth: TSpinEdit;
    DefHeight: TSpinEdit;
    HSpacing: TSpinEdit;
    VSpacing: TSpinEdit;
    GroupBox11: TGroupBox;
    VAlign: TRadioGroup;
    HAlign: TRadioGroup;
    GroupBox9: TGroupBox;
    PrjFontName: TComboBox;
    PrjFontSize: TComboBox;
    PrjBold: TCheckBox;
    PrjItalic: TCheckBox;
    PrjUnderline: TCheckBox;
    fcLabel1: TfcLabel;
    fcLabel2: TfcLabel;
    fcLabel3: TfcLabel;
    fcLabel4: TfcLabel;
    fcLabel5: TfcLabel;
    fcLabel6: TfcLabel;
    fcLabel7: TfcLabel;
    fcLabel8: TfcLabel;
    fcLabel9: TfcLabel;
    fcLabel10: TfcLabel;
    fcLabel11: TfcLabel;
    fcLabel12: TfcLabel;
    fcLabel13: TfcLabel;
    fcLabel14: TfcLabel;
    fcLabel15: TfcLabel;
    fcLabel16: TfcLabel;
    FontColor: TfcColorCombo;
    PaintColor: TfcColorCombo;
    ColorDialog1: TColorDialog;
    PrjFontColor: TfcColorCombo;
    DrawColor: TfcColorCombo;
    ShadowColor: TfcColorCombo;
    LineColor: TfcColorCombo;
    Button3: TButton;
    procedure LevelComboBoxChange(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FontNameChange(Sender: TObject);
    procedure FontSizeChange(Sender: TObject);
    procedure FontColorChange(Sender: TObject);
    procedure PaintColorChange(Sender: TObject);
    procedure rectTypeChange(Sender: TObject);
    procedure DrawColorChange(Sender: TObject);
    procedure lineStyleChange(Sender: TObject);
    procedure shadowChange(Sender: TObject);
    procedure ShadowColorChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DefWidthChange(Sender: TObject);
    procedure DefHeightChange(Sender: TObject);
    procedure HSpacingChange(Sender: TObject);
    procedure VSpacingChange(Sender: TObject);
    procedure HIntervalChange(Sender: TObject);
    procedure VIntervalChange(Sender: TObject);
    procedure VAlignClick(Sender: TObject);
    procedure HAlignClick(Sender: TObject);
    procedure strategyChange(Sender: TObject);
    procedure ShadowDepthChange(Sender: TObject);
    procedure LineColorChange(Sender: TObject);
    procedure CBoldClick(Sender: TObject);
    procedure CItalicClick(Sender: TObject);
    procedure CUnderlineClick(Sender: TObject);
    procedure LineDepthChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure PrjFontNameChange(Sender: TObject);
    procedure PrjFontSizeChange(Sender: TObject);
    procedure PrjBoldClick(Sender: TObject);
    procedure PrjItalicClick(Sender: TObject);
    procedure PrjUnderlineClick(Sender: TObject);
    procedure PrjFontColorChange(Sender: TObject);
    procedure NoControlCharClick(Sender: TObject);
    procedure NumbersOnlyClick(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    Levels:Array[0..10] of TOrgLevel;
    CurLevel:Integer;
    DPMratio:Double;
  public
    { Public declarations }
  end;

var
  LevelSetupForm: TLevelSetupForm;

implementation

uses MainFormUnit, FileNameUnit, DebugUnit, SelAFTableDlgUnit;

{$R *.DFM}

procedure TLevelSetupForm.LevelComboBoxChange(Sender: TObject);
Var i:Integer;
    t:TOrgLevel;
begin
  try
  i:=StrToIntDef(LevelComboBox.Text,0);
  CurLevel:=i;
  t:=Levels[i];
  FontName.Text:=t.FontName;
  FontSize.Text:=IntToStr(t.FontSize);
  FontColor.SelectedColor:=t.FontColor;
  PrjFontName.Text:=t.PrjFontName;
  PrjFontSize.Text:=IntToStr(t.PrjFontSize);
  PrjFontColor.SelectedColor:=t.PrjFontColor;
  PaintColor.SelectedColor:=t.PaintColor;
  case t.RectStyle of
  reNone: rNone.Down:=True;
  re1x:   r1x.Down:=True;
  re2x:   r2x.Down:=True;
  re3x:   r3x.Down:=True;
  re4x:   r4x.Down:=True;
  re2x3:  r2x3.Down:=True;
  re2x4:  r2x4.Down:=True;
  re2x5:  r2x5.Down:=True;
  re3x2:  r3x2.Down:=True;
  re4x2:  r4x2.Down:=True;
  re5x2:  r5x2.Down:=True;
  end;
  DrawColor.SelectedColor:=t.DrawColor;
  case t.LineStyle of
   psSolid: lsSolid.Down:=True;
   psDot:   lsDot.Down:=True;
   psDashDot:  lsDashDot.Down:=True;
  end;
  case t.ShadowType of
   shNone:              sNone.Down:=True;
   shLeftBoxed:         sLeftBoxed.Down:=True;
   shLeftFramed:        sLeftFramed.Down:=True;
   shRightBoxed:        sRightBoxed.Down:=True;
   shRightFramed:       sRightFramed.Down:=True;
   shTopPerspective:    sTop.Down:=True;
   shBottomPerspective: sBottom.Down:=True;
   shInversePerspective: SInverse.Down:=True;
  end;
   ShadowColor.SelectedColor:=t.ShadowColor;
   DefWidth.Value:=t.DefWidth;
   DefHeight.Value:=t.DefHeight;
   VSpacing.Value:=t.VSpacing;
   HSpacing.Value:=t.HSpacing;
   VInterval.Value:=t.VInterval*2;
   HInterval.Value:=t.HInterval*2;
  case t.VAlign of
   taTopJustify:   VAlign.ItemIndex:=0;
   taVCenter:      VAlign.ItemIndex:=1;
   taBottomJustify:  VAlign.ItemIndex:=2;
  end;
  case t.HAlign of
   taLeftJustify:   HAlign.ItemIndex:=0;
   taCenter:        HAlign.ItemIndex:=1;
   taRightJustify:  HAlign.ItemIndex:=2;
  end;
  case t.Strategy of
   stHTree:         ssHTree.Down:=True;
   stVTree:         ssVTree.Down:=True;
   else       ssHTree.Down:=True;
  end;
   ShadowDepth.Value:=t.ShadowDepth;
   LineColor.SelectedColor:=t.LineColor;
   if fsBold in t.FontStyle then CBold.Checked:=True
    else CBold.Checked:=False;
   if fsItalic in t.FontStyle then CItalic.Checked:=True
    else CItalic.Checked:=False;
   if fsUnderline in t.FontStyle then CUnderline.Checked:=True
    else CUnderline.Checked:=False;
   if fsBold in t.PrjFontStyle then PrjBold.Checked:=True
    else PrjBold.Checked:=False;
   if fsItalic in t.PrjFontStyle then PrjItalic.Checked:=True
    else PrjItalic.Checked:=False;
   if fsUnderline in t.PrjFontStyle then PrjUnderline.Checked:=True
    else PrjUnderline.Checked:=False;
   LineDepth.Value:=t.LineDepth;
   NoControlChar.Checked:=t.NoControlChar;
   NumbersOnly.Checked:=t.NumbersOnly;
   except
    on E:Exception do WriteLog('TLevelSetupForm:LevelComboBoxChange',E);
   end;
end;

procedure TLevelSetupForm.Button1Click(Sender: TObject);
Var i:Integer;
    bl:Boolean;
    fname:String;
begin
 try
 MainForm.SetAnimation(True);
 for i:=0 to 10 do
  begin
    Levels[i].DefWidth:=Round(Levels[i].DefWidth/DPMRatio);
    Levels[i].DefHeight:=Round(Levels[i].DefHeight/DPMRatio);
    Levels[i].HSpacing:=Round(Levels[i].HSpacing/DPMRatio);
    Levels[i].VSpacing:=Round(Levels[i].VSpacing/DPMRatio);
    Levels[i].HInterval:=Round(Levels[i].HInterval/DPMRatio);
    Levels[i].VInterval:=Round(Levels[i].VInterval/DPMRatio);
    MainForm.CustomOrgChart1.Nodes.Levels[i]:=Levels[i];
  end;
 fname:=GetOChartFName(MainForm.FFileName,'lsa');
 MainForm.CustomOrgChart1.Nodes.SaveLevels(fname);
 MainForm.CustomOrgChart1.Nodes.PreSetupTree(bl);
 MainForm.CustomOrgChart1.Nodes.SetUpTree;
 MainForm.CustomOrgChart1.Repaint;
 MainForm.SetAnimation(False);
 if not(bl) then
    begin
     MainForm.SetAnimation(True);
     MainForm.ConvertButtonClick(self);
     MainForm.Notebook1.ActivePage:='Page2';
     MainForm.PrintButton.Enabled:=True;
     MainForm.PreviewButton.Enabled:=True;
     MainForm.ExportButton.Enabled:=True;
     MainForm.SetAnimation(False);
     close;
    end
  else
   begin
    for i:=0 to 10 do
    begin
     Levels[i].DefWidth:=Round(Levels[i].DefWidth*DPMRatio);
     Levels[i].DefHeight:=Round(Levels[i].DefHeight*DPMRatio);
     Levels[i].HSpacing:=Round(Levels[i].HSpacing*DPMRatio);
     Levels[i].VSpacing:=Round(Levels[i].VSpacing*DPMRatio);
     Levels[i].HInterval:=Round(Levels[i].HInterval*DPMRatio);
     Levels[i].VInterval:=Round(Levels[i].VInterval*DPMRatio);
    end;
   end;
   except
    on E:Exception do
     begin
      MainForm.SetAnimation(False);
      WriteLog('TLevelSetupForm:Button1Click',E);
     end;
   end;
end;

procedure TLevelSetupForm.Button2Click(Sender: TObject);
begin
   try
     close;
   except
    on E:Exception do WriteLog('TLevelSetupForm:Button2Click',E);
   end;
end;

procedure TLevelSetupForm.FontNameChange(Sender: TObject);
Var i:Integer;
begin
 try
 if not(useToAll.Checked) then
 Levels[CurLevel].FontName:=FontName.Text
 else
  for i:=0 to 10 do Levels[i].FontName:=FontName.Text;
 except
  on E:Exception do WriteLog('TLevelSetupForm:FontNameChange',E);
 end;
end;

procedure TLevelSetupForm.FontSizeChange(Sender: TObject);
Var i:Integer;
begin
 try
 if not(useToAll.Checked) then
 Levels[CurLevel].FontSize:=StrToIntDef(FontSize.Text,10)
 else
  for i:=0 to 10 do Levels[i].FontSize:=StrToIntDef(FontSize.Text,10);
 except
  on E:Exception do WriteLog('TLevelSetupForm:FontSizeChange',E);
 end;
end;

procedure TLevelSetupForm.FontColorChange(Sender: TObject);
Var i:Integer;
begin
 try
 if not(useToAll.Checked) then
 Levels[CurLevel].FontColor:=FontColor.SelectedColor
 else
  for i:=0 to 10 do Levels[i].FontColor:=FontColor.SelectedColor;
 except
  on E:Exception do WriteLog('TLevelSetupForm:FontColorChange',E);
 end;
end;

procedure TLevelSetupForm.PaintColorChange(Sender: TObject);
Var i:Integer;
begin
 try
 if not(useToAll.Checked) then
 Levels[CurLevel].PaintColor:=PaintColor.SelectedColor
 else
  for i:=0 to 10 do  Levels[i].PaintColor:=PaintColor.SelectedColor;
 except
  on E:Exception do WriteLog('TLevelSetupForm:PaintColorChange',E);
 end;
end;

procedure TLevelSetupForm.rectTypeChange(Sender: TObject);
Var i,j:Integer;
begin
 try
 i:=(Sender as TSpeedButton).Tag-1;
 if not(useToAll.Checked) then
 begin
 case i of
  0:  Levels[CurLevel].RectStyle:=reNone;
  1:  Levels[CurLevel].RectStyle:=re1x;
  2:  Levels[CurLevel].RectStyle:=re2x;
  3:  Levels[CurLevel].RectStyle:=re3x;
  4:  Levels[CurLevel].RectStyle:=re4x;
  5:  Levels[CurLevel].RectStyle:=re2x3;
  6:  Levels[CurLevel].RectStyle:=re2x4;
  7:  Levels[CurLevel].RectStyle:=re2x5;
  8:  Levels[CurLevel].RectStyle:=re3x2;
  9:  Levels[CurLevel].RectStyle:=re4x2;
  10: Levels[CurLevel].RectStyle:=re5x2;
 end;
 end
 else
   begin
    case i of
     0:  for j:=0 to 10 do Levels[j].RectStyle:=reNone;
     1:  for j:=0 to 10 do Levels[j].RectStyle:=re1x;
     2:  for j:=0 to 10 do Levels[j].RectStyle:=re2x;
     3:  for j:=0 to 10 do Levels[j].RectStyle:=re3x;
     4:  for j:=0 to 10 do Levels[j].RectStyle:=re4x;
     5:  for j:=0 to 10 do Levels[j].RectStyle:=re2x3;
     6:  for j:=0 to 10 do Levels[j].RectStyle:=re2x4;
     7:  for j:=0 to 10 do Levels[j].RectStyle:=re2x5;
     8:  for j:=0 to 10 do Levels[j].RectStyle:=re3x2;
     9:  for j:=0 to 10 do Levels[j].RectStyle:=re4x2;
    10:  for j:=0 to 10 do Levels[j].RectStyle:=re5x2;
    end;
   end;
 except
  on E:Exception do WriteLog('TLevelSetupForm:RectTypeChange',E);
 end;
end;

procedure TLevelSetupForm.DrawColorChange(Sender: TObject);
Var i:Integer;
begin
 try
 if not(useToAll.Checked) then
 Levels[CurLevel].DrawColor:=DrawColor.SelectedColor
 else
  for i:=0 to 10 do Levels[i].DrawColor:=DrawColor.SelectedColor;
 except
  on E:Exception do WriteLog('TLevelSetupForm:DrawColorChange',E);
 end;
end;

procedure TLevelSetupForm.lineStyleChange(Sender: TObject);
Var i,j:Integer;
begin
 try
 i:=(Sender as TSpeedButton).Tag-1;
 if not(useToAll.Checked) then
 begin
 case i of
  0: Levels[CurLevel].LineStyle:=psSolid;
  1: Levels[CurLevel].LineStyle:=psDot;
  2: Levels[CurLevel].LineStyle:=psDashDot;
 end;
 end
 else
 begin
 case i of
  0: for j:=0 to 10 do Levels[j].LineStyle:=psSolid;
  1: for j:=0 to 10 do Levels[j].LineStyle:=psDot;
  2: for j:=0 to 10 do Levels[j].LineStyle:=psDashDot;
 end;
 end;
 except
  on E:Exception do WriteLog('TLevelSetupForm:LineStyleChange',E);
 end;
end;

procedure TLevelSetupForm.shadowChange(Sender: TObject);
Var i,j:Integer;
begin
 try
 i:=(Sender as TSpeedButton).Tag-1;
 if not(useToAll.Checked) then
 begin
 case i of
  0: Levels[CurLevel].ShadowType:=shNone;
  1: Levels[CurLevel].ShadowType:=shLeftFramed;
  2: Levels[CurLevel].ShadowType:=shRightFramed;
  3: Levels[CurLevel].ShadowType:=shBottomPerspective;
  4: Levels[CurLevel].ShadowType:=shLeftBoxed;
  5: Levels[CurLevel].ShadowType:=shRightBoxed;
  6: Levels[CurLevel].ShadowType:=shTopPerspective;
  7: Levels[CurLevel].ShadowType:=shInversePerspective;
 end;
 end
 else
 begin
 case i of
  0: for j:=0 to 10 do Levels[j].ShadowType:=shNone;
  1: for j:=0 to 10 do Levels[j].ShadowType:=shLeftFramed;
  2: for j:=0 to 10 do Levels[j].ShadowType:=shRightFramed;
  3: for j:=0 to 10 do Levels[j].ShadowType:=shBottomPerspective;
  4: for j:=0 to 10 do Levels[j].ShadowType:=shLeftBoxed;
  5: for j:=0 to 10 do Levels[j].ShadowType:=shRightBoxed;
  6: for j:=0 to 10 do Levels[j].ShadowType:=shTopPerspective;
  7: for j:=0 to 10 do Levels[j].ShadowType:=shInversePerspective;
 end;
 end;
 except
  on E:Exception do WriteLog('TLevelSetupForm:ShadowChange',E);
 end;
end;

procedure TLevelSetupForm.ShadowColorChange(Sender: TObject);
Var i:Integer;
begin
 try
 if not(useToAll.Checked) then
 Levels[CurLevel].ShadowColor:=ShadowColor.SelectedColor
 else
  for i:=0 to 10 do Levels[i].ShadowColor:=ShadowColor.SelectedColor;
 except
  on E:Exception do WriteLog('TLevelSetupForm:ShadowColorChange',E);
 end;
end;

procedure TLevelSetupForm.FormCreate(Sender: TObject);
Var i,k:Integer;
    dc:HDC;
begin
 try
 dc:=GetDC(Application.Handle);
 k:=GetDeviceCaps(dc,LOGPIXELSY);
 ReleaseDC(Application.Handle,dc);
 DPMratio:=25.4 / k; { pixels to mm -> * DPMRatio }
 FontName.Items.Assign(Printer.Fonts);
 PrjFontName.Items.Assign(Printer.Fonts);
 for i:=0 to 10 do
   begin
    Levels[i]:=MainForm.CustomOrgChart1.Nodes.Levels[i];
    Levels[i].DefWidth:=Round(Levels[i].DefWidth*DPMRatio);
    Levels[i].DefHeight:=Round(Levels[i].DefHeight*DPMRatio);
    Levels[i].HSpacing:=Round(Levels[i].HSpacing*DPMRatio);
    Levels[i].VSpacing:=Round(Levels[i].VSpacing*DPMRatio);
    Levels[i].HInterval:=Round(Levels[i].HInterval*DPMRatio);
    Levels[i].VInterval:=Round(Levels[i].VInterval*DPMRatio);
   end;
 CurLevel:=0;
 LevelComboBoxChange(Self);
 PageControl1.ActivePage:=TabSheet1;
 except
  on E:Exception do WriteLog('TLevelSetupForm:FormCreate',E);
 end;
end;

procedure TLevelSetupForm.DefWidthChange(Sender: TObject);
Var i:Integer;
begin
 try
 if not(useToAll.Checked) then
 Levels[CurLevel].DefWidth:=DefWidth.Value
 else
  for i:=0 to 10 do Levels[i].DefWidth:=DefWidth.Value;
 except
  on E:Exception do WriteLog('TLevelSetupForm:DefWidthChange',E);
 end;
end;

procedure TLevelSetupForm.DefHeightChange(Sender: TObject);
Var i:Integer;
begin
 try
 if not(useToAll.Checked) then
 Levels[CurLevel].DefHeight:=DefHeight.Value
 else
  for i:=0 to 10 do Levels[i].DefHeight:=DefHeight.Value;
 except
  on E:Exception do WriteLog('TLevelSetupForm:DefHeightChange',E);
 end;
end;

procedure TLevelSetupForm.HSpacingChange(Sender: TObject);
Var i:Integer;
begin
 try
 if not(useToAll.Checked) then
 Levels[CurLevel].HSpacing:=HSpacing.Value
 else
 for i:=0 to 10 do Levels[i].HSpacing:=HSpacing.Value;
 except
  on E:Exception do WriteLog('TLevelSetupForm:HSpacingChange',E);
 end;
end;

procedure TLevelSetupForm.VSpacingChange(Sender: TObject);
Var i:Integer;
begin
 try
 if not(useToAll.Checked) then
 Levels[CurLevel].VSpacing:=VSpacing.Value
 else
  for i:=0 to 10 do Levels[i].VSpacing:=VSpacing.Value;
 except
  on E:Exception do WriteLog('TLevelSetupForm:VSpacingChange',E);
 end;
end;

procedure TLevelSetupForm.HIntervalChange(Sender: TObject);
Var i:Integer;
begin
 try
 if not(useToAll.Checked) then
 Levels[CurLevel].HInterval:=(HInterval.Value div 2)+(HInterval.Value mod 2)
 else
  for i:=0 to 10 do Levels[i].HInterval:=(HInterval.Value div 2)+(HInterval.Value mod 2);
 except
  on E:Exception do WriteLog('TLevelSetupForm:HIntervalChange',E);
 end;
end;

procedure TLevelSetupForm.VIntervalChange(Sender: TObject);
Var i:Integer;
begin
 try
 if not(useToAll.Checked) then
 Levels[CurLevel].VInterval:=(VInterval.Value div 2)+(VInterval.Value mod 2)
 else
  for i:=0 to 10 do Levels[i].VInterval:=(VInterval.Value div 2)+(VInterval.Value mod 2);
 except
  on E:Exception do WriteLog('TLevelSetupForm:VIntervalChange',E);
 end;
end;

procedure TLevelSetupForm.VAlignClick(Sender: TObject);
Var i:Integer;
begin
 try
 if not(useToAll.Checked) then
 begin
 case VAlign.ItemIndex of
  0: Levels[CurLevel].VAlign:=taTopJustify;
  1: Levels[CurLevel].VAlign:=taVCenter;
  2: Levels[CurLevel].VAlign:=taBottomJustify;
 end;
 end
 else
 begin
 case VAlign.ItemIndex of
  0: for i:=0 to 10 do Levels[i].VAlign:=taTopJustify;
  1: for i:=0 to 10 do Levels[i].VAlign:=taVCenter;
  2: for i:=0 to 10 do Levels[i].VAlign:=taBottomJustify;
 end;
 end;
 except
  on E:Exception do WriteLog('TLevelSetupForm:VAlignClick',E);
 end;
end;

procedure TLevelSetupForm.HAlignClick(Sender: TObject);
Var i:Integer;
begin
 try
 if not(useToAll.Checked) then
 begin
 case HAlign.ItemIndex of
  0: Levels[CurLevel].HAlign:=taLeftJustify;
  1: Levels[CurLevel].HAlign:=taCenter;
  2: Levels[CurLevel].HAlign:=taRightJustify;
 end;
 end
 else
 begin
 case HAlign.ItemIndex of
  0: for i:=0 to 10 do Levels[i].HAlign:=taLeftJustify;
  1: for i:=0 to 10 do Levels[i].HAlign:=taCenter;
  2: for i:=0 to 10 do Levels[i].HAlign:=taRightJustify;
 end;
 end;
 except
  on E:Exception do WriteLog('TLevelSetupForm:HAlignClick',E);
 end;
end;

procedure TLevelSetupForm.strategyChange(Sender: TObject);
Var i,j:Integer;
begin
 try
 i:=(Sender as TSpeedButton).Tag-1;
 if not(useToAll.Checked) then
 begin
 case i of
  0: Levels[CurLevel].Strategy:=stHTree;
  1: Levels[CurLevel].Strategy:=stVTree;
  2: Levels[CurLevel].Strategy:=stVLRTree;
  3: Levels[CurLevel].Strategy:=stVLR2Tree;
 end;
 end
 else
 begin
 case i of
  0: for j:=0 to 10 do Levels[j].Strategy:=stHTree;
  1: for j:=0 to 10 do Levels[j].Strategy:=stVTree;
  2: for j:=0 to 10 do Levels[j].Strategy:=stVLRTree;
  3: for j:=0 to 10 do Levels[j].Strategy:=stVLR2Tree;
 end;
 end;
 except
  on E:Exception do WriteLog('TLevelSetupForm:StrategyChange',E);
 end;
end;

procedure TLevelSetupForm.ShadowDepthChange(Sender: TObject);
Var i:Integer;
begin
 try
 if not(useToAll.Checked) then
  Levels[CurLevel].ShadowDepth:=ShadowDepth.Value
 else
  for i:=0 to 10 do Levels[i].ShadowDepth:=ShadowDepth.Value;
 except
  on E:Exception do WriteLog('TLevelSetupForm:ShadowDepthChange',E);
 end;
end;

procedure TLevelSetupForm.LineColorChange(Sender: TObject);
Var i:Integer;
begin
 try
 if not(useToAll.Checked) then
  Levels[CurLevel].LineColor:=LineColor.SelectedColor
 else
 for i:=0 to 10 do Levels[i].LineColor:=LineColor.SelectedColor;
 except
  on E:Exception do WriteLog('TLevelSetupForm:LineColorChange',E);
 end;
end;


procedure TLevelSetupForm.CBoldClick(Sender: TObject);
Var i:Integer;
begin
 try
 if not(useToAll.Checked) then
 begin
 if CBold.Checked then Levels[CurLevel].FontStyle:=Levels[CurLevel].FontStyle+[fsBold]
  else Levels[CurLevel].FontStyle:=Levels[CurLevel].FontStyle-[fsBold];
 end
 else
 begin
 if CBold.Checked then for i:=0 to 10 do Levels[i].FontStyle:=Levels[i].FontStyle+[fsBold]
  else for i:=0 to 10 do Levels[i].FontStyle:=Levels[i].FontStyle-[fsBold];
 end;
 except
  on E:Exception do WriteLog('TLevelSetupForm:CBoldClick',E);
 end;
end;

procedure TLevelSetupForm.CItalicClick(Sender: TObject);
Var i:Integer;
begin
 try
 if not(useToAll.Checked) then
 begin
 if CItalic.Checked then Levels[CurLevel].FontStyle:=Levels[CurLevel].FontStyle+[fsItalic]
  else Levels[CurLevel].FontStyle:=Levels[CurLevel].FontStyle-[fsItalic];
 end
 else
 begin
 if CItalic.Checked then for i:=0 to 10 do Levels[i].FontStyle:=Levels[i].FontStyle+[fsItalic]
  else for i:=0 to 10 do Levels[i].FontStyle:=Levels[i].FontStyle-[fsItalic];
 end;
 except
  on E:Exception do WriteLog('TLevelSetupForm:CItalicClick',E);
 end;
end;

procedure TLevelSetupForm.CUnderlineClick(Sender: TObject);
Var i:Integer;
begin
 try
 if not(useToAll.Checked) then
 begin
 if CUnderline.Checked then Levels[CurLevel].FontStyle:=Levels[CurLevel].FontStyle+[fsUnderline]
  else Levels[CurLevel].FontStyle:=Levels[CurLevel].FontStyle-[fsUnderline];
 end
 else
 begin
 if CUnderline.Checked then for i:=0 to 10 do Levels[i].FontStyle:=Levels[i].FontStyle+[fsUnderline]
  else for i:=0 to 10 do Levels[i].FontStyle:=Levels[i].FontStyle-[fsUnderline];
 end;
 except
  on E:Exception do WriteLog('TLevelSetupForm:CUnderlineClick',E);
 end;
end;

procedure TLevelSetupForm.LineDepthChange(Sender: TObject);
Var i:Integer;
begin
 try
 if not(useToAll.Checked) then
 Levels[CurLevel].LineDepth:=LineDepth.Value
 else
  for i:=0 to 10 do Levels[i].LineDepth:=LineDepth.Value;
 except
  on E:Exception do WriteLog('TLevelSetupForm:LineDepthChange',E);
 end;
end;


procedure TLevelSetupForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
 try
 Action:=caFree;
 except
  on E:Exception do
   begin
    WriteLog('TLevelSetupForm:FormClose',E);
    Action:=caFree;
   end;
 end;
end;

procedure TLevelSetupForm.PrjFontNameChange(Sender: TObject);
Var i:Integer;
begin
 try
 if not(useToAll.Checked) then
 Levels[CurLevel].PrjFontName:=PrjFontName.Text
 else
  for i:=0 to 10 do Levels[i].PrjFontName:=PrjFontName.Text;
 except
  on E:Exception do WriteLog('TLevelSetupForm:FontNameChange',E);
 end;
end;

procedure TLevelSetupForm.PrjFontSizeChange(Sender: TObject);
Var i:Integer;
begin
 try
 if not(useToAll.Checked) then
 Levels[CurLevel].PrjFontSize:=StrToIntDef(PrjFontSize.Text,10)
 else
  for i:=0 to 10 do Levels[i].PrjFontSize:=StrToIntDef(PrjFontSize.Text,10);
 except
  on E:Exception do WriteLog('TLevelSetupForm:FontSizeChange',E);
 end;
end;

procedure TLevelSetupForm.PrjBoldClick(Sender: TObject);
Var i:Integer;
begin
 try
 if not(useToAll.Checked) then
 begin
 if PrjBold.Checked then Levels[CurLevel].PrjFontStyle:=Levels[CurLevel].PrjFontStyle+[fsBold]
  else Levels[CurLevel].PrjFontStyle:=Levels[CurLevel].PrjFontStyle-[fsBold];
 end
 else
 begin
 if PrjBold.Checked then for i:=0 to 10 do Levels[i].PrjFontStyle:=Levels[i].PrjFontStyle+[fsBold]
  else for i:=0 to 10 do Levels[i].PrjFontStyle:=Levels[i].PrjFontStyle-[fsBold];
 end;
 except
  on E:Exception do WriteLog('TLevelSetupForm:CBoldClick',E);
 end;
end;

procedure TLevelSetupForm.PrjItalicClick(Sender: TObject);
Var i:Integer;
begin
{}
 try
 if not(useToAll.Checked) then
 begin
 if PrjItalic.Checked then Levels[CurLevel].PrjFontStyle:=Levels[CurLevel].PrjFontStyle+[fsItalic]
  else Levels[CurLevel].PrjFontStyle:=Levels[CurLevel].PrjFontStyle-[fsItalic];
 end
 else
 begin
 if PrjItalic.Checked then for i:=0 to 10 do Levels[i].PrjFontStyle:=Levels[i].PrjFontStyle+[fsItalic]
  else for i:=0 to 10 do Levels[i].PrjFontStyle:=Levels[i].PrjFontStyle-[fsItalic];
 end;
 except
  on E:Exception do WriteLog('TLevelSetupForm:CItalicClick',E);
 end;
end;

procedure TLevelSetupForm.PrjUnderlineClick(Sender: TObject);
Var i:Integer;
begin
 try
 if not(useToAll.Checked) then
 begin
 if PrjUnderline.Checked then Levels[CurLevel].PrjFontStyle:=Levels[CurLevel].PrjFontStyle+[fsUnderline]
  else Levels[CurLevel].PrjFontStyle:=Levels[CurLevel].PrjFontStyle-[fsUnderline];
 end
 else
 begin
 if PrjUnderline.Checked then for i:=0 to 10 do Levels[i].PrjFontStyle:=Levels[i].PrjFontStyle+[fsUnderline]
  else for i:=0 to 10 do Levels[i].PrjFontStyle:=Levels[i].PrjFontStyle-[fsUnderline];
 end;
 except
  on E:Exception do WriteLog('TLevelSetupForm:CUnderlineClick',E);
 end;
end;

procedure TLevelSetupForm.PrjFontColorChange(Sender: TObject);
Var i:Integer;
begin
 try
 if not(useToAll.Checked) then
 Levels[CurLevel].PrjFontColor:=PrjFontColor.SelectedColor
 else
  for i:=0 to 10 do Levels[i].PrjFontColor:=PrjFontColor.SelectedColor;
 except
  on E:Exception do WriteLog('TLevelSetupForm:FontColorChange',E);
 end;
end;

procedure TLevelSetupForm.NoControlCharClick(Sender: TObject);
Var i:Integer;
begin
 try
 if not(useToAll.Checked) then
 begin
 if NoControlChar.Checked then Levels[CurLevel].NoControlChar:=True
  else Levels[CurLevel].NoControlChar:=False;
 end
 else
 begin
 if NoControlChar.Checked then for i:=0 to 10 do Levels[i].NoControlChar:=True
  else for i:=0 to 10 do Levels[i].NoControlChar:=False;
 end;
 except
  on E:Exception do WriteLog('TLevelSetupForm:NoControlCharClick',E);
 end;
end;

procedure TLevelSetupForm.NumbersOnlyClick(Sender: TObject);
Var i:Integer;
begin
 try
 if not(useToAll.Checked) then
 begin
 if NumbersOnly.Checked then Levels[CurLevel].NumbersOnly:=True
  else Levels[CurLevel].NumbersOnly:=False;
 end
 else
 begin
 if NumbersOnly.Checked then for i:=0 to 10 do Levels[i].NumbersOnly:=True
  else for i:=0 to 10 do Levels[i].NumbersOnly:=False;
 end;
 except
  on E:Exception do WriteLog('TLevelSetupForm:NumbersOnlyClick',E);
 end;
end;

procedure TLevelSetupForm.Button3Click(Sender: TObject);
Var hm:Integer;
Var path:String;
    s:String;
    source:String;
    Dest:String;
    bl:Boolean;
begin
  SelAFTableDlg.EnumAFTables(GetOChartFName(MainForm.FFileName,'lsa'));
  hm:=SelAFTableDlg.ShowModal;
  if hm=mrOK then
   begin
     { Hm, need to change shablon }
     path:=ExtractFilePath(Application.ExeName)+'DOTS\';
     if SelAFTableDlg.ListBox.ItemIndex=0 then Exit;
     s:=SelAFTableDlg.ListBox.Items[SelAFTableDlg.ListBox.ItemIndex];
     if (not(FileExists(path+s+'.LSA'))) then
      begin
       s:=' ';
      end;
     source:=path+s+'.LSA';
     dest:=GetOChartFName(MainForm.FFileName,'lsa');
     CopyFile(PChar(source),PChar(dest),LongBool(0));
     MainForm.CustomOrgChart1.Nodes.LoadLevels(dest);
     MainForm.CustomOrgChart1.Nodes.PreSetupTree(bl);
     MainForm.CustomOrgChart1.Nodes.SetUpTree;
     MainForm.CustomOrgChart1.Repaint;
     FormCreate(self);
   end;
end;

procedure TLevelSetupForm.FormDestroy(Sender: TObject);
begin
 FontName.Clear;
 PrjFontName.Clear;
 MainForm.CloseTimerLSF.Enabled:=True;
end;

Initialization

LevelSetupForm:=nil;

end.
