unit ExcelBands;
{
(c) . .   1997,2006
}
{$INCLUDE Compmode.inc}
interface
uses classes,DB,otherLists;
Type
TColStatus=integer;
TColArray=array[1..256] of TColStatus;
TColSet=class;
TEXLReportBands=class;
TEXLReportBand=class;
TEXLReportBandLevel=class;
TEXLReportBandCell=class;
TEXLReportBandVariant=class;
TEXLReportBandStackRecord=class;
TConversionFunction=function(s:string):string of object;
TColSet=class(TIntList)
public
 procedure AppendList(l:TColSet);
 procedure AppendCol(col:integer);
 function intersectList(l:TColSet):boolean;
 function intersectCol(col:integer):boolean;
end;
TEXLReportBandCell=class
   fTemplateColStart,fTemplateColEnd,fTempLateRow:integer;
   fConstStrings,
   fDataStrings,
   fTemplateStrings,
   ftemplateStart,
   ftemplateEnd:TStringList;
   fisConstString:TIntList;
   fversion:string;
   ftype:integer;
   DataString:string;
   RSFlag:boolean;
   fisMacro:boolean;
   fUnionEnabled:boolean;
   constructor Create;
   destructor Destroy;override;
   procedure parseTemplate(s:string;convertor:TConversionFunction);
   procedure CalcDataString(firstline:boolean;Row:integer);
   function ConstString:boolean;
   function UnionEnabled:boolean;
  end;
TRowData=class
  frowvalues,frowtypes:TStrings;
  used:array[0..31] of boolean;
  constructor Create;
  destructor Destroy;override;
  function isEmpty:boolean;
  function isTotalRS:boolean;
  end;
  TEXLReportBandVariant=class
  fTempLateRow:integer;
  fCellList:TList;
  fBandLevel:TEXLReportBandLevel;
  function getCell(index:integer):TEXLReportBandCell;
  function getcount:integer;
  function AddCell(col,endcol:integer;Data:string):TEXLReportBandCell;
  function getCellByCol(col:integer):TEXLReportBandCell;
  constructor Create(row:integer;BandLevel:TEXLReportBandLevel);
  destructor Destroy;override;
//  procedure SortCells;

  property Cells[index:integer]: TEXLReportBandCell read getCell;
  property Count:integer read getCount;

  end;
  TEXLReportBand = class
  private
    FID: Integer;
    fLevel:integer;
    fLevels:TList;
    fColumns,fMergedCols:TIntList;
    fColSet:TColSet;
    fName:string;
    fBands:TEXLReportBands;
    fChildBands:TList;
    fintersectchildren:TIntlist;
    fRowData:TRowData;
    fparent:TEXLReportBand;
    fpart:integer;
  protected
    function GetLevelID(index:integer):TEXLReportBandLevel;
    function GetLevel(index:integer):TEXLReportBandLevel;
    function getChildBand(index:integer):TEXLReportBand;
    function getChildrenCount:integer;
    procedure getParent;
    function GetCount:integer;
  public
    OldData:array[1..256] of string;
    ColTerminated:array[1..256] of boolean;
    CurrentRow:integer;
    Terminated:boolean;
    constructor Create(ID:integer;Bands:TEXLReportBands;Name:string);
    destructor Destroy; override;
    function EnsureLevelExists(index:integer):TEXLReportBandLevel;
    function unProcessed:string;
    function isEmpty:Boolean;
    function ToString:String;
    procedure CalcChildrenIntersection;
    function InterSects(Band:TEXLReportBand):boolean;
    function InterSects1(Band:TEXLReportBand):boolean;
    property ID: Integer read FID;
    property Name:string read fName;
    property Bands:TEXLReportBands read fBands;
    property Parent:TEXLReportBand read fParent;
    property Level:integer read fLevel;
    property Part:integer read fpart;
    property LevelsID[index:integer]:TEXLReportBandLevel read getLevelID;
    property Levels[index:integer]:TEXLReportBandLevel read getLevel;
    property Count:integer read getCount;
    property Columns:TIntList read fcolumns;
    property MergedCols:TIntList read fmergedcols;
    property ChildBands[index:integer]:TEXLReportBand read getChildBand;
    property ChildrenCount:integer read getChildrenCount;
    property UsedCols:TColSet read fcolset;
    property RowData:TRowData read fRowData;
  end;
TEXLReportBandLevel = class
  private
    Flevel:integer;
    fVariants:TList;
    fband:TEXLReportBand;
  protected
    function GetVariant(index:integer):TEXLReportBandVariant;
    function getcount:integer;
  public

    constructor Create(Level:integer;Band:TEXLReportBand);
    destructor Destroy; override;
    function GetVariantByRow(row:integer):TEXLReportBandVariant;
    function FindAppropriateVariant:TEXLReportBandVariant;
    function FindNextVariant:TEXLReportBandVariant;
    function FullName:string;
    property Level:integer read flevel;
    property Band:TEXLReportBand read fband;
    property Variants[index:integer]:TEXLReportBandVariant read getVariant;
    property Count:integer read getcount;
  end;

  TEXLReportBands=class
  private
   FBandList:TList;
   FUsedBandList:TList;
   finterSection:TIntList;
  protected
   function GetBand(index:integer):TEXLReportBand;
   function GetCount:integer;
   function GetUsedBand(index:integer):TEXLReportBandLevel;
   function GetUsedCount:integer;
  public
   Convertor:TConversionFunction;
   constructor Create(conv:TConversionFunction);
   destructor Destroy;override;
   function AddNewBand(Name:String):TEXLReportBand;
   function BandByName(Name:String):TEXLReportBand;
   function ensureBandExists(Name:String):TEXLReportBand;
   procedure ResolveMasterDetail;
   procedure FillRow(pos:integer;DataSet:TDataSet);
   procedure CheckParent(band:TEXLReportBand);
   property Bands[index:integer]:TEXLReportBand read getBand;
   property Count:integer read GetCount;
   property UsedBands[index:integer]:TEXLReportBandLevel read getUsedBand;
   property UsedCount:integer read getUsedCount;
   function TotalRowSpan:boolean;
   function firstBandbyName:TEXLReportBand;
   function DirectInterSects(Band1,Band2:TEXLReportBand):boolean;
   procedure CalcInterSection;
  end;
TEXLReportBandStackRecord=class
private
 fOwnerCell:TEXLReportBandCell;
 fLevel:TEXLReportBand;
end;
procedure AddUsedColumns(var src,dst:TColArray);

var textexcel:TStringList;
implementation
uses sysutils,logs,utils;
function TEXLReportBandVariant.getCell(index:integer):TEXLReportBandCell;
begin
 result:=TEXLReportBandCell(fcelllist[index]);
end;
function TEXLReportBandVariant.AddCell(col,endcol:integer;Data:string):TEXLReportBandCell;
var newcell:TEXLReportBandCell;
    i:integer;
begin
 //endcol:=col;
 newcell:=TEXLReportBandCell.Create;
 newcell.fTemplateColStart:=col;
 newcell.fTemplateColEnd:=endcol;
 newcell.fTempLateRow:=fTempLateRow;
 newcell.parseTemplate(Data,fBandLevel.fband.fBands.Convertor);
 fcelllist.add(newcell);
 result:=newcell;
 for i:=col to endcol do
 if fbandLevel.fband.fColumns.IndexOf(i)=-1 then fbandlevel.fband.fColumns.add(i);
 for i:=col+1 to endcol do
 if fbandLevel.fband.fMergedCols.IndexOf(i)=-1 then fbandlevel.fband.fMergedCols.add(i);
end;

constructor  TEXLReportBandVariant.Create(row:integer;BandLevel:TEXLReportBandLevel);
begin
inherited create;
fTempLateRow:=row;
fcellList:=TList.Create;
fbandlevel:=bandlevel;
end;
destructor  TEXLReportBandVariant.Destroy;
var i:integer;
begin
 for i:=0 to fcelllist.Count-1 do
  TEXLReportBandCell(fcellList[i]).free;
  fcelllist.free;
 inherited destroy;
end;
function TEXLReportBandVariant.getcount:integer;
begin
 result:=fcelllist.count;
end;
function TEXLReportBandVariant.getCellByCol(col:integer):TEXLReportBandCell;
var i:integer;
begin
result:=nil;
for i:=0 to fcelllist.count-1 do
 if  TEXLReportBandCell(fcelllist[i]).fTemplateColStart=col then
 begin
  result:= TEXLReportBandCell(fcelllist[i]);
  exit;
 end;
end;
function TEXLReportBandLevel.GetVariant(index:integer):TEXLReportBandVariant;
begin
result:=TEXLReportBandVariant(fvariants[index]);
end;
function TEXLReportBandLevel.GetVariantByRow(row:integer):TEXLReportBandVariant;
var i:integer;
begin
result:=nil;
for i:= 0 to fvariants.count-1 do
if TEXLReportBandVariant(fvariants[i]).fTempLateRow=row then
begin
result:=TEXLReportBandVariant(fvariants[i]);
exit;
end;
result:=TEXLReportBandVariant.Create(row,self);
fvariants.Add(result);
end;
constructor TRowData.create;
begin
 inherited Create;
 frowvalues:=TStringList.create;
 frowtypes:=TStringList.create;
end;
destructor TRowData.destroy;
begin
 frowvalues.free;
 frowtypes.free;
 inherited destroy;
end;
procedure TEXLReportBands.fillRow(pos:integer;DataSet:TDataSet);
var bn:TEXLReportBand;
    blevel:TEXLReportBandLevel;
    i,j:integer;
    s:string;
begin
if not (DataSet.FieldByName('ROWID').asInteger=pos) then
DataSet.locate('ROWID',pos,[]);
FUsedBandList.Clear;
s:='';
for i:=0 to FBandList.Count-1 do
 with TEXLReportBand(FBandList[i]) do
 begin
  frowdata.frowvalues.Clear;
  frowdata.frowtypes.Clear;
 end;
while  not Dataset.eof and (DataSet.FieldByName('ROWID').asInteger=pos) do
begin

 s:=s+dataset.fieldbyname('CELLVALUE').asString+':::';
  bn:=BandByName('*'+dataset.fieldbyname('CELLLEVEL').asString);
if bn<>nil then
 begin
 blevel:=bn.LevelsID[dataset.fieldbyname('NODELEVEL').asInteger];
 bn.fRowData.frowvalues.addObject(dataset.fieldbyname('CELLVALUE').asString,
                                      TObject(dataset.fieldbyname('RSFLAG').asInteger));
 bn.fRowData.frowtypes.add(dataset.fieldbyname('CELLTYPE').asString);
 bn.fRowData.used[bn.fRowData.frowtypes.count-1]:=false;
 if FUsedBandList.IndexOf(blevel)=-1 then
  fUsedBandList.Add(blevel);
end;
DataSet.next;
end;
if textexcel<>nil then
textexcel.add(s);
end;
function TEXLReportBand.unProcessed:string;
var j:integer;
begin
result:='';
 for j:=0 to frowdata.frowtypes.count-1 do
 if  not     (frowdata.Used[j]) then
   begin
    result:=result+frowdata.frowtypes[j]+'{'+frowdata.frowvalues[j]+'}, '
   end;
if result<>'' then result:=copy(result,1,length(result)-2)   
end;
function TEXLReportBandLevel.FindAppropriateVariant:TEXLReportBandVariant;
var i,j,k,l:integer;
    curvar:TEXLReportBandVariant;
    found,need:boolean;
begin
 result:=nil;
 for i:=0 to fvariants.count-1 do
 begin
 curvar:=TEXLReportBandVariant(fvariants[i]);
  for k:=0 to curvar.Count-1 do
  begin
  curvar.Cells[k].RSFlag:=false;
   for l:=0 to curvar.Cells[k].fTemplateStrings.Count-1 do
   begin
    curvar.Cells[k].fDataStrings[l]:=curvar.Cells[k].fConstStrings[l];
    curvar.Cells[k].fDataStrings.Objects[l]:=TObject(0);
   end;
  end;
// if curvar.Count<frowdata.frowvalues.Count then continue;
found:=true;
 for j:=0 to fBand.frowdata.frowtypes.count-1 do
   begin
    found:=false;
    need:=(fband.fRowData.frowvalues[j]<>'')and not Boolean(fBand.frowdata.frowvalues.Objects[j]);
       for k:=0 to curvar.Count-1 do
        for l:=0 to curvar.Cells[k].fTemplateStrings.Count-1 do
      if (UPPERCASE(curvar.Cells[k].fTemplateStrings[l])=UPPERCASE(fBand.frowdata.frowtypes[j])) then
      begin
      curvar.Cells[k].fDataStrings[l]:=fBand.frowdata.frowvalues[j];
      curvar.cells[k].fDataStrings.Objects[l]:=fBand.frowdata.frowvalues.Objects[j];
      found:=true;
      //break;
      end;
      found:=found or not need;
    if not found then break;
   end;
   if found then
   begin
   result:=curvar;
   for j:=0 to fBand.frowdata.frowtypes.Count-1 do
    fBand.frowdata.used[j]:=true;
   exit;
   end;
 end;
end;
function TEXLReportBandLevel.FindNextVariant:TEXLReportBandVariant;
var i,j,k,l:integer;
    curvar:TEXLReportBandVariant;
    found:boolean;
begin
 result:=nil;

found:=false;
for i:=0 to fvariants.count-1 do
 begin
 curvar:=TEXLReportBandVariant(fvariants[i]);
 for j:=0 to fBand.frowdata.frowtypes.count-1 do
 if  not     (fBand.frowdata.Used[j]) then
   begin
    found:=false;
       for k:=0 to curvar.Count-1 do
        for l:=0 to curvar.Cells[k].fTemplateStrings.Count-1 do
      if (UPPERCASE(curvar.Cells[k].fTemplateStrings[l])=UPPERCASE(fBand.frowdata.frowtypes[j])) then
      begin
      curvar.Cells[k].fDataStrings[l]:=fBand.frowdata.frowvalues[j];
      curvar.cells[k].fDataStrings.Objects[l]:=fBand.frowdata.frowvalues.Objects[j];
      fBand.frowdata.Used[j]:=true;
      found:=true;
      //break;
      end;
    if  found then break;
   end;
   if found then
   begin
   for k:=0 to curvar.Count-1 do
        for l:=0 to curvar.Cells[k].fTemplateStrings.Count-1 do
        begin
         for j:=0 to fBand.frowdata.frowtypes.count-1 do
         if (UPPERCASE(curvar.Cells[k].fTemplateStrings[l])=UPPERCASE(fBand.frowdata.frowtypes[j])) then
       begin
      curvar.Cells[k].fDataStrings[l]:=fBand.frowdata.frowvalues[j];
      curvar.cells[k].fDataStrings.Objects[l]:=fBand.frowdata.frowvalues.Objects[j];
      fBand.frowdata.Used[j]:=true;
      found:=true;
      break;
      end;
        end;
   result:=curvar;
   exit;
   end;
 end;
end;

constructor TEXLReportBand.Create(ID:integer;Bands:TEXLReportBands;Name:string);
var i:integer;
    fNewLevel:TEXLReportBandLevel;
begin
 inherited Create;
 fcolset:=TColSet.Create;
 flevel:=1;
 terminated:=true;
 for i:=1 to length(name) do
  if name[i]='_' then inc(flevel);
fpart:=1;
 for i:=1 to 256 do
 begin
 OldData[i]:='';
 Colterminated[i]:=false;
 end;
 fLevels:=TList.create;
 fcolumns:=TIntList.create;
 fMergedCols:=TIntList.Create;
 fChildBands:=TList.Create;
 fintersectchildren:=TIntList.Create;
 fId:=ID;
 fBands:=Bands;
 fname:=name;
 frowdata:=TRowData.create;
 for i:=1 to length(fname) do
  if fname[i] in [':','_'] then break;
 fpart:=strtointdef(copy(fname,2,i-2),1);

 fNewLevel:=TEXLReportBandLevel.Create(0,self);
 flevels.Add(fnewLevel);
end;
destructor TEXLReportBand.Destroy;
var i:integer;
begin
 for i:=0 to flevels.count-1 do
  TEXLReportBandVariant(flevels[i]).free;
 flevels.free;
 fcolumns.free;
 fMergedCols.Free;
 fchildbands.free;
 fintersectchildren.free;
 frowdata.free;
 fcolset.free;
 inherited destroy;
end;
function TEXLReportBands.GetBand(index:integer):TEXLReportBand;
begin
 result:=TEXLReportBand(FBandList[index]);
end;
function TEXLReportBands.GetCount:integer;
begin
 result:=FBandList.Count;
end;
function TEXLReportBands.GetUsedBand(index:integer):TEXLReportBandLevel;
begin
 result:=TEXLReportBandLevel(FUsedBandList[index]);
end;
function TEXLReportBands.GetUsedCount:integer;
begin
 result:=FUsedBandList.Count;
end;

function TEXLReportBands.AddNewBand(Name:String):TEXLReportBand;
var nb:TEXLReportBand;
begin
 nb:=TEXLReportBand.Create(FBandList.Count,self,Name);
 fBandList.Add(nb);
 result:=nb;
end;
function TEXLReportBands.BandByName(Name:String):TEXLReportBand;
var i:integer;
begin
result:=nil;
 for i:=0 to Count-1 do
  if Bands[i].fname=Name then
   begin
    result:=Bands[i];
    exit;
   end;
end;
function TEXLReportBands.ensureBandExists(Name:string):TEXLReportBand;
begin
result:=BandByName(Name);
if result=nil then
result:=AddNewBand(Name);
end;
constructor TEXLReportBands.Create(conv:TConversionFunction);
begin
 inherited Create;
 convertor:=conv;
 FBandList:=TList.Create;
 FUsedBandList:=TList.Create;
 finterSection:=TIntList.Create;
end;
destructor TEXLReportBands.Destroy;
var i:integer;
begin
 for i:=0 to FBandList.Count-1 do
 TEXLReportBand(FBandList[i]).Free;
 FBandList.Free;
 FUsedBandList.Free;
 finterSection.Free;
 inherited Destroy;
end;
procedure AddUsedColumns(var src,dst:TColArray);
var i:integer;
begin
 for i:=1 to 256 do
 if dst[i]<src[i] then dst[i]:=src[i];
end;
constructor TEXLReportBandCell.Create;
begin
 inherited create;
 fTemplateStrings:=TStringList.create;
 ftemplateStart:=TStringList.Create;
 ftemplateEnd:=TStringList.Create;
 fdataStrings:=TStringList.create;
 fConstStrings:=TStringList.Create;
 fisConstString:=TIntList.Create;
 fUnionEnabled:=false;
end;
destructor TEXLReportBandCell.Destroy;
begin
 ftemplateStrings.Free;
 ftemplateStart.Free;
 ftemplateEnd.Free;
 fDataStrings.free;
 fConstStrings.Free;
 fisConstString.Free;
 inherited destroy;
end;
procedure TEXLReportBandCell.parseTemplate(s:string;convertor:TConversionFunction);
var i,j:integer;
    so,sc:string;
    sname,sconst:string;
    contrchar:boolean;
function getNextConst(s:string;var pos:integer):string;
var i:integer;
    second:boolean;
begin
second:=false;
result:='';
 for i:=pos+1 to length(s) do
  if s[i]='"' then
   if second then begin result:=result+'"'; second:=false;end
             else second:=true
      else if second then break
                     else begin result:=result+s[i]; second:=false; end;
 pos:=i;
end;
function getNextField(s:string;var pos:integer;var sopen,sclose:string):string;
var i:integer;
    hasres:boolean;
    p,p2:integer;
    strleft:string;
begin
 sopen:='';
 sclose:='';
 i:=pos;
 hasres:=false;
 while i<=length(s) do
 begin
  if s[i]='+' then break
  else if s[i]='(' then
  begin
  result:=copy(s,pos,i-pos);
  if assigned(convertor) then result:=convertor(result);
  strleft:=copy(s,i,length(s));
  hasres:=true;
  p:=system.pos(';',strleft);
  sopen:=copy(strleft,2,p-2);
  p2:=system.pos(')',strleft);
  sclose:=copy(strleft,p+1,p2-p-1);
  i:=p2+i;
  break;
  end
  else inc(i);
 end;
 if not hasres then
 result:=copy(s,pos,i-pos);
 if assigned(convertor) then result:=convertor(result);
 pos:=i;
end;
begin
 fconststrings.Clear;
 fisConstString.Clear;
 ftemplateStrings.Clear;
 fdatastrings.clear;
 i:=1;
 fisMacro:=false;
 if s='' then exit;
 if (copy(s,1,1)='<')and(copy(s,length(s),1)='>') then
 begin
  fUnionEnabled:=true;
  s:=copy(s,2,length(s)-2);
  fConstStrings.Add(s);
   fisConstString.add(integer(true));
   fTemplateStrings.add('');
   ftemplateStart.add('');
   ftemplateEnd.add('');
 end;
 if copy(s,1,3)='%%(' then
 begin
  fisMacro:=true;
  s:=copy(s,length('%%(')+1,length(s)-length('%%(')-1);
  sname:='';
  sconst:='';
  i:=1;
  contrchar:=false;
  while i<=length(s) do
  begin
   if s[i]='[' then
   begin
    sname:='';
    inc(i);
    while (i<=length(s))and(s[i]<>']') do
    begin
    sname:=sname+s[i];
    inc(i);
    end;
    so:='';
    sc:='';
    j:= pos('(',sname);
    if j>0 then
    begin
    sconst:=copy(sname,j+1,length(sname));
    sname:=copy(sname,1,j-1);
    if sconst[length(sconst)]=')' then sconst:=copy(sconst,1,length(sconst)-1);
    j:=pos(';',sconst);
    if j>0 then
    begin
    so:=copy(sconst,1,j-1);
    sc:=copy(sconst,j+1,length(sconst));
    end
    else
    begin
    so:=sconst;
    sc:='';
    end;
    end;

    if assigned(convertor) then
    fTemplateStrings.add(convertor(sname))
    else
    fTemplateStrings.add(sname);
    ftemplateStart.add(so);
    ftemplateEnd.add(sc);
    fConstStrings.add('');
    fisConstString.add(integer(false));
    inc(i);
   end
   else
   begin
   sconst:='';
   contrchar:=false;
   While (i<=length(s)) and((s[i]<>'[')or contrChar) do
   begin
   if not contrchar and(s[i]='/') then
   contrchar:=true
   else
   begin
   sconst:=sconst+s[i];
   contrchar:=false;
   end;
   inc(i);
   end;
   fConstStrings.Add(sconst);
   fisConstString.add(integer(true));
   fTemplateStrings.add('');
   ftemplateStart.add('');
   ftemplateEnd.add('');
   end;
  end;
 end
 else
 while i<length(s) do
 begin
  if s[i]='"' then begin
                   fConstStrings.Add(getNextConst(s,i));
                   fisConstString.add(integer(true));
                   fTemplateStrings.add('');
                   ftemplateStart.add('');
                   ftemplateEnd.add('');
                   end
              else begin
                   fTemplateStrings.Add(getNextField(s,i,so,sc));
                   ftemplateStart.add(so);
                   ftemplateEnd.add(sc);
                   fConstStrings.add('');
                   fisConstString.add(integer(false));
                   end;
  inc(i);
 end;
   for i:=1 to ftemplatestrings.count do fdatastrings.add('');
end;
procedure TEXLReportBandCell.CalcDataString(firstline:boolean;Row:integer);
var i:integer;
    totalconst:boolean;
function checkExcel(s:string):string;
begin
 result:='';
 if s='' then exit;
 if s[1]in ['=','-','@',''''] then result:=''''+s
             else result:=s;
end;
function DoubleQuotes(s:string):string;
var i:integer;
begin
 result:='';
 for i:=1 to length(s) do
  if s[i]<>'"' then result:=result+s[i]
               else result:=result+'""';
end;
begin
 DataString:='';
  RSFlag:=false;
 if fdatastrings.count=0 then exit;
 RSFlag:=false;
 for i:=0 to fTemplateStrings.Count-1 do
  if lowercase(fTemplateStrings[i])='col' then fDataStrings[i]:=inttostr(fTemplateColStart)
  else
  if lowercase(fTemplateStrings[i])='row' then fDataStrings[i]:=inttostr(Row);
 if fdatastrings.count>0 then
 begin
  if not firstline then
  begin
 RSFlag:=true;
 totalconst:=true;
 for i:=0 to fdatastrings.count-1 do
 begin
 RSFlag:=RSFlag and (boolean(fisConstString[i])or(Boolean(fdatastrings.Objects[i])));
 totalconst:=totalconst and  boolean(fisConstString[i]);
 end;
 RSFlag:=RSFlag and not totalconst;
 end;
 end;
 if RSFlag then DataString:=''
 else
  begin
   for i:=0 to fdatastrings.count-1 do
    if (fdatastrings[i]<>'') then
    begin
    if (i>0) and not(boolean(fisConstString[i])or boolean(fisConstString[i-1])) then
    DataString:=DataString+' ';
    DataString:=DataString+ftemplateStart[i]+fdatastrings[i]+ftemplateEnd[i];

   end;
  DataString:=ClearSpaces(DataString);
  end;
  if (fisConstString.Count>0)and(fisConstString[0]=0) then
  DataString:=CheckExcel(dataString)
  else
  DataString:={DoubleQuotes}(dataString);
end;
function TEXLReportBandCell.ConstString:boolean;
var i:integer;
begin
 result:=true;
 for i:=0 to fisConstString.Count-1 do
  result:=result and boolean(fisConstString[i]);
end;
function TEXLReportBandCell.UnionEnabled:boolean;
begin
 result:=fUnionEnabled;
end;
procedure TEXLReportBand.getParent;
var i,j:integer;
    plevel:string;
begin
 fparent:=nil;
 j:=0;
 for i:=1 to length(fname) do
  if fname[i]='_' then j:=i;
 if j=0 then exit;
 plevel:=copy(fname,1,j-1);
  for i:=0 to fbands.count-1 do
   if fbands.Bands[i].fName=plevel then
    begin
     fparent:=fbands.Bands[i];
     fparent.fChildBands.Add(self);
     fparent.fintersectchildren.add(0);
     break;
    end;
end;
procedure TEXLReportBands.ResolveMasterDetail;
var i:integer;
begin
 for i:=0 to FBandList.Count-1 do
  TEXLReportBand(FBandList[i]).getParent;
end;
function TEXLReportBand.getChildrenCount:integer;
begin
 result:=fchildbands.Count;
end;
function TEXLReportBand.getChildBand(index:integer):TEXLReportBand;
begin
 result:=TEXLReportBand(fchildbands[index]);
end;
function TEXLReportBand.ToString:String;
var i:integer;
begin
result:='';
for i:=0 to frowdata.frowvalues.Count-1 do
result:=result+frowdata.frowtypes[i]+'{'+frowdata.frowvalues[i]+'}'+', ';
if result<>'' then result:=copy(result,1,length(result)-2);
result:=fname+':'+result;
end;
function TEXLReportBandLevel.FullName:string;
begin
result:=fband.fname+':'+inttostr(flevel);
end;
function TEXLReportBand.GetLevelID(index:integer):TEXLReportBandLevel;
var i:integer;
begin
result:=TEXLReportBandLevel(flevels[0]);
if index=0 then exit;
for i:=1 to flevels.Count-1 do
 if TEXLReportBandLevel(flevels[i]).Flevel=index then
 begin
 result:=TEXLReportBandLevel(flevels[i]);
 exit;
 end;
end;
function TEXLReportBand.GetLevel(index:integer):TEXLReportBandLevel;
begin
 result:=TEXLReportBandLevel(flevels[index]);
end;
function TEXLReportBand.EnsureLevelExists(index:integer):TEXLReportBandLevel;
var i:integer;
    FNewLevel:TEXLReportBandLevel;
begin
result:=TEXLReportBandLevel(flevels[0]);
if index=0 then exit;
for i:=1 to flevels.Count-1 do
 if TEXLReportBandLevel(flevels[i]).Flevel=index then
 begin
 result:=TEXLReportBandLevel(flevels[i]);
 exit;
 end;
FNewLevel:=TEXLReportBandLevel.Create(index,self);
flevels.Add(fNewLevel);
result:=fNewLevel;
end;

function TEXLReportBandLevel.getCount:integer;
begin
 result:=fvariants.Count;
end;
constructor TEXLReportBandLevel.Create(Level:integer;Band:TEXLReportBand);
begin
 inherited Create;
 flevel:=Level;
 fVariants:=TList.create;
 fBand:=Band;
end;
destructor TEXLReportBandLevel.Destroy;
var i:integer;
begin
 for i:=0 to fvariants.Count-1 do
   TEXLReportBandVariant(fvariants[i]).Free;
  fvariants.Free;
  inherited Destroy;
end;
function TEXLReportBand.GetCount:integer;
begin
 result:=flevels.Count;
end;
function TRowData.isEmpty:boolean;
begin
result:=frowtypes.count=0;
end;
procedure TColSet.AppendList(l:TColSet);
var i:integer;
begin
 for i:=0 to l.Count-1 do AppendCol(l[i]);
end;
procedure TColSet.AppendCol(col:integer);
begin
 if IndexOf(col)=-1 then Add(col);
end;
function TColSet.intersectList(l:TColSet):boolean;
var i:integer;
begin
result:=true;
 for i:=0 to l.Count-1 do
  if intersectCol(l[i]) then exit;
result:=false;  
end;
function TColSet.intersectCol(col:integer):boolean;
begin
 result:=IndexOf(col)>=0;
end;
procedure TEXLReportBands.CheckParent(band:TEXLReportBand);
var i,j:integer;
    plevel:string;
    name:string;

begin
 if band.Parent=nil then
 begin
 j:=0;
 name:=band.fName;
 for i:=1 to length(name) do
  if name[i]='_' then j:=i;
 if j=0 then exit;
 plevel:=copy(name,1,j-1);
 band.fParent:=ensurebandExists(plevel);
 end;
 CheckParent(band.Parent);
end;
function TEXLReportBand.isEmpty:Boolean;
begin
 result:=Count=0;
end;
function TRowData. isTotalRS :boolean;
var i:integer;
begin
result:=true;
for i:=0 to fRowValues.count-1 do
 result:=result and Boolean(fRowValues.Objects[i]);
end;
function TEXLReportBands.TotalRowSpan:boolean;
var i:integer;
begin
 result:=true;
 for i:=0 to UsedCount-1 do
  result:=result and UsedBands[i].Band.RowData.isTotalRS;
end;

function TEXLReportBands.firstBandbyName:TEXLReportBand;
var i:integer;
function  NormalBandName(Name:string):string;
var j:integer;
subName:string;
begin
result:='';
subName:='';
for j:=1 to Length(Name) do
if Name[j]='*' then result:=result+'*'
else
if Name[j]='_' then
begin
subName:=StringOfChar('0',4-Length(SubName))+subName;
result:=result+subname+'_';
subname:='';
end
else subname:=subName+Name[j];
subName:=StringOfChar('0',4-Length(SubName))+subName;
result:=result+subname;
subname:='';
end;
begin
 result:=nil;
 if Count=0 then exit;
 result:=Bands[0];
 for i:=1 to Count-1 do
  if NormalBandName(result.Name)>NormalBandName(Bands[i].Name) then
   result:=Bands[i];
end;
procedure TEXLReportBand.CalcChildrenIntersection;
var i,j,col:integer;
    cb:TEXLReportBand;
begin
 for i:=0 to fChildBands.Count-1 do
 begin
  cb:=TEXLReportBand(fchildBands[i]);
  fintersectchildren[i]:=0;
  for j:=0 to cb.Columns.Count-1 do
  begin
   col:=cb.Columns[j];
   if columns.IndexOf(col)>=0 then
   begin
    fintersectchildren[i]:=1;
    break;
   end;
  end;
 end;

end;
function TEXLReportBand.InterSects(Band:TEXLReportBand):boolean;
var cb:TEXLReportBand;
    i,ci:integer;
begin
cb:=Band.Parent;
while (cb<>nil)do
begin
 if not cb.Intersects1(Band) then
 begin
  result:=false;
  break;
 end;
 if cb=self then begin result:=true; break; end;
 Band:=cb;
 cb:=Band.Parent;
end;
end;
function TEXLReportBand.InterSects1(Band:TEXLReportBand):boolean;
var i:integer;
begin
 i:=fChildBands.IndexOf(Band);
 result:=false;
 if i<0 then exit;
 result:=fintersectchildren[i]=1;
end;
function TEXLReportBands.DirectInterSects(Band1,Band2:TEXLReportBand):boolean;
var pos1,pos2:integer;
begin
 pos1:=FBandList.IndexOf(Band1);
 pos2:=FBandList.IndexOf(Band2);
 result:=false;
 if (pos1<0)or(pos2<0) then exit;
 result:=(finterSection.IndexOf(pos1 or (pos2 shl 8))>=0)or
         (finterSection.IndexOf(pos2 or (pos1 shl 8))>=0);

end;
procedure TEXLReportBands.CalcInterSection;
var i,j,k,c:integer;
    b1,b2:TEXLReportBand;
begin
fintersection.clear;
 for i:=0 to Count-2 do
  begin
   b1:=Bands[i];
   for j:=i+1 to Count-1 do
   begin
    b2:=Bands[j];
    for k:=0 to b2.Columns.Count-1 do
    begin
     c:=b2.columns[k];
     if b1.Columns.IndexOf(c)>=0 then
     begin
      fintersection.add(i shl 8 or j);
      break;
     end;
    end;
   end;
  end;
end;
end.
