unit DCOMMON;
{
(c) . .  , . .  1997,2006
}
{$INCLUDE Compmode.inc}
interface
uses classes,comctrls;
type
TModelObject=     packed        record
                                n:integer;
                                otype:word;
                                changed:boolean;
                                name,author,comment:string;
                                crtime:TDateTime;
                                li:TListItem;
                                sp1,sp2,sprt:longword;
                                PRS,grp:word;
                                prsSubst:word;
                                ABCCls:word;
                               end;
PModelObject=^TModelobject;
TPRODescription=record
                 n:integer;
                 name:string;
                 ptype:word;
                end;
PPRODescription=^TPRODescription;
TProUseData= packed record
             id:integer;
             direction:byte;
             idleft,idright:integer;
             flags:longint;
             addinfo:longint;
            end;
TModelArray=class;
TModelArray=class
private
{$IFNDEF ED}
fMC:TList;
{$ELSE}
fMC:array[1..150] of TModelObject;
{$ENDIF}
{$IFDEF ED}
fsprcount,fprocount,fbpcount,frepcount:integer;
{$ENDIF}
fcount:integer;
tempid:integer;
protected
function getMC(index:integer):PModelObject;
public
Constructor Create;
destructor Destroy;override;
function getModelObjectByID(id:integer):PModelObject;
function AddMO(mo:TModelObject):PModelObject;
function AddNewMO:PModelObject;
procedure Clear;
procedure FreeObjectN(i:integer);
procedure FreeObjectID(id:integer);
procedure FreeObject(mo:PModelObject);
procedure SetModel(s:TStream);
procedure fillPROList(s,d:integer;visibleonly,prssubstitution,prssplit:boolean;L:TModelArray);
procedure fillMPROList(s,d:integer;visibleonly,prssubstitution:boolean;L:TModelArray);
procedure fillPROListDirect(s,d:integer;visibleonly:boolean;L:TModelArray);
procedure fillType(otype:integer;list:TStrings);
property MCont[index:integer]:PModelObject read getMC;default;
property Count:integer read fcount;
{$IFDEF ED}
property SPRCount:integer read fsprcount;
property PROCount:integer read fprocount;
property REPCount:integer read frepcount;
property BPCount:integer read fbpcount;
{$ENDIF}

end;
TSetOptions=function(AllItems,SelItem:TList):integer;
TGetCaption=function:string;
TMainDLLProc=function(dirs,prjs:Tlist):integer;

TProData=record              kind:integer;
                             mp:PModelObject;
                             usein,used:boolean;
                             end;
PProData=^TProData;

procedure clearMO(var mo:TModelObject);
//var modelName,modelavtor,modelComment:string;

implementation
uses logs,sysutils,appconst;
procedure clearModel(var ma:TModelArray);
begin
ma.Clear;
end;
procedure TModelArray.SetModel(s:TStream);
var r:array[1..5] of integer;
    i:integer;
    mo:integer;
    lmo:PModelObject;
begin
s.Seek(0,sofrombeginning);
while s.Read(r,sizeof(r))=sizeof(r) do
begin
mo:=0;
 for i:=1 to fCount do if MCont[i]^.n=r[1] then
 begin
 mo:=i;
 break;
 end;
if mo=0 then continue;
MCont[mo]^.prs:=r[2] and $FFFF;
MCont[mo]^.grp:=r[3] and $FFFF;
MCont[mo]^.prsSubst:=r[4] and $FFFF;
MCont[mo]^.ABCCls:=r[5] and $FFFF;
lmo:=getmodelobjectByID(MCont[mo]^.ABCCls);
if (lmo=nil)or(lmo^.otype<>appconst.SPRID) then
MCont[mo]^.ABCCls:=0;
lmo:=getmodelobjectByID(MCont[mo]^.prs);
if (lmo=nil)or(lmo^.otype<>appconst.SPRID) then
   MCont[mo]^.prs:=0;
lmo:=getModelObjectByID(MCont[mo]^.grp);
if (lmo=nil)or(lmo^.otype<>appconst.PROID) then
   MCont[mo]^.grp:=0;
lmo:=getModelObjectByID(MCont[mo]^.prsSubst);
if (lmo=nil)or(lmo^.otype<>appconst.SPRID) then
   MCont[mo]^.prsSubst:=0;
if (MCont[mo]^.prssubst<>MCont[mo]^.sp1)and
   (MCont[mo]^.prssubst<>MCont[mo]^.sp2)and
   (MCont[mo]^.prssubst<>MCont[mo]^.sprt) then
MCont[mo]^.prssubst:=MCont[mo]^.sp1;
end;
for i:=1 to fCount do
 if MCont[i]^.prs=0 then MCont[i]^.grp:=0;
end;
Constructor TModelArray.Create;
begin
 inherited create;
 fcount:=0;
 {$IFNDEF ED}
 fMC:=TList.create;
 {$ENDIF}
end;
function TModelArray.getModelObjectByID(id:integer):PModelObject;
var i:integer;
begin
 result:=nil;
 if id=0 then exit;
 for i:=1 to fcount do
  if MCont[i]^.n=id then
  begin
   result:=MCont[i];
   exit;
  end;
end;
function TModelArray.getMC(index:integer):PModelObject;
begin
{$IFDEF ED}
 result:=@fmc[index];
{$ELSE}
 result:=PModelObject(fmc[index-1]);
{$ENDIF}
end;
function TModelArray.AddMO(mo:TModelObject):PModelObject;
var newo:PModelObject;
begin
inc(fcount);
{$IFDEF ED}
if fcount>150 then raise exception.Create('Can''t make more');
{$ENDIF}
{$IFDEF ED}
case mo.otype of
SPRID:inc(fsprcount);
PROID:inc(fprocount);
NEWBPID:inc(fbpcount);
REPID:inc(frepcount);
end;
fmc[fcount]:=mo;
result:=@fmc[fcount];
{$ELSE}
new(newo);
newo^:=mo;
fmc.add(newo);
result:=newo;
{$ENDIF}
end;
function TModelArray.AddNewMO:PModelObject;
var newo:PModelObject;
begin
inc(fcount);
dec(tempID);
{$IFDEF ED}
clearMO(fmc[fcount]);
result:=@fmc[fcount];
{$ELSE}
new(newo);
clearMO(newo^);
fmc.add(newo);
result:=newo;
{$ENDIF}
result^.n:=tempID;
end;
procedure TModelArray.Clear;
var i:integer;
begin
 fcount:=0;
 tempID:=-32;
{$IFDEF ED}
 fsprcount:=0;
 fprocount:=0;
 frepcount:=0;
 fbpcount:=0;
 for i:=1 to 150 do
 clearMO(fmc[i]);
{$ELSE}
 for i:=0 to fmc.Count-1 do
 begin
  dispose(PModelObject(fmc[i]));
 end;
 fmc.clear;
{$ENDIF}
end;
procedure TModelArray.fillPROList(s,d:integer;visibleonly,prssubstitution,prssplit:boolean; L:TModelArray);
var i:integer;
    ts:set of byte;
    cs,cd,cm:integer;
    ok:boolean;
    templ,fullList:TStringList;
begin
logs.startproc('FillProList',inttostr(s),inttostr(d),inttostr(l.count),8);
ts:=[PROID];
templ:=TStringList.create;
fulllist:=TStringList.Create;
try
for i:=1 to fCount do
     with MCont[i]^ do
     if (not visibleonly or assigned(li))and(otype in ts)
     then
     begin
     cs:=sp1;
     cd:=sp2;
     cm:=sprt;
     ok:=false;
     if
     ((
     ((cs=d))and((cd=s))or
     ((cd=d))and((cs=s))or
     ((cs=d))and((cm=s))or
     ((cd=d))and((cm=s))or
     ((cm=d))and((cd=s))or
     ((cm=d))and((cs=s))
     )) then ok:=true;
                    
     if ok  then
      begin
logs.startproc('FillProList',inttostr(l.count),inttostr(MCont[i]^.n),MCont[i]^.name,18);
      templ.AddObject(MCont[i]^.name,TObject(MCont[i]));
//      l[size].direct:=dir;
      end;
     end;
templ.Sort;
fulllist.AddStrings(templ);

if prssubstitution then
begin
templ.clear;
for i:=1 to fCount do
     with MCont[i]^ do
     if (not visibleonly or assigned(li))and(otype in ts)and(fulllist.indexofObject(TObject(MCont[i]))=-1)
     then
     begin
     cs:=sp1;
     cd:=sp2;
     cm:=sprt;
     ok:=false;
     if sp1=prssubst then cs:=prs;
     if sp2=prssubst then cd:=prs;
     if sprt=prssubst then cm:=prs;
               if
     ((
     ((d in [sp1,cs]))and((s in [sp2,cd]))or
     ((d in [sp2,cd]))and((s in [sp1,cs]))or
     ((d in [sp1,cs]))and((cm=s))or
     ((d in [sp2,cd]))and((cm=s))or
     ((cm=d))and((s in [sp2,cd]))or
     ((cm=d))and((s in [sp1,cs]))
     )) then ok:=true;
     if ok  then
      begin
logs.startproc('FillProList',inttostr(l.count),inttostr(MCont[i]^.n),MCont[i]^.name,18);
      templ.AddObject(MCont[i]^.name,TObject(MCont[i]));
//      l[size].direct:=dir;
      end;
     end;
templ.Sort;
fulllist.AddStrings(templ);
end;
if prssplit then
begin
templ.Clear;
for i:=1 to fCount do
     with MCont[i]^ do
     if (not visibleonly or assigned(li))and(otype in ts)and(fulllist.indexofObject(TObject(MCont[i]))=-1)
     then
     begin
     ok:=false;
     cs:=sp1;
     cd:=sp2;
     cm:=sprt;
     if prssplit and(sp1=prssubst){and(sprt=0)} then begin cd:=prs;cs:=sp1; end;
     if prssplit and(sp2=prssubst){and(sprt=0)} then begin cs:=prs; cd:=sp2; end;
     if      ((cs=d))and((cd=s))or
             ((cd=d))and((cs=s)) then ok:=true;

     if ok  then
      begin
logs.startproc('FillProList',inttostr(l.count),inttostr(MCont[i]^.n),MCont[i]^.name,18);
      templ.AddObject(MCont[i]^.name,TObject(MCont[i]))
//      l[size].direct:=dir;
      end;
     end;
templ.Sort;
fulllist.AddStrings(templ);
end;
for i:=0 to fulllist.Count-1 do
l.AddMO(PModelObject(fulllist.Objects[i])^);
finally
templ.free;
fulllist.free;
end;
logs.startproc('FillProList',inttostr(s),inttostr(d),'done'+inttostr(l.count),8);
end;
procedure TModelArray.fillPROListDirect(s,d:integer;visibleonly:boolean;L:TModelArray);
var i:integer;
    ts:set of byte;
    ok:boolean;
begin
logs.startproc('FillProListDirect',inttostr(s),inttostr(d),inttostr(l.count),8);
ts:=[PROID];
for i:=1 to fCount do
     with MCont[i]^ do
     if (not visibleonly or assigned(li))and(otype in ts)
     then
     begin
     ok:=false;
     if ((s=0)or(s=sp1))and((d=0)or(d=sp2)) then ok:=true
     else
     if ((s=0)or(s=sp2))and((d=0)or(d=sp1)) then ok:=true;
     if ok  then
      begin
logs.startproc('FillProListDirect',inttostr(l.count),inttostr(MCont[i]^.n),MCont[i]^.name,18);
       l.addMO(MCont[i]^);
//     l[size].direct:=dir;
      end;
     end;
logs.startproc('FillProListDirect',inttostr(s),inttostr(d),'done'+inttostr(l.count),8);
end;

procedure TModelArray.fillMPROList(s,d:integer;visibleonly,prssubstitution:boolean;L:TModelArray);
var i:integer;
    ts:set of byte;
    ok:boolean;
begin
logs.startproc('fillMPROList',inttostr(s),inttostr(d),inttostr(l.count),8);
ts:=[NEWBPID];
for i:=1 to fCount do
     with MCont[i]^ do
     if (not visibleonly or assigned(li))and(otype in ts)
     then
     begin
     ok:=false;
     if (s=sp1)or(d=sp1) then ok:=true
     else if prssubstitution then
     begin
      if (s=sprt)or(d=sprt) then ok:=true
     end ;
     if ok  then
      begin
logs.startproc('fillMPROList',inttostr(l.count),inttostr(n),name,18);
       l.addMO(MCont[i]^);
//     l[size].direct:=dir;
      end;
     end;
logs.startproc('fillMPROList',inttostr(s),inttostr(d),'done'+inttostr(l.count),8);
end;
procedure clearMO(var mo:TModelObject);
begin
 with mo do
 begin
 n:=0;
 otype:=0;
 sp1:=0;
 sp2:=0;
 sprt:=0;
 name:='';
 crtime:=0;
 prs:=0;
 grp:=0;
 prssubst:=0;
 author:='';
 changed:=false;
 end;
end;
procedure TModelArray.FreeObjectN(i:integer);
begin
freeObject(MCont[i]);
end;
procedure TModelArray.FreeObjectID(id:integer);
var mo:PModelObject;
begin
mo:=getModelObjectByID(id);
freeObject(mo);
end;
procedure TModelArray.FreeObject(mo:PModelObject);
begin
if mo=nil then exit;
{$IFDEF ED}
case mo^.otype of
SPRID:dec(fsprcount);
PROID:dec(fprocount);
NEWBPID:dec(fbpcount);
REPID:inc(frepcount);
end;
{$ENDIF}
mo^.otype:=$FF;
end;
procedure TModelArray.fillType(otype:integer;list:TStrings);
var i:integer;
begin
list.Clear;
list.AddObject('',nil);
 for i:=1 to fCount do
 if (MCont[i]^.otype=otype) then
 list.addObject(MCont[i]^.name,TObject(MCont[i]));
end;
destructor TModelArray.Destroy;
begin
Clear;
{$IFNDEF ED}
fmc.free;
{$ENDIF}
inherited destroy;
end;
end.
