unit itXML;
{
(c) . .   1997,2006
}
{$INCLUDE Compmode.inc}

interface
uses items,classes,dcommon;
procedure PRODTD(XMLData:TStrings);
procedure CLSDTD(XMLData:TStrings);
procedure MODELDTD(XMLData:TStrings);
procedure PARAMSDTD(XMLData:TStrings);
function LinkToXML(data:TOMLink;XMLData:TStrings):integer;
function LinksToXML(mo:PModelobject; data:TLiteLinks;XMLData:TStrings):integer;
function ClsToXML(mo: PModelObject; data:TOMItems;XMLData:TStrings):integer;
function LeveltoXML(data:TOMItems;root:integer;XMLData:TStrings):integer;
function ItemtoXML(data:TOMItem;XMLData:TStrings):integer;
function PARAMStoXML(Caption,Author,Comment:string;MDDate:TDateTime;XMLData:TStrings):integer;
function toCData(s:string):string;
function XMLDate(date:TDateTime):string;
function DateXML(s:string):TDateTime;
implementation
uses sysutils,utils,strUtils, UChoice,appconst;
function LeveltoXML(data:TOMItems;root:integer;XMLData:TStrings):integer;
var i:integer;
begin
if root=0 then exit;
i:=root;
XMLData.Add('<GROUP>');
While i>0 do
begin
if data[i].deleted=0 then
begin
XMLData.add('<ITEM ID="ID'+inttostr(data[i].idloaded)+'">');
itemtoXML(data[i],XMLData);
if not data[i].closed then
leveltoXML(data,data[i].firstchild,XMLData);
XMLData.add('</ITEM>');
end;
i:=data[i].nextitem;
end;
XMLData.Add('</GROUP>');
end;
function ItemtoXML(data:TOMItem;XMLData:TStrings):integer;
var parsed:TStringList;
     i,j:integer;
     oldindex:integer;
begin
 XMLData.Add('<ITEMDATA>');
 XMLData.Add('<NAME>');
 XMLData.add(toCData(data.s));
 XMLData.Add('</NAME>');
 XMLData.Add('<COMMENT>');
 XMLData.Add(toCData(utils.cutCR(data.comment)));
 XMLData.Add('</COMMENT>');
 XMLData.Add('</ITEMDATA>');
end;
function toCData(s:string):string;
var p:integer;
begin
result:='';
s:=ClearSpaces(s);
if s='' then exit;
if not StrContain(s,['&','<','>']) then begin result:=s;exit; end;
s:=strutils.AnsiReplaceStr(s,'&','&amp;');
s:=strutils.AnsiReplaceStr(s,'<','&lt;');
s:=strutils.AnsiReplaceStr(s,'>','&gt;');

result:=s;
end;
function DateXML(s:string):TDateTime;
var oldFormat:string;
    parsed:TStringList;
    pos:integer;
    year,month,day:word;
begin
result:=Now;
decodeDate(Result,Year,Month,Day);
if s='' then exit;
parsed:=TStringList.Create;
try
ExtractStrings(['-'],[],PChar(s),parsed);
pos:=parsed.count;
if pos>0 then
Day:=StrTointDef(parsed[pos-1],day);
dec(pos);
if pos>0 then
Month:=StrTointDef(parsed[pos-1],Month);
dec(pos);
if pos>0 then
Year:=StrTointDef(parsed[pos-1],Year);
finally
parsed.free;
end;
result:=EncodeDate(Year,Month,Day);
end;
function XMLDate(date:TDateTime):string;
begin
 DatetimeToString(result,'YYYY-MM-DD',date);
end;
procedure CLSDTD(XMLData:TStrings);
begin
XMLData.Add('<!ELEMENT ORGMASTER_ITEMSET (OBJECTPARAMS,GROUP)>');
XMLData.Add('<!ELEMENT CAPTION (#PCDATA)>');
XMLData.Add('<!ELEMENT GROUP (ITEM*)>');
XMLData.Add('<!ELEMENT ITEM (ITEMDATA,GROUP?)>');
XMLData.Add('<!ELEMENT ITEMDATA (NAME,COMMENT)>');
XMLData.Add('<!ELEMENT NAME (#PCDATA)>');
XMLData.Add('<!ELEMENT COMMENT (#PCDATA)>');
XMLData.Add('<!ATTLIST ORGMASTER_ITEMSET ID ID #REQUIRED>');
XMLData.Add('<!ATTLIST ITEM ID CDATA #REQUIRED>');
end;
procedure PRODTD(XMLData:TStrings);
begin
XMLData.Add('<!ELEMENT ORGMASTER_LINKSET (OBJECTPARAMS,CLASS_LEFT,CLASS_RIGHT,CLASS_NAMES,CLASS_PROCESS,CLASS_INDEX,LINKS)>');
XMLData.Add('<!ELEMENT LINKS (LINK*)>');
XMLData.Add('<!ELEMENT LINK (LEFT,RIGHT,NAME?,PROCESS,OTHER_PROCESS?,INDEX,KIND,SCALE,LINK_COMMENT,PARAMS)>');
XMLData.Add('<!ELEMENT LINK_COMMENT (#PCDATA)>');
XMLData.Add('<!ATTLIST ORGMASTER_LINKSET ID ID #REQUIRED>');
XMLData.Add('<!ATTLIST CLASS_LEFT ID CDATA #REQUIRED>');
XMLData.Add('<!ATTLIST CLASS_RIGHT ID CDATA #REQUIRED>');
XMLData.Add('<!ATTLIST CLASS_NAMES ID CDATA #REQUIRED>');
XMLData.Add('<!ATTLIST CLASS_PROCESS ID CDATA #REQUIRED>');
XMLData.Add('<!ATTLIST CLASS_INDEX ID CDATA #REQUIRED>');
XMLData.Add('<!ATTLIST LEFT ID CDATA #REQUIRED>');
XMLData.Add('<!ATTLIST RIGHT ID CDATA #REQUIRED>');
XMLData.Add('<!ATTLIST NAME ID CDATA #REQUIRED>');
XMLData.Add('<!ATTLIST PROCESS ID CDATA #REQUIRED>');
XMLData.Add('<!ATTLIST OTHER_PROCESS ID CDATA #REQUIRED>');
XMLData.Add('<!ATTLIST INDEX ID CDATA #REQUIRED>');
XMLData.Add('<!ATTLIST PARAMS tunneled (0|1) "0">');
XMLData.Add('<!ATTLIST PARAMS grouping (0|1) "1">');
end;
procedure MODELDTD(XMLData:TStrings);
begin
XMLData.Add('<!ELEMENT ORGMASTER_MODEL (MODELPARAMS,CLASSLIST,PROJECTIONLIST)>');
XMLData.Add('<!ELEMENT CLASSLIST (ORGMASTER_ITEMSET*)>');
XMLData.Add('<!ELEMENT PROJECTIONLIST (ORGMASTER_LINKSET*)>');
end;
procedure PARAMSDTD(XMLData:TStrings);
begin
XMLData.Add('<!ELEMENT OBJECTPARAMS (OBJECTNAME,OBJECTAUTHOR,OBJECTWRDATE,OBJECTCOMMENT)>');
XMLData.Add('<!ELEMENT OBJECTNAME (#PCDATA)>');
XMLData.Add('<!ELEMENT OBJECTAUTHOR (#PCDATA)>');
XMLData.Add('<!ELEMENT OBJECTWRDATE (#PCDATA)>');
XMLData.Add('<!ELEMENT OBJECTCOMMENT (#PCDATA)>');
end;
function LinkToXML(data:TOMLink;XMLData:TStrings):integer;
const LinkTypes:array[TPrjType,0..3] of string=
(('Right_to_Left','Left_to_Right','None','None'),
 ('Input','Output','Control','Output_Control'),
 ('Mechanism','Mechanism','Mechanism','Mechanism'),
 ('Control','Control','Control','Control'),
 ('Input','Output','Mechanism','Output_Mechanism'));
begin
XMLData.Add('<LINK>');
XMLData.Add('<LEFT ID="ID'+inttostr(data.s)+'"/>');
XMLData.Add('<RIGHT ID="ID'+inttostr(data.d)+'"/>');
if data.ldb<>0  then
XMLData.Add('<NAME ID="ID'+inttostr(-data.ldb)+'"/>');
XMLData.Add('<PROCESS ID="ID'+inttostr(data.ProcID)+'"/>');
if data.procid2<>data.procid then
XMLData.Add('<OTHER_PROCESS ID="ID'+inttostr(data.ProcID2)+'"/>');
XMLData.Add('<INDEX ID="ID'+inttostr(data.ABCID)+'"/>');
XMLData.Add('<KIND type="'+linktypes[data.owner.prjtype,data.flags and 3]+'" value="'+inttostr(data.flags and 3)+'"/>');
XMLData.Add('<LINK_COMMENT>');
XMLData.Add(toCData(data.LinkComment));
XMLData.Add('</LINK_COMMENT>');

XMLData.Add('<PARAMS tunneled="'+Boolean10[data.flags and lcTonnel=lcTonnel]+'" grouping="'+Boolean10[not(data.flags and lcNoneGroup=lcNoneGroup)]+'"/>');
XMLData.Add('</LINK>');
end;
function LinksToXML(mo: PModelObject;data:TLiteLinks;XMLData:TStrings):integer;
var i:integer;
    r1,r2,r3,r4:integer;
    rt:string;
begin
if mo=nil then exit;
XMLData.Add('<ORGMASTER_LINKSET ID="ID'+inttostr(data.proid)+'">');
ParamsToXML(mo^.name,mo^.author,mo^.Comment,mo^.CrTime,XMLData);
XMLData.Add('<CLASS_LEFT ID="ID'+inttostr(data.left.dirid)+'"/>');
XMLData.Add('<CLASS_RIGHT ID="ID'+inttostr(data.Right.dirid)+'"/>');
if data.Middle<>nil then
begin
XMLData.Add('<CLASS_NAMES ID="ID'+inttostr(data.Middle.dirid)+'"/>');
end
else
begin
XMLData.Add('<CLASS_NAMES ID="0"/>');
end;
if data.PRC<>nil then
XMLData.Add('<CLASS_PROCESS ID="ID'+inttostr(data.Prc.dirid)+'"/>')
else
XMLData.Add('<CLASS_PROCESS ID="0"/>');
if data.ABCMap<>nil then
XMLData.Add('<CLASS_INDEX ID="ID'+inttostr(data.ABCMap.dirid)+'"/>')
else
XMLData.Add('<CLASS_INDEX ID="0"/>');
XMLData.Add('<PICTOGRAMS set="'+inttostr(r1)+'"/>');
XMLData.Add('<LINKS>');
for i:=1 to data.sizetotal do
LinkToXML(data.itemsNF[i],XMLData);
XMLData.Add('</LINKS>');
XMLData.Add('</ORGMASTER_LINKSET>');
end;
function ClsToXML(mo: PModelObject;data:TOMItems;XMLData:TStrings):integer;
var i:integer;
    oldindex:integer;
begin
XMLData.Add('<ORGMASTER_ITEMSET ID="ID'+inttostr(data.dirid)+'">');
if MO<>nil then
ParamsToXML(mo^.name,mo^.author,mo^.Comment,mo^.CrTime,XMLData);
leveltoXML(data,data.Root,XMLData);
XMLData.Add('</ORGMASTER_ITEMSET>');
end;
function PARAMStoXML(Caption,Author,Comment:string;MDDate:TDateTime;XMLData:TStrings):integer;
begin
XMLData.Add('<OBJECTPARAMS>');
XMLData.Add('<OBJECTNAME>');
XMLData.add(toCData(Caption));
XMLData.Add('</OBJECTNAME>');
XMLData.Add('<OBJECTAUTHOR>');
XMLData.add(toCData(Author));
XMLData.Add('</OBJECTAUTHOR>');
XMLData.Add('<OBJECTWRDATE>');
XMLData.add(XMLDate(MDDAte));
XMLData.Add('</OBJECTWRDATE>');
XMLData.Add('<OBJECTCOMMENT>');
XMLData.add(toCData(Comment));
XMLData.Add('</OBJECTCOMMENT>');
XMLData.Add('</OBJECTPARAMS>');
end;
end.
