Unit StyleDef;
{
(c) . .  , .   1997,2006
}
{$INCLUDE Compmode.inc}
{ Modified 14-03-2001 }

Interface

Uses Windows,SysUtils;

Type   TStyleString = String[64];

       TReservedString = String[124];

       TFontSizeUnits=(fsuPt,fsuIn,fsuMm,fsuCm,fsuPc,fsuPx,fsuEm,fsuEx);

       TFontWeight=(fwExtraLight,fwLight,fwDemiLight,fwMedium,fwDemiBold,
                    fwBold,fwExtraBold,fwBorder,fwLighter);

       TFontStyle=(fsItalic,fsOblique,fsSmallCaps,fsNone);

       TTextDecoration=(tdUnderline,tdOverline,tdLineThrough,tdBlink,tdNone);

       TTextTransform=(ttCapitalize,ttUppercase,ttLowercase,ttNone);

       TVerticalAlign=(vaBaseline,vaBottom,vaMiddle,vaSub,vaSuper,
                       vaTextBottom,vaTextTop,vaTop);

       TTextAlign=(taCenter,taJustify,taLeft,taRight);

       TPosition=(pRelative,pAbsolute,pStatic);

       TOverflow=(oVisible,oHidden,oScroll,oAuto);

       TBorderType=(btDotted,btDashed,btSolid,btDouble,btGroove,
                    btRidge,btInset,btOutset,btNone);

       TVisibilityType=(vtInherit,vtVisible,vtHidden);

       TListStyle=(lsDisc,lsCircle,lsSquare,lsDecimal,
                   lsLowerRoman,lsUpperRoman,lsLowerAlpha,lsUpperAlpha,
                   lsNone);

       TDirectionType=(dtLeft,dtRight);

       TWhiteSpace=(wsPre,wsNowrap,wsNormal);

       TMarksType=(mtCrop,mtCross,mtNone);

       TOrientation=(orAuto,orLandscape,orPortrait);

       TPageBreak=(pbAlways,pbAuto,pbLeft,pbRight);

Const  ttBoxIn  = 0;             { Const for transition type }
       ttBoxOut = 1;
       ttCircleIn = 2;
       ttCircleOut = 3;
       ttWipeUp = 4;
       ttWipeDown = 5;
       ttWipeRight = 6;
       ttWipeLeft = 7;
       ttVerticalBlinds = 8;
       ttHorizontalBlinds = 9;
       ttCheckerBoardAcross = 10;
       ttCheckerBoardDown = 11;
       ttRandomDissolve = 12;
       ttSplitVerticalIn = 13;
       ttSplitVerticalOut = 14;
       ttSplitHorizontalIn = 15;
       ttSplitHorizontalOut = 16;
       ttStripsLeftDown = 17;
       ttStripsLeftUp = 18;
       ttStripsRightDown = 19;
       ttStripsRightUp = 20;
       ttRandomHorizontalBars = 21;
       ttRandomVerticalBars = 22;
       ttRandomTransition = 23;


Type

  (*    #BODY {  font-family: "Arial";
                 color: black                 or color: #999999
                }


    *)
       PStyleRecord = ^TStyleRecord;
       TStyleRecord = packed record
          ID:DWORD;
          StyleName:TStyleString; { Style Name in CSS }

          { Font Setting }
          FontEnabled:Boolean;    { Enable Font-family subtag }
          Font:TStyleString;      { font-family: "Arial"; }

          FontSizeEnabled:Boolean;    { Enable Font-Size subtag }
          FontSize:Word;                { font-size : 14pt; }
          Flags:Word;                   { For A.Zablozky only }
          FontSizeUnits:TFontSizeUnits; { w/o fsu,smallcaps }

          FontWeightEnabled:Boolean;  { Enable Font-Weight subtag }
          FontWeight:TFontWeight;     { font-weight : extra-light; }

          FontStyleEnabled:Boolean;   { Enable font-style subtag }
          FontStyle:TFontStyle;       { font-style : italic; }

          TextDecorationEnabled:Boolean; { Enable text-decoration subtag }
          TextDecoration:TTextDecoration; { text-decoration : underline; }

          TextTransformEnabled:Boolean;   { Enabled text-transform subtag }
          TextTransform:TTextTransform;   { text-transform : capitalize;  }

          FontColorEnabled:Boolean;       { enable color subtag }
          FontColor:DWORD;               { color : #0099FF; }

          BackColorEnabled:Boolean;       { enable background subtag }
          BackColor:DWORD;               { background : #00FF00; }

          { Align Settings }
          TextIndentEnabled:Boolean;
          TextIndent:Integer;              { text-indent : 8pt; }

          LeadingSpaceEnabled:Boolean;
          LeadingSpace:Integer;           { leading-space : 12pt; }

          WordSpacingEnabled:Boolean;
          WordSpacing:Integer;            { word-spacing : 8pt; }

          LetterSpacingEnabled:Boolean;
          LetterSpacing:Integer;          { letter-spacing : 10pt; }

          VerticalAlignEnabled:Boolean;
          VerticalAlign:TVerticalAlign;   { vertical-align : baseline; }

          TextAlignEnabled:Boolean;
          TextAlign:TTextAlign;           { text-align : center; }

          { Position settings }


          { Borders setting }
          LeftMarginEnabled:Boolean;
          LeftMargin:Integer;             { margin-left : 1pt; }
          LeftMarginUnits:TFontSizeUnits; { in @page }

          RightMarginEnabled:Boolean;
          RightMargin:Integer;             { margin-right : 1pt; }
          RightMarginUnits:TFontSizeUnits; { in @page }

          BottomMarginEnabled:Boolean;
          BottomMargin:Integer;             { margin-bottom : 1pt; }
          BottomMarginUnits:TFontSizeUnits; { in @page }

          TopMarginEnabled:Boolean;
          TopMargin:Integer;                { margin-top : 1pt; }
          TopMarginUnits:TFontSizeUnits;    { in @page }

          LeftBorderEnabled:Boolean;
          LeftBorder:TBorderType;            { border-left : dotted; }

          RightBorderEnabled:Boolean;
          RightBorder:TBorderType;           { border-right : dotted; }

          TopBorderEnabled:Boolean;
          TopBorder:TBorderType;             { border-top : dotted; }

          BottomBorderEnabled:Boolean;
          BottomBorder:TBorderType;           { border-bottom : dotted; }

          { Printing settings - only with @page StyleName }

          MarksEnabled:Boolean;
          MarksType:TMarksType;               { marks : crop; }

          OrientationEnabled:Boolean;
          Orientation:TOrientation;           { size : portrait; }

          PBBEnabled:Boolean;
          PageBreakBefore:TPageBreak;         { page-break-before : right; }

          PBAEnabled:Boolean;
          PageBreakAfter:TPageBreak;          { page-break-after : right; }


          ListStyleEnabled:Boolean;
          ListStyle:TListStyle;              { list-style : circle; }


          WhiteSpaceEnabled:Boolean;
          WhiteSpace:TWhiteSpace;            { white-space : nowrap }
          ShowSystemChars:Boolean;           { Show/hide system chars }
          Next:PStyleRecord;                 { Pointer to next CSS record }

       end;
const       
STNewName:array[0..62] of TStyleString=
         ('@page','ASSERT_SHEET','HEADER','PREAMBULA','POSTSCRIPTUM','SIGNATURE_SHEET','COORDINATE_SHEET',
          'PARTITION','LEVEL_1','LEVEL_2','LEVEL_3','LEVEL_4'
         ,'LEVEL_5','LEVEL_6','LEVEL_7','LEVEL_8','LEVEL_9'
         ,'LEVEL_10','LEVEL_11','LEVEL_12','LEVEL_13','LEVEL_14'
         ,'LEVEL_15','OBRPRJ_1','OBRPRJ_2'
         ,'OBRPRJ_3','OBRPRJ_4','OBRPRJ_5'
         ,'OBRPRJ_6','OBRPRJ_7','OBRPRJ_8'
         ,'OBRPRJ_9','OBRPRJ_10','OBRPRJ_11'
         ,'OBRPRJ_12','OBRPRJ_13','OBRPRJ_14'
         ,'OBRPRJ_15','PRJSUBHEADER','COMMENT',
         'COMMENT_HEADER','DIRECTION_HEADER','INDEX',
         'LINK_NAME','PRJ_DETAIL','PRJ_1','PRJ_2',
         'PRJ_3','PRJ_4','PRJ_5','PRJ_6','PRJ_7',
         'PRJ_8','PRJ_9','PRJ_10','PRJ_11','PRJ_12',
         'PRJ_13','PRJ_14','COLUMN_HEADER','SUBHEADER',
         'POSITION_TYPE','SECOND_COLUMN');

      STOldName:array[0..62] of TStyleString=
         ('@page',' ','','','',' ',' ',
          '',' 1',' 2',' 3',' 4'
         ,' 5',' 6',' 7',' 8',' 9'
         ,' 10',' 11',' 12',' 13',' 14'
         ,' 15','  1','  2'
         ,'  3','  4','  5'
         ,'  6','  7','  8'
         ,'  9','  10','  11'
         ,'  12','  13','  14'
         ,'  15','  ','',
         ' ',' ','',
         ' ','  ',' 1',' 2',
         ' 3',' 4',' 5',' 6',' 7',
         ' 8',' 9',' 10',' 11',' 12',
         ' 13',' 14',' ','',
         ' ','');

Implementation

end.