unit txthtml;
{
(c) . . , .   1997,2006
}
{$INCLUDE Compmode.inc}
interface

Uses Windows,SysUtils,Classes,Graphics,Forms,StyleDef,StyleStr;

Type
    TFileformat=(ffRTF,ffHTML);
    TFileFormats=set of TFileformat;
    TBlank=record
           Grif,Firma,CnfPosition,CnfFIO:String;
           CnfDate:TDateTime;
           useCNF:boolean;
           
           end;
    TTxtToHtmlConverter=class
     private
      {!}
       FRoot,FZeroRoot:PStyleRecord;
       RootID:integer;
       CSSStyles:array[1..16] of record FRoot:PStyleRecord; ID:integer;used:array[0..62] of boolean;end;
       StylesCount:integer;
       RootIndex:integer;
       FCSSFileName:String;
       incomment:boolean;
      {!}
       FSource:TStringList;
       FDest:TStringList;
       RTFFonts,RTFColors:TStringList;
       FStream:TStyleStream;
       FTitle,FAuthor,FCompany:String;
       FLSEnabled:Boolean;
       FUL:Boolean;
//       tablemode:boolean;
       FBgColor:String;        {!!!}
       FStyle2Column:Boolean;  {!!!}
       FFirstColumnWidth:Word; {!!!}
       FTextAlign:TTextAlign;  {!!!}
       FVerticalAlign:TVerticalAlign; {!!!}
       FShowSystemChars:Boolean;
       rowcount:integer;
       used:array[0..62] of boolean;
       fRootLevel:integer;
      procedure   ClearUsed;
      procedure   Convert(razdl:TStrings;useJS:boolean);
//      Procedure   ConvertRTF2(var startendline:integer);
      procedure   AddStyleTable(where:TStrings;ID:integer);
      procedure   AddStyleTableRTF(where:TStrings;ID:integer);
      procedure   AddStyleRecord_P(p:PStyleRecord;name:String;where:TStrings;ID:integer);
      procedure   AddStyleRecord_FONT(p:PStyleRecord;name:String;where:TStrings;ID:integer);
      procedure   AddStyleRecordRTF_P(p:PStyleRecord;name:String;where,fonttable,colortable:TStrings;intable:boolean;ID:integer);
      procedure   AddStyleRecordRTF_FONT(p:PStyleRecord;name:String;where,fonttable,colortable:TStrings;intable:boolean;ID:integer);
      function    GetStyleRecord(id:Integer):PstyleRECORD;
      function    ColorToWeb(Value:TColor):String;
      function    IDToStyle(ind:Integer):String;
      function    GetParaID(Var source:String;Var dest:String;Var id:Integer):Boolean;
      function    GetFontID(Var source:String;Var dest:String;Var id:Integer):Boolean;
      function    ProcessHTMLSpecial(s:string):string;
      function    CheckForSubHeader(Var dest:String):Boolean;
      function    CheckForRazdel(Var dest:String):Boolean;
      function    CheckForLevel(Var dest:String;Var level:Integer):Boolean;
      function    CheckForPrj(Var dest:String;Var level:Integer):Boolean;
      function    CheckForObrPrj(Var dest:String;Var level:Integer):Boolean;
      function    CheckForComment(Var dest:String):Boolean;
      function    CheckForCommentHeader(Var dest:String):Boolean;
      function    CheckForDirHeader(Var dest:String):Boolean;
      function    CheckForLinkName(Var dest:String):Boolean;
      function    CheckForIndex(Var dest:String):Boolean;
      function    CheckForPrjCaption(Var dest:String):Boolean;
      function    HasNext(s:String):Integer;
      procedure   CopySD(Var source:String;Var dest:String;count:Integer);
      function    CheckForDetail(Var dest:String):Boolean;
      function    CheckForLineComment(Var dest:String):Boolean;
      function    CheckForProcess(Var dest:String):Boolean;
      procedure   CheckAndAddRowTag(Value:Integer;var FL:Boolean);
      procedure CheckAndAddDataTag(Value:Integer;var FL:Boolean;parafont:Boolean;oldDT:Integer);
      procedure   AppendLine(s1:String;Value:Integer;s2:String;useJS:Boolean;s3:String);
     public
      codepage,ModelName,rtflang:string;
      makeLinks:boolean;
      constructor Create;
      destructor  Destroy; override;
      procedure   Clear;
      procedure   OpenStream(Stream:TStringList;razdl:TStrings;useJS:boolean;tofile,tofilertf:TFilename);
      procedure   ConvertRTF(tofile:TFileName;CutFormat:boolean);
      procedure ConvertRTFFiles(tofile:TFileName;CutFormat:boolean);
      procedure AddCSSTemplate(id:integer;styleFileName:TFileName);
      procedure ClearStyles;
      function SubstStyle(s:string):string;
      property    CSSFileName:String read FCSSFileName write FCSSFileName;
      property    Title:String read FTitle write FTitle;
      property    Author:String read FAuthor write FAuthor;
      property    Company:String read FCompany write FCompany;
      property HTML:TStringList read fDest;
     end;

Const
       MIDRazdel=7;
       MIDLevel1=8;
       MIDLevel15=22;
       MIDObrPrj1=23;
       MIDObrPrj15=37;
       MIDPrjHeader=38;
       MIDComment=39;
       MIDCommentHeader=40;
       MIDDirHeader=41;
       MIDIndex=42;
       MIDLinkName=43;
       MIDPrjDetail=44;
       MIDPrjLevel1=45;
       MIDPrjLevel13=57;
       MIDSubHeader=60;
       MIDProcess=57;
      start_com='(*';   { Definition start of multi-line comment block }
      end_com='*)';     { Definition end of multi-line comment block }
      start_comh='* ';
      start_linecomment='/* ';
      start_dirheader=':: ';
      start_index='@@ ';
      end_comh=' *';
// modified 25/07/2k by Alexey  Zabloczkiy
      start_linkname='~~ ';
      start_header=' ';
      start_razdel='$$ ';
      start_obrprj='.';
      start_detail2='// ';
      start_prjCap='%%% ';
      start_prj1=' ';
      start_Prj2=' ';
      start_Prj3=' ';
      start_Prj4=' ';
      LTag:array[0..62] of integer=
        (0,0,0,0,0,0,0,
         128, 126,125,124,123,122,121,120,119,
         118,117,116,115,114,113,112,
         111,110,109,108,107,106,105,104,103,102,
         101,99,98,97,96,0,0,0,0,0,
         0,0,111,110,109,108,107,106,105,104,103,
         102,101,99,98,97,0,127,0,0);

      TableTag:array[0..62] of integer=
         (0,0,0,0,0,0,0,
          99, { Partition }
          126,126,126,126,126,126,126,126,126,126,126,126,126,126,126, { Levels }
          97,97,97,97,97,97,97,97,97,97,97,97,97,97,97, { ObrPrj }
          123, 121,
          122,0,0,0,0,
          97,92,87,82,77,72,67,62,57,52,47,42,37,32,0, { Prj }
          130,99,99);
      RowTag:array[0..62] of Integer=
         (0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
         ,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,1,1,0);

      DataTag:array[0..62] of Integer=
         (0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,2
         ,2,2,2,2,2,2,2,2,2,2,0,3,0,0,0,4,0,5,5,5,5,5,5,5,5,5,5,5,
          5,5,5,5,0,6,0);

      GroupTag:array[0..62] of Integer=
         (0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1
         ,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0);
      systemchars:array[0..62] of string[10]=
      ('','','','','','','',' ',      //7
      '','','','','','','','','','','','','','','', //22
      '.','.','.','.','.','.','.','.','.','.','.','.','.','.','.', //37
       '%%% ','','',':: ','@@ ','~~ ','// ', //44
       ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','','', //56
       '','','','$$ ','## ','|| ');

      


implementation
uses dialogs, logs, OleServer, items,appconst,comctrls,utils;


function    TTxtToHtmlConverter.HasNext(s:String):Integer;
 begin
    Result:=0;
   result:=pos(start_prj1,S);
   if result>0 then exit;
   result:=pos(start_prj2,S);
   if result>0 then exit;
   result:=pos(start_prj3,S);
   if result>0 then exit;
   result:=pos(start_prj4,S);
   if result>0 then exit;
   result:=pos(start_linkname,s);
   if result>0 then exit;
   result:=pos(start_detail2,s);
   if result>0 then exit;
   result:=pos(start_index,s);
   if result>0 then exit;
   result:=pos(start_dirheader,s);
   if result>0 then exit;
   result:=pos('{*',s);
   if result>0 then exit;
   result:=pos(start_linecomment,s);
   if result>0 then exit;
   result:=0;
 end;

function    TTxtToHtmlConverter.CheckForSubHeader(Var dest:String):Boolean;
Var j:Integer;
 begin
  {}
   j:=pos(start_header,dest);
   if j=1 then
    begin
      Result:=True;
      dest:=copy(dest,length(start_header)+1,length(dest));
    end
   else Result:=False;
 end;

function    TTxtToHtmlConverter.CheckForRazdel(Var dest:String):Boolean;
 begin
  {}
   Result:=False;
   if Length(dest)<2 then Exit;
   If pos(start_razdel,dest)=1 then
     begin
       dest:=copy(dest,length(start_razdel)+1,length(dest));
       Result:=True;
     end;
 end;

function    TTxtToHtmlConverter.CheckForLevel(Var dest:String;Var level:Integer):Boolean;
Var s1:String;
    c:char;
    p:PStyleRecord;
    indlen:Integer;
    newroot:boolean;
 begin
 if pos('%%L',dest)=1 then
 begin
  result:=true;
  s1:=copy(dest,4,pos(' ',dest)-4);
  level:=strTointDef(s1,1);
  dest:=copy(dest,pos(' ',dest),length(dest));
  exit;
 end;
    Result:=False;
   level:=0;
   s1:=dest;
 {   -   }
  if length(s1)=0 then Exit;
  indlen:=0;
  newroot:=false;
  if s1[1]='#' then begin delete(s1,1,1); inc(indlen); newroot:=true; end;
  if s1[1]='A' then begin delete(s1,1,1); inc(indlen); end;

  if length(s1)=0 then Exit;
  c:=' ';
  if (s1[1] in ['0'..'9']) then
begin
   while (length(s1)>0)and((s1[1] in ['0'..'9'])or(s1[1]='.')) do
   begin
   result:=true;
   if (s1[1]='.')or(dest[1]='A') then inc(level);
   c:=s1[1];
   delete(s1,1,1);
   inc(indlen);
   end;
if (c<>'.')and not((dest[1]='A')and(c in ['0'..'9'])) then result:=false;
if newroot then begin frootlevel:=level; level:=1; end;
//else level:=level+1;
if (level > 15) then level:=15;
 p:=GetStyleRecord(MIDLevel1+level-1);
  if not(p^.ShowSystemChars) then dest:=copy(dest,indlen+1,length(dest)-indlen)
  else if (dest<>'')and(dest[1]='#') then delete(dest,1,1);
end;

 end;

function    TTxtToHtmlConverter.CheckForPrj(Var dest:String;Var level:Integer):Boolean;
Var tmp:String;
    i:Integer;
 begin
  Result:=False;
  level:=0;
  if Length(dest)=0 then Exit;
  tmp:=dest;
  if tmp[1]='' then
                begin
                   dest:=copy(dest,2,length(dest)-1);
                   Result:=True;
                   level:=1;
                   Exit;
                end;
  if tmp[1]='' then
                begin
                   dest:=copy(dest,2,length(dest)-1);
                   Result:=True;
                   level:=2;
                   Exit;
                end;
  if tmp[1]='' then
                begin
                i:=1;
                while (i<length(dest))and(tmp[i]='') do inc(i);
                   dest:=copy(dest,i,length(dest)-1);
                   Result:=True;
                   level:=i+1;
                   Exit;
                end;
  {}
 end;

function    TTxtToHtmlConverter.CheckForObrPrj(Var dest:String;Var level:Integer):Boolean;
Var tmp:String;
      i:Integer;
 begin
 {}
 Result:=False;
 level:=0;
 if Length(dest)=0 then Exit;
 tmp:=dest;
 if (tmp[1]<>start_ObrPrj) then Exit;
 i:=1;
 while ((tmp[i]=start_ObrPrj) and (i<=Length(tmp))) do
  begin
    inc(level);
    inc(i);
  end;
 dest:=copy(dest,i+1,length(dest)-i);
 Result:=True;
 end;

function    TTxtToHtmlConverter.CheckForComment(Var dest:String):Boolean;
 begin
 {}
  Result:=False;
  if Length(dest)=0 then Exit;
  if pos(start_com,dest)=1 then
     begin
       dest:=copy(dest,3,length(dest));
       dest:=copy(dest,1,length(dest)-3);
      { s:=dest;
       dest:='';
       for i:=1 to length(s) do
       if (s[i]=#03)and(i<length(s))
       then dest:=dest+'<BR>'
       else dest:=dest+s[i];}

       Result:=True;
     end;
 end;

function    TTxtToHtmlConverter.CheckForCommentHeader(Var dest:String):Boolean;
 begin
 {}
   Result:=False;
   if Length(dest)=0 then Exit;
   If pos(start_comh,dest)=1 then
     begin
       dest:=copy(dest,3,length(dest)-2);
       Result:=True;
     end;
 end;

function    TTxtToHtmlConverter.CheckForDirHeader(Var dest:String):Boolean;
 begin
 {}
   Result:=False;
   if Length(dest)=0 then Exit;
   If pos(start_dirheader,dest)=1 then
     begin
       dest:=copy(dest,4,length(dest)-3);
       Result:=True;
     end;
 end;

function    TTxtToHtmlConverter.CheckForLinkName(Var dest:String):Boolean;
 begin
 {}
    Result:=False;
    if Length(dest)<2 then Exit;
    If pos(start_linkname,dest)=1 then
     begin
       dest:=copy(dest,4,length(dest)-3);
       Result:=True;
     end;
 end;
function    TTxtToHtmlConverter.CheckForPrjCaption(Var dest:String):Boolean;
 begin
 {}
   Result:=False;
   if Length(dest)=0 then Exit;
   If pos(start_prjCap,dest)=1 then
     begin
       dest:=copy(dest,5,length(dest)-4);
       Result:=True;
     end;
end;
function    TTxtToHtmlConverter.CheckForIndex(Var dest:String):Boolean;
 begin
 {}
   Result:=False;
   if Length(dest)=0 then Exit;
   If pos(start_index,dest)=1 then
     begin
       dest:=copy(dest,4,length(dest)-3);
       Result:=True;
     end;
 end;

procedure  TTxtToHtmlConverter.CopySD(Var source:String;Var dest:String;count:Integer);
 begin
 if count=0 then count:=length(dest)+1;
   source:=copy(dest,count,length(dest));
   dest:=copy(dest,1,count-1);
 end;

function  TTxtToHtmlConverter.GetParaID(Var source:String;Var dest:String;Var id:Integer):Boolean;
Var level:Integer;
    n:Integer;
 begin

  source:=TrimLeft(source);
  dest:=source;
  Result:=True;
  if CheckForSubHeader(dest) then
                             begin
                               ID:=MIDSubHeader;
                               n:=HasNext(dest);
                               CopySD(source,dest,n);
                               Exit;
                             end;
  if CheckForRazdel(dest) then
                             begin
                               ID:=MIDRazdel;
                               n:=HasNext(dest);
                               CopySD(source,dest,n);
                               Exit;
                             end;
  if CheckForLevel(dest,level) then
                             begin
                               ID:=MIDLevel1+level-1;
                               n:=HasNext(dest);
                               CopySD(source,dest,n);
                               Exit;
                             end;
  if CheckForPrj(dest,level) then
                             begin
                               ID:=MIDPrjLevel1+level-1;
                               n:=HasNext(dest);
                               CopySD(source,dest,n);
                               Exit;
                             end;
  if CheckForObrPrj(dest,level) then
                             begin
                               ID:=MIDObrPrj1+level-1;
                               n:=HasNext(dest);
                               CopySD(source,dest,n);
                               Exit;
                             end;
  if CheckForComment(dest) then
                             begin
                               ID:=MIDComment;
                               incomment:=true;
                               Exit;
                             end;
  if CheckForCommentHeader(dest) then
                             begin
                               ID:=MIDCommentHeader;
                               n:=HasNext(dest);
                               CopySD(source,dest,n);
                               Exit;
                             end;
  if CheckForDirHeader(dest) then
                             begin
                               ID:=MIDDirHeader;
                               n:=HasNext(dest);
                               CopySD(source,dest,n);
                               Exit;
                             end;
  if CheckForProcess(dest) then
                                   begin
                                   ID:=MIDProcess;
                                   n:=HasNext(dest);
                                   CopySD(source,dest,n);
                                   Exit;
                                   end;
  if CheckForLinkName(dest) then
                             begin
                               ID:=MIDLinkName;
                               n:=HasNext(dest);
                               CopySD(source,dest,n);
                               Exit;
                             end;
  if CheckForIndex(dest) then
                             begin
                               ID:=MIDIndex;
                               n:=HasNext(dest);
                               CopySD(source,dest,n);
                               Exit;
                             end;
 if CheckForPrjCaption(dest) then
                             begin
                               ID:=MIDPrjHeader;
                               n:=HasNext(dest);
                               CopySD(source,dest,n);
                               Exit;
                             end;
   if CheckForlinecomment(dest)     then
                                  begin
                                   ID:=MIDComment;
                                   n:=HasNext(dest);
                                   if (n<>0) then CopySD(source,dest,n) else
                                   source:='';
                                   Result:=True;
                                   Exit;
                                  end;
  ID:=MIDPrjHeader;
  n:=HasNext(dest);
  if (n<>0) then CopySD(source,dest,n);
 end;

function  TTxtToHtmlConverter.CheckForDetail(Var dest:String):Boolean;
 begin
   Result:=False;
       if (pos(start_detail2,dest)=1) then
          begin
            dest:='/'+copy(dest,length(start_detail2)+1,length(dest));
            Result:=True;
          end;
end;
function  TTxtToHtmlConverter.CheckForLineComment(Var dest:String):Boolean;
 begin
   Result:=False;
       if (pos(start_linecomment,dest)=1) then
          begin
            dest:=copy(dest,length(start_linecomment)+1,length(dest));
            Result:=True;
          end;
end;
function    TTxtToHtmlConverter.CheckForProcess(Var dest:String):Boolean;
 begin
   Result:=False;
       if (pos('{* ',dest)=1) then
          begin
            dest:=copy(dest,length('{* ')+1,length(dest));
            Result:=True;
          end;
end;


function  TTxtToHtmlConverter.GetFontID(Var source:String;Var dest:String;Var id:Integer):Boolean;
Var n,level:Integer;
 begin
   Result:=False;
   source:=TrimLeft(source);
   dest:=source;
     if CheckForPrj(dest,level) then
                             begin
                               ID:=MIDPrjLevel1+level-1;
                               n:=HasNext(dest);
                               CopySD(source,dest,n);
                               result:=true;
                               Exit;
                             end;
  if CheckForObrPrj(dest,level) then
                             begin
                               ID:=MIDObrPrj1+level-1;
                               n:=HasNext(dest);
                               CopySD(source,dest,n);
                               Exit;
                             end;
  if CheckForProcess(dest) then
                                   begin
                                   ID:=MIDProcess;
                                   n:=HasNext(dest);
                                   CopySD(source,dest,n);
                                   Result:=True;
                                   Exit;
                                   end;

   if CheckForLinkName(dest)      then
                                  begin
                                   ID:=MIDLinkName;
                                   n:=HasNext(dest);
                                   if (n<>0) then CopySD(source,dest,n) else
                                   source:='';
                                   Result:=True;
                                   Exit;
                                  end;

   if CheckForDetail(dest)      then
                                  begin
                                   ID:=MIDPrjDetail;
                                   n:=HasNext(dest);
                                   if (n<>0) then CopySD(source,dest,n) else
                                   source:='';
                                   Result:=True;
                                   Exit;
                                  end;

   if CheckForIndex(dest)      then
                                  begin
                                   ID:=MIDIndex;
                                   n:=HasNext(dest);
                                   if (n<>0) then CopySD(source,dest,n) else
                                   source:='';
                                   Result:=True;
                                   Exit;
                                  end;
  if CheckForDirHeader(dest) then
                             begin
                               ID:=MIDDirHeader;
                               n:=HasNext(dest);
                                   if (n<>0) then CopySD(source,dest,n) else
                                   source:='';
                                   Result:=True;
                               Exit;
                             end;


   if CheckForlinecomment(dest)     then
                                  begin
                                   ID:=MIDComment;
                                   n:=HasNext(dest);
                                   if (n<>0) then CopySD(source,dest,n) else
                                   source:='';
                                   Result:=True;
                                   Exit;
                                  end;


 end;

function  TTxtToHtmlConverter.IDToStyle(ind:Integer):String;
Var p:PStyleRecord;
    i:Integer;
    j:Integer;
 begin
   Result:='';
      FLSEnabled:=False;
   FUL:=True;
   FBgColor:='#FFFFFF';   {!!!}
   FStyle2Column:=False;
   FFirstColumnWidth:=0;
   FTextAlign:=taLeft;
   FVerticalAlign:=vaMiddle;
   if FRoot=nil then Exit;
   if ind<=0 then
      begin
        Result:=FRoot^.StyleName;
        if RootId>0 then Result:=result+'_'+intTostr(RootID);
        if RootIndex>0 then CSSStyles[rootIndex].used[ind]:=true;
        FLSEnabled:=FRoot^.ListStyleEnabled;
        FUL:=(FRoot^.ListStyle<lsDecimal);
        if FRoot^.BackColorEnabled then FBgColor:=ColorToWeb(FRoot^.BackColor);   {!!!}
        FFirstColumnWidth:=0;
        FTextAlign:=FRoot^.TextAlign;
        FVerticalAlign:=FRoot^.VerticalAlign;
        FShowSystemChars:=FRoot^.ShowSystemChars;
        Exit;
      end;
   p:=FRoot;
   i:=ind;
   if (i>62) then i:=62;
   for j:=1 to i do p:=p^.Next;
   Result:=p^.StyleName;
        FLSEnabled:=p^.ListStyleEnabled;
        FUL:=(p^.ListStyle<lsDecimal);
        if p^.BackColorEnabled then FBgColor:=ColorToWeb(p^.BackColor);   {!!!}
        FTextAlign:=p^.TextAlign;
        FVerticalAlign:=p^.VerticalAlign;
        FShowSystemChars:=p^.ShowSystemChars;
 end;


function   TTxtToHtmlConverter.GetStyleRecord(id:Integer):PstyleRECORD;
var i,j:Integer;
    p:PStyleRecord;
 begin
   Result:=Froot;
   p:=Result;
   if FRoot=nil then Exit;
   i:=id;
   if (i>62) then i:=62;
   j:=1;
   for j:=1 to i do p:=p^.Next;
   Result:=p;
 end;

function  TTxtToHtmlConverter.ColorToWeb(Value:TColor):String;
Var r,g,b,a:DWORD;
 begin
   Result:='#';
   r:=(DWORD(Value) shr 16) and $FF;
   g:=(DWORD(Value) shr 8) and $FF;
   b:=DWORD(VALUE) and $FF;
   a:=r or (g shl 8) or (b shl 16);
   Result:=Result+IntToHex(a,6);
 end;



procedure TTxtToHtmlConverter.AddStyleRecord_P(p:PStyleRecord;name:String;where:TStrings;ID:integer);
Var s:String;
      IDStr:string;
 begin
   if p=nil then Exit;
{   if (p^.StyleName<>'@page') then
    FDest.Add('#'+StrToCSSName(p^.StyleName)+' {')
   else
    FDest.Add(p^.StyleName+' {');  }
    if ID>0 then
    idStr:='_'+IntTostr(ID)
    else
    idStr:='';
    if p^.id=58 then
   where.Add('P {')
   else
   where.Add(name+idstr+'_P {');
//     
{      if p^.BackColorEnabled then
     where.Add('background : '+ColorToWeb(TColor(p^.BackColor))+';');}
   if p^.TextIndentEnabled then
     where.Add('text-indent : '+IntToStr(p^.TextIndent)+'pt;');
   {if p^.LeadingSpaceEnabled then
     where.Add('padding-left : '+IntToStr(p^.LeadingSpace)+'pt;');}
   case (p^.TextAlign) of
     taCenter:     s:='center';
     taJustify:    s:='justify';
     taLeft:       s:='left';
     taRight:      s:='right';
   end;
   if p^.TextAlignEnabled then
     where.Add('text-align : '+s+';');
   case (p^.LeftMarginUnits) of
    fsuPt: s:='pt';
    fsuIn: s:='in';
    fsuMm: s:='mm';
    fsuCm: s:='cm';
    fsuPc: s:='pc';
    fsuPx: s:='px';
    fsuEm: s:='em';
    fsuEx: s:='ex';
   end;
   if p^.LeftMarginEnabled then
     where.Add('margin-left : '+IntToStr(p^.LeftMargin)+s+';');
   case (p^.RightMarginUnits) of
    fsuPt: s:='pt';
    fsuIn: s:='in';
    fsuMm: s:='mm';
    fsuCm: s:='cm';
    fsuPc: s:='pc';
    fsuPx: s:='px';
    fsuEm: s:='em';
    fsuEx: s:='ex';
   end;
   if p^.RightMarginEnabled then
     where.Add('margin-right : '+IntToStr(p^.RightMargin)+s+';');
   case (p^.TopMarginUnits) of
    fsuPt: s:='pt';
    fsuIn: s:='in';
    fsuMm: s:='mm';
    fsuCm: s:='cm';
    fsuPc: s:='pc';
    fsuPx: s:='px';
    fsuEm: s:='em';
    fsuEx: s:='ex';
   end;
   if p^.TopMarginEnabled then
     where.Add('margin-top : '+IntToStr(p^.TopMargin)+s+';')
   else if p^.ID=58 then
   where.Add('margin-top : 0;');
   case (p^.BottomMarginUnits) of
    fsuPt: s:='pt';
    fsuIn: s:='in';
    fsuMm: s:='mm';
    fsuCm: s:='cm';
    fsuPc: s:='pc';
    fsuPx: s:='px';
    fsuEm: s:='em';
    fsuEx: s:='ex';
   end;
   if p^.BottomMarginEnabled then
     where.Add('margin-bottom : '+IntToStr(p^.BottomMargin)+s+';')
     else if p^.ID=58 then
      where.Add('margin-bottom : 0;');
   case (p^.LeftBorder) of
    btDotted:    s:='1px dotted';
    btDashed:    s:='1px dashed';
    btSolid:     s:='solid';
    btDouble:    s:='double';
    btGroove:    s:='groove';
    btRidge:     s:='ridge';
    btInset:     s:='inset';
    btOutset:    s:='outset';
    btNone:      s:='none';
   end;
   if p^.LeftBorderEnabled then
     where.Add('border-left : '+s+';');
   case (p^.RightBorder) of
    btDotted:    s:='1px dotted';
    btDashed:    s:='1px dashed';
    btSolid:     s:='solid';
    btDouble:    s:='double';
    btGroove:    s:='groove';
    btRidge:     s:='ridge';
    btInset:     s:='inset';
    btOutset:    s:='outset';
    btNone:      s:='none';
   end;
   if p^.RightBorderEnabled then
     where.Add('border-right : '+s+';');
   case (p^.TopBorder) of
    btDotted:    s:='1px dotted';
    btDashed:    s:='1px dashed';
    btSolid:     s:='solid';
    btDouble:    s:='double';
    btGroove:    s:='groove';
    btRidge:     s:='ridge';
    btInset:     s:='inset';
    btOutset:    s:='outset';
    btNone:      s:='none';
   end;
   if p^.TopBorderEnabled then
     where.Add('border-top : '+s+';');
   case (p^.BottomBorder) of
    btDotted:    s:='1px dotted';
    btDashed:    s:='1px dashed';
    btSolid:     s:='solid';
    btDouble:    s:='double';
    btGroove:    s:='groove';
    btRidge:     s:='ridge';
    btInset:     s:='inset';
    btOutset:    s:='outset';
    btNone:      s:='none';
   end;
   if p^.BottomBorderEnabled then
     where.Add('border-bottom : '+s+';');
   case (p^.MarksType) of
    mtCrop:   s:='crop';
    mtCross:  s:='cross';
    mtNone:   s:='none';
   end;
   if p^.MarksEnabled then
     where.Add('marks : '+s+';');
   case (p^.PageBreakBefore) of
     pbAlways:      s:='always';
     pbAuto:        s:='auto';
     pbLeft:        s:='left';
     pbRight:       s:='right';
   end;
   if p^.PBBEnabled then
     where.Add('page-break-before : '+s+';');
   case (p^.PageBreakAfter) of
     pbAlways:      s:='always';
     pbAuto:        s:='auto';
     pbLeft:        s:='left';
     pbRight:       s:='right';
   end;
   if p^.PBAEnabled then
     where.Add('page-break-after : '+s+';');
   case (p^.ListStyle) of
     lsDisc:         s:='disc';
     lsCircle:       s:='circle';
     lsSquare:       s:='square';
     lsDecimal:      s:='decimal';
     lsLowerRoman:   s:='lower-roman';
     lsUpperRoman:   s:='upper-roman';
     lsLowerAlpha:   s:='lower-alpha';
     lsUpperAlpha:   s:='upper-alpha';
 StyleDef.lsNone:         s:='none';
   end;
   if p^.ListStyleEnabled then
     where.Add('list-style : '+s+';');
   case (p^.WhiteSpace) of
    wsPre:        s:='pre';
    wsNowrap:     s:='nowrap';
    wsNormal:     s:='normal';
   end;
   if p^.WhiteSpaceEnabled then
     where.Add('white-space : '+s+';');
   where.Add('}');
 end;
procedure TTxtToHtmlConverter.AddStyleRecord_FONT(p:PStyleRecord;name:String;where:TStrings;ID:integer);
Var s:String;
    idStr:string;
 begin
   if p=nil then Exit;
   if ID>0 then idstr:='_'+IntTostr(ID)
           else idstr:='';
{   if (p^.StyleName<>'@page') then
    FDest.Add('#'+StrToCSSName(p^.StyleName)+' {')
   else
    FDest.Add(p^.StyleName+' {');  }
   if p^.ID=58 then
   where.Add('FONT {')
   else
   where.Add(name+idstr+'_FONT {');
   if p^.FontEnabled then
     where.Add('font-family : "'+p^.Font+'";');
   case (p^.FontSizeUnits) of
    fsuPt: s:='pt';
    fsuIn: s:='in';
    fsuMm: s:='mm';
    fsuCm: s:='cm';
    fsuPc: s:='pc';
    fsuPx: s:='px';
    fsuEm: s:='em';
    fsuEx: s:='ex';
   end;
   if p^.FontSizeEnabled then
     where.Add('font-size : '+IntToStr(p^.FontSize)+s+';');
   case (p^.FontWeight) of
    fwExtraLight:  s:='extra-light';
    fwLight:       s:='light';
    fwDemiLight:   s:='demi-light';
    fwMedium:      s:='medium';
    fwDemiBold:    s:='demi-bold';
    fwBold:        s:='bold';
    fwExtraBold:   s:='extra-bold';
    fwBorder:      s:='border';
    fwLighter:     s:='lighter';
   end;
   if p^.FontWeightEnabled then
     where.Add('font-weight : '+s+';');
   case (p^.FontStyle) of
     fsItalic:      s:='italic';
     fsOblique:     s:='oblique';
     fsSmallCaps:   s:='small-caps';
     fsNone:        s:='none';
   end;
   if p^.FontStyleEnabled then
     where.Add('font-style : '+s+';');
   case (p^.TextDecoration) of
    tdUnderline:    s:='underline';
    tdOverline:     s:='overline';
    tdLineThrough:  s:='line-through';
    tdBlink:        s:='blink';
    tdNone:         s:='none';
   end;
   if p^.TextDecorationEnabled then
     where.Add('text-decoration : '+s+';');
   case (p^.TextTransform) of
    ttCapitalize:    s:='capitalize';
    ttUppercase:     s:='uppercase';
    ttLowercase:     s:='lowercase';
    ttNone:          s:='none';
   end;
   if p^.TextTransformEnabled then
     where.Add('text-transform : '+s+';');
   if p^.FontColorEnabled then
     where.Add('color : '+ColorToWeb(TColor(p^.FontColor))+';');
   if p^.BackColorEnabled then
     where.Add('background : '+ColorToWeb(TColor(p^.BackColor))+';');
   if p^.WordSpacingEnabled then
     where.Add('word-spacing : '+IntToStr(p^.WordSpacing)+'pt;');
   if p^.LetterSpacingEnabled then
     where.Add('letter-spacing : '+IntToStr(p^.LetterSpacing)+'pt;');
   case (p^.VerticalAlign) of
     vaBaseline:   s:='baseline';
     vaBottom:     s:='bottom';
     vaMiddle:     s:='middle';
     vaSub:        s:='sub';
     vaSuper:      s:='super';
     vaTextBottom: s:='text-bottom';
     vaTextTop:    s:='text-top';
     vaTop:        s:='top';
   end;
   if p^.VerticalAlignEnabled then
     where.Add('verical-align : '+s+';');
   where.Add('}');
 end;
function findclosestcolor(t:TColor):integer;
const backcolors:array[1..16] of TColor=
(clBlack,
clBlue,
clAqua,
clLime,
clFuchsia,
clRed,
clYellow,
clWhite,
clNavy,
clTeal,
clGreen,
clPurple,
clMaroon,
clOlive,
clDkGray,
clGray
);
var i:integer;
    dred,dgreen,dblue:integer;
    dmin:integer;
begin
dmin:=255*3;
for i:=1 to 16 do
begin
dred:=abs((backcolors[i] and $FF) - (t and $FF));
dgreen:=abs(((backcolors[i] shr 8) and $FF) - ((t shr 8) and $FF));
dblue:=abs(((backcolors[i] shr 16) and $FF) - ((t shr 16) and $FF));
if dred+dgreen+dblue<dmin then
begin
dmin:=dred+dgreen+dblue;
result:=i;
end;
end;
end;
function ToTWIPS(t:TFontSizeUnits):extended;
begin
case t of
    fsuPt: result:=20;
    fsuIn: result:=1440;
    fsuMm: result:=57;
    fsuCm: result:=573;
    fsuPc: result:=240;
    fsuPx: result:=1440 / Screen.PixelsPerInch;
    fsuEm: result:=200;
    fsuEx: result:=200;
else
   result:=1;
end;
end;

procedure TTxtToHtmlConverter.AddStyleRecordRTF_P(p:PStyleRecord;name:String;where,fonttable,colortable:TStrings;intable:boolean;ID:integer);
Var ss,s:String;
    firstindent,textindent:integer;
 begin
   if p=nil then Exit;
{   if (p^.StyleName<>'@page') then
    FDest.Add('#'+StrToCSSName(p^.StyleName)+' {')
   else
    FDest.Add(p^.StyleName+' {');  }
   ss:='';
   firstindent:=0;
   textindent:=0;
    if p^.ID<>58 then
   ss:=ss+('\s'+inttostr((p^.ID+1)or(ID shl 8)))
   else
   ss:=ss+'\s0';
{   if (p^.ID<>58)and intable then
   ss:=ss+'\sbasedon0\snext0';}
   if p^.ID=MIDSubheader then ss:=ss+'\outlinelevel0';
   if (p^.ID>=MIDLevel1)and(p^.ID<=MIDLevel1+6) then ss:=ss+'\outlinelevel'+inttostr(p^.ID-Midlevel1+1);
   if p^.ID in [MIDPrjHeader] then ss:=ss+'\keepn';
//      
{   if p^.BackColorEnabled then
begin
   i:=colortable.count;
   s:='\red'+inttostr((p^.BackColor shr 0)and $ff)+
      '\green'+inttostr((p^.BackColor shr 8)and $ff)+
      '\blue'+inttostr((p^.BackColor shr 16)and $ff)+';';
   for i:=0 to colortable.count-1 do
    if colortable[i]=s then break ;
   if i=colortable.count then colortable.add(s);
   ss:=ss+'\cbpat'+inttostr(i+1);
   end;}

      if p^.TextIndentEnabled then
     inc(firstindent,(p^.TextIndent*12));
   {if p^.LeadingSpaceEnabled then
     inc(firstindent,(p^.LeadingSpace*12));}
{   if p^.WordSpacingEnabled then
     ss:=ss+('word-spacing : '+IntToStr(p^.WordSpacing)+'pt;');}
   if p^.TextAlignEnabled then
   case (p^.TextAlign) of
     taCenter:     ss:=ss+('\qc');
     taJustify:    ss:=ss+('\qj');
     taLeft:       ss:=ss+('\ql');
     taRight:      ss:=ss+('\qr');
   end;

   if p^.LeftMarginEnabled then
   begin
     //inc(firstindent,round(p^.LeftMargin*TOTWIPS(p^.LeftMarginUnits)));
     inc(textindent,round(p^.LeftMargin*TOTWIPS(p^.LeftMarginUnits)));
   end;
   if p^.RightMarginEnabled then
     ss:=ss+('\ri'+IntToStr(round(p^.RightMargin*TOTWIPS(p^.RightMarginUnits))));
   if firstindent<>0 then ss:=ss+'\fi'+inttostr(firstindent);
   if textindent<>0 then ss:=ss+'\li'+inttostr(textindent);
   if p^.TopMarginEnabled then
     ss:=ss+('\sb'+IntToStr(round(p^.TopMargin*TOTWIPS(p^.TopMarginUnits))));
   if p^.BottomMarginEnabled then
     ss:=ss+('\sa'+IntToStr(round(p^.BottomMargin*TOTWIPS(p^.BottomMarginUnits))));
   case (p^.LeftBorder) of
    btDotted:    s:='\brdrdot';
    btDashed:    s:='\brdrdash';
    btSolid:     s:='\brdrs';
    btDouble:    s:='\brdrth';
    btGroove:    s:='\brdrengrave';
    btRidge:     s:='\brdremboss';
    btInset:     s:='\brdrdashdotstr';
    btOutset:    s:='\brdrwavydb';
    btNone:      s:='\brdrtriple';
   end;
    if p^.LeftBorderEnabled then
   ss:=ss+('\brdrl'+s);

   case (p^.RightBorder) of
    btDotted:    s:='\brdrdot';
    btDashed:    s:='\brdrdash';
    btSolid:     s:='\brdrs';
    btDouble:    s:='\brdrth';
    btGroove:    s:='\brdrengrave';
    btRidge:     s:='\brdremboss';
    btInset:     s:='\brdrdashdotstr';
    btOutset:    s:='\brdrwavydb';
    btNone:      s:='\brdrtriple';
   end;
    if p^.RightBorderEnabled then
   ss:=ss+('\brdrr'+s);

   case (p^.TopBorder) of
    btDotted:    s:='\brdrdot';
    btDashed:    s:='\brdrdash';
    btSolid:     s:='\brdrs';
    btDouble:    s:='\brdrth';
    btGroove:    s:='\brdrengrave';
    btRidge:     s:='\brdremboss';
    btInset:     s:='\brdrdashdotstr';
    btOutset:    s:='\brdrwavydb';
    btNone:      s:='\brdrtriple';
   end;
 if p^.TopBorderEnabled then
   ss:=ss+('\brdrt'+s);
   case (p^.BottomBorder) of
    btDotted:    s:='\brdrdot';
    btDashed:    s:='\brdrdash';
    btSolid:     s:='\brdrs';
    btDouble:    s:='\brdrth';
    btGroove:    s:='\brdrengrave';
    btRidge:     s:='\brdremboss';
    btInset:     s:='\brdrdashdotstr';
    btOutset:    s:='\brdrwavydb';
    btNone:      s:='\brdrtriple';
   end;
 if p^.BottomBorderEnabled then
   ss:=ss+('\brdrb'+s);
if intable Then ss:=ss+' '+name;
Where.add(ss);
 end;
procedure TTxtToHtmlConverter.AddStyleRecordRTF_FONT(p:PStyleRecord;name:String;where,fonttable,colortable:TStrings;intable:boolean;ID:integer);
Var ss,s:String;
    i:integer;
    firstindent,textindent:integer;
    csID:string;
 begin
   if p=nil then Exit;
{   if (p^.StyleName<>'@page') then
    FDest.Add('#'+StrToCSSName(p^.StyleName)+' {')
   else
    FDest.Add(p^.StyleName+' {');  }
   ss:='';
   firstindent:=0;
   textindent:=0;
   if p^.id=58 then csid:='0'
               else csid:=inttostr((p^.ID+1)or(ID shl 8));
    if intable then
    ss:=ss+('\*\cs'+csid+'\additive')
    else
       ss:=ss+('\cs'+csid);
{   if (p^.ID<>58)and intable then
   ss:=ss+'\sbasedon0\snext0';}
   if p^.FontEnabled then
   begin
   i:=fonttable.count;
   for i:=0 to fonttable.count-1 do
    if pos(p^.font,fonttable[i])>0 then break;
   if i=fonttable.count then
   fonttable.add('{\f'+inttostr(i)+' '+p^.font+';}');
     ss:=ss+('\f'+inttostr(i));
   end;
   if p^.FontSizeEnabled then
     ss:=ss+('\fs'+IntToStr(round(p^.FontSize*ToTwips(p^.fontsizeunits)) div 10));
   if p^.FontWeightEnabled then
   case (p^.FontWeight) of
    fwExtraLight,
    fwLight,
    fwDemiLight,
    fwMedium: ss:=ss+('\b0');
    fwDemiBold,
    fwBold,
    fwExtraBold: ss:=ss+('\b1');
    fwBorder:   ss:=ss+('\emb');
    fwLighter:  ss:=ss+('\shad');
   end;
  if p^.FontStyleEnabled then
   case (p^.FontStyle) of
     fsItalic:      ss:=ss+('\i1');
     fsOblique:     ss:=ss+('\i1');
     fsSmallCaps:   ss:=ss+('\scaps');
    end;
 if p^.TextDecorationEnabled then
   case (p^.TextDecoration) of
    tdUnderline:    ss:=ss+('\ul');
    tdOverline:     ss:=ss+('\outl');
    tdLineThrough:  ss:=ss+('\strike');
   end;
   if p^.FontColorEnabled then
   begin
   i:=colortable.count;
   s:='\red'+inttostr((p^.fontcolor shr 0)and $ff)+
      '\green'+inttostr((p^.fontcolor shr 8)and $ff)+
      '\blue'+inttostr((p^.fontcolor shr 16)and $ff)+';';
   for i:=0 to colortable.count-1 do
    if colortable[i]=s then break ;
   if i=colortable.count then colortable.add(s);
     ss:=ss+('\cf'+inttostr(i+1));
   end;
   if p^.BackColorEnabled then
begin
   i:=colortable.count;
   s:='\red'+inttostr((p^.BackColor shr 0)and $ff)+
      '\green'+inttostr((p^.BackColor shr 8)and $ff)+
      '\blue'+inttostr((p^.BackColor shr 16)and $ff)+';';
   for i:=0 to colortable.count-1 do
    if colortable[i]=s then break ;
   if i=colortable.count then colortable.add(s);
   ss:=ss+'\chcbpat'+inttostr(i+1);
   end;
   if p^.LetterSpacingEnabled then
     ss:=ss+('\expnd'+IntToStr(p^.LetterSpacing*4)+'\expndtw'+Inttostr(p^.LetterSpacing*20));
   if p^.VerticalAlignEnabled then
   case (p^.VerticalAlign) of
     vaBaseline:   ss:=ss+('\clvertalb');
     vaBottom:     ss:=ss+('\clvertalb');
     vaMiddle:     ss:=ss+('\clvertalc');
     vaSub:        ss:=ss+('\sub');
     vaSuper:      ss:=ss+('\super');
     vaTextBottom: ss:=ss+('\clvertalb');
     vaTextTop:    ss:=ss+('\clvertalt');
     vaTop:        ss:=ss+('\clvertalt');
   end;
if intable Then ss:=ss+' '+name;
Where.add(ss);
 end;

procedure   TTxtToHtmlConverter.AddStyleTable(where:TStrings;ID:integer);
Var p:PStyleRecord;
    i:integer;
    stused:array[0..62] of boolean;
    stID:integer;
 begin
  if ID>0 then
  for i:=0 to 62 do
   stUsed[i]:=CSSStyles[ID].used[i]
  else
  for i:=0 to 62 do
   stUsed[i]:=used[i];
  if ID>0 then
   stID:=CSSStyles[ID].ID
   else
   stID:=0;
   where.Add('<STYLE>');
   if ID>0 then
   p:=CSSStyles[ID].Froot
   else
   p:=fZeroRoot;
   i:=0;
   while (p<>nil) do
     begin
       if i<>0 then
       begin
       if (i<>58)and(used[i]) then
       begin
       AddStyleRecord_P(p,'#'+stNewName[i],where,stID);
       AddStyleRecord_FONT(p,'#'+stNewName[i],where,stID)
       end
       end
        else
       begin
       AddStyleRecord_P(p,stNewName[i],where,stID);
       AddStyleRecord_FONT(p,stNewName[i],where,stID);
       end;
       p:=p^.Next;
       inc(i);
     end;
   where.Add('</STYLE>');
 end;
procedure   TTxtToHtmlConverter.AddStyleTableRTF(where:TStrings;ID:integer);
Var p:PStyleRecord;
    i:integer;
    styles:TStringList;
    zerostyle,CombinedStyle:PStyleRecord;
    stUsed:array[0..62] of boolean;
    stID:integer;
 begin
 if ID>0 then
  for i:=0 to 62 do
   stUsed[i]:=CSSStyles[ID].used[i]
  else
  for i:=0 to 62 do
   stUsed[i]:=used[i];
  if ID>0 then
   stID:=CSSStyles[ID].ID
   else
   stID:=0;
   styles:=TStringList.create;
   new(CombinedStyle);
   try
   zerostyle:=GetStyleRecord(58);
   if ID>0 then
   p:=CSSStyles[ID].Froot^.Next
   else
   p:=FZeroRoot.Next;
   i:=1;
//   addstyleRecordRTF(Zerostyle,'Normal',styles,RTFFonts,RTFColors,true,true);
   while (p<>nil) do
     begin
     if (used[i] and (p^.ID<>58)) then
     begin

       CombineStyles([ZeroStyle,p],CombinedStyle);
       AddStyleRecordRTF_P(CombinedStyle,stOldName[i],styles,RTFfonts,RTFColors,true,StID);
       AddStyleRecordRTF_FONT(CombinedStyle,stOldName[i],styles,RTFfonts,RTFColors,true,StID);
      end;
       p:=p^.Next;
       inc(i);
     end;


   where.Add('{\stylesheet');


   for i:=0 to styles.count-1 do
   where.add('{'+styles[i]+';}');
   where.add('}');
   where.add('{\fonttbl');
   where.addstrings(RTFfonts);
   where.add('}');
   Where.add('{\colortbl;');
   where.addStrings(RTFColors);
   Where.add('}');
   styles.savetofile('styles.rtf');
   finally
   dispose(CombinedStyle);
   styles.free;
   end;
 end;

constructor TTxtToHtmlConverter.Create;
 begin
   inherited Create;
   FRoot:=nil;
   FCSSFileName:=ExtractFilePath(Application.ExeName)+'default.afm';
   FSource:=TStringList.Create;
   FDest:=TStringList.Create;
   FStream:=TStyleStream.Create;
   FTitle:='MOP Intranet publication template';
 end;

destructor  TTxtToHtmlConverter.Destroy;
 begin
   ClearStyles;
   Clear;
   FStream.Free;
   FSource.Free;
   FDest.Free;
   inherited Destroy;
 end;

procedure TTxtToHtmlConverter.Clear;
 begin
   FStream.ClearCSSList(FZeroRoot);
   FRoot:=nil;
   FZeroRoot:=nil;
   FSource.Clear;
   FDest.Clear;
 end;

procedure   TTxtToHtmlConverter.Convert(razdl:TStrings;useJS:boolean);
Var ic,i,stylepos:Integer;
    s,l,sn,ss:String;
    PIDFlag,PIDEnd:string;
    ind:Integer;
    unformatted,
    res:Boolean;
    parafont:Boolean;
{    tags:array[0..63] of Boolean;
    ultags:array[0..63] of Boolean;
    oldtags:array[0..63] of Integer;
    stekind:Integer;
    stekindtable:Integer;
    newtabletag:Integer;
    oldtabletags:array[0..63] of Integer;
    tagstable:array[0..128] of Boolean; }
    lod:Integer;
    firstpasstr:Boolean;
    FOldColumnEnabled:Boolean;
    nlevs:String;
    astr:String;
    slashp:Boolean;
    ttts:String;
    headers,fstyle:TStringList;
    curID:integer;
    P_ID:integer;
    PName:string;
    function mouseEvent(s:string):string;
    begin
    result:=' onMouseOver="onMove('''+s+''')" '+' onMouseOut="onOut()"';
    end;
    function ParaString(ind,ID:integer;l:string;domouse:boolean):string;
    var stylename:string;
    begin
    stylename:=STNewName[ind];
    if RootID>0 then
    stylename:=stylename+'_'+intTostr(RootID);
    if id>0 then
     stylename:=stylename+'-'+inttostr(id);
                 if domouse then
             result:=(PIDFlag+stylename+MouseEvent(IDToStyle(ind))+'>')
             else
             result:=(PIDFlag+stylename+'>');
    result:=result+l;
    result:=result+PIDend;


    end;
function ProcessLink(nlevs:string;dosystem:boolean):string;
var number,data:string;
function ProcessSystem(nlevs:string;dosystem:boolean):string;
begin
if dosystem then result:=systemchars[ind]+nlevs
            else result:=nlevs;
end;
begin
result:='';
number:=utils.getNumbers(nlevs);
data:=utils.cutNumbers(nlevs);
if (ind<>MIDPrjDetail) then
inc(rowcount);
if (CurID<0)and(makeLinks){and usejs} then
 if (ind>=MIDLevel1)and(ind<=MIDLevel15) then
      result:='<a name='+inttohex(-curid,8)+'>';
 if fileexists(data) then
                   if (Uppercase(extractfileext(data))='.GIF')or(Uppercase(extractfileext(data))='.JPG')then
                   result:=result+'<img align=center src="'+data+'">'
                   else  result:=result+'<a href="'+data+'" '+'target="_blank">'+ProcessSystem(nlevs,dosystem)+'</a>'
                   else if (CurID>0)and MakeLinks {and UseJS} and((ind>=MIDObrPrj1)and(ind<=MIDObrPrj15)or
                   (ind>=MIDPrjLevel1)and(ind<=MIDPrjLevel13)or
                   (ind=MIDLinkName))and(fsource.IndexOfObject(TObject(curid))>=0) then

                   result:=result+'<a href="#'+inttohex(curid,8)+'" '+'target="_blank">'+ProcessSystem(nlevs,dosystem)+'</a>'
                   else
                   result:=result+ProcessSystem(nlevs,dosystem)

end;
 begin
  {}
   lod:=0;                                {!!!}
   unformatted:=false;
   firstpasstr:=False;   {!!!}
   rowcount:=0;
      if razdl<>nil then
   razdl.clear;
   FOldColumnEnabled:=False;
   FRootLevel:=1;
    FDest.Add('<HTML>');
   FDest.Add('<HEAD>');
   FDest.Add('<TITLE>'+FTitle+'</TITLE>');
   FDest.Add('<meta http-equiv="Content-Type" content="text/html; charset='+codepage+'">');
   FDest.add('<META name="Author" content="'+Author+'">');
   FDest.add('<META name="Company" content="'+Company+'">');
   FDest.add('<META name="Generator" content="'+appconst.applicationname+'">');
   FDest.add('<META name="Version" content="'+appconst.version+'">');
   FDest.add('<META name="Serial" content="'+appconst.sysinfo.Serial+'">');
   FDest.add('<META name="Model" content="'+ModelName+'">');
   FDest.add('<META name="Created" content="'+DateTimeTostr(NOW)+'">');
   if useJS  then
   begin
   FDest.Add('<script language="JavaScript">');
   FDest.Add('<!--');
   FDest.Add('	function onMove(estr)');
   FDest.Add('	{');
   FDest.Add('window.status=estr');
   FDest.Add('	}');
   FDest.Add('	function onOut()');
   FDest.Add('	{');
   FDest.Add('window.status=''''');
   FDest.Add('	}');
FDest.Add('// -->');
   FDest.Add('</script>');
   end;
   ClearUsed;
   { Add Style Table}
 fdest.add('<STYLE>');
 AddStyleRecord_FONT(GetStyleRecord(58),'DEF',fdest,0);
 AddStyleRecord_P(GetStyleRecord(58),'DEF',fdest,0);
 fdest.add('UL {');
 fdest.add('font-family : "Times New Roman";');
 fdest.add('margin-top : 0;');
 fdest.add('margin-bottom : 0;');
 fdest.add('}');
 fdest.add('OL {');
 fdest.add('font-family : "Times New Roman";');
 fdest.add('margin-top : 0;');
 fdest.add('margin-bottom : 0;');
 fdest.add('}');

//   fdest.add('#{');
//Fdest.add('margin-top : 0pt;');
//Fdest.add('margin-bottom : 0pt;');
//Fdest.add('font-size : 10pt;');
//   fdest.add('}');
 fdest.add('</STYLE>');
stylepos:=fdest.count;
   if useJS then
   begin
   FDest.add('<LINK rel="stylesheet" type="text/css" href="style.css">');
   end;
   headers:=TStringList.create;
   PIDFlag:='<P ID=';
   PIDEnd:='</P>';
   FDest.Add('</HEAD>');
    FDest.Add('<BODY>');
   { Convert FSource }
   ic:=FSource.Count-1;
   i:=1;
   while i<=ic do
     begin
      s:=SubstStyle(FSource.Strings[i]);
      if unformatted then
      begin
      if s<>'</PREAMBULA>' then fdest.add(processHTMLSpecial(s)+'<BR>')
                           else begin unformatted:=false; fdest.add('</P>');end;
      inc(i);
      continue;
      end;
      if s='<PREAMBULA>' then begin unformatted:=true; fdest.add('<P ID=PREAMBULA>');inc(i);continue;end;
       parafont:=True;
       slashp:=True;
       ttts:=ClearSpaces(s);
       if length(ttts)>0 then
       begin
        res:=GetParaID(s,l,ind);
        if not res then begin inc(i);continue;end;
        curID:=integer(FSource.Objects[i]);
        l:=processHTMLSpecial(ClearSpaces(l));
        if (l='')and(s='') then begin inc(i);continue; end;
       if (ind=MIDSubHeader) then
             begin
             FDest.add('<a NAME="RAZDEL'+inttostr(i)+'"></a>');
             if (razdl<>nil) then
             razdl.addObject(l,TObject(i));
             end;
         PIDFlag:='<P ID=';
         PIDEnd:='</P>';
         sn:=STNewName[ind];
         if RootID>0 then sn:=sn+'_'+inttostr(rootID);
         ss:=IDToStyle(ind);
         PName:=ss;
        P_ID:=ind;
        FDest.Add(PIDFlag+sn+'_P >');
       while res do
        begin
   PIDFlag:='<FONT ID=';
   PIDEnd:='</FONT>';
        used[ind]:=true;
        if ClearSpaces(l)<>'' then
        begin
        IDToStyle(Ind);
             sn:=STNewName[ind];
             ss:=IDToStyle(ind);
             if rootID>0 then
             sn:=sn+'_'+inttostr(rootID);
             if ind<>P_ID then ss:=ss+'/'+PName;
             astr:='';//GetAlignString(FTextAlign,FVerticalAlign);
             if usejs  then
             FDest.Add(PIDFlag+sn+'_FONT '+MouseEvent(ss)+'>')
             else
             FDest.Add(PIDFlag+sn+'_FONT '+'>');
nlevs:=getnumbers(l);
ttts:=cutnumbers(l);
nlevs:=nlevs+' '+processlink(ttts,False);
if FShowSystemChars then
nlevs:=systemchars[ind]+nlevs;
FDest.Add(ClearSpaces(nlevs));
FDest.add(PIDEND);
end;
parafont:=false;
          res:=GetFontID(s,l,ind);
        l:=processHTMLSpecial(ClearSpaces(l));
           l:=ClearSpaces(l);
//          if tablemode and(ind=MIDprjdetail) then delete(l,1,1);
          //if l='' then l:='&nbsp;';
        end;
FDest.add('</P>');
end;
      inc(i);
     end;
   FDest.Add('</BODY>');
   FDest.Add('</HTML>');
      FStyle:=TStringList.create;
      FRoot:=FZeroRoot;
      AddStyletable(FSTyle,0);
   for i:=1 to StylesCount do
      AddStyletable(FSTyle,i);
   if  not usejs then
   begin
   for i:=0 to FStyle.Count-1 do
   FDest.Insert(stylepos+i,FStyle[i]);
   end
   else
   FStyle.savetofile('style.css');
   FSTyle.free;
   headers.free;
 end;

procedure   TTxtToHtmlConverter.OpenStream(Stream:TStringList;razdl:TStrings;useJS:boolean;tofile,tofilertf:TFilename);
 begin
  Clear;
  FSource.AddStrings(Stream);
  FStream.OpenStream(FCSSFileName,stRead);
  FStream.ReadStream(FZeroRoot);
  FRoot:=FZeroRoot;
  FStream.CloseStream;
  if tofilertf<>'' then
  ConvertRTF(tofilertf,not useJS);
  if tofile<>'' then
  begin
  Convert(razdl,useJS);
  FDest.SaveToFile(tofile);
  end;
  end;



procedure   TTxtToHtmlConverter.CheckAndAddRowTag(Value:Integer;var FL:Boolean);
 begin
   if (RowTag[Value]=1) then
    begin
      if not(fl) then
       begin
         FDest.Add('</TD>');
         FDest.Add('</TR>');
       end else fl:=False;
      FDest.Add('<TR>');
      inc(rowcount);
      FDest.Add('<TD ID='+STNewName[Value]+'>');
    end;
 end;

procedure TTxtToHtmlConverter.CheckAndAddDataTag(Value:Integer;var FL:Boolean;parafont:Boolean;oldDT:Integer);
 begin
   if (RowTag[Value]=0) then
     begin
       if ((DataTag[Value]>0) and (oldDT<>DataTag[Value]) and
            parafont and (GroupTag[Value]=0)) then
         begin
           if not(fl) then
            begin
              FDest.Add('</TD>');
            end else fl:=False;
            FDest.Add('<TD ID='+STNewName[Value]+'>');
         end;
     end;
 end;

procedure   TTxtToHtmlConverter.AppendLine(s1:String;Value:Integer;s2:String;useJS:Boolean;s3:String);
Var s:String;

  function mouseEvent(s:string):string;
    begin
    result:=' onMouseOver="onMove('''+s+''')" '+' onMouseOut="onOut()"';
    end;

 begin
   s:=s1;
     if useJS then
        s:=s+' ID='+STNewName[Value]+MouseEvent(IDToStyle(Value))+'>'
   else
        s:=s+' ID='+STNewName[Value]+'>';
   if s1<>'' then
   s:=s+s2+s3
   else
   s:=s2;
   FDest.Add(s);
 end;

procedure TTxtToHtmlConverter.ConvertRTFFiles(tofile:TFileName;CutFormat:boolean);
var i,ind,j:integer;
    s,l,nls:string;
    res,first:boolean;
    Year,Month,Day,Hour,Minute,Second,MS:Word;
    inpreambula,para:boolean;
    stylepos:integer;
    fstyle:TStringList;
    combinedStyle,zeroStyle:PStyleRecord;
    curid:integer;
    curfile:integer;
function conv8bit(s:string):string;
var i:integer;
begin
result:='';
 for i:=1 to length(s) do
  if s[i]<#128 then
 if s[i] in ['\','{','}'] then
  result:=result+'\'+s[i]
  else
   if s[i]=#3 then result:=result+'\par '
  else
  result:=result+s[i]
               else result:=result+'\'''+inttohex(ord(s[i]),2);
end;
begin
curfile:=0;
New(CombinedStyle);
RTFFonts:=TStringList.create;
RTFColors:=TStringList.create;
try
ClearUsed;
FDest.clear;
DecodeDate(Now,Year,Month,Day);
DecodeTime(Now,Hour,Minute,Second,MS);
FDest.add('{\rtf1\ansi\uc1\deff0\ansicpg1251');
FDest.add('\deflang'+rtflang);
FDest.add('{\info');
FDest.add('{\title '+conv8bit(title)+'}');
FDest.add('{\author '+conv8bit(Author)+'}');
FDest.add('{\company '+conv8bit(Company)+'}');
FDest.add('{\creatim\yr'+inttostr(year)+'\mo'+inttostr(Month)+'\dy'+Inttostr(Day)+
                    '\hr'+inttostr(Hour)+'\min'+inttostr(Minute)+'\sec'+inttostr(Second)+'}');
FDest.add('{\*\userprops');
FDest.add('{{\propname GENERATOR}\proptype30 \staticval '+appconst.applicationName+'}');
FDest.add('{{\propname VERSION}\proptype30 \staticval '+appconst.version+'}');
FDest.add('{{\propname SERIAL}\proptype30 \staticval '+appconst.sysinfo.serial+'}');
FDest.add('{{\propname MODEL}\proptype30 \staticval '+MODELName+'}');
FDest.add('}');
FDest.add('}');
 RTFColors.add('\red0\green0\blue0;');
   RTFColors.add('\red255\green255\blue255;');
   RTFFonts.add('{\f0 Microsoft Sans Serif;}');

stylepos:=fdest.count;
FDest.add('\fs24\f0\ql');
ZeroStyle:=GetStyleRecord(58);
AddStyleRecordRTF_P(ZeroStyle,IDToStyle(ind),fdest,RTFFonts,RTFColors,false,0);
AddStyleRecordRTF_FONT(ZeroStyle,IDToStyle(ind),fdest,RTFFonts,RTFColors,false,0);
inpreambula:=false;
FRootLevel:=1;
for i:=1 to FSource.count-1 do
begin
s:=SubstStyle(FSource[i]);
if ClearSpaces(s)='' then continue;
if s='<TABLE>' then continue;
if s='</TABLE>' then continue;
if s='<TABLE1>' then continue;
if s='</TABLE1>' then continue;
if s='<PREAMBULA>' then
begin
inpreambula:=true;
ind:=3;
FDest.Add('{\pard\plain');
CombineStyles([ZeroStyle,GetStyleRecord(ind)],CombinedStyle);
AddStyleRecordRTF_P(CombinedStyle,IDToStyle(ind),fdest,RTFFonts,RTFColors,false,RootID);
AddStyleRecordRTF_FONT(CombinedStyle,IDToStyle(ind),fdest,RTFFonts,RTFColors,false,RootID);
continue;
end;
if s='</PREAMBULA>' then
begin
inpreambula:=false;
FDest.add('\par}');
continue;
end;
nls:=s;
res:=getparaid(s,l,ind);
IDToStyle(ind);
if ind=MIDSubHeader then
begin
    FDest.add('}');
    fstyle:=TStringList.Create;
    FRoot:=FZeroRoot;
    ADDStyleTableRTF(fstyle,0);
    for j:=1 to StylesCount do
    ADDStyleTableRTF(fstyle,j);
    for j:=0 to fstyle.count-1 do
    fdest.Insert(stylepos+j,fstyle[j]);
    fstyle.free;
    if curfile>0 then
    FDest.saveTofile(tofile+inttostr(curfile)+'.rtf');
    ClearUsed;
FDest.clear;
DecodeDate(Now,Year,Month,Day);
DecodeTime(Now,Hour,Minute,Second,MS);
FDest.add('{\rtf1\ansi\uc1\deff0\ansicpg1251');
FDest.add('\deflang'+rtflang);
FDest.add('{\info');
FDest.add('{\title '+conv8bit(title)+'}');
FDest.add('{\author '+conv8bit(Author)+'}');
FDest.add('{\company '+conv8bit(Company)+'}');
FDest.add('{\creatim\yr'+inttostr(year)+'\mo'+inttostr(Month)+'\dy'+Inttostr(Day)+
                    '\hr'+inttostr(Hour)+'\min'+inttostr(Minute)+'\sec'+inttostr(Second)+'}');
FDest.add('{\*\userprops');
FDest.add('{{\propname GENERATOR}\proptype30 \staticval '+appconst.applicationName+'}');
FDest.add('{{\propname VERSION}\proptype30 \staticval '+appconst.version+'}');
FDest.add('{{\propname SERIAL}\proptype30 \staticval '+appconst.sysinfo.serial+'}');
FDest.add('{{\propname MODEL}\proptype30 \staticval '+MODELName+'}');
FDest.add('}');
FDest.add('}');
RTFColors.clear;
RTFFonts.clear;
 RTFColors.add('\red0\green0\blue0;');
   RTFColors.add('\red255\green255\blue255;');
   RTFFonts.add('{\f0 Microsoft Sans Serif;}');

stylepos:=fdest.count;
FDest.add('\fs24\f0\ql');
ZeroStyle:=GetStyleRecord(58);
AddStyleRecordRTF_P(ZeroStyle,IDToStyle(ind),fdest,RTFFonts,RTFColors,false,0);
AddStyleRecordRTF_FONT(ZeroStyle,IDToStyle(ind),fdest,RTFFonts,RTFColors,false,0);
inpreambula:=false;
    inc(curfile);
    FRootLevel:=1;

end;
first:=true;
if not inpreambula then begin
curid:=Integer(FSource.objects[i]);
if (l<>'')or(s<>'') then
begin
FDest.Add('{\pard\plain');
FDest.add('\tx0\tlul\tx8000\tlul\tx9000\tlul\tx10000');
para:=true;
while res do
begin
l:=ClearSpaces(l);
if ind>=0 then
begin
IDToStyle(ind);
used[ind]:=true;
CombineStyles([ZeroStyle,GetStyleRecord(ind)],CombinedStyle);
if para  then
begin
AddStyleRecordRTF_P(CombinedStyle,IDToStyle(ind),fdest,RTFFonts,RTFColors,false,RootID);
FDest.add('{');
end;
if l<>'' then
begin
if  FShowSystemChars then l:=conv8bit(systemchars[ind]+l)
else if not cutformat and (systemchars[ind]<>'') then l:='{\v '+systemchars[ind]+'}'+conv8bit(l)
else l:=conv8bit(l);
end
else
l:=conv8bit(l);
FDest.add('{');
AddStyleRecordRTF_FONT(CombinedStyle,IDToStyle(ind),fdest,RTFFonts,RTFColors,false,RootID);
//if ind=MIDSecondLine then FDest.add('{\tab}');
FDest.add(l);
FDest.add('}');
end;
para:=false;
res:=GetFontID(s,l,ind);
end;
FDest.add('}\par}');
end;
end
else fdest.add(conv8bit(l));
end;
FDest.add('}');
fstyle:=TStringList.Create;
FRoot:=FZeroRoot;
ADDStyleTableRTF(fstyle,0);
for i:=1 to StylesCount do
ADDStyleTableRTF(fstyle,i);
for i:=0 to fstyle.count-1 do
fdest.Insert(stylepos+i,fstyle[i]);
fstyle.free;
if curfile>0 then
    FDest.saveTofile(tofile+inttostr(curfile)+'.rtf');
FDest.clear;
finally
RTFFonts.Free;
RTFColors.free;
dispose(CombinedStyle);
end;
end;

procedure TTxtToHtmlConverter.ConvertRTF(tofile:TFileName;CutFormat:boolean);
var i,ind:integer;
    s,l,nls:string;
    res,first:boolean;
    Year,Month,Day,Hour,Minute,Second,MS:Word;
    inpreambula,para:boolean;
    stylepos:integer;
    fstyle:TStringList;
    combinedStyle,zeroStyle:PStyleRecord;
    curid:integer;
function conv8bit(s:string):string;
var i:integer;
begin
result:='';
 for i:=1 to length(s) do
  if s[i]<#128 then
 if s[i] in ['\','{','}'] then
  result:=result+'\'+s[i]
  else
   if s[i]=#3 then result:=result+'\par '
  else
  result:=result+s[i]
               else result:=result+'\'''+inttohex(ord(s[i]),2);
end;
begin
New(CombinedStyle);
RTFFonts:=TStringList.create;
RTFColors:=TStringList.create;
try
ClearUsed;
FDest.clear;
DecodeDate(Now,Year,Month,Day);
DecodeTime(Now,Hour,Minute,Second,MS);
FDest.add('{\rtf1\ansi\uc1\deff0\ansicpg1251');
FDest.add('\deflang'+rtflang);
FDest.add('{\info');
FDest.add('{\title '+conv8bit(title)+'}');
FDest.add('{\author '+conv8bit(Author)+'}');
FDest.add('{\company '+conv8bit(Company)+'}');
FDest.add('{\creatim\yr'+inttostr(year)+'\mo'+inttostr(Month)+'\dy'+Inttostr(Day)+
                    '\hr'+inttostr(Hour)+'\min'+inttostr(Minute)+'\sec'+inttostr(Second)+'}');
FDest.add('{\*\userprops');
FDest.add('{{\propname GENERATOR}\proptype30 \staticval '+appconst.applicationName+'}');
FDest.add('{{\propname VERSION}\proptype30 \staticval '+appconst.version+'}');
FDest.add('{{\propname SERIAL}\proptype30 \staticval '+appconst.sysinfo.serial+'}');
FDest.add('{{\propname MODEL}\proptype30 \staticval '+MODELName+'}');
FDest.add('}');
FDest.add('}');
 RTFColors.add('\red0\green0\blue0;');
   RTFColors.add('\red255\green255\blue255;');
   RTFFonts.add('{\f0 Microsoft Sans Serif;}');

stylepos:=fdest.count;
FDest.add('\fs24\f0\ql');
ZeroStyle:=GetStyleRecord(58);
AddStyleRecordRTF_P(ZeroStyle,IDToStyle(ind),fdest,RTFFonts,RTFColors,false,0);
AddStyleRecordRTF_FONT(ZeroStyle,IDToStyle(ind),fdest,RTFFonts,RTFColors,false,0);
inpreambula:=false;
FRootLevel:=1;
for i:=1 to FSource.count-1 do
begin
s:=SubstStyle(FSource[i]);
if ClearSpaces(s)='' then continue;
if s='<TABLE>' then continue;
if s='</TABLE>' then continue;
if s='<TABLE1>' then continue;
if s='</TABLE1>' then continue;
if s='<PREAMBULA>' then
begin
inpreambula:=true;
ind:=3;
FDest.Add('{\pard\plain');
CombineStyles([ZeroStyle,GetStyleRecord(ind)],CombinedStyle);
AddStyleRecordRTF_P(CombinedStyle,IDToStyle(ind),fdest,RTFFonts,RTFColors,false,RootID);
AddStyleRecordRTF_FONT(CombinedStyle,IDToStyle(ind),fdest,RTFFonts,RTFColors,false,RootID);
continue;
end;
if s='</PREAMBULA>' then
begin
inpreambula:=false;
FDest.add('\par}');
continue;
end;
nls:=s;
res:=getparaid(s,l,ind);
IDToStyle(ind);
if ind=MIDSubHeader then    FRootLevel:=1;
first:=true;
if not inpreambula then begin
curid:=Integer(FSource.objects[i]);
if (l<>'')or(s<>'') then
begin
FDest.Add('{\pard\plain');
FDest.add('\tx0\tlul\tx8000\tlul\tx9000\tlul\tx10000');
para:=true;
while res do
begin
l:=ClearSpaces(l);
if ind>=0 then
begin
IDToStyle(ind);
used[ind]:=true;
end
else
l:=conv8bit(l);
CombineStyles([ZeroStyle,GetStyleRecord(ind)],CombinedStyle);
if para then
begin
AddStyleRecordRTF_P(CombinedStyle,IDToStyle(ind),fdest,RTFFonts,RTFColors,false,RootID);
FDest.add('{');
end;
if l<>'' then
begin
if  FShowSystemChars then l:=conv8bit(systemchars[ind]+l)
else if not cutformat and (systemchars[ind]<>'') then l:='{\v '+systemchars[ind]+'}'+conv8bit(l)
else l:=conv8bit(l);
FDest.add('{');
AddStyleRecordRTF_FONT(CombinedStyle,IDToStyle(ind),fdest,RTFFonts,RTFColors,false,RootID);

//if ind=MIDSecondLine then FDest.add('{\tab}');
FDest.add(l);
FDest.add('}');
end;
para:=false;
res:=GetFontID(s,l,ind);
end;
FDest.add('}\par}');
end
end
else fdest.add(conv8bit(l));
end;
FDest.add('}');

fstyle:=TStringList.Create;
FRoot:=FZeroRoot;
ADDStyleTableRTF(fstyle,0);
for i:=1 to StylesCount do
ADDStyleTableRTF(fstyle,i);
for i:=0 to fstyle.count-1 do
fdest.Insert(stylepos+i,fstyle[i]);
fstyle.free;

FDest.saveTofile(tofile);
FDest.clear;
finally
RTFFonts.Free;
RTFColors.free;
dispose(CombinedStyle);
end;
end;
function    TTxtToHtmlConverter.ProcessHTMLSpecial(s:string):string;
var i:integer;
begin
result:='';
for i:=1 to length(s) do
case s[i] of
#3 :result:=result+'<BR>';
'&':result:=result+'&amp;';
'<':result:=result+'&lt;';
'>':result:=result+'&gt;';
else
result:=result+s[i];
end;
end;
procedure   TTxtToHtmlConverter.ClearUsed;
var i,j:integer;
    p:PStyleRecord;
begin
 for i:=0 to 6 do used[i]:=true;
 for i:=7 to 62 do used[i]:=false;
 p:=FRoot;
 for i:=0 to 62 do  begin p^.ID:=i; p:=p^.next;end;
 for j:=1 to StylesCount do
 begin
  for i:=0 to 62 do
  CSSStyles[j].used[i]:=false;
  p:=CSSStyles[j].fRoot;
  for i:=0 to 62 do  begin p^.ID:=i; p:=p^.next;end;
 end;
end;
procedure   TTxtToHtmlConverter.AddCSSTemplate(id:integer;styleFileName:TFileName);
begin
 inc(stylesCount);
 CSSStyles[stylesCount].ID:=id;
 FStream.OpenStream(styleFileName,stRead);
 FStream.ReadStream(CSSStyles[stylesCount].FRoot);
 FStream.CloseStream;
end;
procedure TTxtToHtmlConverter.ClearStyles;
var i:integer;
begin
try
 for i:=1 to stylesCount do
 begin
  FStream.ClearCSSList(CSSStyles[i].FRoot);
  CSSStyles[i].FRoot:=nil;
 end;
finally
 stylesCount:=0;
end; 
 FRoot:=FZeroRoot;
 RootID:=0;
end;
function TTxtToHtmlConverter.SubstStyle(s:string):string;
var p1,p2:integer;
    id:string;
    styleId:integer;
    i:integer;
begin
 result:=s;
 FRoot:=fZeroRoot;
 RootIndex:=0;
 RootId:=0;
 p1:= pos('<##Style:=',s);
 if p1<>1 then FRoot:=fZeroRoot
 else
 begin
 p2:=pos('##>',s);
 if p2=0 then FRoot:=fZeroRoot
 else
 begin
  id:=copy(s,1+length('<##Style:='),p2-1-length('<##Style:='));
  result:=copy(s,p2+length('##>'),length(s));
  styleId:=strToIntDef(id,0);
  if styleId=0 then exit;
  rootId:=StyleID;
  for i:=1 to StylesCount do
   if CSSStyles[i].ID=styleID then
   begin
    FRoot:=CSSStyles[i].FRoot;
    RootIndex:=i;
   end;
 end;
 end;
end;
end.
