Unit BPLsa;

{ Logic Structure Analize Module }
{ Modified  06-08-02 }

Interface

Uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
     Printers,QRPrntr,BPDef,BPNode,BPLabel,TFlatProgressBarUnit,StdCtrls,MyUtils;

Type

  PLSAGraphNode=^TLSAGraphNode;
  TLSAGraphNode=record
    BPNode:TBPLSAGraphNode;
    CorrectNode:Boolean;
    llNode:PBPNode;
    NodeX:Array[0..100] of Integer;
    NodeY:Array[0..100] of Integer;
    NodeXYCount:Integer;
    FinalX:Integer;
    FinalY:Integer;
    RightRegion:Integer;
    LeftRegion:Integer;
    NodePassed:Boolean;
    LevelID:Integer;
    next:PLSAGraphNode;
  end;

  PLSAGraphLink=^TLSAGraphLink;
  TLSAGraphLink=record
     BPFromLabel:TBPLabel; {TBPLabel}
     BPToLabel:TBPLabel; {TBPLabel}
     FromNodeNumber:DWORD;
     ToNodeNumber:DWORD;
     dwFlags:DWORD;
     FromLinkNumber:DWORD; { CurrentWork ! }
     ToLinkNumber:DWORD;   { CurrentWork ! }
     LineArrayX:Array[0..20] of Integer;
     LineArrayY:Array[0..20] of Integer;
     LinePointCount:DWORD;
     StartPoint:TPoint;
     EndPoint:TPoint;
     LinkFromCount:DWORD;
     LinkToCount:DWORD;
     MinimalXFrom:Integer;
     MinimalXTo:Integer;
     MinimalYFrom:Integer;
     MinimalYTo:Integer;
     Color:TColor;                          { T's LinkType }
     PenStyle:TPenStyle;                    { T's LinkType }
     llLink:PBPLink;                       { For comparing }
     Visible:Boolean;
     IsCaseOp:Boolean;                     { For internal needs }
     LinkLeftCount:Integer;
     LinkRightCount:Integer;
     next:PLSAGraphLink;
  end;

  TBPLSALinkArray=record
    Links:Array[0..100] of PLSAGraphLink;
    LinksCount:Integer;
  end;

  TBPLSALinkArrayEx=record
    Links:Array[0..100] of PBPLink;
    LinksCount:Integer;
  end;

  TBPLSANodeArray=record
    NodesXLeft:Array[0..100] of Integer;
    NodesXRight:Array[0..100] of Integer;
    NodeNumber:Array[0..100] of DWORD;
    NodesCount:Integer;
  end;

  TBPLSACheckGraphArrayA=record
    Nodes:Array[0..100] of PBPNode;
    Links:Array[0..600] of PBPLink;
    NodesCount:Integer;
    LinksCount:Integer;
  end;

  TBPLSACheckGraphArray=record
    Nodes:Array[0..100,0..30] of PBPNode;
    Links:Array[0..600,0..30] of PBPLink;
    NodesCount:Array[0..30] of Integer;
    LinksCount:Array[0..30] of Integer;
  end;



  TBPLSALeftRight=record
    LeftRegion:Integer;
    RightRegion:Integer;
  end;

  TBPLSACoordinate=record
    Region:Array[0..100] of Integer;
    Count:Array[0..100] of Integer;
    RegionCount:Integer;
  end;


  TBPLSAFrame=class;

  TBPLSAGraph = class(TControl)
      private
       { Private declarations }
        FOwner:TBPLSAFrame;
        FNodes:PBPNode;
        { Spam }
        FSpamNodes:PBPSpamNode;
        FSpamNodesCount:Integer;
        { EndSpam }
        FLinks:PBPLink;
        FTree:PBPTree;     { Tree for model   }
        FNTTree:PBPNodeTypes; { NodeTypes Tree }
        FLTTree:PBPLinkTypes; { LinkTypes Tree }
        FOPTree:PBPOpTree;    { Operation Tree } { CurrentWork ! }
        FIPNode:PBPInProcessNode;
        FHeader:TBPHeader; { Header for model }
        FLevel:Integer;      { Level for model, model must have level -1 }
        FSSLevel:ShortString; { New level for model in x.x.x.x format }
                              { CurrentWork ! }
        FParentLevel:Integer;     { Parent level for model }
        FRootEntries:DWORD;
        FNodesCount:DWORD;
        FLinksCount:DWORD;
        FGNodesCount:Integer;
        FGLinksCount:Integer;
        FGraphNodes:PLSAGraphNode;
        FGraphLinks:PLSAGraphLink;
        FHaspFound:Boolean;
        FMaxWidth:Integer;
        FMaxHeight:Integer;
        { Global nodes links counters }
        FGlobalLeftLinksCount:Integer;
        FGlobalRightLinksCount:Integer;
        FGlobalLeftSize:Integer;
        FGlobalRightSize:Integer;
        FGlobalTopSize:Integer;
        FGlobalBottomSize:Integer;
        { For printing and other }
        FDefWidth:Integer;
        FDefHeight:Integer;
        FPrinting:Boolean;
        FScreenFontName:TFontName;
        FPrinterFontName:TFontName;
        { Vars for mashtabing }
        FFontDPI:Integer;   { FontDPI }
        FFontSize:Integer;  { FontSize }
        FLabelFontSize:Integer;
        FMaxCh:Double;
         {lines mashtabing interval }
        FMinLineStep:Integer; { Line Step }
        FMinArcRadius:Integer;
        FMinLabelX:Integer;
        FMinLabelY:Integer;
        FMinLabelY1:Integer;
        FMinGlobalLabel:Integer;
        FMinLineEndPoint:Integer;
        { nodes mashtabing vars }
        FNodeLineWidth:Integer;
        FNodeDefWidth:Integer;
        FNodeDefHeight:Integer;
        FNodeHSpacing:Integer;
        FNodeVSpacing:Integer;
        FNodeShadowDepth:Integer;
        FNodeWidth:Integer;
        FNodeHeight:Integer;
          {}
        FCalcWidthHeight:Boolean;
          { Debug routines }
        FDebug:Boolean;
        { AF Options }
        FFirstNodeNumber:DWORD;
        FLastNodeNumber:DWORD;
        FScaled:Boolean;             { Clip Windows to fit into ClipRect }
        FScaled2:Boolean;
        FScaled2Ratio:Extended;
        FDiscardDrags:Boolean;
        FRatioWC:Double;             { Ratio for recalc widthcoof }
        FRatioHC:Double;             { Ratio for recalc heightcoof }
        FModified:Boolean;
        FAcceptDragRect:TRect;       { Rect for Accept Drags & Drop }
        FLinksPosRelative:Boolean;
        { Analize graph}
        FADefWidth:Integer;
        FADefHeight:Integer;
        FinalNodeX:Array[0..100] of Integer;
        FinalNodeY:Array[0..100] of Integer;
        FinalWidth:Integer;
        FinalHeight:Integer;
        FRatioX:Double;
        FRatioY:Double;
        FNWidth:Integer;
        FNHeight:Integer;
        FNodeXArray:TBPLSANodeArray; { -+new }
        FChangeTabVisible:Boolean;
        FCheckGraph:TBPLSACheckGraphArray;
        FSearchGraph:TBPLSACheckGraphArrayA;
        { New Properties }
        FNodesCaptionVisible:Boolean;
        FJunctionCaptionVisible:Boolean;
        FMaxNodesCount:Integer;
        FRemoveSomeLinks:Boolean;
        { Debug properties }
        FGlobalShift:Boolean;
        FGlobalShift2:Boolean;
        FGlobalShift3:Boolean;
        FGlobalShift4:Boolean;
         { Graph routines }
        FTranslateNodesType:Integer;
        { New diagram index in level }
        FCurDiag:Integer;
        FFillDiag:Integer; { Var for filling FCheckArray }
        { Spam }
        FUseSpam:Boolean;
        { Advanced regions trace arrays }
        FLeftArray:TBPLSACoordinate;
        FRightArray:TBPLSACoordinate;
        { Nodes and Labels }
        FReplaceNodes:Boolean;
        FReplaceLabels:Boolean;
        FMaxWordLength:Integer;
        FMaxWordCount:Integer;
        FMaxLabelLength:Integer;
        { Barahlo}
        FDoOverrideFS:Boolean;
        FNodesFontSize:Integer;
        FDNodesFontSize:Integer;
        FDProjectionFontSize:Integer;
        FInProcessFontSize:Integer;
        FLabelsFontSize:Integer;
        FOverrideNodesFS:Boolean;
        FOverrideDNodesFS:Boolean;
        FOverrideInProcessFS:Boolean;
        FOverrideLabelsFS:Boolean;
         {      }
        FMaxFontSize:Integer;
        FRealMaxFontSize:Integer;

        FInLSAGraphLink:PLSAGraphLink;
        FInLSAGraphLink1:PLSAGraphLink;
        procedure SetMaxFontSize(Value:Integer);
        procedure UpdateMaxFontSize(Coof:Extended);
        procedure  AnalizeStringsFonts;
        procedure  SetTranslateNodesType(Value:Integer);
        function   GetLinkCaption(nodeNum:DWORD):ShortString;
        function   MyCheckForRemoveLink(l:PBPLink):Boolean;
        function   GetNTFromIndex(index:DWORD):TBPNodeTypes;
        function   GetLTFromIndex(index:DWORD):TBPLinkTypes;
        procedure  ClearGraphNodes;
        procedure  ClearGraphLinks;
        procedure  CreateGraphNodes(wc,hc:Double);
        procedure  CreateGraphLinks(wc,hc:Double);
        { Internal subroutines }
        procedure  CalcMaxWidthHeight;
        function   GetLinkLabel(LinkLabel:String;Var caseOp:Boolean):String;
        function   GetNodeLeftRight(NodeNumber:DWORD):TBPLSALeftRight;
        function   GetGraphNumberedNode(NodeNumber:DWORD):PLSAGraphNode;
        function   GetNumberedNodeEx(NodeNumber:DWORD):PBPNode;
        function   GetGraphLink(index:DWORD):PLSAGraphLink;
        function   GetGraphNode(index:DWORD):TBPLSAGraphNode;
        function   GetGraphNodeRec(index:DWORD):PLSAGraphNode;
        function   GetLinkFrom(const value:PLSAGraphLink):TLinkType;
        function   GetLinkTo(const value:PLSAGraphLink):TLinkType;
        function   GetMultipleMask(index:Integer):TBPMultipleMask;
        function   IsMultipleFirst(index:Integer;MultipleFrom:Boolean):Boolean;
        function   IsMultipleFirstEx(l:PBPLink;MultipleFrom:Boolean):Boolean;
        function   GetMultipleCountFrom(index:Integer):Integer;
        function   GetMultipleCountTo(index:Integer):Integer;
        function   GetMultipleFirst(index:Integer;MultipleFrom:Boolean):PLSAGraphLink;
        procedure  DrawSS(sx,sy,dx,dy:Integer;color:TColor);
        procedure  DrawArrowY(x,y:Integer;Positive:Boolean);
        procedure  DrawStartEnd(x,y,dx,dy:Integer;color:TColor;Start:Boolean;Fill:Boolean);
        { trace routines }
        procedure  CalcLabelSizes;
        procedure  TraceNodes;
        procedure  TraceLinksToNodeCounters;
        procedure  CorrectLinksCounters;
        procedure  TraceNodesToLinksCounters;
        procedure  TraceGlobalStartEndPoints;
        procedure  TraceLocalStartEndPoints;
        procedure  TraceLinks;
        procedure  DrawLinks;
        procedure  SetFontSize(Value:Integer);
        { Set scale of window to fit to Clip Rect }
        procedure SetNodesCaptionVisible(Value:Boolean);
        procedure SetJunctionCaptionVisible(Value:Boolean);
        procedure  SetScaled(Value:Boolean);
        procedure  SetScaled2(Value:Boolean);
        procedure  SetScaled2Ratio(Value:Extended);
        procedure SetDefWidth(Value:Integer);
        procedure SetDefHeight(Value:Integer);
        procedure SetDiscardDrags(Value:Boolean);
        { Analyze Graph }
        function  GetFirstInPoint:PLSAGraphLink;
        function  GetNextInPoint:PLSAGraphLink;
        function  GetFirstInPoint1:PLSAGraphLink;
        function  GetNextInPoint1:PLSAGraphLink;

        function  GetFirstInPointEx:PBPLink;
        function  LinkExInAllCheckGraph(link:PBPLink):Boolean;
        function  GetNextInPointEx:PBPLink;
        function  AnalizeLink(p:TPoint;link:PLSAGraphLink;Level:Integer;var Shift:Integer;nWidth:Integer;ShiftRight:Boolean):TPoint;
        procedure AnalizeGraph(link:PBPLink;level:Integer;var flag:Boolean);
        function  NodePassedEx(node:PBPNode):Boolean;
        function  LinkExsistsEx(link:PBPLink):Boolean;
        function  GetOutputLinksArrayEx(node:PBPNode):TBPLSALinkArrayEx;
        function  IsNodeVisibleEx(node:PBPNode):Boolean;
        function  IsLinkVisibleEx(link:PBPLink):Boolean;
        function  GetInputLinkEx(node:PBPNode):PBPLink;

        procedure CreateCheckGraph;
        procedure InitGNodes;
        procedure InitGLinks;
        function  GetOutputLinksArray(node:PLSAGraphNode):TBPLSALinkArray;
        procedure SortOutputLinksArray(var GLinks:TBPLSALinkArray);
        function  CalcOutputCount(node:PLSAGraphNode):Integer;
        function  CalcNeedOutputShift(var GLinks:TBPLSALinkArray;Output:Integer):Integer;
        function  CalcPagesCount:Integer;
        function  GetInputLink(node:PLSAGraphNode):PLSAGraphLink;
        { Drag & Drop }
        procedure  MyNodeMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer); { Checked }
        procedure  MyLabelMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer); { Checked }
        procedure  UpdateNodesModel(X,Y:Integer;node:TBPLSAGraphNode);
        procedure  UpdateLinksModel(X,Y:Integer;llabel:TBPLabel);
        procedure  CorrectLinksModel(delta:TPoint;NodeNum:DWORD;AcceptRect:TRect);
        { Scaling True }
        procedure   GetMaxNodesCount;
        procedure   SetRemoveSomeLinks(Value:Boolean);
        function    MyNodePassedEx(node:PBPNode):Boolean;
        procedure   AnalizeGraphEx(link,finalLink:PBPLink;oldNode:PBPNode;pLength:Integer;var Final:Boolean);
        function    MyLinkExsistsEx(link,fl:PBPLink):Boolean;
        function    MyGetOutputLinksArrayEx(node:PBPNode):TBPLSALinkArrayEx;
        function    GetFirstInNodePointEx(nodeNum:DWORD):PBPLink;
        function    GetNodeNumberEx(nodeNum:String):Integer;
        procedure   SetGlobalShift(Value:Boolean);
        procedure   SetGlobalShift2(Value:Boolean);
        procedure   SetGlobalShift3(Value:Boolean);
        procedure   SetGlobalShift4(Value:Boolean);
        {}
        procedure FillLeftArray;
        procedure FillRightArray;
        function  IsLeftArray(value:Integer):Integer;
        function  IsRightArray(value:Integer):Integer;
        { Spam function }
        procedure   SetUseSpam(Value:Boolean);
        procedure   FillSpamNodes;
        procedure   ClearSpamNodes;
        procedure   TraceLeftSpamNodes;
        function    GetSpamToLinkNumber(link:PBPLink;spamTop,spamBottom:Boolean):Integer;
        function    IsLinkIndexEqual(li1,li2:String):Boolean;
      public
       { Public declarations }
        FLang:TFontCharset;
        procedure   Optimize;
        procedure   OptimizeModel(pb:TFlatProgressBar;Lbl:TLabel);
        function    OptimizeNodeFonts:Integer;
        procedure   SetMaxAll(BReplaceNodes,BReplaceLabels:Boolean;IMaxWordLength,IMaxWordCount,IMaxLabelLength:Integer);
        procedure   SetOverrideFonts(NFS,DNFS,DPFS,IPFS,LFS:Integer;ONFS,ODFS,OIFS,OLFS:Boolean);
        procedure   SetOverrideFontsAll(NFS,DNFS,DPFS,IPFS,LFS:Integer;ONFS,ODFS,OIFS,OLFS:Boolean;
                                        CNFS,CDNFS,CDPFS,CIPFS,CLFS,CONFS,CODFS,COIFS,COLFS:Boolean);
        constructor Create(AOwner: TComponent); override;
        destructor  Destroy; override;
        procedure   TraceRoute; { Main Tracing Procedure }
        procedure   AssignModel(Tree:PBPTree;NTTree:PBPNodeTypes;LTTree:PBPLinkTypes;
                                OPTree:PBPOpTree;Header:TBPHeader;IPNode:PBPInProcessNode);
        procedure   ClearModel;
        procedure   OpenLevel(wLevel,wDiag:Integer);
        procedure   PresetupFrame(widthcoof,heightcoof:Double);
        { Scale }
        procedure  SetDefaultConstants;
        procedure  SetScaledConstants(ratiox,ratioy,ratio:Double;fontSizeRatio:Double;LabelFontSizeRatio:Double);
        function   IsLevelValid:Boolean;
        function   GetMaxPagesCount:Integer;
        procedure  OptimizeLFS;
        function   HasLongMarch(l:PBPLink):Boolean;
        procedure  SetCurDiag(Value:Integer);

      published
       { Published declarations }
       property Parent:TBPLSAFrame read FOwner write FOwner;
       property FontDPI:Integer read FFontDPI write FFontDPI;
       property DefWidth:Integer read FDefWidth write SetDefWidth;
       property DefHeight:Integer read FDefHeight write SetDefHeight;
       property MaxWidth:Integer read FMaxWidth;
       property MaxHeight:Integer read FMaxHeight;
       property NodeWidth:Integer read FNodeWidth;
       property NodeHeight:Integer read FNodeHeight;
       property Printing:Boolean read FPrinting write FPrinting;
       property MinLineStep:Integer read FMinLineStep write FMinLineStep default 6;
       property GlobalLeftSize:Integer read FGlobalLeftSize write FGlobalLeftSize default 80;
       property GlobalRightSize:Integer read FGlobalRightSize write FGlobalRightSize default 80;
       property GlobalTopSize:Integer read FGlobalTopSize write FGlobalTopSize default 80;
       property GlobalBottomSize:Integer read FGlobalBottomSize write FGlobalBottomSize default 80;
       property FontSize:Integer read FFontSize write SetFontSize;
       property GNodesCount:DWORD read FGNodesCount;
       property MinArcRadius:Integer read FMinArcRadius write FMinArcRadius;
       property MinLabelX:Integer read FMinLabelX write FMinLabelX;
       property MinLabelY:Integer read FMinLabelY write FMinLabelY;
       property MinLabelY1:Integer read FMinLabelY1 write FMinLabelY1;
       property MinGlobalLabel:Integer read FMinGlobalLabel write FMinGlobalLabel;
       property MinLineEndPoint:Integer read  FMinLineEndPoint write FMinLineEndPoint;
       property Level:Integer read FLevel;
       property SSLevel:ShortString read FSSLevel; { CurrentWork !}
       property ParentLevel:Integer read FParentLevel;
       property HaspFound:Boolean read FHaspFound write FHaspFound default False;
       property ScreenFontName:TFontName read FScreenFontName write FScreenFontName;
       property PrinterFontName:TFontName read FPrinterFontName write FPrinterFontName;
       property Debug:Boolean read FDebug write FDebug;
       property Scaled:Boolean read FScaled write SetScaled;
       property Scaled2:Boolean read FScaled2 write SetScaled2;
       property Scaled2Ratio:Extended read FScaled2Ratio write SetScaled2Ratio;
       property DiscardDrags:Boolean read FDiscardDrags write SetDiscardDrags;
       property Modified:Boolean read FModified write FModified;
       property AcceptDragRect:TRect read FAcceptDragRect;
       property LinksPosRelative:Boolean read FLinksPosRelative write FLinksPosRelative default True;
       property NodesCaptionVisible:Boolean read FNodesCaptionVisible write SetNodesCaptionVisible default False;
       property JunctionCaptionVisible:Boolean read FJunctionCaptionVisible write SetJunctionCaptionVisible default False;
       property RootEntries:Integer read FRootEntries;
       property RemoveSomeLinks:Boolean read FRemoveSomeLinks write SetRemoveSomeLinks;
       property GlobalShift:Boolean read FGlobalShift write SetGlobalShift;
       property GlobalShift2:Boolean read FGlobalShift2 write SetGlobalShift2;
       property GlobalShift3:Boolean read FGlobalShift3 write SetGlobalShift3;
       property GlobalShift4:Boolean read FGlobalShift4 write SetGlobalShift4;
       property TranslateLinkType:Integer read FTranslateNodesType write SetTranslateNodesType;
       property DiagCount:Integer read FFillDiag;
       property CurDiag:Integer read FCurDiag write SetCurDiag;
       property UseSpam:Boolean read FUseSpam write SetUseSpam;
       {New}
       property NodesFontSize:Integer read FNodesFontSize;
       property DNodesFontSize:Integer read FDNodesFontSize;
       property DProjectionFontSize:Integer read FDProjectionFontSize;
       property InProcessFontSize:Integer read FInProcessFontSize;
       property LabelsFontSize:Integer read FLabelsFontSize;
       property OverrideNodesFS:Boolean read FOverrideNodesFS;
       property OverrideDNodesFS:Boolean read FOverrideDNodesFS;
       property OverrideInProcessFS:Boolean read FOverrideInProcessFS;
       property OverrideLabelsFS:Boolean read FOverrideLabelsFS;
       property MaxFontSize:Integer read FMaxFontSize write SetMaxFontSize;
     end;

{ TBPLSAFrame definition }
  TBPLSAFrame = class(TScrollingWinControl)
  private
    { Private declarations }
    FBPLSAGraph:TBPLSAGraph;                         { _++-+ +- }
    FCanvas: TCanvas;
    { Page Param Options }
    FPageTop:Integer;
    FPageBottom:Integer;
    FPageLeft:Integer;
    FPageRight:Integer;
    FPrinter:TQRPrinter;
    FPrinting:Boolean;
    FPainting:Boolean; { So disable double insert in painting module }
    FAborting:Boolean;
    { Vars for scaling diagrams }
    FHorzPageCount:Integer;
    FVertPageCount:Integer;
    { Vars for scaling ramka font }
    FRamkaFontRatio:Extended;
    FPSizeH:Extended;
    FPSizeW:Extended;
    FRamkaH:Integer;
    procedure WMPaint(var Message: TWMPaint); message WM_PAINT;
  protected
    { Protected declarations }
    procedure Paint; virtual;
    procedure PaintWindow(DC: HDC); override;
    procedure PaintTo(DC: HDC; X, Y: Integer);
    procedure PaintPageTo(DC: HDC; X, Y: Integer; PageClipRect:TRect);
    { printing routines }
    procedure  PreviewPrintRect(left,right,top,bottom:Integer);
    procedure  PrintRect(left,right,top,bottom:Integer);
    procedure  DrawNode(l,t,w,h:Integer;Canvas:TCanvas;PaintColor,DrawColor:TColor;ShapeType:TLSAShapeType);
    procedure  DrawLink(pl:PLSAGraphLink;Canvas:TCanvas;RatioX,RatioY:Double;Wpos,Hpos:Integer);
    procedure  MyDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure  MyDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
    function   GetCoof(rw,rh:Double;Alg:TBPFormatAlg):Double;
  public
    { Public declarations }
    FUpdatingNavigator:Boolean;
    FPreviewOrPrint:Boolean;
    FFontCoof:Double;
    FNodesValue:Array[0..1] of Integer; { Min Max }
    FFormatAlg:array[0..2] of TBPFormatAlg; { Min Middle Max }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure SetPageParam(Var PageTop,PageBottom,PageLeft,PageRight:Integer;ShowWarning:Boolean);
    procedure SetPreviewPageParam(PageTop,PageBottom,PageLeft,PageRight:Integer);
    procedure Print;
    procedure CreateBitmap(var value:TBitmap;pf:TPixelFormat);
    procedure GetBitmapWithSize(value:TBitmap;iw,ih:Integer); { scaled bitmap }
    procedure CreateBitmapWithSize(var value:TBitmap;pf:TPixelFormat;iw,ih:Integer); { scaled bitmap }
    procedure CreateBitmapForOneShit(var value:TBitmap;pf:TPixelFormat;iw,ih,shitw,shith,maxshitw,maxshith:Integer);
    procedure CreatePreview;
    procedure PrintAll(pb:TFlatProgressBar;Lbl:TLabel;StartP,EndP:Integer);
    procedure CreatePreviewAll(pb:TFlatProgressBar;Lbl:TLabel);
  published
    { Published declarations }
    property BPLSAGraph:TBPLSAGraph read FBPLSAGraph;
    property HorzPages:Integer read FHorzPageCount write FHorzPageCount default 1;
    property VertPages:Integer read FVertPageCount write FVertPageCount default 1;
    property Align default alNone;
    property Width default 100;
    property Height default 100;
    property Enabled default True;
    property ShowHint;
    property Visible;
    property Ctl3D;
    property TabStop default True;
    property TabOrder;
    property Canvas:TCanvas read FCanvas;
    property QPrinter:TQRPrinter read FPrinter;
    property Printing:Boolean read FPrinting;
    property Aborting:Boolean read FAborting write FAborting;
    property OnKeyUp;
    property OnEnter;
    property OnExit;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnStartDrag;
    property PopupMenu;
  end;

function SignedVector(Sign,Value:Integer):Integer;

procedure Register;

Const StartMinLineStep=6;
      StartMinLabelX=8;
      StartMinLabelY=4;
      StartMinLabelY1=12; { Try to change }
      StartMinArcRadius=8;
      NodeRatio=4/3;
      StartMinGlobalLabel=10;
      StartMinLineEndPoint=4;
      StartMaxLines=4;

      A3Width=11.6929;  { Inch }
      A3Height=16.5354; { Inch }
      DefMaxLabelFontSize=14;

Implementation

Uses MainUnit,AnalizeGraphUnit;



function SignedVector(Sign,Value:Integer):Integer;
 begin
   if Sign>0 then Result:=1 else
   if Sign<0 then Result:=-1 else Result:=0;
   Result:=Result*Value;
 end;

{ TBPLSAGraph }

function  TBPLSAGraph.IsLinkIndexEqual(li1,li2:String):Boolean;
Var s1,s2:String;
    p1,p2,p3,p4:Integer;
 begin
   Result:=False;
   if length(li1)=0 then Exit;
   if length(li2)=0 then Exit;
   p1:=pos('<',li1);
   p2:=pos('<',li2);
   p3:=pos('>',li1);
   p4:=pos('>',li2);
   if (p1=0) or (p2=0) or (p3=0) or (p4=0) or (p1>p3) or (p2>p4) then Exit;
   s1:=copy(li1,p1+1,p3-p1-1);
   s2:=copy(li2,p2+1,p4-p2-1);
   if s1=s2 then Result:=True;
 end;

function  TBPLSAGraph.OptimizeNodeFonts:Integer;
Var       i:Integer;
  OptFSize,FS:Integer;
     gNode:PLSAGraphNode;
         h:Integer;
         w:Integer;
         dc:HDC;
         ppi:Integer;
 begin
   if FNodesCount=0 then Exit;
   if (FFontSize>=FRealMaxFontSize) then Exit;
   dc:=GetDC(0);
   ppi:=GetDeviceCaps(dc,LOGPIXELSX);
   ReleaseDC(0,dc);
   gNode:=FGraphNodes;
   OptFSize:=100000;
   for i:=0 to (FGNodesCount-1) do
     begin
       h:=gnode^.BPNode.Height;
       w:=gnode^.BPNode.Width;
       fs:=Round(FFontSize/FScaled2Ratio*100);
       gnode^.BPNode.AutoHeight:=True;
       gnode^.BPNode.DefWidth:=Round(w/1.1);
       gnode^.BPNode.Font.PixelsPerInch:=ppi;
       while (gnode^.BPNode.Height<=h) do
         begin
           inc(fs);
           gnode^.BPNode.Font.Size:=fs;
           gnode^.BPNode.PaintImmediate;
           while gnode^.BPNode.Updating do;
         end;
       dec(fs);
       if (OptFSize>fs) then OptFSize:=fs;
       gnode^.BPNode.AutoHeight:=False;
       gnode:=gnode^.next;
     end;
   Result:=OptFSize;
 end;


procedure TBPLSAGraph.OptimizeModel(pb:TFlatProgressBar;Lbl:TLabel);
Var tmptree:PBPTree;
    fs:Integer;
   lfs:Integer;
 oldLevel:Integer;
   pos:Integer;
   cnt:Integer;
   adv:Double;
 begin
   if (FTree=nil) then Exit;
   oldLevel:=FLevel;
   tmpTree:=FTree;
   cnt:=FRootEntries;
   pos:=0;
   pb.Position:=0;
   Lbl.Caption:=IntToStr(pos);
   Application.ProcessMessages;
   while (tmpTree<>nil) do
    begin
          FNodesCount:=tmpTree^.dwNodesCount;
          FLinksCount:=tmpTree^.dwLinksCount;
          FNodes:=tmpTree^.lpNodes;
          FLinks:=tmpTree^.lpLinks;
          FLevel:=tmpTree^.dwLevel;
          FSSLevel:=tmpTree^.ssLevel;
          FParentLevel:=tmpTree^.dwParent;
          FNodesFontSize:=tmpTree^.dwNodesFontSize;
          FDNodesFontSize:=tmpTree^.dwDNodesFontSize;
          FDProjectionFontSize:=tmpTree^.dwDProjectionFontSize;
          FInProcessFontSize:=tmpTree^.dwInProcessFontSize;
          FLabelsFontSize:=tmpTree^.dwLabelsFontSize;
          FOverrideNodesFS:=tmpTree^.dbOverrideNodesFS;
          FOverrideDNodesFS:=tmpTree^.dbOverrideDNodesFS;
          FOverrideInProcessFS:=tmpTree^.dbOverrideInProcessFS;
          FOverrideLabelsFS:=tmpTree^.dbOverrideLabelsFS;
          SetDefaultConstants;
          CreateGraphNodes(1,1);
          CreateGraphLinks(1,1);
          Scaled:=Scaled;
          if (not(FScaled)) then PresetupFrame(1,1);
          TraceRoute;
           FOwner.Invalidate;
     fs:=OptimizeNodeFOnts;
     lfs:=Round(fs*FMaxCH);
     if fs>FRealMaxFontSize then fs:=FRealMaxFontSize;
     if lfs>FRealMaxFontSize then lfs:=FRealMaxFontSize;
     FNodesFontSize:=fs;
     FLabelsFontSize:=lfs;
    {FDNodesFontSize:=lfs;
     FDProjectionFontSize:=lfs;}
{     FInProcessFontSize:=fs;}
     FOverrideNodesFS:=True;
     FOverrideLabelsFS:=True;
{     FOverrideInProcessFS:=True;}
    {FOverrideDNodesFS:=True;}
     tmpTree^.dwNodesFontSize:=fs;
     tmpTree^.dbOverrideNodesFS:=True;
{     tmpTree^.dwInProcessFontSize:=fs;
     tmpTree^.dbOverrideInProcessFS:=True;}
     tmpTree^.dwLabelsFontSize:=LFS;
     tmpTree^.dbOverrideLabelsFS:=True;
{     tmpTree^.dwDNodesFontSize:=lfs;
     tmpTree^.dbOverrideDNodesFS:=True;
     tmpTree^.dwDProjectionFontSize:=lfs;}
     FModified:=True;
     tmpTree:=tmpTree^.next;
     inc(pos);
     pb.Position:=Round(pos/cnt*100);
     Lbl.Caption:=IntToStr(pb.Position);
     Application.ProcessMessages;
    end;
    OpenLevel(OldLevel,FCurDiag);
    FOwner.Visible:=False;
    pb.Position:=100;
    Lbl.Caption:='100';
    Application.ProcessMessages;
 end;

procedure TBPLSAGraph.Optimize;
Var tmptree:PBPTree;
    fs:Integer;
   lfs:Integer;
 begin
   if (FTree=nil) then Exit;
   fs:=OptimizeNodeFOnts;
   lfs:=Round(fs*FMaxCH);
   if fs>FRealMaxFontSize then fs:=FRealMaxFontSize;
   if lfs>FRealMaxFontSize then lfs:=FRealMaxFontSize;
   FNodesFontSize:=fs;
   FLabelsFontSize:=lfs;
{   FDNodesFontSize:=lfs;
   FDProjectionFontSize:=lfs;}
{   FInProcessFontSize:=fs;}
   FOverrideNodesFS:=True;
   FOverrideLabelsFS:=True;
{   FOverrideInProcessFS:=True;}
{   FOverrideDNodesFS:=True;}
   tmpTree:=FTree;
   while (tmpTree<>nil) and (tmpTree^.dwLevel<>FLevel) do tmpTree:=tmpTree^.next;
   if (tmpTree<>nil) then
   begin
     tmpTree^.dwNodesFontSize:=fs;
     tmpTree^.dbOverrideNodesFS:=True;
{     tmpTree^.dwInProcessFontSize:=fs;}
{     tmpTree^.dbOverrideInProcessFS:=True;}
     tmpTree^.dwLabelsFontSize:=LFS;
     tmpTree^.dbOverrideLabelsFS:=True;
{     tmpTree^.dwDNodesFontSize:=lfs;
     tmpTree^.dbOverrideDNodesFS:=True;
     tmpTree^.dwDProjectionFontSize:=lfs;}
     FModified:=True;
   end;
 end;


procedure TBPLSAGraph.SetOverrideFontsAll(NFS,DNFS,DPFS,IPFS,LFS:Integer;ONFS,ODFS,OIFS,OLFS:Boolean;
                                          CNFS,CDNFS,CDPFS,CIPFS,CLFS,CONFS,CODFS,COIFS,COLFS:Boolean);
Var tmptree:PBPTree;
 begin
  if CNFS then  FNodesFontSize:=NFS;
  if CDNFS then FDNodesFontSize:=DNFS;
  if CDPFS then FDProjectionFontSize:=DPFS;
  if CIPFS then FInProcessFontSize:=IPFS;
  if CLFS then FLabelsFontSize:=LFS;
  if CONFS then FOverrideNodesFS:=ONFS;
  if CODFS then FOverrideDNodesFS:=ODFS;
  if COIFS then FOverrideInProcessFS:=OIFS;
  if COLFS then FOverrideLabelsFS:=OLFS;
  if (FTree=nil) then Exit;
  tmpTree:=FTree;
  while (tmpTree<>nil) do
   begin
     if CNFS then tmpTree^.dwNodesFontSize:=NFS;
     if CONFS then tmpTree^.dbOverrideNodesFS:=ONFS;
     if CDNFS then  tmpTree^.dwDNodesFontSize:=DNFS;
     if CODFS then tmpTree^.dbOverrideDNodesFS:=ODFS;
     if CDPFS then tmpTree^.dwDProjectionFontSize:=DPFS;
     if CIPFS then tmpTree^.dwInProcessFontSize:=IPFS;
     if COIFS then tmpTree^.dbOverrideInProcessFS:=OIFS;
     if CLFS then  tmpTree^.dwLabelsFontSize:=LFS;
     if COLFS then tmpTree^.dbOverrideLabelsFS:=OLFS;
     FModified:=True;
     tmpTree:=tmpTree^.next;
   end;
 end;


procedure TBPLSAGraph.SetOverrideFonts(NFS,DNFS,DPFS,IPFS,LFS:Integer;ONFS,ODFS,OIFS,OLFS:Boolean);
 begin
  FNodesFontSize:=NFS;
  FDNodesFontSize:=DNFS;
  FDProjectionFontSize:=DPFS;
  FInProcessFontSize:=IPFS;
  FLabelsFontSize:=LFS;
  FOverrideNodesFS:=ONFS;
  FOverrideDNodesFS:=ODFS;
  FOverrideInProcessFS:=OIFS;
  FOverrideLabelsFS:=OLFS;
 end;


procedure TBPLSAGraph.AnalizeStringsFonts;
Var s:String;
  len,i:Integer;
  node:TBPLSAGraphNode;
  nodeP:PLSAGraphNode;
  flag:Boolean;
  fs:Integer;
 begin
   if not(BPViewMainForm.EnableAnalizForm.Checked) then Exit;
   if (AnalizeGraphForm=nil) then Exit;
   if (FGNodesCount=0) then Exit;
   if (FGraphNodes=nil) then Exit;
   if FOverrideNodesFS then Exit;
   fs:=Round(FFontSize/FScaled2Ratio*100);
   with AnalizeGraphForm do
    begin
      if (not(FReplaceNodes) and (fs<BP_MINFONT_SIZE)) then
       begin
        flag:=False;
        ResultEditor.Clear;
        len:=(FMaxWordLength+1)*FMaxWordCount;
        for i:=0 to (FGNodesCount-1) do
         begin
          node:=GetGraphNode(i);
          if (length(node.Caption)>len) then
           begin
            ResultEditor.Lines.Append(': '+node.SNodeNumber+' "'+node.Caption+'"');
            flag:=True;
           end;
         end;
        if flag then
           begin
            ResultEditor.Lines.Append(' ');
            ResultEditor.Lines.Append('    '+IntToStr(len)+' ');
            ResultEditor.Lines.Append('         -');
            ResultEditor.Lines.Append('   "  "  ""');
            ResultEditor.Lines.Append(' ');
            ResultEditor.Lines.Append(':    ( )');
            ResultEditor.Lines.Append(' ');
            ResultEditor.Lines.Append('  ='+IntToStr(fs)+' pt.');
            ShowModal;
           end;
       end
      else
       if (FReplaceNodes and (fs<BP_MINFONT_SIZE)) then
        begin
          flag:=False;
          ResultEditor.Clear;
          nodeP:=FGraphNodes;
          for i:=0 to (FGNodesCount-1) do
           begin
             if length(nodeP^.BPNode.Caption)<length(nodeP^.llNode^.ssCaption) then
              begin
               ResultEditor.Lines.Append(': '+nodeP^.BPNode.SNodeNumber+' "'+nodeP^.llNode^.ssCaption+'"');
               ResultEditor.Lines.Append(': "'+nodeP^.BPNode.Caption+'"');
               ResultEditor.Lines.Append(' ');
               flag:=True;
              end;
             nodeP:=nodeP^.Next;
           end;
          if flag then
          begin
           ResultEditor.Lines.Append(':  ,        "  "  ""');
           ResultEditor.Lines.Append('         -');
           ResultEditor.Lines.Append(' ');
           ResultEditor.Lines.Append('  ='+IntToStr(fs)+' pt.');
           ShowModal;
          end;
        end;
      if (FReplaceNodes) and (fs<BP_MINFONT_SIZE) and (not(flag)) then
        begin
         if (FMaxNodesCount>6) then
          begin
          ResultEditor.Clear;
          ResultEditor.Lines.Append(':   -         ');
          ResultEditor.Lines.Append('       ');
          ResultEditor.Lines.Append(' ');
          ResultEditor.Lines.Append('  ='+IntToStr(fs)+' pt.');
          ShowModal;
          end
         else
          begin
          ResultEditor.Clear;
          ResultEditor.Lines.Append(':  ,        "  "  ""');
          ResultEditor.Lines.Append('         -');
          ResultEditor.Lines.Append(' ');
          ResultEditor.Lines.Append('  ='+IntToStr(fs)+' pt.');
          ShowModal;
         end;
        end
      else
      if (not(FReplaceNodes)) and (fs<BP_MINFONT_SIZE) and (not(flag)) then
        begin
         if (FMaxNodesCount>6) then
          begin
          ResultEditor.Clear;
          ResultEditor.Lines.Append(':   -         ');
          ResultEditor.Lines.Append('       ');
          ResultEditor.Lines.Append(' ');
          ResultEditor.Lines.Append('  ='+IntToStr(fs)+' pt.');
          ShowModal;
          end
         else
          begin
          ResultEditor.Clear;
          ResultEditor.Lines.Append(':  ,        "  "  ""');
          ResultEditor.Lines.Append('         -');
          ResultEditor.Lines.Append(' ');
          ResultEditor.Lines.Append('  ='+IntToStr(fs)+' pt.');
          ShowModal;
          end;
        end;
    end;
 end;


 procedure TBPLSAGraph.SetMaxAll(BReplaceNodes,BReplaceLabels:Boolean;IMaxWordLength,IMaxWordCount,IMaxLabelLength:Integer);
  begin
   FReplaceNodes:=BReplaceNodes;
   FReplaceLabels:=BReplaceLabels;
   FMaxWordLength:=IMaxWordLength;
   FMaxWordCount:=IMaxWordCount;
   FMaxLabelLength:=IMaxLabelLength;
   FOwner.Visible:=False;
   OpenLevel(FLevel,FCurDiag);
   FOwner.Invalidate;
   FOwner.Visible:=True;
  end;

 procedure TBPLSAGraph.SetMaxFontSize(Value:Integer);
 Var oldPosX,oldPosY:Integer;
 begin
   FMaxFontSize:=Value;
   FOwner.Visible:=False;
   if FOwner.HorzScrollBar.Visible and
     (FOwner.HorzScrollBar.Range>0) then
       oldPosX:=FOwner.HorzScrollBar.Position
   else
       oldPosX:=0;
   if FOwner.VertScrollBar.Visible and
     (FOwner.VertScrollBar.Range>0) then
       oldPosY:=FOwner.VertScrollBar.Position
   else
       oldPosY:=0;
   OpenLevel(FLevel,FCurDiag);
   FOwner.Invalidate;
   if FOwner.HorzScrollBar.Visible and
     (FOwner.HorzScrollBar.Range>0) then
       FOwner.HorzScrollBar.Position:=oldPosX;
   if FOwner.VertScrollBar.Visible and
     (FOwner.VertScrollBar.Range>0) then
       FOwner.VertScrollBar.Position:=oldPosY;
   FOwner.Visible:=True;
 end;


 procedure TBPLSAGraph.SetUseSpam(Value:Boolean);
 Var oldPosX,oldPosY:Integer;
  begin
    FUseSpam:=Value;
    FOwner.Visible:=False;
   if FOwner.HorzScrollBar.Visible and
     (FOwner.HorzScrollBar.Range>0) then
       oldPosX:=FOwner.HorzScrollBar.Position
   else
       oldPosX:=0;
   if FOwner.VertScrollBar.Visible and
     (FOwner.VertScrollBar.Range>0) then
       oldPosY:=FOwner.VertScrollBar.Position
   else
       oldPosY:=0;
   OpenLevel(FLevel,FCurDiag);
   FOwner.Invalidate;
   if FOwner.HorzScrollBar.Visible and
     (FOwner.HorzScrollBar.Range>0) then
       FOwner.HorzScrollBar.Position:=oldPosX;
   if FOwner.VertScrollBar.Visible and
     (FOwner.VertScrollBar.Range>0) then
       FOwner.VertScrollBar.Position:=oldPosY;
   FOwner.Visible:=True;
  end;


 procedure TBPLSAGraph.ClearSpamNodes;
  begin
    if (FSpamNodes<>nil) then
     begin
      FreeMem(FSpamNodes,sizeof(TBPSpamNode)*FSpamNodesCount);
      FSpamNodes:=nil;
      FSpamNodesCount:=0;
     end;
  end;


 procedure TBPLSAGraph.FillSpamNodes;
 Var tmpNode:PBPNode;
    spamNode:PBPSpamNode;
           i,j:Integer;
  begin
    if (FNodes=nil) then Exit;
    tmpNode:=FNodes;
    ClearSpamNodes;
    FSpamNodesCount:=FNodesCount;
    spamNode:=PBPSpamNode(AllocMem(sizeof(TBPSpamNode)*FNodesCount));
    FSpamNodes:=spamNode;
    for i:=0 to (FNodesCount-1) do
     begin
       system.Move(tmpNode^,spamNode^,sizeof(TBPNode));
       spamNode^.LeftLinksCount:=0;
       spamNode^.TopLinksCount:=0;
       spamNode^.BottomLinksCount:=0;
       for j:=0 to 50 do
         begin
           spamNode^.ResultLinkNumber[j,0]:=0;
           spamNode^.ResultLinkNumber[j,1]:=0;
         end;
       inc(tmpNode);
       inc(spamNode);
     end;
  end;

 procedure  TBPLSAGraph.TraceLeftSpamNodes;
 Var linkp:PBPLink;
  spamNode:PBPSpamNode;
         i,j:Integer;
  begin
    if FLinksCount=0 then Exit;
    if FSpamNodesCount=0 then Exit;
    if (not(FUseSpam)) then Exit;
    linkp:=FLinks;
    for i:=0 to (FLinksCount-1) do
     begin
       spamNode:=FSpamNodes;
       for j:=0 to (FSpamNodesCount-1) do
        begin
          if (spamNode^.dwNodeNumber=linkp^.dwToNodeNumber) and
             ((linkP^.dwFlags and BP_FROMTOMASK)=BP_RIGHT_LEFT) then
             if (spamNode^.LeftLinksCount<linkp^.dwToLinkNumber) then
                 spamNode^.LeftLinksCount:=linkp^.dwToLinkNumber;
          inc(spamNode);
        end;
       inc(linkP);
     end;
  end;

 function  TBPLSAGraph.GetSpamToLinkNumber(link:PBPLink;spamTop,spamBottom:Boolean):Integer;
 Var   spamNode:PBPSpamNode;
          i:Integer;
  begin
    Result:=1;
    if (link=nil) then Exit;
    Result:=link^.dwToLinkNumber;
    if (FSpamNodesCount=0) then Exit;
    spamNode:=FSpamNodes;
    for i:=0 to (FSpamNodesCount-1) do
     begin
       if ((link^.dwToNodeNumber=spamNode^.dwNodeNumber) and spamTop) then
          begin
            if (spamNode^.ResultLinkNumber[link^.dwToLinkNumber,0]=0) then
             begin
              spamNode^.TopLinksCount:=spamNode^.TopLinksCount+1;
              Result:=spamNode^.LeftLinksCount+spamNode^.TopLinksCount+spamNode^.BottomLinksCount;
              spamNode^.ResultLinkNumber[link^.dwToLinkNumber,0]:=Result;
              Exit;
             end
            else
             begin
              Result:=spamNode^.ResultLinkNumber[link^.dwToLinkNumber,0];
              Exit;
             end;
          end;
       if ((link^.dwToNodeNumber=spamNode^.dwNodeNumber) and spamBottom) then
          begin
            if (spamNode^.ResultLinkNumber[link^.dwToLinkNumber,1]=0) then
             begin
              spamNode^.BottomLinksCount:=spamNode^.BottomLinksCount+1;
              Result:=spamNode^.LeftLinksCount+spamNode^.TopLinksCount+spamNode^.BottomLinksCount;
              spamNode^.ResultLinkNumber[link^.dwToLinkNumber,1]:=Result;
              Exit;
             end
            else
             begin
              Result:=spamNode^.ResultLinkNumber[link^.dwToLinkNumber,1];
              Exit;
             end;
          end;
       inc(spamNode);
     end;
  end;


function TBPLSAGraph.GetLinkCaption(nodeNum:DWORD):ShortString;
Var i:Integer;
  tmpNode:PBPInProcessNode;
 begin
   Result:='';
   if (FIPNode=nil) then Exit;
   tmpNode:=FIPNode;
   for i:=0 to (FHeader.dwIPEntries-1) do
    begin
      if (tmpNode^.dwNodeNumber=nodeNum) then
        begin
          case FTranslateNodesType of
           0: Result:=tmpNode^.ssCaption;
           1: Result:=tmpNode^.ssMech;
           2: Result:=tmpNode^.ssUpr;
          end;
          Exit;
        end;
      inc(tmpNode);
    end;
 end;


function  TBPLSAGraph.MyLinkExsistsEx(link,fl:PBPLink):Boolean;
Var i:Integer;
 begin
   Result:=False;
   if (link=nil) then Exit;
    for i:=0 to (FSearchGraph.LinksCount-1) do
      begin
        if  (link<>fl) then
        begin
        if ((DWORD(link^.dwToNodeNumber))<(DWORD(link^.dwFromNodeNumber))) or
           ((link^.dwToNodeNumber and BPGlobalMask)<>0) then
            begin
              Result:=True;
              Exit;
            end;
        if (((FSearchGraph.Links[i]^.dwToNodeNumber and BPGlobalRightNodeNumber)<>0) or
           ((FSearchGraph.Links[i]^.dwToNodeNumber and BPGlobalNodeInProcess)<>0)) then
        begin
         if (FSearchGraph.Links[i]^.dwFromNodeNumber=link^.dwFromNodeNumber) and
            (FSearchGraph.Links[i]^.dwToNodeNumber=link^.dwToNodeNumber) and
            (Pos('<',link^.ssFromCaption)=0) then
            begin
              Result:=True;
              Exit;
            end;
        end
        else
        begin
        if (FSearchGraph.Links[i]^.dwFromNodeNumber=link^.dwFromNodeNumber) and
           (FSearchGraph.Links[i]^.dwToNodeNumber=link^.dwToNodeNumber) and
           (Pos('<',link^.ssFromCaption)=0)  then
            begin
              Result:=True;
              Exit;
            end;
        end;
       end
      else
       begin
       Result:=True;
       Exit;
       end;
      end; { for }
 end;

function  TBPLSAGraph.MyGetOutputLinksArrayEx(node:PBPNode):TBPLSALinkArrayEx;
Var tmpL:PBPLink;
       i,j:Integer;
     hln:Boolean;
 begin
   Result.LinksCount:=0;
   if (FLinksCount=0) then Exit;
   tmpL:=FLinks;
   hln:=False;
    for i:=0 to (FLinksCount-1) do
     begin
       if (tmpL^.dwFromNodeNumber=node^.dwNodeNumber) and
          ((tmpL^.dwFlags and BP_RIGHT_LEFT)=BP_RIGHT_LEFT) and
          (not(FUseSpam)) then
        begin
            Result.Links[Result.LinksCount]:=tmpL;
            Result.LinksCount:=Result.LinksCount+1;
        end;
       if (tmpL^.dwFromNodeNumber=node^.dwNodeNumber) and
          (((tmpL^.dwFlags and BP_RIGHT_LEFT)=BP_RIGHT_LEFT) or
          ((tmpL^.dwFlags and BP_RIGHT_TOP)=BP_RIGHT_TOP) or
          ((tmpL^.dwFlags and BP_RIGHT_BOTTOM)=BP_RIGHT_BOTTOM)) and
          (FUseSpam) then
        begin
            Result.Links[Result.LinksCount]:=tmpL;
            Result.LinksCount:=Result.LinksCount+1;
        end;
       inc(tmpL);
     end;
 end;

function  TBPLSAGraph.MyNodePassedEx(node:PBPNode):Boolean;
Var i:Integer;
 begin
   Result:=False;
   for i:=0 to (FSearchGraph.NodesCount-1) do
    begin
     if (FSearchGraph.Nodes[i]=node) then
       begin
        Result:=True;
        Exit;
       end;
    end;
 end;


function TBPLSAGraph.GetNodeNumberEx(nodeNum:String):Integer;
Var s:String;
 begin
   Result:=-1;
   s:=NodeNum;
   if length(s)=0 then Exit;
   delete(s,1,1);
   while pos('.',s)>0 do
    begin
      delete(s,pos('.',s),pos('.',s));
    end;
   Result:=StrToIntDef(s,-1);
 end;

procedure TBPLSAGraph.AnalizeGraphEx(link,finalLink:PBPLink;oldNode:PBPNode;pLength:Integer;var Final:Boolean);
Var node:PBPNode;
    la:TBPLSALinkArrayEx;
    i:Integer;
    s:String;
    lif,lil:Integer;
 begin
   if (link=nil) then Exit;
   if MyLinkExsistsEx(link,finalLink) then Exit;
   FSearchGraph.Links[FSearchGraph.LinksCount]:=link;
   Inc(FSearchGraph.LinksCount);
   node:=GetNumberedNodeEx(link^.dwToNodeNumber);
   if (node=nil) then Exit;
   if MyNodePassedEx(node) then Exit;
   s:=Trim(node^.ssNodeNumber);
   lif:=GetNodeNumberEx(s);
   if oldNode<>nil then
    begin
     s:=Trim(oldNode^.ssNodeNumber);
     lil:=GetNodeNumberEx(s);
    end
    else
    lil:=-1;
    if ((lif-lil)=1) then Exit;
   if (node^.dwNodeNumber=finalLink^.dwToNodeNumber) and
      (pLength>1) then
    begin
     Final:=True;
     Exit;
    end;
   FSearchGraph.Nodes[FCheckGraph.NodesCount[FFillDiag]]:=node;
   Inc(FSearchGraph.NodesCount);
   la:=MyGetOutputLinksArrayEx(node);
   for i:=0 to (la.LinksCount-1) do
    begin
      AnalizeGraphEx(la.Links[i],finalLink,node,pLength+1,Final);
    end;
 end;



function   TBPLSAGraph.GetFirstInNodePointEx(nodeNum:DWORD):PBPLink;
Var tmp:PBPLink;
      i:Integer;
 begin
   Result:=nil;
   if (FLinks=nil) then Exit;
   tmp:=FLinks;
   for i:=0 to (FLinksCount-1) do
    begin
      if (tmp^.dwToNodeNumber=nodeNum) and
         (tmp^.dwFromNodeNumber<nodeNum) then
           begin
             Result:=tmp;
             Exit;
           end;
      inc(tmp);
    end;
 end;

function   TBPLSAGraph.HasLongMarch(l:PBPLink):Boolean;
Var tmp:PBPLink;
 begin
   Result:=False;
   FSearchGraph.NodesCount:=0;
   FSearchGraph.LinksCount:=0;
   tmp:=GetFirstInNodePointEx(l^.dwFromNodeNumber); { @@@ Replace }
   AnalizeGraphEx(tmp,l,nil,0,Result);
 end;


function   TBPLSAGraph.MyCheckForRemoveLink(l:PBPLink):Boolean;
Var tmpL:PBPLink;
 begin
   Result:=True;
   if (l=nil) then Exit;
   Result:=False;
   if ((l^.dwToNodeNumber and BPGlobalRightNodeNumber)<>0) then Exit;
   if ((l^.dwToNodeNumber and BPGlobalNodeInProcess)<>0) then Exit;
   if ((l^.dwFlags and BP_SHOW_FROMCAPTION)<>0) and
        (pos('<',l^.ssFromCaption)>0) then Exit;
   if HasLongMarch(l) then Result:=True;
 end;


procedure  TBPLSAGraph.SetCurDiag(Value:Integer);
Var oldPosX,oldPosY:Integer;
  begin
   FCurDiag:=Value;
   if (FCurDiag>=FFillDiag) then FCurDiag:=FFillDiag-1;
   if (FCurDiag<0) then FCurDiag:=0;
     FOwner.Visible:=False;
   if FOwner.HorzScrollBar.Visible and
     (FOwner.HorzScrollBar.Range>0) then
       oldPosX:=FOwner.HorzScrollBar.Position
   else
       oldPosX:=0;
   if FOwner.VertScrollBar.Visible and
     (FOwner.VertScrollBar.Range>0) then
       oldPosY:=FOwner.VertScrollBar.Position
   else
       oldPosY:=0;
   OpenLevel(FLevel,FCurDiag);
   FOwner.Invalidate;
   if FOwner.HorzScrollBar.Visible and
     (FOwner.HorzScrollBar.Range>0) then
       FOwner.HorzScrollBar.Position:=oldPosX;
   if FOwner.VertScrollBar.Visible and
     (FOwner.VertScrollBar.Range>0) then
       FOwner.VertScrollBar.Position:=oldPosY;
   FOwner.Visible:=True;
 end;

procedure   TBPLSAGraph.SetRemoveSomeLinks(Value:Boolean);
Var oldPosX,oldPosY:Integer;
  begin
     FRemoveSomeLinks:=Value;
     FOwner.Visible:=False;
   if FOwner.HorzScrollBar.Visible and
     (FOwner.HorzScrollBar.Range>0) then
       oldPosX:=FOwner.HorzScrollBar.Position
   else
       oldPosX:=0;
   if FOwner.VertScrollBar.Visible and
     (FOwner.VertScrollBar.Range>0) then
       oldPosY:=FOwner.VertScrollBar.Position
   else
       oldPosY:=0;
   OpenLevel(FLevel,FCurDiag);
   FOwner.Invalidate;
   if FOwner.HorzScrollBar.Visible and
     (FOwner.HorzScrollBar.Range>0) then
       FOwner.HorzScrollBar.Position:=oldPosX;
   if FOwner.VertScrollBar.Visible and
     (FOwner.VertScrollBar.Range>0) then
       FOwner.VertScrollBar.Position:=oldPosY;
   FOwner.Visible:=True;
 end;

procedure   TBPLSAGraph.SetGlobalShift(Value:Boolean);
Var oldPosX,oldPosY:Integer;
  begin
     FGlobalShift:=Value;
     FOwner.Visible:=False;
   if FOwner.HorzScrollBar.Visible and
     (FOwner.HorzScrollBar.Range>0) then
       oldPosX:=FOwner.HorzScrollBar.Position
   else
       oldPosX:=0;
   if FOwner.VertScrollBar.Visible and
     (FOwner.VertScrollBar.Range>0) then
       oldPosY:=FOwner.VertScrollBar.Position
   else
       oldPosY:=0;
   OpenLevel(FLevel,FCurDiag);
   FOwner.Invalidate;
   if FOwner.HorzScrollBar.Visible and
     (FOwner.HorzScrollBar.Range>0) then
       FOwner.HorzScrollBar.Position:=oldPosX;
   if FOwner.VertScrollBar.Visible and
     (FOwner.VertScrollBar.Range>0) then
       FOwner.VertScrollBar.Position:=oldPosY;
   FOwner.Visible:=True;
 end;

 procedure   TBPLSAGraph.SetGlobalShift2(Value:Boolean);
Var oldPosX,oldPosY:Integer;
  begin
     FGlobalShift2:=Value;
     FOwner.Visible:=False;
   if FOwner.HorzScrollBar.Visible and
     (FOwner.HorzScrollBar.Range>0) then
       oldPosX:=FOwner.HorzScrollBar.Position
   else
       oldPosX:=0;
   if FOwner.VertScrollBar.Visible and
     (FOwner.VertScrollBar.Range>0) then
       oldPosY:=FOwner.VertScrollBar.Position
   else
       oldPosY:=0;
   OpenLevel(FLevel,FCurDiag);
   FOwner.Invalidate;
   if FOwner.HorzScrollBar.Visible and
     (FOwner.HorzScrollBar.Range>0) then
       FOwner.HorzScrollBar.Position:=oldPosX;
   if FOwner.VertScrollBar.Visible and
     (FOwner.VertScrollBar.Range>0) then
       FOwner.VertScrollBar.Position:=oldPosY;
   FOwner.Visible:=True;
 end;

procedure   TBPLSAGraph.SetGlobalShift3(Value:Boolean);
Var oldPosX,oldPosY:Integer;
  begin
     FGlobalShift3:=Value;
     FOwner.Visible:=False;
   if FOwner.HorzScrollBar.Visible and
     (FOwner.HorzScrollBar.Range>0) then
       oldPosX:=FOwner.HorzScrollBar.Position
   else
       oldPosX:=0;
   if FOwner.VertScrollBar.Visible and
     (FOwner.VertScrollBar.Range>0) then
       oldPosY:=FOwner.VertScrollBar.Position
   else
       oldPosY:=0;
   OpenLevel(FLevel,FCurDiag);
   FOwner.Invalidate;
   if FOwner.HorzScrollBar.Visible and
     (FOwner.HorzScrollBar.Range>0) then
       FOwner.HorzScrollBar.Position:=oldPosX;
   if FOwner.VertScrollBar.Visible and
     (FOwner.VertScrollBar.Range>0) then
       FOwner.VertScrollBar.Position:=oldPosY;
   FOwner.Visible:=True;
 end;

procedure   TBPLSAGraph.SetGlobalShift4(Value:Boolean);
Var oldPosX,oldPosY:Integer;
  begin
     FGlobalShift4:=Value;
     FOwner.Visible:=False;
   if FOwner.HorzScrollBar.Visible and
     (FOwner.HorzScrollBar.Range>0) then
       oldPosX:=FOwner.HorzScrollBar.Position
   else
       oldPosX:=0;
   if FOwner.VertScrollBar.Visible and
     (FOwner.VertScrollBar.Range>0) then
       oldPosY:=FOwner.VertScrollBar.Position
   else
       oldPosY:=0;
   OpenLevel(FLevel,FCurDiag);
   FOwner.Invalidate;
   if FOwner.HorzScrollBar.Visible and
     (FOwner.HorzScrollBar.Range>0) then
       FOwner.HorzScrollBar.Position:=oldPosX;
   if FOwner.VertScrollBar.Visible and
     (FOwner.VertScrollBar.Range>0) then
       FOwner.VertScrollBar.Position:=oldPosY;
   FOwner.Visible:=True;
 end;


procedure  TBPLSAGraph.SetTranslateNodesType(Value:Integer);
Var oldPosX,oldPosY:Integer;
  begin
     FTranslateNodesType:=Value;
     FOwner.Visible:=False;
   if FOwner.HorzScrollBar.Visible and
     (FOwner.HorzScrollBar.Range>0) then
       oldPosX:=FOwner.HorzScrollBar.Position
   else
       oldPosX:=0;
   if FOwner.VertScrollBar.Visible and
     (FOwner.VertScrollBar.Range>0) then
       oldPosY:=FOwner.VertScrollBar.Position
   else
       oldPosY:=0;
   OpenLevel(FLevel,FCurDiag);
   FOwner.Invalidate;
   if FOwner.HorzScrollBar.Visible and
     (FOwner.HorzScrollBar.Range>0) then
       FOwner.HorzScrollBar.Position:=oldPosX;
   if FOwner.VertScrollBar.Visible and
     (FOwner.VertScrollBar.Range>0) then
       FOwner.VertScrollBar.Position:=oldPosY;
   FOwner.Visible:=True;
 end;

procedure   TBPLSAGraph.GetMaxNodesCount;
Var nodeP:PLSAGraphNode;
 begin
   FMaxNodesCOunt:=0;
   if FGNodesCount=0 then Exit;
   nodeP:=FGraphNodes;
   while (nodeP<>nil) do
    begin
      if (FMaxNodesCount<nodeP^.LevelID) then FMaxNodesCount:=nodeP^.LevelID;
      nodeP:=nodeP^.next;
    end;
 end;

procedure  TBPLSAGraph.DrawArrowY(x,y:Integer;Positive:Boolean);
Var d:Integer;
    k:Integer;
 begin
  {}
   d:=Round(MinLineEndPoint*0.57735);
   if (d=0) and (MinLineEndPoint=0) then Exit;
   if (d=0) then d:=1;
   for k:=0 to d do
    begin
     if Positive then
      begin
       FOwner.Canvas.MoveTo(x+k,y+MinLineEndPoint);
       FOwner.Canvas.LineTo(x,y);
       FOwner.Canvas.MoveTo(x-k,y+MinLineEndPoint);
       FOwner.Canvas.LineTo(x,y);
      end
     else
      begin
       FOwner.Canvas.MoveTo(x+k,y-MinLineEndPoint);
       FOwner.Canvas.LineTo(x,y);
       FOwner.Canvas.MoveTo(x-k,y-MinLineEndPoint);
       FOwner.Canvas.LineTo(x,y);
      end;
    end;
 end;


procedure  TBPLSAGraph.OptimizeLFS;
Var i,j,k:Integer;
    linkF,linkL,linkTmp:PBPLink;
    indexF,indexL:Integer;
    nodeF,nodeL:DWORD;
    nodeTF,nodeTL:DWORD;
    cnt:Integer;
 begin
  { Optimize Current Level Links for LFS }
   if FLinksCount=0 then Exit;
   cnt:=FLinksCount;
   for i:=0 to (cnt-1) do
    for j:=0 to (cnt-1) do
     begin
       if (i<>j) then
       begin
       linkF:=FLinks;
       linkL:=FLinks;
       inc(linkF,i);
       inc(linkL,j);
       indexF:=linkF^.dwFromLinkNumber;
       indexL:=linkL^.dwFromLinkNumber;
       nodeF:=linkF^.dwFromNodeNumber;
       nodeL:=linkL^.dwFromNodeNumber;
       nodeTF:=linkF^.dwToNodeNumber;
       nodeTL:=linkL^.dwToNodeNumber;
       if ((nodeF and BPGlobalMask)=0) and
          (nodeF=nodeL) and
          ((nodeTF and BPGlobalMask)=0) and
          ((nodeTL and BPGlobalMask)=0) then
           begin
             if ((nodeTF>nodeTL) and { Prjamaja svjaz }
                (indexF<indexL) and
                (nodeTF>nodeF) and
                (nodeTL>nodeF)) or
                ((nodeTF<nodeTL) and { Obr svjaz }
                 (indexF<indexL) and
                 (nodeTF<nodeF) and
                 (nodeTL>nodeF)) then
               begin
                 linkTmp:=FLinks;
                 for k:=0 to (cnt-1) do
                  begin
                    if (k<>i) and (k<>j) then
                      begin
                        if ((linkTmp^.dwFromNodeNumber=linkF^.dwFromNodeNumber) and
                           (linkTmp^.dwFromLinkNumber=linkF^.dwFromLinkNumber)) then
                             begin
                               linkTmp^.dwFromLinkNumber:=indexL;
                             end
                        else
                          if ((linkTmp^.dwFromNodeNumber=linkL^.dwFromNodeNumber) and
                           (linkTmp^.dwFromLinkNumber=linkL^.dwFromLinkNumber)) then
                             begin
                               linkTmp^.dwFromLinkNumber:=indexF;
                             end;
                      end;
                    inc(linkTMP);
                  end;
                 linkF^.dwFromLinkNumber:=indexL;
                 linkL^.dwFromLinkNumber:=indexF;
               end;

           end;
        end { i<>j }
     end; {for i,j }
   FModified:=True;
 end;

function   TBPLSAGraph.IsLevelValid:Boolean;
 begin
   Result:=False;
   if (GetFirstInPoint<>nil) then Result:=True;
 end;

procedure  TBPLSAGraph.UpdateLinksModel(X,Y:Integer;llabel:TBPLabel);
Var xc,yc:Integer;
    i,j:Integer;
    link:PLSAGraphLink;
 begin
   if FGLinksCount=0 then Exit;
   if llabel=nil then Exit;
   if FRatioWC=0 then Exit;
   if FRatioHC=0 then Exit;
  { Recalc X and Y coord to not scaled model }
   if FScaled or FPrinting then
    begin
     xc:=Round(X/FRatioWC);
     yc:=Round(Y/FRatioHC);
    end
   else
    begin
     xc:=x;
     yc:=y;
    end;
    link:=FGraphLinks;
  { Update links model}
    for i:=0 to (FGLinksCount-1) do
      begin
        if (link^.BPFromLabel<>nil) then
          if (link^.BPFromLabel=llabel) then
            begin
              link^.llLink^.FromLeft[2]:=xc;
              link^.llLink^.FromTop[2]:=yc;
              link^.llLink^.FromAcceptPosition[2]:=True;
              FModified:=True;
            end;
        if (link^.BPToLabel<>nil) then
          if (link^.BPToLabel=llabel) then
            begin
              link^.llLink^.ToLeft[2]:=xc;
              link^.llLink^.ToTop[2]:=yc;
              link^.llLink^.ToAcceptPosition[2]:=True;
              FModified:=True;
            end;
        link:=link^.next;
      end;
 end;

procedure  TBPLSAGraph.CorrectLinksModel(delta:TPoint;NodeNum:DWORD;AcceptRect:TRect);
Var p:PLSAGraphLink;
    i:Integer;
    cnt:Integer;
    x,y:Integer;
    x1,y1:Integer;
    dx,dy:Integer;
    flag:Boolean;
    f1:Boolean;
    ff,ft:Boolean;
 begin
   { Correct links coordinates }
   if (FGLinksCount=0) then Exit;
   cnt:=FGLinksCount-1;
   if FOwner.VertScrollBar.Visible then dy:=FOwner.VertScrollBar.Position else dy:=0;
   if FOwner.HorzScrollBar.Visible then dx:=FOwner.HorzScrollBar.Position else dx:=0;
   p:=FGraphLinks;
   for i:=0 to cnt do
     begin
       f1:=((p^.FromNodeNumber=NodeNum) or (p^.ToNodeNumber=NodeNum));
       ff:=(p^.FromNodeNumber=NodeNum);
       ft:=(p^.ToNodeNumber=NodeNum);
       if (f1) then
          begin { Any link to this node }
            flag:=False; { !!! }
            if (p^.BPFromLabel<>nil) then
              if (p^.BPFromLabel.AcceptPosition) then
                 begin
                   if (ff) then Flag:=True;

                   x:=p^.BPFromLabel.LeftDragPos+delta.x;
                   if ((x+p^.BPFromLabel.Width)>AcceptRect.Right) then
                      x:=AcceptRect.Right-p^.BPFromLabel.Width;
                   if (x<AcceptRect.Left) then x:=AcceptRect.Left;

                   x1:=p^.BPFromLabel.Left+delta.x;
                   if ((x1+dx+p^.BPFromLabel.Width)>AcceptRect.Right) then
                      x1:=AcceptRect.Right-dx-p^.BPFromLabel.Width;
                   if ((x1+dx)<AcceptRect.Left) then
                      x1:=AcceptRect.Left-dx;

                   y:=p^.BPFromLabel.TopDragPos+delta.y;
                   if ((y+p^.BPFromLabel.Height)>AcceptRect.Bottom) then
                      y:=AcceptRect.Bottom-p^.BPFromLabel.Height;
                   if (y<AcceptRect.Top) then y:=AcceptRect.Top;

                   y1:=p^.BPFromLabel.Top+delta.y;
                   if ((y1+dy+p^.BPFromLabel.Height)>AcceptRect.Bottom) then
                      y1:=AcceptRect.Bottom-dy-p^.BPFromLabel.Height;
                   if ((y1+dy)<AcceptRect.Top) then
                      y1:=AcceptRect.Top-dy;
                   if Flag then
                   begin
                   p^.BPFromLabel.LeftDragPos:=x;
                   p^.BPFromLabel.TopDragPos:=y;
                   p^.BPFromLabel.Left:=x1;
                   p^.BPFromLabel.Top:=y1;
                   p^.BPFromLabel.AcceptPosition:=True;
                   UpdateLinksModel(x1+dx,y1+dy,p^.BPFromLabel);
                   Flag:=False;
                   end;
                 end;
            Flag:=False;
            if (p^.BPToLabel<>nil) then
              if (p^.BPToLabel.AcceptPosition) then
                 begin
                   if (ft) then Flag:=True;
                   x:=p^.BPToLabel.LeftDragPos+delta.x;
                   if ((x+p^.BPToLabel.Width)>AcceptRect.Right) then
                      x:=AcceptRect.Right-p^.BPToLabel.Width;
                   if (x<AcceptRect.Left) then x:=AcceptRect.Left;

                   x1:=p^.BPToLabel.Left+delta.x;
                   if ((x1+dx+p^.BPToLabel.Width)>AcceptRect.Right) then
                      x1:=AcceptRect.Right-dx-p^.BPToLabel.Width;
                   if ((x1+dx)<AcceptRect.Left) then
                      x1:=AcceptRect.Left-dx;
                   y:=p^.BPToLabel.TopDragPos+delta.y;
                   if ((y+p^.BPToLabel.Height)>AcceptRect.Bottom) then
                      y:=AcceptRect.Bottom-p^.BPToLabel.Height;
                   if (y<AcceptRect.Top) then y:=AcceptRect.Top;

                   y1:=p^.BPToLabel.Top+delta.y;
                   if ((y1+dy+p^.BPToLabel.Height)>AcceptRect.Bottom) then
                      y1:=AcceptRect.Bottom-dy-p^.BPToLabel.Height;
                   if ((y1+dy)<AcceptRect.Top) then
                      y1:=AcceptRect.Top-dy;
                   if Flag then
                   begin
                   p^.BPToLabel.LeftDragPos:=x;
                   p^.BPToLabel.TopDragPos:=y;
                   p^.BPToLabel.Left:=x1;
                   p^.BPToLabel.Top:=y1;
                   p^.BPToLabel.AcceptPosition:=True;
                   UpdateLinksModel(x1+dx,y1+dy,p^.BPToLabel);
                   Flag:=False;
                   end;
                 end;
          end;
        p:=p^.next;
     end;
 end;


procedure TBPLSAGraph.UpdateNodesModel(X,Y:Integer;node:TBPLSAGraphNode);
Var xc,yc:Integer;
    nodePtr:PLSAGraphNode;
    i:Integer;
 begin
   if FGNodesCount=0 then Exit;
   if node=nil then Exit;
   if FRatioWC=0 then Exit;
   if FRatioHC=0 then Exit;
  { Recalc X and Y coord to not scaled model }
   if FScaled or FPrinting then
    begin
     xc:=Round(X/FRatioWC);
     yc:=Round(Y/FRatioHC);
    end
   else
    begin
     xc:=x;
     yc:=y;
    end;
  { Update nodes model }
   nodePtr:=FGraphNodes;
   for i:=0 to (FGNodesCount-1) do
     begin
       if  (node<>nil) and
           (nodePtr^.BPNode=node) then
         begin
           nodePtr^.llNode^.Left[2]:=xc;
           nodePtr^.llNode^.Top[2]:=yc;
           nodePtr^.llNode^.AcceptPosition[2]:=True;
           FModified:=True;
         end;
       nodePtr:=nodePtr^.next;
     end;
 end;


procedure TBPLSAGraph.MyNodeMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer); { Checked }
 begin
  if (Sender is TBPLSAGraphNode) and (Button=mbLeft) then
   (Sender as TBPLSAGraphNode).BeginDrag(False);
 end;

procedure TBPLSAGraph.MyLabelMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer); { Checked }
 begin
   if (Sender is TBPLabel) and (Button=mbLeft) then
        (Sender as TBPLabel).BeginDrag(True);
 end;


procedure TBPLSAGraph.SetNodesCaptionVisible(Value:Boolean);
 begin
   if (Value<>FNodesCaptionVisible) then
    begin
     FOwner.Visible:=False;
     FNodesCaptionVisible:=Value;
     OpenLevel(FLevel,FCurDiag);
     TraceRoute;
     FOwner.Invalidate;
     FOwner.Visible:=True;
    end;
 end;

procedure TBPLSAGraph.SetJunctionCaptionVisible(Value:Boolean);
 begin
   if (FJunctionCaptionVisible<>Value) then
    begin
      FOwner.Visible:=False;
      FJunctionCaptionVisible:=Value;
      OpenLevel(FLevel,FCurDiag);
      TraceRoute;
      FOwner.Invalidate;
      FOwner.Visible:=True;
    end;
 end;

function  TBPLSAGraph.IsNodeVisibleEx(node:PBPNode):Boolean;
Var i:Integer;
 begin
   Result:=False;
   for i:=0 to (FCheckGraph.NodesCount[FCurDiag]-1) do
     begin
       if (FCheckGraph.Nodes[i,FCurDiag]=node) then
         begin
           Result:=True;
           Exit;
         end;
     end;
 end;

function  TBPLSAGraph.IsLinkVisibleEx(link:PBPLink):Boolean;
Var i:Integer;
 begin
   Result:=False;
    for i:=0 to (FCheckGraph.LinksCount[FCurDiag]-1) do
      begin
        if (FCheckGraph.Links[i,FCurDiag]=link) then
          begin
            Result:=True;
            Exit;
          end;
      end;
 end;


function  TBPLSAGraph.LinkExsistsEx(link:PBPLink):Boolean;
Var i:Integer;
 begin
   Result:=False;
   if (link=nil) then Exit;
    for i:=0 to (FCheckGraph.LinksCount[FFillDiag]-1) do
      begin
{        if FCheckGraph.Links[i,FFillDiag]=link then
           begin
             Result:=True;
             Exit;
           end;}
        if (((FCheckGraph.Links[i,FFillDiag]^.dwToNodeNumber and BPGlobalRightNodeNumber)<>0) or
           ((FCheckGraph.Links[i,FFillDiag]^.dwToNodeNumber and BPGlobalNodeInProcess)<>0)) then
        begin
{         if (FCheckGraph.Links[i,FFillDiag]^.dwFromNodeNumber=link^.dwFromNodeNumber) and
            (FCheckGraph.Links[i,FFillDiag]^.dwToNodeNumber=link^.dwToNodeNumber) and
            (Pos('<',link^.ssFromCaption)=0) then
            begin
              Result:=True;
              Exit;
            end;
        end
        else
        begin
        if (FCheckGraph.Links[i,FFillDiag]^.dwFromNodeNumber=link^.dwFromNodeNumber) and
           (FCheckGraph.Links[i,FFillDiag]^.dwToNodeNumber=link^.dwToNodeNumber) and
           (Pos('<',link^.ssFromCaption)=0) then
            begin
              Result:=True;
              Exit;
            end;}
         if (FCheckGraph.Links[i,FFillDiag]=link) and
            (Pos('<',link^.ssFromCaption)=0) then
            begin
              Result:=True;
              Exit;
            end;
        end
        else
        begin
        if (FCheckGraph.Links[i,FFillDiag]=link) and
           (Pos('<',link^.ssFromCaption)=0) then
            begin
              Result:=True;
              Exit;
            end;
        end;
      end;
 end;

function  TBPLSAGraph.GetOutputLinksArrayEx(node:PBPNode):TBPLSALinkArrayEx;
Var tmpL:PBPLink;
       i,j:Integer;
     hln:Boolean;
 begin
   Result.LinksCount:=0;
   if (FLinksCount=0) then Exit;
   tmpL:=FLinks;
   hln:=False;
    for i:=0 to (FLinksCount-1) do
     begin
       if (tmpL^.dwFromNodeNumber=node^.dwNodeNumber) and
          ((tmpL^.dwFlags and BP_RIGHT_LEFT)=BP_RIGHT_LEFT) and
          (not(FUseSpam))  then
        begin
          if FRemoveSomeLinks then
           begin
             if not(MyCheckForRemoveLink(tmpL)) then
              begin
                Result.Links[Result.LinksCount]:=tmpL;
                Result.LinksCount:=Result.LinksCount+1;
                if ((tmpL^.dwToNodeNumber and BPGlobalMask)=0) then hln:=True;
              end;
           end
          else
           begin
            Result.Links[Result.LinksCount]:=tmpL;
            Result.LinksCount:=Result.LinksCount+1;
            if ((tmpL^.dwToNodeNumber and BPGlobalMask)=0) then hln:=True;
           end;
        end;
       if (tmpL^.dwFromNodeNumber=node^.dwNodeNumber) and
          (((tmpL^.dwFlags and BP_RIGHT_LEFT)=BP_RIGHT_LEFT) or
          ((tmpL^.dwFlags and BP_RIGHT_TOP)=BP_RIGHT_TOP) or
          ((tmpL^.dwFlags and BP_RIGHT_BOTTOM)=BP_RIGHT_BOTTOM)) and
          (FUseSpam)  then
        begin
          if FRemoveSomeLinks then
           begin
             if not(MyCheckForRemoveLink(tmpL)) then
              begin
                Result.Links[Result.LinksCount]:=tmpL;
                Result.LinksCount:=Result.LinksCount+1;
                if ((tmpL^.dwToNodeNumber and BPGlobalMask)=0) then hln:=True;
              end;
           end
          else
           begin
            Result.Links[Result.LinksCount]:=tmpL;
            Result.LinksCount:=Result.LinksCount+1;
            if ((tmpL^.dwToNodeNumber and BPGlobalMask)=0) then hln:=True;
           end;
        end;
       inc(tmpL);
     end;
 end;

function  TBPLSAGraph.NodePassedEx(node:PBPNode):Boolean;
Var i:Integer;
 begin
   Result:=False;
   for i:=0 to (FCheckGraph.NodesCount[FFillDiag]-1) do
    begin
     if (FCheckGraph.Nodes[i,FFillDiag]=node) then
       begin
        Result:=True;
        Exit;
       end;
    end;
 end;

function  TBPLSAGraph.GetNumberedNodeEx(NodeNumber:DWORD):PBPNode;
Var tmpN:PBPNode;
    i:Integer;
 begin
   Result:=nil;
   if FNodesCount=0 then Exit;
   tmpN:=FNodes;
   for i:=0 to (FNodesCount-1) do
    begin
      if (tmpN^.dwNodeNumber=NodeNumber) then
          begin
           Result:=tmpN;
           Exit;
          end;
      inc(tmpN);
    end;
 end;

function  TBPLSAGraph.GetInputLinkEx(node:PBPNode):PBPLink;
Var tmp:PBPLink;
      i:Integer;
 begin
   Result:=nil;
   if FLinksCount=0 then Exit;
   tmp:=FLinks;
   for i:=0 to (FLinksCount-1) do
    begin
      if (tmp^.dwToNodeNumber=node^.dwNodeNumber) and
         (((tmp^.dwFromNodeNumber and BPGlobalLeftNodeNumber)<>0) or
         (((tmp^.dwFromNodeNumber and BPGlobalNodeInProcess)<>0) and ((tmp^.dwFlags and BP_FROMTOMASK)=BP_RIGHT_LEFT))) then
          begin
            Result:=tmp;
            Exit;
          end;
      inc(tmp);
    end;
 end;

procedure TBPLSAGraph.AnalizeGraph(link:PBPLink;level:Integer;var flag:Boolean);
Var node:PBPNode;
    la:TBPLSALinkArrayEx;
    i:Integer;
    l:PBPLink;
 begin
   if (link=nil) then Exit;
   if LinkExsistsEx(link) then begin flag:=True; Exit; end;
   FCheckGraph.Links[FCheckGraph.LinksCount[FFillDiag],FFillDiag]:=link;
   Inc(FCheckGraph.LinksCount[FFillDiag]);
   node:=GetNumberedNodeEx(link^.dwToNodeNumber);
   if (node=nil) then Exit;
   if NodePassedEx(node) then begin flag:=True; Exit; end;
   FCheckGraph.Nodes[FCheckGraph.NodesCount[FFillDiag],FFillDiag]:=node;
   Inc(FCheckGraph.NodesCount[FFillDiag]);
   if (level<>0) then
   begin
   l:=GetInputLinkEx(node);
   if (l<>nil) then
    begin
      FCheckGraph.Links[FCheckGraph.LinksCount[FFillDiag],FFillDiag]:=l;
      inc(FCheckGraph.LinksCount[FFillDiag]);
    end;
   end;
   la:=GetOutputLinksArrayEx(node);
   for i:=0 to (la.LinksCount-1) do
    begin
      AnalizeGraph(la.Links[i],level+1,flag);
    end;
 end;

procedure TBPLSAGraph.CreateCheckGraph;
Var tmp:PBPLink;
      i:Integer;
    flag:Boolean;
    flagarray:array[0..30] of Boolean;
    flagarraycount:Integer;
 begin
   FFillDiag:=0;
   for i:=0 to 50 do
    begin
     FCheckGraph.NodesCount[i]:=0;
     FCheckGraph.LinksCount[i]:=0;
    end;
    if FNodesCount=0 then Exit;
   if FLinksCount=0 then Exit;
   flag:=False;
   flagarraycount:=0;
   tmp:=GetFirstInPointEx;
   AnalizeGraph(tmp,0,flag);
   flagarray[flagarraycount]:=flag;
   inc(flagarraycount);
{   inc(FFillDiag);}
   Application.ProcessMessages;
   while (tmp<>nil) do
    begin
      tmp:=GetNextInPointEx;
      flag:=False;
      AnalizeGraph(tmp,0,flag);
      flagarray[flagarraycount]:=flag;
      inc(flagarraycount);
{      Inc(FFillDiag);}
      Application.ProcessMessages;
    end;
  { Fill Diag }
   flagarray[flagarraycount]:=True;
   FFillDiag:=0;
   for i:=0 to 50 do
    begin
     FCheckGraph.NodesCount[i]:=0;
     FCheckGraph.LinksCount[i]:=0;
    end;
   if FNodesCount=0 then Exit;
   if FLinksCount=0 then Exit;
   flagarraycount:=0;
   flag:=False;
   tmp:=GetFirstInPointEx;
   AnalizeGraph(tmp,0,flag);
   inc(flagarraycount);
   if (not(flagarray[flagarraycount])) then inc(FFillDiag);
   Application.ProcessMessages;
   while (tmp<>nil) do
    begin
      tmp:=GetNextInPointEx;
      flag:=False;
      AnalizeGraph(tmp,0,flag);
      inc(flagarraycount);
      if (tmp<>nil) and (not(flagarray[flagarraycount])) then Inc(FFillDiag);
      Application.ProcessMessages;
    end;
 end;

function  TBPLSAGraph.CalcPagesCount:Integer;
var tmpTree:PBPTree;
 begin
   Result:=0;
   if FTree=nil then Exit;
   FOwner.Visible:=False;
   tmpTree:=FTree;
   while (tmpTree<>nil) do
     begin
       FChangeTabVisible:=False;
       OpenLevel(tmpTree^.dwLevel,0);
       FChangeTabVisible:=True;
       PresetupFrame(1,1);
       if (GetFirstInPoint<>nil) then inc(Result,FFillDiag);
       tmpTree:=tmpTree^.next;
     end;
   FOwner.Visible:=True;
 end;

function  TBPLSAGraph.GetLinkLabel(LinkLabel:String;Var caseOp:Boolean):String;
Var s:String;
    i1:Integer;
 begin
  Result:='';
  caseOp:=False;
  if (length(linkLabel)<3) and (not(FNodesCaptionVisible))
                           and (not(FJunctionCaptionVisible)) then Exit;
  s:=linkLabel;
  i1:=pos('<',s);
  if (i1=0) and (not(FNodesCaptionVisible)) then Exit;
  if (not(FJunctionCaptionVisible)) and (i1<>0) then
   begin
    caseOp:=True;
    delete(s,1,i1);
    i1:=pos('>',s);
    s:=copy(s,1,i1-1);
   end
  else
   if (i1<>0) and (FJunctionCaptionVisible) then caseOp:=True;
  Result:=s;
 end;

function  TBPLSAGraph.GetNodeLeftRight(NodeNumber:DWORD):TBPLSALeftRight;
Var i:Integer;
 begin
   Result.LeftRegion:=0;
   Result.RightRegion:=0;
   for i:=0 to (FNodeXArray.NodesCount-1) do
     begin
       if NodeNumber=FNodeXArray.NodeNumber[i] then
         begin
           Result.LeftRegion:=FNodeXArray.NodesXLeft[i];
           Result.RightRegion:=FNodeXArray.NodesXRight[i];
           Exit;
         end;
     end;
 end;


function  TBPLSAGraph.CalcOutputCount(node:PLSAGraphNode):Integer;
Var tmpL:PLSAGraphLink;
    mf:Boolean;
    i,j:Integer;
    gnode:PLSAGraphNode;
    fl,ha:Boolean;
    list:TStringList;
    s:String;
 begin
   Result:=0;
   if (FGLinksCount=0) then Exit;
   if (node=nil) then Exit;
   list:=TStringList.Create;
   list.Clear;
   tmpL:=FGraphLinks;
   for i:=0 to (FGLinksCount-1) do
    begin
       if (tmpL^.FromNodeNumber=node^.BPNode.NodeNumber) then
          begin
            mf:=IsMultipleFirst(i,False);
            if ((tmpL^.dwFlags and BP_SHOW_FROMCAPTION)<>0) and (tmpL^.IsCaseOp) then
             fl:=True
            else
             fl:=False;
            if (mf and fl) then
              begin
               ha:=False;
               for j:=0 to (list.Count-1) do
                 begin
                   s:=list.Strings[j];
                   if IsLinkIndexEqual(s,tmpL^.llLink^.ssFromCaption) then ha:=True;
                 end;
               if not(ha) then
                begin
                 Result:=Result+1;
                 list.Append(tmpL^.llLink^.ssFromCaption);
                end;
              end;
          end;
       tmpL:=tmpL^.next;
    end;
   list.Destroy;
 end;

procedure  TBPLSAGraph.DrawStartEnd(x,y,dx,dy:Integer;color:TColor;Start:Boolean;Fill:Boolean);
Var oldColor,oldColor1:TColor;
    r:TRect;
{    oldStyle:TBrushStyle;}
 begin
   oldColor:=FOwner.Canvas.Pen.Color;
   oldColor1:=FOwner.Canvas.Brush.Color;
{   oldStyle:=FOwner.Canvas.Brush.Style;}
   FOwner.Canvas.Pen.Color:=color;
   FOwner.Canvas.Brush.Color:=color;
{   FOwner.Canvas.Brush.Style:=bsCross;}
{   r.Left:=x-(dx div 2);
   r.Right:=x+(dx div 2);}
   if Start then
     begin
      with FOwner.Canvas do
       begin
       MoveTo(x-2*dx,y);
       LineTo(x+2*dx,y);
       MoveTo(x-2*dx,y-dy);
       LineTo(x+2*dx,y-dy);
       Arc(x-dx,y-2*dx-dy,x+dx,y-dy,x,y-dy,x,y-dy);
      { r.Top:=y-dy-dx-(dx div 2);
       r.Bottom:=y-dy-(dx div 2);}
       if Fill then {FillRect(r);}
         RoundRect(x-(dx div 2),y-dy-dx-(dx div 2),x+(dx div 2),y-dy-(dx div 2),dx div 4, dx div 4);
       end;
     end
    else
     begin
      with FOwner.Canvas do
       begin
       MoveTo(x-2*dx,y);
       LineTo(x+2*dx,y);
       MoveTo(x-2*dx,y+dy);
       LineTo(x+2*dx,y+dy);
       Arc(x-dx,y+2*dx+dy,x+dx,y+dy,x,y+dy,x,y+dy);
{       r.Bottom:=y+dy+dx+(dx div 2);
       r.Top:=y+dy+(dx div 2);}
       if Fill then{ FillRect(r);}
         RoundRect(x-(dx div 2),y+dy+(dx div 2),x+(dx div 2),y+dy+dx+(dx div 2),dx div 4, dx div 4)
       end;
     end;
   FOwner.Canvas.Pen.Color:=oldColor;
   FOwner.Canvas.Brush.Color:=oldColor1;
{   FOwner.Canvas.Brush.Style:=oldStyle;}
 end;


procedure TBPLSAGraph.FillLeftArray;
Var tmpNode:PLSAGraphNode;
          i:Integer;
          p:TBPLSALeftRight;
          lr:Integer;
        posx:Integer;
         ind:Integer;
 begin
  {}
   if (FGNodesCount=0) then Exit;
   FLeftArray.RegionCount:=0;
   tmpNode:=FGraphNodes;
   while (tmpNode<>nil) do
    begin
      p:=GetNodeLeftRight(tmpNode^.BPNode.NodeNumber);
      if FOwner.HorzScrollBar.Visible then posx:=FOwner.HorzScrollBar.ScrollPos else posx:=0;
      lr:=Round(p.LeftRegion*FRatioX)+FOwner.ClientRect.Left+FGlobalLeftSize-posx;
      ind:=IsLeftArray(lr);
      if ind=-1 then
        begin
         FLeftArray.Region[FLeftArray.RegionCount]:=lr;
         FLeftArray.Count[FLeftArray.RegionCount]:=0;
         inc(FLeftArray.RegionCount);
        end;
      tmpNode:=tmpNode^.next;
    end;
 end;

procedure TBPLSAGraph.FillRightArray;
Var tmpNode:PLSAGraphNode;
          i:Integer;
          p:TBPLSALeftRight;
          lr:Integer;
        posx:Integer;
         ind:Integer;
 begin
  {}
   if (FGNodesCount=0) then Exit;
   FRightArray.RegionCount:=0;
   tmpNode:=FGraphNodes;
   while (tmpNode<>nil) do
    begin
      p:=GetNodeLeftRight(tmpNode^.BPNode.NodeNumber);
      if FOwner.HorzScrollBar.Visible then posx:=FOwner.HorzScrollBar.ScrollPos else posx:=0;
      lr:=Round(p.RightRegion*FRatioX)+FOwner.ClientRect.Left+FGlobalLeftSize-posx;
      ind:=IsRightArray(lr);
      if ind=-1 then
        begin
         FRightArray.Region[FRightArray.RegionCount]:=lr;
         FRightArray.Count[FRightArray.RegionCount]:=0;
         inc(FRightArray.RegionCount);
        end;
      tmpNode:=tmpNode^.next;
    end;
 end;

function  TBPLSAGraph.IsLeftArray(value:Integer):Integer;
Var i:Integer;
 begin
   Result:=-1;
   for i:=0 to (FLeftArray.RegionCount-1) do
    begin
      if FLeftArray.Region[i]=value then Result:=i;
    end;
 end;

function  TBPLSAGraph.IsRightArray(value:Integer):Integer;
Var i:Integer;
 begin
   Result:=-1;
   for i:=0 to (FRightArray.RegionCount-1) do
    begin
      if FRightArray.Region[i]=value then Result:=i;
    end;
 end;



procedure   TBPLSAGraph.TraceLinks;  { Checked }
 Var    linkP:PLSAGraphLink;
        i:Integer;
        sx,sy:Integer;
        ex,ey:Integer;
        hw,hh:Integer;
        fc,tc:DWORD;
        fdc,tdc:DWORD;
        gnode:TBPLSAGraphNode;
        nodeP:PLSAGraphNode;
        tx,ty:Integer;
        nfcd,ntcd:DWORD;
        lineWidth:Integer;
        hhh:Integer;
        mm:TBPMultipleMask;
        mft,mff:Boolean;
        coffy,coffx:Integer;
        lrx,rrx:Integer;
        posx:Integer;
        centerx:Integer;
        lr:TBPLSALeftRight;
        fip:PLSAGraphLink;
        tmptmp:Integer;
        llc,lrc:Integer;
        tmpLLL:PLSAGraphLink;
        ccc:Integer;
  begin
    if (FGNodesCount=0) then Exit;
    if (FGLinksCount=0) then Exit;
    gnode:=GetGraphNode(0);
    hw:=gnode.Width div 2;
    hh:=gnode.Height div 2;
    coffy:=hh div 12; { hm ? }
    coffx:=hw div 12; { hm ? }
    if FOwner.HorzScrollBar.Visible then posx:=FOwner.HorzScrollBar.ScrollPos else posx:=0;
    if FPrinting and (not(FScaled2)) then posx:=0;
    fip:=GetFirstInPoint;
    if (fip<>nil) then
      centerx:=fip^.EndPoint.x
    else
      centerx:=(FDefWidth div 2)-posx;
{    posx:=FOwner.ClientRect.Left+FGlobalLeftSize+posx;}
    for i:=0 to (FGLinksCount-1) do
     begin
       linkP:=GetGraphLink(i);
       if linkP^.Visible then
       begin
       mm:=GetMultipleMask(i);
       mff:=IsMultipleFirst(i,True);
       mft:=IsMultipleFirst(i,False);
       sx:=linkP^.StartPoint.X;
       sy:=linkP^.StartPoint.Y;
       ex:=linkP^.EndPoint.X;
       ey:=linkP^.EndPoint.Y;
       fc:=linkP^.LinkFromCount;
       tc:=linkP^.LinkToCount;
       llc:=linkP^.LinkLeftCount;
       lrc:=linkP^.LinkRightCount;
       { Set First dot }
       linkP^.LineArrayX[0]:=sx;
       linkP^.LineArrayY[0]:=sy;
       linkP^.LinePointCount:=1;
       case (linkP^.dwFlags and BP_FROMTOMASK) of
        BP_RIGHT_LEFT: begin
                           if ((ey-sy)>=0) then
                             begin { Forward Link }
                                 if (((linkP^.ToNodeNumber and BPGlobalRightNodeNumber)<>0) or
                                    ((linkP^.FromNodeNumber and BPGlobalLeftNodeNumber)<>0)) or
                                    (((linkP^.ToNodeNumber and BPGlobalNodeInProcess)<>0) or
                                    ((linkP^.FromNodeNumber and BPGlobalNodeInProcess)<>0)) then
                                    begin { Global Link }
                                     if (((linkP^.ToNodeNumber and BPGlobalRightNodeNumber)<>0) or ((linkP^.ToNodeNumber and BPGlobalNodeInProcess)<>0)) and
                                        (GetGraphNumberedNode(linkP^.FromNodeNumber)^.BPNode.ShapeType=lsa_Junction) then
                                     begin
                                          nodeP:=GetGraphNumberedNode(linkP^.FromNodeNumber);
                                          fdc:=nodeP^.BPNode.RightLinksCount-fc;
                                          lr:=GetNodeLeftRight(linkP^.FromNodeNumber);
                                          lrx:=Round(lr.LeftRegion*FRatioX)+FOwner.ClientRect.Left+FGlobalLeftSize-posx;
                                          rrx:=Round(lr.RightRegion*FRatioX)+FOwner.ClientRect.Left+FGlobalLeftSize-posx;
                                          if (fc=1) then
                                           begin { Left Junction Global Link }
                                           linkP^.LineArrayX[1]:=lrx+llc*coffx;
                                           linkP^.LineArrayY[1]:=sy;
                                           linkP^.LineArrayX[2]:=lrx+llc*coffx; { Checked }
                                           linkP^.LineArrayY[2]:=ey;
                                           linkP^.LinePointCount:=3;
                                           LinkP^.EndPoint.x:=lrx+llc*coffx;
                                           end   { Left Junction Global Link }
                                          else
                                           if (fc>=nodeP^.BPNode.RightLinksCount) then
                                            begin { Right Junction Global Link }
                                             tmptmp:=nodeP^.BPNode.Width+nodeP^.BPNode.Left;
                                             linkP^.LineArrayX[1]:=rrx-lrc*coffx;
                                             linkP^.LineArrayY[1]:=sy;
                                             linkP^.LineArrayX[2]:=rrx-lrc*coffx; { Checked }
                                             linkP^.LineArrayY[2]:=ey;
                                             linkP^.LinePointCount:=3;
                                             LinkP^.EndPoint.x:=rrx-lrc*coffx; { Checked }
                                            end   { Right Junction Global Link }
                                          else
                                            begin { Bottom Junction Global Link }
                                             linkP^.LineArrayX[1]:=ex{rrx-fdc*coffx};
                                             linkP^.LineArrayY[1]:=ey;
{                                             linkP^.LineArrayX[2]:=rrx-fdc*coffx;
                                             linkP^.LineArrayY[2]:=ey;}
                                             linkP^.LinePointCount:=2;
                                           {  LinkP^.EndPoint.x:=rrx-fdc*coffx;} { Checked }
                                            end; { Bottom Junction Global Link }
                                     end
                                     else
                                     begin { Normal Global Link }
                                      if (((linkP^.ToNodeNumber and BPGlobalRightNodeNumber)<>0) or ((linkP^.ToNodeNumber and BPGlobalNodeInProcess)<>0)) and (not(mff)) then
                                       begin { Krivaja vetv' }
                                        linkP^.LineArrayX[1]:=sx;
                                        linkP^.LineArrayY[1]:=sy+coffy*(fc+1);
                                        linkP^.LineArrayX[2]:=ex;
                                        linkP^.LineArrayY[2]:=sy+coffy*(fc+1);
                                        linkP^.LineArrayX[3]:=ex;
                                        linkP^.LineArrayY[3]:=ey;
                                        linkP^.LinePointCount:=4;
                                       end   { Krivaja vetv' }
                                      else
                                       begin { Prjamaja vetv' }
                                        if (((linkP^.FromNodeNumber and BPGlobalLeftNodeNumber)<>0) or
                                           ((linkP^.FromNodeNumber and BPGlobalNodeInProcess)<>0)) and not(mft) then
                                         begin
                                          linkP^.LineArrayX[1]:=sx;
                                          linkP^.LineArrayY[1]:=sy+coffy*(fc+1);
                                          linkP^.LineArrayX[2]:=ex;
                                          linkP^.LineArrayY[2]:=sy+coffy*(fc+1);
                                          linkP^.LineArrayX[3]:=ex;
                                          linkP^.LineArrayY[3]:=ey;
                                          linkP^.LinePointCount:=4;
                                         end
                                        else
                                        begin
                                          tmpLLL:=GetFirstInPoint;
                                          ccc:=0;
                                          while tmpLLL<>nil do
                                           begin
                                             inc(ccc);
                                             tmpLLL:=GetNExtInPoint;
                                           end;
                                          linkP^.LineArrayX[1]:=sx;
                                          linkP^.LineArrayY[1]:=sy+coffy*(ccc+1);
                                          linkP^.LineArrayX[2]:=ex;
                                          linkP^.LineArrayY[2]:=sy+coffy*(ccc+1);
                                          linkP^.LineArrayX[3]:=ex;
                                          linkP^.LineArrayY[3]:=ey;
                                          linkP^.LinePointCount:=4;
                                        end;
                                       end; { Prjamaja vetv' }
                                     end; { Normal Global Link }
                                    end   { End Global Link }
                                  else
                                    begin { Local Link }
                                      if ((abs(ex-sx))<FMinLabelY) then
                                        begin { Direct Link }
                                          linkP^.EndPoint.x:=sx;   { Cheked }
                                          linkP^.EndPoint.y:=ey;
                                          linkP^.LineArrayX[1]:=sx;
                                          linkP^.LineArrayY[1]:=ey;
                                          linkP^.LinePointCount:=2;
                                        end   { End Direct Link }
                                      else
                                        begin { Normal Link }
                                          nodeP:=GetGraphNumberedNode(linkP^.FromNodeNumber);
                                          fdc:=nodeP^.BPNode.RightLinksCount-fc;
                                          lr:=GetNodeLeftRight(linkP^.FromNodeNumber);
                                          lrx:=Round(lr.LeftRegion{nodeP^.BPNode.LeftRegion}*FRatioX)+FOwner.ClientRect.Left+FGlobalLeftSize-posx;
                                          rrx:=Round(lr.RightRegion{nodeP^.BPNode.RightRegion}*FRatioX)+FOwner.ClientRect.Left+FGlobalLeftSize-posx;
                                          case (nodeP^.BPNode.ShapeType) of
                                               lsa_Node:  begin
                                                            linkP^.LineArrayX[1]:=sx;
                                                            linkP^.LineArrayY[1]:=ey-tc*coffy-FMinLineStep;
                                                            linkP^.LineArrayX[2]:=ex;
                                                            linkP^.LineArrayY[2]:=ey-tc*coffy-FMinLineStep;
                                                            linkP^.LineArrayX[3]:=ex;
                                                            linkP^.LineArrayY[3]:=ey;
                                                            linkP^.LinePointCount:=4;
                                                          end;
                                            lsa_Junction: begin
                                                            if (fc=1) then
                                                              begin { Junction fc=Left }
                                                               if (sx<=ex) then
                                                               begin { Junction fc=Left sx<=ex }
                                                               linkP^.LineArrayX[1]:=lrx+llc*coffx;
                                                               linkP^.LineArrayY[1]:=sy;
                                                               linkP^.LineArrayX[2]:=lrx+llc*coffx;
                                                               linkP^.LineArrayY[2]:=ey-FMinLineStep-tc*coffy;
                                                               linkP^.LineArrayX[3]:=ex;
                                                               linkP^.LineArrayY[3]:=ey-FMinLineStep-tc*coffy;
                                                               linkP^.LineArrayX[4]:=ex;
                                                               linkP^.LineArrayY[4]:=ey;
                                                               linkP^.LinePointCount:=5;
                                                               end  { Junction fc=Left sx<=ex }
                                                              else
                                                               begin { Junction fc=Left sx>ex }
                                                               linkP^.LineArrayX[1]:=ex;
                                                               linkP^.LineArrayY[1]:=sy;
                                                               linkP^.LineArrayX[2]:=ex;
                                                               linkP^.LineArrayY[2]:=ey;
                                                               linkP^.LinePointCount:=3;
                                                               end;  { Junction fc=Left sx>ex }
                                                              end { Junction fc=Left }
                                                            else
                                                            if (fc>=nodeP^.BPNode.RightLinksCount) then
                                                              begin { Junction fc=Right}
                                                               if ((ex-sx)>=0) then
                                                                begin { Junction fc=Right ex>sx }
                                                                  linkP^.LineArrayX[1]:=ex;
                                                                  linkP^.LineArrayY[1]:=sy;
                                                                  linkP^.LineArrayX[2]:=ex;
                                                                  linkP^.LineArrayY[2]:=ey;
                                                                  linkP^.LinePointCount:=3;
                                                                end  { Junction fc=Right ex>sx }
                                                               else
                                                                begin { Junction fc=Right ex<sx }
                                                                  linkP^.LineArrayX[1]:=rrx{-FMinLineStep}-lrc*coffx;
                                                                  linkP^.LineArrayY[1]:=sy;
                                                                  linkP^.LineArrayX[2]:=rrx{-FMinLineStep}-lrc*coffx;
                                                                  linkP^.LineArrayY[2]:=ey-tc*coffy-FMinLineStep;
                                                                  linkP^.LineArrayX[3]:=ex;
                                                                  linkP^.LineArrayY[3]:=ey-tc*coffy-FMinLineStep;
                                                                  linkP^.LineArrayX[4]:=ex;
                                                                  linkP^.LineArrayY[4]:=ey;
                                                                  linkP^.LinePointCount:=5;
                                                                end;  { Junction fc=Right ex<sx }
                                                              end { Junction fc=Right}
                                                            else
                                                            begin { Junction fc=Bottom }
                                                             { In Main Case }
                                                             linkP^.LineArrayX[1]:=sx;
                                                             linkP^.LineArrayY[1]:=ey-tc*coffy-FMinLineStep;
                                                             linkP^.LineArrayX[2]:=ex;
                                                             linkP^.LineArrayY[2]:=ey-tc*coffy-FMinLineStep;
                                                             linkP^.LineArrayX[3]:=ex;
                                                             linkP^.LineArrayY[3]:=ey;
                                                             linkP^.LinePointCount:=4;
                                                            end;  { Junction fc=Bottom }
                                                          end;
                                          end; { end case nodeP^.BPNode.ShapeType }
                                        end;  { End Normal Link }
                                    end;  { End Local Link }
                             end { End Forward Link }
                            else
                             begin { Backward Link Only Local }
                                nodeP:=GetGraphNumberedNode(linkP^.FromNodeNumber);
                                fdc:=nodeP^.BPNode.RightLinksCount-fc;
                                lr:=GetNodeLeftRight(linkP^.FromNodeNumber);
                                lrx:=Round(lr.LeftRegion{nodeP^.BPNode.LeftRegion}*FRatioX)+FOwner.ClientRect.Left+FGlobalLeftSize-posx;
                                rrx:=Round(lr.RightRegion{nodeP^.BPNode.RightRegion}*FRatioX)+FOwner.ClientRect.Left+FGlobalLeftSize-posx;
                                case (nodeP^.BPNode.ShapeType) of
                                   lsa_Node:  begin
                                                if (nodeP^.BPNode.Left<centerx) then
                                                  begin { CenterX Left }
                                                   linkP^.LineArrayX[1]:=sx;
                                                   linkP^.LineArrayY[1]:=sy+fc*coffy+FMinLineStep;
                                                   linkP^.LineArrayX[2]:=lrx{-FMinLineStep}+llc*coffx;
                                                   linkP^.LineArrayY[2]:=sy+fc*coffy+FMinLineStep;
                                                   linkP^.LineArrayX[3]:=lrx{-FMinLineStep}+llc*coffx;
                                                   linkP^.LineArrayY[3]:=ey-tc*coffy-FMinLineStep;
                                                   linkP^.LineArrayX[4]:=ex;
                                                   linkP^.LineArrayY[4]:=ey-tc*coffy-FMinLineStep;
                                                   linkP^.LineArrayX[5]:=ex;
                                                   linkP^.LineArrayY[5]:=ey;
                                                   linkP^.LinePointCount:=6;
                                                  end { CenterX Left }
                                                 else
                                                  begin { CenterX Right}
                                                   linkP^.LineArrayX[1]:=sx;
                                                   linkP^.LineArrayY[1]:=sy+fc*coffy+FMinLineStep;
                                                   linkP^.LineArrayX[2]:=rrx{-FMinLineStep}-lrc*coffx;
                                                   linkP^.LineArrayY[2]:=sy+fc*coffy+FMinLineStep;
                                                   linkP^.LineArrayX[3]:=rrx{-FMinLineStep}-lrc*coffx;
                                                   linkP^.LineArrayY[3]:=ey-tc*coffy-FMinLineStep;
                                                   linkP^.LineArrayX[4]:=ex;
                                                   linkP^.LineArrayY[4]:=ey-tc*coffy-FMinLineStep;
                                                   linkP^.LineArrayX[5]:=ex;
                                                   linkP^.LineArrayY[5]:=ey;
                                                  linkP^.LinePointCount:=6;
                                                 end; { CenterX Right}
                                              end;
                                lsa_Junction: begin
                                                if (fc=1) then
                                                 begin { Left Region }
                                                  linkP^.LineArrayX[1]:=lrx{+FMinLineStep}+llc*coffx;
                                                  linkP^.LineArrayY[1]:=sy;
                                                  linkP^.LineArrayX[2]:=lrx{+FMinLineStep}+llc*coffx;
                                                  linkP^.LineArrayY[2]:=ey-tc*coffy-FMinLineStep;
                                                  linkP^.LineArrayX[3]:=ex;
                                                  linkP^.LineArrayY[3]:=ey-tc*coffy-FMinLineStep;
                                                  linkP^.LineArrayX[4]:=ex;
                                                  linkP^.LineArrayY[4]:=ey;
                                                  linkP^.LinePointCount:=5;
                                                 end
                                                else
                                                if (fc>=nodeP^.BPNode.RightLinksCount) then
                                                 begin
                                                  linkP^.LineArrayX[1]:=rrx{-FMinLineStep}-lrc*coffx;
                                                  linkP^.LineArrayY[1]:=sy;
                                                  linkP^.LineArrayX[2]:=rrx{-FMinLineStep}-lrc*coffx;
                                                  linkP^.LineArrayY[2]:=ey-tc*coffy-FMinLineStep;
                                                  linkP^.LineArrayX[3]:=ex;
                                                  linkP^.LineArrayY[3]:=ey-tc*coffy-FMinLineStep;
                                                  linkP^.LineArrayX[4]:=ex;
                                                  linkP^.LineArrayY[4]:=ey;
                                                  linkP^.LinePointCount:=5;
                                                 end
                                                else
                                                begin
                                                 { In Main Case }
                                                 linkP^.LineArrayX[1]:=sx;
                                                 linkP^.LineArrayY[1]:=sy+fc*coffy+FMinLineStep;
                                                 linkP^.LineArrayX[2]:=rrx{-FMinLineStep}-lrc*coffx;
                                                 linkP^.LineArrayY[2]:=sy+fc*coffy+FMinLineStep;
                                                 linkP^.LineArrayX[3]:=rrx{-FMinLineStep}-lrc*coffx;
                                                 linkP^.LineArrayY[3]:=ey-tc*coffy-FMinLineStep;
                                                 linkP^.LineArrayX[4]:=ex;
                                                 linkP^.LineArrayY[4]:=ey-tc*coffy-FMinLineStep;
                                                 linkP^.LineArrayX[5]:=ex;
                                                 linkP^.LineArrayY[5]:=ey;
                                                 linkP^.LinePointCount:=6;
                                                end;
                                               end;
                                end; { end case nodeP^.BPNode.ShapeType }
                             end;  { End Backward Link }
                       end;
        else  begin
               { Main error link - not traced }
               linkP^.LineArrayX[1]:=ex;
               linkP^.LineArrayY[1]:=ey;
               linkP^.LinePointCount:=2;
              end;
       end;
      end { Visible link }
     else
      begin
        linkP^.LineArrayX[0]:=linkP^.StartPoint.x;
        linkP^.LineArrayY[0]:=linkP^.StartPoint.y;
        linkP^.LineArrayX[1]:=linkP^.EndPoint.x;
        linkP^.LineArrayY[1]:=linkP^.EndPoint.y;
        linkP^.LinePointCount:=2;
      end;
     end; { for links }
  end;

 procedure  TBPLSAGraph.DrawLinks; { Checked }
  Var linkP:PLSAGraphLink;
         i,j:Integer;
         fx,fy,lx,ly:Integer;
         dx,dy,dx1,dy1,tx,ty:Integer;
         oldColor,cl:TColor;
         k:Integer;
         mls:Integer;
         linkFromType,linkToType:TLinkType;
         lineWidth:Integer;
         s:Integer;
         ops,ps:TPenStyle;
         gnode:PLSAGraphNode;
         NewMinArcRadius:Integer;
         NDelta,nd1,nd2:Integer;
         ox,oy,nx,ny:Integer;
  begin
   if (FGLinksCount=0) then Exit;
   oldColor:=FOwner.Canvas.Pen.Color;
   ops:=FOwner.Canvas.Pen.Style;
   mls:=MinLineStep div 2;
    for i:=0 to (FGLinksCount-1) do
     begin
       linkP:=GetGraphLink(i);
       if linkP^.Visible then
       begin
       cl:=LinkP^.Color;
       FOwner.Canvas.Pen.Color:=cl;
       ps:=LinkP^.PenStyle;
       FOwner.Canvas.Pen.Style:=ps;
       linkFromType:=GetLinkFrom(linkP);
       linkToType:=GetLinkTo(linkP);
       case (LinkToType) of
       lt_Left: begin
                  DrawArrowY(linkP^.EndPoint.x,linkP^.EndPoint.y,False);
               end;
       end;
       FOwner.Canvas.Pen.Color:=cl;
       FOwner.Canvas.Pen.Style:=ps;
       case (LinkFromType) of
        lt_Right: begin {lt_Right  }
                   gnode:=GetGraphNumberedNode(linkP^.FromNodeNumber);
                   if (gnode=nil) or (gnode^.BPNode.ShapeType=lsa_Node) then
                   begin { lsa_Node }

                   if ((linkP^.dwFlags and BP_SHOW_FROMCAPTION)<>0) and
                      (linkP^.BPFromLabel<>nil) then
                   begin
                    if FDiscardDrags or (not(linkP^.BPFromLabel.AcceptPosition)) then
                      begin
                       linkP^.BPFromLabel.Left:=linkP^.StartPoint.x+MinLabelX;
                       linkP^.BPFromLabel.Top:=linkP^.StartPoint.y+MinLabelY1*(linkP^.LinkFromCount-1)+MinLabelY;
                       linkP^.BPFromLabel.AcceptPosition:=False;
                       DrawSS(linkP^.StartPoint.x+1,linkP^.StartPoint.y+MinLabelY+MinLabelY1*(linkP^.LinkFromCount-1)+(linkP^.BPFromLabel.Height div 2),
                          linkP^.StartPoint.x+MinLabelX-1,linkP^.StartPoint.y+MinLabelY+MinLabelY1*(linkP^.LinkFromCount-1)+(linkP^.BPFromLabel.Height div 2),cl);
                      end
                     else
                      DrawSS(linkP^.StartPoint.x+1,
                             linkP^.StartPoint.y+MinLabelY+MinLabelY1*(linkP^.LinkFromCount-1)+(linkP^.BPFromLabel.Height div 2),
                          linkP^.BPFromLabel.Left-1,
                          linkP^.BPFromLabel.Top+(linkP^.BPFromLabel.Height div 2),
                          cl);
                   end;
                   end { lsa_Node or globalNode }
                  else
                   begin { lsa_Junction }
                     if (linkP^.LinkFromCount=1) then
                      begin { Left Junction }

                   if ((linkP^.dwFlags and BP_SHOW_FROMCAPTION)<>0) and
                      (linkP^.BPFromLabel<>nil) then
                   begin
                    if FDiscardDrags or (not(linkP^.BPFromLabel.AcceptPosition)) then
                      begin
                       linkP^.BPFromLabel.Left:=linkP^.StartPoint.x-4-MinLabelX-linkP^.BPFromLabel.Width;
                       linkP^.BPFromLabel.Top:=linkP^.StartPoint.y-MinLabelY-linkP^.BPFromLabel.Height;
                       linkP^.BPFromLabel.AcceptPosition:=False;
                       DrawSS(linkP^.StartPoint.x-5,linkP^.StartPoint.y-2,
                          linkP^.StartPoint.x-4-MinLabelX+1,linkP^.StartPoint.y-MinLabelY-((linkP^.BPFromLabel.Height) div 2),cl);
                      end
                     else
                       DrawSS(linkP^.StartPoint.x-5,
                              linkP^.StartPoint.y-2,
                          linkP^.BPFromLabel.Left+linkP^.BPFromLabel.Width+3,
                          linkP^.BPFromLabel.Top+((linkP^.BPFromLabel.Height) div 2),
                          cl);
                    end;


                      end   { Left Junction }
                     else
                     if (linkP^.LinkFromCount>=gnode^.BPNode.RightLinksCount) then
                      begin { Right Junction }

                        if ((linkP^.dwFlags and BP_SHOW_FROMCAPTION)<>0) and
                        (linkP^.BPFromLabel<>nil) then
                        begin
                          if FDiscardDrags or (not(linkP^.BPFromLabel.AcceptPosition)) then
                           begin
                            linkP^.BPFromLabel.Left:=linkP^.StartPoint.x+MinLabelX;
                            linkP^.BPFromLabel.Top:=linkP^.StartPoint.y-MinLabelY-linkP^.BPFromLabel.Height;
                            linkP^.BPFromLabel.AcceptPosition:=False;
                            DrawSS(linkP^.StartPoint.x+2,linkP^.StartPoint.y-1,linkP^.StartPoint.x+MinLabelX-1,linkP^.StartPoint.y-(linkP^.BPFromLabel.Height div 2)-MinLabelY,cl);
                           end
                         else
                           DrawSS(linkP^.StartPoint.x+2,
                              linkP^.StartPoint.y-1,
                              linkP^.BPFromLabel.Left-1,
                              linkP^.BPFromLabel.Top+(linkP^.BPFromLabel.Height div 2),
                              cl);
                       end;

                      end   { Right Junction }
                     else
                      begin { Normal Junction }

                       if ((linkP^.dwFlags and BP_SHOW_FROMCAPTION)<>0) and
                      (linkP^.BPFromLabel<>nil) then
                   begin
                    if FDiscardDrags or (not(linkP^.BPFromLabel.AcceptPosition)) then
                      begin
                       linkP^.BPFromLabel.Left:=linkP^.StartPoint.x+MinLabelX;
                       linkP^.BPFromLabel.Top:=linkP^.StartPoint.y+MinLabelY1*(linkP^.LinkFromCount-2)+MinLabelY;
                       linkP^.BPFromLabel.AcceptPosition:=False;
                       DrawSS(linkP^.StartPoint.x+1,linkP^.StartPoint.y+MinLabelY+MinLabelY1*(linkP^.LinkFromCount-2)+(linkP^.BPFromLabel.Height div 2),
                          linkP^.StartPoint.x+MinLabelX-1,linkP^.StartPoint.y+MinLabelY+MinLabelY1*(linkP^.LinkFromCount-2)+(linkP^.BPFromLabel.Height div 2),cl);
                      end
                     else
                      DrawSS(linkP^.StartPoint.x+1,
                             linkP^.StartPoint.y+MinLabelY+MinLabelY1*(linkP^.LinkFromCount-2)+(linkP^.BPFromLabel.Height div 2),
                          linkP^.BPFromLabel.Left-1,
                          linkP^.BPFromLabel.Top+(linkP^.BPFromLabel.Height div 2),
                          cl);
                   end;

                      end;  { Normal Junction }
                   end; { lsa_Junction }
                  end; { lt_Right }

        end; { end Case LinkFromType }
       case (LinkToType) of
        lt_Left:   begin
                   if ((linkP^.dwFlags and BP_SHOW_TOCAPTION)<>0) and
                    (linkP^.BPToLabel<>nil) then
                   begin
                    if FDiscardDrags or (not(linkP^.BPToLabel.AcceptPosition)) then
                      begin
                       linkP^.BPToLabel.Left:=linkP^.EndPoint.x+MinLabelX;
                       linkP^.BPToLabel.Top:=linkP^.EndPoint.y-MinLabelY-MinLabelY1*(linkP^.LinkToCount-1)-linkP^.BPToLabel.Height;
                       linkP^.BPToLabel.AcceptPosition:=False;
                       DrawSS(linkP^.EndPoint.x+1,linkP^.EndPoint.y-MinLabelY-MinLabelY1*(linkP^.LinkToCount-1)-(linkP^.BPToLabel.Height div 2),
                          linkP^.EndPoint.x+MinLabelX-1,linkP^.EndPoint.y-MinLabelY-MinLabelY1*(linkP^.LinkToCount-1)-(linkP^.BPToLabel.Height div 2),cl);
                      end
                     else
                       DrawSS(linkP^.EndPoint.x+1,
                           linkP^.EndPoint.y-MinLabelY-MinLabelY1*(linkP^.LinkToCount-1)-(linkP^.BPToLabel.Height div 2),
                          linkP^.BPToLabel.Left-1,
                          linkP^.BPToLabel.Top+(linkP^.BPToLabel.Height div 2),cl);
                   end;
                  end;
        end;
        FOwner.Canvas.Pen.Color:=cl;
        FOwner.Canvas.Pen.Style:=ps;
        for j:=0 to (linkP^.LinePointCount-1) do
         begin
          tx:=linkP^.LineArrayX[j];
          ty:=linkP^.LineArrayY[j];
          NewMinArcRadius:=MinArcRadius;
          if j=0 then FOwner.Canvas.MoveTo(tx,ty);
          if (j=(linkP^.LinePointCount-1)) then FOwner.Canvas.LineTo(tx,ty);
          if (j<>0) and (j<>(linkP^.LinePointCount-1)) then
           begin
            ox:=linkP^.LineArrayX[j-1];
            oy:=linkP^.LineArrayY[j-1];
            nx:=linkP^.LineArrayX[j+1];
            ny:=linkP^.LineArrayY[j+1];
            if nx=tx then
              nd1:=ABS(ny-ty)
            else
              nd1:=ABS(nx-tx);
            if ox=tx then
              nd2:=ABS(ty-oy)
            else
              nd2:=ABS(tx-ox);
            if nd1<nd2 then nDelta:=nd1 else nDelta:=nd2;
            if (NewMinArcRadius>(nDelta div 2)) then NewMinArcRadius:=nDelta div 2;
            dx:=SignedVector(linkP^.LineArrayX[j+1]-tx,NewMinArcRadius);
            dy:=SignedVector(linkP^.LineArrayY[j+1]-ty,NewMinArcRadius);
            dx1:=SignedVector(linkP^.LineArrayX[j-1]-tx,NewMinArcRadius);
            dy1:=SignedVector(linkP^.LineArrayY[j-1]-ty,NewMinArcRadius);
            if (dx*dy1-dx1*dy)>0 then
             begin
            fx:=tx+dx;
            fy:=ty+dy;
            lx:=tx+dx1;
            ly:=ty+dy1;
             end
            else
             begin
            fx:=tx+dx1;
            fy:=ty+dy1;
            lx:=tx+dx;
            ly:=ty+dy;
             end;
            FOwner.Canvas.Arc(tx+2*dx,ty+2*dy,tx+2*dx1,ty+2*dy1,fx,fy,lx,ly);
             if (dx*dy1-dx1*dy)<0 then
              begin
                 FOwner.Canvas.LineTo(fx,fy);
                 FOwner.Canvas.MoveTo(lx,ly);
              end
              else
              begin
                 FOwner.Canvas.LineTo(lx,ly);
                 FOwner.Canvas.MoveTo(fx,fy);
              end;
           end;
         end;
        if ((linkP^.FromNodeNumber and BPGlobalLeftNodeNumber)<>0) then
             DrawStartEnd(linkP^.StartPoint.x,linkP^.StartPoint.y,MinLabelX,MinLabelY,cl,True,False)
        else
         if ((linkP^.FromNodeNumber and BPGlobalNodeInProcess)<>0) then
          DrawStartEnd(linkP^.StartPoint.x,linkP^.StartPoint.y,MinLabelX,MinLabelY,cl,True,True)
        else
         if ((linkP^.ToNodeNumber and BPGlobalRightNodeNumber)<>0) then
           DrawStartEnd(linkP^.EndPoint.x,linkP^.EndPoint.y,MinLabelX,MinLabelY,cl,False,False)
         else
         if ((linkP^.ToNodeNumber and BPGlobalNodeInProcess)<>0) then
          DrawStartEnd(linkP^.EndPoint.x,linkP^.EndPoint.y,MinLabelX,MinLabelY,cl,False,True);
     end; { Visible link }
    end; { For }

    FOwner.Canvas.Pen.Color:=oldColor;
    FOwner.Canvas.Pen.Style:=ops;
  end;


procedure  TBPLSAGraph.TraceLocalStartEndPoints; { Checked }
 Var linkP:PLSAGraphLink;
     gnode:PLSAGraphNode;
        i:Integer;
       w,h:Integer;
       w1,h1:Integer;
       posx,posy:Integer;
       linkFromType,linkToType:TLinkType;
       lc:Integer;
       mm:TBPMultipleMask;
       mff,mft:Boolean;
  begin
   { SetUp Start & End points of Links }
   if (FGLinksCount=0) then Exit;
   if (FGNodesCount=0) then Exit;
   if FOwner.HorzScrollBar.Visible then
     posx:=FOwner.HorzScrollBar.ScrollPos
   else
     posx:=0;
   if FOwner.VertScrollBar.Visible then
     posy:=FOwner.VertScrollBar.ScrollPos
   else
     posy:=0;
   if FPrinting then
    begin
     if not(FScaled2) then
      begin
       posx:=0;
       posy:=0;
      end;
    end;
   for i:=0 to (FGLinksCount-1) do
    begin
      linkP:=GetGraphLink(i);
      if linkP^.Visible then
      begin
      mm:=GetMultipleMask(i);
      mft:=IsMultipleFirst(i,False);
      mff:=IsMultipleFirst(i,True);
      linkFromType:=GetLinkFrom(linkP);
      linkToType:=GetLinkTo(linkP);
      gnode:= GetGraphNumberedNode(linkP^.FromNodeNumber);
      { begin StartPoint }
      if (gnode<>nil) then
       begin
         { local node }
         if (mft) or
         ((mm<>bpmm_To) and (mm<>bpmm_FromTo)) then
         lc:=linkP^.LinkFromCount else
         lc:=GetMultipleCountFrom(i);
         case (LinkFromType) of
          lt_Right: begin
                      case (gnode^.BPNode.ShapeType) of
                      lsa_Node: begin
                                 { w1:=gnode^.BPNode.width div (gnode^.BPNode.RightLinksCount+1);
                                  w:=gnode^.BPNode.left+w1*lc;}
                                  w:=gnode^.BPNode.left+gnode^.BPNode.width div 2;
                                  h:=gnode^.BPNode.top+gnode^.BPNode.Height;
                                end;
                      lsa_Junction:
                                begin
                                  if (lc=1) then
                                    begin
                                     w:=gnode^.BPNode.left;
                                     h:=gnode^.BPNode.Top+(gnode^.BPNode.MinHeight div 2);
                                    end
                                  else
                                   if (lc>=gnode^.BPNode.RightLinksCount) then
                                    begin
                                     w:=gnode^.BPNode.left+gnode^.BPNode.Width;
                                     h:=gnode^.BPNode.Top+(gnode^.BPNode.MinHeight div 2);
                                    end
                                   else
                                    begin
                                     w1:=(gnode^.BPNode.width-gnode^.BPNode.MinHeight) div (gnode^.BPNode.RightLinksCount+1);
                                     w:=gnode^.BPNode.left+(gnode^.BPNode.MinHeight div 2)+w1*lc;
                                     h:=gnode^.BPNode.top+gnode^.BPNode.Height;
                                    end;
                                end;
                      end;
                   end;
         end;
         linkP^.StartPoint.x:=w;
         linkP^.StartPoint.y:=h;
       end;
      { End StartPoint }
      gnode:=GetGraphNumberedNode(linkP^.ToNodeNumber);
      { begin EndPoint }
      if (gnode<>nil) then
       begin
         { local node }
        if (mff) or
           ((mm<>bpmm_From) and (mm<>bpmm_FromTo)) then
        lc:=linkP^.LinkToCount else
        lc:=GetMultipleCountTo(i);
         case (LinkToType) of
          lt_Left:  begin
                     case (gnode^.BPNode.ShapeType) of
                     lsa_Node: begin
                               {w1:=gnode^.BPNode.width div (gnode^.BPNode.LeftLinksCount+1);
                                w:=gnode^.BPNode.left+w1*lc;}
                                w:=gnode^.BPNode.Left+gnode^.BPNode.width div 2; { Slijanie links }
                                h:=gnode^.BPNode.top;
                               end;
                     lsa_Junction: begin
                                     w1:=(gnode^.BPNode.width-gnode^.BPNode.MinHeight) div 2;
                                     w:=gnode^.BPNode.left+(gnode^.BPNode.MinHeight div 2)+w1;
                                     h:=gnode^.BPNode.top;
                                   end;
                     end; {case}
                   end;
         end;
         linkP^.EndPoint.x:=w;
         linkP^.EndPoint.y:=h;
       end;
       { End EndPoint }
      end; { LinkP^.Visible }
    end; { for i }
  end;


 procedure  TBPLSAGraph.TraceGlobalStartEndPoints; { Checked }
 Var linkP,linkTmp:PLSAGraphLink;
         i:Integer;
       w,h:Integer;
       w1,h1:Integer;
       gw,gh:Integer;
       posx,posy:Integer;
       cofs:Integer;
       mff,mft:Boolean;
       hh,hhh:Integer;
  begin
   { SetUp Start & End points of Links }
   if (FGLinksCount=0) then Exit;
   if (FGNodesCount=0) then Exit;
   if FOwner.HorzScrollBar.Visible then
    begin
     gw:=FOwner.HorzScrollBar.Range;
     posx:=FOwner.HorzScrollBar.ScrollPos;
    end
   else
    begin
     gw:=FOwner.ClientWidth;
     posx:=0;
    end;
   if FOwner.VertScrollBar.Visible then
    begin
     gh:=FOwner.VertScrollBar.Range;
     posy:=FOwner.VertScrollBar.ScrollPos;
    end
   else
    begin
     gh:=FOwner.ClientHeight;
     posx:=0;
    end;
   if FPrinting then
    begin
      gh:=FDefHeight;
      gw:=FDefWidth;
      if not(FScaled2) then
       begin
        posx:=0;
        posy:=0;
       end;
    end;
   for i:=0 to (FGLinksCount-1) do
    begin
      linkP:=GetGraphLink(i);
      if linkP^.Visible then
      begin
      mft:=IsMultipleFirst(i,False);
      mff:=IsMultipleFirst(i,True);
      if ((linkP^.FromNodeNumber and BPGlobalMask)<>0) or
         ((linkP^.ToNodeNumber and BPGlobalMask)<>0) then
       begin
         { global node }
         case (linkP^.FromNodeNumber and BPGlobalMask) of
          BPGlobalLeftNodeNumber,BPGlobalNodeInProcess: begin
                     w1:=gw div (FGlobalLeftLinksCount+1);
                     if (mft) then
                      cofs:=linkP^.EndPoint.x
                     else
                      begin
                       linkTmp:=GetMultipleFirst(i,False);
                       cofs:=linkTmp^.EndPoint.x;
                      end;
                     w:=cofs;
                     h:=FGlobalTopSize-posy;
                     linkP^.StartPoint.x:=w;
                     linkP^.StartPoint.y:=h;
                   end;
         end;
         case (linkP^.ToNodeNumber and BPGlobalMask) of
          BPGlobalRightNodeNumber,BPGlobalNodeInProcess:  begin
                     w1:=gw div (FGlobalRightLinksCount+1);
                     if (mff) then
                      begin
                        cofs:=linkP^.StartPoint.x;
                      end
                     else
                      begin
                       linkTmp:=GetMultipleFirst(i,True);
                       cofs:=linkTmp^.StartPoint.x;
                      end;
                     w:=cofs;
                     h:=gh-FGlobalBottomSize-posy;
                     linkP^.EndPoint.x:=w;
                     linkP^.EndPoint.y:=h;
                   end;
         end;
      end;
      end; {linkP^.Visible }
     end; { For }
  end;

function TBPLSAGraph.GetMultipleCountFrom(index:Integer):Integer; { Checked }
Var tmpLink:PLSAGraphLink;
    tmpLink1:PLSAGraphLink;
    flag:Boolean;
    i:Integer;
 begin
   Result:=0;
   if (FGLinksCount=0) then Exit;
   tmpLink:=FGraphLinks;
   i:=0;
   while (i<index) do
    begin
     tmpLink:=tmpLink^.next;
     inc(i);
    end;
   flag:=True;
   i:=0;
   while ((i<FGLinksCount) and (flag)) do
    begin
           tmpLink1:=GetGraphLink(i);
           if (tmpLink^.FromLinkNumber=tmpLink1^.FromLinkNumber) and
              (tmpLink^.FromNodeNumber=tmpLink1^.FromNodeNumber) and
              ((tmpLink^.dwFlags and BP_FROMMASK)=(tmpLink1^.dwFlags and BP_FROMMASK)) then
             begin
               Result:=tmpLink1^.LinkFromCount;
               flag:=False;
             end;
      inc(i);
    end;
 end;


function  TBPLSAGraph.GetMultipleFirst(index:Integer;MultipleFrom:Boolean):PLSAGraphLink; { Checked }
 Var linkP:PLSAGraphLink;
     f:Boolean;
     linkT:PLSAGraphLink;
     i:Integer;
  begin
   Result:=nil;
   if FGLinksCount=0 then Exit;
   linkT:=FGraphLinks;
   i:=0;
   while (i<index) do
    begin
     linkT:=linkT^.next;
     inc(i);
    end;
   linkP:=FGraphLinks;
   f:=True;
   while (linkP<>nil) and (f) do
    begin
      if MultipleFrom then
         begin
           if (linkP^.ToNodeNumber=linkT^.ToNodeNumber) and
              ((linkP^.dwFlags and BP_TOMASK)=(linkT^.dwFlags and BP_TOMASK)) and
              (linkP^.ToLinkNumber=linkT^.ToLinkNumber) then
              begin
                Result:=linkP;
                f:=False;
              end;
         end
        else
         begin
           if (linkP^.FromNodeNumber=linkT^.FromNodeNumber) and
              ((linkP^.dwFlags and BP_FROMMASK)=(linkT^.dwFlags and BP_FROMMASK)) and
              (linkP^.FromLinkNumber=linkT^.FromLinkNumber) then
              begin
                Result:=linkP;
                f:=False;
              end;
         end;
      linkP:=linkP^.next;
    end;
  end;


function TBPLSAGraph.GetMultipleCountTo(index:Integer):Integer; { Checked }
Var tmpLink:PLSAGraphLink;
    tmpLink1:PLSAGraphLink;
    flag:Boolean;
    i:Integer;
 begin
   Result:=0;
   if (FGLinksCount=0) then Exit;
   tmpLink:=FGraphLinks;
   i:=0;
   while (i<index) do
    begin
      tmpLink:=tmpLink^.next;
      inc(i);
    end;
   flag:=True;
   i:=0;
   while ((i<FGLinksCount) and (flag)) do
    begin
           tmpLink1:=GetGraphLink(i);
           if (tmpLink^.ToLinkNumber=tmpLink1^.ToLinkNumber) and
              (tmpLink^.ToNodeNumber=tmpLink1^.ToNodeNumber) and
              ((tmpLink^.dwFlags and BP_TOMASK)=(tmpLink1^.dwFlags and BP_TOMASK)) then
             begin
               Result:=tmpLink1^.LinkToCount;
               flag:=False;
             end;
      inc(i);
    end;
 end;

function  TBPLSAGraph.IsMultipleFirstEx(l:PBPLink;MultipleFrom:Boolean):Boolean;
Var i:Integer;
    flag:Boolean;
    tmpLink1:PBPLink;
 begin
   Result:=False;
   if (FLinksCount=0) then Exit;
   tmpLink1:=FLinks;
   flag:=True;
   i:=0;
   while ((i<FLinksCount) and (flag)) do
    begin
      if MultipleFrom then
         begin
           if (l^.dwToLinkNumber=tmpLink1^.dwToLinkNumber) and
              (l^.dwToNodeNumber=tmpLink1^.dwToNodeNumber) and
              ((l^.dwFlags and BP_TOMASK)=(tmpLink1^.dwFlags and BP_TOMASK)) then
             begin
               if (l=tmpLink1) then Result:=True;
               flag:=False;
             end;
         end
      else
         begin
           if (l^.dwFromLinkNumber=tmpLink1^.dwFromLinkNumber) and
              (l^.dwFromNodeNumber=tmpLink1^.dwFromNodeNumber) and
              ((l^.dwFlags and BP_FROMMASK)=(tmpLink1^.dwFlags and BP_FROMMASK)) then
             begin
               if (l=tmpLink1) then Result:=True;
               flag:=False;
             end;
         end;
      inc(tmpLink1);
      inc(i);
    end;
 end;

function TBPLSAGraph.IsMultipleFirst(index:Integer;MultipleFrom:Boolean):Boolean; { Checked }
Var tmpLink:PLSAGraphLink;
    tmpLink1:PLSAGraphLink;
    flag:Boolean;
    i:Integer;
 begin
   Result:=False;
   if (FGLinksCount=0) then Exit;
   tmpLink:=FGraphLinks;
   tmpLink1:=FGraphLinks;
   i:=0;
   while (i<index) do
    begin
      tmpLink:=tmpLink^.next;
      inc(i);
    end;
   flag:=True;
   i:=0;
   while ((i<FGLinksCount) and (flag)) do
    begin
      if MultipleFrom then
         begin
           if (tmpLink^.ToLinkNumber=tmpLink1^.ToLinkNumber) and
              (tmpLink^.ToNodeNumber=tmpLink1^.ToNodeNumber) and
              ((tmpLink^.dwFlags and BP_TOMASK)=(tmpLink1^.dwFlags and BP_TOMASK)) then
             begin
               if (tmpLink=tmpLink1) then Result:=True;
               flag:=False;
             end;
         end
      else
         begin
           if (tmpLink^.FromLinkNumber=tmpLink1^.FromLinkNumber) and
              (tmpLink^.FromNodeNumber=tmpLink1^.FromNodeNumber) and
              ((tmpLink^.dwFlags and BP_FROMMASK)=(tmpLink1^.dwFlags and BP_FROMMASK)) then
             begin
               if (tmpLink=tmpLink1) then Result:=True;
               flag:=False;
             end;
         end;
      tmpLink1:=tmpLink1^.next;
      inc(i);
    end;
 end;


 function  TBPLSAGraph.GetMultipleMask(index:Integer):TBPMultipleMask; { Checked }
 Var linkP:PLSAGraphLink;
     linkC:PLSAGraphLink;
     i:Integer;
  begin
   Result:=bpmm_None;
   if (index>=FGLinksCount) or (index<0) then Exit;
   linkP:=FGraphLinks;
   linkC:=FGraphLinks;
   i:=0;
   while (i<index) do
     begin
       LinkP:=linkP^.next;
       inc(i);
     end;
   for i:=0 to (FGlinksCount-1) do
     begin
       if (i<>index) then
         begin
           if (linkC^.FromNodeNumber=linkP^.FromNodeNumber) and
              (linkC^.FromLinkNumber=linkP^.FromLinkNumber) and
              ((linkC^.dwFlags and BP_FROMMASK)=(LinkP^.dwFlags and BP_FROMMASK)) then
               begin
                 if Result=bpmm_From then Result:=bpmm_FromTo
                      else Result:=bpmm_To;
               end;
           if (linkC^.ToNodeNumber=linkP^.ToNodeNumber) and
              (linkC^.ToLinkNumber=linkP^.ToLinkNumber) and
              ((linkC^.dwFlags and BP_TOMASK)=(LinkP^.dwFlags and BP_TOMASK)) then
               begin
                 if Result=bpmm_To then Result:=bpmm_FromTo
                      else Result:=bpmm_From;
               end;
         end;
       linkC:=linkC^.next;
     end;
  end;

 function   TBPLSAGraph.GetLinkFrom(const value:PLSAGraphLink):TLinkType; { Checked }
  begin
    Result:=lt_Right;
    if value=nil then Exit;
    case (value^.dwFlags and BP_FROMMASK) of
     BP_FROMNODE_LEFT:   Result:=lt_Left;
     BP_FROMNODE_RIGHT:  Result:=lt_Right;
     BP_FROMNODE_TOP:    Result:=lt_Top;
     BP_FROMNODE_BOTTOM: Result:=lt_Bottom;
    end;
  end;

 function   TBPLSAGraph.GetLinkTo(const value:PLSAGraphLink):TLinkType; { Checked }
  begin
   Result:=lt_Left;
    case (value^.dwFlags and BP_TOMASK) of
     BP_TONODE_LEFT:   Result:=lt_Left;
     BP_TONODE_RIGHT:  Result:=lt_Right;
     BP_TONODE_TOP:    Result:=lt_Top;
     BP_TONODE_BOTTOM: Result:=lt_Bottom;
    end;
  end;

procedure  TBPLSAGraph.CorrectLinksCounters;
 Var linkP:PLSAGraphLink;
     gnode:TBPLSAGraphNode;
       i,j:Integer;
   minco,minci:Array[0..100] of Integer;
 begin
    if (FGLinksCount=0) then Exit;
   if (FGNodesCount=0) then Exit;
   for i:=0 to (FGNodesCount-1) do
    begin
     gnode:=GetGraphNode(i);
     minco[i]:=$FFFF;
     minci[i]:=$FFFF;
     if (gnode<>nil) then
      begin
       for j:=0 to (FGLinksCount-1) do
        begin
         linkP:=GetGraphLink(j);
          if linkP<>nil then
            begin
              if linkP^.Visible then
              begin
                if (linkP^.FromNodeNumber=gnode.NodeNumber) then
                begin
                  if (linkP^.FromLinkNumber<minco[i]) then
                     minco[i]:=linkP^.FromLinkNumber;
                end;
               if (linkP^.ToNodeNumber=gnode.NodeNumber) then
                begin
                  if (linkP^.ToLinkNumber<minci[i]) then
                     minci[i]:=linkP^.ToLinkNumber;
                end;
              end;
            end; {linkP<>nil}
         end; {for j}
        end; {gnode<>nil}
      end; {for i}

   { Now correct link counters }

   for i:=0 to (FGNodesCount-1) do
    begin
     gnode:=GetGraphNode(i);
     if (gnode<>nil) then
      begin
       for j:=0 to (FGLinksCount-1) do
        begin
         linkP:=GetGraphLink(j);
          if linkP<>nil then
            begin
              if linkP^.Visible then
              begin
                if (linkP^.FromNodeNumber=gnode.NodeNumber) then
                begin
                  linkP^.FromLinkNumber:=linkP^.FromLinkNumber-minco[i]+1;
                end;
               if (linkP^.ToNodeNumber=gnode.NodeNumber) then
                begin
                  linkP^.ToLinkNumber:=linkP^.ToLinkNumber-minci[i]+1;
                end;
              end;
            end; {linkP<>nil}
         end; {for j}
        end; {gnode<>nil}
      end; {for i}


 end;

procedure  TBPLSAGraph.TraceLinksToNodeCounters; { Checked }
 Var linkP:PLSAGraphLink;
     gnode:TBPLSAGraphNode;
       i,j:Integer;
     linkFromType,linkToType:TLinkType;
        mm:TBPMultipleMask;
    mff,mft:Boolean;
    lr:TBPLSALeftRight;
    lrx,rrx:Integer;
       llis:Integer;
       rlis:Integer;
       posx:Integer;
  begin
   { Calc links count for every node }
   if (FGLinksCount=0) then Exit;
   if (FGNodesCount=0) then Exit;
   { New code - filling Left,Right,Bottom regions arrays }
   if FOwner.HorzScrollBar.Visible then posx:=FOwner.HorzScrollBar.ScrollPos else posx:=0;
   FillLeftArray;
   FillRightArray;
   for i:=0 to (FGNodesCount-1) do
    begin
     gnode:=GetGraphNode(i);
{     gnode.OutputCount:=0;}
     if (gnode<>nil) then
      begin
       for j:=0 to (FGLinksCount-1) do
        begin
         linkP:=GetGraphLink(j);
         linkFromType:=GetLinkFrom(linkP);
         linkToType:=GetLinkTo(linkP);
          if linkP<>nil then
            begin
              if linkP^.Visible then
              begin
              mm:=GetMultipleMask(j);
              mff:=IsMultipleFirst(j,True);
              mft:=IsMultipleFirst(j,False);
              if (linkP^.FromNodeNumber=gnode.NodeNumber) then
                begin
                  { if not multiple link from or first multiple link }
                 lr:=GetNodeLeftRight(linkP^.FromNodeNumber);
                 lrx:=Round(lr.LeftRegion*FRatioX)+FOwner.ClientRect.Left+FGlobalLeftSize-posx;
                 rrx:=Round(lr.RightRegion*FRatioX)+FOwner.ClientRect.Left+FGlobalLeftSize-posx;
                 llis:=IsLeftArray(lrx);
                 rlis:=IsRightArray(rrx);
                 if ((mm<>bpmm_To) and (mm<>bpmm_FromTo)) or
                    (mft and ((mm=bpmm_To) or (mm=bpmm_FromTo))) then
                  begin
                  case (LinkFromType) of
                   lt_Right:  begin
                               FLeftArray.Count[llis]:=FLeftArray.Count[llis]+1;
                               FRightArray.Count[rlis]:=FRightArray.Count[rlis]+1;
                               gnode.RightLinksCount:=gnode.RightLinksCount+1;
                               {gnode.OutputCount:=gnode.OutputCount+1;}
                               linkP^.LinkFromCount:=linkP^.FromLinkNumber{gnode.RightLinksCount};
                               linkP^.LinkLeftCount:=FLeftArray.Count[llis];
                               linkP^.LinkRightCount:=FRightArray.Count[rlis];
                              end;
                  end;
                  end else linkP^.LinkFromCount:=linkP^.FromLinkNumber;
                  { end if multiple from }
                end;
              if (linkP^.ToNodeNumber=gnode.NodeNumber) then
                begin
                 lr:=GetNodeLeftRight(linkP^.ToNodeNumber);
                 lrx:=Round(lr.LeftRegion*FRatioX)+FOwner.ClientRect.Left+FGlobalLeftSize-posx;
                 rrx:=Round(lr.RightRegion*FRatioX)+FOwner.ClientRect.Left+FGlobalLeftSize-posx;
                 llis:=IsLeftArray(lrx);
                 rlis:=IsRightArray(rrx);
                 if ((mm<>bpmm_From) and (mm<>bpmm_FromTo)) or
                    (mff and ((mm=bpmm_From) or (mm=bpmm_FromTo))) then
                  begin
                  case (LinkToType) of
                   lt_Left:   begin
                              FLeftArray.Count[llis]:=FLeftArray.Count[llis]+1;
                              FRightArray.Count[rlis]:=FRightArray.Count[rlis]+1;
                              gnode.LeftLinksCount:=gnode.LeftLinksCount+1;
                              linkP^.LinkToCount:=linkP^.ToLinkNumber{gnode.LeftLinksCount};
                              linkP^.LinkLeftCount:=FLeftArray.Count[llis];
                              linkP^.LinkRightCount:=FRightArray.Count[rlis];
                              end;
                  end;
                  end else linkP^.LinkToCount:=linkP^.ToLinkNumber;
                end;
               end; { Visible link }
            end; { link<>nil}
        end; { for links }
      end; { node<>nil}
    end; { for nodes }

      for i:=0 to (FGLinksCount-1) do
       begin
          linkP:=GetGraphLink(i);
          if linkP^.Visible then
          begin
             { Now For global nodes }
             mm:=GetMultipleMask(i);
             mff:=IsMultipleFirst(i,True);
             mft:=IsMultipleFirst(i,False);
             {Left global node}
             if ((linkP^.FromNodeNumber and BPGlobalMask)=BPGlobalLeftNodeNumber) then
                 begin
                    if ((mm<>bpmm_To) and (mm<>bpmm_FromTo)) or
                    (mft and ((mm=bpmm_To) or (mm=bpmm_FromTo))) then
                     begin
                      Inc(FGlobalLeftLinksCount);
                      linkP^.LinkFromCount:=FGlobalLeftLinksCount;
                     end else linkP^.LinkFromCount:=GetMultipleCountFrom(i);
                 end;
             if ((linkP^.ToNodeNumber  and BPGlobalMask)=BPGlobalLeftNodeNumber) then
                  begin
                   if ((mm<>bpmm_From) and (mm<>bpmm_FromTo)) or
                    (mff and ((mm=bpmm_From) or (mm=bpmm_FromTo))) then
                   begin
                    Inc(FGlobalLeftLinksCount);
                    linkP^.LinkToCount:=FGlobalLeftLinksCount;
                   end else linkP^.LinkToCount:=GetMultipleCountTo(i);
                  end;
              if ((linkP^.FromNodeNumber and BPGlobalMask)=BPGlobalNodeInProcess) and
                ((linkP^.dwFlags and BP_FROMTOMASK)=BP_RIGHT_LEFT)  then
                 begin
                   {Left Inprocess }
                   if ((mm<>bpmm_To) and (mm<>bpmm_FromTo)) or
                    (mft and ((mm=bpmm_To) or (mm=bpmm_FromTo))) then
                     begin
                      Inc(FGlobalLeftLinksCount);
                      linkP^.LinkFromCount:=FGlobalLeftLinksCount;
                     end else linkP^.LinkFromCount:=GetMultipleCountFrom(i);
                 end;
              if ((linkP^.ToNodeNumber and BPGlobalMask)=BPGlobalNodeInProcess) and
                ((linkP^.dwFlags and BP_FROMTOMASK)=BP_RIGHT_LEFT)  then
                 begin
                   {Right Inprocess }
                   if ((mm<>bpmm_From) and (mm<>bpmm_FromTo)) or
                    (mff and ((mm=bpmm_From) or (mm=bpmm_FromTo))) then
                   begin
                    Inc(FGlobalRightLinksCount);
                    linkP^.LinkToCount:=FGlobalRightLinksCount;
                   end else linkP^.LinkToCount:=GetMultipleCountTo(i);
                 end;
             { Right  global node}
             if ((linkP^.FromNodeNumber and BPGlobalMask)=BPGlobalRightNodeNumber) then
                  begin
                    if ((mm<>bpmm_To) and (mm<>bpmm_FromTo)) or
                    (mft and ((mm=bpmm_To) or (mm=bpmm_FromTo))) then
                   begin
                   Inc(FGlobalRightLinksCount);
                   linkP^.LinkFromCount:=FGlobalRightLinksCount;
                   end else linkP^.LinkFromCount:=GetMultipleCountFrom(i);
                  end;
             if ((linkP^.ToNodeNumber and BPGlobalMask)=BPGlobalRightNodeNumber) then
                  begin
                   if ((mm<>bpmm_From) and (mm<>bpmm_FromTo)) or
                    (mff and ((mm=bpmm_From) or (mm=bpmm_FromTo))) then
                   begin
                    Inc(FGlobalRightLinksCount);
                    linkP^.LinkToCount:=FGlobalRightLinksCount;
                   end else linkP^.LinkToCount:=GetMultipleCountTo(i);
                  end;
          end; { Visible link }
       end; { for }

  end;



procedure  TBPLSAGraph.TraceNodesToLinksCounters; { Checked }
  Var linkP:PLSAGraphLink;
         i:Integer;
 begin
   if (FGLinksCount=0) then Exit;
   for i:=0 to (FGLinksCount-1) do
    begin
     linkP:=GetGraphLink(i);
     linkP^.LinkFromCount:=0;
     linkP^.LinkToCount:=0;
     linkP^.MinimalXFrom:=0;
     linkP^.MinimalXTo:=0;
     linkP^.MinimalYFrom:=0;
     linkP^.MinimalYTo:=0;
     linkP^.LinkLeftCount:=0;
     linkP^.LinkRightCount:=0;
  end;
 end;

procedure  TBPLSAGraph.TraceNodes; { Checked }
 Var i:Integer;
     gnode:PLSAGraphNode;
     w1,h1:Integer;
  begin
    if (FGNodesCount=0) then Exit;
    { We get max node width & height for drawing text, but }
    w1:=FMaxWidth;
    h1:=FMaxHeight;
{    if w1>h1 then h1:=Round(w1/NodeRatio) else
     w1:=Round(h1*NodeRatio);}
    { Printing ! }
     if FPrinting then
     begin
      FRatioX:=(FDefWidth-FGlobalLeftSize-FGlobalRightSize)/(FinalWidth+1);
      FRatioY:=(FDefHeight-FGlobalTopSize-FGlobalBottomSize)/(FinalHeight+1);
      w1:=Round(FNWidth*FRatioX);
      h1:=Round(FNHeight*FRatioY);
     end
      else
     begin
      FinalWidth:=FADefWidth;
      FinalHeight:=FADefHeight;
      FNWidth:=w1;
      FNHeight:=h1;
      FRatioX:=1.0;
      FRatioY:=1.0;
      gnode:=FGraphNodes;
      FNodeXArray.NodesCount:=0;
      for i:=0 to (FGNodesCount-1) do
       begin
         FinalNodeX[i]:=gnode^.FinalX;
         FinalNodeY[i]:=gnode^.FinalY;
         gnode^.RightRegion:={FOwner.ClientRect.Left+FGlobalLeftSize+}gnode^.BPNode.RightRegion{-Parent.HorzScrollBar.Position};
         gnode^.LeftRegion:={FOwner.ClientRect.Left+FGlobalLeftSize+}gnode^.BPNode.LeftRegion{-Parent.HorzScrollBar.Position};
         FNodeXArray.NodeNumber[i]:=gnode^.BPNode.NodeNumber;
         FNodeXArray.NodesXLeft[i]:=gnode^.BPNode.LeftRegion;
         FNodeXArray.NodesXRight[i]:=gnode^.BPNode.RightRegion;
         gnode:=gnode^.next;
         FNodeXArray.NodesCount:=FNodeXArray.NodesCount+1;
       end;
      FDefWidth:=FGlobalLeftSize+FGlobalRightSize+FinalWidth+(w1 div 2);
      FDefHeight:=FGlobalTopSize+FGlobalBottomSize+FinalHeight+(h1 div 2);
     end;
      FAcceptDragRect.Left:=FGlobalLeftSize;
      FAcceptDragRect.Top:=FGlobalTopSize;
      FAcceptDragRect.Bottom:=FDefHeight-FGlobalBottomSize;
      FAcceptDragRect.Right:=FDefWidth-FGlobalRightSize;
      if Parent.HorzScrollBar.Range<>FDefWidth then
       Parent.HorzScrollBar.Range:=FDefWidth;
      if Parent.VertScrollBar.Range<>FDefHeight then
       Parent.VertScrollBar.Range:=FDefHeight;
    FNodeWidth:=w1;
    FNodeHeight:=h1;
    for i:=0 to (FGNodesCount-1) do
     begin
       gnode:=GetGraphNodeRec(i);
       if gnode=nil then Exit;
       gnode^.BPNode.AutoHeight:=False;
       gnode^.BPNode.AutoWidth:=False;
       gnode^.BPNode.DefWidth:=w1;
       gnode^.BPNode.DefHeight:=h1;
       if ((FDiscardDrags) or (not(gnode^.BPNode.AcceptPosition))) then
        begin
         gnode^.BPNode.Top:=FOwner.ClientRect.Top+FGlobalTopSize+Round(FinalNodeY[i]*FRatioY)-Parent.VertScrollBar.Position;
         gnode^.BPNode.Left:=FOwner.ClientRect.Left+FGlobalLeftSize+Round(FinalNodeX[i]*FRatioX)-Parent.HorzScrollBar.Position;
         gnode^.BPNode.AcceptPosition:=False;
        end;
       gnode^.BPNode.LeftLinksCount:=0;
       gnode^.BPNode.RightLinksCount:=0;
     end;
   FGlobalLeftLinksCount:=0;
   FGlobalRightLinksCount:=0;
  end;

procedure TBPLSAGraph.InitGNodes;
Var tmpN:PLSAGraphNode;
 begin
   if (FGNodesCount=0) then Exit;
   tmpN:=FGraphNodes;
   while (tmpN<>nil) do
    begin
      tmpN^.NodeXYCount:=0;
      tmpN^.BPNode.RightRegion:=0;
      tmpN^.BPNode.LeftRegion:=0;
      tmpN^.LeftRegion:=0;
      tmpN^.RightRegion:=0;
      tmpN^.BPNode.OutputCount:=0;
      tmpN^.FinalX:=0;
      tmpN^.FinalY:=0;
      tmpN^.NodePassed:=False;
      tmpN^.LevelID:=0;
      tmpN:=tmpN^.next;
    end;
 end;

procedure TBPLSAGraph.InitGLinks;
Var tmpL:PLSAGraphLink;
 begin
   if (FGLinksCount=0) then Exit;
   tmpL:=FGraphLinks;
   while (tmpL<>nil) do
    begin
      tmpL:=tmpL^.next;
    end;
 end;


function  TBPLSAGraph.LinkExInAllCheckGraph(link:PBPLink):Boolean;
Var i,j,cnt:Integer;
 begin
   Result:=False;
{   if (FFillDiag=0) then Exit;}
   cnt:=FFillDiag;
   for i:=0 to cnt do
    begin
     for j:=0 to (FCheckGraph.LinksCount[i]-1) do
      begin
        if FCheckGraph.Links[j,i]=link then
           begin
             Result:=True;
             Exit;
           end;
      end;
      if ((link^.dwFromNodeNumber and BPGlobalMask)<>0) and
         ((link^.dwFlags and BP_FROMTOMASK)=BP_RIGHT_LEFT) then
         for j:=0 to (FCheckGraph.NodesCount[i]-1) do
           begin
             if FCheckGraph.Nodes[j,i]^.dwNodeNumber=link^.dwToNodeNumber then
               begin
                 Result:=True;
                 Exit;
               end;
           end;
    end;
 end;

function  TBPLSAGraph.GetNextInPointEx:PBPLink;
Var tmpL:PBPLink;
    i:Integer;
 begin
    Result:=nil;
    if (FLinksCount=0) then Exit;
    tmpL:=FLinks;
    for i:=0 to (FLinksCOunt-1) do
     begin
     if   (((tmpL^.dwFromNodeNumber and BPGlobalLeftNodeNumber)<>0) or
          ((tmpL^.dwFromNodeNumber and BPGlobalNodeInProcess)<>0)) and
          ((tmpL^.dwFlags and BP_RIGHT_LEFT)=BP_RIGHT_LEFT) then
        begin
          if not(LinkExInAllCheckGraph(tmpL)) then
           begin
            if (Result=nil) then Result:=tmpL;
            if (Result^.dwToNodeNumber>tmpL^.dwToNodeNumber) then Result:=tmpL;
           end;
        end;
       inc(tmpL);
     end;
 end;

function  TBPLSAGraph.GetFirstInPointEx:PBPLink;
Var tmpL:PBPLink;
       i:Integer;
  begin
    Result:=nil;
    if (FLinksCount=0) then Exit;
    tmpL:=FLinks;
    for i:=0 to (FLinksCOunt-1) do
     begin
       if (((tmpL^.dwFromNodeNumber and BPGlobalLeftNodeNumber)<>0) or
           ((tmpL^.dwFromNodeNumber and BPGlobalNodeInProcess)<>0)) and
          ((tmpL^.dwFlags and BP_RIGHT_LEFT)=BP_RIGHT_LEFT) then
        begin
          if (Result=nil) then Result:=tmpL;
          if (Result^.dwToNodeNumber>tmpL^.dwToNodeNumber) then Result:=tmpL;
        end;
       inc(tmpL);
     end;
  end;

function  TBPLSAGraph.GetFirstInPoint:PLSAGraphLink;
Var tmpL:PLSAGraphLink;
       i:Integer;
  begin
    Result:=nil;
    if (FGLinksCount=0) then Exit;
    tmpL:=FGraphLinks;
    for i:=0 to (FGLinksCOunt-1) do
     begin
       if ((tmpL^.FromNodeNumber and BPGlobalLeftNodeNumber)<>0) or
          (((tmpL^.FromNodeNumber and BPGlobalNodeInProcess)<>0) and
           ((tmpL^.dwFlags and BP_FROMTOMASK)=BP_RIGHT_LEFT)) then
        begin
          if (Result=nil) then Result:=tmpL;
         { if (Result^.ToNodeNumber>tmpL^.ToNodeNumber) then Result:=tmpL;}
        end;
       tmpL:=tmpL^.next;
     end;
    FInLSAGraphLink:=Result;
  end;

function TBPLSAGraph.GetNextInPoint:PLSAGraphLink;
Var tmpL:PLSAGraphLink;
       i:Integer;
      flag:Boolean;
begin
    Result:=nil;
    if (FGLinksCount=0) then Exit;
    tmpL:=FGraphLinks;
    flag:=False;
    for i:=0 to (FGLinksCOunt-1) do
     begin
       if (((tmpL^.FromNodeNumber and BPGlobalLeftNodeNumber)<>0) or
          (((tmpL^.FromNodeNumber and BPGlobalNodeInProcess)<>0) and
           ((tmpL^.dwFlags and BP_FROMTOMASK)=BP_RIGHT_LEFT))) and
           flag then
        begin
          if (Result=nil) then Result:=tmpL;
         { if (Result^.ToNodeNumber>tmpL^.ToNodeNumber) then Result:=tmpL;}
        end;
       if tmpL=FInLSAGraphLink then flag:=True;
       tmpL:=tmpL^.next;
     end;
    FInLSAGraphLink:=Result;
end;


function  TBPLSAGraph.GetFirstInPoint1:PLSAGraphLink;
Var tmpL:PLSAGraphLink;
       i:Integer;
  begin
    Result:=nil;
    if (FGLinksCount=0) then Exit;
    tmpL:=FGraphLinks;
    for i:=0 to (FGLinksCOunt-1) do
     begin
       if ((tmpL^.FromNodeNumber and BPGlobalLeftNodeNumber)<>0) or
          (((tmpL^.FromNodeNumber and BPGlobalNodeInProcess)<>0) and
           ((tmpL^.dwFlags and BP_FROMTOMASK)=BP_RIGHT_LEFT)) then
        begin
          if (Result=nil) then Result:=tmpL;
         { if (Result^.ToNodeNumber>tmpL^.ToNodeNumber) then Result:=tmpL;}
        end;
       tmpL:=tmpL^.next;
     end;
    FInLSAGraphLink1:=Result;
  end;

function TBPLSAGraph.GetNextInPoint1:PLSAGraphLink;
Var tmpL:PLSAGraphLink;
       i:Integer;
      flag:Boolean;
begin
    Result:=nil;
    if (FGLinksCount=0) then Exit;
    tmpL:=FGraphLinks;
    flag:=False;
    for i:=0 to (FGLinksCOunt-1) do
     begin
       if (((tmpL^.FromNodeNumber and BPGlobalLeftNodeNumber)<>0) or
          (((tmpL^.FromNodeNumber and BPGlobalNodeInProcess)<>0) and
           ((tmpL^.dwFlags and BP_FROMTOMASK)=BP_RIGHT_LEFT))) and
           flag then
        begin
          if (Result=nil) then Result:=tmpL;
         { if (Result^.ToNodeNumber>tmpL^.ToNodeNumber) then Result:=tmpL;}
        end;
       if tmpL=FInLSAGraphLink1 then flag:=True;
       tmpL:=tmpL^.next;
     end;
    FInLSAGraphLink1:=Result;
end;

function  TBPLSAGraph.GetOutputLinksArray(node:PLSAGraphNode):TBPLSALinkArray;
Var tmpL:PLSAGraphLink;
       i:Integer;
 begin
   Result.LinksCount:=0;
   if (FGLinksCount=0) then Exit;
   tmpL:=FGraphLinks;
    for i:=0 to (FGLinksCount-1) do
     begin
       if (tmpL^.FromNodeNumber=node^.BPNode.NodeNumber) then
        begin
          Result.Links[Result.LinksCount]:=tmpL;
          Result.LinksCount:=Result.LinksCount+1;
        end;
       tmpL:=tmpL^.next;
     end;
 end;

function  TBPLSAGraph.CalcNeedOutputShift(var GLinks:TBPLSALinkArray;Output:Integer):Integer;
Var   i,j:Integer;
   flagOutput:Boolean;
   flagLink:Boolean;
   num:array[0..100] of DWORD;
   numcount:Integer;
 begin
  Result:=0;
  if GLinks.LinksCount=0 then Exit;
  flagOutput:=False;
  flagLink:=False;
  if Output>1 then
    begin
      numcount:=0;
      for i:=0 to (GLinks.LinksCount-1) do
        begin
          if ((GLinks.Links[i]^.ToNodeNumber and BPGlobalMask)<>0) then
            begin
              flagOutput:=True;
              num[numcount]:=GLinks.Links[i]^.FromLinkNumber;
              inc(numcount);
            end;
          if ((GLinks.Links[i]^.ToNodeNumber and BPGlobalMask)=0) then
            begin
              for j:=0 to (numcount-1) do
                begin
                  if (num[j]=GLinks.Links[i]^.FromLinkNumber) then flagLink:=True;
                end;
            end;
        end;
      if flagOutput and flagLink then Result:=1;
    end
  else
    begin
      for i:=0 to (GLinks.LinksCount-1) do
        begin
          if ((GLinks.Links[i]^.ToNodeNumber and BPGlobalMask)<>0) then
            begin
              flagOutput:=True;
            end;
          if ((GLinks.Links[i]^.ToNodeNumber and BPGlobalMask)=0) then
            begin
             flagLink:=True;
            end;
        end;
      if flagOutput and flagLink then Result:=1;
    end;
 end;

procedure TBPLSAGraph.SortOutputLinksArray(var GLinks:TBPLSALinkArray);
Var linkF,linkL:PLSAGraphLink;
    i,j:Integer;
    flag:Boolean;
 begin
  { Hm LeftRight order }
    if (GLinks.LinksCount=0) then Exit;
    flag:=False;
    while (not(Flag)) do
     begin
       Flag:=True;
       for i:=0 to (GLinks.LinksCount-2) do
        begin
        for j:=(i+1) to (GLinks.LinksCount-1) do
         begin
           linkF:=GLinks.Links[i];
           linkL:=GLinks.Links[j];
            { Changed znak for comparing model }
           if ((linkF^.ToNodeNumber and BPGlobalMask)=0) and
              ((linkL^.ToNodeNumber and BPGlobalMask)<>0) then
             begin
               GLinks.Links[j]:=linkF;
               GLinks.Links[i]:=linkL;
               Flag:=False;
             end
           else
           if ((linkF^.ToNodeNumber and BPGlobalMask)=0) and
              ((linkL^.ToNodeNumber and BPGlobalMask)=0) then
           if ((DWORD(linkF^.ToNodeNumber))>(DWORD(linkL^.ToNodeNumber))) then
              begin
                GLinks.Links[j]:=linkF;
                GLinks.Links[i]:=linkL;
                Flag:=False;
              end;
         end; { for j }
        end; { for i}
     end;
 end;


function  TBPLSAGraph.GetInputLink(node:PLSAGraphNode):PLSAGraphLink;
Var tmpN:PLSAGraphLink;
      i:Integer;
 begin
    Result:=nil;
    if FGLinksCount=0 then Exit;
    if node=nil then Exit;
    tmpN:=FGraphLinks;
    for i:=0 to (FGlinksCount-1) do
     begin
       if (tmpN^.ToNodeNumber=node^.BPNode.NodeNumber) and
          (((tmpN^.FromNodeNumber and BPGlobalLeftNodeNumber)<>0) or
           (((tmpN^.FromNodeNumber and BPGlobalNodeInProcess)<>0)) and
             ((tmpN^.dwFlags and BP_FROMTOMASK)=BP_RIGHT_LEFT)) then
           begin
             Result:=tmpN;
             Exit;
           end
       else
       tmpN:=tmpN^.next;
     end;
 end;

function  TBPLSAGraph.AnalizeLink(p:TPoint;link:PLSAGraphLink;Level:Integer;Var Shift:Integer;nWidth:Integer;ShiftRight:Boolean):TPoint;
Var tmpN:PLSAGraphNode;
    tmpN1:PLSAGraphNode;
    tmpN2:PLSAGraphNode;
    p1,a,p2,p3,ip:TPoint;
    w,h:Integer;
    nx,ny:Integer;
    mx,my:Integer;
    i:Integer;
    tmpLinks:TBPLSALinkArray;
    tmpL:PLSAGraphLink;
    rr,lr:Integer;
    hil:Boolean;
    l:PLSAGraphLink;
    e:Integer;
    NewShiftRight:Boolean;
    tmpLLL:PLSAGraphLink;
    flag1:Boolean;
    mmm:Integer;

function MaxInt(a,b:Integer):Integer;
 begin
  if a<b then Result:=b else Result:=a;
 end;

function MaxTPoint(a,b:TPoint):TPoint;
 begin
   if (a.x<b.x) then Result.x:=b.x else Result.x:=a.x;
   if (a.y<b.y) then Result.y:=b.y else Result.y:=a.y;
 end;

  begin
   {hm}
     ip:=p;
     Result:=ip;
     if (link=nil) then Exit;
{     Application.MessageBox(PChar(IntToStr(link^.ToNodeNumber)),PChar('Node'),MB_OK);}
{1}  tmpN:=GetGraphNumberedNode(link^.ToNodeNumber);
{3}  w:=FMaxWidth{tmpN^.BPNode.Width};
     h:=FMaxHeight{tmpN^.BPNode.Height};
{     if w>h then h:=Round(w/NodeRatio) else
     w:=Round(h*NodeRatio);}
(*     if FGlobalShift and (nWidth>0) then
      begin
       Result.x:=ip.x-w*2{4};
       {Shift:=Shift+w;}
      end;*)
     Result.X:=Result.x+2*w;
     if (tmpN=nil) then Exit;
     Result:=ip;
{     Application.MessageBox(PChar(IntToStr(link^.ToNodeNumber)),PChar(IntToStr(tmpN^.BPNode.NodeNumber)),MB_OK);}
     p1.x:=ip.x+2*w;
     p1.y:=ip.y+2*h;
{3.1}if tmpN^.NodePassed then
      begin
{        tmpN2:=GetGraphNumberedNode(link^.FromNodeNumber);
        if tmpN2=nil then Result.x:=Result.x+2*w;}
        Exit;
        tmpN1:=GetGraphNumberedNode(link^.FromNodeNumber);
        if (tmpN1<>nil) and
           (tmpN1^.BPNode.NodeNumber>tmpN^.BPNode.NodeNumber) then Exit; {  Reward Link }
{3.1}   nx:=0;
        ny:=0;
        mx:=ip.x+(w div 2);
        my:=ip.y+(h div 2);
        for i:=0 to (tmpN^.NodeXYCount-1) do
          begin
            nx:=nx+tmpN^.NodeX[i];
            if ny<tmpN^.NodeY[i] then ny:=tmpN^.NodeY[i];
          end;
        if ny<my then ny:=my;
        nx:=nx+mx;
        tmpN^.NodeXYCount:=tmpN^.NodeXYCount+1;
        tmpN^.NodeX[tmpN^.NodeXYCount-1]:=mx;
        tmpN^.NodeY[tmpN^.NodeXYCount-1]:=my;
        nx:=nx div tmpN^.NodeXYCount;
        {Set FinalX & FinalY }
        tmpN^.FinalX:=nx;
        tmpN^.FinalY:=ny;
        rr:=MaxInt(p1.x{p.x - for true},nx+(w div 2)+w);
        Result.x:=rr;
        Result.y:=MaxInt(p1.y,ny+(h div 2)+h);
        if (rr>tmpN^.BPNode.RightRegion) then tmpN^.BPNode.RightRegion:=rr;
        if (p.x<tmpN^.BPNode.LeftRegion) then tmpN^.BPNode.LeftRegion:=p.x;
        if (tmpN^.LevelID<level) then tmpN^.LevelID:=level;
        Exit;
      end;
{3.2} tmpN^.NodePassed:=True;
{4}   tmpLinks:=GetOutputLinksArray(tmpN);
{      Application.MessageBox(PChar(IntToStr(tmpLinks.LinksCount)),PChar('1Node '+IntToStr(tmpN^.BPNode.NodeNumber)),MB_OK);}
{5}  { SortOutputLinksArray(tmpLinks);}  { Checked }
{      Application.MessageBox(PChar(IntToStr(tmpLinks.LinksCount)),PChar('2Node '+IntToStr(tmpN^.BPNode.NodeNumber)),MB_OK);}
      tmpN^.BPNode.OutputCount:=CalcOutputCount(tmpN);
{      e:=CalcNeedOutputShift(tmpLinks,tmpN^.BPNode.OutputCount);}
      tmpLLL:=GetFirstInPoint1;
      flag1:=False;
      while tmpLLL<>nil do
        begin
          if (tmpLLL^.ToNodeNumber=tmpN^.BPNode.NodeNumber) and (tmpLLL<>link) then flag1:=True;
          tmpLLL:=GetNextInPOint1;
        end;
      a.y:=0;
      a.x:=0;
{      if flag1 then a.x:=2*w else a.x:=0;}
      if flag1 then ip.x:=ip.x+2*w;
      p1.x:=ip.x+2*w;
      ny:=0;
{      if (level>1) and FGlobalShift2 then
       begin
         l:=GetInputLink(tmpN);
         if l<>nil then
          begin
            ip.x:=ip.x-Round(1.5*w);
            Shift:=Shift+Round(1.5*w);
          end;
       end;}
      p3.x:=0;
      p3.y:=0;
      for i:=0 to (tmpLinks.LinksCount-1) do
       begin
         tmpL:=tmpLinks.Links[i];
{         NewShiftRight:=(((tmpL^.ToNodeNumber and BPGlobalMask)=0) and
                         (tmpL^.FromLinkNumber>=tmpN^.BPNode.OutputCount) and
                         (tmpN^.BPNode.OutputCount>1));}
         p2.x:=a.x+ip.x;
         p2.y:=a.y+p1.y;
         p3:=AnalizeLink(p2,tmpL,level+1,Shift,e,NewShiftRight);
         if i=0 then e:=0;
         a.x:={a.x+}p3.x-ip.x;
         if (ny<p3.y) then ny:=p3.y;
       end;
      tmpN^.NodeXYCount:=tmpN^.NodeXYCount+1;
      tmpN^.NodeY[tmpN^.NodeXYCount-1]:=ip.y+(h div 2);
{      if FGlobalShift4 then
       begin
        tmpN^.NodeX[tmpN^.NodeXYCount-1]:=ip.x+((MaxInt(p1.x,p3.x)-p.x-w) div 2);
        tmpN^.FinalX:=ip.x+((MaxInt(p1.x,p3.x)-p.x-w) div 2);
       end
      else
       begin}
        tmpN^.NodeX[tmpN^.NodeXYCount-1]:=ip.x+((MaxInt(p1.x,p3.x)-ip.x-w) div 2);
        tmpN^.FinalX:=ip.x+((MaxInt(p1.x,p3.x)-ip.x-w) div 2);
{       end;}
{      if ShiftRight then
       begin
        tmpN^.NodeX[tmpN^.NodeXYCount-1]:=tmpN^.NodeX[tmpN^.NodeXYCount-1]+w;
        tmpN^.FinalX:=tmpN^.FinalX+w;
       end;}
      tmpN^.FinalY:=ip.y+(h div 2);
      Result.x:=MaxInt(p1.x,p3.x);
      Result.y:=MaxInt(p1.y,ny);
      tmpN^.BPNode.RightRegion:=MaxInt(p1.x,p3.x);
      tmpN^.BPNode.LeftRegion:=ip.x;
{      if ShiftRight then
        begin
          tmpN^.BPNode.RightRegion:=tmpN^.BPNode.RightRegion+w;
        end;}
      tmpN^.LevelID:=level;
  end;

procedure   TBPLSAGraph.PresetupFrame(widthcoof,heightcoof:Double); { Checked }
Var p:TPoint;
    node:PBPNode;
    link:PBPLink;
    gnode:PLSAGraphNode;
    glink:PLSAGraphLink;
    s:String;
    f:TextFile;
    i,j:Integer;
    sh:Integer;
    minx:Integer;
    p1:TPOint;
    tmpL:PLSAGRaphLink;
  begin
   FCalcWidthHeight:=True;
   CalcMaxWidthHeight;
   FCalcWidthHeight:=False;
  { FDiscardDrags:=True;}
   FRatioWC:=widthcoof;
   FRatioHC:=heightcoof;
   p.x:=0;
   p.y:=0;
   InitGNodes;
   InitGLinks;
   sh:=0;
   tmpL:=GetFirstInPoint;
   p1.y:=0;
   while tmpL<>nil do
    begin
      p.y:=0;
      p:=AnalizeLink(p,tmpL,1,sh,0,False);
      if p.y>p1.y then p1.y:=p.y;
      p1.x:=p.x;
      tmpL:=GetNextInPoint;
    end;
   P:=P1;
   if FGlobalShift3 then
   begin
   gnode:=FGraphNodes;
   minx:=$0FFFFFFF;
   for i:=0 to (FGNodesCount-1) do
     begin
       if gnode.FinalX<minx then minx:=gnode.FinalX;
       if gnode.BPNode.LeftRegion<minx then minx:=gnode.BPNode.LeftRegion;
       if gnode.BPNode.RightRegion<minx then minx:=gnode.BPNode.RightRegion;
       gnode:=gnode^.next;
     end;
   gnode:=FGraphNodes;
   if (minx<FGlobalLeftSize) then
    begin
     for i:=0 to (FGNodesCount-1) do
     begin
       gnode.FinalX:=gnode.FinalX+FGlobalLeftSize-minx;
       gnode.BPNode.LeftRegion:=gnode.BPNode.LeftRegion+FGlobalLeftSize-minx;
       gnode.BPNode.RightRegion:=gnode.BPNode.RightRegion+FGlobalLeftSize-minx;
       gnode:=gnode^.next;
     end;
    FADefWidth:=p.x+FGlobalLeftSize-minx;
    end;
    end
   else
    FADefWidth:=p.x;
    FADefHeight:=p.y;
   { New Code }
   { New Code }
   GetMaxNodesCount;
   if (FGNodesCount=0) then Exit;
   if FDebug then
   begin
   AssignFile(f,ExtractFilePath(Application.ExeName)+'lsa.log');
   Rewrite(f);
   for j:=0 to (FFillDiag-1) do
   begin
   Writeln(f,'CheckNodes:');
   for i:=0 to (FCheckGraph.NodesCount[j]-1) do
    begin
      node:=FCheckGraph.Nodes[i,j];
      writeln(f,'');
      writeln(f,'');
      s:=':'+node^.ssCaption;
      writeln(f,s);
      s:=':'+node^.ssNodeNumber;
      writeln(f,s);
      s:=' DWORD:'+IntToStr(node^.dwNodeNumber);
      writeln(f,s);
    end;
   writeln(f,'');
   writeln(f,'');
   writeln(f,'InPointLink');
   if j=0 then
    link:=GetFirstInPointEx
   else
    link:=GetNextInPointEx;
    begin
     s:=IntToStr(link^.dwFromNodeNumber);
     writeln(f,'FromNode: '+s);
     s:=IntToStr(link^.dwToNodeNumber);
     writeln(f,'ToNode: '+s);
     s:=IntToStr(link^.dwFromLinkNumber);
     writeln(f,'FromNumber: '+s);
     s:=IntToStr(link^.dwToLinkNumber);
     writeln(f,'ToNumber: '+s);
    end;
   writeln(f,'');
   writeln(f,'');
   writeln(f,'LinksArray');
   for i:=0 to (FCheckGraph.LinksCount[j]-1) do
    begin
     link:=FCheckGraph.Links[i,j];
     s:=IntToStr(i);
     writeln(f,'');
     writeln(f,'');
     writeln(f,'Link '+s);
     s:=IntToStr(link^.dwFromNodeNumber);
     writeln(f,'FromNode: '+s);
     s:=IntToStr(link^.dwToNodeNumber);
     writeln(f,'ToNode: '+s);
     s:=IntToStr(link^.dwFromLinkNumber);
     writeln(f,'FromNumber: '+s);
     s:=IntToStr(link^.dwToLinkNumber);
     writeln(f,'ToNumber: '+s);
    end;
   end; { FFillDiag }
   gnode:=FGraphNodes;
   while (gnode<>nil) do
    begin
      writeln(f,'');
      writeln(f,'');
      s:=':'+gnode^.BPNode.Caption;
      writeln(f,s);
      s:=':'+gnode^.BPNode.sNodeNumber;
      writeln(f,s);
      s:=' DWORD:'+IntToStr(gnode^.BPNode.NodeNumber);
      writeln(f,s);
      s:='FinalX:'+IntToStr(gnode^.FinalX);
      writeln(f,s);
      s:='FinalY:'+IntToStr(gnode^.FinalY);
      writeln(f,s);
      s:='LeftRegion:'+IntToStr(gnode^.BPNode.LeftRegion);
      writeln(f,s);
      s:='RightRegion:'+IntToStr(gnode^.BPNode.RightRegion);
      writeln(f,s);
      s:='OutputCount:'+IntToStr(gnode^.BPNode.OutputCount);
      writeln(f,'FMaxWidth='+IntToStr(FMaxWidth));
      writeln(f,'FMaxHeight='+IntToStr(FMaxHeight));
      gnode:=gnode^.next;
    end;
   writeln(f,'');
   writeln(f,'');
   writeln(f,'GInPointLink');
    glink:=GetFirstInPoint;
    begin
     s:=IntToStr(glink^.FromNodeNumber);
     writeln(f,'FromNode: '+s);
     s:=IntToStr(glink^.ToNodeNumber);
     writeln(f,'ToNode: '+s);
     s:=IntToStr(glink^.FromLinkNumber);
     writeln(f,'FromNumber: '+s);
     s:=IntToStr(glink^.ToLinkNumber);
     writeln(f,'ToNumber: '+s);
    end;
   writeln(f,'');
   writeln(f,'');
   writeln(f,'GLinksArray');
   glink:=FGraphLinks;
   i:=0;
    while (glink<>nil) do
     begin
       s:=IntToStr(i);
       writeln(f,'');
       writeln(f,'');
       writeln(f,'Link '+s);
       s:=IntToStr(glink^.FromNodeNumber);
       writeln(f,'FromNode: '+s);
       s:=IntToStr(glink^.ToNodeNumber);
       writeln(f,'ToNode: '+s);
       s:=IntToStr(glink^.FromLinkNumber);
       writeln(f,'FromNumber: '+s);
       s:=IntToStr(glink^.ToLinkNumber);
       writeln(f,'ToNumber: '+s);
       glink:=glink^.next;
       inc(i);
     end;
   CloseFile(f);
   end;
  end;

procedure   TBPLSAGraph.OpenLevel(wLevel,wDiag:Integer); { Checked }
 Var tmpTree:PBPTree;
     Flag:Boolean;
     fip:PLSAGraphLink;
  begin
     if (FTree=nil) then Exit;
     tmpTree:=FTree;
     Flag:=True;
     while (tmpTree<>nil) and (flag) do
      begin
       if (tmpTree^.dwLevel=wLevel) then
         begin
          FNodesCount:=tmpTree^.dwNodesCount;
          FLinksCount:=tmpTree^.dwLinksCount;
          FNodes:=tmpTree^.lpNodes;
          FLinks:=tmpTree^.lpLinks;
          FLevel:=tmpTree^.dwLevel;
          FSSLevel:=tmpTree^.ssLevel;
          Caption:=tmpTree^.ssCaption;
          FParentLevel:=tmpTree^.dwParent;
          FNodesFontSize:=tmpTree^.dwNodesFontSize;
          FDNodesFontSize:=tmpTree^.dwDNodesFontSize;
          FDProjectionFontSize:=tmpTree^.dwDProjectionFontSize;
          FInProcessFontSize:=tmpTree^.dwInProcessFontSize;
          FLabelsFontSize:=tmpTree^.dwLabelsFontSize;
          FOverrideNodesFS:=tmpTree^.dbOverrideNodesFS;
          FOverrideDNodesFS:=tmpTree^.dbOverrideDNodesFS;
          FOverrideInProcessFS:=tmpTree^.dbOverrideInProcessFS;
          FOverrideLabelsFS:=tmpTree^.dbOverrideLabelsFS;
          FCurDiag:=wDiag;
          Flag:=False;
         end;
       tmpTree:=tmpTree^.next;
      end;
    if (Flag) then
     begin
          FNodesCount:=FTree^.dwNodesCount;
          FLinksCount:=FTree^.dwLinksCount;
          FNodes:=FTree^.lpNodes;
          FLinks:=FTree^.lpLinks;
          FLevel:=FTree^.dwLevel;
          FSSLevel:=FTree^.ssLevel;
          FParentLevel:=FTree^.dwParent;
          Caption:=FTree^.ssCaption;
          FNodesFontSize:=FTree^.dwNodesFontSize;
          FDNodesFontSize:=FTree^.dwDNodesFontSize;
          FDProjectionFontSize:=FTree^.dwDProjectionFontSize;
          FInProcessFontSize:=FTree^.dwInProcessFontSize;
          FLabelsFontSize:=FTree^.dwLabelsFontSize;
          FOverrideNodesFS:=FTree^.dbOverrideNodesFS;
          FOverrideDNodesFS:=FTree^.dbOverrideDNodesFS;
          FOverrideInProcessFS:=FTree^.dbOverrideInProcessFS;
          FOverrideLabelsFS:=FTree^.dbOverrideLabelsFS;
          Flag:=False;
     end;
    FCurDiag:=wDiag;
    CreateCheckGraph;
    SetDefaultConstants;
    CreateGraphNodes(1,1);
    CreateGraphLinks(1,1);
    fip:=GetFirstInPoint;
    if FChangeTabVisible then
    if (fip<>nil) then BPViewMainForm.SetTabVisibleLFS(True)
    else BPViewMainForm.SetTabVisibleLFS(False);
    Scaled:=Scaled;
    if (not(FScaled)) then PresetupFrame(1,1);
{    TraceRoute;}
    if (BPViewMainForm.BPNavigator.Height>1) and
       (BPViewMainForm.PageControl1.ActivePage=BPViewMainForm.TabSheet3) then
      begin
       AnalizeStringsFonts;
       BPViewMainFOrm.BPGetBitmapTimer.Enabled:=True;
      end;
  end;


 procedure TBPLSAGraph.ClearModel;
 begin
   FTree:=nil;
   FNTTree:=nil;
   FLTTree:=nil;
   FOPTree:=nil;
   FIPNode:=nil;
   FHeader.dwNodesTypesCount:=0;
   FHeader.dwLinksTypesCount:=0;
   FHeader.dwOpEntries:=0;
   FHeader.dwIPEntries:=0;
 end;

 procedure TBPLSAGraph.AssignModel(Tree:PBPTree;NTTree:PBPNodeTypes;LTTree:PBPLinkTypes;
                                OPTree:PBPOpTree;Header:TBPHeader;IPNode:PBPInProcessNode);
 begin
   FTree:=Tree;
   FNTTree:=NTTree;
   FLTTree:=LTTree;
   FOPTree:=OPTree;
   FHeader:=Header;
   FIPNode:=IPNode;
   FRootEntries:=CalcPagesCount;
   FChangeTabVisible:=True;
   OpenLevel(-1,0);
   TraceRoute;
   FOwner.Invalidate;
 end;


  procedure  TBPLSAGraph.TraceRoute; { Main Tracing Procedure } { Checked }
  begin
    { Lets Trace graph }
    if (FCalcWidthHeight) then Exit;      { Disable Reenter to routine }
     TraceNodes;                           { Trace Nodes }
     TraceNodesToLinksCounters;             { Hm }
     CorrectLinksCounters;                  { New }
     TraceLinksToNodeCounters;              { Hm }
     TraceLocalStartEndPoints;              { OK }
     TraceGlobalStartEndPoints;             { OK }
     CalcLabelSizes;                        { Yes }
     TraceLinks;                           { Yes }
     DrawLinks;                            { Yes }
     FDiscardDrags:=False;
  end;

 constructor TBPLSAGraph.Create(AOwner: TComponent); { Checked }
  begin
    inherited Create(AOwner);
    FOwner:=AOwner as TBPLSAFrame;
    FRemoveSomeLinks:=True;
    FGlobalShift:=True;
    FGlobalShift2:=True;
    FGlobalShift3:=False;
    FGlobalShift4:=True;
    FNodes:=nil;
    FSpamNodes:=nil;
    FSpamNodesCount:=0;
    FLinks:=nil;
    FNodesCount:=0;
    FLinksCount:=0;
    FGNodesCount:=0;
    FGLinksCount:=0;
    FCurDiag:=0;
    FUseSpam:=True;
    FTranslateNodesType:=0;
    FGraphNodes:=nil;
    FGraphLinks:=nil;
    FLang:=RUSSIAN_CHARSET;
    FTree:=nil;
    FOpTree:=nil;     { CurrentWork ! }
    FLTTree:=nil;
    FNTTree:=nil;
    FIPNode:=nil;
    FLevel:=-1;
    FSSLevel:='-1';   { CurrentWork ! }
    FParentLevel:=-2; { Disabled }
    FHaspFound:=False;
    FillChar(FHeader,sizeof(FHeader),0);
    FMaxWidth:=0;
    FMaxHeight:=0;
    FRootEntries:=0;
    FGlobalLeftLinksCount:=0;
    FGlobalRightLinksCount:=0;
    FGlobalLeftSize:=80;
    FGlobalRightSize:=80;
    FGlobalTopSize:=80;
    FGlobalBottomSize:=80;
    FFontDPI:=96;
    FFontSize:=8;
    FLabelFontSize:=8;
    FMinLineStep:=StartMinLineStep;
    FNodeLineWidth:=1;
    FNodeDefWidth:=100;
    FNodeDefHeight:=100;
    FNodeHSpacing:=8;
    FNodeVSpacing:=8;
    FNodeShadowDepth:=4;
    FMinArcRadius:=StartMinArcRadius;
    FMinLabelX:=StartMinLabelX;
    FMinLabelY:=StartMinLabelY;
    FMinLabelY1:=StartMinLabelY1;
    FMinGlobalLabel:=StartMinGlobalLabel;
    FMinLineEndPoint:=StartMinLineEndPoint;
    FNodeWidth:=0;
    FNodeHeight:=0;
    FCalcWidthHeight:=False;
    FDebug:=False;
    FScaled:=False;
    FScreenFontName:='Times New Roman';
    FPrinterFontName:='Times New Roman';
    FFirstNodeNumber:=0;
    FLastNodeNumber:=0;
    FDiscardDrags:=False;
    FRatioWC:=1;
    FRatioHC:=1;
    FModified:=False;
    FLinksPosRelative:=True;
    FNodesCaptionVisible:=False;
    FJunctionCaptionVisible:=False;
    FScaled2Ratio:=100;
    FScaled2:=True;
    FReplaceNodes:=False;
    FReplaceLabels:=False;
    FMaxWordLength:=8;
    FMaxWordCount:=5;
    FMaxLabelLength:=32;
    FMaxFontSize:=DefMaxLabelFontSize;
    FRealMaxFontSize:=DefMaxLabelFontSize;
    Scaled:=True;
  end;

 destructor  TBPLSAGraph.Destroy;  { Checked }
  begin
    if (FSpamNodes<>nil) then ClearSpamNodes;
    if (FGraphNodes<>nil) then ClearGraphNodes;
    if (FGraphLinks<>nil) then ClearGraphLinks;
    if (FTree<>nil) then FTree:=nil;
    if (FNTTree<>nil) then FNTTree:=nil;
    if (FLTTree<>nil) then FLTTree:=nil;
    if (FOPTree<>nil) then FOPTree:=nil; { CurrentWork ! }
    if (FIPNode<>nil) then FIPNode:=nil;
    inherited Destroy;
  end;

procedure TBPLSAGraph.SetDiscardDrags(Value:Boolean); { Checked }
var i:Integer;
    nodePtr:PBPNode;
    linkPtr:PBPLink;
 begin
  { Disable all drags in context diagram }
   FDiscardDrags:=True;
   FOwner.Repaint;
   if FNodesCount=0 then Exit;
   nodePtr:=FNodes;
   for i:=0 to (FNodesCount-1) do
     begin
       nodePtr^.AcceptPosition[2]:=False;
       FModified:=True;
       inc(nodePtr);
     end;
   if FLinksCount=0 then Exit;
   linkPtr:=FLinks;
   for i:=0 to (FLinksCount-1) do
     begin
       LinkPtr^.FromAcceptPosition[2]:=False;
       linkPtr^.ToAcceptPosition[2]:=False;
       FModified:=True;
       inc(linkPtr);
     end;
 end;

procedure TBPLSAGraph.SetDefWidth(Value:Integer);  { Checked }
 begin
  FDefWidth:=Value;
 end;

procedure TBPLSAGraph.SetDefHeight(Value:Integer);  { Checked }
 begin
  FDefHeight:=Value;
 end;

procedure TBPLSAGraph.SetScaled2(Value:Boolean);
  begin
   {}
    FScaled2:=Value;
  end;

procedure TBPLSAGraph.SetScaled2Ratio(Value:Extended);
 Var posx,posy:Double;
  begin
   {}
{!} posx:=FScaled2Ratio;
{!} posy:=FScaled2Ratio;
{!} if (FOwner.HorzScrollBar.Range>0) and
       (FOwner.HorzScrollBar.Visible) then
     posx:=Value/(posx+0.01)*FOwner.HorzScrollBar.Position
    else
     posx:=0;
{!} if (FOwner.VertScrollBar.Range>0) and
       (FOwner.VertScrollBar.Visible) then
     posy:=Value/(posy+0.01)*FOwner.VertScrollBar.Position
    else
     posy:=0;
    FScaled2Ratio:=Value;
    FOwner.Visible:=False;
    Scaled:=Scaled;
    FOwner.Invalidate;
{!} if (FOwner.HorzScrollBar.Range>0) then
        FOwner.HorzScrollBar.Position:=Round(posx);
{!} if (FOwner.VertScrollBar.Range>0) then
        FOwner.VertScrollBar.Position:=Round(posy);
    FOwner.Visible:=True;
  end;

procedure TBPLSAGraph.UpdateMaxFontSize(Coof:Extended);
Var hca3:Extended;
    aSize:Integer;
    tmpi:TQRPaperSize;
 begin
  { Update & calc real max font size }
  hca3:=1.0;
  if MainUnit.HasPrnDevice then
   begin
    aSize:=Printer.PaperSize;
    for tmpi:= Default to Custom do
      begin
       if aSize=cQRPaperTranslate[tmpI] then
        begin
         hca3:=cQRPaperSizeMetrics[tmpI,0]/cQRPaperSizeMetrics[A3,0];
        end;
      end;
   end;
  if FScaled then
    begin
      if FScaled2 then
       begin { if FScaled2 }
        FRealMaxFontSize:=Round(FMaxFontSize*hca3*FScaled2Ratio/100.0);
       end
      else
       begin
        FRealMaxFontSize:=Round(FMaxFontSize/coof*hca3);
       end;
    end
   else
    begin
      FRealMaxFontSize:=Round(FMaxFontSize*FOwner.FFontCoof*hca3);
    end;
 end;


 procedure TBPLSAGraph.SetScaled(Value:Boolean);  { Checked }
Var r1,r2,ratio,fontRatio,labelFontRatio:Double;
    nw,nh,mw,mh:Integer;
    rw,rh:Double;
    dc:HDC;
    ws2,hs2:Extended;
    pgAlg:TBPPgAlg;
    {New}
    wca3,hca3:Extended;
    aSize:Integer;
    tmpi:TQRPaperSize;
 begin
   FScaled:=Value;
   if FTree=nil then Exit;
   if FScaled then
    begin
    if FOwner.VertScrollBar.Visible then FOwner.VertScrollBar.Position:=0;
    if FOwner.HorzScrollBar.Visible then FOwner.HorzScrollBar.Position:=0;
    Repaint;
    SetDefaultConstants;
    Printing:=False;
    SetDefaultConstants;
    CreateGraphNodes(1,1); { read x,y,acceptposition }
    CreateGraphLinks(1,1); { read x,y,acceptposition }
    PresetupFrame(1,1); { Scale x,y to widthcoof,heightcoof }
    TraceRoute;
    if FMaxNodesCount>FOwner.FNodesValue[0] then
     begin
       if FMaxNodesCount>FOwner.FNodesValue[1] then
         pgAlg:=pg_Max
       else
         pgAlg:=pg_Middle;
     end
    else pgAlg:=pg_Min;
    FOwner.Invalidate;
   end;
   if FScaled2 then
    begin { if FScaled2 }
      wca3:=1.0;
      hca3:=1.0;
      if MainUnit.HasPrnDevice then
      begin
       aSize:=Printer.PaperSize;
       for tmpi:= Default to Custom do
        begin
         if aSize=cQRPaperTranslate[tmpI] then
           begin
            hca3:=cQRPaperSizeMetrics[tmpI,0]/cQRPaperSizeMetrics[A3,0];
            wca3:=cQRPaperSizeMetrics[tmpI,1]/cQRPaperSizeMetrics[A3,1];
           end;
        end;
       end;
      dc:=GetDC(0);
      ws2:=GetDeviceCaps(dc,LOGPIXELSX)*A3Width*hca3*FScaled2Ratio/100.0;
      hs2:=GetDeviceCaps(dc,LOGPIXELSY)*A3Height*wca3*FScaled2Ratio/100.0;
      UpdateMaxFontSize(1);
      ReleaseDC(0,dc);
      if (FOwner.HorzScrollBar.Range>0) and
         (FOwner.HorzScrollBar.Visible) then
       begin
        FOwner.HorzScrollBar.Position:=0;
        r1:=ws2/(FOwner.HorzScrollBar.Range);
       end
      else r1:=ws2/FOwner.ClientWidth;
      if (FOwner.VertScrollBar.Visible) and
         (FOwner.VertScrollBar.Range>0) then
       begin
         FOwner.VertScrollBar.Position:=0;
         r2:=hs2/(FOwner.VertScrollBar.Range);
       end
      else r2:=hs2/FOwner.ClientHeight;
    end { if FScaled2 }
   else
   begin { if not FScaled2 }
   if FOwner.HorzScrollBar.Visible then
    begin
     FOwner.HorzScrollBar.Position:=0;
     r1:=FOwner.ClientWidth/(FOwner.HorzScrollBar.Range+1);
    end
   else r1:=1;
   if FOwner.VertScrollBar.Visible then
    begin
     FOwner.VertScrollBar.Position:=0;
     r2:=FOwner.ClientHeight/(FOwner.VertScrollBar.Range+1);
    end
   else r2:=1;
   UpdateMaxFontSize(r2);
   end; { if not FScaled2 }
   if FScaled then
    begin
     case pgAlg of
      pg_Min:     ratio:=FOwner.GetCoof(r1,r2,FOwner.FFormatAlg[0]);
      pg_Middle:  ratio:=FOwner.GetCoof(r1,r2,FOwner.FFormatAlg[1]);
      pg_Max:     ratio:=FOwner.GetCoof(r1,r2,FOwner.FFormatAlg[2]);
     end;
     SetDefaultConstants;
     SetScaledConstants(r1,r2,ratio,ratio,ratio);
     if FScaled2 then
      begin
       DefWidth:=Round(ws2);
       DefHeight:=Round(hs2);
      end
     else
      begin
       DefWidth:=FOwner.ClientWidth;
       DefHeight:=FOwner.ClientHeight;
      end;
     Printing:=True;
     CreateGraphNodes(r1,r2); { read x,y,acceptposition }
     CreateGraphLinks(r1,r2); { read x,y,acceptposition }
     PresetupFrame(r1,r2); { Scale x,y to widthcoof,heightcoof }
     TraceRoute;
     FOwner.Invalidate;
     while FOwner.FPainting do;
     nw:=NodeWidth;
     nh:=NodeHeight;
     mw:=MaxWidth;
     mh:=MaxHeight;
     rw:=ratio*nw/(mw+1);
     rh:=ratio*nh/(mh+1);
     case pgAlg of
       pg_Min:    fontRatio:=FOwner.GetCoof(rw,rh,FOwner.FFormatAlg[0]);
       pg_Middle: fontRatio:=FOwner.GetCoof(rw,rh,FOwner.FFormatAlg[1]);
       pg_Max:    fontRatio:=FOwner.GetCoof(rw,rh,FOwner.FFormatAlg[2]);
     end;
{     if fontRatio>ratio then fontRatio:=ratio;}
     LabelFontRatio:=fontRatio*FMaxCH;
     FOwner.Canvas.FillRect(FOwner.Canvas.ClipRect);
     if FScaled2 then
      begin
       DefWidth:=Round(ws2);
       DefHeight:=Round(hs2);
      end
     else
      begin
       DefWidth:=FOwner.ClientWidth;
       DefHeight:=FOwner.ClientHeight;
      end;
     SetDefaultConstants;
     SetScaledConstants(r1,r2,ratio,fontRatio,labelFontRatio);
     CreateGraphNodes(r1,r2); { read x,y,acceptposition }
     CreateGraphLinks(r1,r2); { read x,y,acceptposition }
     PresetupFrame(r1,r2);   { Scale x,y to widthcoof,heightcoof }
     TraceRoute;
     FOwner.Invalidate;
    end
   else
    begin
     UpdateMaxFontSize(1);
     SetDefaultConstants;
     Printing:=False;
     SetDefaultConstants;
     CreateGraphNodes(1,1); { read x,y,acceptposition }
     CreateGraphLinks(1,1); { read x,y,acceptposition }
     PresetupFrame(1,1); { Scale x,y to widthcoof,heightcoof }
     TraceRoute;
     FOwner.Invalidate;
    end;
 end;

 procedure  TBPLSAGraph.SetDefaultConstants; { Checked }
 Var dc:HDC;
  begin
   FDoOverrideFS:=False;
   dc:=GetDC(FOwner.Handle);
   FFontDPI:=96;{GetDeviceCaps(dc,LOGPIXELSX);}
   ReleaseDC(FOwner.Handle,dc);
   FFontSize:=8;
   FLabelFontSize:=8;
   FMinLineStep:=StartMinLineStep;
   FNodeLineWidth:=1;
   FNodeDefWidth:=100;
   FNodeDefHeight:=100;
   FNodeHSpacing:=1;
   FNodeVSpacing:=1;
   FGlobalLeftSize:=10;
   FGlobalRightSize:=10;
   FGlobalTopSize:=35;
   FGlobalBottomSize:=35;
   FMinArcRadius:=StartMinArcRadius;
   FMinLabelX:=StartMinLabelX;
   FMinLabelY:=StartMinLabelY;
   FMinLabelY1:=StartMinLabelY1;
   FMinGlobalLabel:=StartMinGlobalLabel;
   FNodeShadowDepth:=4;
   FMinLineEndPoint:=StartMinLineEndPoint;
  end;

 procedure  TBPLSAGraph.SetScaledConstants(ratiox,ratioy,ratio:Double;fontSizeRatio:Double;LabelFontSizeRatio:Double); { Checked }

  function GetMinLabelY1(Value:Integer):Integer;
 Var  dc:HDC;
     ppi:Integer;
  begin
    Result:=Value;
    if not(FDoOverrideFS and FOverrideLabelsFS) then Exit;
    dc:=GetDC(0);
    ppi:=GetDeviceCaps(dc,LOGPIXELSY);
    ReleaseDC(0,dc);
    if FOwner.FPreviewOrPrint then
      Result:=Round(1.2*FLabelsFontSize*ppi*FOwner.FFOntCoof/72)
    else
      Result:=Round(1.2*FLabelsFontSize*ppi*FScaled2Ratio/100/72);
  end;

  begin
   FDoOverrideFS:=True;
   FFontDPI:=Round(FFontDPI*ratio);
   FFontSize:=Round(FFontSize*fontSizeRatio);
   if FFontSize=0 then FFontSize:=1;
   FLabelFontSize:=Round(FLabelFontSize*LabelfontSizeRatio);
   if FLabelFontSize=0 then FLabelFontSize:=1;
   if FLabelFontSize>FRealMaxFontSize then FLabelFontSize:=FRealMaxFontSize;
   if FFontSize>FRealMaxFontSize then FFontSize:=FRealMaxFontSize;
{   FMinLineStep:=(FNodeWidth div 4) div StartMaxLines;}
   FMinLineStep:=FNodeWidth div 8;
   FNodeLineWidth:=Round(FNodeLineWidth*ratio);
   if FNodeLineWidth=0 then FNodeLineWidth:=1;
   FNodeDefWidth:=Round(FNodeDefWidth*ratiox);
   FNodeDefHeight:=Round(FNodeDefHeight*ratioy);
   FNodeHSpacing:=Round(FNodeHSpacing*ratiox);
   FNodeVSpacing:=Round(FNodeVSpacing*ratioy);
   FGlobalLeftSize:=Round(FGlobalLeftSize*ratiox);
   FGlobalRightSize:=Round(FGlobalRightSize*ratiox);
   FGlobalTopSize:=Round(FGlobalTopSize*ratioy);
   FGlobalBottomSize:=Round(FGlobalBottomSize*ratioy);
   FMinArcRadius:=Round(FMinArcRadius*ratio);
   FMinLabelX:=Round(FMinLabelX*ratiox);
   FMinLabelY:=Round(FMinLabelY*ratioy);
   FMinLabelY1:=Round(FMinLabelY1*fontSizeRatio);
   FMinLabelY1:=GetMinLabelY1(FMinLabelY1);
   FMinGlobalLabel:=Round(FMinGlobalLabel*ratio);
   FNodeShadowDepth:=Round(FNodeShadowDepth*ratio);
   if FNodeShadowDepth=0 then FNodeShadowDepth:=1;
   FMinLineEndPoint:=Round(FMinLineEndPoint*ratio);
  end;

 procedure  TBPLSAGraph.SetFontSize(Value:Integer);  { Checked }
  begin
   if Value=FFontSize then Exit;
   FFontSize:=Value;
   CreateGraphNodes(FRatioWC,FRatioHC);
   CreateGraphLinks(FRatioWC,FRatioHC);
  end;

 procedure  TBPLSAGraph.CalcLabelSizes; { Checked }
  Var gnode:TBPLSAGraphNode;
      i,j:Integer;
      maxlch:Integer;
      FSize:Integer;
      linkP:PLSAGraphLink;
  begin
   if (FTree=nil) then Exit;
   if (FGLinksCount=0) then Exit;
   if (FGNodesCount=0) then Exit;
   maxlch:=0;
   for i:=0 to (FGNodesCount-1) do
    begin
     gnode:=GetGraphNode(i);
     if (gnode<>nil) then
      begin
        if (maxlch<gnode.LeftLinksCount) then maxlch:=gnode.LeftLinksCount;
        if (maxlch<gnode.RightLinksCount) then maxlch:=gnode.RightLinksCount;
      end;
    end;
    if (maxlch<8) then
     begin
      FMaxCH:=1.0;
      FSize:=FLabelFontSize;
     end
    else
     begin
      FMaxCH:=8/maxlch;
      FSize:=Round(FLabelFontSize*8/maxlch)+1;
     end;
    if FPrinting then Exit;
    if FScaled then Exit;
    for j:=0 to (FGLinksCount-1) do
        begin
         linkP:=GetGraphLink(j);
          if linkP<>nil then
            begin
              if (((linkP^.dwFlags and BP_SHOW_FROMCAPTION)<>0) and
                  linkP^.Visible) then
               begin
                 linkP^.BPFromLabel.Font.Size:=FSize;
               end;
              if (((linkP^.dwFlags and BP_SHOW_TOCAPTION)<>0) and
                  linkP^.Visible) then
               begin
                 linkP^.BPToLabel.Font.Size:=FSize;
               end;
            end;
        end;
  end;

procedure  TBPLSAGraph.DrawSS(sx,sy,dx,dy:Integer;color:TColor); { Checked }
  Var oldColor:TColor;
      hw:Integer;
      x1,y1,x2,y2:Integer;
      zx,zy:Integer;
      f1,f2:Double;
      normaz:Integer;
      sizex,sizey:Integer;
  begin
   { Draws SS link from point to caption }
    with FOwner.Canvas do
     begin
       oldColor:=Pen.Color;
       Pen.Color:=color;
       zx:=(dx-sx) div 2;
       zy:=(dy-sy) div 2;
       normaz:=Round(Sqrt(zx*zx+zy*zy));
       f1:=3.14/2;
       f2:=-3.14/2;
       sizex:=MinLabelX div 4;
       sizey:=sizex;
       if (normaz=0) then normaz:=1;
       if (sizex=0) then sizex:=1;
       if (sizey=0) then sizey:=1;
       x1:=Round((cos(f1)*zx+sin(f1)*zy)/normaz*sizex)+sx+zx;
       y1:=Round((cos(f1)*zy-sin(f1)*zx)/normaz*sizey)+sy+zy;
       x2:=Round((cos(f2)*zx+sin(f2)*zy)/normaz*sizex)+sx+zx;
       y2:=Round((cos(f2)*zy-sin(f2)*zx)/normaz*sizey)+sy+zy;
       MoveTo(sx,sy);
       LineTo(x1,y1);
       LineTo(x2,y2);
       LineTo(dx,dy);
       Pen.Color:=oldColor;
     end;
  end;

 function   TBPLSAGraph.GetGraphNodeRec(index:DWORD):PLSAGraphNode;
 Var tmpN:PLSAGraphNode;
     i:DWORD;
  begin
   Result:=nil;
   if FGraphNodes=nil then Exit;
   if (index>=FGNodesCount) then Exit;
   tmpN:=FGraphNodes;
   for i:=0 to index do
    begin
      Result:=tmpN;
      tmpN:=tmpN^.Next;
    end;
  end;

 function   TBPLSAGraph.GetGraphNode(index:DWORD):TBPLSAGraphNode; { Checked }
 Var tmpN:PLSAGraphNode;
     i:DWORD;
  begin
   Result:=nil;
   if FGraphNodes=nil then Exit;
   if (index>=FGNodesCount) then Exit;
   tmpN:=FGraphNodes;
   for i:=0 to index do
    begin
      Result:=tmpN^.BPNode;
      tmpN:=tmpN^.Next;
    end;
  end;

 function   TBPLSAGraph.GetGraphNumberedNode(NodeNumber:DWORD):PLSAGraphNode; { Checked }
 Var tmpN:PLSAGraphNode;
  begin
   Result:=nil;
   if FGraphNodes=nil then Exit;
   tmpN:=FGraphNodes;
   while ((tmpN<>nil) and (tmpN^.BPNode.NodeNumber<>NodeNumber)) do
    begin
      tmpN:=tmpN^.Next;
    end;
   if (tmpN<>nil) then Result:=tmpN;
  end;

function   TBPLSAGraph.GetGraphLink(index:DWORD):PLSAGraphLink; { Checked }
 Var tmpN:PLSAGraphLink;
     i:DWORD;
  begin
   Result:=nil;
   if FGraphLinks=nil then Exit;
   if (index>=FGLinksCount) then Exit;
   tmpN:=FGraphLinks;
   for i:=0 to index do
    begin
      Result:=tmpN;
      tmpN:=tmpN^.Next;
    end;
  end;

procedure  TBPLSAGraph.CalcMaxWidthHeight;  { Checked }
 Var nodeP:PLSAGraphNode;
     i:Integer;
  begin
   if FGNodesCount=0 then Exit;
   FMaxWidth:=0;
   FMaxHeight:=0;
   nodeP:=FGraphNodes;
    for i:=0 to (FGNodesCount-1) do
     begin
       nodeP^.BPNode.AutoHeight:=True;
       nodeP^.BPNode.AutoWidth:=True;
       nodeP^.BPNode.Repaint;
       if nodeP^.BPNode.MaxWidth>FMaxWidth then
               FMaxWidth:=nodeP^.BPNode.MaxWidth;
       if nodeP^.BPNode.MaxHeight>FMaxHeight then
               FMaxHeight:=nodeP^.BPNode.MaxHeight;
       nodeP^.BPNode.AutoHeight:=False;
       nodeP^.BPNode.AutoWidth:=False;
       nodeP^.BPNode.Repaint;
       nodeP:=nodeP^.next;
     end;
  end;


 procedure  TBPLSAGraph.CreateGraphLinks(wc,hc:Double); { Checked }
 Var linkP:PBPLink;
     linkG:PLSAGraphLink;
     curLinkG,tmpLinkG:PLSAGraphLink;
     i,j:Integer;
     tmp:TBPLinkTypes;
     tnnd,fnnd:Boolean;
     fnip,tnip:Boolean;
     fngm,tngm:Boolean;
     linkVisible:Boolean;
     lfl:String;
     ltl:String;
     sfc:Boolean;
     stc:Boolean;
     caseOp,caseOp1,caseOp2:Boolean;
     lc:String;
     spamLinkTop:Boolean;
     spamLinkBottom:Boolean;
     s:String;


procedure SetShowFromToCaption(var Flags:DWORD;showFrom,showTo:Boolean);
 begin
   if not(showFrom) then
     Flags:=Flags and BP_DONTSHOW_FROMCAPTION;
   if not(showTo) then
     Flags:=Flags and BP_DONTSHOW_TOCAPTION;
 end;

  begin
   if (FGraphLinks<>nil) then ClearGraphLinks;
   if (FLinks=nil) then Exit;
   linkP:=FLinks;
   FGLinksCount:=0;
   curLinkG:=nil;
   for i:=0 to (FLinksCount-1) do
    begin
      tmp:=GetLTFromIndex(linkP^.dwLinkIndex);
      fnnd:=((linkp^.dwFromNodeNumber and BPGlobalNodeOperation)<>0);
      tnnd:=((linkp^.dwToNodeNumber and BPGlobalNodeOperation)<>0);
      fnip:=((linkp^.dwFromNodeNumber and BPGlobalNodeInProcess)<>0);
      tnip:=((linkp^.dwToNodeNumber and BPGlobalNodeInProcess)<>0);
      fngm:=((linkp^.dwFromNodeNumber and BPGlobalMask)<>0);
      tngm:=((linkp^.dwToNodeNumber and BPGlobalMask)<>0);
      lc:='';
      if fnip then lc:=GetLinkCaption(linkp^.dwFromNodeNumber and BPNotGlobalMask);
      if tnip then lc:=GetLinkCaption(linkp^.dwToNodeNumber and BPNotGlobalMask);
      linkVisible:=((not(fnnd or tnnd)));
      linkVisible:={linkVisible and }IsLinkVisibleEx(linkP);
      linkVisible:=linkVisible and tmp.dbShowLinkType;
      spamLinkTop:=linkVisible and
                   ((linkP^.dwFlags and BP_FROMTOMASK)=BP_RIGHT_TOP);
      spamLinkBottom:=linkVisible and
                   ((linkP^.dwFlags and BP_FROMTOMASK)=BP_RIGHT_BOTTOM);
      if linkVisible then
      begin
      if (curLinkG=nil) then
          begin
            curLinkG:=PLSAGraphLink(AllocMem(sizeof(TLSAGraphLink)));
            curLinkG^.llLink:=linkP;
            lfl:=GetLinkLabel(linkP^.ssFromCaption,CaseOp1);
            ltl:=GetLinkLabel(linkP^.ssToCaption,CaseOp2);
            if CaseOp1 and fngm then lfl:='';
            if CaseOp2 and tngm then ltl:='';
            caseOp1:=CaseOp1 and (not(fngm));
            caseOp2:=CaseOp2 and (not(tngm));
            caseOp:=CaseOp1 or CaseOp2;
            stc:=False;
            sfc:=False;
            if (((linkP^.dwFlags and BP_SHOW_FROMCAPTION)<>0) and linkVisible and (length(lfl)>0)) then
            begin
            sfc:=True;
            curLinkG^.BPFromLabel:=TBPLabel.Create(Parent);
            curLinkG^.BPFromLabel.Parent:=Parent as TWinControl;
            if (length(lc)>0) and fnip then
            curLinkG^.BPFromLabel.Caption:=MyUtils.MyReplaceLabelCaption(lc+': '+lfl,FMaxLabelLength,FReplaceLabels)
            else
            curLinkG^.BPFromLabel.Caption:=MyUtils.MyReplaceLabelCaption(lfl,FMaxLabelLength,FReplaceLabels){linkP^.ssFromCaption};
            curLinkG^.BPFromLabel.ParentFont:=False;
            curLinkG^.BPFromLabel.Hint:=lfl{linkP^.ssFromCaption};
            curLinkG^.BPFromLabel.ShowHint:=True;
            curLinkG^.BPFromLabel.Path:=linkP^.ssFromPath;
            curLinkG^.BPFromLabel.Font.Name:=FPrinterFontName;
            if FDoOverrideFS and FOverrideLabelsFS then
             if FOwner.FPreviewOrPrint then
              curLinkG^.BPFromLabel.Font.Size:=Round(FLabelsFontSize*FOwner.FFOntCoof)
             else
              curLinkG^.BPFromLabel.Font.Size:=Round(FLabelsFontSize*FScaled2Ratio/100)
            else
            curLinkG^.BPFromLabel.Font.Size:=FLabelFontSize;
            curLinkG^.BPFromLabel.Font.Color:=tmp.dwColor;
            curLinkG^.BPFromLabel.Font.Charset:=FLang;
            curLinkG^.BPFromLabel.SetFontDPI(FFontDPI);
            curLinkG^.BPFromLabel.Transparent:=True;
            curLinkG^.BPFromLabel.AutoSize:=True;
            curLinkG^.BPFromLabel.Color:=clWhite;
            curLinkG^.BPFromLabel.WordWrap:=False;
            curLinkG^.BPFromLabel.AcceptPosition:=False;
            curLinkG^.BPFromLabel.Top:=Round(linkP^.FromTop[2]*hc);
            curLinkG^.BPFromLabel.Left:=Round(linkP^.FromLeft[2]*wc);
            curLinkG^.BPFromLabel.AcceptPosition:=linkP^.FromAcceptPosition[2];
            curLinkG^.BPFromLabel.DragMode:=dmManual;
            curLinkG^.BPFromLabel.Cursor:=crHandPoint;
            curLinkG^.BPFromLabel.OnMouseDown:=MyLabelMouseDown;
            curLinkG^.BPFromLabel.PopupMenu:=BPViewMainForm.LSALinksPopupMenu;
            curLinkG^.BPFromLabel.SendToBack;
            end
             else
            curLinkG^.BPFromLabel:=nil;
            if (((linkP^.dwFlags and BP_SHOW_TOCAPTION)<>0) and linkVisible and (length(ltl)>0)) then
            begin
            stc:=True;
            curLinkG^.BPToLabel:=TBPLabel.Create(Parent);
            curLinkG^.BPToLabel.Parent:=Parent as TWinControl;
            if (length(lc)>0) and tnip then
             curLinkG^.BPToLabel.Caption:=MyUtils.MyReplaceLabelCaption(ltl+': '+lc,FMaxLabelLength,FReplaceLabels)
            else
            curLinkG^.BPToLabel.Caption:=MyUtils.MyReplaceLabelCaption(ltl,FMaxLabelLength,FReplaceLabels){linkP^.ssToCaption};
            curLinkG^.BPToLabel.ParentFont:=False;
            curLinkG^.BPToLabel.Hint:=ltl{linkP^.ssToCaption};
            curLinkG^.BPToLabel.ShowHint:=True;
            curLinkG^.BPToLabel.Path:=linkP^.ssToPath;
            curLinkG^.BPToLabel.Font.Name:=FPrinterFontName;
            if FDoOverrideFS and FOverrideLabelsFS then
             if FOwner.FPreviewOrPrint then
              curLinkG^.BPToLabel.Font.Size:=Round(FLabelsFontSize*FOwner.FFOntCoof)
             else
              curLinkG^.BPToLabel.Font.Size:=Round(FLabelsFontSize*FScaled2Ratio/100)
            else
            curLinkG^.BPToLabel.Font.Size:=FLabelFontSize;
            curLinkG^.BPToLabel.Font.Color:=tmp.dwColor;
            curLinkG^.BPToLabel.Font.Charset:=FLang;
            curLinkG^.BPToLabel.SetFontDPI(FFontDPI);
            curLinkG^.BPToLabel.Transparent:=True;
            curLinkG^.BPToLabel.AutoSize:=True;
            curLinkG^.BPToLabel.Color:=clWhite;
            curLinkG^.BPToLabel.WordWrap:=False;
            curLinkG^.BPToLabel.AcceptPosition:=False;
            curLinkG^.BPToLabel.Top:=Round(linkP^.ToTop[2]*hc);
            curLinkG^.BPToLabel.Left:=Round(linkP^.ToLeft[2]*wc);
            curLinkG^.BPToLabel.AcceptPosition:=linkP^.ToAcceptPosition[2];
            curLinkG^.BPToLabel.DragMode:=dmManual;
            curLinkG^.BPToLabel.Cursor:=crHandPoint;
            curLinkG^.BPToLabel.OnMouseDown:=MyLabelMouseDown;
            curLinkG^.BPToLabel.PopupMenu:=BPViewMainForm.LSALinksPopupMenu;
            curLinkG^.BPToLabel.SendToBack;
            end
             else
            curLinkG^.BPToLabel:=nil;
            curLinkG^.FromNodeNumber:=linkP^.dwFromNodeNumber;
            curLinkG^.ToNodeNumber:=linkP^.dwToNodeNumber;
            if ((spamLinkTop or spamLinkBottom) and FUseSpam) then
              curLinkG^.dwFlags:=(linkP^.dwFlags and BP_TOMASK_INVERT) or BP_TONODE_LEFT
            else
              curLinkG^.dwFlags:=linkP^.dwFlags;
            SetShowFromToCaption(curLinkG^.dwFlags,sfc,stc);
            curLinkG^.FromLinkNumber:=linkP^.dwFromLinkNumber;
            if ((spamLinkTop or spamLinkBottom) and FUseSpam) then
             curLinkG^.ToLinkNumber:=GetSpamToLinkNumber(linkP,spamLinkTop,spamLinkBottom)
            else
             curLinkG^.ToLinkNumber:=linkP^.dwToLinkNumber;
            curLinkG^.StartPoint.x:=0;
            curLinkG^.StartPoint.y:=0;
            curLinkG^.EndPoint.x:=0;
            curLinkG^.EndPoint.y:=0;
            curLinkG^.LinkFromCount:=0;
            curLinkG^.LinkToCount:=0;
            curLinkG^.MinimalXFrom:=0;
            curLinkG^.MinimalXTo:=0;
            curLinkG^.MinimalYFrom:=0;
            curLinkG^.MinimalYTo:=0;
            FillChar(curLinkG^.LineArrayX,sizeof(curLinkG^.LineArrayX),0);
            FillChar(curLinkG^.LineArrayY,sizeof(curLinkG^.LineArrayY),0);
            curLinkG^.LinePointCount:=0;
            curLinkG^.Color:=tmp.dwColor;
            curLinkG^.PenStyle:=tmp.dwPenStyle;
            curLinkG^.Visible:=linkVisible;
            curLinkG^.IsCaseOp:=CaseOp;
            curLinkG^.next:=nil;
            FGraphLinks:=curLinkG;
            Inc(FGLinksCount);
          end
       else
          begin
            linkG:=PLSAGraphLink(AllocMem(sizeof(TLSAGraphLink)));
            linkG^.llLink:=linkP;
            lfl:=GetLinkLabel(linkP^.ssFromCaption,CaseOp1);
            ltl:=GetLinkLabel(linkP^.ssToCaption,CaseOp2);
            if CaseOp1 and fngm then lfl:='';
            if CaseOp2 and tngm then ltl:='';
            caseOp1:=CaseOp1 and (not(fngm));
            caseOp2:=CaseOp2 and (not(tngm));
            caseOp:=caseOp1 or caseOp2;
            stc:=False;
            sfc:=False;
            if (((linkP^.dwFlags and BP_SHOW_FROMCAPTION)<>0) and linkVisible and (length(lfl)>0)) then
            begin
            sfc:=True;
            LinkG^.BPFromLabel:=TBPLabel.Create(Parent);
            LinkG^.BPFromLabel.Parent:=Parent as TWinControl;
            if (length(lc)>0) and fnip then
            LinkG^.BPFromLabel.Caption:=MyUtils.MyReplaceLabelCaption(lc+': '+lfl,FMaxLabelLength,FReplaceLabels)
            else
            LinkG^.BPFromLabel.Caption:=MyUtils.MyReplaceLabelCaption(lfl,FMaxLabelLength,FReplaceLabels){linkP^.ssFromCaption};
            LinkG^.BPFromLabel.ParentFont:=False;
            LinkG^.BPFromLabel.Hint:=lfl{linkP^.ssFromCaption};
            LinkG^.BPFromLabel.ShowHint:=True;
            LinkG^.BPFromLabel.Path:=linkP^.ssFromPath;
            LinkG^.BPFromLabel.Font.Name:=FPrinterFontName;
            if FDoOverrideFS and FOverrideLabelsFS then
             if FOwner.FPreviewOrPrint then
              LinkG^.BPFromLabel.Font.Size:=Round(FLabelsFontSize*FOwner.FFOntCoof)
             else
              LinkG^.BPFromLabel.Font.Size:=Round(FLabelsFontSize*FScaled2Ratio/100)
            else
            LinkG^.BPFromLabel.Font.Size:=FLabelFontSize;
            LinkG^.BPFromLabel.Font.Color:=tmp.dwColor;
            LinkG^.BPFromLabel.Font.Charset:=FLang;
            LinkG^.BPFromLabel.SetFontDPI(FFontDPI);
            LinkG^.BPFromLabel.Transparent:=True;
            LinkG^.BPFromLabel.AutoSize:=True;
            LinkG^.BPFromLabel.Color:=clWhite;
            LinkG^.BPFromLabel.WordWrap:=False;
            LinkG^.BPFromLabel.AcceptPosition:=False;
            LinkG^.BPFromLabel.Top:=Round(linkP^.FromTop[2]*hc);
            LinkG^.BPFromLabel.Left:=Round(linkP^.FromLeft[2]*wc);
            LinkG^.BPFromLabel.AcceptPosition:=linkP^.FromAcceptPosition[2];
            LinkG^.BPFromLabel.DragMode:=dmManual;
            LinkG^.BPFromLabel.Cursor:=crHandPoint;
            LinkG^.BPFromLabel.OnMouseDown:=MyLabelMouseDown;
            LinkG^.BPFromLabel.PopupMenu:=BPViewMainForm.LSALinksPopupMenu;
            LinkG^.BPFromLabel.SendToBack;
            end
             else
            LinkG^.BPFromLabel:=nil;
            if (((linkP^.dwFlags and BP_SHOW_TOCAPTION)<>0) and LinkVisible and (length(ltl)>0)) then
            begin
            stc:=True;
            LinkG^.BPToLabel:=TBPLabel.Create(Parent);
            LinkG^.BPToLabel.Parent:=Parent as TWinControl;
            if (length(lc)>0) and tnip then
             LinkG^.BPToLabel.Caption:=MyUtils.MyReplaceLabelCaption(ltl+': '+lc,FMaxLabelLength,FReplaceLabels)
            else
            LinkG^.BPToLabel.Caption:=MyUtils.MyReplaceLabelCaption(ltl,FMaxLabelLength,FReplaceLabels){linkP^.ssToCaption};
            LinkG^.BPToLabel.ParentFont:=False;
            LinkG^.BPToLabel.Hint:=ltl{linkP^.ssToCaption};
            LinkG^.BPToLabel.ShowHint:=True;
            LinkG^.BPToLabel.Path:=linkP^.ssToPath;
            LinkG^.BPToLabel.Font.Name:=FPrinterFontName;
            LinkG^.BPToLabel.Font.Charset:=FLang;
            if FDoOverrideFS and FOverrideLabelsFS then
             if FOwner.FPreviewOrPrint then
              LinkG^.BPToLabel.Font.Size:=Round(FLabelsFontSize*FOwner.FFOntCoof)
             else
              LinkG^.BPToLabel.Font.Size:=Round(FLabelsFontSize*FScaled2Ratio/100)
            else
            LinkG^.BPToLabel.Font.Size:=FLabelFontSize;
            LinkG^.BPToLabel.Font.Color:=tmp.dwColor;
            LinkG^.BPToLabel.SetFontDPI(FFontDPI);
            LinkG^.BPToLabel.Transparent:=True;
            LinkG^.BPToLabel.AutoSize:=True;
            LinkG^.BPToLabel.Color:=clWhite;
            LinkG^.BPToLabel.WordWrap:=False;
            LinkG^.BPToLabel.AcceptPosition:=False;
            LinkG^.BPToLabel.Top:=Round(linkP^.ToTop[2]*hc);
            LinkG^.BPToLabel.Left:=Round(linkP^.ToLeft[2]*wc);
            LinkG^.BPToLabel.AcceptPosition:=linkP^.ToAcceptPosition[2];
            LinkG^.BPToLabel.DragMode:=dmManual;
            LinkG^.BPToLabel.Cursor:=crHandPoint;
            LinkG^.BPToLabel.OnMouseDown:=MyLabelMouseDown;
            LinkG^.BPToLabel.PopupMenu:=BPViewMainForm.LSALinksPopupMenu;
            LinkG^.BPToLabel.SendToBack;
            end
             else
            LinkG^.BPToLabel:=nil;
            linkG^.FromNodeNumber:=linkP^.dwFromNodeNumber;
            linkG^.ToNodeNumber:=linkP^.dwToNodeNumber;
            if ((spamLinkTop or spamLinkBottom) and FUseSpam) then
              LinkG^.dwFlags:=(linkP^.dwFlags and BP_TOMASK_INVERT) or BP_TONODE_LEFT
            else
              LinkG^.dwFlags:=linkP^.dwFlags;
            SetShowFromToCaption(LinkG^.dwFlags,sfc,stc);
            LinkG^.FromLinkNumber:=linkP^.dwFromLinkNumber;
            if ((spamLinkTop or spamLinkBottom) and FUseSpam) then
             LinkG^.ToLinkNumber:=GetSpamToLinkNumber(linkP,spamLinkTop,spamLinkBottom)
            else
             LinkG^.ToLinkNumber:=linkP^.dwToLinkNumber;
            linkG^.StartPoint.x:=0;
            linkG^.StartPoint.y:=0;
            linkG^.EndPoint.x:=0;
            linkG^.EndPoint.y:=0;
            linkG^.LinkFromCount:=0;
            linkG^.LinkToCount:=0;
            linkG^.MinimalXFrom:=0;
            linkG^.MinimalXTo:=0;
            linkG^.MinimalYFrom:=0;
            linkG^.MinimalYTo:=0;
            FillChar(linkG^.LineArrayX,sizeof(linkG^.LineArrayX),0);
            FillChar(linkG^.LineArrayY,sizeof(linkG^.LineArrayY),0);
            linkG^.LinePointCount:=0;
            LinkG^.Color:=tmp.dwColor;
            LinkG^.PenStyle:=tmp.dwPenStyle;
            LinkG^.Visible:=linkVisible;
            LinkG^.IsCaseOp:=caseOp;
            linkG^.next:=nil;
            if caseOp then
             begin
               tmpLinkG:=FGraphLinks;
               for j:=0 to (FGLinksCount-1) do
                begin
                  if ((tmpLinkG^.FromNodeNumber and BPGlobalMask)=0) and
                     ((linkG^.FromNodeNumber and BPGlobalMask)=0) and
                     (tmpLinkG^.FromNodeNumber=linkG^.FromNodeNumber) and
                     ((tmpLinkG^.dwFlags and BP_FROMMASK)=BP_FROMNODE_RIGHT) and
                     ((linkG^.dwFlags and BP_FROMMASK)=BP_FROMNODE_RIGHT) then
                      begin
                        if IsLinkIndexEqual(tmpLinkG^.llLink^.ssFromCaption,LinkG^.llLink^.ssFromCaption) then
                          begin
                            LinkG^.FromLinkNumber:=tmpLinkG^.FromLinkNumber;
                          end;
                      end;
                  tmpLinkG:=tmpLinkG^.next;
                end;
             end;
            curLinkG^.next:=linkG;
            curLinkG:=linkG;
            Inc(FGLinksCount);
          end;
      end; { linkVisible }
      Inc(linkP);
    end; { for }
  end;


procedure  TBPLSAGraph.CreateGraphNodes(wc,hc:Double); { Checked }
 Var nodeP:PBPNode;
     nodeG:PLSAGraphNode;
     curNodeG:PLSAGraphNode;
     i,j:Integer;
     tmp:TBPNodeTypes;
     s:String;
     nc:String;
  begin
    if (FUseSpam) then
     begin
      FillSpamNodes;
      TraceLeftSpamNodes;
     end else ClearGraphNodes;
   if (FGraphNodes<>nil) then ClearGraphNodes;
   if (FNodes=nil) then Exit;
   FGNodesCount:=0;
   FGlobalLeftLinksCount:=0;
   FGlobalRightLinksCount:=0;
   nodeP:=FNodes;
   j:=-1;
   for i:=0 to (FNodesCount-1) do
    begin
      tmp:=GetNTFromIndex(nodeP^.dwNodeIndex);
      if IsNodeVisibleEx(nodeP){NodeVisible(nodeP)} then
      begin { Node Visible }
      nc:=MyUtils.MyReplaceNodeCaption(nodeP^.ssCaption,FMAxWordLength,FMaxWordCount,FReplaceNodes);
      if (j=-1) then
          begin
            j:=1;
            curNodeG:=PLSAGraphNode(AllocMem(sizeof(TLSAGraphNode)));
            curNodeG^.BPNode:=TBPLSAGraphNode.Create(Parent);
            curNodeG^.BPNode.Parent:=Parent as TWinControl;
            curNodeG^.BPNode.Caption:=nc;
            curNodeG^.BPNode.NodeNumber:=nodeP^.dwNodeNumber;
            curNodeG^.BPNode.SNodeNumber:=nodeP^.ssNodeNumber;
            curNodeG^.BPNode.AutoHeight:=False;
            curNodeG^.BPNode.AutoWidth:=False;
            if not(FScaled2) then
            begin
            s:=Format('%f',[nodeP^.fABCValue]);
            curNodeG^.BPNode.Hint:=nodeP^.ssNodeNumber+': '+nodeP^.ssCaption+' ['+s+']';
            end
            else
            begin
            if (Length(nodeP^.ssComment)>0) then
              curNodeG^.BPNode.Hint:=nodeP^.ssComment
            else
             begin
              s:=Format('%f',[nodeP^.fABCValue]);
              curNodeG^.BPNode.Hint:=nodeP^.ssNodeNumber+': '+nodeP^.ssCaption+' ['+s+']';
             end;
            end;
            { New }
            curNodeG^.BPNode.ShowHint:=True;
            curNodeG^.BPNode.Font.Color:=tmp.dwFontColor;
            curNodeG^.BPNode.Font.Charset:=FLang;
            curNodeG^.BPNode.PaintColor:=tmp.dwPaintColor;
            curNodeG^.BPNode.ShadowType:=TDSShadowType(tmp.dwShadowStyle);
            curNodeG^.BPNode.RectStyle:=TDSRectStyle(tmp.dwRectStyle);
            curNodeG^.BPNode.ShadowColor:=tmp.dwShadowColor;
            curNodeG^.BPNode.RectColor:=tmp.dwDrawColor;
            { End New }
            curNodeG^.BPNode.Font.Name:=FPrinterFontName;
            if FDoOverrideFS and FOverrideNodesFS then
             if FOwner.FPreviewOrPrint then
               curNodeG^.BPNode.Font.Size:=Round(FNodesFontSize*FOwner.FFOntCoof)
             else
               curNodeG^.BPNode.Font.Size:=Round(FNodesFontSize*FScaled2Ratio/100)
            else
            curNodeG^.BPNode.Font.Size:=FFontSize;
            curNodeG^.BPNode.Font.Style:=[fsBold];
            curNodeG^.BPNode.LeftLinksCount:=0;
            curNodeG^.BPNode.RightLinksCount:=0;
            curNodeG^.BPNode.ShadowDepth:=FNodeShadowDepth;
            curNodeG^.BPNode.SetFontDPI(FFontDPI);
            curNodeG^.BPNode.LineWidth:=FNodeLineWidth;
            curNodeG^.BPNode.DefWidth:=FNodeDefWidth;
            curNodeG^.BPNode.DefHeight:=FNodeDefHeight;
            curNodeG^.BPNode.HSpacing:=FNodeHSpacing;
            curNodeG^.BPNode.VSpacing:=FNodeVSpacing;
            curNodeG^.CorrectNode:=True;
            if nodeP^.AcceptPosition[2] then
            begin
            curNodeG^.BPNode.Top:=Round(nodeP^.Top[2]*hc);
            curNodeG^.BPNode.Left:=Round(nodeP^.Left[2]*wc);
            end;
            curNodeG^.BPNode.AcceptPosition:=nodeP^.AcceptPosition[2];
            curNodeG^.BPNode.DragMode:=dmManual;
            curNodeG^.BPNode.OnMouseDown:=MyNodeMouseDown;
            curNodeG^.BPNode.PopupMenu:=BPViewMainForm.LSANodesPopupMenu;
            curNodeG^.BPNode.Tag:=i;
            curNodeG^.next:=nil;
            curNodeG^.llNode:=nodeP;
            FGraphNodes:=curNodeG;
            inc(FGNodesCount);
          end
       else
          begin
            nodeG:=PLSAGraphNode(AllocMem(sizeof(TLSAGraphNode)));
            nodeG^.BPNode:=TBPLSAGraphNode.Create(Parent);
            nodeG^.BPNode.Parent:=Parent as TWinControl;
            nodeG^.BPNode.Caption:=nc;
            nodeG^.BPNode.SNodeNumber:=nodeP^.ssNodeNumber;
            nodeG^.BPNode.NodeNumber:=nodeP^.dwNodeNumber;
            nodeG^.BPNode.AutoHeight:=False;
            nodeG^.BPNode.AutoWidth:=False;
            if not(FScaled2) then
            begin
            s:=Format('%f',[nodeP^.fABCValue]);
            nodeG^.BPNode.Hint:=nodeP^.ssNodeNumber+': '+nodeP^.ssCaption+' ['+s+']';
            end
            else
            begin
             if (Length(nodeP^.ssComment)>0) then
               nodeG^.BPNode.Hint:=nodeP^.ssComment
             else
              begin
               s:=Format('%f',[nodeP^.fABCValue]);
               nodeG^.BPNode.Hint:=nodeP^.ssNodeNumber+': '+nodeP^.ssCaption+' ['+s+']';
              end;
            end;
            { New }
            nodeG^.BPNode.ShowHint:=True;
            nodeG^.BPNode.Font.Color:=tmp.dwFontColor;
            NodeG^.BPNode.Font.Charset:=FLang;
            nodeG^.BPNode.PaintColor:=tmp.dwPaintColor;
            nodeG^.BPNode.ShadowType:=TDSShadowType(tmp.dwShadowStyle);
            nodeG^.BPNode.RectStyle:=TDSRectStyle(tmp.dwRectStyle);
            nodeG^.BPNode.ShadowColor:=tmp.dwShadowColor;
            nodeG^.BPNode.RectColor:=tmp.dwDrawColor;
            { End New }
            nodeG^.BPNode.Font.Name:=FPrinterFontName;
            if FDoOverrideFS and FOverrideNodesFS then
             if FOwner.FPreviewOrPrint then
               NodeG^.BPNode.Font.Size:=Round(FNodesFontSize*FOwner.FFOntCoof)
             else
               NodeG^.BPNode.Font.Size:=Round(FNodesFontSize*FScaled2Ratio/100)
            else
            nodeG^.BPNode.Font.Size:=FFontSize;
            nodeG^.BPNode.Font.Style:=[fsBold];
            nodeG^.BPNode.LeftLinksCount:=0;
            nodeG^.BPNode.RightLinksCount:=0;
            nodeG^.BPNode.ShadowDepth:=FNodeShadowDepth;
            nodeG^.BPNode.SetFontDPI(FFontDPI);
            nodeG^.BPNode.LineWidth:=FNodeLineWidth;
            nodeG^.BPNode.DefWidth:=FNodeDefWidth;
            nodeG^.BPNode.DefHeight:=FNodeDefHeight;
            nodeG^.BPNode.HSpacing:=FNodeHSpacing;
            nodeG^.BPNode.VSpacing:=FNodeVSpacing;
            nodeG^.CorrectNode:=True;
            if nodeP^.AcceptPosition[2] then
            begin
            nodeG^.BPNode.Top:=Round(nodeP^.Top[2]*hc);
            nodeG^.BPNode.Left:=Round(nodeP^.Left[2]*wc);
            end;
            nodeG^.BPNode.AcceptPosition:=nodeP^.AcceptPosition[2];
            nodeG^.BPNode.DragMode:=dmManual;
            nodeG^.BPNode.OnMouseDown:=MyNodeMouseDown;
            nodeG^.BPNode.PopupMenu:=BPViewMainForm.LSANodesPopupMenu;
            nodeG^.BPNode.Tag:=i;
            nodeG^.llNode:=nodeP;
            nodeG^.next:=nil;
            curNodeG^.next:=nodeG;
            curNodeG:=nodeG;
            inc(FGNodesCount);
            FLastNodeNumber:=nodeP^.dwNodeNumber;
          end;
     end; { NodeVisible }
     if (FGNodesCount=1) then FFirstNodeNumber:=nodeP^.dwNodeNumber;
     Inc(nodeP);
    end; { for }
  end;

 procedure  TBPLSAGraph.ClearGraphNodes; { Checked }
 Var tmpN,tmpN1:PLSAGraphNode;
  begin
   if FGraphNodes=nil then Exit;
   tmpN:=FGraphNodes;
   tmpN1:=nil;
   while tmpN<>nil do
    begin
      if tmpN1<>nil then
        begin
{         tmpN1^.BPNode.OnDblClick:=nil; }
         tmpN1^.BPNode.OnMouseDown:=nil;
         tmpN1^.BPNode.PopupMenu:=nil;
         tmpN1^.BPNode.Destroy;
         FreeMem(tmpN1);
        end;
      tmpN1:=tmpN;
      tmpN:=tmpN.Next;
    end;
    if tmpN1<>nil then
       begin
{         tmpN1^.BPNode.OnDblClick:=nil; }
         tmpN1^.BPNode.OnMouseDown:=nil;
         tmpN1^.BPNode.PopupMenu:=nil;
         tmpN1^.BPNode.Destroy;
         FreeMem(tmpN1);
       end;
   FGraphNodes:=nil;
   FGNodesCount:=0;
   FMaxWidth:=0;
   FMaxHeight:=0;
  end;

 procedure  TBPLSAGraph.ClearGraphLinks; { Checked }
  Var tmpN,tmpN1:PLSAGraphLink;
  begin
   { Clears graphics links list }
   if FGraphLinks=nil then Exit;
   tmpN:=FGraphLinks;
   tmpN1:=nil;
   while tmpN<>nil do
    begin
      if tmpN1<>nil then
        begin
         if ((tmpN1^.dwFlags and BP_SHOW_FROMCAPTION)<>0)  and (tmpN1^.BPFromLabel<>nil) and (tmpN1^.BPFromLabel<>nil) then
           begin
            tmpN1^.BPFromLabel.OnMouseDown:=nil;
            tmpN1^.BPFromLabel.PopupMenu:=nil;
            tmpN1^.BPFromLabel.Destroy;
           end;
         if ((tmpN1^.dwFlags and BP_SHOW_TOCAPTION)<>0) and (tmpN1^.BPToLabel<>nil) and (tmpN1^.BPToLabel<>nil) then
           begin
            tmpN1^.BPToLabel.OnMouseDown:=nil;
            tmpN1^.BPToLabel.PopupMenu:=nil;
            tmpN1^.BPToLabel.Destroy;
           end;
         tmpN1^.llLink:=nil;
         FreeMem(tmpN1);
        end;
      tmpN1:=tmpN;
      tmpN:=tmpN.Next;
    end;
    if tmpN1<>nil then
       begin
         if ((tmpN1^.dwFlags and BP_SHOW_FROMCAPTION)<>0)  and (tmpN1^.BPFromLabel<>nil) then
           begin
            tmpN1^.BPFromLabel.OnMouseDown:=nil;
            tmpN1^.BPFromLabel.PopupMenu:=nil;
            tmpN1^.BPFromLabel.Destroy;
           end;
         if ((tmpN1^.dwFlags and BP_SHOW_TOCAPTION)<>0)  and (tmpN1^.BPToLabel<>nil) then
           begin
            tmpN1^.BPToLabel.OnMouseDown:=nil;
            tmpN1^.BPToLabel.PopupMenu:=nil;
            tmpN1^.BPToLabel.Destroy;
           end;
         tmpN1^.llLink:=nil;
         FreeMem(tmpN1);
       end;
   FGraphLinks:=nil;
   FGLinksCount:=0;
  end;

function  TBPLSAGraph.GetNTFromIndex(index:DWORD):TBPNodeTypes; { Checked }
 Var flag:Boolean;
     i,ic:Integer;
     tmpPtr:PBPNodeTypes;
  begin
     flag:=True;
     tmpPtr:=FNTTree;
     ic:=FHeader.dwNodesTypesCount;
     if (ic>0) then
       begin
         i:=0;
         while ((i<ic) and (flag)) do
           begin
              if tmpPtr^.dwNodeIndex=index then
                 begin
                   flag:=False;
                   Result:=tmpPtr^;
                   Exit;
                 end
               else
                begin
                 inc(tmpPtr);
                 inc(i);
                end;
           end;
       end;
      Result.dwNodeIndex:=index;
      Result.ssCaption:='Default';
      Result.dwFontColor:=clBlack;
      Result.dwPaintColor:=clWhite;
      Result.dwDrawColor:=clBlack;
      Result.dwShadowColor:=clBlack;
      Result.dwShadowStyle:=6;
      Result.dwRectStyle:=2;
  end;

function  TBPLSAGraph.GetLTFromIndex(index:DWORD):TBPLinkTypes; { Checked }
 Var flag:Boolean;
     i,ic:Integer;
     tmpPtr:PBPLinkTypes;
  begin
     flag:=True;
     tmpPtr:=FLTTree;
     ic:=FHeader.dwLinksTypesCount;
     if (ic>0) then
       begin
         i:=0;
         while ((i<ic) and (flag)) do
           begin
              if tmpPtr^.dwLinkIndex=index then
                 begin
                   flag:=False;
                   Result:=tmpPtr^;
                   Exit;
                 end
               else
                begin
                 inc(tmpPtr);
                 inc(i);
                end;
           end;
       end;
      Result.dwLinkIndex:=index;
      Result.ssCaption:='Default';
      Result.dwPenStyle:=psSolid;
      Result.dwColor:=clBlack;
  end;



{ TBPLSAFrame }

procedure TBPLSAFrame.MyDragDrop(Sender, Source: TObject; X, Y: Integer); { Checked }
var p:TPoint;
    vpos,hpos:Integer;
begin
 if HorzScrollBar.Visible then hpos:=HorzScrollBar.Position;
 if VertScrollBar.Visible then vpos:=VertScrollBar.Position;
 if (Sender is TBPLSAFrame) and (Source is TBPLSAGraphCustomNode) then
  begin
    with Source as TBPLSAGraphNode do
    begin
      p.x:=X-Left;
      p.y:=Y-Top;
      Left:=X;
      Top:=Y;
      if VertScrollBar.Visible then
       TopDragPos:=Y+VertScrollBar.Position
      else
       TopDragPos:=Y;
      if HorzScrollBar.Visible then
       LeftDragPos:=X+HorzScrollBar.Position
      else
       LeftDragPos:=X;
      AcceptPosition:=True;
      FBPLSAGraph.UpdateNodesModel(LeftDragPos,TopDragPos,Source as TBPLSAGraphNode);
      if FBPLSAGraph.FLinksPosRelative then FBPLSAGraph.CorrectLinksModel(p,(Source as TBPLSAGraphNode).NodeNumber,FBPLSAGraph.AcceptDragRect);
      BringToFront;
    end;
    with (Sender as TBPLSAFrame) do
      begin
       Visible:=False;
       FBPLSAGraph.TraceRoute;
       Repaint;
       Visible:=True;
       if HorzScrollBar.Visible then HorzScrollBar.Position:=hpos;
       if VertScrollBar.Visible then VertScrollBar.Position:=vpos;
       BPViewMainForm.BPGetBitmapTimer.Enabled:=True;
      end;
  end;
 if (Sender is TBPLSAFrame) and (Source is TBPLabel) then
  begin
    with Source as TBPLabel do
    begin
      Left:=X;
      Top:=Y;
      if VertScrollBar.Visible then
       TopDragPos:=Y+VertScrollBar.Position
      else
       TopDragPos:=Y;
      if HorzScrollBar.Visible then
       LeftDragPos:=X+HorzScrollBar.Position
      else
       LeftDragPos:=X;
      AcceptPosition:=True;
    end;
     with (Sender as TBPLSAFrame) do
      begin
       FBPLSAGraph.UpdateLinksModel((Source as TBPLabel).LeftDragPos,
               (Source as TBPLabel).TopDragPos,Source as TBPLabel);
       Visible:=False;
       FBPLSAGraph.TraceRoute;
       Repaint;
       Visible:=True;
       if HorzScrollBar.Visible then HorzScrollBar.Position:=hpos;
       if VertScrollBar.Visible then VertScrollBar.Position:=vpos;
       BPViewMainForm.BPGetBitmapTimer.Enabled:=True;
      end;
   end;
end;



procedure TBPLSAFrame.MyDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean); { Checked }
Var tmpn:TBPLSAGraphNode;
    tmpl:TBPLabel;
    xnew,ynew:Integer;
begin
 if VertScrollBar.Visible then
   ynew:=y+VertScrollBar.Position
 else
   ynew:=y;
 if HorzScrollBar.Visible then
   xnew:=x+HorzScrollBar.Position
 else
   xnew:=x;
 { Check for Source }
 Accept:=(Source is TBPLSAGraphCustomNode);
 { Check coordinates }
 if Accept then
    begin
      tmpn:=Source as TBPLSAGraphNode;
      if   (Xnew<FBPLSAGraph.AcceptDragRect.Left)
       or  (Ynew<FBPLSAGraph.AcceptDragRect.Top)
       or  ((Xnew+tmpn.Width)>FBPLSAGraph.AcceptDragRect.Right)
       or  ((Ynew+tmpn.Height)>FBPLSAGraph.AcceptDragRect.Bottom)
        then
         Accept:=False;
    end;
 if not(Accept) then
  begin
   Accept:=Source is TBPLabel;
   if Accept then
     begin
       tmpl:=Source as TBPLabel;
       if   (Xnew<FBPLSAGraph.AcceptDragRect.Left)
       or  (Ynew<FBPLSAGraph.AcceptDragRect.Top)
       or  ((Xnew+tmpl.Width)>FBPLSAGraph.AcceptDragRect.Right)
       or  ((Ynew+tmpl.Height)>FBPLSAGraph.AcceptDragRect.Bottom)
        then
         Accept:=False;
     end;
  end;
end;


constructor TBPLSAFrame.Create(AOwner: TComponent); { Checked }
begin
 inherited Create(AOwner);
 FPainting:=False;
 FPrinting:=False;
 FAborting:=False;
 FPreviewOrPrint:=False;
 FFontCoof:=1;
 FBPLSAGraph:=TBPLSAGraph.Create(self);
 FBPLSAGraph.Parent:=self;
 FCanvas := TControlCanvas.Create;
 TControlCanvas(FCanvas).Control := Self;
 Canvas.Brush.Color:=clWhite;
 DragCursor:=crMyCursor;
 OnDragDrop:=MyDragDrop;
 OnDragOver:=MyDragOver;
 FPageTop:=15;
 FPageBottom:=15;
 FPageLeft:=25;
 FPageRight:=15;
 FHorzPageCount:=1;
 FVertPageCount:=1;
 FRamkaFontRatio:=1.0;
 FPSizeH:=21;
 FPSizeW:=29.7;
 FRamkaH:=0;
 TabStop:=True;
 Enabled:=True;
 FUpdatingNavigator:=False;
 FFormatAlg[0]:=fa_Min;
 FFormatAlg[1]:=fa_Sqrt;
 FFormatAlg[2]:=fa_Max;
 FNodesValue[0]:=4;
 FNodesValue[1]:=6;
 if MainUnit.HasPrnDevice then SetPageParam(FPageTop,FPageBottom,FPageLeft,FPageRight,False);
end;

destructor TBPLSAFrame.Destroy; { Checked }
begin
 OnDragDrop:=nil;
 OnDragOver:=nil;
 if (FPrinter<>nil) then FPrinter.Free;
 if (FCanvas<>nil) then FCanvas.Free;
 if (FBPLSAGraph<>nil) then FBPLSAGraph.Destroy; { +-+ +- }
 inherited Destroy;
end;

procedure TBPLSAFrame.WMPaint(var Message: TWMPaint); { Checked }
begin
   PaintHandler(Message);
end;

procedure TBPLSAFrame.PaintWindow(DC: HDC); { Checked }
begin
  if FPainting then Exit;
  FPainting:=True;
  inherited PaintWindow(DC);
  FCanvas.Lock;
  try
    FCanvas.Handle := DC;
    try
      Paint;
    finally
      FCanvas.Handle := 0;
    end;
  finally
    FCanvas.Unlock;
    FPainting:=False;
  end;
end;

procedure TBPLSAFrame.Paint; { Checked }
Var oldcr:TCursor;
begin
  oldcr:=Cursor;
  Cursor:=crHourGlass;
  Canvas.FillRect(ClientRect);
  FBPLSAGraph.TraceRoute;
  if (not(FUpdatingNavigator)) and
  (BPViewMainFOrm.PageControl1.ActivePage=BPViewMainFOrm.TabSheet3) then
  if (BPViewMainFOrm.BPNavigator.Height>1) then
      BPViewMainFOrm.BPNavigator.ScrollBarChanged(self);
  {  BPViewMainForm.BPNavTimer.Enabled:=True;}
  Cursor:=oldcr;
end;

procedure TBPLSAFrame.PaintTo(DC: HDC; X, Y: Integer); { Checked }
var
  SaveIndex: Integer;
begin
  SaveIndex := SaveDC(DC);
  MoveWindowOrg(DC, X, Y);
  Perform(WM_ERASEBKGND, DC, 0);
  Perform(WM_PAINT, DC, 0);
  RestoreDC(DC, SaveIndex);
end;

procedure TBPLSAFrame.PaintPageTo(DC: HDC; X, Y: Integer; PageClipRect:TRect); { Checked }
var
  SaveIndex: Integer;
begin
  SaveIndex := SaveDC(DC);
  MoveWindowOrg(DC, X-PageClipRect.Left, Y-PageClipRect.Top);
  IntersectClipRect(DC, PageClipRect.Left, PageClipRect.Top, PageClipRect.Right, PageClipRect.Bottom);
  Perform(WM_ERASEBKGND, DC, 0);
  Perform(WM_PAINT, DC, 0);
  RestoreDC(DC, SaveIndex);
end;

procedure TBPLSAFrame.PrintRect(left,right,top,bottom:Integer); { Checked }
Var oldStyle:TPenStyle;
    oldSize,w,h:Integer;
    s:String; 
begin
 with Printer.Canvas do
  begin
   oldStyle:=Pen.Style;
   Pen.Style:=psSolid;
   oldSize:=Font.Size;
   Font.Size:=16;
   s:='A'+FBPLSAGraph.FSSLevel+' '+FBPLSAGraph.Caption+' : '+IntToStr(FBPLSAGraph.CurDiag);
   w:=TextWidth(s);
   h:=TextHeight(s);
   TextOut(Left+((Right-Left-w) div 2),Top+2*h,s);
   Font.Size:=oldSize;
   Pen.Style:=psDot;
   MoveTo(Left,Top);
   LineTo(Right,Top);
   LineTo(Right,Bottom);
   LineTo(Left,Bottom);
   LineTo(Left,Top);
   Pen.Style:=oldStyle;
  end;
end;

function   TBPLSAGraph.GetMaxPagesCount:Integer;
 begin
   Result:=CalcPagesCount;
 end;

procedure TBPLSAFrame.PrintAll(pb:TFlatProgressBar;Lbl:TLabel;StartP,EndP:Integer); { Checked }
Var  oldLevel:Integer;
     tmpTree:PBPTree;
     i,j:Integer;
     prnppi,scrppi:Integer;
     w,h:Integer;
     prnx,prny:Integer;
     dc:HDC;
     ratio,fontRatio,LabelFontRatio:Double;
     rw,rh:Double;
     ramkaH:Integer;
     nw,nh,mw,mh:Integer;
     oldScaled:Boolean;
     oldScaled2:Boolean;
     clRect:TRect;
     px,py:Integer;
     pw,ph:Double;
     tmpI:TQRPaperSize;
     asize:Integer;
     wc,hc:Double;
     pc:Integer;
     pgalg:TBPPgAlg;
     oldDiag:Integer;
begin
  { Print All Pages }
  oldScaled:=BPLSAGraph.Scaled;
  oldScaled2:=BPLSAGraph.Scaled2;
  oldLevel:=-1;
  oldDiag:=0;
  if FBPLSAGraph.FTree=nil then Exit;
  FUpdatingNavigator:=True;
  FPreviewOrPrint:=True;
  FBPLSAGRaph.Scaled2:=False;
  if FBPLSAGraph.FScaled then FBPLSAGraph.Scaled:=False;
  tmpTree:=FBPLSAGraph.FTree;
  try
   FPrinting:=True;
  { Store old viewing level }
   oldLevel:=FBPLSAGraph.FLevel;
   oldDiag:=FBPLSAGraph.CurDiag;
   i:=0;
   pc:=0;
   prnppi:=GetDeviceCaps(Printer.Handle,LOGPIXELSX);
   ramkaH:=Round(prnppi/2.54);
   FRamkaH:=ramkaH;
   dc:=GetDC(self.Handle);
   scrppi:=GetDeviceCaps(dc,LOGPIXELSX);
   FFontCoof:=GetDeviceCaps(Printer.Handle,LOGPIXELSX)/GetDeviceCaps(dc,LOGPIXELSX);
   FBPLSAGraph.UpdateMaxFontSize(1);
   ReleaseDC(self.Handle,dc);
   aSize:=Printer.PaperSize;
   FRamkaFontRatio:=1.0;
   FPSizeH:=21;
   FPSizeW:=29.7;
   for tmpi:= Default to Custom do
     begin
      if aSize=cQRPaperTranslate[tmpI] then
         begin
           FRamkaFontRatio:=cQRPaperSizeMetrics[tmpI,0]/cQRPaperSizeMetrics[A4,0];
           FPSizeH:=cQRPaperSizeMetrics[tmpI,0]/10;
           FPSizeW:=cQRPaperSizeMetrics[tmpI,1]/10;
         end;
     end;
   { New Code }
   pw:= GetDeviceCaps(Printer.Handle,VERTRES);
   ph:= GetDeviceCaps(Printer.Handle,HORZRES);
   if ((FHorzPageCount=1) and (FVertPageCount=1)) then
    ph:=ph - ramkaH;
   { End New Code }
  { ratio:=(prnppi*FHorzPageCount) / scrppi;}
   Printer.BeginDoc;
   while (tmpTree<>nil) and (not(FAborting)) do
    begin
     FBPLSAGraph.OpenLevel(tmpTree^.dwLevel,0);
     FBPLSAGraph.TraceRoute;
     if (FBPLSAGraph.FMaxNodesCount>FNodesValue[0]) then
      begin
        if (FBPLSAGraph.FMaxNodesCount<FNodesValue[1]) then
          pgAlg:=pg_Middle
        else
          pgAlg:=pg_Max;
      end
     else pgalg:=pg_Min;
     if HorzScrollBar.Visible then HorzScrollBar.Position:=0;
     if VertScrollBar.Visible then VertScrollBar.Position:=0;
     Repaint;
     if (FBPLSAGraph.GetFirstInPoint<>nil) then
     begin
     for j:=0 to (FBPLSAGraph.DiagCount-1) do
     begin
     FBPLSAGraph.OpenLevel(tmpTree^.dwLevel,j);
     FBPLSAGraph.TraceRoute;
     if (pc>=StartP) and (pc<=EndP)  then
     begin
     inc(i);
     pb.Position:=Round((i-1)*100/(EndP-StartP+1));
     Lbl.Caption:=IntToStr(pb.Position);
     pb.Update;
     lbl.Update;
     Application.ProcessMessages;
     if FAborting then break;
     while (FPainting) do;
     { New Code }
     rw:=(pw*FHorzPageCount)/FBPLSAGraph.DefWidth;
     rh:=(ph*FVertPageCount)/FBPLSAGraph.DefHeight;
     wc:=FBPLSAGraph.DefWidth;
     hc:=FBPLSAGraph.DefHeight;
     case pgAlg of
      pg_Min:     Ratio:=GetCoof(rw,rh,FFormatAlg[0]);
      pg_Middle:  Ratio:=GetCoof(rw,rh,FFormatAlg[1]);
      pg_Max:     Ratio:=GetCoof(rw,rh,FFormatAlg[2]);
     end; {case pgAlg }
    { End New Code }
     FBPLSAGraph.SetScaledConstants(rw,rh,ratio,ratio,ratio);
     FBPLSAGraph.DefWidth:=FHorzPageCount*(Printer.PageWidth-FPageLeft-FPageRight);
     if ((FHorzPageCount=1) and (FVertPageCount=1)) then
      FBPLSAGraph.DefHeight:=FVertPageCount*(Printer.PageHeight-FPageTop-FPageBottom-ramkaH)
     else
      FBPLSAGraph.DefHeight:=FVertPageCount*(Printer.PageHeight-FPageTop-FPageBottom);
     wc:=FBPLSAGraph.DefWidth/wc;
     hc:=FBPLSAGraph.DefHeight/hc;
     FBPLSAGraph.Printing:=True;
     FBPLSAGraph.CreateGraphNodes(wc,hc);
     FBPLSAGraph.CreateGraphLinks(wc,hc);
     FBPLSAGraph.PresetupFrame(wc,hc);
     FBPLSAGraph.TraceRoute;
     Repaint;
     while FPainting do;
     nw:=FBPLSAGraph.NodeWidth;
     nh:=FBPLSAGraph.NodeHeight;
     mw:=FBPLSAGraph.MaxWidth;
     mh:=FBPLSAGraph.MaxHeight;
     rw:=ratio*nw/mw;
     rh:=ratio*nh/mh;
     case pgAlg of
       pg_Min:     fontRatio:=GetCoof(rw,rh,FFormatAlg[0]);
       pg_Middle:  fontRatio:=GetCoof(rw,rh,FFormatAlg[1]);
       pg_Max:     fontRatio:=GetCoof(rw,rh,FFormatAlg[2]);
     end;
{     if fontRatio>ratio then fontRatio:=ratio;}
     LabelFontRatio:=fontRatio*FBPLSAGraph.FMaxCH;
     FBPLSAGraph.DefWidth:=FHorzPageCount*(Printer.PageWidth-FPageLeft-FPageRight);
     if ((FHorzPageCount=1) and (FVertPageCount=1)) then
      FBPLSAGraph.DefHeight:=FVertPageCount*(Printer.PageHeight-FPageTop-FPageBottom-ramkaH)
     else
      FBPLSAGraph.DefHeight:=FVertPageCount*(Printer.PageHeight-FPageTop-FPageBottom);
     FBPLSAGraph.SetDefaultConstants;
     FBPLSAGraph.SetScaledConstants(wc,hc,ratio,fontRatio,LabelFontRatio);
     FBPLSAGraph.CreateGraphNodes(wc,hc);
     FBPLSAGraph.CreateGraphLinks(wc,hc);
     FBPLSAGraph.PresetupFrame(wc,hc);
     FBPLSAGraph.TraceRoute;
     Repaint;
     while FPainting do;
    for px:=1 to FHorzPageCount do
    begin
     clRect.Left:=(px-1)*(Printer.PageWidth-FPageRight-FPageLeft);
     clRect.Right:=px*(Printer.PageWidth-FPageRight-FPageLeft);
    for py:=1 to FVertPageCount do
     begin
     clRect.Top:=(py-1)*(Printer.PageHeight-FPageTop-FPageBottom);
     clRect.Bottom:=py*(Printer.PageHeight-FPageTop-FPageBottom);
     if ((FHorzPageCount=1) and (FVertPageCount=1)) then
       begin
        PaintTo(Printer.Handle,FPageLeft,FPageTop+ramkaH);
        PrintRect(FPageLeft,Printer.PageWidth-FPageRight,
                           FPageTop,Printer.PageHeight-FPageBottom);
       end
      else
       begin
        PaintPageTo(Printer.Handle,FPageLeft,FPageTop,clRect);
        PrintRect(FPageLeft,Printer.PageWidth-FPageRight,
                           FPageTop,Printer.PageHeight-FPageBottom);
       end;
       if ((FHorzPageCount<>px) or (FVertPageCount<>py)) then
        Printer.NewPage;
     end;
    end;
     FBPLSAGraph.SetDefaultConstants;
     FBPLSAGraph.Printing:=False;
     FBPLSAGraph.CreateGraphNodes(1,1);
     FBPLSAGraph.CreateGraphLinks(1,1);
     FBPLSAGraph.PresetupFrame(1,1);
     FBPLSAGraph.TraceRoute;
     Invalidate;
     if ((tmpTree^.next<>nil) and (pc<EndP))
      or ((j<>(FBPLSAGRaph.DiagCount-1)) and (pc<EndP))  then Printer.NewPage; { Wrong !!! }
     end; { StartP, EndP}
     inc(pc);
     end; { For Diags do }
      tmpTree:=tmpTree^.next;
     end
     else { GetFirstInPoint }
     tmpTree:=tmpTree^.next;
    end;  { while }
   if FAborting then Printer.Abort
   else Printer.EndDoc;
  finally
   { Restore old viewing level}
   FPrinting:=False;
   FUpdatingNavigator:=False;
   FPreviewOrPrint:=False;
   FBPLSAGraph.SetDefaultConstants;
   FBPLSAGraph.Printing:=False;
   FBPLSAGraph.CreateGraphNodes(1,1);
   FBPLSAGraph.CreateGraphLinks(1,1);
   FBPLSAGraph.SetScaled2(oldScaled2);
   FBPLSAGraph.SetScaled(oldScaled);
   if (not(oldScaled)) then FBPLSAGraph.PresetupFrame(1,1);
   FBPLSAGraph.TraceRoute;
   Invalidate;
   pb.Position:=100;
   lbl.Caption:=IntToStr(pb.Position);
   pb.Update;
   lbl.Update;
   FBPLSAGraph.OpenLevel(oldLevel,oldDiag);
   FBPLSAGraph.TraceRoute;
   Invalidate;
  end;
 end;


procedure TBPLSAFrame.Print; { Checked }
Var  prnppi,scrppi:Integer;
     w,h:Integer;
     prnx,prny:Integer;
     dc:HDC;
     ratio,fontRatio,labelFontRatio:Double;
     rw,rh:Double;
     pw,ph:Double;
     ramkaH:Integer;
     nw,nh,mw,mh:Integer;
     oldScaled:Boolean;
     oldScaled2:Boolean;
     clRect:TRect;
     px,py:Integer;
     tmpI:TQRPaperSize;
     asize:Integer;
     wc,hc:Double;
     pgalg:TBPPgAlg;
begin
 try
  oldScaled:=BPLSAGraph.Scaled;
  oldScaled2:=BPLSAGraph.Scaled2;
  FUpdatingNavigator:=True;
  FPreviewOrPrint:=True;
  if (FBPLSAGraph.FMaxNodesCount>FNodesValue[0]) then
      begin
        if (FBPLSAGraph.FMaxNodesCount<FNodesValue[1]) then
          pgAlg:=pg_Middle
        else
          pgAlg:=pg_Max;
      end
     else pgalg:=pg_Min;
  FBPLSAGraph.Scaled2:=False;
  if FBPLSAGraph.FScaled then FBPLSAGraph.Scaled:=False;
  FPrinting:=True;
  if HorzScrollBar.Visible then HorzScrollBar.Position:=0;
  if VertScrollBar.Visible then VertScrollBar.Position:=0;
  prnppi:=GetDeviceCaps(Printer.Handle,LOGPIXELSX);
  dc:=GetDC(self.Handle);
  scrppi:=GetDeviceCaps(dc,LOGPIXELSX);
  FFontCoof:=GetDeviceCaps(Printer.Handle,LOGPIXELSX)/GetDeviceCaps(dc,LOGPIXELSX);
  FBPLSAGraph.UpdateMaxFontSize(1);
  ReleaseDC(self.Handle,dc);
  aSize:=Printer.PaperSize;
  FRamkaFontRatio:=1.0;
  FPSizeH:=21;
  FPSizeW:=29.7;
  for tmpi:= Default to Custom do
     begin
      if aSize=cQRPaperTranslate[tmpI] then
         begin
           FRamkaFontRatio:=cQRPaperSizeMetrics[tmpI,0]/cQRPaperSizeMetrics[A4,0];
           FPSizeH:=cQRPaperSizeMetrics[tmpI,0]/10;
           FPSizeW:=cQRPaperSizeMetrics[tmpI,1]/10;
         end;
     end;
  ramkaH:=Round(prnppi/2.54);
  FRamkaH:=ramkaH;
  { New Code }
  pw:= GetDeviceCaps(Printer.Handle,VERTRES);
  ph:= GetDeviceCaps(Printer.Handle,HORZRES);
  if ((FHorzPageCount=1) and (FVertPageCount=1)) then
   ph:= ph-ramkaH;
  { End New Code }
{  ratio:=(prnppi*FHorzPageCount) / scrppi;}
  { New Code }
  rw:=(pw*FHorzPageCount)/FBPLSAGraph.DefWidth;
  rh:=(ph*FVertPageCount)/FBPLSAGraph.DefHeight;
  wc:=FBPLSAGraph.DefWidth;
  hc:=FBPLSAGraph.DefHeight;
  case pgAlg of
      pg_Min:     Ratio:=GetCoof(rw,rh,FFormatAlg[0]);
      pg_Middle:  Ratio:=GetCoof(rw,rh,FFormatAlg[1]);
      pg_Max:     Ratio:=GetCoof(rw,rh,FFormatAlg[2]);
  end; {case pgAlg }
  { End New Code }
  Printer.BeginDoc;
  FBPLSAGraph.SetDefaultConstants;
  FBPLSAGraph.SetScaledConstants(rw,rh,ratio,ratio,ratio);
  FBPLSAGraph.DefWidth:=(Printer.PageWidth*FHorzPageCount-FPageLeft*FHorzPageCount-FPageRight*FHorzPageCount);
  if ((FHorzPageCount=1) and (FVertPageCount=1)) then
   FBPLSAGraph.DefHeight:=(Printer.PageHeight*FVertPageCount-FPageTop*FVertPageCount-FPageBottom*FVertPageCount-ramkaH*FVertPageCount)
  else
   FBPLSAGraph.DefHeight:=(Printer.PageHeight*FVertPageCount-FPageTop*FVertPageCount-FPageBottom*FVertPageCount);
   wc:=FBPLSAGraph.DefWidth/wc;
   hc:=FBPLSAGraph.DefHeight/hc;
  FBPLSAGraph.Printing:=True;
  FBPLSAGraph.CreateGraphNodes(wc,hc);
  FBPLSAGraph.CreateGraphLinks(wc,hc);
  FBPLSAGraph.PresetupFrame(wc,hc);
  FBPLSAGraph.TraceRoute;
  Repaint;
  while FPainting do;
  nw:=FBPLSAGraph.NodeWidth;
  nh:=FBPLSAGraph.NodeHeight;
  mw:=FBPLSAGraph.MaxWidth;
  mh:=FBPLSAGraph.MaxHeight;
  rw:=ratio*nw/mw;
  rh:=ratio*nh/mh;
  case pgAlg of
       pg_Min:     fontRatio:=GetCoof(rw,rh,FFormatAlg[0]);
       pg_Middle:  fontRatio:=GetCoof(rw,rh,FFormatAlg[1]);
       pg_Max:     fontRatio:=GetCoof(rw,rh,FFormatAlg[2]);
  end;
{  if fontRatio>ratio then fontRatio:=ratio;}
  LabelFontRatio:=fontRatio*FBPLSAGraph.FMaxCH;
  FBPLSAGraph.DefWidth:=(Printer.PageWidth*FHorzPageCount-FPageLeft*FHorzPageCount-FPageRight*FHorzPageCount);
  if ((FHorzPageCount=1) and (FVertPageCount=1)) then
   FBPLSAGraph.DefHeight:=(Printer.PageHeight*FVertPageCount-FPageTop*FVertPageCount-FPageBottom*FVertPageCount-ramkaH*FVertPageCount)
  else
   FBPLSAGraph.DefHeight:=(Printer.PageHeight*FVertPageCount-FPageTop*FVertPageCount-FPageBottom*FVertPageCount);
  FBPLSAGraph.SetDefaultConstants;
  FBPLSAGraph.SetScaledConstants(wc,hc,ratio,fontRatio,LabelFontRatio);
  FBPLSAGraph.CreateGraphNodes(wc,hc);
  FBPLSAGraph.CreateGraphLinks(wc,hc);
  FBPLSAGraph.PresetupFrame(wc,hc);
  FBPLSAGraph.TraceRoute;
  Repaint;
  while FPainting do;
   for px:=1 to FHorzPageCount do
    begin
     clRect.Left:=(px-1)*(Printer.PageWidth-FPageRight-FPageLeft);
     clRect.Right:=px*(Printer.PageWidth-FPageRight-FPageLeft);
    for py:=1 to FVertPageCount do
     begin
     clRect.Top:=(py-1)*(Printer.PageHeight-FPageTop-FPageBottom);
     clRect.Bottom:=py*(Printer.PageHeight-FPageTop-FPageBottom);
     if ((FHorzPageCount=1) and (FVertPageCount=1)) then
       begin
        PaintTo(Printer.Handle,FPageLeft,FPageTop+ramkaH);
        PrintRect(FPageLeft,Printer.PageWidth-FPageRight,
                           FPageTop,Printer.PageHeight-FPageBottom);
       end
      else
       begin
        PaintPageTo(Printer.Handle,FPageLeft,FPageTop,clRect);
        PrintRect(FPageLeft,Printer.PageWidth-FPageRight,
                           FPageTop,Printer.PageHeight-FPageBottom);
       end;
       if ((FHorzPageCount<>px) or (FVertPageCount<>py)) then
        Printer.NewPage;
     end;
    end;
  finally
   Printer.EndDoc;
   FPrinting:=False;
   FUpdatingNavigator:=False;
   FPreviewOrPrint:=False;
   FBPLSAGraph.SetDefaultConstants;
   FBPLSAGraph.Printing:=False;
   FBPLSAGraph.CreateGraphNodes(1,1);
   FBPLSAGraph.CreateGraphLinks(1,1);
{   FBPLSAGraph.CheckLinksAndNodes;}
   FBPLSAGraph.SetScaled2(oldScaled2);
   FBPLSAGraph.SetScaled(oldScaled);
   if (not(oldScaled)) then FBPLSAGraph.PresetupFrame(1,1);
   FBPLSAGraph.TraceRoute;
   Invalidate;
  end;
end;


procedure TBPLSAFrame.CreatePreviewAll(pb:TFlatProgressBar;Lbl:TLabel); { Checked }
Var savedOrd:TPrinterOrientation;
    pw,ph:Integer;
    fpl,fpr,fpt,fpb:Integer;
    ratio,fontRatio,LabelFontRatio:Double;
    rw,rh:Double;
    dc:HDC;
    scrppi:LongInt;
    ramkaH:Integer;
    nw,nh,mw,mh:Integer;
    oldLevel:Integer;
    tmpTree:PBPTree;
    i,j:Integer;
    oldScaled:Boolean;
    oldScaled2:Boolean;
    px,py:Integer;
    clrect:TRect;
    aSize:Integer;
    tmpi:TQRPaperSize;
    wc,hc:Double;
    pgalg:TBPPgAlg;
    oldDiag:Integer;
begin
 { Create QRPreview Model }
   oldScaled:=BPLSAGraph.Scaled;
   oldScaled2:=BPLSAGraph.Scaled2;
   if FBPLSAGraph.FTree=nil then Exit;
   FUpdatingNavigator:=True;
   FPreviewOrPrint:=True;
   FBPLSAGraph.Scaled2:=False;
   if FBPLSAGraph.FScaled then FBPLSAGraph.Scaled:=False;
   tmpTree:=FBPLSAGraph.FTree;
   if (fPrinter<>nil) then fPrinter.Free;
   savedOrd:=Printer.Orientation;
   oldLevel:=FBPLSAGraph.FLevel;
   oldDiag:=FBPLSAGraph.CurDiag;
   FPrinter:=TQRPrinter.Create;
   try
    FPrinting:=True;
    FPrinter.Cleanup;
    FPrinter.BeginDoc;
    FPrinter.Orientation:=poPortrait;
    Printer.Orientation:=poPortrait;
    FPrinter.PrinterIndex:=Printer.PrinterIndex;
    aSize:=Printer.PaperSize;
    FPrinter.PaperSize:=Default;
    FRamkaFontRatio:=1.0;
    FPSizeH:=21;
    FPSizeW:=29.7;
    for tmpi:= Default to Custom do
     begin
      if aSize=cQRPaperTranslate[tmpI] then
         begin
           FPrinter.PaperSize := tmpI;
           FRamkaFontRatio:=cQRPaperSizeMetrics[tmpI,0]/cQRPaperSizeMetrics[A4,0];
           FPSizeH:=cQRPaperSizeMetrics[tmpI,0]/10;
           FPSizeW:=cQRPaperSizeMetrics[tmpI,1]/10;
         end;
     end;
    FPrinter.PaperLength:=Printer.PaperLength;
    FPrinter.PaperWidth:=Printer.PaperWidth;
    dc:=GetDC(0);
    scrppi:=GetDeviceCaps(dc,LOGPIXELSX);
    FFontCoof:=1;
    FBPLSAGraph.UpdateMaxFontSize(1);
    ReleaseDC(0,dc);
    ramkaH:=Round(scrppi/2.54);
    FRamkaH:=ramkaH;
    FPrinter.NewPage;
{   if SavedOrd=poPortrait then
   begin}
    pw:= FPrinter.XSize(FPrinter.PaperWidth);
    ph:= FPrinter.YSize(FPrinter.PaperLength);
{   end
   else
   begin
    pw:= FPrinter.XSize(FPrinter.PaperLength);
    ph:= FPrinter.YSize(FPrinter.PaperWidth);
   end;}
   if ((FHorzPageCount=1) and (FVertPageCount=1)) then
     ph:=ph - ramkaH;
   fpl:=FPrinter.XSize(FPageLeft*10);
   fpr:=FPrinter.XSize(FPageRight*10);
   fpt:=FPrinter.YSize(FPageTop*10);
   fpb:=FPrinter.YSize(FPageBottom*10);
   i:=0;
   while (tmpTree<>nil) and (not(FAborting)) do
    begin  { while }
     FBPLSAGraph.OpenLevel(tmpTree^.dwLevel,0);
     FBPLSAGraph.TraceRoute;
     Repaint;
     if (FBPLSAGraph.FMaxNodesCount>FNodesValue[0]) then
      begin
        if (FBPLSAGraph.FMaxNodesCount<FNodesValue[1]) then
          pgAlg:=pg_Middle
        else
          pgAlg:=pg_Max;
      end
     else pgalg:=pg_Min;
     if FBPLSAGraph.GetFirstInPoint<>nil then
     begin { GetInPoint }
     for j:=0 to (FBPLSAGraph.DiagCount-1) do
      begin
       FBPLSAGraph.OpenLevel(tmpTree^.dwLevel,j);
       FBPLSAGraph.TraceRoute;
       Repaint;
     inc(i);
     pb.Position:=Round((i-1)*100/FBPLSAGraph.FRootEntries);
     lbl.Caption:=IntToStr(pb.Position);
     pb.Update;
     lbl.Update;
     Application.ProcessMessages;
     if FAborting then break;
     while (FPainting) do;
     if HorzScrollBar.Visible then HorzScrollBar.Position:=0;
     if VertScrollBar.Visible then VertScrollBar.Position:=0;
     rw:=(pw*FHorzPageCount)/FBPLSAGraph.DefWidth;
     rh:=(ph*FVertPageCount)/FBPLSAGraph.DefHeight;
     wc:=FBPLSAGraph.DefWidth;
     hc:=FBPLSAGraph.DefHeight;
     case pgAlg of
      pg_Min:     Ratio:=GetCoof(rw,rh,FFormatAlg[0]);
      pg_Middle:  Ratio:=GetCoof(rw,rh,FFormatAlg[1]);
      pg_Max:     Ratio:=GetCoof(rw,rh,FFormatAlg[2]);
     end; {case pgAlg }
     FBPLSAGraph.SetDefaultConstants;
     FBPLSAGraph.SetScaledConstants(rw,rh,ratio,ratio,ratio);
     FBPLSAGraph.DefWidth:=(PW*FHorzPageCount-FPL*FHorzPageCount-FPR*FHorzPageCount);
     if ((FHorzPageCount=1) and (FVertPageCount=1)) then
      FBPLSAGraph.DefHeight:=(PH*FVertPageCount-FPT*FVertPageCount-FPB*FVertPageCount-ramkaH*FVertPageCount)
     else
      FBPLSAGraph.DefHeight:=(PH*FVertPageCount-FPT*FVertPageCount-FPB*FVertPageCount);
     wc:=FBPLSAGraph.DefWidth/wc;
     hc:=FBPLSAGraph.DefHeight/hc;
     FBPLSAGraph.Printing:=True;
     FBPLSAGraph.CreateGraphNodes(wc,hc);
     FBPLSAGraph.CreateGraphLinks(wc,hc);
     FBPLSAGraph.PresetupFrame(wc,hc);
     FBPLSAGraph.TraceRoute;
     Repaint;
    while FPainting do;
    nw:=FBPLSAGraph.NodeWidth;
    nh:=FBPLSAGraph.NodeHeight;
    mw:=FBPLSAGraph.MaxWidth;
    mh:=FBPLSAGraph.MaxHeight;
    rw:=ratio*nw/mw;
    rh:=ratio*nh/mh;
    case pgAlg of
       pg_Min:     fontRatio:=GetCoof(rw,rh,FFormatAlg[0]);
       pg_Middle:  fontRatio:=GetCoof(rw,rh,FFormatAlg[1]);
       pg_Max:     fontRatio:=GetCoof(rw,rh,FFormatAlg[2]);
    end;
{    if fontRatio>ratio then fontRatio:=ratio;}
    LabelFontRatio:=fontRatio*FBPLSAGraph.FMaxCH;
    FBPLSAGraph.DefWidth:=(PW*FHorzPageCount-FPL*FHorzPageCount-FPR*FHorzPageCount);
    if ((FHorzPageCount=1) and (FVertPageCount=1)) then
     FBPLSAGraph.DefHeight:=(PH*FVertPageCount-FPT*FVertPageCount-FPB*FVertPageCount-ramkaH*FVertPageCount)
    else
    FBPLSAGraph.DefHeight:=(PH*FVertPageCount-FPT*FVertPageCount-FPB*FVertPageCount);
    FBPLSAGraph.SetDefaultConstants;
    FBPLSAGraph.SetScaledConstants(wc,hc,ratio,fontRatio,LabelFontRatio);
    FBPLSAGraph.CreateGraphNodes(wc,hc);
    FBPLSAGraph.CreateGraphLinks(wc,hc);
    FBPLSAGraph.PresetupFrame(wc,hc);
    FBPLSAGraph.TraceRoute;
    Repaint;
    while FPainting do;
    for px:=1 to FHorzPageCount do
     begin
      clRect.Left:=(px-1)*(pw-fpl-fpr);
      clRect.Right:=px*(pw-fpl-fpr);
      for py:=1 to FVertPageCount do
       begin
        clRect.Top:=(py-1)*(ph-fpt-fpb);
        clRect.Bottom:=py*(ph-fpt-fpb);
        if ((FHorzPageCount=1) and (FVertPageCount=1)) then
         begin
          PaintTo(FPrinter.Canvas.Handle,fpl,fpt+ramkaH);
          PreviewPrintRect(fpl,pw-fpr,fpt,ph-fpb);
         end
        else
         begin
          PaintPageTo(FPrinter.Canvas.Handle,fpl,fpt,clRect);
          PreviewPrintRect(fpl,pw-fpr,fpt,ph-fpb);
         end;
         if ((FHorzPageCount<>px) or (FVertPageCount<>py)) then
          FPrinter.NewPage;
       end;
     end;
     if (j<>(FBPLSAGRaph.DiagCount-1)) then FPrinter.NewPage;
    end; { For Diags }
    tmpTree:=tmpTree^.next;
    if tmpTree<>nil then FPrinter.NewPage;
    end
     else { getFirstInPoint }
     tmpTree:=tmpTree^.next;
   end; { while }
   finally
    if FAborting then FPrinter.AbortDoc else
    FPrinter.EndDoc;
    FPrinting:=False;
    FUpdatingNavigator:=False;
    FPreviewOrPrint:=False;
    FBPLSAGraph.SetDefaultConstants;
    FBPLSAGraph.Printing:=False;
    FBPLSAGraph.CreateGraphNodes(1,1);
    FBPLSAGraph.CreateGraphLinks(1,1);
    FBPLSAGraph.SetScaled2(oldScaled2);
    FBPLSAGraph.SetScaled(oldScaled);
    if (not(oldScaled)) then FBPLSAGraph.PresetupFrame(1,1);
    FBPLSAGraph.TraceRoute;
    Invalidate;
    pb.Position:=100;
    lbl.Caption:=IntToStr(pb.Position);
    pb.Update;
    lbl.Update;
    FBPLSAGraph.OpenLevel(oldLevel,oldDiag);
    FBPLSAGraph.TraceRoute;
    Invalidate;
   end;
end;

procedure TBPLSAFrame.PreviewPrintRect(left,right,top,bottom:Integer);  { Checked }
Var oldStyle:TPenStyle;
    oldSize:Integer;
    w,h:Integer;
    s:String;
begin
 if FPrinter = nil then Exit;
 with FPrinter.Canvas do
  begin
   oldStyle:=Pen.Style;
   Pen.Style:=psSolid;
   oldSize:=Font.Size;
   Font.Size:=16;
   s:='A'+FBPLSAGraph.FSSLevel+' '+FBPLSAGraph.Caption+' : '+IntToStr(FBPLSAGraph.CurDiag);
   w:=TextWidth(s);
   h:=TextHeight(s);
   TextOut(Left+((Right-Left-w) div 2),Top+2*h,s);
   Font.Size:=oldSize;
   Pen.Style:=psDot;
   MoveTo(Left,Top);
   LineTo(Right,Top);
   LineTo(Right,Bottom);
   LineTo(Left,Bottom);
   LineTo(Left,Top);
   Pen.Style:=oldStyle;
  end;
end;

procedure TBPLSAFrame.CreatePreview; { Checked }
Var savedOrd:TPrinterOrientation;
    pw,ph:Integer;
    fpl,fpr,fpt,fpb:Integer;
    ratio,fontRatio,LabelFontRatio:Double;
    dc:HDC;
    rw,rh:Double;
    scrppi:LongInt;
    ramkaH:Integer;
    nw,nh,mw,mh:Integer;
    oldScaled:Boolean;
    oldScaled2:Boolean;
    px,py:Integer;
    clRect:TRect;
    aSize:Integer;
    tmpi:TQRPaperSize;
    FTmp:Double;
    wc,hc:Double;
    pgalg:TBPPgAlg;
begin
 { Create QRPreview }
   oldScaled:=BPLSAGraph.Scaled;
   oldScaled2:=BPLSAGraph.Scaled2;
   FUpdatingNavigator:=True;
   FPreviewOrPrint:=True;
   if (FBPLSAGraph.FMaxNodesCount>FNodesValue[0]) then
      begin
        if (FBPLSAGraph.FMaxNodesCount<FNodesValue[1]) then
          pgAlg:=pg_Middle
        else
          pgAlg:=pg_Max;
      end
     else pgalg:=pg_Min;
   FBPLSAGraph.Scaled2:=False;
   if FBPLSAGraph.FScaled then FBPLSAGraph.Scaled:=False;
   if HorzScrollBar.Visible then HorzScrollBar.Position:=0;
   if VertScrollBar.Visible then VertScrollBar.Position:=0;
   if (fPrinter<>nil) then fPrinter.Free;
   savedOrd:=Printer.Orientation;
   FPrinter:=TQRPrinter.Create;
   try
    FPrinting:=True;
    FPrinter.Cleanup;
    FPrinter.BeginDoc;
    FPrinter.Orientation:=poPortrait;
    Printer.Orientation:=poPortrait;
    FPrinter.PrinterIndex:=Printer.PrinterIndex;
    aSize:=Printer.PaperSize;
    FPrinter.PaperSize:=Default;
    FRamkaFontRatio:=1.0;
    FPSizeH:=21;
    FPSizeW:=29.7;
    for tmpi:= Default to Custom do
     begin
      if aSize=cQRPaperTranslate[tmpI] then
         begin
           FPrinter.PaperSize := tmpI;
           FRamkaFontRatio:=cQRPaperSizeMetrics[tmpI,0]/cQRPaperSizeMetrics[A4,0];
           FPSizeH:=cQRPaperSizeMetrics[tmpI,0]/10;
           FPSizeW:=cQRPaperSizeMetrics[tmpI,1]/10;
         end;
     end;
     FPrinter.PaperLength:=Printer.PaperLength;
     FPrinter.PaperWidth:=Printer.PaperWidth;
   dc:=GetDC(0);
   scrppi:=GetDeviceCaps(dc,LOGPIXELSX);
   FFontCoof:=1;
   FBPLSAGraph.UpdateMaxFontSize(1);
   ReleaseDC(0,dc);
   ramkaH:=Round(scrppi/2.54);
   FRamkaH:=ramkaH;
    FPrinter.NewPage;
{   if SavedOrd=poPortrait then
   begin}
    pw:= FPrinter.XSize(FPrinter.PaperWidth);
    ph:= FPrinter.YSize(FPrinter.PaperLength);
{   end
   else
   begin
    pw:= FPrinter.XSize(FPrinter.PaperLength);
    ph:= FPrinter.YSize(FPrinter.PaperWidth);
   end;}
   if ((FHorzPageCount=1) and (FVertPageCount=1)) then
    ph:=ph-ramkaH;
   rw:=(pw*FHorzPageCount)/FBPLSAGraph.DefWidth;
   rh:=(ph*FVertPageCount)/FBPLSAGraph.DefHeight;
{   wc:=rw;
    hc:=rh; }
   case pgAlg of
      pg_Min:     Ratio:=GetCoof(rw,rh,FFormatAlg[0]);
      pg_Middle:  Ratio:=GetCoof(rw,rh,FFormatAlg[1]);
      pg_Max:     Ratio:=GetCoof(rw,rh,FFormatAlg[2]);
   end; {case pgAlg }
   fpl:=FPrinter.XSize(FPageLeft*10);
   fpr:=FPrinter.XSize(FPageRight*10);
   fpt:=FPrinter.YSize(FPageTop*10);
   fpb:=FPrinter.YSize(FPageBottom*10);
   wc:=FBPLSAGraph.DefWidth;
   hc:=FBPLSAGraph.DefHeight;
   FBPLSAGraph.SetDefaultConstants;
   FBPLSAGraph.SetScaledConstants(rw,rh,ratio,ratio,ratio);
   FBPLSAGraph.DefWidth:=(PW*FHorzPageCount-FPL*FHorzPageCount-FPR*FHorzPageCount);
   if ((FHorzPageCount=1) and (FVertPageCount=1)) then
     FBPLSAGraph.DefHeight:=(PH*FVertPageCount-FPT*FVertPageCount-FPB*FVertPageCount-ramkaH*FVertPageCount)
   else
     FBPLSAGraph.DefHeight:=(PH*FVertPageCount-FPT*FVertPageCount-FPB*FVertPageCount);
   wc:=FBPLSAGraph.DefWidth/wc;
   hc:=FBPLSAGraph.DefHeight/hc;
   FBPLSAGraph.Printing:=True;
   FBPLSAGraph.CreateGraphNodes(wc,hc);
   FBPLSAGraph.CreateGraphLinks(wc,hc);
   FBPLSAGraph.PresetupFrame(wc,hc);
   FBPLSAGraph.TraceRoute;
   Repaint;
   while FPainting do;
    nw:=FBPLSAGraph.NodeWidth;
    nh:=FBPLSAGraph.NodeHeight;
    mw:=FBPLSAGraph.MaxWidth;
    mh:=FBPLSAGraph.MaxHeight;
    rw:=ratio*nw/mw;
    rh:=ratio*nh/mh;
    case pgAlg of
       pg_Min:     fontRatio:=GetCoof(rw,rh,FFormatAlg[0]);
       pg_Middle:  fontRatio:=GetCoof(rw,rh,FFormatAlg[1]);
       pg_Max:     fontRatio:=GetCoof(rw,rh,FFormatAlg[2]);
     end;
{    if fontRatio>ratio then fontRatio:=ratio;}
    LabelFontRatio:=fontRatio*FBPLSAGraph.FMaxCH;
    FBPLSAGraph.DefWidth:=(PW*FHorzPageCount-FPL*FHorzPageCount-FPR*FHorzPageCount);
    if ((FHorzPageCount=1) and (FVertPageCount=1)) then
      FBPLSAGraph.DefHeight:=(PH*FVertPageCount-FPT*FVertPageCount-FPB*FVertPageCount-ramkaH*FVertPageCount)
    else
     FBPLSAGraph.DefHeight:=(PH*FVertPageCount-FPT*FVertPageCount-FPB*FVertPageCount);
    FBPLSAGraph.SetDefaultConstants;
    FBPLSAGraph.SetScaledConstants(wc,hc,ratio,fontRatio,LabelFontRatio);
    FBPLSAGraph.CreateGraphNodes(wc,hc);
    FBPLSAGraph.CreateGraphLinks(wc,hc);
    FBPLSAGraph.PresetupFrame(wc,hc);
    FBPLSAGraph.TraceRoute;
    Repaint;
    while FPainting do;
    for px:=1 to FHorzPageCount do
    begin
     clrect.Left:=(px-1)*(pw-fpl-fpr);
     clRect.Right:=px*(pw-fpl-fpr);
     for py:=1 to FVertPageCount do
     begin
      clrect.Top:=(py-1)*(ph-fpt-fpb);
      clrect.Bottom:=py*(ph-fpt-fpb);
      if ((FHorzPageCount=1) and (FVertPageCount=1)) then
       begin
         PaintTo(FPrinter.Canvas.Handle,fpl,fpt+ramkaH);
         PreviewPrintRect(FPageLeft,pw-FPageRight,FPageTop,ph+ramkaH-FPageBottom);
       end
       else
        begin
         PaintPageTo(FPrinter.Canvas.Handle,fpl,fpt{+ramkaH},clrect);
         PreviewPrintRect(fpl,pw-fpr,fpt,ph-fpb);
        end;
      if ((px<>FHorzPageCount) or (py<>FVertPageCount)) then FPrinter.NewPage;
     end;
    end;
   finally
    FPrinter.EndDoc;
    FPrinting:=False;
    FUpdatingNavigator:=False;
    FPreviewOrPrint:=False;
    FHorzPageCount:=1;
    FVertPageCount:=1;
    FBPLSAGraph.SetDefaultConstants;
    FBPLSAGraph.Printing:=False;
    FBPLSAGraph.CreateGraphNodes(1,1);
    FBPLSAGraph.CreateGraphLinks(1,1);
{    FBPLSAGraph.CheckLinksAndNodes;}
    FBPLSAGraph.SetScaled2(oldScaled2);
    FBPLSAGraph.SetScaled(oldScaled);
    if (not(oldScaled)) then FBPLSAGraph.PresetupFrame(1,1);
    FBPLSAGraph.TraceRoute;
    Invalidate;
   end;
end;

procedure TBPLSAFrame.CreateBitmap(var value:TBitmap;pf:TPixelFormat); { Checked }
 begin
  try
   FUpdatingNavigator:=True;
   FPreviewOrPrint:=True;
   FFontCoof:=1;
   FBPLSAGraph.UpdateMaxFontSize(1);
   if HorzScrollBar.Visible then HorzScrollBar.Position:=0;
   if VertScrollBar.Visible then VertScrollBar.Position:=0;
   Visible:=False;
   value:=TBitmap.Create;
   value.PixelFormat:=pf;
   value.Width:=FBPLSAGraph.FDefWidth;
   value.Height:=FBPLSAGraph.FDefHeight;
   Repaint;
   while FPainting do;
   value.Canvas.Lock;
   PaintTo(value.Canvas.Handle,0,0);
   Value.Canvas.Unlock;
  finally
    FUpdatingNavigator:=False;
    FPreviewOrPrint:=False;
    Visible:=True;
  end;
 end;

procedure TBPLSAFrame.CreateBitmapWithSize(var value:TBitmap;pf:TPixelFormat;iw,ih:Integer); { scaled bitmap } { Checked }
Var oldScaled:Boolean;
    oldScaled2:Boolean;
    oldPrinting:Boolean;
    rw,rh:Double;
    ratio,fontRatio,LabelFontRatio:Double;
    nw,nh:Integer;
    mw,mh:Integer;
    wc,hc:Double;
    pgalg:TBPPgAlg;
 begin
  try
   FUpdatingNavigator:=True;
   if (FBPLSAGraph.FMaxNodesCount>FNodesValue[0]) then
      begin
        if (FBPLSAGraph.FMaxNodesCount<FNodesValue[1]) then
          pgAlg:=pg_Middle
        else
          pgAlg:=pg_Max;
      end
     else pgalg:=pg_Min;
   oldScaled:=FBPLSAGraph.Scaled;
   oldScaled2:=FBPLSAGraph.Scaled2;
   oldPrinting:=FBPLSAGraph.Printing;
   if HorzScrollBar.Visible then HorzScrollBar.Position:=0;
   if VertScrollBar.Visible then VertScrollBar.Position:=0;
   Visible:=False;
   if FBPLSAGraph.Scaled2 then FBPLSAGraph.Scaled2:=False;
   if FBPLSAGraph.Scaled then FBPLSAGraph.Scaled:=False;
   FPrinting:=True;
   rw:=iw/FBPLSAGraph.DefWidth;
   rh:=ih/FBPLSAGraph.DefHeight;
   wc:=rw;
   hc:=rh;
   case pgAlg of
      pg_Min:     Ratio:=GetCoof(rw,rh,FFormatAlg[0]);
      pg_Middle:  Ratio:=GetCoof(rw,rh,FFormatAlg[1]);
      pg_Max:     Ratio:=GetCoof(rw,rh,FFormatAlg[2]);
   end; {case pgAlg }
   FBPLSAGraph.SetDefaultConstants;
   FBPLSAGraph.SetScaledConstants(rw,rh,ratio,ratio,ratio);
   FBPLSAGraph.DefHeight:=ih;
   FBPLSAGraph.DefWidth:=iw;
   FBPLSAGraph.Printing:=True;
   FBPLSAGraph.CreateGraphNodes(wc,hc);
   FBPLSAGraph.CreateGraphLinks(wc,hc);
   FBPLSAGraph.PresetupFrame(wc,hc);
   FBPLSAGraph.TraceRoute;
   Repaint;
   while FPainting do;
   nw:=FBPLSAGraph.NodeWidth;
   nh:=FBPLSAGraph.NodeHeight;
   mw:=FBPLSAGraph.MaxWidth;
   mh:=FBPLSAGraph.MaxHeight;
   rw:=ratio*nw/mw;
   rh:=ratio*nh/mh;
   case pgAlg of
       pg_Min:     fontRatio:=GetCoof(rw,rh,FFormatAlg[0]);
       pg_Middle:  fontRatio:=GetCoof(rw,rh,FFormatAlg[1]);
       pg_Max:     fontRatio:=GetCoof(rw,rh,FFormatAlg[2]);
   end;
{   if fontRatio>ratio then fontRatio:=ratio;}
   LabelFontRatio:=fontRatio*FBPLSAGraph.FMaxCH;
   FBPLSAGraph.DefHeight:=ih;
   FBPLSAGraph.DefWidth:=iw;
   FBPLSAGraph.SetDefaultConstants;
   FBPLSAGraph.SetScaledConstants(wc,hc,ratio,fontRatio,LabelFontRatio);
   FBPLSAGraph.CreateGraphNodes(wc,hc);
   FBPLSAGraph.CreateGraphLinks(wc,hc);
   FBPLSAGraph.PresetupFrame(wc,hc);
   FBPLSAGraph.TraceRoute;
   Repaint;
   while FPainting do;
   value:=TBitmap.Create;
   value.PixelFormat:=pf;
   value.Width:=iw;
   value.Height:=ih;
   while FPainting do;
   value.Canvas.Lock;
   PaintTo(value.Canvas.Handle,0,0);
   value.Canvas.Unlock;
  finally
   FPrinting:=False;
   FBPLSAGraph.SetDefaultConstants;
   FBPLSAGraph.Printing:=oldPrinting;
   FBPLSAGraph.CreateGraphNodes(1,1);
   FBPLSAGraph.CreateGraphLinks(1,1);
{   FBPLSAGraph.CheckLinksAndNodes;}
   FBPLSAGraph.SetScaled2(oldScaled2);
   FBPLSAGraph.SetScaled(oldScaled);
   if (not(oldScaled)) then FBPLSAGraph.PresetupFrame(1,1);
   FUpdatingNavigator:=False;
   FBPLSAGraph.TraceRoute;
   Invalidate;
   Visible:=True;
  end;
 end;

procedure TBPLSAFrame.DrawNode(l,t,w,h:Integer;Canvas:TCanvas;PaintColor,DrawColor:TColor;ShapeType:TLSAShapeType);
Var r1:TRect;
  oldPenColor:TColor;
  oldBrushColor:TColor;
    mh:Integer;
 begin
    oldBrushColor:=Canvas.Brush.Color;
    oldPenColor:=Canvas.Pen.Color;
    Canvas.Brush.Color:=PaintColor;
    Canvas.Pen.Color:=DrawColor;
    case ShapeType of
    lsa_Node: begin
                r1.Left:=l;
                r1.Top:=t;
                r1.Right:=l+w;
                r1.Bottom:=t+h;
                Canvas.FillRect(r1);
                Canvas.MoveTo(l,t);
                Canvas.LineTo(l+w,t);
                Canvas.LineTo(l+w,t+h);
                Canvas.LineTo(l,t+h);
                Canvas.LineTo(l,t);
              end;
    lsa_Junction: begin
                    r1.Left:=l;
                    r1.Top:=t;
                    r1.Right:=l+w;
                    r1.Bottom:=t+h;
                    if w<h then mh:=w else mh:=h;
                    Canvas.MoveTo(l+(mh div 2),t);
                    Canvas.LineTo(l+w-(mh div 2),t);
                    Canvas.LineTo(l+w,t+(h div 2));
                    Canvas.LineTo(l+w-(mh div 2),t+h);
                    Canvas.LineTo(l+(mh div 2),t+h);
                    Canvas.LineTo(l,t+(h div 2));
                    Canvas.LineTo(l+(mh div 2),t);
                    Canvas.FloodFill((w div 2)+l,t+(h div 2),DrawColor,fsBorder);
                  end;
   end; { case }
   Canvas.Brush.Color:=oldBrushColor;
   Canvas.Pen.Color:=oldPenColor;
end;

procedure TBPLSAFrame.DrawLink(pl:PLSAGraphLink;Canvas:TCanvas;RatioX,RatioY:Double;Wpos,Hpos:Integer);
Var i,cnt:Integer;
    oldPenColor:TColor;
    oldPenStyle:TPenStyle;
begin
{}
  if pl=nil then Exit;
  oldPenColor:=Canvas.Pen.Color;
  oldPenStyle:=Canvas.Pen.Style;
  Canvas.Pen.Color:=pl^.Color;
  Canvas.Pen.Style:=pl^.PenStyle;
  cnt:=pl^.LinePointCount-1;
  Canvas.MoveTo(Round((pl^.LineArrayX[0]+wpos)*RatioX),Round((pl^.LineArrayY[0]+hpos)*RatioY));
  for i:=1 to cnt do
   begin
      Canvas.LineTo(Round((pl.LineArrayX[i]+wpos)*RatioX),Round((pl^.LineArrayY[i]+hpos)*RatioY));
    end;
  Canvas.Pen.Color:=oldPenColor;
  Canvas.Pen.Style:=oldPenStyle;
end;


procedure TBPLSAFrame.GetBitmapWithSize(value:TBitmap;iw,ih:Integer); { scaled bitmap } { Checked }
Var rw,rh:Double;
    nw,nh:Integer;
    mw,mh:Integer;
    wc,hc:Double;
    i:Integer;
    wl,wt,ww,wh:Integer;
    node:PLSAGraphNode;
    link:PLSAGraphLink;
    hpos,vpos:Integer;
 begin
  try
   FUpdatingNavigator:=True;
   if HorzScrollBar.Visible then hpos:=HorzScrollBar.Position;
   if VertScrollBar.Visible then vpos:=VertScrollBar.Position;
   Visible:=False;
   if HorzScrollBar.Visible then HorzScrollBar.Position:=0;
   if VertScrollBar.Visible then VertScrollBar.Position:=0;
   while FPainting do;
   rw:=iw/(FBPLSAGraph.DefWidth+1);
   rh:=ih/(FBPLSAGraph.DefHeight+1);
   value.Canvas.Lock;
   Value.Canvas.FillRect(Value.Canvas.ClipRect);
   { Draw Node}
     node:=FBPLSAGraph.FGraphNodes;
    for i:=0 to (FBPLSAGraph.FGNodesCount-1) do
    begin
     wl:=Round(node^.BPNode.Left*rw);
     wt:=Round(node^.BPNode.Top*rh);
     ww:=Round(node^.BPNode.Width*rw);
     wh:=Round(node^.BPNode.Height*rh);
     DrawNode(wl,wt,ww,wh,Value.Canvas,node^.BPNode.PaintColor,node^.BPNode.RectColor,node^.BPNode.ShapeType);
     node:=node^.next;
    end;
     { Draw Links}
    link:=BPLSAGraph.FGraphLinks;
    for i:=0 to(BPLSAGraph.FGLinksCount-1) do
    begin
     if link^.Visible then  DrawLink(link,value.Canvas,rw,rh,hpos,vpos);
     link:=link^.next;
    end;
   value.Canvas.Unlock;
  finally
   if HorzScrollBar.Visible then HorzScrollBar.Position:=hpos;
   if VertScrollBar.Visible then VertScrollBar.Position:=vpos;
   Visible:=True;
   FUpdatingNavigator:=False;
  end;
 end;


procedure TBPLSAFrame.CreateBitmapForOneShit(var value:TBitmap;pf:TPixelFormat;iw,ih,shitw,shith,maxshitw,maxshith:Integer); { Checked }
Var oldScaled:Boolean;
    oldScaled2:Boolean;
    oldPrinting:Boolean;
    rw,rh:Double;
    ratio,fontRatio,LabelFontRatio:Double;
    nw,nh:Integer;
    mw,mh:Integer;
    clRect:TRect;
    wc,hc:Double;
    pgalg:TBPPgAlg;
 begin
    try
   FUpdatingNavigator:=True;
   if (FBPLSAGraph.FMaxNodesCount>FNodesValue[0]) then
      begin
        if (FBPLSAGraph.FMaxNodesCount<FNodesValue[1]) then
          pgAlg:=pg_Middle
        else
          pgAlg:=pg_Max;
      end
     else pgalg:=pg_Min;
   oldScaled:=FBPLSAGraph.Scaled;
   oldScaled2:=FBPLSAGraph.Scaled2;
   oldPrinting:=FBPLSAGraph.Printing;
   if HorzScrollBar.Visible then HorzScrollBar.Position:=0;
   if VertScrollBar.Visible then VertScrollBar.Position:=0;
   Visible:=False;
   if FBPLSAGraph.Scaled2 then FBPLSAGraph.Scaled2:=False;
   if FBPLSAGraph.Scaled then FBPLSAGraph.Scaled:=False;
   FPrinting:=True;
   rw:=(iw*maxshitw)/FBPLSAGraph.DefWidth;
   rh:=(ih*maxshith)/FBPLSAGraph.DefHeight;
   wc:=rw;
   hc:=rh;
   case pgAlg of
      pg_Min:     Ratio:=GetCoof(rw,rh,FFormatAlg[0]);
      pg_Middle:  Ratio:=GetCoof(rw,rh,FFormatAlg[1]);
      pg_Max:     Ratio:=GetCoof(rw,rh,FFormatAlg[2]);
   end; {case pgAlg }
   FBPLSAGraph.SetDefaultConstants;
   FBPLSAGraph.SetScaledConstants(rw,rh,ratio,ratio,ratio);
   FBPLSAGraph.DefHeight:=ih*maxshith;
   FBPLSAGraph.DefWidth:=iw*maxshitw;
   FBPLSAGraph.Printing:=True;
   FBPLSAGraph.CreateGraphNodes(wc,hc);
   FBPLSAGraph.CreateGraphLinks(wc,hc);
   FBPLSAGraph.PresetupFrame(wc,hc);
   FBPLSAGraph.TraceRoute;
   Repaint;
   while FPainting do;
   nw:=FBPLSAGraph.NodeWidth;
   nh:=FBPLSAGraph.NodeHeight;
   mw:=FBPLSAGraph.MaxWidth;
   mh:=FBPLSAGraph.MaxHeight;
   rw:=ratio*nw/mw;
   rh:=ratio*nh/mh;
   case pgAlg of
       pg_Min:     fontRatio:=GetCoof(rw,rh,FFormatAlg[0]);
       pg_Middle:  fontRatio:=GetCoof(rw,rh,FFormatAlg[1]);
       pg_Max:     fontRatio:=GetCoof(rw,rh,FFormatAlg[2]);
   end;
{   if fontRatio>ratio then fontRatio:=ratio;}
   LabelFontRatio:=fontRatio*FBPLSAGraph.FMaxCH;
   FBPLSAGraph.DefHeight:=ih*maxshith;
   FBPLSAGraph.DefWidth:=iw*maxshitw;
   FBPLSAGraph.SetDefaultConstants;
   FBPLSAGraph.SetScaledConstants(wc,hc,ratio,fontRatio,LabelFontRatio);
   FBPLSAGraph.CreateGraphNodes(wc,hc);
   FBPLSAGraph.CreateGraphLinks(wc,hc);
   FBPLSAGraph.PresetupFrame(wc,hc);
   FBPLSAGraph.TraceRoute;
   Repaint;
   while FPainting do;
   value:=TBitmap.Create;
   value.PixelFormat:=pf;
   value.Width:=iw;
   value.Height:=ih;
   while FPainting do;
   clrect.Left:=shitw*iw;
   clRect.Right:=(shitw+1)*iw;
   clrect.Top:=shith*ih;
   clrect.Bottom:=(shith+1)*ih;
   value.Canvas.Lock;
   PaintPageTo(Value.Canvas.Handle,0,0,clrect);
   value.Canvas.Unlock;
  finally
   FPrinting:=False;
   FBPLSAGraph.SetDefaultConstants;
   FBPLSAGraph.Printing:=oldPrinting;
   FBPLSAGraph.CreateGraphNodes(1,1);
   FBPLSAGraph.CreateGraphLinks(1,1);
   FBPLSAGraph.SetScaled2(oldScaled2);
   FBPLSAGraph.SetScaled(oldScaled);
   if (not(oldScaled)) then FBPLSAGraph.PresetupFrame(1,1);
   FUpdatingNavigator:=False;
   FBPLSAGraph.TraceRoute;
   Invalidate;
   Visible:=True;
  end;
 end;

procedure TBPLSAFrame.SetPageParam(Var PageTop,PageBottom,PageLeft,PageRight:Integer;ShowWarning:Boolean); { Checked }
Var px,py,plofs,ptofs,pbofs,profs:Integer;
    s:String;
    pw,ph,hw,hh:Integer;
    po:TPrinterOrientation;
Const   es='      .    ';
        se=' ';
begin
 po:=Printer.Orientation;
 case po of
 poPortrait:
   begin
    px:=GetDeviceCaps(Printer.Handle,LOGPIXELSX);
    py:=GetDeviceCaps(Printer.Handle,LOGPIXELSY);
    plofs:=GetDeviceCaps(Printer.Handle,PHYSICALOFFSETX);
    ptofs:=GetDeviceCaps(Printer.Handle,PHYSICALOFFSETY);
    pw:=GetDeviceCaps(Printer.Handle,PHYSICALWIDTH);
    hw:=GetDeviceCaps(Printer.Handle,HORZRES);
    ph:=GetDeviceCaps(Printer.Handle,PHYSICALHEIGHT);
    hh:=GetDeviceCaps(Printer.Handle,VERTRES);
   end;
  poLandscape:
   begin
    py:=GetDeviceCaps(Printer.Handle,LOGPIXELSX);
    px:=GetDeviceCaps(Printer.Handle,LOGPIXELSY);
    ptofs:=GetDeviceCaps(Printer.Handle,PHYSICALOFFSETX);
    plofs:=GetDeviceCaps(Printer.Handle,PHYSICALOFFSETY);
    ph:=GetDeviceCaps(Printer.Handle,PHYSICALWIDTH);
    hh:=GetDeviceCaps(Printer.Handle,HORZRES);
    pw:=GetDeviceCaps(Printer.Handle,PHYSICALHEIGHT);
    hw:=GetDeviceCaps(Printer.Handle,VERTRES);
   end;
 end;
 pbofs:=ph-hh-ptofs;
 profs:=pw-hw-plofs;
 FPageTop:=Round(PageTop*py/25.4)-ptofs;
 FPageBottom:=Round(PageBottom*py/25.4)-pbofs;
 FPageLeft:=Round(PageLeft*px/25.4)-plofs;
 FPageRight:=Round(PageRight*px/25.4)-profs;
 if ShowWarning then
 begin
 if FPageTop<0 then
   begin
   s:=se+''+es;
   Application.MessageBox(PChar(s),' !',MB_OK);
   FPageTop:=0;
   PageTop:=Round(ptofs*25.4/py)+1;
   end;
  if FPageBottom<0 then
   begin
   s:=se+''+es;
   Application.MessageBox(PChar(s),' !',MB_OK);
   FPageBottom:=0;
   PageBottom:=Round(pbofs*25.4/py)+1;
   end;
  if FPageLeft<0 then
   begin
   s:=se+''+es;
   Application.MessageBox(PChar(s),' !',MB_OK);
   FPageLeft:=0;
   PageLeft:=Round(plofs*25.4/px)+1;
   end;
  if FPageRight<0 then
   begin
   s:=se+''+es;
   Application.MessageBox(PChar(s),' !',MB_OK);
   FPageRight:=0;
   PageRight:=Round(profs*25.4/px)+1;
   end;
  end;
end;

procedure TBPLSAFrame.SetPreviewPageParam(PageTop,PageBottom,PageLeft,PageRight:Integer); { Checked }
Var px,py:Integer;
begin
 FPageTop:=PageTop;
 FPageBottom:=PageBottom;
 FPageLeft:=PageLeft;
 FPageRight:=PageRight;
end;

function TBPLSAFrame.GetCoof(rw,rh:Double;Alg:TBPFormatAlg):Double;
 begin
   case Alg of
     fa_Min:  if rw>=rh then Result:=rh else Result:=rw;
     fa_Max:  if rw>=rh then Result:=rw else Result:=rh;
     fa_Sqrt: Result:=Sqrt(rw*rh);
     fa_Sum:  Result:=(rw+rh)/2;
     fa_Width:  Result:=rw;
     fa_Height: Result:=rh;
   end;
 end;


procedure Register; { Checked }
begin
  RegisterComponents('DeadSouls', [TBPLSAFrame]);
end;

end.