Unit BPFrame;

{ EIDEF0 Diagram Module }
{ Partially corrected 24.12.98 }
{ Rewritten 14-09-98 }
{ Corrected 01-11-00 }
{ Rewritten  16-11-00 }
{ Modified  06-08-02 }


Interface

Uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
     ComCtrls,StdCtrls,Menus,BPDef,BPStream,BPNode,BPLabel,Printers,QRPrntr,
     MyUtils,TFlatProgressBarUnit;

Type

  PGraphNode=^TGraphNode;
  TGraphNode=record
    BPNode:TBPGraphNode;
    CorrectNode:Boolean;
    llNode:PBPNode;
    next:PGraphNode;
  end;

  PDGraphNode=^TDGraphNode;
  TDGraphNode=record
    BPDNode:TBPDGraphNode;
    CorrectNode:Boolean;
    next:PDGraphNode;
  end;

  PDInProcessNode=^TDInProcessNode;
  TDInProcessNode=record
    node:PBPInProcessNode;
    flags:DWORD;
    Count:Integer;
    next:PDInProcessNode;
  end;

  PGraphLink=^TGraphLink;
  TGraphLink=record
     BPFromLabel:TBPLabel; {TBPLabel}
     BPToLabel:TBPLabel; {TBPLabel}
     BPGlobalLabel:TBPLabel;
     FromNodeNumber:DWORD;
     ToNodeNumber:DWORD;
     dwFlags:DWORD;
     FromLinkNumber:DWORD; { CurrentWork ! }
     ToLinkNumber:DWORD;   { CurrentWork ! }
     CorrectLink:Boolean;
     LineArrayX:Array[0..20] of Integer;
     LineArrayY:Array[0..20] of Integer;
     LineSelected:Boolean;
     LinePointCount:DWORD;
     StartPoint:TPoint;
     EndPoint:TPoint;
     LinkFromCount:DWORD;
     LinkToCount:DWORD;
     LinkFromCountMTB:DWORD;
     LinkToCountMTB:DWORD;
     LinkFromUpCount:DWORD;
     LinkFromDownCount:DWORD;
     LinkToUpCount:DWORD;
     LinkToDownCount:DWORD;
     {!!!}
     LinkFromPos:DWORD;
     LinkToPos:DWORD;
     LinkFromAdd:DWORD;
     LinkToAdd:DWORD;
     {!!!}
     MinimalXFrom:Integer;
     MinimalXTo:Integer;
     MinimalYFrom:Integer;
     MinimalYTo:Integer;
     Color:TColor;                          { T's LinkType }
     PenStyle:TPenStyle;                    { T's LinkType }
     Visible:Boolean;               { New property visible }
     Tag:Integer;
     llLink:PBPLink;                       { For comparing }
     next:PGraphLink;
  end;

  TBPFrame = class;

  TBPGraph = class(TControl)
      private
       { Private declarations }
        FOwner:TBPFrame;
        FNodes:PBPNode;
        FLinks:PBPLink;
        FTree:PBPTree;     { Tree for model   }
        FNTTree:PBPNodeTypes; { NodeTypes Tree }
        FLTTree:PBPLinkTypes; { LinkTypes Tree }
        FOPTree:PBPOpTree;    { Operation Tree } { CurrentWork ! }
        FIPNode:PBPInProcessNode;
        FEntryArray:PBPEntryArray;
        FCheckGraphArray:PBPCheckGraphArray;
        FHeader:TBPHeader; { Header for model }
        FLevel:Integer;      { Level for model, model must have level -1 }
        FSSLevel:ShortString; { New level for model in x.x.x.x format }
                              { CurrentWork ! }
        FParentLevel:Integer;     { Parent level for model }
        FRootEntries:DWORD;
        FNodesCount:DWORD;
        FLinksCount:DWORD;
        FDNodesCount:DWORD;
        FLevelCaption:ShortString;
        FLevelRevision:DWORD;
        FLevelDraftStatus:TDraftStatus;
        FLevelPageNumber:DWORD;
        FLevelNotes:ShortString;
        FGraphNodes:PGraphNode;
        FDGraphNodes:PDGraphNode;
        FDLastNode:PDGraphNode;
        FGraphLinks:PGraphLink;
        FHaspFound:Boolean;
        FMaxWidth:Integer;
        FMaxHeight:Integer;
        FDMaxWidth:Integer;
        FDMaxHeight:Integer;
        FDPrjMaxHeight:Integer;
        { Global nodes links counters }
        FGlobalLeftLinksCount:Integer;
        FGlobalRightLinksCount:Integer;
        FGlobalTopLinksCount:Integer;
        FGlobalBottomLinksCount:Integer;
        FGlobalLeftSize:Integer;
        FGlobalRightSize:Integer;
        FGlobalTopSize:Integer;
        FGlobalBottomSize:Integer;
        FGlobalOperationSize:Integer;
        FBPFileStream:TBPFileStream; { For reading/writing object }
        { For printing and other }
        FDefWidth:Integer;
        FDefHeight:Integer;
        FPrinting:Boolean;
        FScreenFontName:TFontName;
        FPrinterFontName:TFontName;
        { Vars for mashtabing }
        FFontDPI:Integer;   { FontDPI }
        FFontSize:Integer;  { FontSize }
        FLabelFontSize:Integer;
        FMaxCh:Double;
         {lines mashtabing interval }
        FMinLineStep:Integer; { Line Step }
        FMinArcRadius:Integer;
        FMinLabelX:Integer;
        FMinLabelY:Integer;
        FMinLabelY1:Integer;
        FMinLabelX2:Integer;
        FMinLabelY2:Integer;
        FMinLabelY3:Integer;
        FMinLabelYNew:Integer;
        FMinGlobalLabel:Integer;
        FMinLineEndPoint:Integer;
        { nodes mashtabing vars }
        FNodeLineWidth:Integer;
        FNodeDefWidth:Integer;
        FNodeDefHeight:Integer;
        FNodeHSpacing:Integer;
        FNodeVSpacing:Integer;
        FNodeShadowDepth:Integer;
        FNodeWidth:Integer;
        FNodeHeight:Integer;
          {}
        FCalcWidthHeight:Boolean;
          { Debug routines }
        FDebug:Boolean;
        { AF Options }
        FTruncLRGlobalCaptions:Boolean;
        FTruncLRLocalCaptions:Boolean;
        FTruncDirection:Boolean;
        FFirstNodeNumber:DWORD;
        FLastNodeNumber:DWORD;
        FEnableA0Numeration:Boolean; { Enable A0 Numeration }
        FScaled:Boolean;             { Clip Windows to fit into ClipRect }
        FScaled2:Boolean;            { Clip Windows to fit into A3 format }
        FScaled2Ratio:Extended;      { Scaled2 Ratio }
        FDiscardDrags:Boolean;
        FRatioWC:Double;             { Ratio for recalc widthcoof }
        FRatioHC:Double;             { Ratio for recalc heightcoof }
        FRatioHC1:Double;
        FModified:Boolean;
        FAcceptDragRect:TRect;       { Rect for Accept Drags & Drop }
        FLinksPosRelative:Boolean;
        FShowDataware:Boolean;       { Show dataware at IDEF0 diagramm }
        FShowDatawareLine:Boolean;   { Show dataware line at FGlobalOperationSize pos }
        FOperationLabelsSize:Integer;
        FForAllLevels:Boolean;
        { Dugi sverhu i snizu }
        FMinTopSize:Integer;
        FMinBottomSize:Integer;
        FMultipleTopLinksCount:Integer;
        FMultipleBottomLinksCount:Integer;

        FbpOperationLinks:array[0..600] of PBPLink;
        FbpOpLinksCount:Integer;
        FTranslateNodesType:Integer;
        FMaxOpNodeHeight:Integer;

        FIPGraphNodes:PDInProcessNode;
        FIPNodesCount:Integer;
        { Nodes and Labels }
        FReplaceNodes:Boolean;
        FReplaceLabels:Boolean;
        FMaxWordLength:Integer;
        FMaxWordCount:Integer;
        FMaxLabelLength:Integer;
        { Barahlo}
        FDoOverrideFS:Boolean;
        FNodesFontSize:Integer;
        FDNodesFontSize:Integer;
        FDProjectionFontSize:Integer;
        FInProcessFontSize:Integer;
        FLabelsFontSize:Integer;
        FOverrideNodesFS:Boolean;
        FOverrideDNodesFS:Boolean;
        FOverrideInProcessFS:Boolean;
        FOverrideLabelsFS:Boolean;
        {      }
        FMaxFontSize:Integer;
        FRealMaxFontSize:Integer;
        {   GlobalOperationSize }
        FMaxGOS:Double; {      }
        FIOFontSize:Integer; {   }
        procedure SetMaxFontSize(Value:Integer);
        procedure UpdateMaxFontSize(Coof:Extended);
        function  GetNodeRect(nodeNum:DWORD):TRect;
        procedure CorrectGlobalLinks;
        procedure MyIncMLinks(link:PGraphLink;FromTo:Boolean;Incv:Integer);
        procedure CLCorrectLinks(link:PBPLink;FromTo:Boolean);
        procedure AnalizeStringsFonts;
        procedure ClearArrayOpLinks;
        function  CompareArrayOpLinks(l:PBPLink):Boolean;
        procedure WriteLinksToDebugFile;
        procedure WriteNodesToDebugFile;
        function  CheckLinksAndNodes:Boolean;
         { Graph routines }
        procedure  ClearIPNode;
        procedure  ClearNTTree;
        procedure  ClearLTTree;
        function   GetNTFromIndex(index:DWORD):TBPNodeTypes;
        function   GetLTFromIndex(index:DWORD):TBPLinkTypes;
        procedure  ClearTree;
        procedure  ClearOpTree; { CurrentWork ! }
        procedure  ClearGraphNodes;
        procedure  ClearDGraphNodes;
        procedure  ClearGraphLinks;
        procedure  CreateGraphNodes(wc,hc:Double);
        procedure  CreateGraphLinks(wc,hc:Double);
        procedure  CreateDGraphNodes(wc,hc:Double);
        function   GetMaxNodeNumber:DWORD;

        { Internal subroutines }
        function   GetMultipleMask(index:Integer):TBPMultipleMask;
        function   IsMultipleFirst(index:Integer;MultipleFrom:Boolean):Boolean;

        function   GetIndexedLink(index:DWORD):PBPLink;
        procedure  CalcMaxWidthHeight;
        procedure  CalcDNodesMaxWidthHeight;
        function   GetGraphNumberedNode(NodeNumber:DWORD):TBPGraphNode;
        function   GetDGraphNumberedNode(NodeNumber:DWORD):TBPDGraphNode;
        function   GetGraphLink(index:DWORD):PGraphLink;
        function   GetGraphNode(index:DWORD):TBPGraphNode;
        function   GetDGraphNode(index:DWORD):TBPDGraphNode;
        function   GetNodeFromCaption(sCaption:ShortString):TBPGraphNode;
        function   GetLinkFrom(const value:PGraphLink):TLinkType;
        function   GetLinkTo(const value:PGraphLink):TLinkType;

        function   GetMultipleCountFrom(index:Integer):Integer;
        function   GetMultipleCountTo(index:Integer):Integer;
        function   GetMultipleCountFromMTB(index:Integer):Integer;
        function   GetMultipleCountToMTB(index:Integer):Integer;

        function   GetMultipleFirst(index:Integer;MultipleFrom:Boolean):PGraphLink;
        procedure  DrawSS(sx,sy,dx,dy:Integer;color:TColor);
        procedure  DrawArrowX(x,y:Integer;Positive:Boolean);
        procedure  DrawArrowY(x,y:Integer;Positive:Boolean);
        { Level Header Rout}
        function   GetLevelHeader:PBPTree;
        procedure  SetLevelHeader(Value:PBPTree);
        { trace routines }
        procedure  CalcLabelSizes;
        procedure  TraceNodes;
        function   MaxLinkDownCount(NodeNum:DWORD;FromTo:Boolean):Integer;
        procedure  CorrectLinksToNodeCountersUpDown;
        procedure  TraceLinksToNodeCounters;
        procedure  TraceLinksToNodeCountersUpDown;
        procedure  TraceNodesToLinksCounters;
        procedure  TraceGlobalStartEndPoints;
        procedure  TraceLocalStartEndPoints;
        procedure  CorrectLinks;
        procedure  TraceLinks;
        procedure  DrawLinks;
        procedure  CalcMinimalXY;
        procedure  SetFontSize(Value:Integer);
        { Set scale of window to fit to Clip Rect }
        procedure  SetMaxGOS(Value:Double);
        procedure  SetScaled(Value:Boolean);
        procedure SetScaled2(Value:Boolean);
        procedure SetScaled2Ratio(Value:Extended);
        procedure SetDefWidth(Value:Integer);
        procedure SetDefHeight(Value:Integer);
        procedure SetDiscardDrags(Value:Boolean);
        procedure CorectMultipleLinks(value:TBPLabel);
        procedure UpdateNodesModel(X,Y:Integer;node:TBPGraphNode);
        procedure UpdateLinksModel(X,Y:Integer;llabel:TBPLabel);
        function  CompareGraphNodeWithNode(l1:TBPGraphNode;l2:PBPNode):Boolean;
        function  CompareGraphLinkWithLink(l1:PGraphLink;l2:PBPLink;CompareFrom:Boolean):Boolean;
        procedure MyNodeMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
        procedure MyLabelMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
        procedure MyNodeDblClick(Sender: TObject);
        procedure CorrectLinksModel(delta:TPoint;NodeNum:DWORD;AcceptRect:TRect);
        function  GetLevelCaption:ShortString;
        procedure SetShowDataware(Value:Boolean);
        procedure SetShowDatawareLine(Value:Boolean);
        procedure DrawDataWareLine;
        procedure AddDNode(num:DWORD;Cap:String;Prj:String;HintPrj:String;index:Integer;snn:ShortString);
        function  GetDNode(num:DWORD):PBPOpTree;
        function  CheckForDecompose(ssNumber:String):Boolean;
        function  GetNodeCaption(nodeP:PBPNode):String;
        procedure SetTranslateNodesType(Value:Integer);
        function  CheckForExIP(nodeP:PBPInProcessNode;flags:DWORD):Boolean;
        procedure ClearIPGraphNodes;
        procedure CreateIPGraphNodes(wc,hc:Double); { Checked }
        function  GetLinkCaption(nodeNum:DWORD;flags:DWORD):ShortString;
        procedure DrawCircle(x,y,radius,deltax,deltay:Integer);
        function  GetIPGraphNumberedNode(nodeNum,flags:DWORD):PDInProcessNode;
      public
       { Public declarations }
        FLang:TFontCharset;
        procedure   Optimize;
        procedure   OptimizeModel(pb:TFlatProgressBar;Lbl:TLabel);
        function    OptimizeNodeFonts:Integer;
        procedure   SetMaxAll(BReplaceNodes,BReplaceLabels:Boolean;IMaxWordLength,IMaxWordCount,IMaxLabelLength:Integer);
        procedure   SetOverrideFonts(NFS,DNFS,DPFS,IPFS,LFS:Integer;ONFS,ODFS,OIFS,OLFS:Boolean);
        procedure   SetOverrideFontsAll(NFS,DNFS,DPFS,IPFS,LFS:Integer;ONFS,ODFS,OIFS,OLFS:Boolean;
                                        CNFS,CDNFS,CDPFS,CIPFS,CLFS,CONFS,CODFS,COIFS,COLFS:Boolean);
        constructor Create(AOwner: TComponent); override;
        destructor  Destroy; override;
        procedure   TraceRoute; { Main Tracing Procedure }
        function    LoadFromFile(FileName:String):Boolean;
        function    SaveToFile(FileName:String):Boolean;
        procedure   OpenLevel(wLevel:Integer);
        procedure   PresetupFrame(widthcoof,heightcoof:Double);
        { Scale }
        procedure  SetDefaultConstants;
        procedure  SetScaledConstants(ratiox,ratioy,ratio:Double;fontSizeRatio:Double;LabelFontSizeRatio:Double;IOFontSizeRatio:Double);
        { Level}
        function  GetLevelsCount:Integer;
        function  GetLevelInfo(index:Integer):TBPInfo;
        function  GetTreeLevelFromSNumber(SNumber:ShortString):Integer;
        { A0 numeration}
        procedure SetEnableA0Numeration(Value:Boolean);
        { Visio 2k integration }
        procedure WriteVisio2k(FileName:String);
        { Additional Calculation }
        function  GetMaxDNodeLinksCount:Integer;
        function  GetMaxPagesCount:Integer;
        procedure FillBPInfoBlock(var InfoBlock:TBPInfoBlock);
        procedure SetNodeCaption(node:TBPGraphNode;Text:ShortString);
        procedure SetLinkCaption(mlabel:TBPLabel;Text:ShortString);
      published
       { Published declarations }
       property Parent:TBPFrame read FOwner write FOwner;
       property FontDPI:Integer read FFontDPI write FFontDPI;
       property DefWidth:Integer read FDefWidth write SetDefWidth;
       property DefHeight:Integer read FDefHeight write SetDefHeight;
       property MaxWidth:Integer read FMaxWidth;
       property MaxHeight:Integer read FMaxHeight;
       property PrjMaxHeight:Integer read FDPrjMaxHeight;
       property NodeWidth:Integer read FNodeWidth;
       property NodeHeight:Integer read FNodeHeight;
       property Printing:Boolean read FPrinting write FPrinting;
       property MinLineStep:Integer read FMinLineStep write FMinLineStep default 6;
       property GlobalLeftSize:Integer read FGlobalLeftSize write FGlobalLeftSize default 40;
       property GlobalRightSize:Integer read FGlobalRightSize write FGlobalRightSize default 40;
       property GlobalTopSize:Integer read FGlobalTopSize write FGlobalTopSize default 40;
       property GlobalBottomSize:Integer read FGlobalBottomSize write FGlobalBottomSize default 40;
       property GlobalOperationSize:Integer read FGlobalOperationSize write FGlobalOperationSize default 150;
       property FontSize:Integer read FFontSize write SetFontSize;
       property NodesCount:DWORD read FNodesCount;
       property MinArcRadius:Integer read FMinArcRadius write FMinArcRadius;
       property MinLabelX:Integer read FMinLabelX write FMinLabelX;
       property MinLabelY:Integer read FMinLabelY write FMinLabelY;
       property MinLabelY3:Integer read FMinLabelY3 write FMinLabelY3;
       property MinLabelY1:Integer read FMinLabelY1 write FMinLabelY1;
       property MinLabelY2:Integer read FMinLabelY2 write FMinLabelY2;
       property MinLabelX2:Integer read FMinLabelX2 write FMinLabelX2;
       property MinLabelYNew:Integer read FMinLabelYNew write FMinLabelYNew;
       property MinGlobalLabel:Integer read FMinGlobalLabel write FMinGlobalLabel;
       property MinLineEndPoint:Integer read  FMinLineEndPoint write FMinLineEndPoint;
       property Level:Integer read FLevel;
       property SSLevel:ShortString read FSSLevel; { CurrentWork !}
       property ParentLevel:Integer read FParentLevel;
       property HaspFound:Boolean read FHaspFound write FHaspFound default False;
       property ScreenFontName:TFontName read FScreenFontName write FScreenFontName;
       property PrinterFontName:TFontName read FPrinterFontName write FPrinterFontName;
       property LevelCaption:ShortString read GetLevelCaption;
       property Debug:Boolean read FDebug write FDebug;
       property TruncLocal:Boolean read FTruncLRLocalCaptions write FTruncLRLocalCaptions;
       property TruncGlobal:Boolean read FTruncLRGlobalCaptions write FTruncLRGlobalCaptions;
       property TruncateDir:Boolean read FTruncDirection write FTruncDirection;
       property EnableA0Numeration:Boolean read FEnableA0Numeration write SetEnableA0Numeration;
       property Scaled:Boolean read FScaled write SetScaled;
       property Scaled2:Boolean read FScaled2 write SetScaled2;
       property Scaled2Ratio:Extended read FScaled2Ratio write SetScaled2Ratio;
       property Header:TBPHeader read FHeader;
       property NTTree:PBPNodeTypes read FNTTree;
       property LTTree:PBPLinkTypes read FLTTree;
       property Tree:PBPTree read FTree;
       property OpTree:PBPOpTree read FOpTree;
       property IPNode:PBPInProcessNode read FIPNode;
       property DiscardDrags:Boolean read FDiscardDrags write SetDiscardDrags;
       property Modified:Boolean read FModified write FModified;
       property AcceptDragRect:TRect read FAcceptDragRect;
       property LinksPosRelative:Boolean read FLinksPosRelative write FLinksPosRelative default True;
       property ShowDataWare:Boolean read FShowDataWare write SetShowDataWare default True;
       property ShowDataWareLine:Boolean read FShowDataWareLine write SetShowDataWareLine default True;
       property RootEntries:DWORD read FRootEntries;
       property EntryArray:PBPEntryArray read FEntryArray;
       property CheckGraphArray:PBPCheckGraphArray read FCheckGraphArray;
       property LevelHeader:PBPTree read GetLevelHeader write SetLevelHeader;
       property ForAllLevels:Boolean read FForAllLevels write FForAllLevels;
       property MinTopSize:Integer read FMinTopSize write FMinTopSize;
       property MinBottomSize:Integer read FMinBottomSize write FMinBottomSize;
       property TranslateNodesType:Integer read FTranslateNodesType write SetTranslateNodesType;
       property ReplaceNodes:Boolean read FReplaceNodes;
       property ReplaceLabels:Boolean read FReplaceLabels;
       property MaxWordLength:Integer read FMaxWordLength;
       property MaxWordCount:Integer read FMaxWordCount;
       property MaxLabelLength:Integer read FMaxLabelLength;
       {New}
       property NodesFontSize:Integer read FNodesFontSize;
       property DNodesFontSize:Integer read FDNodesFontSize;
       property DProjectionFontSize:Integer read FDProjectionFontSize;
       property InProcessFontSize:Integer read FInProcessFontSize;
       property LabelsFontSize:Integer read FLabelsFontSize;
       property LabelFontSize:Integer read FLabelFontSize;
       property IOFontSize:Integer read FIOFontSize;
       property OverrideNodesFS:Boolean read FOverrideNodesFS;
       property OverrideDNodesFS:Boolean read FOverrideDNodesFS;
       property OverrideInProcessFS:Boolean read FOverrideInProcessFS;
       property OverrideLabelsFS:Boolean read FOverrideLabelsFS;
       property MaxGOS:Double read FMaxGOS write SetMaxGOS;
       property MaxFontSize:Integer read FMaxFontSize write SetMaxFontSize;
     end;


 { TBPFrame definition }
  TBPFrame = class(TScrollingWinControl)
  private
    { Private declarations }
    FBPGraph:TBPGraph;                         { 砥  }
    FCanvas: TCanvas;
    { Page Param Options }
    FPageTop:Integer;
    FPageBottom:Integer;
    FPageLeft:Integer;
    FPageRight:Integer;
    FPrinter:TQRPrinter;
    FPrinting:Boolean;
    FPainting:Boolean; { So disable double insert in painting module }
    FAborting:Boolean;
    { Vars for scaling diagrams }
    FHorzPageCount:Integer;
    FVertPageCount:Integer;
    { Vars for scaling ramka font }
    FRamkaFontRatio:Extended;
    FPSizeH:Extended;
    FPSizeW:Extended;
    FRamkaH:Integer;
    { Vars for drawing context }
    FContextBitmap:TBitmap;
    FDrawCBitmap:Boolean;
    FXBPos:Integer;
    {New}
    procedure WMPaint(var Message: TWMPaint); message WM_PAINT;
  protected
    { Protected declarations }
    procedure Paint; virtual;
    procedure PaintWindow(DC: HDC); override;
    procedure PaintTo(DC: HDC; X, Y: Integer);
    procedure PaintPageTo(DC: HDC; X, Y: Integer; PageClipRect:TRect);
    { printing routines }
    procedure  PrintStandartRectangle(cl:String);
    procedure  PreviewStandartRectangle(pw,ph:Integer;cl:String);
    function   CalcNewString(s:String;Const outCanvas:TCanvas;MaxWidth:Integer):String;
    procedure  PreviewPrintRect(left,right,top,bottom:Integer);
    procedure  PrintRect(left,right,top,bottom:Integer);
    procedure DoEnter;  override;
    procedure DoExit; override;
    procedure DrawNode(l,t,w,h:Integer;Canvas:TCanvas;PaintColor,DrawColor:TColor);
    procedure DrawLink(pl:PGraphLink;Canvas:TCanvas;RatioX,RatioY:Double;Wpos,Hpos:Integer);
    procedure MyDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure MyDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
    function  GetHeaderBitmapSize:TPoint;
    function  GetHeaderBitmapSizePreview(pw,ph:Integer):TPoint;
    function  GetCoof(rw,rh:Double;Alg:TBPFormatAlg):Double;
  public
    { Public declarations }
    FUpdatingNavigator:Boolean;
    FNodesValue:Array[0..1] of Integer; { Min Max }
    FFormatAlg:array[0..2] of TBPFormatAlg; { Min Middle Max }
    FPreviewOrPrint:Boolean;
    FFontCoof:Double;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure SetPageParam(Var PageTop,PageBottom,PageLeft,PageRight:Integer;ShowWarning:Boolean);
    procedure SetPreviewPageParam(PageTop,PageBottom,PageLeft,PageRight:Integer);
    procedure Print;
    procedure CreateBitmap(var value:TBitmap;pf:TPixelFormat);
    procedure GetBitmapWithSize(value:TBitmap;iw,ih:Integer); { scaled bitmap }
    procedure CreateBitmapWithSize(var value:TBitmap;pf:TPixelFormat;iw,ih:Integer); { scaled bitmap }
    function  FillBitmapWithSize(var value:TBitmap;iw,ih:Integer;level_id:Integer):String;
    procedure CreateBitmapForOneShit(var value:TBitmap;pf:TPixelFormat;iw,ih,shitw,shith,maxshitw,maxshith:Integer);
    procedure CreatePreview;
    procedure PrintAll(pb:TFlatProgressBar;Lbl:TLabel;StartP,EndP:Integer);
    procedure CreatePreviewAll(pb:TFlatProgressBar;Lbl:TLabel);
  published
    { Published declarations }
    property HorzPages:Integer read FHorzPageCount write FHorzPageCount default 1;
    property VertPages:Integer read FVertPageCount write FVertPageCount default 1;
    property BPGraph:TBPGraph read FBPGraph;
    property Align default alNone;
    property Width default 100;
    property Height default 100;
    property Enabled default True;
    property ShowHint;
    property Visible;
    property Ctl3D;
    property TabStop default True;
    property TabOrder;
    property Canvas:TCanvas read FCanvas;
    property QPrinter:TQRPrinter read FPrinter;
    property Printing:Boolean read FPrinting;
    property Aborting:Boolean read FAborting write FAborting;
    property OnKeyUp;
    property OnEnter;
    property OnExit;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnStartDrag;
  end;

function SignedVector(Sign,Value:Integer):Integer;

procedure Register;

Const StartMinLineStep=6;
      StartMinLabelX=8;
      StartMinLabelY=4;
      StartMinLabelY1=12; { Try to change }
      StartMinLabelYNew=2;
      StartMinArcRadius=8;
      NodeRatio=4/3;
      StartMinGlobalLabel=10;
      StartMinLineEndPoint=4;
      StartMaxLines=4;
      MaxNodesPgAlg=5;

      A3Width=16.5354;  { Inch }
      A3Height=11.6929; { Inch }
      DefMaxLabelFontSize=14;

      ExternIn='EI';
      ExternOut='EO';
      ExternControl='EC';
      ExternMech='EM';

Implementation

Uses MainUnit,AnalizeGraphUnit;


function  TBPGraph.OptimizeNodeFonts:Integer;
Var       i:Integer;
  OptFSize,FS:Integer;
     gNode:PGraphNode;
         h:Integer;
         w:Integer;
         dc:HDC;
         ppi:Integer;
 begin
   if FNodesCount=0 then Exit;
   if (FFontSize>=FRealMaxFontSize) then Exit;
   dc:=GetDC(0);
   ppi:=GetDeviceCaps(dc,LOGPIXELSX);
   ReleaseDC(0,dc);
   gNode:=FGraphNodes;
   OptFSize:=100000;
   for i:=0 to (FNodesCount-1) do
     begin
       h:=gnode^.BPNode.Height;
       w:=gnode^.BPNode.Width;
       fs:=Round(FFontSize/FScaled2Ratio*100);
       gnode^.BPNode.AutoHeight:=True;
       gnode^.BPNode.DefWidth:=Round(w/1.1);
       gnode^.BPNode.Font.PixelsPerInch:=ppi;
       while ((gnode^.BPNode.Height-2*gnode^.BPNode.Font.Height)<=h) do
         begin
           inc(fs);
           gnode^.BPNode.Font.Size:=fs;
           gnode^.BPNode.PaintImmediate;
           while gnode^.BPNode.Updating do;
         end;
       dec(fs);
       if (OptFSize>fs) then OptFSize:=fs;
       gnode^.BPNode.AutoHeight:=False;
       gnode:=gnode^.next;
     end;
   Result:=OptFSize;
 end;


procedure TBPGraph.CLCorrectLinks(link:PBPLink;FromTo:Boolean);
Var tlink:PBPLink;
        i:Integer;
 begin
  if FLinksCount=0 then Exit;
  tlink:=FLinks;
  for i:=0 to (FLinksCOunt-1) do
   begin
    if (tlink<>link) then
      begin
        if FromTo then
          begin
            if (tlink^.dwFromNodeNumber=link^.dwFromNodeNumber) and
               (tlink^.dwFromLinkNumber=link^.dwFromLinkNumber) and
               ((tlink^.dwFlags and BP_FROMMASK)=(link^.dwFlags and BP_FROMMASK)) and
               ((tlink^.dwFlags and BP_SHOW_FROMCAPTION)<>0) and
               (tlink^.ssFromCaption<>'') then
                tlink^.ssFromCaption:=link^.ssFromCaption;
          end
         else
          begin
            if (tlink^.dwToNodeNumber=link^.dwToNodeNumber) and
               (tlink^.dwToLinkNumber=link^.dwToLinkNumber) and
               ((tlink^.dwFlags and BP_TOMASK)=(link^.dwFlags and BP_TOMASK)) and
               ((tlink^.dwFlags and BP_SHOW_TOCAPTION)<>0) and
               (tlink^.ssToCaption<>'') then
                tlink^.ssToCaption:=link^.ssToCaption;
          end;
      end;
    inc(tlink);
   end;
 end;

procedure TBPGraph.SetLinkCaption(mlabel:TBPLabel;Text:ShortString);
Var tlink:PGraphLink;
        i:Integer;
 begin
   if FGraphLinks=nil then Exit;
   tlink:=FGraphLinks;
   for i:=0 to (FLinksCount-1) do
    begin
       if tlink^.BPFromLabel=mlabel then
         begin
           tLink^.llLink^.ssFromCaption:=Text;
           CLCorrectLinks(tLink^.llLink,True);
           FModified:=True;
           Exit;
         end;
        if tlink^.BPToLabel=mlabel then
         begin
           tLink^.llLink^.ssToCaption:=Text;
           CLCorrectLinks(tLink^.llLink,False);
           FModified:=True;
           Exit;
         end;
       tlink:=tlink^.next;
    end;
 end;

procedure TBPGraph.SetNodeCaption(node:TBPGraphNode;Text:ShortString);
Var tnode:PGraphNode;
        i:Integer;
       flag:Boolean;
       s:String;
       tmpTree:PBPTree;
 begin
   if FGraphNodes=nil then Exit;
   flag:=False;
   tnode:=FGraphNodes;
   for i:=0 to (FNodesCount-1) do
     begin
       if (tnode^.BPNode=node) then
          begin
            case FTranslateNodesType of
              0: begin
                  tNode^.llnode^.ssCaption:=Text;
                  s:=Trim(tNode^.llNode^.ssNodeNumber);
                  if length(s)>1 then Delete(s,1,1);
                  flag:=True;
                  FModified:=True;
                 end;
             else showmessage('   -       .');
            end;
          end;
       tnode:=tnode^.next;
     end;
  if flag then
    begin
      tmpTree:=FTree;
      while (tmpTree<>nil) do
        begin
          if (tmpTree^.ssLevel=s) then
            begin
              tmpTree^.ssCaption:=Text;
              Exit;
            end;
          tmpTree:=tmpTree^.next;
        end;
    end;
 end;


procedure TBPGraph.OptimizeModel(pb:TFlatProgressBar;Lbl:TLabel);
Var tmptree:PBPTree;
    fs:Integer;
   lfs:Integer;
 oldLevel:Integer;
   pos:Integer;
   cnt:Integer;
   adv:Double;
 begin
   if (FTree=nil) then Exit;
   oldLevel:=FLevel;
   tmpTree:=FTree;
   cnt:=FRootEntries;
   pos:=0;
   pb.Position:=0;
   Lbl.Caption:=IntToStr(pos);
   Application.ProcessMessages;
   while (tmpTree<>nil) do
    begin
          FNodesCount:=tmpTree^.dwNodesCount;
          FLinksCount:=tmpTree^.dwLinksCount;
          FNodes:=tmpTree^.lpNodes;
          FLinks:=tmpTree^.lpLinks;
          FLevelCaption:=tmpTree^.ssCaption;
          FLevelNotes:=tmpTree^.ssNotes;
          FLevelRevision:=tmpTree^.dwRevision;
          FLevelDraftStatus:=tmpTree^.dwStatus;
          FLevelPageNumber:=tmpTree^.dwPageNumber;
          FLevel:=tmpTree^.dwLevel;
          FSSLevel:=tmpTree^.ssLevel;
          FParentLevel:=tmpTree^.dwParent;
          FNodesFontSize:=tmpTree^.dwNodesFontSize;
          FDNodesFontSize:=tmpTree^.dwDNodesFontSize;
          FDProjectionFontSize:=tmpTree^.dwDProjectionFontSize;
          FInProcessFontSize:=tmpTree^.dwInProcessFontSize;
          FLabelsFontSize:=tmpTree^.dwLabelsFontSize;
          FOverrideNodesFS:=tmpTree^.dbOverrideNodesFS;
          FOverrideDNodesFS:=tmpTree^.dbOverrideDNodesFS;
          FOverrideInProcessFS:=tmpTree^.dbOverrideInProcessFS;
          FOverrideLabelsFS:=tmpTree^.dbOverrideLabelsFS;
          SetDefaultConstants;
          CreateGraphNodes(1,1);
          CreateIPGraphNodes(1,1);
          CreateGraphLinks(1,1);
          if FShowDataWare then
           CreateDGraphNodes(1,1)
          else
           ClearDGraphNodes;
          Scaled:=Scaled;
          CheckLinksAndNodes;
          if (not(FScaled)) then PresetupFrame(1,1);
          TraceRoute;
           FOwner.Invalidate;
     fs:=OptimizeNodeFOnts;
     lfs:=Round(fs*FMaxCH);
     if fs>FRealMaxFontSize then fs:=FRealMaxFontSize;
     if lfs>FRealMaxFontSize then lfs:=FRealMaxFontSize;
     FNodesFontSize:=fs;
     FLabelsFontSize:=lfs;
    {FDNodesFontSize:=lfs;
     FDProjectionFontSize:=lfs;}
     FInProcessFontSize:=fs;
     FOverrideNodesFS:=True;
     FOverrideLabelsFS:=True;
     FOverrideInProcessFS:=True;
    {FOverrideDNodesFS:=True;}
     tmpTree^.dwNodesFontSize:=fs;
     tmpTree^.dbOverrideNodesFS:=True;
     tmpTree^.dwInProcessFontSize:=fs;
     tmpTree^.dbOverrideInProcessFS:=True;
     tmpTree^.dwLabelsFontSize:=LFS;
     tmpTree^.dbOverrideLabelsFS:=True;
{     tmpTree^.dwDNodesFontSize:=lfs;
     tmpTree^.dbOverrideDNodesFS:=True;
     tmpTree^.dwDProjectionFontSize:=lfs;}
     FModified:=True;
     tmpTree:=tmpTree^.next;
     inc(pos);
     pb.Position:=Round(pos/cnt*100);
     Lbl.Caption:=IntToStr(pb.Position);
     Application.ProcessMessages;
    end;
    OpenLevel(OldLevel);
    FOwner.Visible:=False;
    pb.Position:=100;
    Lbl.Caption:='100';
    Application.ProcessMessages;
 end;

procedure TBPGraph.Optimize;
Var tmptree:PBPTree;
    fs:Integer;
   lfs:Integer;
 begin
   if (FTree=nil) then Exit;
   fs:=OptimizeNodeFOnts;
   lfs:=Round(fs*FMaxCH);
   if fs>FRealMaxFontSize then fs:=FRealMaxFontSize;
   if lfs>FRealMaxFontSize then lfs:=FRealMaxFontSize;
   FNodesFontSize:=fs;
   FLabelsFontSize:=lfs;
{   FDNodesFontSize:=lfs;
   FDProjectionFontSize:=lfs;}
   FInProcessFontSize:=fs;
   FOverrideNodesFS:=True;
   FOverrideLabelsFS:=True;
   FOverrideInProcessFS:=True;
{   FOverrideDNodesFS:=True;}
   tmpTree:=FTree;
   while (tmpTree<>nil) and (tmpTree^.dwLevel<>FLevel) do tmpTree:=tmpTree^.next;
   if (tmpTree<>nil) then
   begin
     tmpTree^.dwNodesFontSize:=fs;
     tmpTree^.dbOverrideNodesFS:=True;
     tmpTree^.dwInProcessFontSize:=fs;
     tmpTree^.dbOverrideInProcessFS:=True;
     tmpTree^.dwLabelsFontSize:=LFS;
     tmpTree^.dbOverrideLabelsFS:=True;
{     tmpTree^.dwDNodesFontSize:=lfs;
     tmpTree^.dbOverrideDNodesFS:=True;
     tmpTree^.dwDProjectionFontSize:=lfs;}
     FModified:=True;
   end;
 end;

procedure TBPGraph.SetOverrideFonts(NFS,DNFS,DPFS,IPFS,LFS:Integer;ONFS,ODFS,OIFS,OLFS:Boolean);
Var tmptree:PBPTree;
 begin
  FNodesFontSize:=NFS;
  FDNodesFontSize:=DNFS;
  FDProjectionFontSize:=DPFS;
  FInProcessFontSize:=IPFS;
  FLabelsFontSize:=LFS;
  FOverrideNodesFS:=ONFS;
  FOverrideDNodesFS:=ODFS;
  FOverrideInProcessFS:=OIFS;
  FOverrideLabelsFS:=OLFS;
  if (FTree=nil) then Exit;
  tmpTree:=FTree;
  while (tmpTree<>nil) and (tmpTree^.dwLevel<>FLevel) do tmpTree:=tmpTree^.next;
  if (tmpTree<>nil) then
   begin
     tmpTree^.dwNodesFontSize:=NFS;
     tmpTree^.dbOverrideNodesFS:=ONFS;
     tmpTree^.dwDNodesFontSize:=DNFS;
     tmpTree^.dbOverrideDNodesFS:=ODFS;
     tmpTree^.dwDProjectionFontSize:=DPFS;
     tmpTree^.dwInProcessFontSize:=IPFS;
     tmpTree^.dbOverrideInProcessFS:=OIFS;
     tmpTree^.dwLabelsFontSize:=LFS;
     tmpTree^.dbOverrideLabelsFS:=OLFS;
     FModified:=True;
   end;
 end;

procedure TBPGraph.SetOverrideFontsAll(NFS,DNFS,DPFS,IPFS,LFS:Integer;ONFS,ODFS,OIFS,OLFS:Boolean;
                                       CNFS,CDNFS,CDPFS,CIPFS,CLFS,CONFS,CODFS,COIFS,COLFS:Boolean);
Var tmptree:PBPTree;
 begin
  if CNFS then  FNodesFontSize:=NFS;
  if CDNFS then FDNodesFontSize:=DNFS;
  if CDPFS then FDProjectionFontSize:=DPFS;
  if CIPFS then FInProcessFontSize:=IPFS;
  if CLFS then FLabelsFontSize:=LFS;
  if CONFS then FOverrideNodesFS:=ONFS;
  if CODFS then FOverrideDNodesFS:=ODFS;
  if COIFS then FOverrideInProcessFS:=OIFS;
  if COLFS then FOverrideLabelsFS:=OLFS;
  if (FTree=nil) then Exit;
  tmpTree:=FTree;
  while (tmpTree<>nil) do
   begin
     if CNFS then tmpTree^.dwNodesFontSize:=NFS;
     if CONFS then tmpTree^.dbOverrideNodesFS:=ONFS;
     if CDNFS then  tmpTree^.dwDNodesFontSize:=DNFS;
     if CODFS then tmpTree^.dbOverrideDNodesFS:=ODFS;
     if CDPFS then tmpTree^.dwDProjectionFontSize:=DPFS;
     if CIPFS then tmpTree^.dwInProcessFontSize:=IPFS;
     if COIFS then tmpTree^.dbOverrideInProcessFS:=OIFS;
     if CLFS then  tmpTree^.dwLabelsFontSize:=LFS;
     if COLFS then tmpTree^.dbOverrideLabelsFS:=OLFS;
     FModified:=True;
     tmpTree:=tmpTree^.next;
   end;
 end;


procedure TBPGraph.AnalizeStringsFonts;
Var s:String;
  len,i:Integer;
  node:TBPGraphNode;
  nodeP:PGraphNode;
  flag:Boolean;
  fs:Integer;
 begin
   if not(BPViewMainForm.EnableAnalizForm.Checked) then Exit;
   if (AnalizeGraphForm=nil) then Exit;
   if (FNodesCount=0) then Exit;
   if (FGraphNodes=nil) then Exit;
   if FOverrideNodesFS then Exit;
   fs:=Round(FFontSize/FScaled2Ratio*100);
   with AnalizeGraphForm do
    begin
      if (not(FReplaceNodes) and (fs<BP_MINFONT_SIZE)) then
       begin
        flag:=False;
        ResultEditor.Clear;
        len:=(FMaxWordLength+1)*FMaxWordCount;
        for i:=0 to (FNodesCount-1) do
         begin
          node:=GetGraphNode(i);
          if (length(node.Caption)>len) then
           begin
            ResultEditor.Lines.Append(': '+node.SNodeNumber+' "'+node.Caption+'"');
            flag:=True;
           end;
         end;
        if flag then
           begin
            ResultEditor.Lines.Append(' ');
            ResultEditor.Lines.Append('    '+IntToStr(len)+' ');
            ResultEditor.Lines.Append('         -');
            ResultEditor.Lines.Append('   "  "  ""');
            ResultEditor.Lines.Append(' ');
            ResultEditor.Lines.Append(':    ( )');
            ResultEditor.Lines.Append(' ');
            ResultEditor.Lines.Append('  ='+IntToStr(fs)+' pt.');
            ShowModal;
           end;
       end
      else
       if (FReplaceNodes and (fs<BP_MINFONT_SIZE)) then
        begin
          flag:=False;
          ResultEditor.Clear;
          nodeP:=FGraphNodes;
          for i:=0 to (FNodesCount-1) do
           begin
             if length(nodeP^.BPNode.Caption)<length(nodeP^.llNode^.ssCaption) then
              begin
               ResultEditor.Lines.Append(': '+nodeP^.BPNode.SNodeNumber+' "'+nodeP^.llNode^.ssCaption+'"');
               ResultEditor.Lines.Append(': "'+nodeP^.BPNode.Caption+'"');
               ResultEditor.Lines.Append(' ');
               flag:=True;
              end;
             nodeP:=nodeP^.Next;
           end;
          if flag then
          begin
           ResultEditor.Lines.Append(':  ,        "  "  ""');
           ResultEditor.Lines.Append('         -');
           ResultEditor.Lines.Append(' ');
           ResultEditor.Lines.Append('  ='+IntToStr(fs)+' pt.');
           ShowModal;
          end;
        end;
      if (FReplaceNodes) and (fs<BP_MINFONT_SIZE) and (not(flag)) then
        begin
         if (FNodesCount>6) then
          begin
          ResultEditor.Clear;
          ResultEditor.Lines.Append(':   -         ');
          ResultEditor.Lines.Append('       ');
          ResultEditor.Lines.Append(' ');
          ResultEditor.Lines.Append('  ='+IntToStr(fs)+' pt.');
          ShowModal;
          end
         else
          begin
          ResultEditor.Clear;
          ResultEditor.Lines.Append(':  ,        "  "  ""');
          ResultEditor.Lines.Append('         -');
          ResultEditor.Lines.Append(' ');
          ResultEditor.Lines.Append('  ='+IntToStr(fs)+' pt.');
          ShowModal;
          end
        end
      else
      if (not(FReplaceNodes)) and (fs<BP_MINFONT_SIZE) and (not(flag)) then
        begin
         if (FNodesCount>6) then
          begin
          ResultEditor.Clear;
          ResultEditor.Lines.Append(':   -         ');
          ResultEditor.Lines.Append('       ');
          ResultEditor.Lines.Append(' ');
          ResultEditor.Lines.Append('  ='+IntToStr(fs)+' pt.');
          ShowModal;
          end
         else
          begin
          ResultEditor.Clear;
          ResultEditor.Lines.Append(':  ,        "  "  ""');
          ResultEditor.Lines.Append('         -');
          ResultEditor.Lines.Append(' ');
          ResultEditor.Lines.Append('  ='+IntToStr(fs)+' pt.');
          ShowModal;
          end;
        end;
    end;
 end;

procedure TBPGraph.DrawCircle(x,y,radius,deltax,deltay:Integer);
Var oldColor:TColor;
    oldColor1:TColor;
 begin
  with FOwner.Canvas do
  begin
    oldColor:=Brush.Color;
    oldColor1:=Pen.Color;
    Pen.Color:=clBlack;
    Brush.Color:=clBlack;
    RoundRect(x-radius+deltax,y-radius+deltay,x+radius+deltax,y+radius+deltay,radius div 2, radius div 2);
    Brush.Color:=oldColor;
    Pen.Color:=oldColor1;
  end;
 end;

function SignedVector(Sign,Value:Integer):Integer;
 begin
   if Sign>0 then Result:=1 else
   if Sign<0 then Result:=-1 else Result:=0;
   Result:=Result*Value;
 end;

{  TBPFrame drag and drop routines   }

function TBPGraph.GetIPGraphNumberedNode(nodeNum,flags:DWORD):PDInProcessNode;
Var i:Integer;
  tmpNode:PDInProcessNode;
 begin
   Result:=nil;
   if (FIPGraphNodes=nil) then Exit;
   tmpNode:=FIPGraphNodes;
   for i:=0 to (FIPNodesCount-1) do
    begin
      if (tmpNode^.flags=flags) and (tmpNode^.node^.dwNodeNumber=nodeNum) then
        begin
          Result:=tmpNode;
          Exit;
        end;
      tmpNode:=tmpNode^.next;
    end;
 end;

function TBPGraph.GetLinkCaption(nodeNum:DWORD;flags:DWORD):ShortString;
Var i:Integer;
  tmpNode:PDInProcessNode;
 begin
   Result:='';
   if (FIPGraphNodes=nil) then Exit;
   tmpNode:=FIPGraphNodes;
   for i:=0 to (FIPNodesCount-1) do
    begin
      if (tmpNode^.flags=flags) and (tmpNode^.node^.dwNodeNumber=nodeNum) then
        begin
          case FTranslateNodesType of
           0: Result:=tmpNode^.node^.ssCaption;
           1: Result:=tmpNode^.node^.ssMech;
           2: Result:=tmpNode^.node.ssUpr;
          end;
          Exit;
        end;
      tmpNode:=tmpNode^.next;
    end;
 end;

function TBPGraph.CheckForExIP(nodeP:PBPInProcessNode;flags:DWORD):Boolean;
Var i:Integer;
  tmpNode:PDInProcessNode;
 begin
   Result:=True;
   if (FIPGraphNodes=nil) then Exit;
   tmpNode:=FIPGraphNodes;
   for i:=0 to (FIPNodesCount-1) do
    begin
      if (tmpNode^.flags=flags) and (tmpNode^.node=nodeP) then
        begin
          Result:=False;
          Exit;
        end;
      tmpNode:=tmpNode^.next;
    end;
 end;

 procedure  TBPGraph.ClearIPGraphNodes;
 Var tmpN,tmpN1:PDInProcessNode;
  begin
   if FIPGraphNodes=nil then Exit;
   tmpN:=FIPGraphNodes;
   tmpN1:=nil;
   while tmpN<>nil do
    begin
      if tmpN1<>nil then
        begin
         FreeMem(tmpN1);
        end;
      tmpN1:=tmpN;
      tmpN:=tmpN.Next;
    end;
    if tmpN1<>nil then
       begin
         FreeMem(tmpN1);
       end;
   FIPGraphNodes:=nil;
   FIPNodesCount:=0;
 end;


procedure  TBPGraph.CreateIPGraphNodes(wc,hc:Double); { Checked }
 Var nodeP:PBPInProcessNode;
     linkP:PBPLink;
     nodeG:PDInProcessNode;
     curNodeG:PDInProcessNode;
     i,j:Integer;
     s:String;
     nc:String;
     ltip,lfip:Boolean;
     tflags:Boolean;
     lr:Boolean;
     lnn:Integer;
     ci:Integer;
     gi:Integer;
     flags:DWORD;
  begin
   if (FIPGraphNodes<>nil) then ClearIPGraphNodes;
   if (FLinks=nil) then Exit;
   if (FIPNode=nil) then Exit;
   nodeP:=FIPNode;
   for i:=0 to (FHeader.dwIPEntries-1) do
    begin
     linkP:=FLinks;
     for j:=0 to (FLinksCount-1) do
     begin
     lfip:=((linkP^.dwFromNodeNumber and BPGlobalNodeInProcess)<>0);
     ltip:=((linkP^.dwToNodeNumber and BPGlobalNodeInProcess)<>0);
     flags:=0;
     if lfip and ((linkP^.dwFlags and BP_FROMTOMASK)=BP_RIGHT_LEFT) then
       flags:=BP_IPNODE_LEFT
     else
     if ltip and ((linkP^.dwFlags and BP_FROMTOMASK)=BP_RIGHT_LEFT) then
       flags:=BP_IPNODE_RIGHT
     else
     if lfip and ((linkP^.dwFLags and BP_FROMMASK)=BP_FROMNODE_BOTTOM) then
       flags:=BP_IPNODE_TOP
      else
       if lfip then
       flags:=BP_IPNODE_BOTTOM;
     if ((lfip and (nodeP^.dwNodeNumber=(linkP^.dwFromNodeNumber and BPNotGlobalMask))) or
        (ltip and (nodeP^.dwNodeNumber=(linkP^.dwToNodeNumber and BPNotGlobalMask)))) and
         (flags>0) then
     begin
     if CheckForExIP(nodeP,flags) then
     begin
     if (FIPGraphNodes=nil) then
          begin
            inc(FIPNodesCount);
            curNodeG:=PDInProcessNode(AllocMem(sizeof(TDInProcessNode)));
            curNodeG^.node:=nodeP;
            curNodeG^.flags:=flags;
            curNodeG^.Count:=0;
            curNodeG^.next:=nil;
            FIPGraphNodes:=curNodeG;
          end
        else
          begin
            inc(FIPNodesCount);
            nodeG:=PDInProcessNode(AllocMem(sizeof(TDInProcessNode)));
            nodeG^.node:=nodeP;
            nodeG^.flags:=flags;
            nodeG^.Count:=0;
            nodeG^.next:=nil;
            curNodeG^.next:=nodeG;
            curNodeG:=nodeG;
          end;
          end; { CheckForExIP }
         end; { if lfip,ltip }
         inc(linkP);
        end; { for j }
      inc(nodeP);
    end; { for i }
  end;


function  TBPGraph.GetNodeCaption(nodeP:PBPNode):String;
 Var i:Integer;
    linkP:PBPLink;
    s:String;
  begin
    Result:='';
    if nodeP=nil then Exit;
    Result:=nodeP^.ssCaption;
    case FTranslateNodesType of
     0: { function }
        begin
          Exit;
        end;
     1: { mechanizm }
        begin
          if FLinksCount=0 then Exit;
          s:='';
          linkP:=FLinks;
          for i:=0 to (FLinksCOunt-1) do
           begin
             if ((linkP^.dwFromNodeNumber and BPGlobalMask)=0) and
                ((linkP^.dwToNodeNumber and BPGlobalNodeOperation)=0) and
                (linkP^.dwFromNodeNumber=nodeP^.dwNodeNumber) and
                ((linkP^.dwFlags and BP_FROMMASK)=BP_FROMNODE_BOTTOM) then
                if  ((linkP^.dwFlags and BP_SHOW_FROMCAPTION)<>0) then
                 s:=s+linkP^.ssFromCaption+', '
                else
                 s:=s+linkP^.ssToCaption+', ';
             if ((linkP^.dwToNodeNumber and BPGlobalMask)=0) and
                ((linkP^.dwFromNodeNumber and BPGlobalNodeOperation)=0) and
                (linkP^.dwToNodeNumber=nodeP^.dwNodeNumber) and
                ((linkP^.dwFlags and BP_TOMASK)=BP_TONODE_BOTTOM) then
                if  ((linkP^.dwFlags and BP_SHOW_TOCAPTION)<>0) then
                  s:=s+linkP^.ssToCaption+', '
                else
                  s:=s+linkP^.ssFromCaption+', ';
             inc(linkP);
           end;
          if (s<>'') then
           begin
            delete(s,length(s)-1,2);
            Result:=s;
           end;
        end;
     2: { control }
        begin
          if FLinksCount=0 then Exit;
          s:='';
          linkP:=FLinks;
          for i:=0 to (FLinksCount-1) do
           begin
             if ((linkP^.dwFromNodeNumber and BPGlobalMask)=0) and
                ((linkP^.dwToNodeNumber and BPGlobalNodeOperation)=0) and
                (linkP^.dwFromNodeNumber=nodeP^.dwNodeNumber) and
                ((linkP^.dwFlags and BP_FROMMASK)=BP_FROMNODE_TOP) then
                if  ((linkP^.dwFlags and BP_SHOW_FROMCAPTION)<>0) then
                 s:=s+linkP^.ssFromCaption+', '
                else
                 s:=s+linkP^.ssToCaption+', ';
             if ((linkP^.dwToNodeNumber and BPGlobalMask)=0) and
                ((linkP^.dwFromNodeNumber and BPGlobalNodeOperation)=0) and
                (linkP^.dwToNodeNumber=nodeP^.dwNodeNumber) and
                ((linkP^.dwFlags and BP_TOMASK)=BP_TONODE_TOP) then
                if  ((linkP^.dwFlags and BP_SHOW_TOCAPTION)<>0) then
                  s:=s+linkP^.ssToCaption+', '
                else
                  s:=s+linkP^.ssFromCaption+', ';
             inc(linkP);
           end;
          if (s<>'') then
          begin
            delete(s,length(s)-1,2);
            Result:=s;
          end;
        end;
    end;
  end;

 procedure TBPGraph.SetMaxAll(BReplaceNodes,BReplaceLabels:Boolean;IMaxWordLength,IMaxWordCount,IMaxLabelLength:Integer);
  begin
   FReplaceNodes:=BReplaceNodes;
   FReplaceLabels:=BReplaceLabels;
   FMaxWordLength:=IMaxWordLength;
   FMaxWordCount:=IMaxWordCount;
   FMaxLabelLength:=IMaxLabelLength;
   FOwner.Visible:=False;
   OpenLevel(FLevel);
   FOwner.Invalidate;
   FOwner.Visible:=True;
  end;

 procedure TBPGraph.SetMaxGOS(Value:Double);
 Var oldPosX,oldPosY:Integer;
  begin
   FMaxGOS:=Value;
   FOwner.Visible:=False;
   if FOwner.HorzScrollBar.Visible and
     (FOwner.HorzScrollBar.Range>0) then
       oldPosX:=FOwner.HorzScrollBar.Position
   else
       oldPosX:=0;
   if FOwner.VertScrollBar.Visible and
     (FOwner.VertScrollBar.Range>0) then
       oldPosY:=FOwner.VertScrollBar.Position
   else
       oldPosY:=0;
   OpenLevel(FLevel);
   FOwner.Invalidate;
   if FOwner.HorzScrollBar.Visible and
     (FOwner.HorzScrollBar.Range>0) then
       FOwner.HorzScrollBar.Position:=oldPosX;
   if FOwner.VertScrollBar.Visible and
     (FOwner.VertScrollBar.Range>0) then
       FOwner.VertScrollBar.Position:=oldPosY;
   FOwner.Visible:=True;
  end;

 procedure TBPGraph.SetMaxFontSize(Value:Integer);
 Var oldPosX,oldPosY:Integer;
 begin
   FMaxFontSize:=Value;
   FOwner.Visible:=False;
   if FOwner.HorzScrollBar.Visible and
     (FOwner.HorzScrollBar.Range>0) then
       oldPosX:=FOwner.HorzScrollBar.Position
   else
       oldPosX:=0;
   if FOwner.VertScrollBar.Visible and
     (FOwner.VertScrollBar.Range>0) then
       oldPosY:=FOwner.VertScrollBar.Position
   else
       oldPosY:=0;
   OpenLevel(FLevel);
   FOwner.Invalidate;
   if FOwner.HorzScrollBar.Visible and
     (FOwner.HorzScrollBar.Range>0) then
       FOwner.HorzScrollBar.Position:=oldPosX;
   if FOwner.VertScrollBar.Visible and
     (FOwner.VertScrollBar.Range>0) then
       FOwner.VertScrollBar.Position:=oldPosY;
   FOwner.Visible:=True;
 end;


 procedure TBPGraph.SetTranslateNodesType(Value:Integer);
 Var oldPosX,oldPosY:Integer;
  begin
   FTranslateNodesType:=Value;
   FOwner.Visible:=False;
   if FOwner.HorzScrollBar.Visible and
     (FOwner.HorzScrollBar.Range>0) then
       oldPosX:=FOwner.HorzScrollBar.Position
   else
       oldPosX:=0;
   if FOwner.VertScrollBar.Visible and
     (FOwner.VertScrollBar.Range>0) then
       oldPosY:=FOwner.VertScrollBar.Position
   else
       oldPosY:=0;
   OpenLevel(FLevel);
   FOwner.Invalidate;
   if FOwner.HorzScrollBar.Visible and
     (FOwner.HorzScrollBar.Range>0) then
       FOwner.HorzScrollBar.Position:=oldPosX;
   if FOwner.VertScrollBar.Visible and
     (FOwner.VertScrollBar.Range>0) then
       FOwner.VertScrollBar.Position:=oldPosY;
   FOwner.Visible:=True;
  end;


procedure   TBPGraph.ClearIPNode;
  begin
    if (FIPNode<>nil) then FreeMEm(FIPNode,sizeof(TBPInProcessNode)*FHeader.dwIPEntries);
  end;


procedure TBPGraph.FillBPInfoBlock(var InfoBlock:TBPInfoBlock);
Var count:Integer;
 tmpTree:PBPTree;
 begin
   count:=0;
   InfoBlock.levelsCount:=0;
   if (FTree=nil) then Exit;
   tmpTree:=FTree;
   while (tmpTree<>nil) do
    begin
      InfoBlock.Pages[count]:=tmpTree^.dwPageNumber;
      if (tmpTree^.ssLevel='-1') or (tmpTree^.ssLevel='-0') then
       InfoBlock.LevelsID[count]:='A-0'
      else
       InfoBlock.LevelsID[count]:='A'+tmpTree^.ssLevel;
      InfoBlock.Captions[count]:=tmpTree^.ssCaption;
      InfoBlock.Comments[count]:=tmpTree^.ssNotes;
      inc(count);
      tmpTree:=tmpTree^.next;
    end;
   InfoBlock.levelsCount:=count;
 end;

procedure  TBPGraph.DrawArrowX(x,y:Integer;Positive:Boolean);
Var d:Integer;
    k:Integer;
 begin
  {}
   d:=Round(MinLineEndPoint*0.57735);
   if (d=0) and (MinLineEndPoint=0) then Exit;
   if (d=0) then d:=1;
   for k:=0 to d do
    begin
     if Positive then
      begin
       FOwner.Canvas.MoveTo(x+MinLineEndPoint,y+k);
       FOwner.Canvas.LineTo(x,y);
       FOwner.Canvas.MoveTo(x+MinLineEndPoint,y-k);
       FOwner.Canvas.LineTo(x,y);
      end
     else
      begin
       FOwner.Canvas.MoveTo(x-MinLineEndPoint,y+k);
       FOwner.Canvas.LineTo(x,y);
       FOwner.Canvas.MoveTo(x-MinLineEndPoint,y-k);
       FOwner.Canvas.LineTo(x,y);
      end;
    end;
 end;

procedure  TBPGraph.DrawArrowY(x,y:Integer;Positive:Boolean);
Var d:Integer;
    k:Integer;
 begin
  {}
   d:=Round(MinLineEndPoint*0.57735);
   if (d=0) and (MinLineEndPoint=0) then Exit;
   if (d=0) then d:=1;
   for k:=0 to d do
    begin
     if Positive then
      begin
       FOwner.Canvas.MoveTo(x+k,y+MinLineEndPoint);
       FOwner.Canvas.LineTo(x,y);
       FOwner.Canvas.MoveTo(x-k,y+MinLineEndPoint);
       FOwner.Canvas.LineTo(x,y);
      end
     else
      begin
       FOwner.Canvas.MoveTo(x+k,y-MinLineEndPoint);
       FOwner.Canvas.LineTo(x,y);
       FOwner.Canvas.MoveTo(x-k,y-MinLineEndPoint);
       FOwner.Canvas.LineTo(x,y);
      end;
    end;
 end;

function   TBPGraph.GetLevelHeader:PBPTree;
Var tmpTree:PBPTree;
    flag:Boolean;
 begin
   Result:=nil;
   if (FTree=nil) then Exit;
   tmpTree:=FTree;
   flag:=True;
   while (tmpTree<>nil) and flag do
    begin
      if (tmpTree^.dwLevel=FLevel) then
         begin
           Result:=tmpTree;
           flag:=False;
           Exit;
         end;
      tmpTree:=tmpTree^.next;
    end;
 end;

procedure  TBPGraph.SetLevelHeader(Value:PBPTree);
Var tmpTree:PBPTree;
 begin
   if (FTree=nil) then Exit;
   tmpTree:=FTree;
   while (tmpTree<>nil) do
    begin
      if (tmpTree^.dwLevel=FLevel) or
         (FForAllLevels) then
         begin
           tmpTree^.ssNotes:=Value^.ssNotes;
           tmpTree^.dwRevision:=Value^.dwRevision;
           tmpTree^.dwStatus:=Value^.dwStatus;
         end;
      tmpTree:=tmpTree^.next;
    end;
    FModified:=True;
 end;

function  TBPGraph.GetMaxDNodeLinksCount:Integer;
Var gnodes:Array[0..1,0..100] of Integer;
    gnodesCount:Integer;
    linkP:PBPLink;
    i,j:Integer;
    nodeNum:Integer;
    addFlag:Boolean;
 begin
   Result:=0;
   if not(FShowDataWare) then Exit;
   if FLinksCount=0 then Exit;
   gnodesCount:=0;
   for i:=0 to 100 do
    begin
     gnodes[0,i]:=-1;
     gnodes[1,i]:=0;
    end;
   ClearArrayOpLinks;
   linkP:=FLinks;
   for i:=0 to (FLinksCount-1) do
    begin
      if ((LinkP^.dwFromNodeNumber and BPGlobalNodeOperation)<>0) then
         begin
           if not(CompareArrayOpLinks(linkP)) then
           begin
           nodeNum:=LinkP^.dwToNodeNumber and BPNotGlobalMask;
           Addflag:=True;
           for j:=0 to (gnodesCount-1) do
            begin
              if (gnodes[0,j]=nodeNum) then
                begin
                  gnodes[1,j]:=gnodes[1,j]+1;
                  AddFlag:=False;
                end;
            end;
            if AddFlag then
              begin
                gnodes[0,gnodesCount]:=nodeNum;
                gnodes[1,gnodesCount]:=1;
                inc(gnodesCount);
              end;
          end;
         end;
      if ((LinkP^.dwToNodeNumber and BPGlobalNodeOperation)<>0) then
         begin
           if not(CompareArrayOpLinks(linkP)) then
           begin
           nodeNum:=LinkP^.dwFromNodeNumber and BPNotGlobalMask;
           Addflag:=True;
           for j:=0 to (gnodesCount-1) do
            begin
              if (gnodes[0,j]=nodeNum) then
                begin
                  gnodes[1,j]:=gnodes[1,j]+1;
                  AddFlag:=False;
                end;
            end;
            if AddFlag then
              begin
                gnodes[0,gnodesCount]:=nodeNum;
                gnodes[1,gnodesCount]:=1;
                inc(gnodesCount);
              end;
           end;
         end;
      inc(linkP);
    end;
   for i:=0 to (gnodesCount-1) do
    begin
      if Result<gnodes[1,i] then Result:=gnodes[1,i];
    end;
 end;

procedure TBPGraph.DrawDataWareLine;
var oldColor:TColor;
    oldPen:TPenStyle;
    i:Integer;

 begin
   oldColor:=FOwner.Canvas.Pen.Color;
   oldPen:=FOwner.Canvas.Pen.Style;
   FOwner.Canvas.Pen.Color:=clBlack;
   FOwner.Canvas.Pen.Style:=psSolid;
   For i:=0 to 0 do
   begin
    FOwner.Canvas.MoveTo(FOwner.ClientRect.Left-Parent.HorzScrollBar.Position,FOwner.ClientRect.Top+FDefHeight-FGlobalOperationSize-i-Parent.VertScrollBar.Position);
    FOwner.Canvas.LineTo(FOwner.ClientRect.Left+FDefWidth-Parent.HorzScrollBar.Position,FOwner.ClientRect.Top+FDefHeight-FGlobalOperationSize-i-Parent.VertScrollBar.Position);
   end;
   FOwner.Canvas.Pen.Style:=oldPen;
   FOwner.Canvas.Pen.Color:=oldColor;
 end;

function  TBPGraph.GetLevelCaption:ShortString; { Checked }
var i:Integer;
 begin
  Result:='';
  if length(FLevelCaption)=0 then Exit;
  i:=1;
  while (i<=length(FLevelCaption)) do
   begin
    if (FLevelCaption[i] in ['A'..'Z']) or
       (FLevelCaption[i] in ['a'..'z']) or
       (FLevelCaption[i] in [''..'']) or
       (FLevelCaption[i] in [' ','_','-']) then
        Result:=Result+FLevelCaption[i];
    inc(i);
   end;
 end;

function  TBPGraph.GetTreeLevelFromSNumber(SNumber:ShortString):Integer; { Checked }
Var tmpTree:PBPTree;
    s:String;
 begin
    Result:=-1;
    tmpTree:=FTree;
    if tmpTree=nil then Exit;
    s:=Trim(SNumber);
    if length(s)<2 then Exit;
    s:=copy(s,2,length(s)-1);
    while (tmpTree<>nil) do
     begin
       if (tmpTree^.ssLevel=s) then Result:=tmpTree^.dwLevel;
       tmpTree:=tmpTree^.next;
     end;
 end;

procedure TBPGraph.MyNodeDblClick(Sender: TObject);  { Checked }
 begin
  (Sender as TBPGraphNode).EndDrag(False);
   FOwner.EndDrag(False);
   BPViewMainForm.OpenedLevel:=GetTreeLevelFromSNumber((Sender as TBPGraphNode).SNodeNumber);
   BPViewMainForm.OrderOpenTimer.Enabled:=True;
 end;

procedure TBPGraph.MyNodeMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer); { Checked }
 begin
  if (Sender is TBPGraphNode) and (Button=mbLeft) then
   (Sender as TBPGraphNode).BeginDrag(False);
 end;

procedure TBPGraph.MyLabelMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer); { Checked }
 begin
   if (Sender is TBPLabel) and (Button=mbLeft) then
        (Sender as TBPLabel).BeginDrag(True);
 end;


procedure TBPGraph.CorrectLinksModel(delta:TPoint;NodeNum:DWORD;AcceptRect:TRect); { Hm }
Var p:PGraphLink;
    i:Integer;
    cnt:Integer;
    x,y:Integer;
    x1,y1:Integer;
    dx,dy:Integer;
    flag:Boolean;
 begin
   { Correct links coordinates }
   if (FLinksCount=0) then Exit;
   cnt:=FLinksCount-1;
   if FOwner.VertScrollBar.Visible then dy:=FOwner.VertScrollBar.Position else dy:=0;
   if FOwner.HorzScrollBar.Visible then dx:=FOwner.HorzScrollBar.Position else dx:=0;
   for i:=0 to cnt do
     begin
       p:=GetGraphLink(i);
       if ((p^.FromNodeNumber=NodeNum) or
          (p^.ToNodeNumber=NodeNum)) then
          begin { Any link to this node }
            flag:=False; { !!! }
            if (p^.BPFromLabel<>nil) then
              if (p^.BPFromLabel.AcceptPosition) then
                 begin
                   if (p^.FromNodeNumber=NodeNum) then Flag:=True;
                   { GlobalLeftNodeNumber }
                   if ((p^.FromNodeNumber and BPGlobalLeftNodeNumber)<>0) then
                   begin
                     x:=p^.BPFromLabel.LeftDragPos;
                     x1:=p^.BPFromLabel.Left;
                     Flag:=True;
                   end
                   else
                   begin
                   x:=p^.BPFromLabel.LeftDragPos+delta.x;
                   if ((x+p^.BPFromLabel.Width)>AcceptRect.Right) then
                      x:=AcceptRect.Right-p^.BPFromLabel.Width;
                   if (x<AcceptRect.Left) then x:=AcceptRect.Left;

                   x1:=p^.BPFromLabel.Left+delta.x;
                   if ((x1+dx+p^.BPFromLabel.Width)>AcceptRect.Right) then
                      x1:=AcceptRect.Right-dx-p^.BPFromLabel.Width;
                   if ((x1+dx)<AcceptRect.Left) then
                      x1:=AcceptRect.Left-dx;
                   end;
                   { Top or Bottom NodeNumber }
                   if ((p^.FromNodeNumber and BPGlobalTopNodeNumber)<>0) or
                      ((p^.FromNodeNumber and BPGlobalBottomNodeNumber)<>0) then
                   begin
                    y:=p^.BPFromLabel.TopDragPos;
                    y1:=p^.BPFromLabel.Top;
                    Flag:=True;
                   end
                   else
                   begin
                   y:=p^.BPFromLabel.TopDragPos+delta.y;
                   if ((y+p^.BPFromLabel.Height)>AcceptRect.Bottom) then
                      y:=AcceptRect.Bottom-p^.BPFromLabel.Height;
                   if (y<AcceptRect.Top) then y:=AcceptRect.Top;

                   y1:=p^.BPFromLabel.Top+delta.y;
                   if ((y1+dy+p^.BPFromLabel.Height)>AcceptRect.Bottom) then
                      y1:=AcceptRect.Bottom-dy-p^.BPFromLabel.Height;
                   if ((y1+dy)<AcceptRect.Top) then
                      y1:=AcceptRect.Top-dy;
                   end;
                   if Flag then
                   begin
                   p^.BPFromLabel.LeftDragPos:=x;
                   p^.BPFromLabel.TopDragPos:=y;
                   p^.BPFromLabel.Left:=x1;
                   p^.BPFromLabel.Top:=y1;
                   p^.BPFromLabel.AcceptPosition:=True;
              {     CorectMultipleLinks(p^.BPFromLabel);}
                   UpdateLinksModel(x1+dx,y1+dy,p^.BPFromLabel);
                   Flag:=False;
                   end;
                 end;
            Flag:=False;
            if (p^.BPToLabel<>nil) then
              if (p^.BPToLabel.AcceptPosition) then
                 begin
                   if (p^.ToNodeNumber=NodeNum) then Flag:=True;
                   if ((p^.ToNodeNumber and BPGlobalRightNodeNumber)<>0) then
                   begin
                    x:=p^.BPToLabel.LeftDragPos;
                    x1:=p^.BPToLabel.Left;
                    Flag:=True;
                   end
                   else
                   begin
                   x:=p^.BPToLabel.LeftDragPos+delta.x;
                   if ((x+p^.BPToLabel.Width)>AcceptRect.Right) then
                      x:=AcceptRect.Right-p^.BPToLabel.Width;
                   if (x<AcceptRect.Left) then x:=AcceptRect.Left;

                   x1:=p^.BPToLabel.Left+delta.x;
                   if ((x1+dx+p^.BPToLabel.Width)>AcceptRect.Right) then
                      x1:=AcceptRect.Right-dx-p^.BPToLabel.Width;
                   if ((x1+dx)<AcceptRect.Left) then
                      x1:=AcceptRect.Left-dx;
                   end;

                   if ((p^.ToNodeNumber and BPGlobalBottomNodeNumber)<>0) then
                   begin
                    y:=p^.BPToLabel.TopDragPos;
                    y1:=p^.BPToLabel.Top;
                    Flag:=True;
                   end
                   else
                   begin
                   y:=p^.BPToLabel.TopDragPos+delta.y;
                   if ((y+p^.BPToLabel.Height)>AcceptRect.Bottom) then
                      y:=AcceptRect.Bottom-p^.BPToLabel.Height;
                   if (y<AcceptRect.Top) then y:=AcceptRect.Top;

                   y1:=p^.BPToLabel.Top+delta.y;
                   if ((y1+dy+p^.BPToLabel.Height)>AcceptRect.Bottom) then
                      y1:=AcceptRect.Bottom-dy-p^.BPToLabel.Height;
                   if ((y1+dy)<AcceptRect.Top) then
                      y1:=AcceptRect.Top-dy;
                   end;
                   if Flag then
                   begin
                   p^.BPToLabel.LeftDragPos:=x;
                   p^.BPToLabel.TopDragPos:=y;
                   p^.BPToLabel.Left:=x1;
                   p^.BPToLabel.Top:=y1;
                   p^.BPToLabel.AcceptPosition:=True;
                 {  CorectMultipleLinks(p^.BPToLabel);}
                   UpdateLinksModel(x1+dx,y1+dy,p^.BPToLabel);
                   Flag:=False;
                   end;
                 end;
          end;
     end;
 end;

procedure TBPFrame.MyDragDrop(Sender, Source: TObject; X, Y: Integer); { Checked }
var p:TPoint;
    vpos,hpos:Integer;
begin
 if HorzScrollBar.Visible then hpos:=HorzScrollBar.Position;
 if VertScrollBar.Visible then vpos:=VertScrollBar.Position;
 if (Sender is TBPFrame) and (Source is TBPGraphCustomNode) then
  begin
    with Source as TBPGraphNode do
    begin
      p.x:=X-Left;
      p.y:=Y-Top;
      Left:=X;
      Top:=Y;
      if VertScrollBar.Visible then
       TopDragPos:=Y+VertScrollBar.Position
      else
       TopDragPos:=Y;
      if HorzScrollBar.Visible then
       LeftDragPos:=X+HorzScrollBar.Position
      else
       LeftDragPos:=X;
      AcceptPosition:=True;
      FBPGraph.UpdateNodesModel(LeftDragPos,TopDragPos,Source as TBPGraphNode);
      if FBPGraph.FLinksPosRelative then FBPGraph.CorrectLinksModel(p,(Source as TBPGraphNode).NodeNumber,FBPGraph.AcceptDragRect);
      BringToFront;
    end;
    with (Sender as TBPFrame) do
      begin
       Visible:=False;
       FBPGraph.TraceRoute;
       Repaint;
       Visible:=True;
       if HorzScrollBar.Visible then HorzScrollBar.Position:=hpos;
       if VertScrollBar.Visible then VertScrollBar.Position:=vpos;
       BPViewMainForm.BPGetBitmapTimer.Enabled:=True;
      end;
  end;
 if (Sender is TBPFrame) and (Source is TBPLabel) then
  begin
    with Source as TBPLabel do
    begin
      Left:=X;
      Top:=Y;
      if VertScrollBar.Visible then
       TopDragPos:=Y+VertScrollBar.Position
      else
       TopDragPos:=Y;
      if HorzScrollBar.Visible then
       LeftDragPos:=X+HorzScrollBar.Position
      else
       LeftDragPos:=X;
      AcceptPosition:=True;
    end;
     with (Sender as TBPFrame) do
      begin
       FBPGraph.CorectMultipleLinks(Source as TBPLabel);
       FBPGraph.UpdateLinksModel((Source as TBPLabel).LeftDragPos,
               (Source as TBPLabel).TopDragPos,Source as TBPLabel);
       Visible:=False;
       FBPGraph.TraceRoute;
       Repaint;
       Visible:=True;
       if HorzScrollBar.Visible then HorzScrollBar.Position:=hpos;
       if VertScrollBar.Visible then VertScrollBar.Position:=vpos;
       BPViewMainForm.BPGetBitmapTimer.Enabled:=True;
      end;
   end;
end;

procedure TBPFrame.MyDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean); { Checked }
Var tmpn:TBPGraphNode;
    tmpl:TBPLabel;
    xnew,ynew:Integer;
begin
 if VertScrollBar.Visible then
   ynew:=y+VertScrollBar.Position
 else
   ynew:=y;
 if HorzScrollBar.Visible then
   xnew:=x+HorzScrollBar.Position
 else
   xnew:=x;
 { Check for Source }
 Accept:=(Source is TBPGraphCustomNode);
 { Check coordinates }
 if Accept then
    begin
      tmpn:=Source as TBPGraphNode;
      if   (Xnew<FBPGraph.AcceptDragRect.Left)
       or  (Ynew<FBPGraph.AcceptDragRect.Top)
       or  ((Xnew+tmpn.Width)>FBPGraph.AcceptDragRect.Right)
       or  ((Ynew+tmpn.Height)>FBPGraph.AcceptDragRect.Bottom)
        then
         Accept:=False;
    end;
 if not(Accept) then
  begin
   Accept:=Source is TBPLabel;
   if Accept then
     begin
       tmpl:=Source as TBPLabel;
       if   (Xnew<FBPGraph.AcceptDragRect.Left)
       or  (Ynew<FBPGraph.AcceptDragRect.Top)
       or  ((Xnew+tmpl.Width)>FBPGraph.AcceptDragRect.Right)
       or  ((Ynew+tmpl.Height)>FBPGraph.AcceptDragRect.Bottom)
        then
         Accept:=False;
     end;
  end;
end;



{ TBPGraph }

procedure TBPGraph.SetShowDataWare(Value:Boolean);
 begin
   if Value<>FShowDataWare then
     begin
       FShowDataWare:=Value;
       FOwner.Visible:=False;
       OpenLevel(FLevel);
       TraceRoute;
       FOwner.Visible:=True;
     end;
 end;

procedure TBPGraph.SetShowDataWareLine(Value:Boolean);
 begin
   if Value<>FShowDataWareLine then
     begin
       FShowDataWareLine:=Value;
       if FShowDataWare then
        begin
         FOwner.Visible:=False;
         OpenLevel(FLevel);
         TraceRoute;
         FOwner.Visible:=True;
        end;
     end;
 end;


function  TBPGraph.CompareGraphNodeWithNode(l1:TBPGraphNode;l2:PBPNode):Boolean; { Checked }
 Var s1,s2:ShortString;
 begin
   {}
   Result:=False;
   s1:=l1.Caption;
   s2:=l2^.ssCaption;
   if (s1<>s2) then Exit;
   s1:=l1.SNodeNumber;
   s2:=l2^.ssNodeNumber;
   if (s1<>s2) then Exit;
   if (l1.NodeNumber<>l2^.dwNodeNumber) then Exit;
   Result:=True;
 end;

function  TBPGraph.GetMultipleMask(index:Integer):TBPMultipleMask; { Checked }
 Var linkP:PBPLink;
     linkC:PBPLink;
     i:Integer;
  begin
   Result:=bpmm_None;
   if (index>=FLinksCount) or (index<0) then Exit;
   linkP:=FLinks;
   linkC:=FLinks;
   if (index>0) then Inc(linkP,index);
   for i:=0 to (FlinksCount-1) do
     begin
       if (i<>index) then
         begin
           if (linkC^.dwFromNodeNumber=linkP^.dwFromNodeNumber) and
              (linkC^.dwFromLinkNumber=linkP^.dwFromLinkNumber) and
              ((linkC^.dwFlags and BP_FROMMASK)=(LinkP^.dwFlags and BP_FROMMASK)) and
              ((linkC^.dwToNodeNumber and BPGlobalNodeOperation)=0) and
              ((linkP^.dwToNodeNumber and BPGlobalNodeOperation)=0)
               then
               begin
                 if Result=bpmm_From then Result:=bpmm_FromTo
                      else Result:=bpmm_To;
               end;
           if (linkC^.dwToNodeNumber=linkP^.dwToNodeNumber) and
              (linkC^.dwToLinkNumber=linkP^.dwToLinkNumber) and
              ((linkC^.dwFlags and BP_TOMASK)=(LinkP^.dwFlags and BP_TOMASK)) and
              ((linkC^.dwFromNodeNumber and BPGlobalNodeOperation)=0) and
              ((linkP^.dwFromNodeNumber and BPGlobalNodeOperation)=0) then
               begin
                 if Result=bpmm_To then Result:=bpmm_FromTo
                      else Result:=bpmm_From;
               end;
         end;
       inc(linkC);
     end;
  end;

function  TBPGraph.CompareGraphLinkWithLink(l1:PGraphLink;l2:PBPLink;CompareFrom:Boolean):Boolean; { Checked }
 Var s1,s2:ShortString;
 begin
   {}
     Result:=False;
{     if CompareFrom then
     begin
       if ((l1^.dwFlags and BP_SHOW_FROMCAPTION)<>0) and
          ((l2^.dwFlags and BP_SHOW_FROMCAPTION)<>0) and
          (l1^.BPFromLabel<>nil) then
       begin
        s1:=l1^.BPFromLabel.Caption;
        s2:=l2^.ssFromCaption;
        if (s1<>s2) then Exit;
       end else Exit;
     end
      else
     begin
     if ((l1^.dwFlags and BP_SHOW_TOCAPTION)<>0) and
        ((l2^.dwFlags and BP_SHOW_TOCAPTION)<>0) and
        (l1^.BPToLabel<>nil) then
       begin
        s1:=l1^.BPToLabel.Caption;
        s2:=l2^.ssToCaption;
        if (s1<>s2) then Exit;
       end else Exit;
     end;}
       if CompareFrom then
        begin
          if (l1^.FromNodeNumber<>l2^.dwFromNodeNumber) then Exit;
          if (l1^.FromLinkNumber<>l2^.dwFromLinkNumber) then Exit;
          if (l1^.dwFlags and BP_FROMMASK)<>(l2^.dwFlags and BP_FROMMASK) then Exit;
        end
       else
        begin
          if (l1^.ToNodeNumber<>l2^.dwToNodeNumber) then Exit;
          if (l1^.ToLinkNumber<>l2^.dwToLinkNumber) then Exit;
          if (l1^.dwFlags and BP_TOMASK)<>(l2^.dwFlags and BP_TOMASK) then Exit;
        end;
     Result:=True;
 end;

procedure TBPGraph.UpdateNodesModel(X,Y:Integer;node:TBPGraphNode); { Checked }
Var xc,yc:Integer;
    nodePtr:PBPNode;
    i:Integer;
 begin
   if FNodesCount=0 then Exit;
   if node=nil then Exit;
   if FRatioWC=0 then Exit;
   if FRatioHC=0 then Exit;
  { Recalc X and Y coord to not scaled model }
   if FScaled or FPrinting then
    begin
     xc:=Round(X/FRatioWC);
     yc:=Round(Y/FRatioHC);
    end
   else
    begin
     xc:=x;
     yc:=y;
    end;
  { Update nodes model }
   nodePtr:=FNodes;
   for i:=0 to (FNodesCount-1) do
     begin
       if CompareGraphNodeWithNode(node,nodePtr) then
         begin
           nodePtr^.Left[0]:=xc;
           nodePtr^.Top[0]:=yc;
           nodePtr^.AcceptPosition[0]:=True;
           FModified:=True;
         end;
       inc(nodePtr);
     end;
 end;

procedure TBPGraph.UpdateLinksModel(X,Y:Integer;llabel:TBPLabel); { Checked }
Var xc,yc:Integer;
    i,j:Integer;
    linkPtr:PBPLink;
    link:PGraphLink;

 begin
   if FLinksCount=0 then Exit;
   if llabel=nil then Exit;
   if FRatioWC=0 then Exit;
   if FRatioHC=0 then Exit;
  { Recalc X and Y coord to not scaled model }
   if FScaled or FPrinting then
    begin
     xc:=Round(X/FRatioWC);
     yc:=Round(Y/FRatioHC);
    end
   else
    begin
     xc:=x;
     yc:=y;
    end;
  { Update links model}
    for i:=0 to (FLinksCount-1) do
      begin
        link:=GetGraphLink(i);
        if (link^.BPFromLabel<>nil) then
          if (link^.BPFromLabel=llabel) then
            begin
              linkPtr:=FLinks;
              for j:=0 to (FLinksCount-1) do
               begin
                    if CompareGraphLinkWithLink(link,linkPtr,True) then
                      begin
                        linkPtr^.FromLeft[0]:=xc;
                        linkPtr^.FromTop[0]:=yc;
                        linkPtr^.FromAcceptPosition[0]:=True;
                        FModified:=True;
                      end;
                 inc(linkPtr);
               end;
            end;
        if (link^.BPToLabel<>nil) then
          if (link^.BPToLabel=llabel) then
            begin
              linkPtr:=FLinks;
              for j:=0 to (FLinksCount-1) do
               begin
                    if CompareGraphLinkWithLink(link,linkPtr,False) then
                      begin
                        linkPtr^.ToLeft[0]:=xc;
                        linkPtr^.ToTop[0]:=yc;
                        linkPtr^.ToAcceptPosition[0]:=True;
                        FModified:=True;
                      end;
                 inc(linkPtr);
               end;
            end;
      end;
 end;

procedure TBPGraph.CorectMultipleLinks(value:TBPLabel); { Checked }
Var i,j:Integer;
    link1,link2:PGraphLink;
    mm1,mm2:TBPMultipleMask;
 begin
  { Move multiple links label in same position }
    if FLinksCount=0 then Exit;
    for i:=0 to (FLinksCount-1) do
      begin
        link1:=GetGraphLink(i);
        mm1:=GetMultipleMask(i);
        if (link1^.BPFromLabel<>nil) then
        if (link1^.BPFromLabel.AcceptPosition) and
           ((mm1=bpmm_To) or (mm1=bpmm_FromTo)) and
           (link1^.BPFromLabel=value) then
            begin
              for j:=0 to (FLinksCount-1) do
               if i<>j then
                 begin
                   link2:=GetGraphLink(j);
                   mm2:=GetMultipleMask(j);
                   if (link2^.BPFromLabel<>nil) then
                   if ((mm2=bpmm_To) or (mm2=bpmm_FromTo)) then
                    begin
                      if (link1^.FromLinkNumber=link2^.FromLinkNumber) and
                         (link1^.FromNodeNumber=link2^.FromNodeNumber) and
                         ((link1^.dwFlags and BP_FROMMASK)=(link2^.dwFlags and BP_FROMMASK))  then
                        begin
                          link2^.BPFromLabel.AcceptPosition:=True;
                          link2^.BPFromLabel.Left:=link1^.BPFromLabel.Left;
                          link2^.BPFromLabel.Top:=link1^.BPFromLabel.Top;
                          link2^.BPFromLabel.LeftDragPos:=link1^.BPFromLabel.LeftDragPos;
                          link2^.BPFromLabel.TopDragPos:=link1^.BPFromLabel.TopDragPos;
                        end;
                    end;
                 end;

            end;
        if (link1^.BPToLabel<>nil) then
        if (link1^.BPToLabel.AcceptPosition) and
           ((mm1=bpmm_From) or(mm1=bpmm_FromTo)) and
           (link1^.BPToLabel = value) then
            begin
              for j:=0 to (FLinksCount-1) do
               if i<>j then
                 begin
                   link2:=GetGraphLink(j);
                   mm2:=GetMultipleMask(j);
                   if (link2^.BPToLabel<>nil) then
                   if ((mm2=bpmm_From) or (mm2=bpmm_FromTo)) then
                    begin
                      if (link1^.ToLinkNumber=link2^.ToLinkNumber) and
                         (link1^.ToNodeNumber=link2^.ToNodeNumber) and
                         ((link1^.dwFlags and BP_TOMASK)=(link2^.dwFlags and BP_TOMASK))  then
                        begin
                          link2^.BPToLabel.AcceptPosition:=True;
                          link2^.BPToLabel.Left:=link1^.BPToLabel.Left;
                          link2^.BPToLabel.Top:=link1^.BPToLabel.Top;
                          link2^.BPToLabel.LeftDragPos:=link1^.BPToLabel.LeftDragPos;
                          link2^.BPToLabel.TopDragPos:=link1^.BPToLabel.TopDragPos;
                        end;
                    end;
                 end;

            end;
      end;
 end;

procedure TBPGraph.SetDiscardDrags(Value:Boolean); { Checked }
var i:Integer;
    nodePtr:PBPNode;
    linkPtr:PBPLink;
 begin
  { Disable all drags in context diagram }
   FDiscardDrags:=True;
   FOwner.Repaint;
   if FNodesCount=0 then Exit;
   nodePtr:=FNodes;
   for i:=0 to (FNodesCount-1) do
     begin
       nodePtr^.AcceptPosition[0]:=False;
       FModified:=True;
       inc(nodePtr);
     end;
   if FLinksCount=0 then Exit;
   linkPtr:=FLinks;
   for i:=0 to (FLinksCount-1) do
     begin
       LinkPtr^.FromAcceptPosition[0]:=False;
       linkPtr^.ToAcceptPosition[0]:=False;
       FModified:=True;
       inc(linkPtr);
     end;
 end;

procedure TBPGraph.SetDefWidth(Value:Integer);  { Checked }
 begin
  FDefWidth:=Value;
 end;

procedure TBPGraph.SetDefHeight(Value:Integer);  { Checked }
 begin
  FDefHeight:=Value;
 end;

procedure TBPGraph.WriteVisio2k(FileName:String); { Checked }
Var f:TextFile;
    tmp:TBPGraphNode;
    i,j:Integer;
    ls,ts,ws,hs:String;
    snn,pname,snn1:String;
    w,h:Integer;
    lf,tf,wf,hf:Single;
    tmpl:PGraphLink;
    flag:Boolean;
Const xScale=8.0;
      yScale=12.0;

function MyFloat(s:String):String;
 begin
   Result:=s;
   if (pos(',',s)>0) then
     begin
       Result[pos(',',s)]:='.';
     end;
 end;

 begin
  { Visio 2k integration }
  w:=FDefWidth;
  h:=FDefHeight;
  AssignFile(f,FileName);
  Rewrite(f);
  Writeln(f,'Template, "IDEF0 Diagram.vst"');
  Writeln(f,'Master,",,","Activity box","IDEF0 Diagram Shapes.vss"');
  Writeln(f,'Master,",,","Dynamic connector","IDEF0 Diagram Shapes.vss"');
  Writeln(f,'Master,",,","1 legged connector","IDEF0 Diagram Shapes.vss"');
  for i:=0 to (FNodesCount-1) do
   begin
    tmp:=GetGraphNode(i);
    snn:=tmp.SNodeNumber;
    pname:=tmp.Caption;
    lf:=tmp.Left*xScale/w;
    tf:=yScale-tmp.Top*yScale/h;
    wf:=tmp.Width*xScale/w;
    hf:=tmp.Height*yScale/h;
    ls:=MyFloat(FloatToStrF(lf,ffGeneral,7,3));
    ts:=MyFloat(FloatToStrF(tf,ffGeneral,7,3));
    ws:=MyFloat(FloatToStrF(wf,ffGeneral,7,3));
    hs:=MyFloat(FloatToStrF(hf,ffGeneral,7,3));
    Writeln(f,'Shape,"'+snn+'","Activity box",,'+
        ls+','+ts+','+ws+','+hs+',,"'+snn+'","'+pname+'"');

{ ; Shape"A1","Activity box",???,Left,Top,Width,Height,SubDiagramID,"SNumber","Process Name"
   Shape,"A1","Activity box",,2,10,,,,"A1","My Process 1"
   Link,"Link1","Dynamic connector","some text","A1","A2"
    Shape,"Shape Name","Master Name","Shape Text","ShapeX","ShapeY","Width","Height","Cost","Duration","Resources"
;     where anything in quotes denotes the actual value.
;
;     For example,
;     Shape,"MyShape1","Process","This is my shape's text",,,,,"1.05","4 hours","Some resources"
;     Visio determines ShapeX, ShapeY, Width, and Height (the position and size of the shape)
;     when you leave them blank.
 }
   end;
   for i:=0 to (FLinksCount-1) do
    begin
      tmpl:=GetGraphLink(i);
      if ((tmpl^.dwFlags and BP_SHOW_FROMCAPTION)<>0) then
         pname:=tmpl^.BPFromLabel.Caption
      else
         pname:=tmpl^.BPToLabel.Caption;
      flag:=False;
      snn:='GLOBAL';
      snn1:='GLOBAL';
      if ((tmpl^.FromNodeNumber and BPGlobalMask)<>0) then
         flag:=True
      else
        begin
         tmp:=GetGraphNumberedNode(tmpl^.FromNodeNumber);
         snn:=tmp.SNodeNumber;
        end;
      if ((tmpl^.ToNodeNumber and BPGlobalMask)<>0) then
         flag:=True
      else
        begin
         tmp:=GetGraphNumberedNode(tmpl^.ToNodeNumber);
         snn1:=tmp.SNodeNumber;
        end;
      if (not(flag)) then
      Writeln(f,'Link,"Link'+IntToStr(i)+'","Dynamic connector","'+
             pname+'","'+snn+'","'+snn1+'"')
      else
      Writeln(f,'Link,"Link'+IntToStr(i)+'","1 legged connector","'+
             pname+'","'+snn+'","'+snn1+'"')
    end;
  CloseFile(f);
 end;

function  TBPGraph.GetNTFromIndex(index:DWORD):TBPNodeTypes; { Checked }
 Var flag:Boolean;
     i,ic:Integer;
     tmpPtr:PBPNodeTypes;
  begin
     flag:=True;
     tmpPtr:=FNTTree;
     ic:=FHeader.dwNodesTypesCount;
     if (ic>0) then
       begin
         i:=0;
         while ((i<ic) and (flag)) do
           begin
              if tmpPtr^.dwNodeIndex=index then
                 begin
                   flag:=False;
                   Result:=tmpPtr^;
                   Exit;
                 end
               else
                begin
                 inc(tmpPtr);
                 inc(i);
                end;
           end;
       end;
      Result.dwNodeIndex:=index;
      Result.ssCaption:='Default';
      Result.dwFontColor:=clBlack;
      Result.dwPaintColor:=clWhite;
      Result.dwDrawColor:=clBlack;
      Result.dwShadowColor:=clBlack;
      Result.dwShadowStyle:=6;
      Result.dwRectStyle:=2;
  end;

function  TBPGraph.GetLTFromIndex(index:DWORD):TBPLinkTypes; { Checked }
 Var flag:Boolean;
     i,ic:Integer;
     tmpPtr:PBPLinkTypes;
  begin
     flag:=True;
     tmpPtr:=FLTTree;
     ic:=FHeader.dwLinksTypesCount;
     if (ic>0) then
       begin
         i:=0;
         while ((i<ic) and (flag)) do
           begin
              if tmpPtr^.dwLinkIndex=index then
                 begin
                   flag:=False;
                   Result:=tmpPtr^;
                   Exit;
                 end
               else
                begin
                 inc(tmpPtr);
                 inc(i);
                end;
           end;
       end;
      Result.dwLinkIndex:=index;
      Result.ssCaption:='Default';
      Result.dwPenStyle:=psSolid;
      Result.dwColor:=clBlack;
  end;

 procedure  TBPGraph.ClearNTTree; { Checked }
   begin
    if (FNTTree<>nil) then
      begin
        FreeMem(FNTTree,sizeOf(TBPNodeTypes)*FHeader.dwNodesTypesCount);
        FNTTree:=nil;
      end;
   end;

 procedure  TBPGraph.ClearLTTree; { Checked }
   begin
    if (FLTTree<>nil) then
      begin
        FreeMem(FLTTree,sizeOf(TBPLinkTypes)*FHeader.dwLinksTypesCount);
        FLTTree:=nil;
      end;
   end;

 procedure   TBPGraph.SetEnableA0Numeration(Value:Boolean); { Checked }
  begin
   FEnableA0Numeration:=Value;
   if (FLevel=0) and (FSSLevel='0') then
    begin
     OpenLevel(FLevel);
     TraceRoute;
     if (FOwner<>nil) then FOwner.Invalidate;
    end;
  end;


 procedure   TBPGraph.PresetupFrame(widthcoof,heightcoof:Double); { Checked }
 Var LabelsCount:Integer;
  begin
   FCalcWidthHeight:=True;
   CalcMaxWidthHeight;
   if FShowDataWare then CalcDNodesMaxWidthHeight;
   if FShowDataWare then
    begin
     if FDNodesCount>0 then
      begin
       LabelsCount:=GetMaxDNodeLinksCount+1;
       FOperationLabelsSize:=(LabelsCount*MinLabelY2);
      end
     else
       FOperationLabelsSize:=0;
     FGlobalOperationSize:=Round(1.4*(FDMaxHeight+FDPrjMaxHeight))+FOperationLabelsSize; //?
    end
   else
    begin
     FGlobalOperationSize:=0;
     FOperationLabelsSize:=0;
    end;
   FCalcWidthHeight:=False;
  { FDiscardDrags:=True;}
   FRatioWC:=widthcoof;
   FRatioHC:=heightcoof;
  end;

 function  TBPGraph.GetMaxPagesCount:Integer;
  begin
   Result:=GetLevelsCount;
  end;

 function  TBPGraph.GetLevelsCount:Integer; { Checked }
 Var tmpTree:PBPTree;
  begin
   Result:=0;
   if (FTree=nil) then Exit;
   tmpTree:=FTree;
   while (tmpTree<>nil) do
    begin
     inc(Result);
     tmpTree:=tmpTree^.next;
    end;
  end;

 function   TBPGraph.GetLevelInfo(index:Integer):TBPInfo;
  Var tmpTree:PBPTree;
      i:Integer;
  begin
    Result.dwLevel:=-1;
    Result.ssLevel:='-1';
    Result.ssCaption:='';
   if (FTree=nil) then Exit;
   tmpTree:=FTree;
   i:=0;
   while (tmpTree<>nil) and (i<>index) do
    begin
     inc(i);
     tmpTree:=tmpTree^.next;
    end;
    if i<>index then Exit;
    if (tmpTree=nil) then Exit;
     Result.dwLevel:=tmpTree^.dwLevel;
     Result.ssCaption:=tmpTree^.ssCaption;
     Result.ssLevel:=tmpTree^.ssLevel;
  end;

 procedure  TBPGraph.SetDefaultConstants; { Checked }
 Var dc:HDC;
  begin
   FDoOverrideFS:=False;
   dc:=GetDC(FOwner.Handle);
   FFontDPI:=GetDeviceCaps(dc,LOGPIXELSX);
   ReleaseDC(FOwner.Handle,dc);
   FFontSize:=8;
   FDNodesFontSize:=8;
   FDProjectionFontSize:=8;
   FLabelFontSize:=8;
   FIOFontSize:=8;
   FMinLineStep:=StartMinLineStep;
   FNodeLineWidth:=1;
   FNodeDefWidth:=100;
   FNodeDefHeight:=100;
   FNodeHSpacing:=1;
   FNodeVSpacing:=1;
   FGlobalLeftSize:=40;
   FGlobalRightSize:=40;
   FGlobalTopSize:=40;
   FGlobalBottomSize:=40;
   FGlobalOperationSize:=Round(2.2*(FDMaxHeight+FDPrjMaxHeight));
   FMinArcRadius:=StartMinArcRadius;
   FMinLabelX:=StartMinLabelX;
   FMinLabelY:=StartMinLabelY;
   FMinLabelY3:=StartMinLabelY;
   FMinLabelY1:=StartMinLabelY1;
   FMinLabelX2:=StartMinLabelX;
   FMinLabelY2:=StartMinLabelY1;
   FMinLabelYNew:=StartMinLabelYNew;
   FMinGlobalLabel:=StartMinGlobalLabel;
   FNodeShadowDepth:=4;
   FMinLineEndPoint:=StartMinLineEndPoint;
  end;

 procedure  TBPGraph.SetScaledConstants(ratiox,ratioy,ratio:Double;fontSizeRatio:Double;LabelFontSizeRatio:Double;IOFontSizeRatio:Double); { Checked }

 function GetMinLabelY1(Value:Integer):Integer;
 Var  dc:HDC;
     ppi:Integer;
  begin
    Result:=Value;
    if not(FDoOverrideFS and FOverrideLabelsFS) then Exit;
    dc:=GetDC(0);
    ppi:=GetDeviceCaps(dc,LOGPIXELSY);
    ReleaseDC(0,dc);
    if FOwner.FPreviewOrPrint then
      Result:=Round(1.2*FLabelsFontSize*ppi*FOwner.FFOntCoof/72)
    else
      Result:=Round(1.2*FLabelsFontSize*ppi*FScaled2Ratio/100/72);
  end;

 function GetMinLabelY2(Value:Integer):Integer;
  Var  dc:HDC;
     ppi:Integer;
   begin
     Result:=Value;
     if not(FDoOverrideFS and FOverrideDNodesFS) then Exit;
     dc:=GetDC(0);
     ppi:=GetDeviceCaps(dc,LOGPIXELSY);
     ReleaseDC(0,dc);
     if FOwner.FPreviewOrPrint then
       Result:=Round(1.2*FDNodesFontSize*ppi*FOwner.FFOntCoof/72)
     else
       Result:=Round(1.2*FDNodesFontSize*ppi*FScaled2Ratio/100/72);
   end;

  begin
   FDoOverrideFS:=True;
{   if MainUnit.HasPrnDevice then
   FFontDPI:=GetDeviceCaps(Printer.Handle,LOGPIXELSX)
   else}
   FFontDPI:=Round(FFontDPI*ratio);
   FFontSize:=Round(FFontSize*fontSizeRatio);
   FDNodesFontSize:=Round(FDNodesFontSize*fontSizeRatio);
   FDProjectionFontSize:=Round(FDProjectionFontSize*fontSizeRatio);
   FIOFontSize:=Round(FIOFontSize*IOFontSizeRatio);
   if FIOFontSize=0 then FIOFontSize:=1;
   if FFontSize=0 then FFontSize:=1;
   if FDNodesFontSize=0 then FDNodesFontSize:=1;
   if FDProjectionFontSize=0 then FDProjectionFontSize:=1;
   FLabelFontSize:=Round(FLabelFontSize*LabelfontSizeRatio);
   if FLabelFontSize=0 then FLabelFontSize:=1;
   { New block }
   if FLabelFontSize>FRealMaxFontSize then FLabelFontSize:=FRealMaxFontSize;
   if FFontSize>FRealMaxFontSize then FFontSize:=FRealMaxFontSize;
   if FIOFontSize>FRealMaxFontSize then FIOFontSize:=FRealMaxFontSize;
   { End new block }
{   if FLabelFontSize>10 then FLabelFontSize:=10;}
{   FMinLineStep:=(FNodeWidth div 4) div StartMaxLines;}
   FMinLineStep:=FNodeWidth div 8;
   FNodeLineWidth:=Round(FNodeLineWidth*ratio);
   if FNodeLineWidth=0 then FNodeLineWidth:=1;
   FNodeDefWidth:=Round(FNodeDefWidth*ratiox);
   FNodeDefHeight:=Round(FNodeDefHeight*ratioy);
   FNodeHSpacing:=Round(FNodeHSpacing*ratiox);
   FNodeVSpacing:=Round(FNodeVSpacing*ratioy);
   FGlobalLeftSize:=Round(FGlobalLeftSize*ratiox);
   FGlobalRightSize:=Round(FGlobalRightSize*ratiox);
   FGlobalTopSize:=Round(FGlobalTopSize*ratioy);
   FGlobalBottomSize:=Round(FGlobalBottomSize*ratioy);
   FGlobalOperationSize:=Round(FGlobalOperationSize*ratioy);
   FMinArcRadius:=Round(FMinArcRadius*ratio);
   FMinLabelX:=Round(FMinLabelX*ratiox);
   FMinLabelY:=Round(FMinLabelY*ratioy);
   FMinLabelY1:=Round(FMinLabelY1*fontSizeRatio);
   FMinLabelY1:=GetMinLabelY1(FMinLabelY1);
   FMinLabelY2:=Round(FMinLabelY2*iofontSizeRatio);
   FMinLabelY3:=Round(FMinLabelY3*ioFontSizeRatio);
   FMinLabelY2:=GetMinLabelY2(FMinLabelY2);
   FMinLabelX2:=Round(FMinLabelX2*ioFontSizeRatio);
   FMinLabelYNew:=Round(FMinLabelYNew*fontSizeRatio);
   FMinGlobalLabel:=Round(FMinGlobalLabel*ratio);
   FNodeShadowDepth:=Round(FNodeShadowDepth*ratio);
   if FNodeShadowDepth=0 then FNodeShadowDepth:=1;
   FMinLineEndPoint:=Round(FMinLineEndPoint*ratio);
  end;

 constructor TBPGraph.Create(AOwner: TComponent); { Checked }
  begin
    inherited Create(AOwner);
    FOwner:=AOwner as TBPFrame;
    FNodes:=nil;
    FLinks:=nil;
    FNodesCount:=0;
    FLinksCount:=0;
    FGraphNodes:=nil;
    FGraphLinks:=nil;
    FDGraphNodes:=nil;
    FIPGraphNodes:=nil;
    FIPNodesCOunt:=0;
    FDLastNode:=nil;
    FIPNode:=nil;
    FDNodesCount:=0;
    FLang:=RUSSIAN_CHARSET;
    FTree:=nil;
    FOpTree:=nil;     { CurrentWork ! }
    FLTTree:=nil;
    FNTTree:=nil;
    FEntryArray:=nil;
    FCheckGraphArray:=nil;
    FLevel:=-1;
    FSSLevel:='-1';   { CurrentWork ! }
    FParentLevel:=-2; { Disabled }
    FLevelNotes:='';
    FHaspFound:=False;
    FEnableA0Numeration:=True;
    FillChar(FHeader,sizeof(FHeader),0);
    FHeader.dwNodesTypesCount:=0;
    FHeader.dwLinksTypesCount:=0;
    FHeader.dwOpEntries:=0;
    FHeader.dwIPEntries:=0;
    FMaxWidth:=0;
    FMaxHeight:=0;
    FDMaxWidth:=0;
    FDMaxHeight:=0;
    FDPrjMaxHeight:=0;
    FRootEntries:=0;
    FGlobalLeftLinksCount:=0;
    FGlobalRightLinksCount:=0;
    FGlobalTopLinksCount:=0;
    FGlobalBottomLinksCount:=0;
    FGlobalLeftSize:=40;
    FGlobalRightSize:=40;
    FGlobalTopSize:=40;
    FGlobalBottomSize:=40;
    FGlobalOperationSize:=150;
    FFontDPI:=96;
    FFontSize:=8;
    FLabelFontSize:=8;
    FMinLineStep:=StartMinLineStep;
    FNodeLineWidth:=1;
    FNodeDefWidth:=100;
    FNodeDefHeight:=100;
    FNodeHSpacing:=8;
    FNodeVSpacing:=8;
    FNodeShadowDepth:=4;
    FMinArcRadius:=StartMinArcRadius;
    FMinLabelX:=StartMinLabelX;
    FMinLabelY:=StartMinLabelY;
    FMinLabelY3:=StartMinLabelY;
    FMinLabelY1:=StartMinLabelY1;
    FMinLabelYNew:=StartMinLabelYNew;
    FMinGlobalLabel:=StartMinGlobalLabel;
    FMinLineEndPoint:=StartMinLineEndPoint;
    FNodeWidth:=0;
    FNodeHeight:=0;
    FLevelCaption:='';
    FLevelNotes:='';
    FLevelRevision:=0;
    FLevelDraftStatus:=[];
    FLevelPageNumber:=0;
    FCalcWidthHeight:=False;
    FDebug:=False;
    FScaled:=False;
    FScreenFontName:='Times New Roman';
    FPrinterFontName:='Times New Roman';
    FTruncLRGlobalCaptions:=False;
    FTruncLRLocalCaptions:=False;
    FTruncDirection:=False;
    FFirstNodeNumber:=0;
    FLastNodeNumber:=0;
    FDiscardDrags:=False;
    FRatioWC:=1;
    FRatioHC:=1;
    FModified:=False;
    FLinksPosRelative:=True;
    FShowDataWare:=True;
    FShowDataWareLine:=True;
    FTranslateNodesType:=0;
    FReplaceNodes:=False;
    FReplaceLabels:=False;
    FMaxWordLength:=8;
    FMaxWordCount:=5;
    FMaxLabelLength:=32;
    FBPFileStream:=TBPFileStream.Create;
    FScaled2Ratio:=100;
    FScaled2:=True;
    FMaxFontSize:=DefMaxLabelFontSize;
    FRealMaxFontSize:=DefMaxLabelFontSize;
    FMaxGOS:=0.33;
    Scaled:=True;
{    FScaled2:=False;}
  end;

 destructor  TBPGraph.Destroy;  { Checked }
  begin
    if (FGraphNodes<>nil) then ClearGraphNodes;
    if (FDGraphNodes<>nil) then ClearDGraphNodes;
    if (FGraphLinks<>nil) then ClearGraphLinks;
    if (FIPGraphNodes<>nil) then ClearIPGraphNodes;
    if (FTree<>nil) then ClearTree;
    if (FNTTree<>nil) then ClearNTTree;
    if (FLTTree<>nil) then ClearLTTree;
    if (FOPTree<>nil) then ClearOPTree; { CurrentWork ! }
    if (FEntryArray<>nil) then FreeMem(FEntryArray,sizeof(TBPEntryArray));
    if (FCheckGraphArray<>nil) then FreeMem(FCheckGraphArray,sizeof(TBPCheckGraphArray));
    if (FBPFileStream<>nil) then FBPFileStream.Destroy;
    inherited Destroy;
  end;

 procedure  TBPGraph.ClearDGraphNodes; { Checked }
 Var tmpN,tmpN1:PDGraphNode;
  begin
   FDLastNode:=nil;
   if FGraphNodes=nil then Exit;
   tmpN:=FDGraphNodes;
   tmpN1:=nil;
   while tmpN<>nil do
    begin
      if tmpN1<>nil then
        begin
        { tmpN1^.BPDNode.OnDblClick:=nil;
         tmpN1^.BPDNode.OnMouseDown:=nil;
         tmpN1^.BPDNode.PopupMenu:=nil;}
         tmpN1^.BPDNode.Destroy;
         FreeMem(tmpN1);
        end;
      tmpN1:=tmpN;
      tmpN:=tmpN.Next;
    end;
    if tmpN1<>nil then
       begin
        { tmpN1^.BPDNode.OnDblClick:=nil;
         tmpN1^.BPDNode.OnMouseDown:=nil;
         tmpN1^.BPDNode.PopupMenu:=nil;}
         tmpN1^.BPDNode.Destroy;
         FreeMem(tmpN1);
       end;
   FDGraphNodes:=nil;
   FDMaxWidth:=0;
   FDMaxHeight:=0;
   FDPrjMaxHeight:=0;
  end;


 procedure  TBPGraph.ClearGraphNodes; { Checked }
 Var tmpN,tmpN1:PGraphNode;
  begin
   if FGraphNodes=nil then Exit;
   tmpN:=FGraphNodes;
   tmpN1:=nil;
   while tmpN<>nil do
    begin
      if tmpN1<>nil then
        begin
         tmpN1^.BPNode.OnDblClick:=nil;
         tmpN1^.BPNode.OnMouseDown:=nil;
         tmpN1^.BPNode.PopupMenu:=nil;
         tmpN1^.BPNode.Destroy;
         FreeMem(tmpN1);
        end;
      tmpN1:=tmpN;
      tmpN:=tmpN.Next;
    end;
    if tmpN1<>nil then
       begin
         tmpN1^.BPNode.OnDblClick:=nil;
         tmpN1^.BPNode.OnMouseDown:=nil;
         tmpN1^.BPNode.PopupMenu:=nil;
         tmpN1^.BPNode.Destroy;
         FreeMem(tmpN1);
       end;
   FGraphNodes:=nil;
   FMaxWidth:=0;
   FMaxHeight:=0;
  end;

 procedure  TBPGraph.ClearGraphLinks; { Checked }
  Var tmpN,tmpN1:PGraphLink;
  begin
   { Clears graphics links list }
   if FGraphLinks=nil then Exit;
   tmpN:=FGraphLinks;
   tmpN1:=nil;
   while tmpN<>nil do
    begin
      if tmpN1<>nil then
        begin
         if ((tmpN1^.dwFlags and BP_SHOW_FROMCAPTION)<>0)  and (tmpN1^.BPFromLabel<>nil) and (tmpN1^.BPFromLabel<>nil) then
           begin
            tmpN1^.BPFromLabel.OnMouseDown:=nil;
            tmpN1^.BPFromLabel.PopupMenu:=nil;
            tmpN1^.BPFromLabel.Destroy;
           end;
         if ((tmpN1^.dwFlags and BP_SHOW_TOCAPTION)<>0) and (tmpN1^.BPToLabel<>nil) and (tmpN1^.BPToLabel<>nil) then
           begin
            tmpN1^.BPToLabel.OnMouseDown:=nil;
            tmpN1^.BPToLabel.PopupMenu:=nil;
            tmpN1^.BPToLabel.Destroy;
           end;
         if ((tmpN1^.dwFlags and BP_SHOW_GLOBALCAPTION)<>0) and (tmpN1^.BPGlobalLabel<>nil) and (tmpN1^.BPGlobalLabel<>nil) then tmpN1^.BPGlobalLabel.Destroy;
         tmpN1^.llLink:=nil;
         FreeMem(tmpN1);
        end;
      tmpN1:=tmpN;
      tmpN:=tmpN.Next;
    end;
    if tmpN1<>nil then
       begin
         if ((tmpN1^.dwFlags and BP_SHOW_FROMCAPTION)<>0)  and (tmpN1^.BPFromLabel<>nil) then
           begin
            tmpN1^.BPFromLabel.OnMouseDown:=nil;
            tmpN1^.BPFromLabel.PopupMenu:=nil;
            tmpN1^.BPFromLabel.Destroy;
           end;
         if ((tmpN1^.dwFlags and BP_SHOW_TOCAPTION)<>0)  and (tmpN1^.BPToLabel<>nil) then
           begin
            tmpN1^.BPToLabel.OnMouseDown:=nil;
            tmpN1^.BPToLabel.PopupMenu:=nil;
            tmpN1^.BPToLabel.Destroy;
           end;
         if ((tmpN1^.dwFlags and BP_SHOW_GLOBALCAPTION)<>0)  and (tmpN1^.BPGlobalLabel<>nil) then tmpN1^.BPGlobalLabel.Destroy;
         tmpN1^.llLink:=nil;
         FreeMem(tmpN1);
       end;
   FGraphLinks:=nil;
  end;

 function   TBPGraph.GetMaxNodeNumber:DWORD; { Checked ?? Hm }
 Var gnode:TBPGraphNode;
     i:Integer;
  begin
    Result:=0;
    if (FNodesCount=0) then Exit;
    for i:=0 to (FNodesCount-1) do
     begin
      gnode:=GetGraphNode(i);
      if (gnode<>nil) then
      if Result<gnode.NodeNumber then Result:=gnode.NodeNumber;
     end;
  end;

procedure  TBPGraph.AddDNode(num:DWORD;Cap:String;Prj:String;HintPrj:String;index:Integer;snn:ShortString);
 Var nodeG:PDGraphNode;
     curNodeG:PDGraphNode;
     tmp:TBPNodeTypes;
 begin
   tmp:=GetNTFromIndex(index);
   if (FDNodesCount=0) then
       begin
                   curNodeG:=PDGraphNode(AllocMem(sizeof(TDGraphNode)));
                   curNodeG^.BPDNode:=TBPDGraphNode.Create(Parent);
                   curNodeG^.BPDNode.Parent:=Parent as TWinControl;
                   curNodeG^.BPDNode.Text:=cap;
                   curNodeG^.BPDNode.Projection:=prj;
                   curNodeG^.BPDNode.NodeNumber:=num;
                   curNodeG^.BPDNode.SNodeNumber:=snn;
                   curNodeG^.BPDNode.AutoHeight:=False;
                   curNodeG^.BPDNode.AutoWidth:=False;
                   curNodeG^.BPDNode.Hint:=HintPrj;
                   curNodeG^.BPDNode.ShowHint:=True;
                   curNodeG^.BPDNode.Font.Color:=tmp.dwFontColor;
                   curNodeG^.BPDNode.Font.Charset:=FLang;
                   curNodeG^.BPDNode.PrjFont.Charset:=FLang;
                   curNodeG^.BPDNode.PrjFont.Color:=tmp.dwFontColor;
                   curNodeG^.BPDNode.PaintColor:=tmp.dwPaintColor;
                   curNodeG^.BPDNode.ShadowType:=TDSShadowType(tmp.dwShadowStyle);
                   curNodeG^.BPDNode.RectStyle:=TDSRectStyle(tmp.dwRectStyle);
                   curNodeG^.BPDNode.ShadowColor:=tmp.dwShadowColor;
                   curNodeG^.BPDNode.RectColor:=tmp.dwDrawColor;
                   curNodeG^.BPDNode.Font.Name:=FPrinterFontName;
                   curNodeG^.BPDNode.PrjFont.Name:=FPrinterFontName;
                   if FDoOverrideFS and FOverrideDNodesFS then
                     if FOwner.FPreviewOrPrint then
                       curNodeG^.BPDNode.Font.Size:=Round(FDNodesFontSize*FOwner.FFontCoof)
                     else
                       curNodeG^.BPDNode.Font.Size:=Round(FDNodesFontSize*FScaled2Ratio/100)
                   else
                   curNodeG^.BPDNode.Font.Size:=FIOFontSize;
                   curNodeG^.BPDNode.Font.Style:=[];
                   if FDoOverrideFS and FOverrideDNodesFS then
                     if FOwner.FPreviewOrPrint then
                       curNodeG^.BPDNode.PrjFont.Size:=Round(FDProjectionFontSize*FOwner.FFOntCoof)
                     else
                       curNodeG^.BPDNode.PrjFont.Size:=Round(FDProjectionFontSize*FScaled2Ratio/100)
                   else
                   curNodeG^.BPDNode.PrjFont.Size:=FIOFontSize;
                   curNodeG^.BPDNode.PrjFont.Style:=[];
                   curNodeG^.BPDNode.SetFontDPI(FFontDPI);
                   curNodeG^.BPDNode.ShadowDepth:=FNodeShadowDepth;
                   curNodeG^.BPDNode.LineWidth:=FNodeLineWidth;
                   curNodeG^.BPDNode.DefWidth:=Round(FNodeDefWidth*1.5);
                   curNodeG^.BPDNode.DefHeight:=FNodeDefHeight;
                   curNodeG^.BPDNode.HSpacing:=FNodeHSpacing;
                   curNodeG^.BPDNode.VSpacing:=FNodeVSpacing;
                   curNodeG^.CorrectNode:=True;
                   {if nodeP^.AcceptPosition then
                    begin
                     curNodeG^.BPNode.Top:=Round(nodeP^.Top*hc);
                     curNodeG^.BPNode.Left:=Round(nodeP^.Left*wc);
                    end;
                   curNodeG^.BPNode.AcceptPosition:=nodeP^.AcceptPosition;
                   curNodeG^.BPNode.DragMode:=dmManual;
                   curNodeG^.BPNode.OnMouseDown:=MyNodeMouseDown;
                   curNodeG^.BPNode.OnDblClick:=MyNodeDblClick;}
                   curNodeG^.BPDNode.PopupMenu:=BPViewMainForm.DNodesPopupMenu;
                  { curNodeG^.BPDNode.Tag:=j;}
                   curNodeG^.next:=nil;
                   FDGraphNodes:=curNodeG;
                   FDLastNode:=curNodeG;
                 end
               else
                 begin
                   nodeG:=PDGraphNode(AllocMem(sizeof(TDGraphNode)));
                   nodeG^.BPDNode:=TBPDGraphNode.Create(Parent);
                   nodeG^.BPDNode.Parent:=Parent as TWinControl;
                   nodeG^.BPDNode.Text:=cap;
                   nodeG^.BPDNode.Projection:=prj;
                   nodeG^.BPDNode.NodeNumber:=num;
                   nodeG^.BPDNode.SNodeNumber:=snn;
                   nodeG^.BPDNode.AutoHeight:=False;
                   nodeG^.BPDNode.AutoWidth:=False;
                   nodeG^.BPDNode.Hint:=HintPrj;
                   nodeG^.BPDNode.ShowHint:=True;
                   nodeG^.BPDNode.Font.Color:=tmp.dwFontColor;
                   nodeG^.BPDNode.PrjFont.Color:=tmp.dwFontColor;
                   NodeG^.BPDNode.Font.Charset:=FLang;
                   NodeG^.BPDNode.PrjFont.Charset:=FLang;
                   nodeG^.BPDNode.PaintColor:=tmp.dwPaintColor;
                   nodeG^.BPDNode.ShadowType:=TDSShadowType(tmp.dwShadowStyle);
                   nodeG^.BPDNode.RectStyle:=TDSRectStyle(tmp.dwRectStyle);
                   nodeG^.BPDNode.ShadowColor:=tmp.dwShadowColor;
                   nodeG^.BPDNode.RectColor:=tmp.dwDrawColor;
                  { End New }
                   nodeG^.BPDNode.Font.Name:=FPrinterFontName;
                   nodeG^.BPDNode.PrjFont.Name:=FPrinterFontName;
                   if FDoOverrideFS and FOverrideDNodesFS then
                    if FOwner.FPreviewOrPrint then
                      NodeG^.BPDNode.Font.Size:=Round(FDNodesFontSize*FOwner.FFOntCoof)
                    else
                      NodeG^.BPDNode.Font.Size:=Round(FDNodesFontSize*FScaled2Ratio/100)
                   else
                   nodeG^.BPDNode.Font.Size:=FIOFontSize;
                   if FDoOverrideFS and FOverrideDNodesFS then
                    if FOwner.FPreviewOrPrint then
                      NodeG^.BPDNode.PrjFont.Size:=Round(FDProjectionFontSize*FOwner.FFOntCoof)
                    else
                      NodeG^.BPDNode.PrjFont.Size:=Round(FDProjectionFontSize*FScaled2Ratio/100)
                   else
                   nodeG^.BPDNode.PrjFont.Size:=FIOFontSize;
                   nodeG^.BPDNode.Font.Style:=[];
                   nodeG^.BPDNode.PrjFont.Style:=[];
                   nodeG^.BPDNode.SetFontDPI(FFontDPI);
                   nodeG^.BPDNode.ShadowDepth:=FNodeShadowDepth;
                   nodeG^.BPDNode.LineWidth:=FNodeLineWidth;
                   nodeG^.BPDNode.DefWidth:=Round(FNodeDefWidth*1.5);
                   nodeG^.BPDNode.DefHeight:=FNodeDefHeight;
                   nodeG^.BPDNode.HSpacing:=FNodeHSpacing;
                   nodeG^.BPDNode.VSpacing:=FNodeVSpacing;
                   nodeG^.CorrectNode:=True;
                   {if nodeP^.AcceptPosition then
                     begin
                      nodeG^.BPNode.Top:=Round(nodeP^.Top*hc);
                      nodeG^.BPNode.Left:=Round(nodeP^.Left*wc);
                     end;
                   nodeG^.BPNode.AcceptPosition:=nodeP^.AcceptPosition;
                   nodeG^.BPNode.DragMode:=dmManual;
                   nodeG^.BPNode.OnMouseDown:=MyNodeMouseDown;
                   nodeG^.BPNode.OnDblClick:=MyNodeDblClick;}
                   nodeG^.BPDNode.PopupMenu:=BPViewMainForm.DNodesPopupMenu;
                  { nodeG^.BPDNode.Tag:=j;}
                   nodeG^.next:=nil;
                   FDLastNode^.next:=nodeG;
                   FDLastNode:=nodeG;
                 end;
        inc(FDNodesCount);
 end;

function TBPGraph.GetDNode(num:DWORD):PBPOpTree;
Var nodeP:PBPOpTree;
    Flag:Boolean;
 begin
  Result:=nil;
 {}
  if (FHeader.dwOpEntries=0) then Exit;
  nodeP:=FOpTree;
  Flag:=True;
  while ((nodeP<>nil) and flag) do
   begin
     if (nodeP^.dwLevel=num) then
        begin
          Result:=nodeP;
          Flag:=False;
        end;
     nodeP:=nodeP^.next;
   end;
 end;

procedure  TBPGraph.CreateDGraphNodes(wc,hc:Double);
 Var i,j:Integer;
     s,s1:String;
     ph:String;
     tmplink:PBPLink;
     tmpNode:PBPNode;
     opCount:DWORD;
     tmpDNode:PBPOpTree;
     nc:String;
{     fnn,tnn:DWORD;
     fnnd,tnnd:Boolean;}
 begin
  { New procedure }
   if (FDGraphNodes<>nil) then ClearDGraphNodes;
   if (FOPTree=nil) then Exit;
   FDNodesCount:=0;
   tmpNode:=FNodes;
   if (tmpNode=nil) then Exit;
   if (FLinks=nil) then Exit;
   for i:=0 to (FNodesCount-1) do
     begin { fori }
        s:='';
        ph:='';
        opCount:=0;
        tmpLink:=FLinks;
       for j:=0 to (FLinksCount-1) do
        begin { forj }
          if (tmpLink^.dwFromNodeNumber=tmpNode^.dwNodeNumber) and
             ((tmpLink^.dwToNodeNumber and BPGlobalNodeOperation)<>0) then
             begin
              inc(opCount);
              tmpDNode:=GetDNode(tmpLink^.dwToNodeNumber and BPNotGlobalMask);
              nc:=MyUtils.MyReplaceNodeCaption(Trim(tmpDNode^.ssCaption),FMaxWordLength,FMaxWordCount,FReplaceNodes);
              if pos(nc,s)=0 then
              if Length(nc)>0 then
               begin
                s:=s+nc+#13;
                ph:=ph+Trim(tmpDNode^.ssCaption)+#13;
               end;
             end;
          if (tmpLink^.dwToNodeNumber=tmpNode^.dwNodeNumber) and
             ((tmpLink^.dwFromNodeNumber and BPGlobalNodeOperation)<>0) then
             begin
              inc(opCount);
              tmpDNode:=GetDNode(tmpLink^.dwFromNodeNumber and BPNotGlobalMask);
              nc:=MyUtils.MyReplaceNodeCaption(Trim(tmpDNode^.ssCaption),FMaxWordLength,FMaxWordCount,FReplaceNodes);
              if pos(nc,s)=0 then
              if Length(nc)>0 then
               begin
                s:=s+nc+#13;
                ph:=ph+Trim(tmpDNode^.ssCaption)+#13;
               end;
             end;
          inc(tmpLink);
        end;  { forj }
        if (opCount>0) then
          AddDNode(tmpNode^.dwNodeNumber,
                    MyUtils.MyReplaceNodeCaption(Trim(BPViewMainForm.DFDBlockName),FMaxWordLength,FMaxWordCount,FReplaceNodes),
                    s,ph,tmpNode^.dwNodeIndex,tmpNode^.ssNodeNumber);
        inc(tmpNode);
     end;  { fori }
 end;

function   TBPGraph.CheckForDecompose(ssNumber:String):Boolean;
Var tmpTree:PBPTree;
    s:String;
    flag:Boolean;
 begin
   Result:=False;
   if FTree=nil then Exit;
   s:=Trim(ssNumber);
   if length(s)=0 then Exit;
   delete(s,1,1);
   tmpTree:=FTree;
   flag:=True;
   while (tmpTree<>nil) and flag do
    begin
      if Trim(tmpTree^.ssLevel)=s then
         begin
           Result:=True;
           Flag:=False;
           Exit;
         end
       else tmpTree:=tmpTree^.next;
    end;
 end;

procedure  TBPGraph.CreateGraphNodes(wc,hc:Double); { Checked }
 Var nodeP:PBPNode;
     nodeG:PGraphNode;
     curNodeG:PGraphNode;
     i:Integer;
     tmp:TBPNodeTypes;
     s:String;
     nc:String;
    fnc:String;
  begin
   if (FGraphNodes<>nil) then ClearGraphNodes;
   if (FNodes=nil) then Exit;
   FGlobalLeftLinksCount:=0;
   FGlobalRightLinksCount:=0;
   FGlobalTopLinksCount:=0;
   FGlobalBottomLinksCount:=0;
   nodeP:=FNodes;
   for i:=0 to (FNodesCount-1) do
    begin
      nc:=GetNodeCaption(nodep);
      fnc:=nc;
      nc:=MyUtils.MyReplaceNodeCaption(nc,FMaxWordLength,FMaxWordCount,FReplaceNodes);
      tmp:=GetNTFromIndex(nodeP^.dwNodeIndex);
      if (i=0) then
          begin
            curNodeG:=PGraphNode(AllocMem(sizeof(TGraphNode)));
            curNodeG^.BPNode:=TBPGraphNode.Create(Parent);
            curNodeG^.BPNode.Parent:=Parent as TWinControl;
            curNodeG^.BPNode.Caption:=nc;
            curNodeG^.BPNode.FullCaption:=fnc;
            curNodeG^.BPNode.NodeNumber:=nodeP^.dwNodeNumber;
            curNodeG^.BPNode.SNodeNumber:=nodeP^.ssNodeNumber;
            curNodeG^.BPNode.AutoHeight:=False;
            curNodeG^.BPNode.AutoWidth:=False;
{            curNodeG^.BPNode.AutoHeight:=True;
            curNodeG^.BPNode.AutoWidth:=True;}
            if not(FScaled2) then
            begin
            s:=Format('%f',[nodeP^.fABCValue]);
            curNodeG^.BPNode.Hint:=nodeP^.ssNodeNumber+': '+nodeP^.ssCaption+' ['+s+']';
            end
            else
            begin
            if (Length(nodeP^.ssComment)>0) then
             curNodeG^.BPNode.Hint:=nodeP^.ssComment
            else
             begin
              s:=Format('%f',[nodeP^.fABCValue]);
              curNodeG^.BPNode.Hint:=nodeP^.ssNodeNumber+': '+nodeP^.ssCaption+' ['+s+']';
             end;
            end;
            curNodeG^.BPNode.ShowHint:=True;
            curNodeG^.BPNode.ABCValue:=nodeP^.fABCValue;
            { New }
            curNodeG^.BPNode.Font.Color:=tmp.dwFontColor;
            curNodeG^.BPNode.Font.Charset:=FLang;
            curNodeG^.BPNode.PaintColor:=tmp.dwPaintColor;
            curNodeG^.BPNode.ShadowType:=TDSShadowType(tmp.dwShadowStyle);
            curNodeG^.BPNode.RectStyle:=TDSRectStyle(tmp.dwRectStyle);
            curNodeG^.BPNode.ShadowColor:=tmp.dwShadowColor;
            curNodeG^.BPNode.RectColor:=tmp.dwDrawColor;
            { End New }
            curNodeG^.BPNode.Font.Name:=FPrinterFontName;
            if FDoOverrideFS and FOverrideNodesFS then
             if FOwner.FPreviewOrPrint then
              curNodeG^.BPNode.Font.Size:=Round(FNodesFontSize*FOwner.FFOntCoof)
             else
              curNodeG^.BPNode.Font.Size:=Round(FNodesFontSize*FScaled2Ratio/100)
            else
            curNodeG^.BPNode.Font.Size:=FFontSize;
            curNodeG^.BPNode.Font.Style:=[fsBold];
            curNodeG^.BPNode.TopToLeftCount:=0;
            curNodeG^.BPNode.BottomToLeftCount:=0;
            curNodeG^.BPNode.LeftToTopCount:=0;
            curNodeG^.BPNode.RightToTopCount:=0;
            curNodeG^.BPNode.TopToRightCount:=0;
            curNodeG^.BPNode.BottomToRightCount:=0;
            curNodeG^.BPNode.LeftToBottomCount:=0;
            curNodeG^.BPNode.RightToBottomCount:=0;
            curNodeG^.BPNode.TopLinksCount:=0;
            curNodeG^.BPNode.BottomLinksCount:=0;
            curNodeG^.BPNode.LeftLinksCount:=0;
            curNodeG^.BPNode.RightLinksCount:=0;
            curNodeG^.BPNode.ShadowDepth:=FNodeShadowDepth;
            curNodeG^.BPNode.LineWidth:=FNodeLineWidth;
            curNodeG^.BPNode.DefWidth:=FNodeDefWidth;
            curNodeG^.BPNode.DefHeight:=FNodeDefHeight;
            curNodeG^.BPNode.HSpacing:=FNodeHSpacing;
            curNodeG^.BPNode.VSpacing:=FNodeVSpacing;
            curNodeG^.BPNode.VAlign:=BPNode.taVCenter;
            curNodeG^.BPNode.SetFontDPI(FFontDPI);
            curNodeG^.BPNode.HasDecompose:=CheckForDecompose(nodeP^.ssNodeNumber);
            curNodeG^.CorrectNode:=True;
            if nodeP^.AcceptPosition[0] then
            begin
            curNodeG^.BPNode.Top:=Round(nodeP^.Top[0]*hc);
            curNodeG^.BPNode.Left:=Round(nodeP^.Left[0]*wc);
            end;
            curNodeG^.BPNode.AcceptPosition:=nodeP^.AcceptPosition[0];
            curNodeG^.BPNode.DragMode:=dmManual;
            curNodeG^.BPNode.OnMouseDown:=MyNodeMouseDown;
            curNodeG^.BPNode.OnDblClick:=MyNodeDblClick;
            curNodeG^.BPNode.PopupMenu:=BPViewMainForm.NodesPopupMenu;
            curNodeG^.BPNode.Tag:=i;
            curNodeG^.llNode:=nodeP;
            curNodeG^.next:=nil;
            FGraphNodes:=curNodeG;
          end
       else
          begin
            nodeG:=PGraphNode(AllocMem(sizeof(TGraphNode)));
            nodeG^.BPNode:=TBPGraphNode.Create(Parent);
            nodeG^.BPNode.Parent:=Parent as TWinControl;
            nodeG^.BPNode.Caption:=nc;
            nodeG^.BPNode.FullCaption:=fnc;
            nodeG^.BPNode.SNodeNumber:=nodeP^.ssNodeNumber;
            nodeG^.BPNode.NodeNumber:=nodeP^.dwNodeNumber;
            nodeG^.BPNode.AutoHeight:=False;
            nodeG^.BPNode.AutoWidth:=False;
{            NodeG^.BPNode.AutoHeight:=True;
            NodeG^.BPNode.AutoWidth:=True;}
            if not(FScaled2) then
            begin
            s:=Format('%f',[nodeP^.fABCValue]);
            nodeG^.BPNode.Hint:=nodeP^.ssNodeNumber+': '+nodeP^.ssCaption+' ['+s+']';
            end
            else
            begin
            if (Length(nodeP^.ssComment)>0) then
              nodeG^.BPNode.Hint:=nodeP^.ssComment
            else
             begin
              s:=Format('%f',[nodeP^.fABCValue]);
              nodeG^.BPNode.Hint:=nodeP^.ssNodeNumber+': '+nodeP^.ssCaption+' ['+s+']';
             end;
            end;
            nodeG^.BPNode.ShowHint:=True;
            nodeG^.BPNode.ABCValue:=nodeP^.fABCValue;
            { New }
            nodeG^.BPNode.Font.Color:=tmp.dwFontColor;
            NodeG^.BPNode.Font.Charset:=FLang;
            nodeG^.BPNode.PaintColor:=tmp.dwPaintColor;
            nodeG^.BPNode.ShadowType:=TDSShadowType(tmp.dwShadowStyle);
            nodeG^.BPNode.RectStyle:=TDSRectStyle(tmp.dwRectStyle);
            nodeG^.BPNode.ShadowColor:=tmp.dwShadowColor;
            nodeG^.BPNode.RectColor:=tmp.dwDrawColor;
            { End New }
            nodeG^.BPNode.Font.Name:=FPrinterFontName;
            if FDoOverrideFS and FOverrideNodesFS then
              if FOwner.FPreviewOrPrint then
               nodeG^.BPNode.Font.Size:=Round(FNodesFontSize*FOwner.FFOntCoof)
              else
               nodeG^.BPNode.Font.Size:=Round(FNodesFontSize*FScaled2Ratio/100)
            else
            nodeG^.BPNode.Font.Size:=FFontSize;
            nodeG^.BPNode.Font.Style:=[fsBold];
            nodeG^.BPNode.SetFontDPI(FFontDPI);
            nodeG^.BPNode.TopToLeftCount:=0;
            nodeG^.BPNode.BottomToLeftCount:=0;
            nodeG^.BPNode.LeftToTopCount:=0;
            nodeG^.BPNode.RightToTopCount:=0;
            nodeG^.BPNode.TopToRightCount:=0;
            nodeG^.BPNode.BottomToRightCount:=0;
            nodeG^.BPNode.LeftToBottomCount:=0;
            nodeG^.BPNode.RightToBottomCount:=0;
            nodeG^.BPNode.TopLinksCount:=0;
            nodeG^.BPNode.BottomLinksCount:=0;
            nodeG^.BPNode.LeftLinksCount:=0;
            nodeG^.BPNode.RightLinksCount:=0;
            nodeG^.BPNode.ShadowDepth:=FNodeShadowDepth;
            nodeG^.BPNode.SetFontDPI(FFontDPI);
            nodeG^.BPNode.LineWidth:=FNodeLineWidth;
            nodeG^.BPNode.DefWidth:=FNodeDefWidth;
            nodeG^.BPNode.DefHeight:=FNodeDefHeight;
            nodeG^.BPNode.HSpacing:=FNodeHSpacing;
            nodeG^.BPNode.VSpacing:=FNodeVSpacing;
            nodeG^.BPNode.VAlign:=BPNode.taVCenter;
            nodeG^.BPNode.HasDecompose:=CheckForDecompose(nodeP^.ssNodeNumber);
            nodeG^.CorrectNode:=True;
            if nodeP^.AcceptPosition[0] then
            begin
            nodeG^.BPNode.Top:=Round(nodeP^.Top[0]*hc);
            nodeG^.BPNode.Left:=Round(nodeP^.Left[0]*wc);
            end;
            nodeG^.BPNode.AcceptPosition:=nodeP^.AcceptPosition[0];
            nodeG^.BPNode.DragMode:=dmManual;
            nodeG^.BPNode.OnMouseDown:=MyNodeMouseDown;
            nodeG^.BPNode.OnDblClick:=MyNodeDblClick;
            nodeG^.BPNode.PopupMenu:=BPViewMainForm.NodesPopupMenu;
            nodeG^.BPNode.Tag:=i;
            nodeG^.llNode:=nodeP;
            nodeG^.next:=nil;
            curNodeG^.next:=nodeG;
            curNodeG:=nodeG;
          end;
          if (i=0) then FFirstNodeNumber:=nodeP^.dwNodeNumber;
          if (i=FNodesCount-1) then FLastNodeNumber:=nodeP^.dwNodeNumber;
          Inc(nodeP);
    end;
  end;

 procedure  TBPGraph.SetFontSize(Value:Integer);  { Checked }
  begin
   if Value=FFontSize then Exit;
   FFontSize:=Value;
   CreateGraphNodes(FRatioWC,FRatioHC);
   CreateIPGraphNodes(FRatioWC,FRatioHC);
   CreateGraphLinks(FRatioWC,FRatioHC);
   if FShowDataWare then
        CreateDGraphNodes(FRatioWC,FRatioHC)
   else
        ClearDGraphNodes;
  end;

 procedure  TBPGraph.CalcDNodesMaxWidthHeight;
 Var nodeP:PDGraphNode;
     i:Integer;
     j:Integer;
  begin
  if FDNodesCount=0 then Exit;
   FDMaxWidth:=0;
   FDMaxHeight:=0;
   FDPrjMaxHeight:=0;
   FMaxOpNodeHeight:=0;
   nodeP:=FDGraphNodes;
    for i:=0 to (FDNodesCount-1) do
     begin
{       nodeP^.BPDNode.DefWidth:=1000;}
       nodeP^.BPDNode.AutoHeight:=True;
       nodeP^.BPDNode.AutoWidth:=True;
       nodeP^.BPDNode.PaintImmediate;
       while nodeP^.BPDNode.Updating do;
       if nodeP^.BPDNode.MaxWidth>FDMaxWidth then
               FDMaxWidth:=nodeP^.BPDNode.MaxWidth;
       if nodeP^.BPDNode.MaxHeight>FDMaxHeight then
               FDMaxHeight:=nodeP^.BPDNode.MaxHeight;
       if nodeP^.BPDNode.PrjMaxHeight>FDPrjMaxHeight then
               FDPrjMaxHeight:=nodeP^.BPDNode.PrjMaxHeight;
{       if nodeP^.BPDNode.Height>FMaxOpNodeHeight then
               FMaxOpNodeHeight:=nodeP^.BPDNode.Height;}
       if nodeP^.BPDNode.MaxWidth>(Round(FMaxWidth*1.5)) then
               FMaxWidth:=Round(nodeP^.BPDNode.MaxWidth/1.5);
       nodeP^.BPDNode.AutoHeight:=False;
       nodeP^.BPDNode.AutoWidth:=False;
       nodeP^.BPDNode.Repaint;
       nodeP:=nodeP^.next;
     end;
  end;

 procedure  TBPGraph.CalcMaxWidthHeight;  { Checked }
 Var nodeP:PGraphNode;
     i:Integer;
  begin
   if FNodesCount=0 then Exit;
   FMaxWidth:=0;
   FMaxHeight:=0;
   nodeP:=FGraphNodes;
    for i:=0 to (FNodesCount-1) do
     begin
       nodeP^.BPNode.AutoHeight:=True;
       nodeP^.BPNode.AutoWidth:=True;
       nodeP^.BPNode.PaintImmediate;{ .Repaint;}
       while nodeP^.BPNode.Updating do;
       if nodeP^.BPNode.MaxWidth>FMaxWidth then
               FMaxWidth:=nodeP^.BPNode.MaxWidth;
       if nodeP^.BPNode.MaxHeight>FMaxHeight then
               FMaxHeight:=nodeP^.BPNode.MaxHeight;
       nodeP^.BPNode.AutoHeight:=False;
       nodeP^.BPNode.AutoWidth:=False;
       nodeP^.BPNode.Repaint;
       nodeP:=nodeP^.next;
     end;
  end;

   procedure TBPGraph.ClearArrayOpLinks;
    var i:Integer;
     begin
       for i:=0 to 600 do
         FbpOperationLinks[i]:=nil;
       FbpOpLinksCount:=0;
     end;

  function TBPGraph.CompareArrayOpLinks(l:PBPLink):Boolean;
  var i:Integer;
   begin
     Result:=False;
     for i:=0 to (FbpOpLinksCount-1) do
      begin
         with FbpOperationLinks[i]^ do
          begin
            if (((dwToNodeNumber and BPGlobalNodeOperation)<>0) and
               ((l^.dwToNodeNumber and BPGlobalNodeOperation)<>0)) then
            if (dwFromNodeNumber=l^.dwFromNodeNumber) and
               (dwFlags=l^.dwFlags) then
            if (l^.ssFromCaption=ssFromCaption) and
               (l^.ssToCaption=ssToCaption) then Result:=True;

            if (((dwFromNodeNumber and BPGlobalNodeOperation)<>0) and
               ((l^.dwFromNodeNumber and BPGlobalNodeOperation)<>0)) then
            if (dwToNodeNumber=l^.dwToNodeNumber) and
               (dwFlags=l^.dwFlags) then
            if (l^.ssFromCaption=ssFromCaption) and
               (l^.ssToCaption=ssToCaption) then Result:=True;


          end;
      end;
     if (not(Result)) and
        (((l^.dwFromNodeNumber and BPGlobalNodeOperation)<>0) or
        ((l^.dwToNodeNumber and BPGlobalNodeOperation)<>0)) then
        begin
          FbpOperationLinks[FbpOpLinksCount]:=l;
          inc(FbpOpLinksCount);
        end;
   end;

 procedure  TBPGraph.CreateGraphLinks(wc,hc:Double); { Checked }
 Var linkP:PBPLink;
     linkG:PGraphLink;
     curLinkG:PGraphLink;
     i:Integer;
     tmp:TBPLinkTypes;
     tnnd,fnnd:Boolean;
     linkVisible:Boolean;
     tnip,fnip:Boolean;
     lc:ShortString;
     nc:DWORD;
     flags:DWORD;
     gtop,gbottom:Boolean;
     flc,tlc:String;
     hfc,htc:String;
     ffc,ftc:String;
     addonFlagsF,addonFlagsT:DWORD;
     e:String;
  begin
   if (FGraphLinks<>nil) then ClearGraphLinks;
   if (FLinks=nil) then Exit;
   linkP:=FLinks;
   curLinkG:=nil;
   ClearArrayOpLinks;
   for i:=0 to (FLinksCount-1) do
    begin
      tmp:=GetLTFromIndex(linkP^.dwLinkIndex);
      gtop:=((linkp^.dwFromNodeNumber and BPGlobalTopNodeNumber)<>0) or
            ((linkp^.dwToNodeNumber and BPGlobalTopNodeNumber)<>0);
      gbottom:=((linkp^.dwFromNodeNumber and BPGlobalBottomNodeNumber)<>0) or
            ((linkp^.dwToNodeNumber and BPGlobalBottomNodeNumber)<>0);
      fnnd:=((linkp^.dwFromNodeNumber and BPGlobalNodeOperation)<>0);
      tnnd:=((linkp^.dwToNodeNumber and BPGlobalNodeOperation)<>0);
      fnip:=((linkp^.dwFromNodeNumber and BPGlobalNodeInProcess)<>0);
      tnip:=((linkp^.dwToNodeNumber and BPGlobalNodeInProcess)<>0);
      linkVisible:=((fnnd or tnnd) and FShowDataWare) or
         ((not(fnnd or tnnd)));
      linkVisible:=linkVisible and tmp.dbShowLinkType;
      linkVisible:=LinkVisible and (not(CompareArrayOpLinks(linkP)));
      case FTranslateNodesType of
       0: begin end;
       1: linkVisible:=linkVIsible and (not(gbottom));
       2: linkVisible:=linkVIsible and (not(gTop));
      end;
{      if CompareArrayOpLinks(linkP) then Application.MessageBox('OPS','Bug',MB_OK);}
{      if  not(CompareArrayOpLinks(linkP)) then
      begin}
      flags:=0;
      addonFlagsF:=0;
      addonFlagsT:=0;
      lc:='';
      nc:=0;
      if fnip then
         begin
          if ((linkP^.dwFlags and BP_FROMTOMASK)=BP_RIGHT_LEFT) then
           flags:=BP_IPNODE_LEFT
          else
          if ((linkP^.dwFlags and BP_FROMMASK)=BP_FROMNODE_BOTTOM) then
           flags:=BP_IPNODE_TOP
          else
           flags:=BP_IPNODE_BOTTOM;
          nc:=linkP^.dwFromNodeNumber and BPNotGlobalMask;
         end
      else if tnip then
       begin
         if ((linkP^.dwFlags and BP_TOMASK)=BP_TONODE_LEFT) then
          flags:=BP_IPNODE_RIGHT
         else
         if ((linkP^.dwFlags and BP_TOMASK)=BP_TONODE_BOTTOM) then
           flags:=BP_IPNODE_BOTTOM
          else
           flags:=BP_IPNODE_TOP;
         nc:=linkP^.dwToNodeNumber and BPNotGlobalMask;
        end
      else flags:=0;
      lc:=GetLinkCaption(nc,flags);
      if (fnip and (length(lc)>0)) then
       begin
        e:=linkP^.ssFromCaption;
        ffc:=e;
        if length(e)>0 then e:=': '+e;
        flc:=MyUtils.MyReplaceLabelCaption(lc+e,FMaxLabelLength,FReplaceLabels);
        hfc:=lc+e;
        addonFlagsF:=BP_SHOW_FROMCAPTION;
       end
      else
       begin
        ffc:=linkP^.ssFromCaption;
        flc:=MyUtils.MyReplaceLabelCaption(linkP^.ssFromCaption,FMaxLabelLength,FReplaceLabels);
        hfc:=linkP^.ssFromCaption;
        addonFlagsF:=0;
       end;
      if (tnip and (length(lc)>0)) then
       begin
        e:=linkP^.ssToCaption;
        ftc:=e;
        if length(e)>0 then e:=e+': ';
        tlc:=MyUtils.MyReplaceLabelCaption(e+lc,FMaxLabelLength,FReplaceLabels);
        htc:=e+lc;
        addonFlagsT:=BP_SHOW_TOCAPTION;
       end
      else
       begin
        tlc:=MyUtils.MyReplaceLabelCaption(linkP^.ssToCaption,FMaxLabelLength,FReplaceLabels);
        htc:=linkP^.ssToCaption;
        ftc:=linkP^.ssToCaption;
        addonFlagsT:=0;
       end;
      if (curLinkG=nil) then
          begin
            curLinkG:=PGraphLink(AllocMem(sizeof(TGraphLink)));
            curLinkG^.llLink:=linkP;
            if ((((linkP^.dwFlags and BP_SHOW_FROMCAPTION)<>0) or (addonFlagsF<>0)) and linkVisible) then
            begin
//            showmessage('from:'+linkP^.ssFromCaption);
            if (FTRuncLRGlobalCaptions and ((linkP^.dwFromNodeNumber and BPGlobalMask)<>0))or
               (FTRuncLRLocalCaptions and ((linkP^.dwFromNodeNumber and BPGlobalMask)=0)and((linkP^.dwtoNodeNumber and BPGlobalMask)<>0))
{            if (((linkP^.dwToNodeNumber and BPGlobalRightNodeNumber)<>0) and
               ((linkP^.dwFlags and BP_TONODE_LEFT)<>0) and
               (FTruncLRGlobalCaptions) and (not(FTruncDirection)))
               or
               (((linkP^.dwFromNodeNumber and BPGlobalLeftNodeNumber)<>0) and
               ((linkP^.dwFlags and BP_FROMNODE_RIGHT)<>0) and
               (FTruncLRGlobalCaptions) and (FTruncDirection))
               or
               (((linkP^.dwFromNodeNumber and BPGlobalTopNodeNumber)<>0) and
               ((linkP^.dwFlags and BP_FROMNODE_BOTTOM)<>0) and
               (FTruncLRGlobalCaptions) and (FTruncDirection))
               or
               (((linkP^.dwFromNodeNumber and BPGlobalBottomNodeNumber)<>0) and
               ((linkP^.dwFlags and BP_FROMNODE_TOP)<>0) and
               (FTruncLRGlobalCaptions) and (FTruncDirection))
               or
               (((linkP^.dwToNodeNumber and BPGlobalBottomNodeNumber)<>0) and
               ((linkP^.dwFlags and BP_TONODE_TOP)<>0) and
               (FTruncLRGlobalCaptions) and (not(FTruncDirection)))}
               then
                begin
                 curLinkG^.BPFromLabel:=nil;
                end
            else
            begin
            curLinkG^.BPFromLabel:=TBPLabel.Create(Parent);
            curLinkG^.BPFromLabel.Parent:=Parent as TWinControl;
            curLinkG^.BPFromLabel.Caption:=flc;
            curLinkG^.BPFromLabel.FullCaption:=ffc;
            curLinkG^.BPFromLabel.ParentFont:=False;

            curLinkG^.BPFromLabel.Hint:=hfc;
            curLinkG^.BPFromLabel.ShowHint:=True;
            curLinkG^.BPFromLabel.Path:=linkP^.ssFromPath;
//
//            if (curlinkG.dwFlags and BP_FROMNODE_LEFT<>0)or(curlinkG.dwFlags and BP_FROMNODE_RIGHT<>0) then
            curLinkG^.BPFromLabel.Font.Name:=FPrinterFontName;
            if (fnnd or tnnd) then
            begin
             if FDoOverrideFS and FOverrideDNodesFS then
             if FOwner.FPreviewOrPrint then
              curLinkG^.BPFromLabel.Font.Size:=Round(FDNodesFontSize*FOwner.FFOntCoof)
             else
              curLinkG^.BPFromLabel.Font.Size:=Round(FDNodesFontSize*FScaled2Ratio/100)
             else
              curLinkG^.BPFromLabel.Font.Size:=FIOFontSize
            end
            else
            begin
             if FDoOverrideFS and FOverrideLabelsFS then
             if FOwner.FPreviewOrPrint then
              curLinkG^.BPFromLabel.Font.Size:=Round(FLabelsFontSize*FOwner.FFOntCoof)
             else
              curLinkG^.BPFromLabel.Font.Size:=Round(FLabelsFontSize*FScaled2Ratio/100)
             else
              curLinkG^.BPFromLabel.Font.Size:=FLabelFontSize;
            end;
            curLinkG^.BPFromLabel.Font.Color:=tmp.dwColor;
            curLinkG^.BPFromLabel.Font.Charset:=FLang;
            curLinkG^.BPFromLabel.SetFontDPI(FFontDPI);
            curLinkG^.BPFromLabel.Transparent:=True;
            curLinkG^.BPFromLabel.AutoSize:=True;
            curLinkG^.BPFromLabel.Color:=clWhite;
            curLinkG^.BPFromLabel.WordWrap:=False;
            curLinkG^.BPFromLabel.AcceptPosition:=False;
            curLinkG^.BPFromLabel.Top:=Round(linkP^.FromTop[0]*hc);
            curLinkG^.BPFromLabel.Left:=Round(linkP^.FromLeft[0]*wc);
            curLinkG^.BPFromLabel.AcceptPosition:=linkP^.FromAcceptPosition[0];
            curLinkG^.BPFromLabel.DragMode:=dmManual;
            curLinkG^.BPFromLabel.Cursor:=crHandPoint;
            curLinkG^.BPFromLabel.OnMouseDown:=MyLabelMouseDown;
            curLinkG^.BPFromLabel.PopupMenu:=BPViewMainForm.LinksPopupMenu;
            curLinkG^.BPFromLabel.SendToBack;
            end;
            end
             else
            curLinkG^.BPFromLabel:=nil;
            if ((((linkP^.dwFlags and BP_SHOW_TOCAPTION)<>0) or (addonFlagsT<>0)) and linkVisible) then
            begin
//                        showmessage('to:'+linkP^.ssToCaption);
            if (FTRuncLRGlobalCaptions and ((linkP^.dwToNodeNumber and BPGlobalMask)<>0))or
               (FTRuncLRLocalCaptions and ((linkP^.dwToNodeNumber and BPGlobalMask)=0))

{            if (((linkP^.dwFromNodeNumber and BPGlobalLeftNodeNumber)<>0) and
               ((linkP^.dwFlags and BP_FROMNODE_RIGHT)<>0) and
               (FTruncLRGlobalCaptions) and (not(FTruncDirection)))
               or
               (((linkP^.dwToNodeNumber and BPGlobalRightNodeNumber)<>0) and
               ((linkP^.dwFlags and BP_TONODE_LEFT)<>0) and
               (FTruncLRGlobalCaptions) and (FTruncDirection))
               or
               (((linkP^.dwFromNodeNumber and BPGlobalTopNodeNumber)<>0) and
               ((linkP^.dwFlags and BP_FROMNODE_BOTTOM)<>0) and
               (FTruncLRGlobalCaptions) and (FTruncDirection))
               or
               (((linkP^.dwToNodeNumber and BPGlobalBottomNodeNumber)<>0) and
               ((linkP^.dwFlags and BP_TONODE_TOP)<>0) and
               (FTruncLRGlobalCaptions) and (FTruncDirection))
               or
               (((linkP^.dwFromNodeNumber and BPGlobalBottomNodeNumber)<>0) and
               ((linkP^.dwFlags and BP_FROMNODE_TOP)<>0) and
               (FTruncLRGlobalCaptions) and (not(FTruncDirection)))}
               then
                begin
                 curLinkG^.BPToLabel:=nil;
                end
            else
            begin
            curLinkG^.BPToLabel:=TBPLabel.Create(Parent);
            curLinkG^.BPToLabel.Parent:=Parent as TWinControl;
            curLinkG^.BPToLabel.Caption:=tlc;
            curLinkG^.BPToLabel.FullCaption:=ftc;
            curLinkG^.BPToLabel.ParentFont:=False;
            curLinkG^.BPToLabel.Hint:=htc;
            curLinkG^.BPToLabel.ShowHint:=True;
            curLinkG^.BPToLabel.Path:=linkP^.ssToPath;
            curLinkG^.BPToLabel.Font.Name:=FPrinterFontName;
            if (fnnd or tnnd) then
            begin
             if FDoOverrideFS and FOverrideDNodesFS then
             if FOwner.FPreviewOrPrint then
              curLinkG^.BPToLabel.Font.Size:=Round(FDNodesFontSize*FOwner.FFOntCoof)
             else
              curLinkG^.BPToLabel.Font.Size:=Round(FDNodesFontSize*FScaled2Ratio/100)
             else
              curLinkG^.BPToLabel.Font.Size:=FIOFontSize
            end
            else
            begin
             if FDoOverrideFS and FOverrideLabelsFS then
             if FOwner.FPreviewOrPrint then
              curLinkG^.BPToLabel.Font.Size:=Round(FLabelsFontSize*FOwner.FFOntCoof)
             else
              curLinkG^.BPToLabel.Font.Size:=Round(FLabelsFontSize*FScaled2Ratio/100)
             else
              curLinkG^.BPToLabel.Font.Size:=FLabelFontSize;
            end;
            curLinkG^.BPToLabel.Font.Color:=tmp.dwColor;
            curLinkG^.BPToLabel.Font.Charset:=FLang;
            curLinkG^.BPToLabel.SetFontDPI(FFontDPI);
            curLinkG^.BPToLabel.Transparent:=True;
            curLinkG^.BPToLabel.AutoSize:=True;
            curLinkG^.BPToLabel.Color:=clWhite;
            curLinkG^.BPToLabel.WordWrap:=False;
            curLinkG^.BPToLabel.AcceptPosition:=False;
            curLinkG^.BPToLabel.Top:=Round(linkP^.ToTop[0]*hc);
            curLinkG^.BPToLabel.Left:=Round(linkP^.ToLeft[0]*wc);
            curLinkG^.BPToLabel.AcceptPosition:=linkP^.ToAcceptPosition[0];
            curLinkG^.BPToLabel.DragMode:=dmManual;
            curLinkG^.BPToLabel.Cursor:=crHandPoint;
            curLinkG^.BPToLabel.OnMouseDown:=MyLabelMouseDown;
            curLinkG^.BPToLabel.PopupMenu:=BPViewMainForm.LinksPopupMenu;
            curLinkG^.BPToLabel.SendToBack;
            end;
            end
             else
            curLinkG^.BPToLabel:=nil;
            if ((((((linkP^.dwFlags and BP_SHOW_GLOBALCAPTION)<>0) and
               ((FSSLevel<>'0') and (FSSLevel<>'-1'))) or
               (((linkP^.dwFlags and BP_SHOW_GLOBALCAPTION)<>0) and
               ((FSSLevel='0') or (FSSLevel='-1')) and (FEnableA0Numeration)))) and linkVisible) or
               ((flags<>0) and LinkVisible) then
            begin
            curLinkG^.BPGlobalLabel:=TBPLabel.Create(Parent);
            curLinkG^.BPGlobalLabel.Parent:=Parent as TWinControl;
            if (flags<>0) then
             begin
               if ((flags and BP_IPNODE_RIGHT)=BP_IPNODE_RIGHT) then
                 begin
                  curLinkG^.BPGlobalLabel.Caption:=ExternOut;
                  curLinkG^.BPGlobalLabel.FullCaption:=ExternOut;
                  curLinkG^.BPGlobalLabel.Hint:=ExternOut;
                 end
                 else
                if ((flags and BP_IPNODE_TOP)=BP_IPNODE_TOP) then
                 begin
                  CurLinkG^.BPGlobalLabel.Caption:=ExternControl;
                  CurLinkG^.BPGlobalLabel.Hint:=ExternControl;
                  CurLinkG^.BPGlobalLabel.FullCaption:=ExternControl;
                 end
                else
                 if ((flags and BP_IPNODE_BOTTOM)=BP_IPNODE_BOTTOM) then
                 begin
                  CurLinkG^.BPGlobalLabel.Caption:=ExternMech;
                  CurLinkG^.BPGlobalLabel.Hint:=ExternMech;
                  CurLinkG^.BPGlobalLabel.FullCaption:=ExternMech;
                 end
                else
                 begin
                  curLinkG^.BPGlobalLabel.Caption:=ExternIn;
                  curLinkG^.BPGlobalLabel.FullCaption:=ExternIn;
                  curLinkG^.BPGlobalLabel.Hint:=ExternIn;
                 end;
             end
            else
             begin
              curLinkG^.BPGlobalLabel.Caption:=linkP^.ssGlobalCaption;
              curLinkG^.BPGlobalLabel.Hint:=linkP^.ssGlobalCaption;
              curLinkG^.BPGlobalLabel.FullCaption:=linkP^.ssGlobalCaption;
             end;
            curLinkG^.BPGlobalLabel.ParentFont:=False;
            curLinkG^.BPGlobalLabel.ShowHint:=True;
            curLinkG^.BPGlobalLabel.Font.Name:=FPrinterFontName;
            if FDoOverrideFS and FOverrideLabelsFS then
             if FOwner.FPreviewOrPrint then
              curLinkG^.BPGlobalLabel.Font.Size:=Round(FLabelsFontSize*FOwner.FFOntCoof)
             else
              curLinkG^.BPGlobalLabel.Font.Size:=Round(FLabelsFontSize*FScaled2Ratio/100)
            else
            curLinkG^.BPGlobalLabel.Font.Size:=FFontSize;
            curLinkG^.BPGlobalLabel.Font.Style:=[fsBold];
            curLinkG^.BPGlobalLabel.Font.Color:=tmp.dwColor;
            curLinkG^.BPGlobalLabel.Font.Charset:=FLang;
            curLinkG^.BPGlobalLabel.SetFontDPI(FFontDPI);
            curLinkG^.BPGlobalLabel.Transparent:=True;
            curLinkG^.BPGlobalLabel.AutoSize:=True;
            curLinkG^.BPGlobalLabel.Color:=clWhite;
            curLinkG^.BPGlobalLabel.WordWrap:=False;
            curLinkG^.BPGlobalLabel.AcceptPosition:=False;
            curLinkG^.BPGlobalLabel.Top:=0;
            curLinkG^.BPGlobalLabel.Left:=0;
            curLinkG^.BPGlobalLabel.DragMode:=dmManual;
            end
             else
            curLinkG^.BPGlobalLabel:=nil;
            curLinkG^.FromNodeNumber:=linkP^.dwFromNodeNumber;
            curLinkG^.ToNodeNumber:=linkP^.dwToNodeNumber;
            if (flags<>0) then
            curLinkG^.dwFlags:=linkP^.dwFlags or BP_SHOW_GLOBALCAPTION or addonFlagsF or addonFlagsT
            else
            curLinkG^.dwFlags:=linkP^.dwFlags or addonFlagsF or addonFlagsT;
            curLinkG^.FromLinkNumber:=linkP^.dwFromLinkNumber;
            curLinkG^.ToLinkNumber:=linkP^.dwToLinkNumber;
            curLinkG^.StartPoint.x:=0;
            curLinkG^.StartPoint.y:=0;
            curLinkG^.EndPoint.x:=0;
            curLinkG^.EndPoint.y:=0;
            curLinkG^.LinkFromCount:=0;
            curLinkG^.LinkToCount:=0;
            curLinkG^.LinkFromUpCount:=0;
            curLinkG^.LinkFromDownCount:=0;
            curLinkG^.LinkToUpCount:=0;
            curLinkG^.LinkToDownCount:=0;
            curLinkG^.MinimalXFrom:=0;
            curLinkG^.MinimalXTo:=0;
            curLinkG^.MinimalYFrom:=0;
            curLinkG^.MinimalYTo:=0;
            FillChar(curLinkG^.LineArrayX,sizeof(curLinkG^.LineArrayX),0);
            FillChar(curLinkG^.LineArrayY,sizeof(curLinkG^.LineArrayY),0);
            curLinkG^.LinePointCount:=0;
            curLinkG^.CorrectLink:=True;
            curLinkG^.LineSelected:=False;
            curLinkG^.Color:=tmp.dwColor;
            curLinkG^.PenStyle:=tmp.dwPenStyle;
            curLinkG^.Visible:=linkVisible;
            curLinkG^.Tag:=i;
            curLinkG^.next:=nil;
            FGraphLinks:=curLinkG;
          end
       else
          begin
            linkG:=PGraphLink(AllocMem(sizeof(TGraphLink)));
            linkG^.llLink:=linkP;
            if ((((linkP^.dwFlags and BP_SHOW_FROMCAPTION)<>0) or (addonFlagsF<>0)) and linkVisible) then
            begin
//            showmessage('from:'+linkP^.ssFromCaption);
            if (FTRuncLRGlobalCaptions and ((linkP^.dwFromNodeNumber and BPGlobalMask)<>0))or
               (FTRuncLRLocalCaptions and ((linkP^.dwFromNodeNumber and BPGlobalMask)=0)and((linkP^.dwtoNodeNumber and BPGlobalMask)<>0))
{
             if (((linkP^.dwToNodeNumber and BPGlobalRightNodeNumber)<>0) and
               ((linkP^.dwFlags and BP_TONODE_LEFT)<>0) and
               (FTruncLRGlobalCaptions) and (not(FTruncDirection)))
               or
               (((linkP^.dwFromNodeNumber and BPGlobalLeftNodeNumber)<>0) and
               ((linkP^.dwFlags and BP_FROMNODE_RIGHT)<>0) and
               (FTruncLRGlobalCaptions) and (FTruncDirection))
               or
               (((linkP^.dwFromNodeNumber and BPGlobalTopNodeNumber)<>0) and
               ((linkP^.dwFlags and BP_FROMNODE_BOTTOM)<>0) and
               (FTruncLRGlobalCaptions) and (FTruncDirection))
               or
               (((linkP^.dwFromNodeNumber and BPGlobalBottomNodeNumber)<>0) and
               ((linkP^.dwFlags and BP_FROMNODE_TOP)<>0) and
               (FTruncLRGlobalCaptions) and (FTruncDirection))
               or
               (((linkP^.dwToNodeNumber and BPGlobalBottomNodeNumber)<>0) and
               ((linkP^.dwFlags and BP_TONODE_TOP)<>0) and
               (FTruncLRGlobalCaptions) and (not(FTruncDirection)))}
               then
                begin
                 LinkG^.BPFromLabel:=nil;
                end
            else
            begin
            LinkG^.BPFromLabel:=TBPLabel.Create(Parent);
            LinkG^.BPFromLabel.Parent:=Parent as TWinControl;
            LinkG^.BPFromLabel.Caption:=flc;
            LinkG^.BPFromLabel.FullCaption:=ffc;
            LinkG^.BPFromLabel.ParentFont:=False;
            LinkG^.BPFromLabel.Hint:=hfc;
            LinkG^.BPFromLabel.ShowHint:=True;
            LinkG^.BPFromLabel.Path:=linkP^.ssFromPath;
            LinkG^.BPFromLabel.Font.Name:=FPrinterFontName;
            if (fnnd or tnnd) then
            begin
             if FDoOverrideFS and FOverrideDNodesFS then
             if FOwner.FPreviewOrPrint then
              LinkG^.BPFromLabel.Font.Size:=Round(FDNodesFontSize*FOwner.FFOntCoof)
             else
              LinkG^.BPFromLabel.Font.Size:=Round(FDNodesFontSize*FScaled2Ratio/100)
             else
              LinkG^.BPFromLabel.Font.Size:=FIOFontSize
            end
            else
            begin
             if FDoOverrideFS and FOverrideLabelsFS then
             if FOwner.FPreviewOrPrint then
              LinkG^.BPFromLabel.Font.Size:=Round(FLabelsFontSize*FOwner.FFOntCoof)
             else
              LinkG^.BPFromLabel.Font.Size:=Round(FLabelsFontSize*FScaled2Ratio/100)
             else
              LinkG^.BPFromLabel.Font.Size:=FLabelFontSize;
            end;
            LinkG^.BPFromLabel.Font.Color:=tmp.dwColor;
            LinkG^.BPFromLabel.Font.Charset:=FLang;
            LinkG^.BPFromLabel.SetFontDPI(FFontDPI);
            LinkG^.BPFromLabel.Transparent:=True;
            LinkG^.BPFromLabel.AutoSize:=True;
            LinkG^.BPFromLabel.Color:=clWhite;
            LinkG^.BPFromLabel.WordWrap:=False;
            LinkG^.BPFromLabel.AcceptPosition:=False;
            LinkG^.BPFromLabel.Top:=Round(linkP^.FromTop[0]*hc);
            LinkG^.BPFromLabel.Left:=Round(linkP^.FromLeft[0]*wc);
            LinkG^.BPFromLabel.AcceptPosition:=linkP^.FromAcceptPosition[0];
            LinkG^.BPFromLabel.DragMode:=dmManual;
            LinkG^.BPFromLabel.Cursor:=crHandPoint;
            LinkG^.BPFromLabel.OnMouseDown:=MyLabelMouseDown;
            LinkG^.BPFromLabel.PopupMenu:=BPViewMainForm.LinksPopupMenu;
            LinkG^.BPFromLabel.SendToBack;
            end;
            end
             else
            LinkG^.BPFromLabel:=nil;
            if ((((linkP^.dwFlags and BP_SHOW_TOCAPTION)<>0) or (addonFlagsT<>0)) and LinkVisible) then
            begin
//            showmessage('to:'+linkP^.ssToCaption);
            if (FTRuncLRGlobalCaptions and ((linkP^.dwtoNodeNumber and BPGlobalMask)<>0))or
               (FTRuncLRLocalCaptions and ((linkP^.dwtoNodeNumber and BPGlobalMask)=0))

{            if (((linkP^.dwFromNodeNumber and BPGlobalLeftNodeNumber)<>0) and
               ((linkP^.dwFlags and BP_FROMNODE_RIGHT)<>0) and
               (FTruncLRGlobalCaptions) and (not(FTruncDirection)))
               or
               (((linkP^.dwToNodeNumber and BPGlobalRightNodeNumber)<>0) and
               ((linkP^.dwFlags and BP_TONODE_LEFT)<>0) and
               (FTruncLRGlobalCaptions) and (FTruncDirection))
               or
               (((linkP^.dwFromNodeNumber and BPGlobalTopNodeNumber)<>0) and
               ((linkP^.dwFlags and BP_FROMNODE_BOTTOM)<>0) and
               (FTruncLRGlobalCaptions) and (FTruncDirection))
               or
               (((linkP^.dwToNodeNumber and BPGlobalBottomNodeNumber)<>0) and
               ((linkP^.dwFlags and BP_TONODE_TOP)<>0) and
               (FTruncLRGlobalCaptions) and (FTruncDirection))
               or
               (((linkP^.dwFromNodeNumber and BPGlobalBottomNodeNumber)<>0) and
               ((linkP^.dwFlags and BP_FROMNODE_TOP)<>0) and
               (FTruncLRGlobalCaptions) and (not(FTruncDirection)))}
               then
                begin
                 LinkG^.BPToLabel:=nil;
                end
            else
            begin
            LinkG^.BPToLabel:=TBPLabel.Create(Parent);
            LinkG^.BPToLabel.Parent:=Parent as TWinControl;
            LinkG^.BPToLabel.Caption:=tlc;
            LinkG^.BPToLabel.FullCaption:=ftc;
            LinkG^.BPToLabel.ParentFont:=False;
            LinkG^.BPToLabel.Hint:=htc;
            LinkG^.BPToLabel.ShowHint:=True;
            LinkG^.BPToLabel.Path:=linkP^.ssToPath;
            LinkG^.BPToLabel.Font.Name:=FPrinterFontName;
            LinkG^.BPToLabel.Font.Charset:=FLang;
            if (fnnd or tnnd) then
            begin
             if FDoOverrideFS and FOverrideDNodesFS then
             if FOwner.FPreviewOrPrint then
              LinkG^.BPToLabel.Font.Size:=Round(FDNodesFontSize*FOwner.FFOntCoof)
             else
              LinkG^.BPToLabel.Font.Size:=Round(FDNodesFontSize*FScaled2Ratio/100)
             else
              LinkG^.BPToLabel.Font.Size:=FIOFontSize
            end
            else
            begin
             if FDoOverrideFS and FOverrideLabelsFS then
             if FOwner.FPreviewOrPrint then
              LinkG^.BPToLabel.Font.Size:=Round(FLabelsFontSize*FOwner.FFOntCoof)
             else
              LinkG^.BPToLabel.Font.Size:=Round(FLabelsFontSize*FScaled2Ratio/100)
             else
              LinkG^.BPToLabel.Font.Size:=FLabelFontSize;
            end;
            LinkG^.BPToLabel.Font.Color:=tmp.dwColor;
            LinkG^.BPToLabel.SetFontDPI(FFontDPI);
            LinkG^.BPToLabel.Transparent:=True;
            LinkG^.BPToLabel.AutoSize:=True;
            LinkG^.BPToLabel.Color:=clWhite;
            LinkG^.BPToLabel.WordWrap:=False;
            LinkG^.BPToLabel.AcceptPosition:=False;
            LinkG^.BPToLabel.Top:=Round(linkP^.ToTop[0]*hc);
            LinkG^.BPToLabel.Left:=Round(linkP^.ToLeft[0]*wc);
            LinkG^.BPToLabel.AcceptPosition:=linkP^.ToAcceptPosition[0];
            LinkG^.BPToLabel.DragMode:=dmManual;
            LinkG^.BPToLabel.Cursor:=crHandPoint;
            LinkG^.BPToLabel.OnMouseDown:=MyLabelMouseDown;
            LinkG^.BPToLabel.PopupMenu:=BPViewMainForm.LinksPopupMenu;
            LinkG^.BPToLabel.SendToBack;
            end;
            end
             else
            LinkG^.BPToLabel:=nil;
            if ((((((linkP^.dwFlags and BP_SHOW_GLOBALCAPTION)<>0) and
                ((FSSLevel<>'0') and (FSSLevel<>'-1')))  or
               (((linkP^.dwFlags and BP_SHOW_GLOBALCAPTION)<>0) and
                ((FSSLevel='0') or (FSSLevel='-1')) and FEnableA0Numeration))) and linkVisible) or
                ((flags<>0) and linkVisible) then
            begin
            LinkG^.BPGlobalLabel:=TBPLabel.Create(Parent);
            LinkG^.BPGlobalLabel.Parent:=Parent as TWinControl;
            if (flags<>0) then
             begin
               if ((flags and BP_IPNODE_RIGHT)=BP_IPNODE_RIGHT) then
                 begin
                  LinkG^.BPGlobalLabel.Caption:=ExternOut;
                  LinkG^.BPGlobalLabel.Hint:=ExternOut;
                  LinkG^.BPGlobalLabel.FullCaption:=ExternOut;
                 end
                else
                if ((flags and BP_IPNODE_TOP)=BP_IPNODE_TOP) then
                 begin
                  LinkG^.BPGlobalLabel.Caption:=ExternControl;
                  LinkG^.BPGlobalLabel.Hint:=ExternControl;
                  LinkG^.BPGlobalLabel.FullCaption:=ExternControl;
                 end
                else
                 if ((flags and BP_IPNODE_BOTTOM)=BP_IPNODE_BOTTOM) then
                 begin
                  LinkG^.BPGlobalLabel.Caption:=ExternMech;
                  LinkG^.BPGlobalLabel.Hint:=ExternMech;
                  LinkG^.BPGlobalLabel.FullCaption:=ExternMech;
                 end
                else
                 begin
                  LinkG^.BPGlobalLabel.Caption:=ExternIn;
                  LinkG^.BPGlobalLabel.Hint:=ExternIn;
                  LinkG^.BPGlobalLabel.FullCaption:=ExternIn;
                 end;
             end
            else
             begin
              LinkG^.BPGlobalLabel.Caption:=linkP^.ssGlobalCaption;
              LinkG^.BPGlobalLabel.Hint:=linkP^.ssGlobalCaption;
              LinkG^.BPGlobalLabel.FullCaption:=linkP^.ssGlobalCaption;
             end;
            LinkG^.BPGlobalLabel.ParentFont:=False;
            LinkG^.BPGlobalLabel.ShowHint:=True;
            LinkG^.BPGlobalLabel.Font.Name:=FPrinterFontName;
            LinkG^.BPGlobalLabel.Font.Charset:=FLang;
            if FDoOverrideFS and FOverrideLabelsFS then
             if FOwner.FPreviewOrPrint then
              LinkG^.BPGlobalLabel.Font.Size:=Round(FLabelsFontSize*FOwner.FFOntCoof)
             else
              LinkG^.BPGlobalLabel.Font.Size:=Round(FLabelsFontSize*FScaled2Ratio/100)
            else
            LinkG^.BPGlobalLabel.Font.Size:=FFontSize;
            LinkG^.BPGlobalLabel.Font.Style:=[fsBold];
            LinkG^.BPGlobalLabel.Font.Color:=tmp.dwColor;
            LinkG^.BPGlobalLabel.SetFontDPI(FFontDPI);
            LinkG^.BPGlobalLabel.Transparent:=True;
            LinkG^.BPGlobalLabel.AutoSize:=True;
            LinkG^.BPGlobalLabel.Color:=clWhite;
            LinkG^.BPGlobalLabel.WordWrap:=False;
            LinkG^.BPGlobalLabel.AcceptPosition:=False;
            LinkG^.BPGlobalLabel.Top:=0;
            LinkG^.BPGlobalLabel.Left:=0;
            LinkG^.BPGlobalLabel.DragMode:=dmManual;
            end
             else
            LinkG^.BPGlobalLabel:=nil;
            linkG^.FromNodeNumber:=linkP^.dwFromNodeNumber;
            linkG^.ToNodeNumber:=linkP^.dwToNodeNumber;
            if (flags<>0) then
            LinkG^.dwFlags:=linkP^.dwFlags or BP_SHOW_GLOBALCAPTION or addonFlagsF or addonFlagsT
            else
            LinkG^.dwFlags:=linkP^.dwFlags or addonFlagsF or addonFlagsT;
            LinkG^.FromLinkNumber:=linkP^.dwFromLinkNumber;
            LinkG^.ToLinkNumber:=linkP^.dwToLinkNumber;
            linkG^.StartPoint.x:=0;
            linkG^.StartPoint.y:=0;
            linkG^.EndPoint.x:=0;
            linkG^.EndPoint.y:=0;
            linkG^.LinkFromCount:=0;
            linkG^.LinkToCount:=0;
            linkG^.LinkFromUpCount:=0;
            linkG^.LinkFromDownCount:=0;
            linkG^.LinkToUpCount:=0;
            linkG^.LinkToDownCount:=0;
            linkG^.MinimalXFrom:=0;
            linkG^.MinimalXTo:=0;
            linkG^.MinimalYFrom:=0;
            linkG^.MinimalYTo:=0;
            FillChar(linkG^.LineArrayX,sizeof(linkG^.LineArrayX),0);
            FillChar(linkG^.LineArrayY,sizeof(linkG^.LineArrayY),0);
            linkG^.LinePointCount:=0;
            LinkG^.CorrectLink:=True;
            LinkG^.LineSelected:=False;
            LinkG^.Color:=tmp.dwColor;
            LinkG^.PenStyle:=tmp.dwPenStyle;
            LinkG^.Visible:=linkVisible;
            LinkG^.Tag:=i;
            linkG^.next:=nil;
            curLinkG^.next:=linkG;
            curLinkG:=linkG;
          end;
  {      end;} { CompareArrayOpLinks }
       Inc(linkP);
    end;
{    ClearArrayOpLinks;}
  end;

 function   TBPGraph.GetLinkFrom(const value:PGraphLink):TLinkType; { Checked }
  begin
    Result:=lt_Right;
    if value=nil then Exit;
    case (value^.dwFlags and BP_FROMMASK) of
     BP_FROMNODE_LEFT:   Result:=lt_Left;
     BP_FROMNODE_RIGHT:  Result:=lt_Right;
     BP_FROMNODE_TOP:    Result:=lt_Top;
     BP_FROMNODE_BOTTOM: Result:=lt_Bottom;
    end;
  end;

 function   TBPGraph.GetLinkTo(const value:PGraphLink):TLinkType; { Checked }
  begin
   Result:=lt_Left;
    case (value^.dwFlags and BP_TOMASK) of
     BP_TONODE_LEFT:   Result:=lt_Left;
     BP_TONODE_RIGHT:  Result:=lt_Right;
     BP_TONODE_TOP:    Result:=lt_Top;
     BP_TONODE_BOTTOM: Result:=lt_Bottom;
    end;
  end;

 function   TBPGraph.GetNodeFromCaption(sCaption:ShortString):TBPGraphNode; { Checked }
 Var tmpN:PGraphNode;
  begin
   Result:=nil;
   if FGraphNodes=nil then Exit;
   tmpN:=FGraphNodes;
   while ((tmpN<>nil) and (tmpN^.BPNode.Caption<>sCaption)) do
    begin
      tmpN:=tmpN^.Next;
    end;
   if tmpN<>nil then Result:=tmpN^.BPNode;
  end;

 function   TBPGraph.GetDGraphNode(index:DWORD):TBPDGraphNode; { Checked }
 Var tmpN:PDGraphNode;
     i:DWORD;
  begin
   Result:=nil;
   if FDGraphNodes=nil then Exit;
   if (index>=FDNodesCount) then Exit;
   tmpN:=FDGraphNodes;
   for i:=0 to index do
    begin
      Result:=tmpN^.BPDNode;
      tmpN:=tmpN^.Next;
    end;
  end;


 function   TBPGraph.GetGraphNode(index:DWORD):TBPGraphNode; { Checked }
 Var tmpN:PGraphNode;
     i:DWORD;
  begin
   Result:=nil;
   if FGraphNodes=nil then Exit;
   if (index>=FNodesCount) then Exit;
   tmpN:=FGraphNodes;
   for i:=0 to index do
    begin
      Result:=tmpN^.BPNode;
      tmpN:=tmpN^.Next;
    end;
  end;

 function   TBPGraph.GetDGraphNumberedNode(NodeNumber:DWORD):TBPDGraphNode;
 Var tmpN:PDGraphNode;
  begin
   Result:=nil;
   if FDGraphNodes=nil then Exit;
   tmpN:=FDGraphNodes;
   while ((tmpN<>nil) and (tmpN^.BPDNode.NodeNumber<>NodeNumber)) do
    begin
      tmpN:=tmpN^.Next;
    end;
   if tmpN<>nil then Result:=tmpN^.BPDNode;
  end;


 function   TBPGraph.GetGraphNumberedNode(NodeNumber:DWORD):TBPGraphNode; { Checked }
 Var tmpN:PGraphNode;
  begin
   Result:=nil;
   if FGraphNodes=nil then Exit;
   tmpN:=FGraphNodes;
   while ((tmpN<>nil) and (tmpN^.BPNode.NodeNumber<>NodeNumber)) do
    begin
      tmpN:=tmpN^.Next;
    end;
   if tmpN<>nil then Result:=tmpN^.BPNode;
  end;

  function   TBPGraph.GetGraphLink(index:DWORD):PGraphLink; { Checked }
   Var tmpN:PGraphLink;
     i:DWORD;
  begin
   Result:=nil;
   if FGraphLinks=nil then Exit;
   if (index>=FLinksCount) then Exit;
   tmpN:=FGraphLinks;
   for i:=0 to index do
    begin
      Result:=tmpN;
      if tmpN<>nil then tmpN:=tmpN^.Next;
    end;
  end;

 procedure  TBPGraph.TraceNodes; { Checked }
 Var i:DWORD;
     gnode:TBPGraphNode;
     gdnode:TBPDGraphNode;
     w1,h1:Integer;
     w2,h2,h3:Integer;
     m:Double;
     sw,sh:Integer;
     c:Integer;
     LabelsCount:Integer;
     sdh:Integer;
{Const  del=1.75;}
  begin
    if (FNodesCount=0) then Exit;
    { We get max node width & height for drawing text, but }
   if FShowDataWare then
    begin
     if FDNodesCount>0 then
      begin
       CalcDNodesMaxWidthHeight;
       LabelsCount:=GetMaxDNodeLinksCount+1;
       FOperationLabelsSize:={(}(LabelsCount*MinLabelY2){ div 2)+2*MinLabelY2};
      end
     else
       FOperationLabelsSize:=0;
     FGlobalOperationSize:=Round(1.4*(FDMaxHeight+FDPrjMaxHeight))+FOperationLabelsSize; //?
    end
   else
    begin
     FGlobalOperationSize:=0;
     FOperationLabelsSize:=0;
    end;
    m:=(10*FNodesCount*FNodesCount+13*FNodesCount+12)/(5*FNodesCount);
    w1:=Round(FMaxWidth*1.1);
    h1:=Round(FMaxHeight*1.1);
    w2:=Round(FDMaxWidth*1.1);
    h2:=Round(FDMaxHeight*1.1);
    h3:=Round(FDPrjMaxHeight*1.1);
    sdh:=0;
    if w1>h1 then h1:=Round(w1/NodeRatio) else
     w1:=Round(h1*NodeRatio);
    { Printing ! }
     if FPrinting then
     begin
      w1:=Round((FDefWidth - FGlobalLeftSize-FGlobalRightSize)/ m{(FNodesCount+2)/2});
      sw:=Round(((FDefWidth - FGlobalLeftSize-FGlobalRightSize)-(2*FNodesCount-1)*w1)/2);
      if FShowDataWare and (FDNodesCount>0) then w2:=Round(w1*1.5);
      if FShowDataWare then
      begin
       h1:=Round((FDefHeight - FGlobalTopSize-FGlobalBottomSize-FGlobalOperationSize)/ {(FNodesCount+2)/2}m);
       sh:=Round(((FDefHeight - FGlobalTopSize-FGlobalBottomSize-FGlobalOperationSize)-(2*FNodesCount-1)*h1)/2);
      end
      else
      begin
       h1:=Round((FDefHeight - FGlobalTopSize-FGlobalBottomSize)/{ (FNodesCount+2)/2}m);
       sh:=Round(((FDefHeight - FGlobalTopSize-FGlobalBottomSize)-(2*FNodesCount-1)*h1)/2);
      end;
     end
      else
     begin
      if FShowDataWare and (FDNodesCount>0) then w2:=Round(w1*1.5);
      FDefWidth:=Round({2*(FNodesCount+2)}m*w1+FGlobalLeftSize+FGlobalRightSize);
      sw:=Round(((m*w1)-(2*FNodesCount-1)*w1)/2);
      sh:=Round(((m*h1)-(2*FNodesCount-1)*h1)/2);
      if FShowDataWare then
        FDefHeight:=Round(m{2*(FNodesCount+2)}*h1+FGlobalTopSize+FGlobalBottomSize+FGlobalOperationSize)
      else
        FDefHeight:=Round(m{2*(FNodesCount+2)}*h1+FGlobalTopSize+FGlobalBottomSize);
     end;
      FAcceptDragRect.Left:=FGlobalLeftSize;
      FAcceptDragRect.Top:=FGlobalTopSize;
      if FSHowDataWare then
       FAcceptDragRect.Bottom:=FDefHeight{-FGlobalBottomSize-FGlobalOperationSize}
      else
      FAcceptDragRect.Bottom:=FDefHeight-FGlobalBottomSize;
      FAcceptDragRect.Right:=FDefWidth-FGlobalRightSize;
      if Parent.HorzScrollBar.Range<>FDefWidth then
       Parent.HorzScrollBar.Range:=FDefWidth;
      if Parent.VertScrollBar.Range<>FDefHeight then
       Parent.VertScrollBar.Range:=FDefHeight;
    FNodeWidth:=w1;
    FNodeHeight:=h1;
    FMinTopSize:=h1;    { Set to 1 rectangle }
    FMinBottomSize:=h1; { Set to 1 rectangle }
   { if w2<w1 then w2:=w1;}
    for i:=0 to (FNodesCount-1) do
     begin
       gnode:=GetGraphNode(i);
       if gnode=nil then Exit;
       gnode.DefWidth:=w1;
       gnode.DefHeight:=h1;
       if ((FDiscardDrags) or (not(gnode.AcceptPosition))) then
        begin
         gnode.Top:=FOwner.ClientRect.Top+FGlobalTopSize+sh+2*h1*i-Parent.VertScrollBar.Position;
         gnode.Left:=FOwner.ClientRect.Left+FGlobalLeftSize+sw+2*w1*i-Parent.HorzScrollBar.Position;
         gnode.AcceptPosition:=False;
        end;
       c:=gnode.Width;
       gnode.LeftLinksCount:=0;
       gnode.RightLinksCount:=0;
       gnode.TopLinksCount:=0;
       gnode.BottomLinksCount:=0;
       gnode.FromUpLinksCount:=0;
       gnode.FromDownLinksCount:=0;
       gnode.ToUpLinksCount:=0;
       gnode.ToDownLinksCount:=0;
     end;
   if FShowDataWare then
   begin
    if FShowDataWareLine and (FDNodesCount>0) then DrawDataWareLine;
    for i:=0 to (FDNodesCount-1) do
     begin
       gdnode:=GetDGraphNode(i);
       gnode:=GetGraphNumberedNode(gdnode.NodeNumber);
       if gdnode=nil then Exit;
       gdnode.DefWidth:=w2;
       gdnode.DefHeight:=h2;
       gdnode.DefPrjHeight:=h3;
       sdh:=-((gdnode.Width-gnode.Width) div 2);
{       sdh:=-Round((Abs(gnode.Width-gdnode.Width))/2);}
       gdnode.Top:=FOwner.ClientRect.Top+FDefHeight-Parent.VertScrollBar.Position
                   -FGlobalOperationSize+FOperationLabelsSize;
       gdnode.Left:=gnode.Left+sdh;
       gdnode.TopLinksCount:=0;
       gdnode.BottomLinksCount:=0;
     end;
   end;
   FGlobalLeftLinksCount:=0;
   FGlobalRightLinksCount:=0;
   FGlobalTopLinksCount:=0;
   FGlobalBottomLinksCount:=0;
   FMultipleTopLinksCOunt:=0;
   FMultipleBottomLinksCount:=0;
  end;


{ Hm ? }


function  TBPGraph.GetMultipleFirst(index:Integer;MultipleFrom:Boolean):PGraphLink; { Checked }
 Var linkP:PGraphLink;
     f:Boolean;
     linkT:PBPLink;
  begin
   Result:=nil;
   if FLinksCount=0 then Exit;
   linkT:=FLinks;
   inc(linkT,index);
   linkP:=FGraphLinks;
   f:=True;
   while (linkP<>nil) and (f) do
    begin
      if MultipleFrom then
         begin
           if (linkP^.ToNodeNumber=linkT^.dwToNodeNumber) and
              ((linkP^.dwFlags and BP_TOMASK)=(linkT^.dwFlags and BP_TOMASK)) and
              (linkP^.ToLinkNumber=linkT^.dwToLinkNumber) and
              (linkP^.Visible) then
              begin
                Result:=linkP;
                f:=False;
              end;
         end
        else
         begin
           if (linkP^.FromNodeNumber=linkT^.dwFromNodeNumber) and
              ((linkP^.dwFlags and BP_FROMMASK)=(linkT^.dwFlags and BP_FROMMASK)) and
              (linkP^.FromLinkNumber=linkT^.dwFromLinkNumber) and
              (linkP^.Visible) then
              begin
                Result:=linkP;
                f:=False;
              end;
         end;
      linkP:=linkP^.next;
    end;
  end;


 function   TBPGraph.MaxLinkDownCount(NodeNum:DWORD;FromTo:Boolean):Integer;
 Var linkP:PGraphLink;
  begin
   {}
   Result:=0;
   if (FLinksCount=0) then Exit;
   if (FGraphLinks=nil) then Exit;
   linkP:=FGraphLinks;
   while linkP<>nil do
    begin
      if FromTo then
        begin
          if (LinkP^.FromNodeNumber=NodeNum) then
           begin
            if LinkP^.LinkFromUpCount>Result then Result:=LinkP^.LinkFromUpCount;
            if LinkP^.LinkFromDownCount>Result then  Result:=LinkP^.LinkFromDownCount;
           end;
        end
      else
        begin
          if (LinkP^.ToNodeNumber=NodeNum) then
           begin
            if LinkP^.LinkToUpCount>Result then Result:=LinkP^.LinkToUpCount;
            if LinkP^.LinkToDownCount>Result then  Result:=LinkP^.LinkToDownCount;
           end;
        end;
      linkP:=linkP^.next;
    end;
  end;

 procedure  TBPGraph.CorrectLinksToNodeCountersUpDown;
 Var linkF,linkL:PGraphLink;
             i,j:Integer;
  begin
   {}
     if FLinksCount=0 then Exit;
     if FGraphLinks=nil then Exit;
     linkF:=FGraphLinks;
     for i:=0 to (FLinksCount-1) do
      begin
       if linkF^.Visible then
        begin
          LinkL:=FGraphLinks;
          for j:=0 to (FLinksCount-1) do
           begin
              if LinkL^.Visible and (i<>j) then
               begin
                 if ((LinkF^.ToNodeNumber and BPFrameGlobalMask)<>0) and
                    ((LinkL^.ToNodeNumber and BPFrameGlobalMask)<>0) and
                    (LinkF^.ToLinkNumber <> linkL^.ToNodeNumber) and
                    (LinkF^.FromNodeNumber=LinkL^.FromNodeNumber) and
                    (LinkF^.FromLinkNumber<>linkL^.FromLinkNumber) and
                    (LinkF^.LinkFromUpCount=linkL^.LinkFromDownCount) and
                    (LinkF^.LinkFromUpCount>0) and
                    (LinkL^.LinkFromDownCount>0) then
                      begin
                        linkL^.LinkFromDownCount:=MaxLinkDownCount(linkF^.FromNodeNumber,True)+1;
                      end;
                 if ((LinkF^.FromNodeNumber and BPFrameGlobalMask)<>0) and
                    ((LinkL^.FromNodeNumber and BPFrameGlobalMask)<>0) and
                    (LinkF^.FromLinkNumber <> linkL^.FromNodeNumber) and
                    (LinkF^.ToNodeNumber=LinkL^.ToNodeNumber) and
                    (LinkF^.ToLinkNumber<>linkL^.ToLinkNumber) and
                    (LinkF^.LinkToUpCount=linkL^.LinkToDownCount) and
                    (LinkF^.LinkToUpCount>0) and
                    (LinkL^.LinkToDownCount>0) then
                      begin
                        linkL^.LinkToDownCount:=MaxLinkDownCount(linkF^.ToNodeNumber,False)+1;
                      end;
               end;
              linkL:=linkL^.next;
           end;
        end;
       linkF:=linkF^.next;
      end;
  end;


 procedure  TBPGraph.TraceLinksToNodeCountersUpDown; { Checked }
 Var linkP:PGraphLink;
     gnode:TBPGraphNode;
         i,j:Integer;
     linkFromType,linkToType:TLinkType;
     linksFromUp,linksFromDown:Integer;
     linksToUp,linksToDown:Integer;
 begin
 { Trace counter for Up/Down vertical lines - there are diferent from other  }
   if (FLinksCount=0) then Exit;
   if (FNodesCount=0) then Exit;
   for i:=0 to (FNodesCount-1) do
    begin
     gnode:=GetGraphNode(i);
     if (gnode<>nil) then
      begin
       linksFromUp:=0;
       linksFromDown:=0;
       linksToUp:=0;
       linksToDown:=0;
       for j:=0 to (FLinksCount-1) do
        begin
         linkP:=GetGraphLink(j);
         linkFromType:=GetLinkFrom(linkP);
         linkToType:=GetLinkTo(linkP);
          if linkP<>nil then
            begin
             if linkP^.Visible then
              begin
               { Calc from Up/Down counters }
               if (linkP^.FromNodeNumber=gnode.NodeNumber) then
                begin
                 if (linkP^.EndPoint.y <> linkP^.StartPoint.y) then
                 begin
                 { Calc from Up }
                  { BPGlobalRight links }
                  if  (linkP^.EndPoint.y < linkP^.StartPoint.y) and
                      (((linkP^.ToNodeNumber and BPGlobalRightNodeNumber)<>0) or
                      ((linkP^.ToNodeNumber and BPGlobalNodeInProcess)<>0)) then
                    begin
                     inc(linksFromUp);
                     linkP^.LinkFromUpCount:=linksFromUp;
                    end;
                   { Up local links }
                   if (linkP^.EndPoint.y < linkP^.StartPoint.y) and
                      ((linkP^.ToNodeNumber and BPGlobalMask)=0) and
                      ( linkToType =lt_Top) then
                    begin
                     inc(linksFromUp);
                     linkP^.LinkFromUpCount:=linksFromUp;
                    end;
                 { Calc from Down }
                    { Down local links }
                   if (linkP^.EndPoint.y < linkP^.StartPoint.y) and
                      ((linkP^.ToNodeNumber and BPGlobalMask)=0) and
                      ((linkToType=lt_Left) or (linkToType =lt_Bottom)) then
                    begin
                     inc(linksFromDown);
                     linkP^.LinkFromDownCount:=linksFromDown;
                    end;
                   if (linkP^.EndPoint.y > linkP^.StartPoint.y) and
                      ((linkP^.ToNodeNumber and BPGlobalMask)=0) and
                      (linkToType =lt_Bottom) then
                    begin
                     inc(linksFromDown);
                     linkP^.LinkFromDownCount:=linksFromDown;
                    end;
                  { BPGlobalRight links }
                  if (linkP^.EndPoint.y > linkP^.StartPoint.y) and
                      (((linkP^.ToNodeNumber and BPGlobalRightNodeNumber)<>0) or
                       ((linkP^.ToNodeNumber and BPGlobalNodeInProcess)<>0)) then
                    begin
                     inc(linksFromDown);
                     linkP^.LinkFromDownCount:=linksFromDown;
                    end;
                 end;
                end;
               { Calc to Up/Down counters }
               if (linkP^.ToNodeNumber=gnode.NodeNumber) then
                begin
                 if ((linkP^.FromNodeNumber and BPGlobalMask)=0) and
                     (linkFromType=lt_Right) then
                   begin
                  { Calc to Up }
                    if (linkP^.StartPoint.y < linkP^.EndPoint.y) then
                     begin
                       inc(linksToUp);
                       linkP^.LinkToUpCount:=linksToUp;
                     end;
                  { Calc to Down }
                    if (linkP^.StartPoint.y > linkP^.EndPoint.y) then
                     begin
                       inc(linksToDown);
                       linkP^.LinkToDownCount:=linksToDown;
                     end;
                   end;
                end;
              end; { Visible link }
            end; { link<>nil}
        end; { for links}
        gnode.FromUpLinksCount:=linksFromUp;
        gnode.FromDownLinksCount:=linksFromDown;
        gnode.ToUpLinksCount:=linksToUp;
        gnode.ToDownLinksCount:=linksToDown;
      end; { node<>nil }
    end; { For nodes }
 end;

 procedure  TBPGraph.CalcMinimalXY; { Checked }
  Var linkP:PGraphLink;
     gnode:TBPGraphNode;
         i,j:Integer;
     linkFromType,linkToType:TLinkType;
         w,h:Integer;
  begin
  { Calculate minimalX for local nodes }
   if (FLinksCount=0) then Exit;
   if (FNodesCount=0) then Exit;
   w:=FNodeWidth;
   h:=FNodeHeight;
   for i:=0 to (FNodesCount-1) do
    begin
     gnode:=GetGraphNode(i);
     if (gnode<>nil) then
      begin
       for j:=0 to (FLinksCount-1) do
        begin
         linkP:=GetGraphLink(j);
         linkFromType:=GetLinkFrom(linkP);
         linkToType:=GetLinkTo(linkP);
          if linkP<>nil then
            begin
             if linkP^.Visible then
              begin
              if (linkP^.FromNodeNumber=gnode.NodeNumber) and
                 (linkP^.LinkFromDownCount<>0) then
              begin
                 linkP^.MinimalXFrom:=Round((w-MinLineStep)/4/(gnode.FromDownLinksCount));
                 linkP^.MinimalYFrom:=Round((h-MinLineStep)/1.5/(gnode.FromDownLinksCount));
              end;
              if (linkP^.FromNodeNumber=gnode.NodeNumber) and
                 (linkP^.LinkFromUpCount<>0) and
                 (linkP^.MinimalXFrom=0) then
              begin
                 linkP^.MinimalXFrom:=Round((w-MinLineStep)/4/(gnode.FromUpLinksCount));
                 linkP^.MinimalYFrom:=Round((h-MinLineStep)/1.5/(gnode.FromUpLinksCount));
              end;
              if (linkP^.ToNodeNumber=gnode.NodeNumber) and
                  (linkP^.LinkToUpCount<>0) then {up}
               begin
                 linkP^.MinimalXTo:=Round((w-MinLineStep)/4/(gnode.ToUpLinksCount));
                 linkP^.MinimalYTo:=Round((h-MinLineStep)/1.5/(gnode.ToUpLinksCount));
               end;
              if (linkP^.ToNodeNumber=gnode.NodeNumber) and
                  (linkP^.LinkToDownCount<>0) and
                  (linkP^.MinimalXTo=0) then {up}
               begin
                 linkP^.MinimalXTo:=Round((w-MinLineStep)/4/(gnode.ToDownLinksCount));
                 linkP^.MinimalYTo:=Round((h-MinLineStep)/1.5/(gnode.ToDownLinksCount));
               end;
              end; { linkP^.Visible }
            end; { linkp<>nil}
        end; { for j }
      end; { gnode<>nil}
    end; { for i}
  end;


 procedure  TBPGraph.CalcLabelSizes; { Checked }
  Var gnode:TBPGraphNode;
      i,j:Integer;
      maxlch:Integer;
      FSize:Integer;
      linkP:PGraphLink;
  begin
   if (FTree=nil) then Exit;
   if (FLinksCount=0) then Exit;
   if (FNodesCount=0) then Exit;
   maxlch:=0;
   for i:=0 to (FNodesCount-1) do
    begin
     gnode:=GetGraphNode(i);
     if (gnode<>nil) then
      begin
        if (maxlch<gnode.LeftLinksCount) then maxlch:=gnode.LeftLinksCount;
        if (maxlch<gnode.RightLinksCount) then maxlch:=gnode.RightLinksCount;
      end;
    end;
    if (maxlch<8) then
     begin
      FMaxCH:=1.0;
      FSize:=FLabelFontSize;
     end
    else
     begin
      FMaxCH:=8/maxlch;
      FSize:=Round(FLabelFontSize*8/maxlch)+1;
     end;
    if FPrinting then Exit;
    if FScaled then Exit;
    for j:=0 to (FLinksCount-1) do
        begin
         linkP:=GetGraphLink(j);
          if linkP<>nil then
            begin
              if (((linkP^.dwFlags and BP_SHOW_FROMCAPTION)<>0) and
                  linkP^.Visible) then
               begin
                 linkP^.BPFromLabel.Font.Size:=FSize;
               end;
              if (((linkP^.dwFlags and BP_SHOW_TOCAPTION)<>0) and
                  linkP^.Visible) then
               begin
                 linkP^.BPToLabel.Font.Size:=FSize;
               end;
            end;
        end;

  end;


function TBPGraph.IsMultipleFirst(index:Integer;MultipleFrom:Boolean):Boolean; { Checked }
Var tmpLink:PBPLink;
    tmpLink1:PGraphLink;
    flag:Boolean;
    i:Integer;
 begin
   Result:=False;
   if (FLinksCount=0) then Exit;
   tmpLink:=FLinks;
   tmpLink1:=FGraphLinks;
   inc(tmpLink,index);
   if ((tmpLink^.dwFromNodeNumber and BPGlobalMask)=BPGlobalNodeOperation) and
      ((tmpLink^.dwToNodeNumber and BPGlobalMask)=BPGlobalNodeOperation) then
       begin
         Result:=True;
         Exit;
       end;
   flag:=True;
   i:=0;
   while ((i<FLinksCount) and (flag)) do
    begin
      tmpLink1:=GetGraphLink(i);
      if MultipleFrom then
         begin
           if (tmpLink^.dwToLinkNumber=tmpLink1^.ToLinkNumber) and
              (tmpLink^.dwToNodeNumber=tmpLink1^.ToNodeNumber) and
              ((tmpLink^.dwFlags and BP_TOMASK)=(tmpLink1^.dwFlags and BP_TOMASK)) and
              (tmpLink1^.Visible) and
              ((tmpLink1^.FromNodeNumber and BPGlobalMask)<>BPGlobalNodeOperation) then
             begin
               if (tmpLink=tmpLink1^.llLink) then Result:=True;
               flag:=False;
             end;
         end
      else
         begin
           if (tmpLink^.dwFromLinkNumber=tmpLink1^.FromLinkNumber) and
              (tmpLink^.dwFromNodeNumber=tmpLink1^.FromNodeNumber) and
              ((tmpLink^.dwFlags and BP_FROMMASK)=(tmpLink1^.dwFlags and BP_FROMMASK)) and
              ((tmpLink1^.ToNodeNumber and BPGlobalMask)<>BPGlobalNodeOperation) and
              (tmpLink1^.Visible) then
             begin
               if (tmpLink=tmpLink1^.llLink) then Result:=True;
               flag:=False;
             end;
         end;
      inc(i);
    end;

 end;

function TBPGraph.GetMultipleCountFrom(index:Integer):Integer; { Checked }
Var tmpLink:PBPLink;
    tmpLink1:PGraphLink;
    flag:Boolean;
    i:Integer;
 begin
   Result:=0;
   if (FLinksCount=0) then Exit;
   tmpLink:=FLinks;
   inc(tmpLink,index);
   flag:=True;
   i:=0;
   while ((i<FLinksCount) and (flag)) do
    begin
           tmpLink1:=GetGraphLink(i);
           if (tmpLink^.dwFromLinkNumber=tmpLink1^.FromLinkNumber) and
              (tmpLink^.dwFromNodeNumber=tmpLink1^.FromNodeNumber) and
              ((tmpLink^.dwFlags and BP_FROMMASK)=(tmpLink1^.dwFlags and BP_FROMMASK)) and
              (tmpLink1^.Visible)  then
             begin
               Result:=tmpLink1^.LinkFromCount;
               flag:=False;
             end;
      inc(i);
    end;
 end;


function TBPGraph.GetMultipleCountTo(index:Integer):Integer; { Checked }
Var tmpLink:PBPLink;
    tmpLink1:PGraphLink;
    flag:Boolean;
    i:Integer;
 begin
   Result:=0;
   if (FLinksCount=0) then Exit;
   tmpLink:=FLinks;
   inc(tmpLink,index);
   flag:=True;
   i:=0;
   while ((i<FLinksCount) and (flag)) do
    begin
           tmpLink1:=GetGraphLink(i);
           if (tmpLink^.dwToLinkNumber=tmpLink1^.ToLinkNumber) and
              (tmpLink^.dwToNodeNumber=tmpLink1^.ToNodeNumber) and
              ((tmpLink^.dwFlags and BP_TOMASK)=(tmpLink1^.dwFlags and BP_TOMASK)) and
              (tmpLink1^.Visible) then
             begin
               Result:=tmpLink1^.LinkToCount;
               flag:=False;
             end;
      inc(i);
    end;
 end;


function TBPGraph.GetMultipleCountFromMTB(index:Integer):Integer; { Checked }
Var tmpLink:PBPLink;
    tmpLink1:PGraphLink;
    flag:Boolean;
    i:Integer;
 begin
   Result:=0;
   if (FLinksCount=0) then Exit;
   tmpLink:=FLinks;
   inc(tmpLink,index);
   flag:=True;
   i:=0;
   while ((i<FLinksCount) and (flag)) do
    begin
           tmpLink1:=GetGraphLink(i);
           if (tmpLink^.dwFromLinkNumber=tmpLink1^.FromLinkNumber) and
              (tmpLink^.dwFromNodeNumber=tmpLink1^.FromNodeNumber) and
              ((tmpLink^.dwFlags and BP_FROMMASK)=(tmpLink1^.dwFlags and BP_FROMMASK)) and
              (tmpLink1^.Visible)  then
             begin
               Result:=tmpLink1^.LinkFromCountMTB;
               flag:=False;
             end;
      inc(i);
    end;
 end;


function TBPGraph.GetMultipleCountToMTB(index:Integer):Integer; { Checked }
Var tmpLink:PBPLink;
    tmpLink1:PGraphLink;
    flag:Boolean;
    i:Integer;
 begin
   Result:=0;
   if (FLinksCount=0) then Exit;
   tmpLink:=FLinks;
   inc(tmpLink,index);
   flag:=True;
   i:=0;
   while ((i<FLinksCount) and (flag)) do
    begin
           tmpLink1:=GetGraphLink(i);
           if (tmpLink^.dwToLinkNumber=tmpLink1^.ToLinkNumber) and
              (tmpLink^.dwToNodeNumber=tmpLink1^.ToNodeNumber) and
              ((tmpLink^.dwFlags and BP_TOMASK)=(tmpLink1^.dwFlags and BP_TOMASK)) and
              (tmpLink1^.Visible) then
             begin
               Result:=tmpLink1^.LinkToCountMTB;
               flag:=False;
             end;
      inc(i);
    end;
 end;


procedure TBPGraph.MyIncMLinks(link:PGraphLink;FromTo:Boolean;Incv:Integer);
Var i:Integer;
   linkT:PGraphLink;
 begin
  {}
  if (FLinksCount=0) then Exit;
  linkT:=FGraphLinks;
  while (linkT<>nil) do
   begin
     if (linkT^.Visible) then
       begin
         if (linkT^.Tag>link^.Tag) then
          if FromTo then
           begin
           if (link^.ToLinkNumber=linkT^.ToLinkNumber) and
             (link^.ToNodeNumber=linkT^.ToNodeNumber) and
             ((link^.dwFlags and BP_TOMASK)=(linkT^.dwFlags and BP_TOMASK)) then linkT^.LinkFromPos:=linkT^.LinkFromPos+Incv;
           end
          else
           begin
            if (link^.FromLinkNumber=linkT^.FromLinkNumber) and
             (link^.FromNodeNumber=linkT^.FromNodeNumber) and
             ((link^.dwFlags and BP_FROMMASK)=(linkT^.dwFlags and BP_FROMMASK)) then linkT^.LinkToPos:=linkT^.LinkToPos+Incv;
           end;
       end;
     linkT:=linkT^.next;
   end;
 end;

{!!!}
procedure  TBPGraph.TraceLinksToNodeCounters; { Checked }
 Var linkP:PGraphLink;
     gnode:TBPGraphNode;
     gdnode:TBPDGraphNode;
         i,j:Integer;
     linkFromType,linkToType:TLinkType;
         mm:TBPMultipleMask;
         mff,mft:Boolean;
         fromC,toC:TRect;
  begin
   { Calc links count for every node }
   if (FLinksCount=0) then Exit;
   if (FNodesCount=0) then Exit;
   for i:=0 to (FNodesCount-1) do
    begin
     gnode:=GetGraphNode(i);
     if (gnode<>nil) then
      begin
       fromC.Left:=0;
       fromC.Right:=0;
       FromC.Top:=0;
       FromC.Bottom:=0;
       toC.Left:=0;
       toC.Right:=0;
       toC.Top:=0;
       toC.Bottom:=0;
       for j:=0 to (FLinksCount-1) do
        begin
         linkP:=GetGraphLink(j);
         linkFromType:=GetLinkFrom(linkP);
         linkToType:=GetLinkTo(linkP);
          if linkP<>nil then
            begin
             (* if linkP^.Visible then
              begin { Link Visible } *)
              mm:=GetMultipleMask(j);
              mff:=IsMultipleFirst(j,True);
              mft:=IsMultipleFirst(j,False);
              if (linkP^.FromNodeNumber=gnode.NodeNumber) then
                begin
                  { if not multiple link from or first multiple link }
                 if ((mm<>bpmm_To) and (mm<>bpmm_FromTo)) or
                    (mft and ((mm=bpmm_To) or (mm=bpmm_FromTo))) or
                    (((linkP^.ToNodeNumber and BPFrameGlobalMask)<>0)
                     and ((not(mft)) and mff and ((mm=bpmm_To) or (mm=bpmm_FromTo))))  then
                  begin
                  case (LinkFromType) of
                   lt_Left:   begin
                               gnode.LeftLinksCount:=gnode.LeftLinksCount+1;
                               linkP^.LinkFromCount:=linkP^.FromLinkNumber+FromC.Left;
                               if (((mm<>bpmm_To) and (mm<>bpmm_FromTo)) or
                                  (mft and ((mm=bpmm_To) or (mm=bpmm_FromTo)))) and
                                   ((linkP^.ToNodeNumber and BPFrameGlobalMask)=0) then
                                   begin
                                    dec(linkP^.linkToPos);
                                    MyIncMLinks(linkP,False,-1);
                                   end;
                               if (((linkP^.ToNodeNumber and BPFrameGlobalMask)<>0)
                                  and ((not(mft)) and mff and ((mm=bpmm_To) or (mm=bpmm_FromTo)))) then
                                begin
                                 inc(linkP^.linkToPos);
                                 MyIncMLinks(linkP,False,1);
                                 if linkP^.linkToPos>0 then inc(FromC.Left)
                                  else gnode.LeftLinksCount:=gnode.LeftLinksCount-1;
                                end;
                              end;
                   lt_Right:  begin
                               gnode.RightLinksCount:=gnode.RightLinksCount+1;
                               linkP^.LinkFromCount:=linkP^.FromLinkNumber+FromC.Right;
                               if (((mm<>bpmm_To) and (mm<>bpmm_FromTo)) or
                                  (mft and ((mm=bpmm_To) or (mm=bpmm_FromTo)))) and
                                   ((linkP^.ToNodeNumber and BPFrameGlobalMask)=0) then
                                   begin
                                    dec(linkP^.linkToPos);
                                    MyIncMLinks(linkP,False,-1);
                                   end;
                               if (((linkP^.ToNodeNumber and BPFrameGlobalMask)<>0)
                                  and ((not(mft)) and mff and ((mm=bpmm_To) or (mm=bpmm_FromTo)))) then
                                begin
                                 inc(linkP^.linkToPos);
                                 MyIncMLinks(linkP,False,1);
                                 if linkP^.linkToPos>0 then inc(FromC.Right) else
                                  gnode.RightLinksCount:=gnode.RightLinksCount-1;
                                end;
                              end;
                   lt_Top:    begin
                               gnode.TopLinksCount:=gnode.TopLinksCount+1;
                               linkP^.LinkFromCount:=linkP^.FromLinkNumber+FromC.Top;
                               if (((mm<>bpmm_To) and (mm<>bpmm_FromTo)) or
                                  (mft and ((mm=bpmm_To) or (mm=bpmm_FromTo)))) and
                                   ((linkP^.ToNodeNumber and BPFrameGlobalMask)=0) then
                                   begin
                                    dec(linkP^.linkToPos);
                                    MyIncMLinks(linkP,False,-1);
                                   end;
                               if (((linkP^.ToNodeNumber and BPFrameGlobalMask)<>0)
                                  and ((not(mft)) and mff and ((mm=bpmm_To) or (mm=bpmm_FromTo)))) then
                                begin
                                 inc(linkP^.linkToPos);
                                 MyIncMLinks(linkP,False,1);
                                 if linkP^.linkToPos>0 then inc(FromC.Top) else
                                   gnode.TopLinksCount:=gnode.TopLinksCount-1;
                                end;
                              end;
                   lt_Bottom: begin
                               if ((linkP^.ToNodeNumber and BPGlobalNodeOperation)=0) then
                                begin
                                gnode.BottomLinksCount:=gnode.BottomLinksCount+1;
                                linkP^.LinkFromCount:=linkP^.FromLinkNumber+FromC.Bottom;
                                if (((mm<>bpmm_To) and (mm<>bpmm_FromTo)) or
                                  (mft and ((mm=bpmm_To) or (mm=bpmm_FromTo)))) and
                                   ((linkP^.ToNodeNumber and BPFrameGlobalMask)=0) then
                                   begin
                                    dec(linkP^.linkToPos);
                                    MyIncMLinks(linkP,False,-1);
                                   end;
                                if (((linkP^.ToNodeNumber and BPFrameGlobalMask)<>0)
                                  and ((not(mft)) and mff and ((mm=bpmm_To) or (mm=bpmm_FromTo)))) then
                                begin
                                 inc(linkP^.linkToPos);
                                 MyIncMLinks(linkP,False,1);
                                 if linkP^.linkToPos>0 then inc(FromC.Bottom) else
                                  gnode.BottomLinksCount:=gnode.BottomLinksCount-1;
                                end;
                                end;
                              end;
                  end;
                  end else
                   case (LinkFromType) of
                   lt_Left: linkP^.LinkFromCount:=linkP^.FromLinkNumber+FromC.Left;
                   lt_Right: linkP^.LinkFromCount:=linkP^.FromLinkNumber+FromC.Right;
                   lt_Top:   linkP^.LinkFromCount:=linkP^.FromLinkNumber+FromC.Top;
                   lt_Bottom: if ((linkP^.ToNodeNumber and BPGlobalNodeOperation)=0) then
                                linkP^.LinkFromCount:=linkP^.FromLinkNumber+FromC.Bottom
                              else
                                linkP^.LinkFromCount:=linkP^.FromLinkNumber;
                   { end if multiple from }
                   end;
                end;
              if (linkP^.ToNodeNumber=gnode.NodeNumber) then
                begin
                 if ((mm<>bpmm_From) and (mm<>bpmm_FromTo)) or
                    (mff and ((mm=bpmm_From) or (mm=bpmm_FromTo))) or
                    (((linkP^.FromNodeNumber and BPFrameGlobalMask)<>0)
                     and ((not(mff)) and mft and ((mm=bpmm_From) or (mm=bpmm_FromTo)))) then
                  begin
                  case (LinkToType) of
                   lt_Left:   begin
                              gnode.LeftLinksCount:=gnode.LeftLinksCount+1;
                              linkP^.LinkToCount:=linkP^.ToLinkNumber+toC.Left;
                              if (((mm<>bpmm_From) and (mm<>bpmm_FromTo)) or
                                 (mff and ((mm=bpmm_From) or (mm=bpmm_FromTo)))) and
                                 ((linkP^.FromNodeNumber and BPFrameGlobalMask)=0) then
                                  begin
                                    dec(linkP^.LinkFromPos);
                                    MyIncMLinks(linkP,True,-1);
                                  end;
                              if (((linkP^.FromNodeNumber and BPFrameGlobalMask)<>0)
                                  and ((not(mff)) and mft and ((mm=bpmm_From) or (mm=bpmm_FromTo)))) then
                                begin
                                 inc(linkP^.LinkFromPos);
                                 MyIncMLinks(linkP,True,1);
                                 if linkP^.linkFromPos>0 then inc(toC.Left) else
                                  gnode.LeftLinksCount:=gnode.LeftLinksCount-1;
                                end;
                              end;
                   lt_Right:  begin
                              gnode.RightLinksCount:=gnode.RightLinksCount+1;
                              linkP^.LinkToCount:=linkP^.ToLinkNumber+ToC.Right;
                              if (((mm<>bpmm_From) and (mm<>bpmm_FromTo)) or
                                 (mff and ((mm=bpmm_From) or (mm=bpmm_FromTo)))) and
                                 ((linkP^.FromNodeNumber and BPFrameGlobalMask)=0) then
                                  begin
                                    dec(linkP^.LinkFromPos);
                                    MyIncMLinks(linkP,True,-1);
                                  end;
                              if (((linkP^.FromNodeNumber and BPFrameGlobalMask)<>0)
                                  and ((not(mff)) and mft and ((mm=bpmm_From) or (mm=bpmm_FromTo)))) then
                                begin
                                 inc(linkP^.LinkFromPos);
                                 MyIncMLinks(linkP,True,1);
                                 if linkP^.linkFromPos>0 then inc(toC.Right) else
                                  gnode.RightLinksCount:=gnode.RightLinksCount-1;
                                end;
                              end;
                   lt_Top:    begin
                              gnode.TopLinksCount:=gnode.TopLinksCount+1;
                              linkP^.LinkToCount:=linkP^.ToLinkNumber+ToC.Top;
                              if (((mm<>bpmm_From) and (mm<>bpmm_FromTo)) or
                                 (mff and ((mm=bpmm_From) or (mm=bpmm_FromTo)))) and
                                 ((linkP^.FromNodeNumber and BPFrameGlobalMask)=0) then
                                  begin
                                    dec(linkP^.LinkFromPos);
                                    MyIncMLinks(linkP,True,-1);
                                  end;
                              if (((linkP^.FromNodeNumber and BPFrameGlobalMask)<>0)
                                  and ((not(mff)) and mft and ((mm=bpmm_From) or (mm=bpmm_FromTo)))) then
                                begin
                                 inc(linkP^.LinkFromPos);
                                 MyIncMLinks(linkP,True,1);
                                 if linkP^.linkFromPos>0 then inc(toC.Top) else
                                  gnode.TopLinksCount:=gnode.TopLinksCount-1;
                                end;
                              end;
                   lt_Bottom: begin
                              if ((linkP^.FromNodeNumber and BPGlobalNodeOperation)=0) then
                                begin
                                 gnode.BottomLinksCount:=gnode.BottomLinksCount+1;
                                 linkP^.LinkToCount:=linkP^.ToLinkNumber+toc.Bottom;
                                 if (((mm<>bpmm_From) and (mm<>bpmm_FromTo)) or
                                 (mff and ((mm=bpmm_From) or (mm=bpmm_FromTo)))) and
                                 ((linkP^.FromNodeNumber and BPFrameGlobalMask)=0) then
                                  begin
                                    dec(linkP^.LinkFromPos);
                                    MyIncMLinks(linkP,True,-1);
                                  end;
                                 if (((linkP^.FromNodeNumber and BPFrameGlobalMask)<>0)
                                  and ((not(mff)) and mft and ((mm=bpmm_From) or (mm=bpmm_FromTo)))) then
                                  begin
                                  inc(linkP^.LinkFromPos);
                                  MyIncMLinks(linkP,True,1);
                                  if linkP^.linkFromPos>0 then inc(toC.Bottom) else
                                    gnode.BottomLinksCount:=gnode.BottomLinksCount-1;
                                  end;
                                end;
                              end;
                  end;
                  end else
                   case (LinkToType) of
                    lt_Left:    linkP^.LinkToCount:=linkP^.ToLinkNumber+ToC.Left;
                    lt_Right:   linkP^.LinkToCount:=linkP^.ToLinkNumber+ToC.Right;
                    lt_Top:     linkP^.LinkToCount:=linkP^.ToLinkNumber+ToC.Top;
                    lt_Bottom:  if ((linkP^.FromNodeNumber and BPGlobalNodeOperation)=0) then
                                linkP^.LinkToCount:=linkP^.ToLinkNumber+ToC.Bottom
                                else
                                 linkP^.LinkToCount:=linkP^.ToLinkNumber;
                   end;
                end;
             (*  end; { Visible link } *)
            end; { link<>nil}
        end; { for links }
      end; { node<>nil}
    end; { for nodes }

      for i:=0 to (FLinksCount-1) do
       begin
          linkP:=GetGraphLink(i);
          if linkP^.Visible then
          begin
             { Now For global nodes }
             mm:=GetMultipleMask(i);
             mff:=IsMultipleFirst(i,True);
             mft:=IsMultipleFirst(i,False);

             if ((linkP^.FromNodeNumber and BPGlobalMask)=BPGlobalNodeInProcess) and
                ((linkP^.dwFlags and BP_FROMTOMASK)=BP_RIGHT_LEFT)  then
                 begin
                   {Left Inprocess }
                   if ((mm<>bpmm_To) and (mm<>bpmm_FromTo)) or
                    (mft and ((mm=bpmm_To) or (mm=bpmm_FromTo))) then
                     begin
                      Inc(FGlobalLeftLinksCount);
                      linkP^.LinkFromCount:=FGlobalLeftLinksCount;
                     end else linkP^.LinkFromCount:=GetMultipleCountFrom(i);
                 end;
             if ((linkP^.FromNodeNumber and BPGlobalMask)=BPGlobalNodeInProcess) and
                ((linkP^.dwFlags and BP_FROMMASK)=BP_FROMNODE_BOTTOM)  then
                 begin
                   { TOp inpROCESS }
                   if ((mm<>bpmm_To) and (mm<>bpmm_FromTo)) or
                    (mft and ((mm=bpmm_To) or (mm=bpmm_FromTo))) then
                   begin
                    Inc(FGlobalTopLinksCount);
                    if (mm<>bpmm_None) then
                     begin
                      Inc(FMultipleTopLinksCount);
                      LinkP^.LinkFromCountMTB:=FMultipleTopLinksCount;
                     end;
                    linkP^.LinkFromCount:=FGlobalTopLinksCount;
                   end else
                    begin
                    linkP^.LinkFromCount:=GetMultipleCountFrom(i);
                    linkP^.LinkFromCountMTB:=GetMultipleCountFromMTB(i);
                    end;
                 end;
             if ((linkP^.FromNodeNumber and BPGlobalMask)=BPGlobalNodeInProcess) and
                ((linkP^.dwFlags and BP_FROMMASK)=BP_FROMNODE_TOP)  then
                 begin
                   { bOTTOM InProcess }
                   if ((mm<>bpmm_To) and (mm<>bpmm_FromTo)) or
                    (mft and ((mm=bpmm_To) or (mm=bpmm_FromTo))) then
                   begin
                    Inc(FGlobalBottomLinksCount);
                    if (mm<>bpmm_None) then
                     begin
                      Inc(FMultipleBottomLinksCount);
                      LinkP^.LinkFromCountMTB:=FMultipleBottomLinksCount;
                     end;
                    linkP^.LinkFromCount:=FGlobalBottomLinksCount;
                   end else
                    begin
                     linkP^.LinkFromCount:=GetMultipleCountFrom(i);
                     linkP^.LinkFromCountMTB:=GetMultipleCountFromMTB(i);
                    end;
                 end;
             if ((linkP^.ToNodeNumber and BPGlobalMask)=BPGlobalNodeInProcess) and
                ((linkP^.dwFlags and BP_FROMTOMASK)=BP_RIGHT_LEFT)  then
                 begin
                   {Right Inprocess }
                   if ((mm<>bpmm_From) and (mm<>bpmm_FromTo)) or
                    (mff and ((mm=bpmm_From) or (mm=bpmm_FromTo))) then
                   begin
                    Inc(FGlobalRightLinksCount);
                    linkP^.LinkToCount:=FGlobalRightLinksCount;
                   end else linkP^.LinkToCount:=GetMultipleCountTo(i);
                 end;
             {Left global node}
             if ((linkP^.FromNodeNumber and BPGlobalMask)=BPGlobalLeftNodeNumber) then
                 begin
                    if ((mm<>bpmm_To) and (mm<>bpmm_FromTo)) or
                    (mft and ((mm=bpmm_To) or (mm=bpmm_FromTo))) then
                     begin
                      Inc(FGlobalLeftLinksCount);
                      linkP^.LinkFromCount:=FGlobalLeftLinksCount;
                     end else linkP^.LinkFromCount:=GetMultipleCountFrom(i);
                 end;
             if ((linkP^.ToNodeNumber  and BPGlobalMask)=BPGlobalLeftNodeNumber) then
                  begin
                   if ((mm<>bpmm_From) and (mm<>bpmm_FromTo)) or
                    (mff and ((mm=bpmm_From) or (mm=bpmm_FromTo))) then
                   begin
                    Inc(FGlobalLeftLinksCount);
                    linkP^.LinkToCount:=FGlobalLeftLinksCount;
                   end else linkP^.LinkToCount:=GetMultipleCountTo(i);
                  end;
             { Right  global node}
             if ((linkP^.FromNodeNumber and BPGlobalMask)=BPGlobalRightNodeNumber) then
                  begin
                    if ((mm<>bpmm_To) and (mm<>bpmm_FromTo)) or
                    (mft and ((mm=bpmm_To) or (mm=bpmm_FromTo))) then
                   begin
                   Inc(FGlobalRightLinksCount);
                   linkP^.LinkFromCount:=FGlobalRightLinksCount;
                   end else linkP^.LinkFromCount:=GetMultipleCountFrom(i);
                  end;
             if ((linkP^.ToNodeNumber and BPGlobalMask)=BPGlobalRightNodeNumber) then
                  begin
                   if ((mm<>bpmm_From) and (mm<>bpmm_FromTo)) or
                    (mff and ((mm=bpmm_From) or (mm=bpmm_FromTo))) then
                   begin
                    Inc(FGlobalRightLinksCount);
                    linkP^.LinkToCount:=FGlobalRightLinksCount;
                   end else linkP^.LinkToCount:=GetMultipleCountTo(i);
                  end;
             { Top  global node}
             if ((linkP^.FromNodeNumber and BPGlobalMask)=BPGlobalTopNodeNumber) then
                  begin
                   if ((mm<>bpmm_To) and (mm<>bpmm_FromTo)) or
                    (mft and ((mm=bpmm_To) or (mm=bpmm_FromTo))) then
                   begin
                    Inc(FGlobalTopLinksCount);
                    if (mm<>bpmm_None) then
                     begin
                      Inc(FMultipleTopLinksCount);
                      LinkP^.LinkFromCountMTB:=FMultipleTopLinksCount;
                     end;
                    linkP^.LinkFromCount:=FGlobalTopLinksCount;
                   end else
                    begin
                    linkP^.LinkFromCount:=GetMultipleCountFrom(i);
                    linkP^.LinkFromCountMTB:=GetMultipleCountFromMTB(i);
                    end;
                  end;
             if ((linkP^.ToNodeNumber and BPGlobalMask)=BPGlobalTopNodeNumber) then
                  begin
                  if ((mm<>bpmm_From) and (mm<>bpmm_FromTo)) or
                    (mff and ((mm=bpmm_From) or (mm=bpmm_FromTo))) then
                   begin
                    Inc(FGlobalTopLinksCount);
                    if (mm<>bpmm_None) then
                     begin
                      Inc(FMultipleTopLinksCount);
                      LinkP^.LinkToCountMTB:=FMultipleTopLinksCount;
                     end;
                    linkP^.LinkToCount:=FGlobalTopLinksCount;
                   end else
                    begin
                     linkP^.LinkToCount:=GetMultipleCountTo(i);
                     linkP^.LinkToCountMTB:=GetMultipleCountToMTB(i);
                    end;
                  end;
            { Bottom  global node}
             if ((linkP^.FromNodeNumber and BPGlobalMask)=BPGlobalBottomNodeNumber) then
                  begin
                   if ((mm<>bpmm_To) and (mm<>bpmm_FromTo)) or
                    (mft and ((mm=bpmm_To) or (mm=bpmm_FromTo))) then
                   begin
                    Inc(FGlobalBottomLinksCount);
                    if (mm<>bpmm_None) then
                     begin
                      Inc(FMultipleBottomLinksCount);
                      LinkP^.LinkFromCountMTB:=FMultipleBottomLinksCount;
                     end;
                    linkP^.LinkFromCount:=FGlobalBottomLinksCount;
                   end else
                    begin
                     linkP^.LinkFromCount:=GetMultipleCountFrom(i);
                     linkP^.LinkFromCountMTB:=GetMultipleCountFromMTB(i);
                    end;
                  end;
             if ((linkP^.ToNodeNumber and BPGlobalMask)=BPGlobalBottomNodeNumber) then
                  begin
                  if ((mm<>bpmm_From) and (mm<>bpmm_FromTo)) or
                    (mff and ((mm=bpmm_From) or (mm=bpmm_FromTo))) then
                   begin
                    Inc(FGlobalBottomLinksCount);
                    if (mm<>bpmm_None) then
                     begin
                      Inc(FMultipleBottomLinksCount);
                      LinkP^.LinkToCountMTB:=FMultipleBottomLinksCount;
                     end;
                    linkP^.LinkToCount:=FGlobalBottomLinksCount;
                   end else
                    begin
                     linkP^.LinkToCount:=GetMultipleCountTo(i);
                     linkP^.LinkToCountMTB:=GetMultipleCountToMTB(i);
                    end;
                  end;
             if ((linkP^.FromNodeNumber and BPGlobalMask)=BPGlobalNodeOperation) then
                 begin
                  { if ((mm<>bpmm_To) and (mm<>bpmm_FromTo)) or
                    (mft and ((mm=bpmm_To) or (mm=bpmm_FromTo))) then
                   begin}
                    gdnode:=GetDGraphNumberedNode(linkP^.ToNodeNumber);
                    if (gdNode<>nil) then
                    begin
                    gdNode.TopLinksCount:=gdNode.TopLinksCount+1;
                    linkP^.LinkFromCount:=gdNode.TopLinksCount;
                    linkP^.LinkToCount:=gdNode.TopLinksCount;
                    end;
                 {  end else linkP^.LinkFromCount:=GetMultipleCountFrom(i);}

                 end;
             if ((linkP^.ToNodeNumber and BPGlobalMask)=BPGlobalNodeOperation) then
                 begin
{                   if ((mm<>bpmm_From) and (mm<>bpmm_FromTo)) or
                    (mff and ((mm=bpmm_From) or (mm=bpmm_FromTo))) then
                    begin}
                    gdnode:=GetDGraphNumberedNode(linkP^.FromNodeNumber);
                    if (gdNode<>nil) then
                    begin
                    gdNode.TopLinksCount:=gdNode.TopLinksCount+1;
                    linkP^.LinkToCount:=gdNode.TopLinksCount;
                    linkP^.LinkFromCount:=gdNode.TopLinksCount;
                    end;
                 {  end else linkP^.LinkToCount:=GetMultipleCountFrom(i);}
                 end;
          end; { Visible link }
       end; { for }

  end;



procedure  TBPGraph.TraceNodesToLinksCounters; { Checked }
  Var linkP:PGraphLink;
         i:Integer;
 begin
   if (FLinksCount=0) then Exit;
   for i:=0 to (FLinksCount-1) do
    begin
     linkP:=GetGraphLink(i);
     linkP^.LinkFromCount:=0;
     linkP^.LinkToCount:=0;
     linkP^.LinkFromDownCount:=0;
     linkP^.LinkToDownCount:=0;
     linkP^.LinkFromUpCount:=0;
     linkP^.LinkToUpCount:=0;
     linkP^.LinkFromCountMTB:=0;
     linkP^.LinkToCountMTB:=0;
     linkP^.MinimalXFrom:=0;
     linkP^.MinimalXTo:=0;
     linkP^.MinimalYFrom:=0;
     linkP^.MinimalYTo:=0;
     linkP^.LinkFromPos:=0;
     linkP^.LinkToPos:=0;
     linkP^.LinkFromAdd:=0;
     linkP^.LinkToAdd:=0;
  end;
 end;

 { BUG!!! }
procedure  TBPGraph.TraceLocalStartEndPoints; { Checked }
 Var linkP:PGraphLink;
     gnode:TBPGraphNode;
         i:Integer;
       w,h:Integer;
       w1,h1:Integer;
       posx,posy:Integer;
       linkFromType,linkToType:TLinkType;
       lc:Integer;
       mm:TBPMultipleMask;
       mff,mft:Boolean;
  begin
   { SetUp Start & End points of Links }
   if (FLinksCount=0) then Exit;
   if (FNodesCount=0) then Exit;
   if FOwner.HorzScrollBar.Visible then
     posx:=FOwner.HorzScrollBar.ScrollPos
   else
     posx:=0;
   if FOwner.VertScrollBar.Visible then
     posy:=FOwner.VertScrollBar.ScrollPos
   else
     posx:=0;
   if FPrinting then
    begin
      posx:=0;
      posy:=0;
    end;
   for i:=0 to (FLinksCount-1) do
    begin
      linkP:=GetGraphLink(i);
      if linkP^.Visible then
      begin
      mm:=GetMultipleMask(i);
      mft:=IsMultipleFirst(i,False);
      mff:=IsMultipleFirst(i,True);
      linkFromType:=GetLinkFrom(linkP);
      linkToType:=GetLinkTo(linkP);
      gnode:=GetGraphNumberedNode(linkP^.FromNodeNumber);
      { begin StartPoint }
      if (gnode<>nil) then
       begin
         { local node }
         if (mft) or
         ((mm<>bpmm_To) and (mm<>bpmm_FromTo)) then
         lc:=linkP^.LinkFromCount else
         lc:=GetMultipleCountFrom(i);
         case (LinkFromType) of
          lt_Left: begin
                     h1:=gnode.height div (gnode.LeftLinksCount+1);
                     w:=gnode.left;
                     h:=gnode.top+h1*lc;
                   end;
          lt_Right: begin
                     h1:=gnode.height div (gnode.RightLinksCount+1);
                     w:=gnode.left+gnode.Width;
                     h:=gnode.top+h1*lc;
                   end;
          lt_Top:  begin
                     w1:=gnode.width div (gnode.TopLinksCount+1);
                     w:=gnode.left+w1*lc;
                     h:=gnode.top;
                   end;
          lt_Bottom: begin
                     w1:=gnode.width div (gnode.BottomLinksCount+1);
                     w:=gnode.left+w1*lc;
                     h:=gnode.top+gnode.Height;
                   end;
         end;
          linkP^.StartPoint.x:=w;
          linkP^.StartPoint.y:=h;
       end;
      { End StartPoint }
      gnode:=GetGraphNumberedNode(linkP^.ToNodeNumber);
      { begin EndPoint }
      if (gnode<>nil) then
       begin
         { local node }
        if (mff) or
           ((mm<>bpmm_From) and (mm<>bpmm_FromTo)) then
        lc:=linkP^.LinkToCount else
        lc:=GetMultipleCountTo(i);
         case (LinkToType) of
          lt_Left: begin
                     h1:=gnode.height div (gnode.LeftLinksCount+1);
                     w:=gnode.left;
                     h:=gnode.top+h1*lc;
                   end;
          lt_Right: begin
                     h1:=gnode.height div (gnode.RightLinksCount+1);
                     w:=gnode.left+gnode.Width;
                     h:=gnode.top+h1*lc;
                   end;
          lt_Top:  begin
                     w1:=gnode.width div (gnode.TopLinksCount+1);
                     w:=gnode.left+w1*lc;
                     h:=gnode.top;
                   end;
          lt_Bottom: begin
                     w1:=gnode.width div (gnode.BottomLinksCount+1);
                     w:=gnode.left+w1*lc;
                     h:=gnode.top+gnode.Height;
                   end;
         end;
         linkP^.EndPoint.x:=w;
         linkP^.EndPoint.y:=h;
       end;
       { End EndPoint }
      end; { LinkP^.Visible }
    end; { for i }
  end;

 function  TBPGraph.GetNodeRect(nodeNum:DWORD):TRect;
 Var i:Integer;
     tmpNode:PGraphNode;
  begin
   result.Left:=0;
   result.Top:=0;
   result.Bottom:=0;
   result.Right:=0;
   if (FNodesCount=0) then Exit;
   tmpNode:=FGraphNodes;
    while (tmpNode<>nil) do
      begin
        if tmpNode^.BPNode.NodeNumber=nodeNum then
          begin
            Result.Left:=tmpNode^.BPNode.Height;
            Result.Right:=tmpNode^.BPNode.Height;
            Result.Top:=tmpNode^.BPNode.Width;
            Result.Bottom:=tmpNode^.BPNode.Width;
            if tmpNode^.BPNode.LeftLinksCount=0 then Result.Left:=0
             else Result.Left:=Result.Left div (tmpNode^.BPNode.LeftLinksCount+1);
            if tmpNode^.BPNode.RightLinksCount=0 then Result.Right:=0
             else Result.Right:=Result.Right div (tmpNode^.BPNode.RightLinksCount+1);
            if tmpNode^.BPNode.TopLinksCount=0 then Result.Top:=0
             else Result.Top:=Result.Top div (tmpNode^.BPNode.TopLinksCount+1);
            if tmpNode^.BPNode.BottomLinksCount=0 then Result.Bottom:=0
             else Result.Bottom:=Result.Bottom div (tmpNode^.BPNode.BottomLinksCount+1);
          end;
        tmpNOde:=tmpNOde^.next;
      end;
  end;

 procedure TBPGraph.CorrectGlobalLinks;
Var i:Integer;
   linkP,linkT:PGraphLink;
   addFrom,addTo:DWORD;
   r:TRect;
 begin
   if (FLinksCount=0) then Exit;
   linkP:=FGraphLinks;
   while linkP<>nil do
    begin
      if ((linkP^.FromNodeNumber and BPFrameGlobalMask)<>0) and
         (linkP^.LinkFromPos>0) then
          begin
            r:=GetNodeRect(linkP^.ToNodeNumber);
            case (LinkP^.FromNodeNumber and BPFrameGlobalMask) of
             BPGlobalRightNodeNumber: addFrom:=linkP^.LinkFromPos*r.Right;
             BPGlobalLeftNodeNumber: addFrom:=linkP^.LinkFromPos*r.Left;
             BPGlobalBottomNodeNumber: AddFrom:=linkP^.LinkFromPos*r.Bottom;
             BPGlobalNodeInProcess: begin
                                     if linkP^.Visible then
                                      begin
                                       if ((linkP^.dwFlags and BP_FROMTOMASK)=BP_RIGHT_LEFT) then
                                        addFrom:=linkP^.LinkFromPos*r.Left
                                       else
                                       if ((linkP^.dwFlags and BP_FROMMASK)=BP_FROMNODE_BOTTOM) then
                                        addFrom:=linkP^.LinkFromPos*r.Top
                                       else
                                        addFrom:=linkP^.LinkFromPos*r.Bottom;
                                      end;
                                    end;
             BPGlobalTopNodeNumber: AddFrom:=linkP^.LinkFromPos*r.Top;
             else AddFrom:=0;
            end;
            linkP^.LinkFromAdd:=AddFrom;
            linkT:=FGraphLinks;
            while linkT<>nil do
             begin
               if (linkP<>linkT) then
                 begin
                   if (linkP^.FromLinkNumber=linkT^.FromLinkNumber) and
                      ((linkP^.FromNodeNumber and BPFrameGlobalMask)=(linkT^.FromNodeNumber and BPFrameGlobalMask)) and
                      ((linkP^.dwFlags and BP_FROMMASK)=(linkT^.dwFlags and BP_FROMMASK)) then
                    begin
                     linkT^.LinkFromAdd:=linkP^.LinkFromAdd;
                    end;
                 end;
               linkT:=linkT^.next;
             end;
          end;
        if ((linkP^.ToNodeNumber and BPFrameGlobalMask)<>0) and
         (linkP^.LinkToPos>0) then
          begin
            r:=GetNodeRect(linkP^.FromNodeNumber);
            case (linkP^.ToNodeNumber and BPFrameGlobalMask) of
             BPGlobalRightNodeNumber: addTo:=linkP^.LinkToPos*r.Right;
             BPGlobalLeftNodeNumber: addTo:=linkP^.LinkToPos*r.Left;
             BPGlobalBottomNodeNumber: AddTo:=linkP^.LinkToPos*r.Bottom;
             BPGlobalTopNodeNumber: AddTo:=linkP^.LinkToPos*r.Top;
             BPGlobalNodeInProcess: begin
                                     if linkP^.Visible then
                                      begin
                                        addTo:=linkP^.LinkToPos*r.Right;
                                      end;
                                    end;
             else AddTo:=0;
            end;
            linkP^.LinkToAdd:=addTo;
            linkT:=FGraphLinks;
            while linkT<>nil do
             begin
               if (linkP<>linkT) then
                 begin
                   if ((linkP^.ToNodeNumber and BPFrameGlobalMask)=(linkT^.ToNodeNumber and BPFrameGlobalMask)) and
                      ((linkP^.dwFlags and BP_TOMASK)=(linkT^.dwFlags and BP_TOMASK)) and
                      (linkP^.ToLinkNumber=linkT^.ToLinkNumber) then
                    begin
                     linkT^.LinkToAdd:=linkP^.LinkToAdd;
                    end;
                 end;
               linkT:=linkT^.next;
             end;
          end;
      linkP:=linkP^.next;
    end;
 end;


 procedure  TBPGraph.TraceGlobalStartEndPoints; { Checked }
 Var linkP,linkTmp:PGraphLink;
         i:Integer;
       w,h:Integer;
       w1,h1:Integer;
       gw,gh:Integer;
       posx,posy:Integer;
       cofs:Integer;
       mff,mft:Boolean;
       gdnode:TBPDGraphNode;
       hh,hhh:Integer;
  begin
   { SetUp Start & End points of Links }
   if (FLinksCount=0) then Exit;
   if (FNodesCount=0) then Exit;
   if FOwner.HorzScrollBar.Visible then
    begin
     gw:=FOwner.HorzScrollBar.Range;
     posx:=FOwner.HorzScrollBar.ScrollPos;
    end
   else
    begin
     gw:=FOwner.ClientWidth;
     posx:=0;
    end;
   if FOwner.VertScrollBar.Visible then
    begin
     gh:=FOwner.VertScrollBar.Range;
     posy:=FOwner.VertScrollBar.ScrollPos;
    end
   else
    begin
     gh:=FOwner.ClientHeight;
     posx:=0;
    end;
   if FPrinting then
    begin
      gh:=FDefHeight;
      gw:=FDefWidth;
      if not(FScaled2) then
       begin
        posx:=0;
        posy:=0;
       end;
    end;
   for i:=0 to (FLinksCount-1) do
    begin
      linkP:=GetGraphLink(i);
      if linkP^.Visible then
      begin
      mft:=IsMultipleFirst(i,False);
      mff:=IsMultipleFirst(i,True);
      if ((linkP^.FromNodeNumber and BPGlobalMask)<>0) or
         ((linkP^.ToNodeNumber and BPGlobalMask)<>0) then
       begin
         { global node }
         case (linkP^.FromNodeNumber and BPGlobalMask) of
          BPGlobalRightNodeNumber: begin
                     if (mft) then
                      cofs:=linkP^.StartPoint.y
                     else
                      begin
                       linkTmp:=GetMultipleFirst(i,False);
                       cofs:=linkTmp^.StartPoint.y;
                      end;
                     w:=gw-FGlobalRightSize-posx;
                     h:=cofs+linkP^.LinkFromAdd;
                     linkP^.EndPoint.x:=w;
                     linkP^.EndPoint.y:=h;
                   end;
          BPGlobalLeftNodeNumber: begin
                     if (mft) then
                      cofs:=linkP^.EndPoint.y
                     else
                      begin
                       linkTmp:=GetMultipleFirst(i,False);
                       cofs:=linkTmp^.EndPoint.y;
                      end;
                     w:=FGlobalLeftSize-posx;
                     h:=cofs+linkP^.LinkFromAdd;
                     linkP^.StartPoint.x:=w;
                     linkP^.StartPoint.y:=h;
                   end;
          BPGlobalBottomNodeNumber:  begin
                     if (mft) then
                      begin
                      if ((linkP^.FromNodeNumber and BPGlobalMask)<>0) then
                      cofs:=linkP^.EndPoint.x else cofs:=linkP^.StartPoint.x;
                      end
                     else
                      begin
                       linkTmp:=GetMultipleFirst(i,False);
                       if ((linkP^.FromNodeNumber and BPGlobalMask)<>0) then
                       cofs:=linkTmp^.EndPoint.x else cofs:=linkTmp^.StartPoint.x;
                      end;
                     w:=cofs+linkP^.LinkFromAdd;
                     if FShowDataWare then
                      h:=gh-FGlobalBottomSize-FGlobalOperationSize-posy
                     else
                      h:=gh-FGlobalBottomSize-posy;
                     if ((linkP^.FromNodeNumber and BPGlobalMask)<>0) then
                      begin
                        linkP^.StartPoint.x:=w;
                        linkP^.StartPoint.y:=h;
                      end
                      else
                       begin
                        linkP^.EndPoint.x:=w;
                        linkP^.EndPoint.y:=h;
                       end;
                   end;
          BPGlobalNodeInProcess: begin
                                  if linkP^.Visible then
                                   begin
                                    { Search for IPGraphNode }
                                    if ((linkP^.dwFlags and BP_FROMTOMASK)=BP_RIGHT_LEFT) then
                                      begin
                                       if (mft) then
                                         cofs:=linkP^.EndPoint.y
                                       else
                                        begin
                                         linkTmp:=GetMultipleFirst(i,False);
                                         cofs:=linkTmp^.EndPoint.y;
                                        end;
                                       LinkP^.StartPoint.x:=FGlobalLeftSize-posx;
                                       linkP^.StartPoint.y:=cofs+linkP^.LinkFromAdd;
                                      end
                                    else
                                    if ((linkP^.dwFlags and BP_FROMMASK)=BP_FROMNODE_BOTTOM) then
                                      begin
                                        if (mft) then
                                          cofs:=linkP^.EndPoint.x
                                        else
                                         begin
                                          linkTmp:=GetMultipleFirst(i,False);
                                          cofs:=linkTmp^.EndPoint.x;
                                         end;
                                        LinkP^.StartPoint.x:=cofs+linkP^.LinkFromAdd;
                                        LinkP^.StartPoint.y:=FGlobalTopSize-posy;
                                      end
                                    else
                                      begin
                                       if (mft) then
                                        begin
                                          cofs:=linkP^.EndPoint.x;
                                        end
                                       else
                                        begin
                                         linkTmp:=GetMultipleFirst(i,False);
                                         cofs:=linkTmp^.EndPoint.x;
                                        end;
                                       if FShowDataWare then
                                         h:=gh-FGlobalBottomSize-FGlobalOperationSize-posy
                                       else
                                         h:=gh-FGlobalBottomSize-posy;
                                       LinkP^.StartPoint.x:=cofs+linkP^.LinkFromAdd;
                                       LinkP^.StartPoint.y:=h;
                                      end;
                                   end;
                                 end;
          BPGlobalNodeOperation: begin
                     if linkP^.Visible then
                     begin
                      if ((linkP^.FromNodeNumber and BPGlobalMask)<>0) then
                       begin
                         gdnode:=GetDGraphNumberedNode(linkp^.ToNodeNumber);
                         if (gdnode<>nil) then
                          begin
                         linkP^.EndPoint.x:= gdnode.Left +
                         (gdnode.Width div (gdnode.TopLinksCount+1))*linkp^.LinkFromCount;
                         linkp^.StartPoint.x:=linkp^.EndPoint.x;
                         linkp^.StartPoint.y:=gdnode.Top;
                         linkp^.EndPoint.y:=FDefHeight-FGlobalOperationSize-posy;
                          end;
                       end
                      else
                       begin
                         gdnode:=GetDGraphNumberedNode(linkp^.FromNodeNumber);
                         if (gdnode<>nil) then
                          begin
                         linkp^.StartPoint.x:=gdnode.Left +
                         (gdnode.Width div (gdnode.TopLinksCount+1))*linkp^.LinkToCount;
                         linkp^.EndPoint.x:=linkp^.StartPoint.x;
                         linkp^.EndPoint.y:=gdnode.Top;
                         linkp^.StartPoint.y:=FDefHeight-FGlobalOperationSize-posy;
                          end;
                       end;
                     end
                     else
                     begin
                       linkP^.StartPoint.x:=0;
                       linkP^.StartPoint.y:=0;
                       linkP^.EndPoint.x:=0;
                       linkP^.EndPoint.y:=0;
                     end;
                   end;
          BPGlobalTopNodeNumber: begin
                     if (mft) then
                      cofs:=linkP^.EndPoint.x
                     else
                      begin
                       linkTmp:=GetMultipleFirst(i,False);
                       cofs:=linkTmp^.EndPoint.x;
                      end;
                     w:=cofs+linkP^.LinkFromAdd;
                     h:=FGlobalTopSize-posy;
                     linkP^.StartPoint.x:=w;
                     linkP^.StartPoint.y:=h;
                   end;
         end;
         case (linkP^.ToNodeNumber and BPGlobalMask) of
          BPGlobalRightNodeNumber: begin
                     if (mff) then
                      cofs:=linkP^.StartPoint.y
                     else
                      begin
                       linkTmp:=GetMultipleFirst(i,True);
                       cofs:=linkTmp^.StartPoint.y;
                      end;
                     w:=gw-FGlobalRightSize-posx;
                     h:=cofs+linkP^.LinkToAdd;
                     linkP^.EndPoint.x:=w;
                     linkP^.EndPoint.y:=h;
                   end;
          BPGlobalLeftNodeNumber: begin
                     if (mff) then
                      cofs:=linkP^.EndPoint.y
                     else
                      begin
                       linkTmp:=GetMultipleFirst(i,True);
                       cofs:=linkTmp^.EndPoint.y;
                      end;
                     w:=FGlobalLeftSize-posx;
                     h:=cofs+linkP^.LinkToAdd;
                     linkP^.StartPoint.x:=w;
                     linkP^.StartPoint.y:=h;
                   end;
          BPGlobalBottomNodeNumber:  begin
                     w1:=gw div (FGlobalBottomLinksCount+1);
                     if (mff) then
                      begin
                      if ((linkP^.FromNodeNumber and BPGlobalMask)<>0) then
                      cofs:=linkP^.EndPoint.x else cofs:=linkP^.StartPoint.x;
                      end
                     else
                      begin
                       linkTmp:=GetMultipleFirst(i,True);
                       if ((linkP^.FromNodeNumber and BPGlobalMask)<>0) then
                       cofs:=linkTmp^.EndPoint.x else cofs:=linkTmp^.StartPoint.x;
                      end;
                     w:=cofs+linkP^.LinkToAdd;
                     if FShowDataWare then
                      h:=gh-FGlobalBottomSize-FGlobalOperationSize-posy
                     else
                      h:=gh-FGlobalBottomSize-posy;
                     if ((linkP^.FromNodeNumber and BPGlobalMask)<>0) then
                      begin
                        linkP^.StartPoint.x:=w;
                        linkP^.StartPoint.y:=h;
                      end
                      else
                       begin
                        linkP^.EndPoint.x:=w;
                        linkP^.EndPoint.y:=h;
                       end;
                   end;
          BPGlobalNodeInProcess: begin
                                  if linkP^.Visible then
                                   begin
                                    { Search for IPGraphNode }
                                    if ((linkP^.dwFlags and BP_FROMTOMASK)=BP_RIGHT_LEFT) then
                                      begin
                                       if (mff) then
                                        cofs:=linkP^.StartPoint.y
                                       else
                                        begin
                                         linkTmp:=GetMultipleFirst(i,True);
                                         cofs:=linkTmp^.StartPoint.y;
                                        end;
                                       LinkP^.EndPoint.x:=gw-FGlobalRightSize-posx;
                                       linkP^.EndPoint.y:=cofs+linkP^.LinkToAdd;
                                      end;
                                   end;
                                 end;

          BPGlobalNodeOperation: begin
                      if linkP^.Visible then
                      begin
                      if ((linkP^.ToNodeNumber and BPGlobalMask)<>0) then
                       begin
                         gdnode:=GetDGraphNumberedNode(linkp^.FromNodeNumber);
                         if gdnode<>nil then
                         begin
                         linkp^.StartPoint.x:=gdnode.Left+
                          (gdnode.Width div (gdnode.TopLinksCount+1))*linkp^.LinkToCount;
                         linkp^.StartPoint.y:=FDefHeight-FGlobalOperationSize-posy;
                         linkp^.EndPoint.y:=gdnode.Top;
                         linkp^.EndPoint.x:=linkp^.StartPoint.x;
                         end;
                       end
                      else
                       begin
                         gdnode:=GetDGraphNumberedNode(linkp^.ToNodeNumber);
                         if gdnode<>nil then
                         begin
                         linkp^.EndPoint.x:=gdnode.Left+
                          (gdnode.Width div (gdnode.TopLinksCount+1))*linkp^.LinkFromCount;
                         linkp^.EndPoint.y:=FDefHeight-FGlobalOperationSize-posy;
                         linkp^.StartPoint.y:=gdnode.Top;
                         linkp^.StartPoint.x:=linkp^.EndPoint.x;
                         end;
                       end;
                      end
                      else
                      begin
                       linkP^.StartPoint.x:=0;
                       linkP^.StartPoint.y:=0;
                       linkP^.EndPoint.x:=0;
                       linkP^.EndPoint.y:=0;
                      end;
                   end;
          BPGlobalTopNodeNumber: begin
                     if (mff) then
                      cofs:=linkP^.EndPoint.x
                     else
                      begin
                       linkTmp:=GetMultipleFirst(i,True);
                       cofs:=linkTmp^.EndPoint.x;
                      end;
                     w:=cofs+linkP^.LinkToAdd;
                     h:=FGlobalTopSize-posy;
                     linkP^.StartPoint.x:=w;
                     linkP^.StartPoint.y:=h;
                   end;
         end;
      end;
      end; {linkP^.Visible }
     end; { For }
  end;


procedure   TBPGraph.CorrectLinks; { Checked }
 Var    linkP:PGraphLink;
        gnode:TBPGraphNode;
        i:Integer;
 begin
    if (FNodesCount=0) then Exit;
    if (FLinksCount=0) then Exit;
    for i:=0 to (FLinksCount-1) do
     begin
       linkP:=GetGraphLink(i);
       if linkP^.Visible then
       begin
       if ((linkP^.FromNodeNumber and BPGlobalNodeOperation)=0) then
       begin
       gnode:=GetGraphNumberedNode(linkP^.FromNodeNumber);
        if (gnode<>nil) then
          begin
            case (linkP^.dwFlags and BP_FROMMASK) of
             BP_FROMNODE_LEFT:   if gnode.LeftLinksCount=0 then gnode.LeftLinksCount:=1;
             BP_FROMNODE_RIGHT:  if gnode.RightLinksCount=0 then gnode.RightLinksCount:=1;
             BP_FROMNODE_TOP:    if gnode.TopLinksCount=0 then gnode.TopLinksCount:=1;
             BP_FROMNODE_BOTTOM: if gnode.BottomLinksCount=0 then gnode.BottomLinksCount:=1;
            end;
          end;
       end;
       if ((linkP^.ToNodeNumber and BPGlobalNodeOperation)=0) then
       begin
       gnode:=GetGraphNumberedNode(linkP^.ToNodeNumber);
        if (gnode<>nil) then
          begin
            case (linkP^.dwFlags and BP_TOMASK) of
             BP_TONODE_LEFT:   if gnode.LeftLinksCount=0 then gnode.LeftLinksCount:=1;
             BP_TONODE_RIGHT:  if gnode.RightLinksCount=0 then gnode.RightLinksCount:=1;
             BP_TONODE_TOP:    if gnode.TopLinksCount=0 then gnode.TopLinksCount:=1;
             BP_TONODE_BOTTOM: if gnode.BottomLinksCount=0 then gnode.BottomLinksCount:=1;
            end;
          end;
       end;
       end; { LinkP^.Visible }
     end; { For }
 end;

procedure   TBPGraph.TraceLinks;  { Checked }
 Var    linkP:PGraphLink;
        i:Integer;
        sx,sy:Integer;
        ex,ey:Integer;
        hw,hh:Integer;
        fc,tc,fcd,fcu,tcd,tcu:DWORD;
        fgc,tgc:DWORD;
        gnode:TBPGraphNode;
        tx,ty:Integer;
        mfx,mtx,mty,mfy:Integer;
        nfcd,ntcd:DWORD;
        lineWidth:Integer;
        hhh:Integer;
        mm:TBPMultipleMask;
        mft,mff:Boolean;
        fcmtb,tcmtb:Integer;
  begin
    if (FNodesCount=0) then Exit;
    if (FLinksCount=0) then Exit;
    gnode:=GetGraphNode(0);
    hw:=gnode.Width div 2;
    hh:=gnode.Height div 2;
    { new code }
    if FMultipleTopLinksCount>0 then
      FMinTopSize:=Round(FMinTopSize/(FMultipleTopLinksCount+2));
    if FMultipleBottomLinksCount>0 then
      FMinBottomSize:=Round(FMinBottomSize/(FMultipleBottomLinksCount+2));
    { end new code}
    for i:=0 to (FLinksCount-1) do
     begin
       linkP:=GetGraphLink(i);
       if linkP^.Visible then
       begin
       mm:=GetMultipleMask(i);
       mff:=IsMultipleFirst(i,True);
       mft:=IsMultipleFirst(i,False);
       sx:=linkP^.StartPoint.X;
       sy:=linkP^.StartPoint.Y;
       ex:=linkP^.EndPoint.X;
       ey:=linkP^.EndPoint.Y;
       fc:=linkP^.LinkFromCount;
       tc:=linkP^.LinkToCount;
       fcmtb:=LinkP^.LinkFromCountMTB;
       tcmtb:=LinkP^.LinkToCountMTB;
       fcu:=linkP^.LinkFromUpCount;
       tcu:=linkP^.LinkToUpCount;
       fcd:=linkP^.LinkFromDownCount;
       tcd:=linkP^.LinkToDownCount;
       mtx:=linkP^.MinimalXTo;
       mfx:=linkP^.MinimalXFrom;
       mty:=linkP^.MinimalYTo;
       mfy:=linkP^.MinimalYFrom;
       if linkP^.StartPoint.y<linkP^.EndPoint.y then fgc:=fcd else fgc:=fcu;
       if linkP^.StartPoint.y<linkP^.EndPoint.y then tgc:=tcd else tgc:=tcu;
       { Set First dot }
       linkP^.LineArrayX[0]:=sx;
       linkP^.LineArrayY[0]:=sy;
       linkP^.LinePointCount:=1;
       case (linkP^.dwFlags and BP_FROMTOMASK) of
        BP_RIGHT_LEFT: begin
                         { Main In-Out link }
                           if (ex-sx)>=0 then
                             begin
                                    {    }
                                    if (((linkP^.ToNodeNumber and BPGlobalRightNodeNumber)<>0) or
                                       ((linkP^.FromNodeNumber and BPGlobalLeftNodeNumber)<>0)) or
                                       (((linkP^.ToNodeNumber and BPGlobalNodeInProcess)<>0) or
                                       ((linkP^.FromNodeNumber and BPGlobalNodeInProcess)<>0)) then
                                     begin
                                      {    }
                                      if ((mm=bpmm_None) or
                                         (mft and mff)) then
                                       begin
                                        { From or To =  Global
                                          SimpleLink or MultipleFirst }
                                        linkP^.LineArrayX[1]:=ex;
                                        linkP^.LineArrayY[1]:=ey;
                                        linkP^.LinePointCount:=2;
                                       end
                                      else
                                       begin
                                        {   }
                                        if ((linkP^.FromNodeNumber and BPGlobalMask)<>0) then
                                         begin
                                         { From  =  Global
                                           not SimpleLink and not MultipleFirst }
                                        linkP^.LineArrayX[1]:=sx+MinLineStep*fc;
                                        linkP^.LineArrayY[1]:=sy;
                                        linkP^.LineArrayX[2]:=sx+MinLineStep*fc;
                                        linkP^.LineArrayY[2]:=ey;
                                        linkP^.LineArrayX[3]:=ex;
                                        linkP^.LineArrayY[3]:=ey;
                                        linkP^.LinePointCount:=4;
                                         end
                                        else
                                         begin
                                         { To  =  Global
                                           not SimpleLink and not MultipleFirst }
                                         if ((linkP^.ToNodeNumber and BPGlobalMask)=BPGlobalNodeInProcess) then
                                          begin
                                           linkP^.LineArrayX[1]:=sx+MinLineStep*fgc;
                                           linkP^.LineArrayY[1]:=sy;
                                           linkP^.LineArrayX[2]:=sx+MinLineStep*fgc;
                                           linkP^.LineArrayY[2]:=ey;
                                           linkP^.LineArrayX[3]:=ex;
                                           linkP^.LineArrayY[3]:=ey;
                                           linkP^.LinePointCount:=4;
                                          end            
                                         else
                                          begin
                                           linkP^.LineArrayX[1]:=sx+MinLineStep*fgc;
                                           linkP^.LineArrayY[1]:=sy;
                                           linkP^.LineArrayX[2]:=sx+MinLineStep*fgc;
                                           linkP^.LineArrayY[2]:=ey;
                                           linkP^.LineArrayX[3]:=ex;
                                           linkP^.LineArrayY[3]:=ey;
                                           linkP^.LinePointCount:=4;
                                          end;
                                        end;
                                       end;
                                     end
                                     else
                                      begin
                                      { From  =  Local and To = Local  Direct Link }
                                     { -|_   }
                                      if ((ey-sy)>=0) then
                                        begin
                                         linkP^.LineArrayX[1]:=ex-MinLineStep-mtx*(tcu-1);
                                         linkP^.LineArrayY[1]:=sy;
                                         linkP^.LineArrayX[2]:=ex-MinLineStep-mtx*(tcu-1);
                                         linkP^.LineArrayY[2]:=ey;
                                         linkP^.LineArrayX[3]:=ex;
                                         linkP^.LineArrayY[3]:=ey;
                                         linkP^.LinePointCount:=4;
                                        end
                                      else
                                        begin
                                         {_|-   }
                                         linkP^.LineArrayX[1]:=ex-MinLineStep-mtx*(tcd-1);
                                         linkP^.LineArrayY[1]:=sy;
                                         linkP^.LineArrayX[2]:=ex-MinLineStep-mtx*(tcd-1);
                                         linkP^.LineArrayY[2]:=ey;
                                         linkP^.LineArrayX[3]:=ex;
                                         linkP^.LineArrayY[3]:=ey;
                                         linkP^.LinePointCount:=4;
                                        end;
                                     end;
                             end
                            else
                             begin
                              {    -    }
                                if ((ey-sy)>=0) then
                                 begin
                                  gnode:=GetGraphNumberedNode(linkP^.FromNodeNumber);
                                  hh:=gnode.Height div 2;
                                  nfcd:=gnode.FromDownLinksCount-fcd+1;
                                 { ty:=gnode.Top+gnode.Height;}
                                  gnode:=GetGraphNumberedNode(linkP^.ToNodeNumber);
                                  ntcd:=gnode.ToUpLinksCount-tcu+1;
                                  ty:=gnode.Top+gnode.Height;
                                  linkP^.LineArrayX[1]:=sx+MinLineStep*fc;
                                  linkP^.LineArrayY[1]:=sy;
                                  linkP^.LineArrayX[2]:=sx+MinLineStep*fc;
                                  linkP^.LineArrayY[2]:=ty+hh+MinLineStep+tcu*(mty-1){fcd}+1;
                                  linkP^.LineArrayX[3]:=ex-MinLineStep-mtx*(ntcd+1);
                                  linkP^.LineArrayY[3]:=ty+hh+MinLineStep+tcu*(mty-1){fcd}+1;
                                  linkP^.LineArrayX[4]:=ex-MinLineStep-mtx*(ntcd+1);
                                  linkP^.LineArrayY[4]:=ey;
                                  linkP^.LineArrayX[5]:=ex;
                                  linkP^.LineArrayY[5]:=ey;
                                  linkP^.LinePointCount:=6;
                                 end
                                else
                                 begin
                                  { 2 - ey<sy     -    }
                                  gnode:=GetGraphNumberedNode(linkP^.FromNodeNumber);
                                  hh:=gnode.Height div 2;
                                  nfcd:=gnode.FromDownLinksCount-fcd+1;
                                  ty:=gnode.Top+gnode.Height;
                                  gnode:=GetGraphNumberedNode(linkP^.ToNodeNumber);
                                  if gnode=nil then
                                    begin
                                     linkP^.LineArrayX[1]:=ex;
                                     linkP^.LineArrayY[1]:=ey;
                                     linkP^.LinePointCount:=2;
                                     Exit;
                                    end;
                                  ntcd:=gnode.ToDownLinksCount-tcd+1;
                                 { ty:=gnode.Top+gnode.Height;}
                                  linkP^.LineArrayX[1]:=sx+MinLineStep+mfx*(nfcd-1);
                                  linkP^.LineArrayY[1]:=sy;
                                  linkP^.LineArrayX[2]:=sx+MinLineStep+mfx*(nfcd-1);
                                  linkP^.LineArrayY[2]:=ty+hh+MinLineStep-fcd*(mfy-1){fcd}+1;
                                  linkP^.LineArrayX[3]:=ex-MinLineStep-mtx*(ntcd+1);
                                  linkP^.LineArrayY[3]:=ty+hh+MinLineStep-fcd*(mfy-1){fcd}+1;
                                  linkP^.LineArrayX[4]:=ex-MinLineStep-mtx*(ntcd+1);
                                  linkP^.LineArrayY[4]:=ey;
                                  linkP^.LineArrayX[5]:=ex;
                                  linkP^.LineArrayY[5]:=ey;
                                  linkP^.LinePointCount:=6;
                                 end;
                             end;
                       end;

        BP_RIGHT_TOP:  begin
                         { Out to upravlenie }
                        if (ex-sx)>=0 then
                          begin
                           if ((ey-sy)>=0) then
                            {   }
                            begin
                             linkP^.LineArrayX[1]:=ex;
                             linkP^.LineArrayY[1]:=sy;
                             linkP^.LineArrayX[2]:=ex;
                             linkP^.LineArrayY[2]:=ey;
                             linkP^.LinePointCount:=3;
                            end
                           else
                            begin
                             gnode:=GetGraphNumberedNode(linkP^.ToNodeNumber);
                             ntcd:=gnode.ToDownLinksCount-tcd+1;
                             linkP^.LineArrayX[1]:=gnode.Left-MinLineStep-mtx*(ntcd+1);
                             linkP^.LineArrayY[1]:=sy;
                             linkP^.LineArrayX[2]:=gnode.Left-MinLineStep-mtx*(ntcd+1);
                             linkP^.LineArrayY[2]:=ey-MinLineStep-mtx*(ntcd+1);
                             linkP^.LineArrayX[3]:=ex;
                             linkP^.LineArrayY[3]:=ey-MinLineStep-mtx*(ntcd+1);
                             linkP^.LineArrayX[4]:=ex;
                             linkP^.LineArrayY[4]:=ey;
                             linkP^.LinePointCount:=5;
                            end;
                          end
                         else
                          begin
                           gnode:=GetGraphNumberedNode(linkP^.FromNodeNumber);
                           nfcd:=gnode.FromUpLinksCount-fcu+1;
                           linkP^.LineArrayX[1]:=sx+MinLineStep+mfx*(fc-1){u};
                           linkP^.LineArrayY[1]:=sy;
                           linkP^.LineArrayX[2]:=sx+MinLineStep+mfx*(fc-1){u};
                           linkP^.LineArrayY[2]:=ey-MinLineStep*tc;
                           linkP^.LineArrayX[3]:=ex;
                           linkP^.LineArrayY[3]:=ey-MinLineStep*tc;
                           linkP^.LineArrayX[4]:=ex;
                           linkP^.LineArrayY[4]:=ey;
                           linkP^.LinePointCount:=5;
                          end;
                       end;
        BP_RIGHT_BOTTOM:begin
                         { Out to mechnism }
                           if (ex-sx)>=0 then
                            begin
                             {   ey>sy }
                             if ((ey-sy)>=0) then
                              begin
                               gnode:=GetGraphNumberedNode(linkP^.FromNodeNumber);
                               nfcd:=gnode.FromDownLinksCount-fcd+1;
                               linkP^.LineArrayX[1]:=sx+MinLineStep+mfx*(nfcd-1);
                               linkP^.LineArrayY[1]:=sy;
                               linkP^.LineArrayX[2]:=sx+MinLineStep+mfx*(nfcd-1);
                               linkP^.LineArrayY[2]:=ey+mtx*tcu;
                               linkP^.LineArrayX[3]:=ex;
                               linkP^.LineArrayY[3]:=ey+mtx*tcu;
                               linkP^.LineArrayX[4]:=ex;
                               linkP^.LineArrayY[4]:=ey;
                               linkP^.LinePointCount:=5;
                              end
                             else
                              begin
                               {   ey<sy }
                               linkP^.LineArrayX[1]:=ex;
                               linkP^.LineArrayY[1]:=sy;
                               linkP^.LineArrayX[2]:=ex;
                               linkP^.LineArrayY[2]:=ey;
                               linkP^.LinePointCount:=3;
                              end;
                            end
                           else
                            begin
                             {   }
                             if ((ey-sy)>=0) then
                              begin
                               gnode:=GetGraphNumberedNode(linkP^.FromNodeNumber);
                               hhh:=(gnode.Height div 4)*3;
                               ty:=gnode.Top+gnode.Height;
                               nfcd:=gnode.FromDownLinksCount-fcd+1;
                               linkP^.LineArrayX[1]:=sx+MinLineStep+mfx*(nfcd-1);
                               linkP^.LineArrayY[1]:=sy;
                               linkP^.LineArrayX[2]:=sx+MinLineStep+mfx*(nfcd-1);
                               linkP^.LineArrayY[2]:=ey+hh-tc*(mfy-1)+1;
                               linkP^.LineArrayX[3]:=ex;
                               linkP^.LineArrayY[3]:=ey+hh-tc*(mfy-1)+1;
                               linkP^.LineArrayX[4]:=ex;
                               linkP^.LineArrayY[4]:=ey;
                               linkP^.LinePointCount:=5;
                              end
                             else
                              begin
                               gnode:=GetGraphNumberedNode(linkP^.FromNodeNumber);
                               hhh:=(gnode.Height div 4)*3;
                               ty:=gnode.Top+gnode.Height;
                               nfcd:=gnode.FromDownLinksCount-fcd+1;
                               linkP^.LineArrayX[1]:=sx+MinLineStep+mfx*(nfcd-1);
                               linkP^.LineArrayY[1]:=sy;
                               linkP^.LineArrayX[2]:=sx+MinLineStep+mfx*(nfcd-1);
                               linkP^.LineArrayY[2]:=ty+hh-fcd*(mfy-1)+1;
                               linkP^.LineArrayX[3]:=ex;
                               linkP^.LineArrayY[3]:=ty+hh-fcd*(mfy-1)+1;
                               linkP^.LineArrayX[4]:=ex;
                               linkP^.LineArrayY[4]:=ey;
                               linkP^.LinePointCount:=5;
                              end;
                            end;
                        end;
        BP_TOP_BOTTOM: begin
                         { Main mechanism link only global }
                         if ((LinkP^.FromNodeNumber and BPGlobalNodeOperation)<>0) or
                            ((LinkP^.ToNodeNumber and BPGlobalNodeOperation)<>0) then
                            begin
                             linkP^.LineArrayX[1]:=ex;
                             linkP^.LineArrayY[1]:=ey;
                             linkP^.LinePointCount:=2;
                            end
                         else
                         begin
                         if (mm<>bpmm_None) and
                            ((not(mft)) or (not(mff))) then
                            begin
                           linkP^.LineArrayX[1]:=sx;
                           linkP^.LineArrayY[1]:=sy-(FNodeHeight div 2)-(fcmtb+1)*FMinBottomSize{-2*MinLineStep*(fc+1)};
                           linkP^.LineArrayX[2]:=ex;
                           linkP^.LineArrayY[2]:=sy-(FNodeHeight div 2)-(fcmtb+1)*FMinBottomSize{-2*MinLineStep*(fc+1)};
                           linkP^.LineArrayX[3]:=ex;
                           linkP^.LineArrayY[3]:=ey;
                           linkP^.LinePointCount:=4;
                           end
                           else
                            begin
                             linkP^.LineArrayX[1]:=ex;
                             linkP^.LineArrayY[1]:=ey;
                             linkP^.LinePointCount:=2;
                            end;
                         end; { NodeOperation }
                       end;
        BP_BOTTOM_TOP: begin
                          { Upravlenie, mehanism out only global }
                         if ((LinkP^.FromNodeNumber and BPGlobalNodeOperation)<>0) or
                            ((LinkP^.ToNodeNumber and BPGlobalNodeOperation)<>0) then
                            begin
                             linkP^.LineArrayX[1]:=ex;
                             linkP^.LineArrayY[1]:=ey;
                             linkP^.LinePointCount:=2;
                            end
                         else
                         begin
                          if (mm<>bpmm_None) and
                            ((not(mft)) or (not(mff))) then
                            begin
                             linkP^.LineArrayX[1]:=sx;
                             linkP^.LineArrayY[1]:=sy+(FNodeHeight div 2)+FMinTopSize*(fcmtb+1){+2*MinLineStep*(fc+1)};
                             linkP^.LineArrayX[2]:=ex;
                             linkP^.LineArrayY[2]:=sy+(FNodeHeight div 2)+FMinTopSize*(fcmtb+1){+2*MinLineStep*(fc+1)};
                             linkP^.LineArrayX[3]:=ex;
                             linkP^.LineArrayY[3]:=ey;
                             linkP^.LinePointCount:=4;
                            end
                             else
                            begin
                             linkP^.LineArrayX[1]:=ex;
                             linkP^.LineArrayY[1]:=ey;
                             linkP^.LinePointCount:=2;
                            end;
                           end; { Node Operation }
                       end;
        else  begin
               { Main error link - not traced }
               linkP^.LineArrayX[1]:=ex;
               linkP^.LineArrayY[1]:=ey;
               linkP^.LinePointCount:=2;
              end;
       end;
      end { Visible link }
     else
      begin
        linkP^.LineArrayX[0]:=linkP^.StartPoint.x;
        linkP^.LineArrayY[0]:=linkP^.StartPoint.y;
        linkP^.LineArrayX[1]:=linkP^.EndPoint.x;
        linkP^.LineArrayY[1]:=linkP^.EndPoint.y;
        linkP^.LinePointCount:=2;
      end;
     end; { for links }
  end;

procedure  TBPGraph.DrawSS(sx,sy,dx,dy:Integer;color:TColor); { Checked }
  Var oldColor:TColor;
      hw:Integer;
      x1,y1,x2,y2:Integer;
      zx,zy:Integer;
      f1,f2:Double;
      normaz:Integer;
      sizex,sizey:Integer;
  begin
   { Draws SS link from point to caption }
    with FOwner.Canvas do
     begin
       oldColor:=Pen.Color;
       Pen.Color:=color;
       zx:=(dx-sx) div 2;
       zy:=(dy-sy) div 2;
       normaz:=Round(Sqrt(zx*zx+zy*zy));
       f1:=3.14/2;
       f2:=-3.14/2;
       sizex:=MinLabelX div 4;
       sizey:=sizex;
       if (normaz=0) then normaz:=1;
       if (sizex=0) then sizex:=1;
       if (sizey=0) then sizey:=1;
       x1:=Round((cos(f1)*zx+sin(f1)*zy)/normaz*sizex)+sx+zx;
       y1:=Round((cos(f1)*zy-sin(f1)*zx)/normaz*sizey)+sy+zy;
       x2:=Round((cos(f2)*zx+sin(f2)*zy)/normaz*sizex)+sx+zx;
       y2:=Round((cos(f2)*zy-sin(f2)*zx)/normaz*sizey)+sy+zy;
       MoveTo(sx,sy);
       LineTo(x1,y1);
       LineTo(x2,y2);
       LineTo(dx,dy);
       Pen.Color:=oldColor;
     end;
  end;

 procedure  TBPGraph.DrawLinks; { Checked }
  Var linkP:PGraphLink;
         i,j:Integer;
         fx,fy,lx,ly:Integer;
         dx,dy,dx1,dy1,tx,ty:Integer;
         oldColor,cl:TColor;
         k:Integer;
         mls:Integer;
         linkFromType,linkToType:TLinkType;
         lineWidth:Integer;
         s:Integer;
         ops,ps:TPenStyle;
         fnip,tnip:Boolean;
         NewMinArcRadius:Integer;
         NDelta,nd1,nd2:Integer;
         ox,oy,nx,ny:Integer;
         NewMinLabelY1FromTop,NewMinLabelY1ToBottom:Integer;
         NewMinLabelY1FromBottom,NewMinLabelY1ToTop:Integer;
Const    newcof=1.0;
  begin
   if (FLinksCount=0) then Exit;
   oldColor:=FOwner.Canvas.Pen.Color;
   ops:=FOwner.Canvas.Pen.Style;
   mls:=MinLineStep div 2;
    for i:=0 to (FLinksCount-1) do
     begin
       linkP:=GetGraphLink(i);
       if linkP^.Visible then
       begin
{    if linkP^.CorrectLink then cl:=clBlack else
       cl:=clRed;}
       fnip:=((linkp^.FromNodeNumber and BPGlobalNodeInProcess)<>0);
       tnip:=((linkp^.ToNodeNumber and BPGlobalNodeInProcess)<>0);
       cl:=LinkP^.Color;
       FOwner.Canvas.Pen.Color:=cl;
       ps:=LinkP^.PenStyle;
       FOwner.Canvas.Pen.Style:=ps;
       linkFromType:=GetLinkFrom(linkP);
       linkToType:=GetLinkTo(linkP);
       case (LinkToType) of
       lt_Left: begin
                 DrawArrowX(linkP^.EndPoint.x,linkP^.EndPoint.y,False);
               end;
       lt_Top: begin
                 DrawArrowY(linkP^.EndPoint.x,linkP^.EndPoint.y,False);
               end;
       lt_Bottom: begin
                 DrawArrowY(linkP^.EndPoint.x,linkP^.EndPoint.y,True);
               end;
       end;
       FOwner.Canvas.Pen.Color:=cl;
       FOwner.Canvas.Pen.Style:=ps;
       case (LinkFromType) of
        lt_Right: begin
                   if ((linkP^.dwFlags and BP_SHOW_FROMCAPTION)<>0) and
                        (linkP^.BPFromLabel<>nil) then
                   begin
                   if ((linkP^.FromNodeNumber and BPGlobalMask)<>0) then
                    begin
                     if FDiscardDrags or (not(linkP^.BPFromLabel.AcceptPosition)) then
                      begin
                       linkP^.BPFromLabel.Left:=linkP^.StartPoint.x+MinLabelX+MLS;
                       linkP^.BPFromLabel.Top:=linkP^.StartPoint.y-MinLabelYNew-linkP^.BPFromLabel.Height;
                       linkP^.BPFromLabel.AcceptPosition:=False;
                       DrawSS(linkP^.StartPoint.x+2+MLS,linkP^.StartPoint.y-1,linkP^.StartPoint.x+MinLabelX-1+MLS,linkP^.StartPoint.y-(linkP^.BPFromLabel.Height div 2)-MinLabelYNew,cl);
                      end
                       else
                       DrawSS(linkP^.StartPoint.x+2+MLS,
                              linkP^.StartPoint.y-1,
                              linkP^.BPFromLabel.Left-1+MLS,
                              linkP^.BPFromLabel.Top+(linkP^.BPFromLabel.Height div 2),
                              cl);
                    end
                   else
                    begin
                     if FDiscardDrags or (not(linkP^.BPFromLabel.AcceptPosition)) then
                      begin
                       linkP^.BPFromLabel.Left:=linkP^.StartPoint.x+MinLabelX;
                       linkP^.BPFromLabel.Top:=linkP^.StartPoint.y-MinLabelYNew-linkP^.BPFromLabel.Height;
                       linkP^.BPFromLabel.AcceptPosition:=False;
                       DrawSS(linkP^.StartPoint.x+2,linkP^.StartPoint.y-1,linkP^.StartPoint.x+MinLabelX-1,linkP^.StartPoint.y-(linkP^.BPFromLabel.Height div 2)-MinLabelYNew,cl);
                      end
                       else
                       DrawSS(linkP^.StartPoint.x+2,
                              linkP^.StartPoint.y-1,
                              linkP^.BPFromLabel.Left-1,
                              linkP^.BPFromLabel.Top+(linkP^.BPFromLabel.Height div 2),
                              cl);
                    end;
                   end;
                  end;
        lt_Top:   begin
                   if ((linkP^.dwFlags and BP_SHOW_FROMCAPTION)<>0) and
                       (linkP^.BPFromLabel<>nil)  then
                   begin
                   NewMinLabelY1FromTop:=Round(linkP^.BPFromLabel.Height*newcof);
                   if ((linkP^.FromNodeNumber and BPGlobalNodeOperation)<>0) then
                   begin
                    if FDiscardDrags or (not(linkP^.BPFromLabel.AcceptPosition)) then
                      begin
                       linkP^.BPFromLabel.Left:=linkP^.StartPoint.x+MinLabelX;
                       linkP^.BPFromLabel.Top:=linkP^.StartPoint.y-MinLabelY3-MinLabelY2*(linkP^.LinkFromCount-1)-linkP^.BPFromLabel.Height;
                       linkP^.BPFromLabel.AcceptPosition:=False;
                       DrawSS(linkP^.StartPoint.x+1,linkP^.StartPoint.y-MinLabelY3-MinLabelY2*(linkP^.LinkFromCount-1)-(linkP^.BPFromLabel.Height div 2),
                          linkP^.BPFromLabel.Left-1,linkP^.BPFromLabel.Top+(linkP^.BPFromLabel.Height div 2),cl);
                      end
                     else
                       DrawSS(linkP^.StartPoint.x+1,
                       linkP^.StartPoint.y-MinLabelY3-MinLabelY2*(linkP^.LinkFromCount-1)-(linkP^.BPFromLabel.Height div 2),
                          linkP^.BPFromLabel.Left-1,
                          linkP^.BPFromLabel.Top+(linkP^.BPFromLabel.Height div 2),
                          cl);
                   end
                   else
                   begin
                   if FDiscardDrags or (not(linkP^.BPFromLabel.AcceptPosition)) then
                      begin
                       linkP^.BPFromLabel.Left:=linkP^.StartPoint.x+MinLabelX;
                       linkP^.BPFromLabel.Top:=linkP^.StartPoint.y-MinLabelY-NewMinLabelY1FromTop*(linkP^.LinkFromCount-1)-linkP^.BPFromLabel.Height;
                       linkP^.BPFromLabel.AcceptPosition:=False;
                       DrawSS(linkP^.StartPoint.x+1,linkP^.StartPoint.y-MinLabelY-NewMinLabelY1FromTop*(linkP^.LinkFromCount-1)-(linkP^.BPFromLabel.Height div 2),
                          linkP^.BPFromLabel.Left-1,linkP^.BPFromLabel.Top+(linkP^.BPFromLabel.Height div 2),cl);
                      end
                     else
                       DrawSS(linkP^.StartPoint.x+1,
                       linkP^.StartPoint.y-MinLabelY-NewMinLabelY1FromTop*(linkP^.LinkFromCount-1)-(linkP^.BPFromLabel.Height div 2),
                          linkP^.BPFromLabel.Left-1,
                          linkP^.BPFromLabel.Top+(linkP^.BPFromLabel.Height div 2),
                          cl);
                   end;
                  end;
                  end;
        lt_Bottom: begin
                   if ((linkP^.dwFlags and BP_SHOW_FROMCAPTION)<>0) and
                      (linkP^.BPFromLabel<>nil) then
                   begin
                   NewMinLabelY1FromBottom:=Round(linkP^.BPFromLabel.Height*newcof);
                   if ((linkP^.ToNodeNumber and BPGlobalNodeOperation)<>0) then
                   begin
                    if FDiscardDrags or (not(linkP^.BPFromLabel.AcceptPosition)) then
                      begin
                       linkP^.BPFromLabel.Left:=linkP^.EndPoint.x+MinLabelX;
                       linkP^.BPFromLabel.Top:=linkP^.EndPoint.y-MinLabelY3-MinLabelY2*(linkP^.LinkToCount-1)-linkP^.BPFromLabel.Height;
                       linkP^.BPFromLabel.AcceptPosition:=False;
                       DrawSS(linkP^.EndPoint.x+1,linkP^.EndPoint.y-MinLabelY3-MinLabelY2*(linkP^.LinkToCount-1)-(linkP^.BPFromLabel.Height div 2),
                              linkP^.BPFromLabel.Left-1,
                              linkP^.BPFromLabel.Top+(linkP^.BPFromLabel.Height div 2),cl);
                      end
                     else
                       DrawSS(linkP^.EndPoint.x+1,
                           linkP^.EndPoint.y-MinLabelY3-MinLabelY2*(linkP^.LinkToCount-1)-(linkP^.BPFromLabel.Height div 2),
                          linkP^.BPFromLabel.Left-1,
                          linkP^.BPFromLabel.Top+(linkP^.BPFromLabel.Height div 2),cl);

                   end
                   else
                   begin
                    if FDiscardDrags or (not(linkP^.BPFromLabel.AcceptPosition)) then
                      begin
                       linkP^.BPFromLabel.Left:=linkP^.StartPoint.x+MinLabelX;
                       linkP^.BPFromLabel.Top:=linkP^.StartPoint.y+NewMinLabelY1FromBottom*(linkP^.LinkFromCount-1)+MinLabelY;
                       linkP^.BPFromLabel.AcceptPosition:=False;
                       DrawSS(linkP^.StartPoint.x+1,linkP^.StartPoint.y+MinLabelY+NewMinLabelY1FromBottom*(linkP^.LinkFromCount-1)+(linkP^.BPFromLabel.Height div 2),
                              linkP^.BPFromLabel.Left-1,
                            linkP^.BPFromLabel.Top+(linkP^.BPFromLabel.Height div 2),cl);
                      end
                     else
                      DrawSS(linkP^.StartPoint.x+1,
                             linkP^.StartPoint.y+MinLabelY+NewMinLabelY1FromBottom*(linkP^.LinkFromCount-1)+(linkP^.BPFromLabel.Height div 2),
                          linkP^.BPFromLabel.Left-1,
                          linkP^.BPFromLabel.Top+(linkP^.BPFromLabel.Height div 2),
                          cl);
                    end;
                   end;
                  end;

        end;
       case (LinkToType) of
        lt_Left: begin
                   if ((linkP^.dwFlags and BP_SHOW_TOCAPTION)<>0) and
                      (linkP^.BPToLabel<>nil) then
                   begin
                   if ((linkP^.ToNodeNumber and BPGlobalMask)<>0) then
                    begin
                     if FDiscardDrags or (not(linkP^.BPToLabel.AcceptPosition)) then
                      begin
                       linkP^.BPToLabel.Left:=linkP^.EndPoint.x-4-MinLabelX-linkP^.BPToLabel.Width-MLS;
                       linkP^.BPToLabel.Top:=linkP^.EndPoint.y-MinLabelYNew-linkP^.BPToLabel.Height;
                       linkP^.BPToLabel.AcceptPosition:=False;
                       DrawSS(linkP^.EndPoint.x-5-MLS,linkP^.EndPoint.y-2,
                          linkP^.EndPoint.x-4-MinLabelX+1-MLS,linkP^.EndPoint.y-MinLabelYNew-((linkP^.BPToLabel.Height) div 2),cl);
                      end
                      else
                        DrawSS(linkP^.EndPoint.x-5-MLS,
                               linkP^.EndPoint.y-2,
                                linkP^.BPToLabel.Left+linkP^.BPToLabel.Width-3-MLS,
                                linkP^.BPToLabel.Top+((linkP^.BPToLabel.Height) div 2),
                                cl);
                    end
                   else
                   begin
                    if FDiscardDrags or (not(linkP^.BPToLabel.AcceptPosition)) then
                      begin
                       linkP^.BPToLabel.Left:=linkP^.EndPoint.x-4-MinLabelX-linkP^.BPToLabel.Width;
                       linkP^.BPToLabel.Top:=linkP^.EndPoint.y-MinLabelYNew-linkP^.BPToLabel.Height;
                       linkP^.BPToLabel.AcceptPosition:=False;
                       DrawSS(linkP^.EndPoint.x-5,linkP^.EndPoint.y-2,
                          linkP^.EndPoint.x-4-MinLabelX+1,linkP^.EndPoint.y-MinLabelYNew-((linkP^.BPToLabel.Height) div 2),cl);
                      end
                     else
                       DrawSS(linkP^.EndPoint.x-5,
                              linkP^.EndPoint.y-2,
                          linkP^.BPToLabel.Left+linkP^.BPToLabel.Width+3,
                          linkP^.BPToLabel.Top+((linkP^.BPToLabel.Height) div 2),
                          cl);
                   end;
                   end;
                  end;
        lt_Top:   begin
                   if ((linkP^.dwFlags and BP_SHOW_TOCAPTION)<>0) and
                    (linkP^.BPToLabel<>nil) then
                   begin
                      NewMinLabelY1ToTop:=Round(linkP^.BPToLabel.Height*newcof);
                      if FDiscardDrags or (not(linkP^.BPToLabel.AcceptPosition)) then
                      begin
                       linkP^.BPToLabel.Left:=linkP^.EndPoint.x+MinLabelX;
                       linkP^.BPToLabel.Top:=linkP^.EndPoint.y-MinLabelY-NewMinLabelY1ToTop*(linkP^.LinkToCount-1)-linkP^.BPToLabel.Height;
                       linkP^.BPToLabel.AcceptPosition:=False;
                       DrawSS(linkP^.EndPoint.x+1,linkP^.EndPoint.y-MinLabelY-NewMinLabelY1ToTop*(linkP^.LinkToCount-1)-(linkP^.BPToLabel.Height div 2),
                              linkP^.BPToLabel.Left-1,
                          linkP^.BPToLabel.Top+(linkP^.BPToLabel.Height div 2),cl);
                      end
                     else
                       DrawSS(linkP^.EndPoint.x+1,
                           linkP^.EndPoint.y-MinLabelY-NewMinLabelY1ToTop*(linkP^.LinkToCount-1)-(linkP^.BPToLabel.Height div 2),
                          linkP^.BPToLabel.Left-1,
                          linkP^.BPToLabel.Top+(linkP^.BPToLabel.Height div 2),cl);
                   end; { Show tocaption }
                  end;  { lt_Top}
        lt_Bottom: begin
                   if ((linkP^.dwFlags and BP_SHOW_TOCAPTION)<>0) and
                    (linkP^.BPToLabel<>nil) then
                   begin
                     NewMinLabelY1ToBottom:=Round(linkP^.BPToLabel.Height*newcof);
                     if FDiscardDrags or (not(linkP^.BPToLabel.AcceptPosition)) then
                      begin
                       linkP^.BPToLabel.Top:=linkP^.EndPoint.y+MinLabelY+NewMinLabelY1ToBottom*(linkP^.LinkToCount-1);
                       linkP^.BPToLabel.Left:=linkP^.EndPoint.x+MinLabelX;
                       linkP^.BPToLabel.AcceptPosition:=False;
                       DrawSS(linkP^.EndPoint.x+1,linkP^.EndPoint.y+MinLabelY+NewMinLabelY1ToBottom*(linkP^.LinkToCount-1)+(linkP^.BPToLabel.Height div 2),
                              linkP^.BPToLabel.Left-1,
                          linkP^.BPToLabel.Top+(linkP^.BPToLabel.Height div 2),cl);
                      end
                     else
                       DrawSS(linkP^.EndPoint.x+1,
                              linkP^.EndPoint.y+MinLabelY+NewMinLabelY1ToBottom*(linkP^.LinkToCount-1)+(linkP^.BPToLabel.Height div 2),
                          linkP^.BPToLabel.Left-1,
                          linkP^.BPToLabel.Top+(linkP^.BPToLabel.Height div 2),cl);
                   end;
                  end;

        end;
        if (linkP^.BpGlobalLabel<>nil) then
        if ((linkP^.dwFlags and BP_SHOW_GLOBALCAPTION)<>0) then
         begin
           if ((linkP^.FromNodeNumber and BPGlobalMask)<>0) then
            begin
              case (linkFromType) of
                lt_Right: begin
                           linkP^.BPGlobalLabel.Left:=linkP^.StartPoint.x-linkP^.BPGlobalLabel.Width-MinGlobalLabel;
                           linkP^.BPGlobalLabel.Top:=linkP^.StartPoint.y-(linkP^.BPGlobalLabel.Height div 2);
                          end;
                lt_Bottom: begin
                           linkP^.BPGlobalLabel.Left:=linkP^.StartPoint.x-(linkP^.BPGlobalLabel.Height div 2);
                           linkP^.BPGlobalLabel.Top:=linkP^.StartPoint.y-MinGlobalLabel-linkP^.BPGlobalLabel.Height;
                           end;
                lt_Top:    begin
                           linkP^.BPGlobalLabel.Left:=linkP^.StartPoint.x-(linkP^.BPGlobalLabel.Height div 2);
                           linkP^.BPGlobalLabel.Top:=linkP^.StartPoint.y+MinGlobalLabel;
                           end;
              end;

            end
           else
            begin
              case (linkToType) of
                lt_Left:  begin
                           linkP^.BPGlobalLabel.Left:=linkP^.EndPoint.x+MinGlobalLabel;
                           linkP^.BPGlobalLabel.Top:=linkP^.EndPoint.y-(linkP^.BPGlobalLabel.Height div 2);
                          end;
                lt_Top:   begin
                           linkP^.BPGlobalLabel.Left:=linkP^.EndPoint.x-(linkP^.BPGlobalLabel.Height div 2);
                           linkP^.BPGlobalLabel.Top:=linkP^.EndPoint.y+MinGlobalLabel;
                          end;
              end;
            end;
         end;
{        if fnip then
         begin
          if ((linkP^.dwFlags and BP_FROMTOMASK)=BP_RIGHT_LEFT) then
           DrawCircle(linkP^.StartPoint.x,linkP^.StartPoint.y,MinArcRadius,-2*MinArcRadius,0)
          else
          if ((linkP^.dwFlags and BP_FROMMASK)=BP_FROMNODE_BOTTOM) then
           DrawCircle(linkP^.StartPoint.x,linkP^.StartPoint.y,MinArcRadius,0,-2*MinArcRadius)
          else
          DrawCircle(linkP^.StartPoint.x,linkP^.StartPoint.y,MinArcRadius,0,2*MinArcRadius);
         end;
        if tnip then DrawCircle(linkP^.EndPoint.x,linkP^.EndPoint.y,MinArcRadius,2*MinArcRadius,0);}
        if ((linkP^.dwFlags and BP_NOTUSED_NOW)<>0) then
         begin
           { Draw not used }
           if ((linkP^.dwFlags and BP_NOTUSED_FROM)<>0) then
            begin
             tx:=linkP^.StartPoint.x;
             ty:=linkP^.StartPoint.y;
             dx:=MinArcRadius;
             dy:=MinArcRadius;
             case (LinkFromType) of
              lt_Right: begin
                        FOwner.Canvas.Arc(tx+dx+2,ty+dy,tx-dx+2,ty-dy,tx-dx+3,ty+dy-1,tx+dx+1,ty+dy-1);
                        FOwner.Canvas.Arc(tx+dx+2,ty+dy,tx-dx+2,ty-dy,tx+dx+1,ty-dy+1,tx-dx+3,ty-dy+1);
                       end;
              lt_Left:begin
                        FOwner.Canvas.Arc(tx+dx-2,ty+dy,tx-dx-2,ty-dy,tx-dx-1,ty+dy-1,tx+dx-3,ty+dy-1);
                        FOwner.Canvas.Arc(tx+dx-2,ty+dy,tx-dx-2,ty-dy,tx+dx-3,ty-dy+1,tx-dx-1,ty-dy+1);
                       end;
              lt_Bottom:    begin
                          FOwner.Canvas.Arc(tx+dx,ty+dy+2,tx-dx,ty-dy+2,tx+dx-1,ty+dy+1,tx+dx-1,ty-dy+3);
                          FOwner.Canvas.Arc(tx+dx,ty+dy+2,tx-dx,ty-dy+2,tx-dx+1,ty-dy+3,tx-dx+1,ty+dy+1);
                         end;
              lt_Top: begin
                          FOwner.Canvas.Arc(tx+dx,ty+dy-2,tx-dx,ty-dy-2,tx+dx-1,ty+dy-3,tx+dx-1,ty-dy-1);
                          FOwner.Canvas.Arc(tx+dx,ty+dy-2,tx-dx,ty-dy-2,tx-dx+1,ty-dy-1,tx-dx+1,ty+dy-3);
                         end;
             end;
            end;
           if ((linkP^.dwFlags and BP_NOTUSED_TO)<>0) then
            begin
             tx:=linkP^.EndPoint.x;
             ty:=linkP^.EndPoint.y;
             dx:=MinArcRadius;
             dy:=MinArcRadius;
             case (LinkToType) of
              lt_Right: begin
                        FOwner.Canvas.Arc(tx+dx+2,ty+dy,tx-dx+2,ty-dy,tx-dx+3,ty+dy-1,tx+dx+1,ty+dy-1);
                        FOwner.Canvas.Arc(tx+dx+2,ty+dy,tx-dx+2,ty-dy,tx+dx+1,ty-dy+1,tx-dx+3,ty-dy+1);
                       end;
              lt_Left:begin
                        FOwner.Canvas.Arc(tx+dx-2,ty+dy,tx-dx-2,ty-dy,tx-dx-1,ty+dy-1,tx+dx-3,ty+dy-1);
                        FOwner.Canvas.Arc(tx+dx-2,ty+dy,tx-dx-2,ty-dy,tx+dx-3,ty-dy+1,tx-dx-1,ty-dy+1);
                       end;
              lt_Bottom:    begin
                          FOwner.Canvas.Arc(tx+dx,ty+dy+2,tx-dx,ty-dy+2,tx+dx-1,ty+dy+1,tx+dx-1,ty-dy+3);
                          FOwner.Canvas.Arc(tx+dx,ty+dy+2,tx-dx,ty-dy+2,tx-dx+1,ty-dy+3,tx-dx+1,ty+dy+1);
                         end;
              lt_Top: begin
                          FOwner.Canvas.Arc(tx+dx,ty+dy-2,tx-dx,ty-dy-2,tx+dx-1,ty+dy-3,tx+dx-1,ty-dy-1);
                          FOwner.Canvas.Arc(tx+dx,ty+dy-2,tx-dx,ty-dy-2,tx-dx+1,ty-dy-1,tx-dx+1,ty+dy-3);
                         end;
             end;
            end;
         end;
        FOwner.Canvas.Pen.Color:=cl;
        FOwner.Canvas.Pen.Style:=ps;
        for j:=0 to (linkP^.LinePointCount-1) do
         begin
          tx:=linkP^.LineArrayX[j];
          ty:=linkP^.LineArrayY[j];
          NewMinArcRadius:=MinArcRadius;
          if j=0 then FOwner.Canvas.MoveTo(tx,ty);
          if (j=(linkP^.LinePointCount-1)) then FOwner.Canvas.LineTo(tx,ty);
          if (j<>0) and (j<>(linkP^.LinePointCount-1)) then
           begin
            ox:=linkP^.LineArrayX[j-1];
            oy:=linkP^.LineArrayY[j-1];
            nx:=linkP^.LineArrayX[j+1];
            ny:=linkP^.LineArrayY[j+1];
            if nx=tx then
              nd1:=ABS(ny-ty)
            else
              nd1:=ABS(nx-tx);
            if ox=tx then
              nd2:=ABS(ty-oy)
            else
              nd2:=ABS(tx-ox);
            if nd1<nd2 then nDelta:=nd1 else nDelta:=nd2;
            if (NewMinArcRadius>(nDelta div 2)) then NewMinArcRadius:=nDelta div 2;
            dx:=SignedVector(linkP^.LineArrayX[j+1]-tx,NewMinArcRadius);
            dy:=SignedVector(linkP^.LineArrayY[j+1]-ty,NewMinArcRadius);
            dx1:=SignedVector(linkP^.LineArrayX[j-1]-tx,NewMinArcRadius);
            dy1:=SignedVector(linkP^.LineArrayY[j-1]-ty,NewMinArcRadius);
            if (dx*dy1-dx1*dy)>0 then
             begin
            fx:=tx+dx;
            fy:=ty+dy;
            lx:=tx+dx1;
            ly:=ty+dy1;
             end
            else
             begin
            fx:=tx+dx1;
            fy:=ty+dy1;
            lx:=tx+dx;
            ly:=ty+dy;
             end;
            FOwner.Canvas.Arc(tx+2*dx,ty+2*dy,tx+2*dx1,ty+2*dy1,fx,fy,lx,ly);
             if (dx*dy1-dx1*dy)<0 then
              begin
                 FOwner.Canvas.LineTo(fx,fy);
                 FOwner.Canvas.MoveTo(lx,ly);
              end
              else
              begin
                 FOwner.Canvas.LineTo(lx,ly);
                 FOwner.Canvas.MoveTo(fx,fy);
              end;
           end;
         end;
     end; { Visible link }
    end; { For }
    FOwner.Canvas.Pen.Color:=oldColor;
    FOwner.Canvas.Pen.Style:=ops;
  end;


 procedure   TBPGraph.TraceRoute; { Main Tracing Procedure } { Checked }
  begin
    { Lets Trace graph }
    if (FCalcWidthHeight) then Exit;      { Disable Reenter to routine }
    TraceNodes;                           { Trace Nodes }
    TraceNodesToLinksCounters;            { Hm }
    TraceLinksToNodeCounters;             { Hm }
    CorrectLinks;                         { May be it's posible }
    TraceLocalStartEndPoints;             { OK }
    CorrectGlobalLinks;
    TraceGlobalStartEndPoints;            { OK }
    { !!! New Code  }
    TraceLinksToNodeCountersUpDown;       { Not need }
    CorrectLinksToNodeCountersUpDown;
    CalcMinimalXY;                        { Not calc - define as Var }
    CalcLabelSizes;                       { Yes }
    TraceLinks;                           { Yes }
    DrawLinks;                            { Yes }
    FDiscardDrags:=False;
  end;

 function TBPGraph.GetIndexedLink(index:DWORD):PBPLink; { Checked }
  Var linkP:PBPLink;
  begin
    Result:=nil;
    if (index>=FLinksCount) then Exit;
    linkP:=FLinks;
    if (index>0) then Inc(linkP,index);
    Result:=linkP;
  end;

   procedure TBPGraph.WriteLinksToDebugFile;  { Checked }
   Var s:ShortString;
       r:Integer;
       linkP:PBPLink;
       linkt:PGraphLink;
       F:TextFile;
    begin
      system.AssignFile(f,'out.dbg');
      system.Append(f);
      for r:=0 to (FLinksCount-1) do
       begin
        linkP:=GetIndexedLink(r);
        linkt:=GetGraphLink(r);
         writeln(f,'Link N '+IntToStr(r));
        if linkP^.ssFromCaption<>'' then
         writeln(f,'FromCaption = '+linkP^.ssFromCaption);
        if linkP^.ssToCaption<>'' then
         writeln(f,'ToCaption = '+linkP^.ssToCaption);
        if linkP^.ssGlobalCaption<>'' then
         writeln(f,'GlobalCaption = '+linkP^.ssGlobalCaption);
        if ((linkP^.dwFromNodeNumber and BPGlobalMask)=0) then
           writeln(f,'From Node='+IntToStr(linkP^.dwFromNodeNumber))
         else
           begin
             case (linkP^.dwFromNodeNumber and BPGlobalMask) of
              BPGlobalLeftNodeNumber:  writeln(f,'From Node= Global Left');
              BPGlobalRightNodeNumber: writeln(f,'From Node= Global Right');
              BPGlobalTopNodeNumber:   writeln(f,'From Node= Global Top');
              BPGlobalBottomNodeNumber: writeln(f,'From Node= Global Bottom');
              BPGlobalNodeOperation: writeln(f,'From Node= Operation');
             end;
           end;
         case (linkP^.dwFLags and BP_FROMMASK) of
          BP_FROMNODE_LEFT:   writeln(f,'From node left side');
          BP_FROMNODE_TOP:    writeln(f,'From node top side');
          BP_FROMNODE_RIGHT:  writeln(f,'From node right side');
          BP_FROMNODE_BOTTOM: writeln(f,'From node bottom side');
         end;
        if ((linkP^.dwToNodeNumber and BPGlobalMask)=0) then
           writeln(f,'To Node='+IntToStr(linkP^.dwToNodeNumber))
         else
           begin
             case (linkP^.dwToNodeNumber and BPGlobalMask) of
              BPGlobalLeftNodeNumber:  writeln(f,'To Node= Global Left');
              BPGlobalRightNodeNumber: writeln(f,'To Node= Global Right');
              BPGlobalTopNodeNumber:   writeln(f,'To Node= Global Top');
              BPGlobalBottomNodeNumber: writeln(f,'To Node= Global Bottom');
              BPGlobalNodeOperation: writeln(f,'To Node= Operation');
             end;
           end;
         case (linkP^.dwFLags and BP_TOMASK) of
          BP_TONODE_LEFT:   writeln(f,'To node left side');
          BP_TONODE_TOP:    writeln(f,'To node top side');
          BP_TONODE_RIGHT:  writeln(f,'To node right side');
          BP_TONODE_BOTTOM: writeln(f,'To node bottom side');
         end;
         if ((linkP^.dwFlags and BP_NOTUSED_NOW)<>0) then   writeln(f,'Not used now');

         writeln(f,'From pos = '+IntToStr(linkP^.dwFromLinkNumber));
         writeln(f,'To pos = '+IntToStr(linkP^.dwToLinkNumber));
         writeln(f,'From pos = '+IntToStr(linkT^.LinkFromCount));
         writeln(f,'To pos = '+IntToStr(linkT^.LinkToCount));
         writeln(f,'');
       end;
      system.CloseFile(f);
    end;


 procedure   TBPGraph.WriteNodesToDebugFile;
 Var s:ShortString;
     r:Integer;
     F:TextFile;
     nodeP:TBPGraphNode;
  begin
   system.AssignFile(f,'out.dbg');
   system.Rewrite(f);
      for r:=0 to (FNodesCount-1) do
       begin
        nodeP:=GetGraphNode(r);
        if (nodeP<>nil) then
         begin
           writeln(f,'Record N= '+IntToStr(r));
           writeln(f,'Node N= '+IntToStr(nodeP.NodeNumber));
           writeln(f,'Node VN='+nodeP.SNodeNumber);
           writeln(f,'Caption= '+nodeP.Caption);
           writeln(f,'LeftLinksCount= '+IntToStr(nodeP.LeftLinksCount));
           writeln(f,'RightLinksCount= '+IntToStr(nodeP.RightLinksCount));
           writeln(f,'TopLinksCount= '+IntToStr(nodeP.TopLinksCount));
           writeln(f,'BottomLinksCount= '+IntToStr(nodeP.BottomLinksCount));
           writeln(f,'');
         end;
       end;
    system.CloseFile(f);
  end;

function  TBPGraph.CheckLinksAndNodes:Boolean; { Checked }
 Var i:Integer;
     gnode:TBPGraphNode;
     linkP:PGraphLink;
  begin
    Result:=True;
    if (FNodesCount=0) then Exit; { clean paper AR }
    if (FLinksCount=0) then Exit; { No links }
    if FDebug then
    begin
    WriteNodesToDebugFile;
    WriteLinksToDebugFile;
    end;
     for i:=0 to (FLinksCount-1) do
     begin
       linkP:=GetGraphLink(i);
       { check from node }
       if ((linkP^.FromNodeNumber and BPGlobalMask)=0) then
        begin
        gnode:=GetGraphNumberedNode(linkP^.FromNodeNumber);
        if gnode=nil then
           begin
             Result:=False;
             linkP^.CorrectLink:=False;
           end
        end;
       { check to node }
       if ((linkP^.ToNodeNumber and BPGlobalMask)=0) then
        begin
        gnode:=GetGraphNumberedNode(linkP^.ToNodeNumber);
        if gnode=nil then
           begin
             Result:=False;
             linkP^.CorrectLink:=False;
           end
        end;
     end;
  end;


procedure   TBPGraph.OpenLevel(wLevel:Integer); { Checked }
 Var tmpTree:PBPTree;
     Flag:Boolean;
  begin
     if (FTree=nil) then Exit;
     tmpTree:=FTree;
     Flag:=True;
     while (tmpTree<>nil) and (flag) do
      begin
       if (tmpTree^.dwLevel=wLevel) then
         begin
          FNodesCount:=tmpTree^.dwNodesCount;
          FLinksCount:=tmpTree^.dwLinksCount;
          FNodes:=tmpTree^.lpNodes;
          FLinks:=tmpTree^.lpLinks;
          FLevelCaption:=tmpTree^.ssCaption;
          FLevelNotes:=tmpTree^.ssNotes;
          FLevelRevision:=tmpTree^.dwRevision;
          FLevelDraftStatus:=tmpTree^.dwStatus;
          FLevelPageNumber:=tmpTree^.dwPageNumber;
          FLevel:=tmpTree^.dwLevel;
          FSSLevel:=tmpTree^.ssLevel;
          FParentLevel:=tmpTree^.dwParent;
          FNodesFontSize:=tmpTree^.dwNodesFontSize;
          FDNodesFontSize:=tmpTree^.dwDNodesFontSize;
          FDProjectionFontSize:=tmpTree^.dwDProjectionFontSize;
          FInProcessFontSize:=tmpTree^.dwInProcessFontSize;
          FLabelsFontSize:=tmpTree^.dwLabelsFontSize;
          FOverrideNodesFS:=tmpTree^.dbOverrideNodesFS;
          FOverrideDNodesFS:=tmpTree^.dbOverrideDNodesFS;
          FOverrideInProcessFS:=tmpTree^.dbOverrideInProcessFS;
          FOverrideLabelsFS:=tmpTree^.dbOverrideLabelsFS;
          Flag:=False;
         end;
       tmpTree:=tmpTree^.next;
      end;
    if (Flag) then
     begin
          FNodesCount:=FTree^.dwNodesCount;
          FLinksCount:=FTree^.dwLinksCount;
          FNodes:=FTree^.lpNodes;
          FLinks:=FTree^.lpLinks;
          FLevelCaption:=FTree^.ssCaption;
          FLevelRevision:=FTree^.dwRevision;
          FLevelDraftStatus:=FTree^.dwStatus;
          FLevelPageNumber:=FTree^.dwPageNumber;
          FLevelNotes:=FTree^.ssNotes;
          FLevel:=FTree^.dwLevel;
          FSSLevel:=FTree^.ssLevel;
          FParentLevel:=FTree^.dwParent;
          FNodesFontSize:=FTree^.dwNodesFontSize;
          FDNodesFontSize:=FTree^.dwDNodesFontSize;
          FDProjectionFontSize:=FTree^.dwDProjectionFontSize;
          FInProcessFontSize:=FTree^.dwInProcessFontSize;
          FLabelsFontSize:=FTree^.dwLabelsFontSize;
          FOverrideNodesFS:=FTree^.dbOverrideNodesFS;
          FOverrideDNodesFS:=FTree^.dbOverrideDNodesFS;
          FOverrideInProcessFS:=FTree^.dbOverrideInProcessFS;
          FOverrideLabelsFS:=FTree^.dbOverrideLabelsFS;
          Flag:=False;
     end;
    SetDefaultConstants;
    CreateGraphNodes(1,1);
    CreateIPGraphNodes(1,1);
    CreateGraphLinks(1,1);
    if FShowDataWare then
        CreateDGraphNodes(1,1)
   else
    ClearDGraphNodes;
    Scaled:=Scaled;
    CheckLinksAndNodes;
    if (not(FScaled)) then PresetupFrame(1,1);
    TraceRoute;
    FOwner.Invalidate;
    if (BPViewMainForm.BPNavigator.Height>1) and
       (BPViewMainForm.PageControl1.ActivePage=BPViewMainForm.TabSheet1) then
      begin
       AnalizeStringsFonts;
       BPViewMainFOrm.BPGetBitmapTimer.Enabled:=True;
      end;
  end;

 procedure TBPGraph.SetScaled2(Value:Boolean);
  begin
   {}
    FScaled2:=Value;
  end;

 procedure TBPGraph.SetScaled2Ratio(Value:Extended);
 Var posx,posy:Double;
  begin
   {}
{!} posx:=FScaled2Ratio;
{!} posy:=FScaled2Ratio;
{!} if (FOwner.HorzScrollBar.Range>0) and
       (FOwner.HorzScrollBar.Visible) then
     posx:=Value/(posx+0.01)*FOwner.HorzScrollBar.Position
    else
     posx:=0;
{!} if (FOwner.VertScrollBar.Range>0) and
       (FOwner.VertScrollBar.Visible) then
     posy:=Value/(posy+0.01)*FOwner.VertScrollBar.Position
    else
     posy:=0;
    FScaled2Ratio:=Value;
    FOwner.Visible:=False;
    Scaled:=Scaled;
    FOwner.Invalidate;
{!} if (FOwner.HorzScrollBar.Range>0) then
        FOwner.HorzScrollBar.Position:=Round(posx);
{!} if (FOwner.VertScrollBar.Range>0) then
        FOwner.VertScrollBar.Position:=Round(posy);
    FOwner.Visible:=True;
  end;

procedure TBPGraph.UpdateMaxFontSize(Coof:Extended);
Var hca3:Extended;
    aSize:Integer;
    tmpi:TQRPaperSize;
 begin
  { Update & calc real max font size }
  hca3:=1.0;
  if MainUnit.HasPrnDevice then
   begin
    aSize:=Printer.PaperSize;
    for tmpi:= Default to Custom do
      begin
       if aSize=cQRPaperTranslate[tmpI] then
        begin
         hca3:=cQRPaperSizeMetrics[tmpI,0]/cQRPaperSizeMetrics[A3,0];
        end;
      end;
   end;
  if FScaled then
    begin
      if FScaled2 then
       begin { if FScaled2 }
        FRealMaxFontSize:=Round(FMaxFontSize*hca3*FScaled2Ratio/100.0);
       end
      else
       begin
        FRealMaxFontSize:=Round(FMaxFontSize/coof*hca3);
       end;
    end
   else
    begin
      FRealMaxFontSize:=Round(FMaxFontSize*FOwner.FFontCoof*hca3);
    end;
 end;

procedure TBPGraph.SetScaled(Value:Boolean);  { Checked }
Var r1,r2,ratio,fontRatio,labelFontRatio,ioFontRatio:Double;
    nw,nh,mw,mh:Integer;
    rw,rh:Double;
    pgAlg:TBPPgAlg;
    dc:HDC;
    ws2,hs2:Extended;
    {New}
    wca3,hca3:Extended;
    aSize:Integer;
    tmpi:TQRPaperSize;
    r3:Double;
 begin
   FScaled:=Value;
   if FTree=nil then Exit;
   if FScaled then
    begin
    if FOwner.VertScrollBar.Visible then FOwner.VertScrollBar.Position:=0;
    if FOwner.HorzScrollBar.Visible then FOwner.HorzScrollBar.Position:=0;
    Repaint;
    SetDefaultConstants;
    Printing:=False;
    SetDefaultConstants;
    CreateGraphNodes(1,1); { read x,y,acceptposition }
    CreateIPGraphNodes(1,1);
    CreateGraphLinks(1,1); { read x,y,acceptposition }
    if FShowDataWare then
        CreateDGraphNodes(1,1)
   else
        ClearDGraphNodes;
    PresetupFrame(1,1); { Scale x,y to widthcoof,heightcoof }
    TraceRoute;
    FOwner.Invalidate;
    if FNodesCount>FOwner.FNodesValue[0] then
     begin
       if FNodesCount>FOwner.FNodesValue[1] then
         pgAlg:=pg_Max
       else
         pgAlg:=pg_Middle;
     end
    else pgAlg:=pg_Min;
   end;
   if FScaled2 then
    begin { if FScaled2 }
     wca3:=1.0;
     hca3:=1.0;
     if MainUnit.HasPrnDevice then
      begin
       aSize:=Printer.PaperSize;
       for tmpi:= Default to Custom do
        begin
         if aSize=cQRPaperTranslate[tmpI] then
           begin
            hca3:=cQRPaperSizeMetrics[tmpI,0]/cQRPaperSizeMetrics[A3,0];
            wca3:=cQRPaperSizeMetrics[tmpI,1]/cQRPaperSizeMetrics[A3,1];
           end;
        end;
       end;
      dc:=GetDC(0);
      ws2:=GetDeviceCaps(dc,LOGPIXELSX)*A3Width*wca3*FScaled2Ratio/100.0;
      hs2:=GetDeviceCaps(dc,LOGPIXELSY)*A3Height*hca3*FScaled2Ratio/100.0;
      UpdateMaxFontSize(1);
      ReleaseDC(0,dc);
      if (FOwner.HorzScrollBar.Visible) and
         (FOwner.HorzScrollBar.Range>0) then
       begin
        FOwner.HorzScrollBar.Position:=0;
        r1:=ws2/FOwner.HorzScrollBar.Range;
       end
      else r1:=ws2/FOwner.ClientWidth;
      if (FOwner.VertScrollBar.Visible) and
         (FOwner.VertScrollBar.Range>0) then
       begin
         FOwner.VertScrollBar.Position:=0;
         r2:=hs2/FOwner.VertScrollBar.Range;
       end
      else r2:=hs2/FOwner.ClientHeight;
    end { if FScaled2 }
   else
   begin { if not FScaled2 }
   if FOwner.HorzScrollBar.Visible then
    begin
     FOwner.HorzScrollBar.Position:=0;
     r1:=FOwner.ClientWidth/FOwner.HorzScrollBar.Range;
    end
   else r1:=1;
   if FOwner.VertScrollBar.Visible then
    begin
     FOwner.VertScrollBar.Position:=0;
     r2:=FOwner.ClientHeight/FOwner.VertScrollBar.Range;
    end
   else r2:=1;
   UpdateMaxFontSize(r2);
   end; { if not FScaled2  }
{   if r1<r2 then ratio:=r1 else ratio:=r2;}
   if FScaled then
    begin
     case pgAlg of
      pg_Min:     ratio:=FOwner.GetCoof(r1,r2,FOwner.FFormatAlg[0]);
      pg_Middle:  ratio:=FOwner.GetCoof(r1,r2,FOwner.FFormatAlg[1]);
      pg_Max:     ratio:=FOwner.GetCoof(r1,r2,FOwner.FFormatAlg[2]);
     end;
     SetDefaultConstants;
     SetScaledConstants(r1,r2,ratio,ratio,ratio,ratio);
     if FScaled2 then
      begin
       DefWidth:=Round(ws2);
       DefHeight:=Round(hs2);
      end
     else
      begin
       DefWidth:=FOwner.ClientWidth;
       DefHeight:=FOwner.ClientHeight;
      end;
     Printing:=True;
     CreateGraphNodes(r1,r2); { read x,y,acceptposition }
     CreateIPGraphNodes(r1,r2);
     CreateGraphLinks(r1,r2); { read x,y,acceptposition }
     if FShowDataWare then
        CreateDGraphNodes(r1,r2)
   else
        ClearDGraphNodes;
     PresetupFrame(r1,r2); { Scale x,y to widthcoof,heightcoof }
     TraceRoute;
     FOwner.Invalidate;
     while FOwner.FPainting do;
     {new code }
     if (FGlobalOperationSize/(FDefHeight+1))>FMaxGOS then
      ioFontRatio:=(FDefHeight*FMaxGOS)/(FGlobalOperationSize+1)
     else
      ioFontRatio:=ratio;
     if ioFontRatio>ratio then ioFontRatio:=ratio;
     if ioFontRatio>r2 then ioFontRatio:=r2;
     if FScaled2 then
      begin
       DefWidth:=Round(ws2);
       DefHeight:=Round(hs2);
      end
     else
      begin
       DefWidth:=FOwner.ClientWidth;
       DefHeight:=FOwner.ClientHeight;
      end;
     SetDefaultConstants;
     SetScaledConstants(r1,r2,ratio,ratio,ratio,ioFontRatio);
     CreateGraphNodes(r1,r2); { read x,y,acceptposition }
     CreateIPGraphNodes(r1,r2);
     CreateGraphLinks(r1,r2); { read x,y,acceptposition }
     if FShowDataWare then
        CreateDGraphNodes(r1,r2)
     else
        ClearDGraphNodes;
     PresetupFrame(r1,r2);   { Scale x,y to widthcoof,heightcoof }
     TraceRoute;
     FOwner.Invalidate;
     while FOwner.FPainting do;
    { End new code }
     nw:=NodeWidth;  { Dopusk Width diagram }
     nh:=NodeHeight; { Dopusk Height diagram }
     mw:=MaxWidth;   { MaxWidth from ratio for font }
     mh:=MaxHeight;  { MaxHeight from ratio for font }
     rw:=ratio*nw/mw;
     rh:=ratio*nh/mh;
     case pgAlg of
       pg_Min:    fontRatio:=FOwner.GetCoof(rw,rh,FOwner.FFormatAlg[0]);
       pg_Middle: fontRatio:=FOwner.GetCoof(rw,rh,FOwner.FFormatAlg[1]);
       pg_Max:    fontRatio:=FOwner.GetCoof(rw,rh,FOwner.FFormatAlg[2]);
     end;
     if fontRatio>ratio then fontRatio:=ratio;
     LabelFontRatio:=fontRatio*FMaxCH;
     FOwner.Canvas.FillRect(FOwner.Canvas.ClipRect);
     if FScaled2 then
      begin
       DefWidth:=Round(ws2);
       DefHeight:=Round(hs2);
      end
     else
      begin
       DefWidth:=FOwner.ClientWidth;
       DefHeight:=FOwner.ClientHeight;
      end;
     if (FGlobalOperationSize/(FDefHeight+1))>FMaxGOS then
      ioFontRatio:=(FDefHeight*FMaxGOS)/(FGlobalOperationSize+1)*FontRatio
     else
      ioFontRatio:=ioFontRatio*FontRatio;
     if ioFontRatio>ratio then ioFontRatio:=ratio;
     if ioFontRatio>r2 then ioFontRatio:=r2;
{     else
      ioFontRatio:=FontRatio;}
     SetDefaultConstants;
     SetScaledConstants(r1,r2,ratio,fontRatio,labelFontRatio,iofontRatio);
     CreateGraphNodes(r1,r2); { read x,y,acceptposition }
     CreateIPGraphNodes(r1,r2);
     CreateGraphLinks(r1,r2); { read x,y,acceptposition }
     if FShowDataWare then
        CreateDGraphNodes(r1,r2)
     else
        ClearDGraphNodes;
     PresetupFrame(r1,r2);   { Scale x,y to widthcoof,heightcoof }
     TraceRoute;
     FOwner.Invalidate;
     while FOwner.FPainting do;
    end
   else
    begin
     UpdateMaxFontSize(1);
     SetDefaultConstants;
     Printing:=False;
     SetDefaultConstants;
     CreateGraphNodes(1,1); { read x,y,acceptposition }
     CreateIPGraphNodes(1,1);
     CreateGraphLinks(1,1); { read x,y,acceptposition }
     if FShowDataWare then
        CreateDGraphNodes(1,1)
   else
        ClearDGraphNodes;
     PresetupFrame(1,1); { Scale x,y to widthcoof,heightcoof }
     TraceRoute;
     FOwner.Invalidate;
    end;
 end;


 procedure  TBPGraph.ClearOpTree; { Checked }
 Var treeP,treeP1:PBPOpTree;
  begin
     if (FOPTree<>nil) then
     begin
        treeP:=FOPTree;
        while (treeP<>nil) do
         begin
          treeP1:=treeP;
          treeP:=treeP^.next;
          if (treeP1^.dwOpDetailCount>0) then FreeMem(treeP1^.lpOpDetail,
                                                      sizeof(TBPOpDetail)*treeP1^.dwOpDetailCount);
          FreeMem(treeP1);
         end;
     end;
    FOPTree:=nil;
    FDNodesCount:=0;
  end;

 procedure   TBPGraph.ClearTree; { Checked }
 Var treeP,treeP1:PBPTree;
  begin
     if (FTree<>nil) then
     begin
        treeP:=FTree;
        while (treeP<>nil) do
         begin
          treeP1:=treeP;
          treeP:=treeP^.next;
          if (treeP1^.lpNodes<>nil) then FreeMem(treeP1^.lpNodes);
          if (treeP1^.lpLinks<>nil) then FreeMem(treeP1^.lpLinks);
          FreeMem(treeP1);
         end;
     end;
    FTree:=nil;
    FLevel:=-1;
    FParentLevel:=-2; { Disabled }
    FNodes:=nil;
    FLinks:=nil;
    FNodesCount:=0;
    FLinksCount:=0;
  end;

 function    TBPGraph.LoadFromFile(FileName:String):Boolean; { Checked }
  begin
    Result:=FBPFileStream.OpenStream(FileName,stRead);
    if not(Result) then Exit;
    FModified:=False;
    if (FTree<>nil) then ClearTree;
    if (FNTTree<>nil) then ClearNTTree;
    if (FLTTree<>nil) then ClearLTTree;
    if (FOpTree<>nil) then ClearOpTree;
    if (FEntryArray<>nil) then FreeMem(FEntryArray,sizeof(TBPEntryArray));
    if (FCheckGraphArray<>nil) then FreeMem(FCheckGraphArray,sizeof(TBPCheckGraphArray));
    if (FIPNode<>nil) then ClearIPNode;
    FTree:=nil;
    FNTTree:=nil;
    FLTTree:=nil;
    FOPTree:=nil;
    FEntryArray:=nil;
    FCheckGraphArray:=nil;
    FIPNode:=nil;
    Result:=FBPFileStream.ReadBP(FHeader,FTree,FNTTree,FLTTree,FOpTree,FEntryArray,FCheckGraphArray,FIPNode);
    FRootEntries:=FBPFileStream.RootEntries;
    if not(Result) then
      begin
        FBPFileStream.CloseStream;
        Exit;
      end;
    FBPFileStream.CloseStream;
    FLevel:=-1;
    FSSLevel:='-1';
    FParentLevel:=-2; { Disabled }
    OpenLevel(FLevel);
    TraceRoute;
  end;

 function    TBPGraph.SaveToFile(FileName:String):Boolean; { Checked }
  begin
   Result:=False;
   if (FTree=nil) then Exit;
   Result:=FBPFileStream.OpenStream(FileName,stWrite);
   if not(Result) then Exit;
   Result:=FBPFileStream.WriteBP(FHeader,FTree,FNTTree,FLTTree,FOPTree,FEntryArray,FCheckGraphArray,FIPNode);
    if not(Result) then
      begin
        FBPFileStream.CloseStream;
        Exit;
      end;
    FBPFileStream.CloseStream;
    FModified:=False;
    BPViewMainForm.SetOtherModified(False);
  end;

{ TBPFrame }

constructor TBPFrame.Create(AOwner: TComponent); { Checked }
Var item:TMenuItem;
begin
 inherited Create(AOwner);
 FPainting:=False;
 FPrinting:=False;
 FAborting:=False;
 FPreviewOrPrint:=False;
 FFontCoof:=1;
 FBPGraph:=TBPGraph.Create(self);
 FBPGraph.Parent:=self;
 FCanvas := TControlCanvas.Create;
 TControlCanvas(FCanvas).Control := Self;
 Canvas.Brush.Color:=clWhite;
 DragCursor:=crMyCursor;
{ DragMode:=dmAutomatic;}
 OnDragDrop:=MyDragDrop;
 OnDragOver:=MyDragOver;
 FPageTop:=15;
 FPageBottom:=15;
 FPageLeft:=25;
 FPageRight:=15;
 FHorzPageCount:=1;
 FVertPageCount:=1;
 FRamkaFontRatio:=1.0;
 FPSizeH:=21;
 FPSizeW:=29.7;
 FRamkaH:=0;
 TabStop:=True;
 Enabled:=True;
 FUpdatingNavigator:=False;
 FContextBitmap:=TBitmap.Create;
 FContextBitmap.PixelFormat:=pf4bit;
 FDrawCBitmap:=False;
 FFormatAlg[0]:=fa_Min;
 FFormatAlg[1]:=fa_Sqrt;
 FFormatAlg[2]:=fa_Max;
 FNodesValue[0]:=4;
 FNodesValue[1]:=6;
 if MainUnit.HasPrnDevice then SetPageParam(FPageTop,FPageBottom,FPageLeft,FPageRight,False);
end;

destructor TBPFrame.Destroy; { Checked }
begin
 OnDragDrop:=nil;
 OnDragOver:=nil;
 if (FPrinter<>nil) then FPrinter.Free;
 if (FCanvas<>nil) then FCanvas.Free;
 if (FBPGraph<>nil) then FBPGraph.Destroy; {   }
 FContextBitmap.Destroy;
 inherited Destroy;
end;

procedure TBPFrame.SetPageParam(Var PageTop,PageBottom,PageLeft,PageRight:Integer;ShowWarning:Boolean); { Checked }
Var px,py,plofs,ptofs,pbofs,profs:Integer;
    pw,ph,hw,hh:Integer;
    s:String;
    po:TPrinterOrientation;
Const   es='      .    ';
        se=' ';

begin
 po:=Printer.Orientation;
 case po of
 poPortrait:
   begin
    px:=GetDeviceCaps(Printer.Handle,LOGPIXELSX);
    py:=GetDeviceCaps(Printer.Handle,LOGPIXELSY);
    plofs:=GetDeviceCaps(Printer.Handle,PHYSICALOFFSETX);
    ptofs:=GetDeviceCaps(Printer.Handle,PHYSICALOFFSETY);
    pw:=GetDeviceCaps(Printer.Handle,PHYSICALWIDTH);
    hw:=GetDeviceCaps(Printer.Handle,HORZRES);
    ph:=GetDeviceCaps(Printer.Handle,PHYSICALHEIGHT);
    hh:=GetDeviceCaps(Printer.Handle,VERTRES);
   end;
  poLandscape:
   begin
    py:=GetDeviceCaps(Printer.Handle,LOGPIXELSX);
    px:=GetDeviceCaps(Printer.Handle,LOGPIXELSY);
    ptofs:=GetDeviceCaps(Printer.Handle,PHYSICALOFFSETX);
    plofs:=GetDeviceCaps(Printer.Handle,PHYSICALOFFSETY);
    ph:=GetDeviceCaps(Printer.Handle,PHYSICALWIDTH);
    hh:=GetDeviceCaps(Printer.Handle,HORZRES);
    pw:=GetDeviceCaps(Printer.Handle,PHYSICALHEIGHT);
    hw:=GetDeviceCaps(Printer.Handle,VERTRES);
   end;
 end;
 pbofs:=ph-hh-ptofs;
 profs:=pw-hw-plofs;
 FPageTop:=Round(PageTop*py/25.4)-ptofs;
 FPageBottom:=Round(PageBottom*py/25.4)-pbofs;
 FPageLeft:=Round(PageLeft*px/25.4)-plofs;
 FPageRight:=Round(PageRight*px/25.4)-profs;
{ px:=GetDeviceCaps(Printer.Handle,LOGPIXELSX);
 py:=GetDeviceCaps(Printer.Handle,LOGPIXELSY);
 plofs:=GetDeviceCaps(Printer.Handle,PHYSICALOFFSETX);
 ptofs:=GetDeviceCaps(Printer.Handle,PHYSICALOFFSETY);
 profs:=GetDeviceCaps(Printer.Handle,PHYSICALWIDTH)-GetDeviceCaps(Printer.Handle,HORZRES)-plofs;
 pbofs:=GetDeviceCaps(Printer.Handle,PHYSICALHEIGHT)-GetDeviceCaps(Printer.Handle,VERTRES)-ptofs;
 FPageTop:=Round(PageTop*py/25.4)-ptofs;
 FPageBottom:=Round(PageBottom*py/25.4)-pbofs;
 FPageLeft:=Round(PageLeft*px/25.4)-plofs;
 FPageRight:=Round(PageRight*px/25.4)-profs;}
 if ShowWarning then
 begin
 if FPageTop<0 then
   begin
   s:=se+''+es;
   Application.MessageBox(PChar(s),' !',MB_OK);
   FPageTop:=0;
   PageTop:=Round(ptofs*25.4/py)+1;
   end;
  if FPageBottom<0 then
   begin
   s:=se+''+es;
   Application.MessageBox(PChar(s),' !',MB_OK);
   FPageBottom:=0;
   PageBottom:=Round(pbofs*25.4/py)+1;
   end;
  if FPageLeft<0 then
   begin
   s:=se+''+es;
   Application.MessageBox(PChar(s),' !',MB_OK);
   FPageLeft:=0;
   PageLeft:=Round(plofs*25.4/px)+1;
   end;
  if FPageRight<0 then
   begin
   s:=se+''+es;
   Application.MessageBox(PChar(s),' !',MB_OK);
   FPageRight:=0;
   PageRight:=Round(profs*25.4/px)+1;
   end;
  end;
end;

procedure TBPFrame.SetPreviewPageParam(PageTop,PageBottom,PageLeft,PageRight:Integer); { Checked }
Var px,py:Integer;
begin
 FPageTop:=PageTop;
 FPageBottom:=PageBottom;
 FPageLeft:=PageLeft;
 FPageRight:=PageRight;
end;


procedure TBPFrame.WMPaint(var Message: TWMPaint); { Checked }
begin
   PaintHandler(Message);
end;

procedure TBPFrame.PaintWindow(DC: HDC); { Checked }
begin
  if FPainting then Exit;
  FPainting:=True;
  inherited PaintWindow(DC);
  FCanvas.Lock;
  try
    FCanvas.Handle := DC;
    try
      Paint;
    finally
      FCanvas.Handle := 0;
    end;
  finally
    FCanvas.Unlock;
    FPainting:=False;
  end;
end;

procedure TBPFrame.Paint; { Checked }
Var oldcr:TCursor;
begin
  oldcr:=Cursor;
  Cursor:=crHourGlass;
  Canvas.FillRect(ClientRect);
  BPGraph.TraceRoute;
  if (not(FUpdatingNavigator)) and
     (BPViewMainFOrm.PageControl1.ActivePage=BPViewMainFOrm.TabSheet1) then
     if (BPViewMainFOrm.BPNavigator.Height>1) then
      BPViewMainFOrm.BPNavigator.ScrollBarChanged(self);
{     BPViewMainForm.BPNavTimer.Enabled:=True;}
  Cursor:=oldcr;
end;

procedure TBPFrame.PaintTo(DC: HDC; X, Y: Integer); { Checked }
var
  SaveIndex: Integer;
begin
  SaveIndex := SaveDC(DC);
  MoveWindowOrg(DC, X, Y);
  Perform(WM_ERASEBKGND, DC, 0);
  Perform(WM_PAINT, DC, 0);
  RestoreDC(DC, SaveIndex);
end;

procedure TBPFrame.PaintPageTo(DC: HDC; X, Y: Integer; PageClipRect:TRect); { Checked }
var
  I, EdgeFlags, BorderFlags, SaveIndex: Integer;
  R: TRect;
begin
  SaveIndex := SaveDC(DC);
  MoveWindowOrg(DC, X-PageClipRect.Left, Y-PageClipRect.Top);
  IntersectClipRect(DC, PageClipRect.Left, PageClipRect.Top, PageClipRect.Right, PageClipRect.Bottom);
  Perform(WM_ERASEBKGND, DC, 0);
  Perform(WM_PAINT, DC, 0);
  RestoreDC(DC, SaveIndex);
end;

procedure TBPFrame.PrintRect(left,right,top,bottom:Integer); { Checked }
Var oldStyle:TPenStyle;
begin
 oldStyle:=Printer.Canvas.Pen.Style;
 Printer.Canvas.Pen.Style:=psDot;
 Printer.Canvas.MoveTo(Left,Top);
 Printer.Canvas.LineTo(Right,Top);
 Printer.Canvas.LineTo(Right,Bottom);
 Printer.Canvas.LineTo(Left,Bottom);
 Printer.Canvas.LineTo(Left,Top);
 Printer.Canvas.Pen.Style:=oldStyle;
end;


function TBPFrame.GetCoof(rw,rh:Double;Alg:TBPFormatAlg):Double;
 begin
   case Alg of
     fa_Min:  if rw>=rh then Result:=rh else Result:=rw;
     fa_Max:  if rw>=rh then Result:=rw else Result:=rh;
     fa_Sqrt: Result:=Sqrt(rw*rh);
     fa_Sum:  Result:=(rw+rh)/2;
     fa_Width:  Result:=rw;
     fa_Height: Result:=rh;
   end;
 end;

procedure TBPFrame.PrintAll(pb:TFlatProgressBar;Lbl:TLabel;StartP,EndP:Integer); { Checked }
Var  oldLevel:Integer;
     tmpTree:PBPTree;
     i:Integer;
     prnppi,scrppi:Integer;
     w,h:Integer;
     prnx,prny:Integer;
     dc:HDC;
     ratio,fontRatio,LabelFontRatio,ioFontRatio:Double;
     rw,rh:Double;
     ramkaH:Integer;
     nw,nh,mw,mh:Integer;
     oldScaled:Boolean;
     oldScaled2:Boolean;
     clRect:TRect;
     px,py:Integer;
     pw,ph:Double;
     tmpI:TQRPaperSize;
     asize:Integer;
     wc,hc:Double;
     pc:Integer;
     bmsize:TPoint;
     pgalg:TBPPgAlg; { 0 Min 1 Middle 2 Max }
     cl:String;
begin
  { Print All Pages }
  oldScaled:=BPGraph.Scaled;
  oldScaled2:=BPGraph.Scaled2;
  oldLevel:=-1;
  if FBPGraph.FTree=nil then Exit;
  FPreviewOrPrint:=True;
  FUpdatingNavigator:=True;
  FDrawCBitmap:=True;
  FBPGraph.Scaled2:=False;
  if FBPGraph.FScaled then FBPGraph.Scaled:=False;
  tmpTree:=FBPGraph.FTree;
  try
   FPrinting:=True;
  { Store old viewing level }
   oldLevel:=FBPGraph.FLevel;
   i:=0;
   pc:=0;
   prnppi:=GetDeviceCaps(Printer.Handle,LOGPIXELSX);
   ramkaH:=Round(2.5*prnppi/2.54);
   FRamkaH:=ramkaH;
   dc:=GetDC(self.Handle);
   scrppi:=GetDeviceCaps(dc,LOGPIXELSX);
   FFontCoof:=GetDeviceCaps(Printer.Handle,LOGPIXELSY)/GetDeviceCaps(dc,LOGPIXELSY);
   FBPGraph.UpdateMaxFontSize(1);
   ReleaseDC(self.Handle,dc);
   aSize:=Printer.PaperSize;
   FRamkaFontRatio:=1.0;
   FPSizeH:=21;
   FPSizeW:=29.7;
   for tmpi:= Default to Custom do
     begin
      if aSize=cQRPaperTranslate[tmpI] then
         begin
           FRamkaFontRatio:=cQRPaperSizeMetrics[tmpI,0]/cQRPaperSizeMetrics[A4,0];
           FPSizeH:=cQRPaperSizeMetrics[tmpI,0]/10;
           FPSizeW:=cQRPaperSizeMetrics[tmpI,1]/10;
         end;
     end;
   { New Code }
   bmsize:=GetHeaderBitmapSize;
   FContextBitmap.Width:=bmsize.x;
   FContextBitmap.Height:=bmsize.y;
   pw:= GetDeviceCaps(Printer.Handle,VERTRES);
   ph:= GetDeviceCaps(Printer.Handle,HORZRES);
   if ((FHorzPageCount=1) and (FVertPageCount=1)) then
    ph:=ph - ramkaH;
   { End New Code }
  { ratio:=(prnppi*FHorzPageCount) / scrppi;}
   Printer.BeginDoc;
   while (tmpTree<>nil) and (not(FAborting)) do
    begin
     if (pc>=StartP) and (pc<=EndP) then
     begin
     FBPGraph.OpenLevel(tmpTree^.dwLevel);
     FBPGraph.TraceRoute;
     if (FBPGraph.FNodesCount>FNodesValue[0]) then
      begin
        if (FBPGraph.FNodesCount<FNodesValue[1]) then
          pgAlg:=pg_Middle
        else
          pgAlg:=pg_Max;
      end
     else pgalg:=pg_Min;
     cl:=FillBitmapWithSize(FContextBitmap,bmsize.x,bmsize.y,tmpTree^.dwParent);
     if HorzScrollBar.Visible then HorzScrollBar.Position:=0;
     if VertScrollBar.Visible then VertScrollBar.Position:=0;
     Repaint;
     inc(i);
     pb.Position:=Round((i-1)*100/(EndP-StartP+1));
     Lbl.Caption:=IntToStr(pb.Position);
     pb.Update;
     lbl.Update;
     Application.ProcessMessages;
     if FAborting then break;
     while (FPainting) do;
     { New Code }
     rw:=(pw*FHorzPageCount)/FBPGraph.DefWidth;
     rh:=(ph*FVertPageCount)/FBPGraph.DefHeight;
     wc:=FBPGraph.DefWidth;
     hc:=FBPGraph.DefHeight;
     case pgAlg of
      pg_Min:     Ratio:=GetCoof(rw,rh,FFormatAlg[0]);
      pg_Middle:  Ratio:=GetCoof(rw,rh,FFormatAlg[1]);
      pg_Max:     Ratio:=GetCoof(rw,rh,FFormatAlg[2]);
     end; {case pgAlg }
    { End New Code }
     FBPGraph.SetDefaultConstants;
     FBPGraph.SetScaledConstants(rw,rh,ratio,ratio,ratio,ratio);
     FBPGraph.DefWidth:=FHorzPageCount*(Printer.PageWidth-FPageLeft-FPageRight);
     if ((FHorzPageCount=1) and (FVertPageCount=1)) then
      FBPGraph.DefHeight:=FVertPageCount*(Printer.PageHeight-FPageTop-FPageBottom-ramkaH)
     else
      FBPGraph.DefHeight:=FVertPageCount*(Printer.PageHeight-FPageTop-FPageBottom);
     wc:=FBPGraph.DefWidth/wc;
     hc:=FBPGraph.DefHeight/hc;
     FBPGraph.Printing:=True;
     FBPGraph.CreateGraphNodes(wc,hc);
     FBPGraph.CreateIPGraphNodes(wc,hc);
     FBPGraph.CreateGraphLinks(wc,hc);
     if FBPGraph.ShowDataWare then
        FBPGraph.CreateDGraphNodes(wc,hc)
     else
        FBPGraph.ClearDGraphNodes;
     FBPGraph.PresetupFrame(wc,hc);
     FBPGraph.TraceRoute;
     Repaint;
     while FPainting do;
     if (FBPGraph.FGlobalOperationSize/(FBPGraph.FDefHeight+1))>FBPGraph.FMaxGOS then
      ioFontRatio:=(FBPGraph.FDefHeight*FBPGraph.FMaxGOS)/(FBPGraph.FGlobalOperationSize+1)
     else
      ioFontRatio:=ratio;
     if ioFontRatio>ratio then ioFontRatio:=ratio;
     if ioFontRatio>hc then ioFontRatio:=hc;
      FBPGraph.DefWidth:=FHorzPageCount*(Printer.PageWidth-FPageLeft-FPageRight);
     if ((FHorzPageCount=1) and (FVertPageCount=1)) then
      FBPGraph.DefHeight:=FVertPageCount*(Printer.PageHeight-FPageTop-FPageBottom-ramkaH)
     else
      FBPGraph.DefHeight:=FVertPageCount*(Printer.PageHeight-FPageTop-FPageBottom);
     FBPGraph.SetDefaultConstants;
     FBPGraph.SetScaledConstants(wc,hc,ratio,Ratio,Ratio,iofontRatio);
     FBPGraph.CreateGraphNodes(wc,hc);
     FBPGraph.CreateIPGraphNodes(wc,hc);
     FBPGraph.CreateGraphLinks(wc,hc);
     if FBPGraph.ShowDataWare then
        FBPGraph.CreateDGraphNodes(wc,hc)
   else
        FBPGraph.ClearDGraphNodes;
     FBPGraph.PresetupFrame(wc,hc);
     FBPGraph.TraceRoute;
     Repaint;
     while FPainting do;
     nw:=FBPGraph.NodeWidth;
     nh:=FBPGraph.NodeHeight;
     mw:=FBPGraph.MaxWidth;
     mh:=FBPGraph.MaxHeight;
     rw:=ratio*nw/mw;
     rh:=ratio*nh/mh;
     case pgAlg of
       pg_Min:     fontRatio:=GetCoof(rw,rh,FFormatAlg[0]);
       pg_Middle:  fontRatio:=GetCoof(rw,rh,FFormatAlg[1]);
       pg_Max:     fontRatio:=GetCoof(rw,rh,FFormatAlg[2]);
     end;
     if fontRatio>ratio then fontRatio:=ratio;
     LabelFontRatio:=fontRatio*FBPGraph.FMaxCH;
     FBPGraph.DefWidth:=FHorzPageCount*(Printer.PageWidth-FPageLeft-FPageRight);
     if ((FHorzPageCount=1) and (FVertPageCount=1)) then
      FBPGraph.DefHeight:=FVertPageCount*(Printer.PageHeight-FPageTop-FPageBottom-ramkaH)
     else
      FBPGraph.DefHeight:=FVertPageCount*(Printer.PageHeight-FPageTop-FPageBottom);
     if (FBPGraph.FGlobalOperationSize/(FBPGraph.FDefHeight+1))>FBPGraph.FMaxGOS then
      ioFontRatio:=(FBPGraph.FDefHeight*FBPGraph.FMaxGOS)/(FBPGraph.FGlobalOperationSize+1)*fontRatio
     else
      ioFontRatio:=ioFontRatio*FontRatio;
     if ioFontRatio>ratio then ioFontRatio:=ratio;
     if ioFontRatio>hc then ioFontRatio:=hc;
     FBPGraph.SetDefaultConstants;
     FBPGraph.SetScaledConstants(wc,hc,ratio,fontRatio,LabelFontRatio,iofontRatio);
     FBPGraph.CreateGraphNodes(wc,hc);
     FBPGraph.CreateIPGraphNodes(wc,hc);
     FBPGraph.CreateGraphLinks(wc,hc);
     if FBPGraph.ShowDataWare then
        FBPGraph.CreateDGraphNodes(wc,hc)
   else
        FBPGraph.ClearDGraphNodes;
     FBPGraph.PresetupFrame(wc,hc);
     FBPGraph.TraceRoute;
     Repaint;
     while FPainting do;
    for px:=1 to FHorzPageCount do
    begin
     clRect.Left:=(px-1)*(Printer.PageWidth-FPageRight-FPageLeft);
     clRect.Right:=px*(Printer.PageWidth-FPageRight-FPageLeft);
    for py:=1 to FVertPageCount do
     begin
     clRect.Top:=(py-1)*(Printer.PageHeight-FPageTop-FPageBottom);
     clRect.Bottom:=py*(Printer.PageHeight-FPageTop-FPageBottom);
     if ((FHorzPageCount=1) and (FVertPageCount=1)) then
       begin
        PaintTo(Printer.Handle,FPageLeft,FPageTop+(ramkaH div 2));
        PrintStandartRectangle(cl);
       end
      else
       begin
        PaintPageTo(Printer.Handle,FPageLeft,FPageTop,clRect);
        PrintRect(FPageLeft,Printer.PageWidth-FPageRight,
                           FPageTop,Printer.PageHeight-FPageBottom);
       end;
       if ((FHorzPageCount<>px) or (FVertPageCount<>py)) then
        Printer.NewPage;
     end;
    end;
     FBPGraph.SetDefaultConstants;
     FBPGraph.Printing:=False;
     FBPGraph.CreateGraphNodes(1,1);
     FBPGraph.CreateIPGraphNodes(1,1);
     FBPGraph.CreateGraphLinks(1,1);
     if FBPGraph.ShowDataWare then
        FBPGraph.CreateDGraphNodes(1,1)
   else
        FBPGraph.ClearDGraphNodes;
     FBPGraph.PresetupFrame(1,1);
     FBPGraph.TraceRoute;
     Invalidate;
     if (tmpTree^.next<>nil) and (pc<EndP) then Printer.NewPage;
     end; { StartP,EndP }
     tmpTree:=tmpTree^.next;
     inc(pc);
    end;
   if FAborting then Printer.Abort
   else Printer.EndDoc;
  finally
   { Restore old viewing level}
   FPrinting:=False;
   FUpdatingNavigator:=False;
   FPreviewOrPrint:=False;
   FBPGraph.SetDefaultConstants;
   FBPGraph.Printing:=False;
   FBPGraph.CreateGraphNodes(1,1);
   FBPGraph.CreateIPGraphNodes(1,1);
   FBPGraph.CreateGraphLinks(1,1);
   if FBPGraph.ShowDataWare then
        FBPGraph.CreateDGraphNodes(1,1)
   else
        FBPGraph.ClearDGraphNodes;
   FBPGraph.SetScaled2(oldScaled2);
   FBPGraph.SetScaled(oldScaled);
   if (not(oldScaled)) then FBPGraph.PresetupFrame(1,1);
   FBPGraph.TraceRoute;
   Invalidate;
   pb.Position:=100;
   lbl.Caption:=IntToStr(pb.Position);
   pb.Update;
   lbl.Update;
   FBPGraph.OpenLevel(oldLevel);
   FBPGraph.TraceRoute;
   Invalidate;
  end;
 end;

procedure TBPFrame.Print; { Checked }
Var  prnppi,scrppi:Integer;
     w,h:Integer;
     prnx,prny:Integer;
     dc:HDC;
     ratio,fontRatio,labelFontRatio,ioFontRatio:Double;
     rw,rh:Double;
     pw,ph:Double;
     ramkaH:Integer;
     nw,nh,mw,mh:Integer;
     oldScaled:Boolean;
     oldScaled2:Boolean;
     clRect:TRect;
     px,py:Integer;
     tmpI:TQRPaperSize;
     asize:Integer;
     wc,hc:Double;
     bmsize:TPoint;
     pgalg:TBPPgAlg;
     cl:String;
begin
 try
  oldScaled:=BPGraph.Scaled;
  oldScaled2:=BPGraph.Scaled2;
  FUpdatingNavigator:=True;
  FPreviewOrPrint:=True;
  FDrawCBitmap:=True;
  if (FBPGraph.FNodesCount>FNodesValue[0]) then
      begin
        if (FBPGraph.FNodesCount<FNodesValue[1]) then
          pgAlg:=pg_Middle
        else
          pgAlg:=pg_Max;
      end
     else pgalg:=pg_Min;
  bmsize:=GetHeaderBitmapSize;
  FContextBitmap.Width:=bmsize.x;
  FContextBitmap.Height:=bmsize.y;
  cl:=FillBitmapWithSize(FContextBitmap,bmsize.x,bmsize.y,FBPGraph.FParentLevel);
  Repaint;
  if HorzScrollBar.Visible then HorzScrollBar.Position:=0;
  if VertScrollBar.Visible then VertScrollBar.Position:=0;
  FBPGraph.Scaled2:=False;
  if FBPGraph.FScaled then FBPGraph.Scaled:=False;
  FPrinting:=True;
  prnppi:=GetDeviceCaps(Printer.Handle,LOGPIXELSX);
  dc:=GetDC(self.Handle);
  scrppi:=GetDeviceCaps(dc,LOGPIXELSX);
  FFontCoof:=GetDeviceCaps(Printer.Handle,LOGPIXELSY)/GetDeviceCaps(dc,LOGPIXELSY);
  FBPGraph.UpdateMaxFontSize(1);
  ReleaseDC(self.Handle,dc);
  aSize:=Printer.PaperSize;
  FRamkaFontRatio:=1.0;
  FPSizeH:=21;
  FPSizeW:=29.7;
  for tmpi:= Default to Custom do
     begin
      if aSize=cQRPaperTranslate[tmpI] then
         begin
           FRamkaFontRatio:=cQRPaperSizeMetrics[tmpI,0]/cQRPaperSizeMetrics[A4,0];
           FPSizeH:=cQRPaperSizeMetrics[tmpI,0]/10;
           FPSizeW:=cQRPaperSizeMetrics[tmpI,1]/10;
         end;
     end;
  ramkaH:=Round(2.5*prnppi/2.54);
  FRamkaH:=ramkaH;
  { New Code }
  pw:= GetDeviceCaps(Printer.Handle,VERTRES);
  ph:= GetDeviceCaps(Printer.Handle,HORZRES);
  if ((FHorzPageCount=1) and (FVertPageCount=1)) then
   ph:= ph-ramkaH;
  { End New Code }
{  ratio:=(prnppi*FHorzPageCount) / scrppi;}
  { New Code }
  rw:=(pw*FHorzPageCount)/FBPGraph.DefWidth;
  rh:=(ph*FVertPageCount)/FBPGraph.DefHeight;
  wc:=FBPGraph.DefWidth;
  hc:=FBPGraph.DefHeight;
     case pgAlg of
      pg_Min:     Ratio:=GetCoof(rw,rh,FFormatAlg[0]);
      pg_Middle:  Ratio:=GetCoof(rw,rh,FFormatAlg[1]);
      pg_Max:     Ratio:=GetCoof(rw,rh,FFormatAlg[2]);
     end; {case pgAlg }
  { End New Code }
  Printer.BeginDoc;
  FBPGraph.SetDefaultConstants;
  FBPGraph.SetScaledConstants(rw,rh,ratio,ratio,ratio,ratio);
  FBPGraph.DefWidth:=(Printer.PageWidth*FHorzPageCount-FPageLeft*FHorzPageCount-FPageRight*FHorzPageCount);
  if ((FHorzPageCount=1) and (FVertPageCount=1)) then
   FBPGraph.DefHeight:=(Printer.PageHeight*FVertPageCount-FPageTop*FVertPageCount-FPageBottom*FVertPageCount-ramkaH*FVertPageCount)
  else
   FBPGraph.DefHeight:=(Printer.PageHeight*FVertPageCount-FPageTop*FVertPageCount-FPageBottom*FVertPageCount);
   wc:=FBPGraph.DefWidth/wc;
   hc:=FBPGraph.DefHeight/hc;
  FBPGraph.Printing:=True;
  FBPGraph.CreateGraphNodes(wc,hc);
  FBPGraph.CreateIPGraphNodes(wc,hc);
  FBPGraph.CreateGraphLinks(wc,hc);
  if FBPGraph.ShowDataWare then
        FBPGraph.CreateDGraphNodes(wc,hc)
   else
        FBPGraph.ClearDGraphNodes;
  FBPGraph.PresetupFrame(wc,hc);
  FBPGraph.TraceRoute;
  Repaint;
  while FPainting do;
  {}
  if (FBPGraph.FGlobalOperationSize/(FBPGraph.FDefHeight+1))>FBPGraph.FMaxGOS then
      ioFontRatio:=(FBPGraph.FDefHeight*FBPGraph.FMaxGOS)/(FBPGraph.FGlobalOperationSize+1)
     else
      ioFontRatio:=ratio;
  if ioFontRatio>ratio then ioFontRatio:=ratio;
  if ioFontRatio>hc then ioFontRatio:=hc;
  FBPGraph.DefWidth:=(Printer.PageWidth*FHorzPageCount-FPageLeft*FHorzPageCount-FPageRight*FHorzPageCount);
  if ((FHorzPageCount=1) and (FVertPageCount=1)) then
   FBPGraph.DefHeight:=(Printer.PageHeight*FVertPageCount-FPageTop*FVertPageCount-FPageBottom*FVertPageCount-ramkaH*FVertPageCount)
  else
   FBPGraph.DefHeight:=(Printer.PageHeight*FVertPageCount-FPageTop*FVertPageCount-FPageBottom*FVertPageCount);
   FBPGraph.SetDefaultConstants;
  FBPGraph.SetScaledConstants(wc,hc,ratio,Ratio,Ratio,iofontRatio);
  FBPGraph.CreateGraphNodes(wc,hc);
  FBPGraph.CreateIPGraphNodes(wc,hc);
  FBPGraph.CreateGraphLinks(wc,hc);
  if FBPGraph.ShowDataWare then
        FBPGraph.CreateDGraphNodes(wc,hc)
   else
        FBPGraph.ClearDGraphNodes;
  FBPGraph.PresetupFrame(wc,hc);
  FBPGraph.TraceRoute;
  Repaint;
  while FPainting do;
  {}
  nw:=FBPGraph.NodeWidth;
  nh:=FBPGraph.NodeHeight;
  mw:=FBPGraph.MaxWidth;
  mh:=FBPGraph.MaxHeight;
  rw:=ratio*nw/mw;
  rh:=ratio*nh/mh;
  case pgAlg of
       pg_Min:     fontRatio:=GetCoof(rw,rh,FFormatAlg[0]);
       pg_Middle:  fontRatio:=GetCoof(rw,rh,FFormatAlg[1]);
       pg_Max:     fontRatio:=GetCoof(rw,rh,FFormatAlg[2]);
  end;
  if fontRatio>ratio then fontRatio:=ratio;
  LabelFontRatio:=fontRatio*FBPGraph.FMaxCH;
  FBPGraph.DefWidth:=(Printer.PageWidth*FHorzPageCount-FPageLeft*FHorzPageCount-FPageRight*FHorzPageCount);
  if ((FHorzPageCount=1) and (FVertPageCount=1)) then
   FBPGraph.DefHeight:=(Printer.PageHeight*FVertPageCount-FPageTop*FVertPageCount-FPageBottom*FVertPageCount-ramkaH*FVertPageCount)
  else
   FBPGraph.DefHeight:=(Printer.PageHeight*FVertPageCount-FPageTop*FVertPageCount-FPageBottom*FVertPageCount);
  if (FBPGraph.FGlobalOperationSize/(FBPGraph.FDefHeight+1))>FBPGraph.FMaxGOS then
      ioFontRatio:=(FBPGraph.FDefHeight*FBPGraph.FMaxGOS)/(FBPGraph.FGlobalOperationSize+1)*FontRatio
  else
      ioFontRatio:=ioFontRatio*fontRatio;
  if ioFontRatio>ratio then ioFontRatio:=ratio;
  if ioFontRatio>hc then ioFontRatio:=hc;
  FBPGraph.SetDefaultConstants;
  FBPGraph.SetScaledConstants(wc,hc,ratio,fontRatio,LabelFontRatio,iofontRatio);
  FBPGraph.CreateGraphNodes(wc,hc);
  FBPGraph.CreateIPGraphNodes(wc,hc);
  FBPGraph.CreateGraphLinks(wc,hc);
  if FBPGraph.ShowDataWare then
        FBPGraph.CreateDGraphNodes(wc,hc)
   else
        FBPGraph.ClearDGraphNodes;
  FBPGraph.PresetupFrame(wc,hc);
  FBPGraph.TraceRoute;
  Repaint;
  while FPainting do;
   for px:=1 to FHorzPageCount do
    begin
     clRect.Left:=(px-1)*(Printer.PageWidth-FPageRight-FPageLeft);
     clRect.Right:=px*(Printer.PageWidth-FPageRight-FPageLeft);
    for py:=1 to FVertPageCount do
     begin
     clRect.Top:=(py-1)*(Printer.PageHeight-FPageTop-FPageBottom);
     clRect.Bottom:=py*(Printer.PageHeight-FPageTop-FPageBottom);
     if ((FHorzPageCount=1) and (FVertPageCount=1)) then
       begin
        PaintTo(Printer.Handle,FPageLeft,FPageTop+(ramkaH div 2));
        PrintStandartRectangle(cl);
       end
      else
       begin
        PaintPageTo(Printer.Handle,FPageLeft,FPageTop,clRect);
        PrintRect(FPageLeft,Printer.PageWidth-FPageRight,
                           FPageTop,Printer.PageHeight-FPageBottom);
       end;
       if ((FHorzPageCount<>px) or (FVertPageCount<>py)) then
        Printer.NewPage;
     end;
    end;
  finally
   Printer.EndDoc;
   FPrinting:=False;
   FUpdatingNavigator:=False;
   FPreviewOrPrint:=False;
   FBPGraph.SetDefaultConstants;
   FBPGraph.Printing:=False;
   FBPGraph.CreateGraphNodes(1,1);
   FBPGraph.CreateIPGraphNodes(1,1);
   FBPGraph.CreateGraphLinks(1,1);
   if FBPGraph.ShowDataWare then
        FBPGraph.CreateDGraphNodes(1,1)
   else
        FBPGraph.ClearDGraphNodes;
{   FBPGraph.CheckLinksAndNodes;}
   FBPGraph.SetScaled2(oldScaled2);
   FBPGraph.SetScaled(oldScaled);
   if (not(oldScaled)) then FBPGraph.PresetupFrame(1,1);
   FBPGraph.TraceRoute;
   Invalidate;
  end;
end;

function   TBPFrame.GetHeaderBitmapSize:TPoint;
Var w,h:Integer;
    ppsmh,ppsmw:Integer;
    rw:Double;
Const coof=0.6;
      coof1=4.2;
 begin
  w:=Printer.PageWidth;
  ppsmw:=Round(w/FPSizeW*FRamkaFontRatio);
  h:=Printer.PageHeight;
  ppsmh:=Round((h*1.5)/FPSizeH*FRamkaFontRatio);
  rw:=coof*FBPGraph.DefWidth/FBPGraph.DefHeight*coof1;
  Result.x:=Round(rw*ppsmw);
  Result.y:=Round(coof*ppsmh);
 end;

procedure  TBPFrame.PrintStandartRectangle(cl:String); { Checked }
Var oldColor:TColor;
    w,h:Integer;
    ppsmh:Integer;
    ppsmh2:Integer;
    ppsmw:Integer;
    ppsmw2:Integer;
    oldFontSize:Integer;
    oldFontName:TFontName;
    oldFontStyle:TFontStyles;
    oldFontColor:TColor;
    oldFontCharset:TFontCharset;
    s:String;
    lev:Integer;
 begin
  { Print Rect for Document }
   with Printer.Canvas do
    begin
     oldFontSize:=Font.Size;
     oldFontName:=Font.Name;
     oldFontStyle:=Font.Style;
     oldFontColor:=Font.Color;
     oldFontCharset:=Font.Charset;
     Font.Size:=Round(10*FRamkaFontRatio);
     Font.Name:='Times New Roman';
     Font.Charset:=RUSSIAN_CHARSET;
     oldColor:=Pen.Color;
     Pen.Color:=clBlack;
     w:=Printer.PageWidth;
     h:=Printer.PageHeight;
     ppsmh:=Round((h*1.5)/FPSizeH*FRamkaFontRatio);
{     ppsmh:=Round(GetDeviceCaps(Printer.Handle,LOGPIXELSX)*1.5/2.54);}
     ppsmh2:=ppsmh div 2;
      ppsmw:=Round(w/FPSizeW*FRamkaFontRatio);
{     ppsmw:=Round(GetDeviceCaps(Printer.Handle,LOGPIXELSX)/2.54);}
     ppsmw2:=ppsmw div 2;
     { Draw Ramka }
     MoveTo(FPageLeft,FPageTop);
     LineTo(w-FPageRight,FPageTop);
     LineTo(w-FPageRight,h-FPageBottom);
     LineTo(FPageLeft,h-FPageBottom);
     LineTo(FPageLeft,FPageTop);
     { Draw foother}
     MoveTo(FPageLeft,h-FPageBottom-ppsmh2);
     LineTo(w-FPageRight,h-FPageBottom-ppsmh2);
     MoveTo(FPageLeft+5*ppsmw,h-FPageBottom-ppsmh2);
     LineTo(FPageLeft+5*ppsmw,h-FPageBottom);
     MoveTo(w-FPageRight-6*ppsmw,h-FPageBottom-ppsmh2);
     LineTo(w-FPageRight-6*ppsmw,h-FPageBottom);
     MoveTo(w-FPageRight,h-FPageBottom-Round(ppsmh*0.35));
     LineTo(w-FPageRight-2*ppsmw,h-FPageBottom-Round(ppsmh*0.35));
     LineTo(w-FPageRight-2*ppsmw,h-FPageBottom);
     { Draw header }
     MoveTo(FPageLeft,FPageTop+ppsmh);
     LineTo(w-FPageRight,FPageTop+ppsmh);
     MoveTo(FPageLeft+Round(4.5*ppsmw),FPageTop);
     LineTo(FPageLeft+Round(4.5*ppsmw),FPageTop+ppsmh);
     MoveTo(w-FPageRight-5*ppsmw,FPageTop);
     LineTo(w-FPageRight-5*ppsmw,FPageTop+ppsmh);
     MoveTo(w-FPageRight-11*ppsmw,FPageTop);
     LineTo(w-FPageRight-11*ppsmw,FPageTop+ppsmh);
     MoveTo(w-FPageRight-14*ppsmw,FPageTop);
     LineTo(w-FPageRight-14*ppsmw,FPageTop+ppsmh);
     MoveTo(w-FPageRight-Round(14.4*ppsmw),FPageTop);
     LineTo(w-FPageRight-Round(14.4*ppsmw),FPageTop+ppsmh);
     MoveTo(w-FPageRight-Round(14.4*ppsmw),FPageTop+(ppsmh2 div 2));
     LineTo(w-FPageRight-5*ppsmw,FPageTop+(ppsmh2 div 2));
     MoveTo(w-FPageRight-Round(14.4*ppsmw),FPageTop+ppsmh2);
     LineTo(w-FPageRight-5*ppsmw,FPageTop+ppsmh2);
     MoveTo(w-FPageRight-Round(14.4*ppsmw),FPageTop+(ppsmh2 div 2)+ppsmh2);
     LineTo(w-FPageRight-5*ppsmw,FPageTop+(ppsmh2 div 2)+ppsmh2);
     { DrawText }
       { Foother text }
     s:=':';
     TextOut(FPageLeft+ppsmw2,h-FPageBottom-((ppsmh2-Font.Height) div 2),s);
     if BPGraph.ssLevel<>'-1' then
      s:='A'+BPGraph.ssLevel+'/C'+IntToStr(BPGraph.FLevelPageNumber)
     else
      s:='A-0/C'+IntToStr(BPGraph.FLevelPageNumber);
     TextOut(FPageLeft+ppsmw2+ppsmw,h-FPageBottom-((ppsmh2-Font.Height) div 2),s);
     s:=':';
     TextOut(FPageLeft+5*ppsmw+ppsmw2,h-FPageBottom-((ppsmh2-Font.Height) div 2),s);
     if BPGraph.ssLevel<>'-1' then
      s:='A'+BPGraph.ssLevel+': '+BPGraph.FLevelCaption
     else
      s:=BPGraph.FLevelCaption;
{!!!} s:=CalcNewString(s,Printer.Canvas,(w-FPageRight-Round(6.5*ppsmw))-(FPageLeft+5*ppsmw+5*ppsmw2));
     TextOut(FPageLeft+5*ppsmw+5*ppsmw2,h-FPageBottom-((ppsmh2-Font.Height) div 2),s);
      s:=':';
     TextOut(w-FPageRight-6*ppsmw+ppsmw2,h-FPageBottom-((ppsmh2-Font.Height) div 2),s);
      s:='. '+IntToStr(BPGraph.FLevelPageNumber);
     TextOut(w-FPageRight-6*ppsmw+4*ppsmw2,h-FPageBottom-((ppsmh2-Font.Height) div 2),s);
     { header text }
      s:=' :';
     TextOut(FPageLeft+ppsmw2,FPageTop-(Font.Height div 2),s);
      s:=BPGraph.FHeader.ssCompany;
{!!!} TextRect(Rect(FPageLeft+ppsmw2,FPageTop+ppsmh2+(Font.Height div 2),FPageLeft+4*ppsmw,FPageTop+ppsmh+(Font.Height div 2))
               ,FPageLeft+ppsmw2,FPageTop+ppsmh2+(Font.Height div 2),s);
      s:=':';
     TextOut(FPageLeft+5*ppsmw,FPageTop+(ppsmh2 div 2)+((Font.Height*4) div 5),s);
      s:=BPGraph.FHeader.ssAuthor;
{!!!} s:=CalcNewString(s,Printer.Canvas,(w-FPageRight-Round(17.8*ppsmw))-(FPageLeft+7*ppsmw));
     TextOut(FPageLeft+7*ppsmw,FPageTop+(ppsmh2 div 2)+((Font.Height*4) div 5),s);
      s:=':';
     TextOut(FPageLeft+5*ppsmw,FPageTop+ppsmh2+((Font.Height*4) div 5),s);
      s:=BPGraph.FHeader.ssModel;
{!!!} s:=CalcNewString(s,Printer.Canvas,(w-FPageRight-Round(17.8*ppsmw))-(FPageLeft+7*ppsmw));
     TextOut(FPageLeft+7*ppsmw,FPageTop+ppsmh2+((Font.Height*4) div 5),s);
      s:=':';
     TextOut(FPageLeft+5*ppsmw,FPageTop+Round(ppsmh*0.9)+((Font.Height*4) div 5),s);
      s:=BPGraph.FLevelNotes;
{!!!} s:=CalcNewString(s,Printer.Canvas,(w-FPageRight-Round(17.8*ppsmw))-(FPageLeft+7*ppsmw));
     TextOut(FPageLeft+7*ppsmw,FPageTop+Round(ppsmh*0.9)+((Font.Height*4) div 5),s);
      s:=':';
     TextOut(w-FPageRight-Round(17.5*ppsmw),FPageTop+(ppsmh2 div 2)+((Font.Height*4) div 5),s);
      s:=DateToStr(BPGraph.FHeader.dfDateTime);
     TextOut(w-FPageRight-Round(16.1*ppsmw),FPageTop+(ppsmh2 div 2)+((Font.Height*4) div 5),s);
      s:=':';
     TextOut(w-FPageRight-Round(17.5*ppsmw),FPageTop+ppsmh2+((Font.Height*4) div 5),s);
      s:=IntToStr(BPGraph.FLevelRevision);
     TextOut(w-FPageRight-Round(16.1*ppsmw),FPageTop+ppsmh2+((Font.Height*4) div 5),s);
      s:=':';
     TextOut(w-FPageRight-Round(17.5*ppsmw),FPageTop+Round(ppsmh*0.9)+((Font.Height*4) div 5),s);
      s:=TimeToStr(BPGraph.FHeader.dfDateTime);
     TextOut(w-FPageRight-Round(16.1*ppsmw),FPageTop+Round(ppsmh*0.9)+((Font.Height*4) div 5),s);
     Font.Size:=Round(8*FRamkaFontRatio);
      s:=' ';
     TextOut(w-FPageRight-Round(13.8*ppsmw),FPageTop-(Font.Height div 5),s);
      s:='';
     TextOut(w-FPageRight-Round(13.8*ppsmw),FPageTop+(ppsmh2 div 2)-(Font.Height div 5),s);
      s:='';
     TextOut(w-FPageRight-Round(13.8*ppsmw),FPageTop+ppsmh2-(Font.Height div 5),s);
      s:='';
     TextOut(w-FPageRight-Round(13.8*ppsmw),FPageTop+3*(ppsmh2 div 2)-(Font.Height div 5),s);
     Font.Style:=[fsBold];
      s:='';
     TextOut(w-FPageRight-Round(10.8*ppsmw),FPageTop-(Font.Height div 5),s);
      s:='';
     TextOut(w-FPageRight-Round(7.0*ppsmw),FPageTop-(Font.Height div 5),s);
     Font.Style:=[];
      s:=':';
     TextOut(w-FPageRight-Round(3.5*ppsmw),FPageTop-(Font.Height div 5),s);
     { Draw context }
     if (BPGraph.ssLevel<>'-1') and (BPGraph.ssLevel<>'0') then
      begin
       if FDrawCBitmap then
        begin
         Draw(Round(w-FPageRight-4.8*ppsmw),Round(FPageTop+ppsmh*0.05),FContextBitmap);
         s:=':';
         TextOut(w-FPageRight-Round(3.5*ppsmw),FPageTop-(Font.Height div 5),s);
         s:=cl;
         Font.Size:=Round(14*FRamkaFontRatio);
         Font.Style:=[fsBold];
         TextOut(w-FPageRight-Round(2.5*ppsmw),FPageTop+(ppsmh2 div 2)-(Font.Height div 5),s);
        end
       else
        begin
         s:=cl;
         Font.Size:=Round(16*FRamkaFontRatio);
         Font.Style:=[fsBold];
         TextOut(w-FPageRight-Round(3.5*ppsmw),FPageTop+(ppsmh2 div 2)-(Font.Height div 5),s);
        end;
      end
     else
      begin
       if (BPGraph.ssLevel='0') then
        s:=''
       else s:='';
        Font.Size:=Round(16*FRamkaFontRatio);
        Font.Style:=[fsBold];
       TextOut(w-FPageRight-Round(3.5*ppsmw),FPageTop+(ppsmh2 div 2)-(Font.Height div 5),s);
      end;
      { Draw Draft Status }
      Font.Size:=Round(8*FRamkaFontRatio);
      Font.Style:=[fsBold];
      s:='x';
      if dsWorking in BPGraph.FLevelDraftStatus then
       TextOut(w-FPageRight-Round(14.3*ppsmw),FPageTop-(Font.Height div 5),s);
      if dsDraft in BPGraph.FLevelDraftStatus then
       TextOut(w-FPageRight-Round(14.3*ppsmw),FPageTop+(ppsmh2 div 2)-(Font.Height div 5),s);
      if dsRecomended in BPGraph.FLevelDraftStatus then
       TextOut(w-FPageRight-Round(14.3*ppsmw),FPageTop+ppsmh2-(Font.Height div 5),s);
      if dsPublication in BPGraph.FLevelDraftStatus then
       TextOut(w-FPageRight-Round(14.3*ppsmw),FPageTop+3*(ppsmh2 div 2)-(Font.Height div 5),s);
     {EndDrawText}
     Pen.Color:=oldColor;
     Font.Size:=oldFontSize;
     Font.Name:=oldFontName;
     Font.Style:=oldFontStyle;
     Font.Color:=oldFontColor;
     Font.Charset:=oldFontCharset;
    end;
 end;

function   TBPFrame.CalcNewString(s:String;Const outCanvas:TCanvas;MaxWidth:Integer):String; { Checked }
Var ss:String;
 begin
   ss:=s;
   while ((outCanvas.TextExtent(ss).cx>MaxWidth)  and (length(ss)>0)) do
    begin
     ss:=copy(ss,1,length(ss)-1);
    end;
  Result:=ss;
 end;


function   TBPFrame.GetHeaderBitmapSizePreview(pw,ph:Integer):TPoint;
Var w,h:Integer;
    ppsmh,ppsmw:Integer;
    rw:Double;
Const coof=0.7;
      coof1=1.2;
 begin
  w:=pw;
  ppsmw:=Round((w+FPageRight)/FPSizeW*FRamkaFontRatio);
  h:=ph;
  ppsmh:=Round(((h+FPageBottom-FRamkaH)*1.5)/FPSizeH*FRamkaFontRatio);
  rw:=coof*FBPGraph.DefWidth/FBPGraph.DefHeight*coof1;
  Result.x:=Round(rw*ppsmw);
  Result.y:=Round(0.7*ppsmh);
 end;


procedure  TBPFrame.PreviewStandartRectangle(pw,ph:Integer;cl:String); { Checked }
Var oldColor:TColor;
    w,h:Integer;
    ppsmh:Integer;
    ppsmh2:Integer;
    ppsmw:Integer;
    ppsmw2:Integer;
    oldFontSize:Integer;
    oldFontName:TFontName;
    oldFontStyle:TFontStyles;
    oldFontColor:TColor;
    oldFontCharset:TFontCharset;
    s:String;
    lev:Integer;
 begin
  { Print Rect for Document }
   if FPrinter = nil then Exit;
   with FPrinter.Canvas do
    begin
     oldFontSize:=Font.Size;
     oldFontName:=Font.Name;
     oldFontStyle:=Font.Style;
     oldFontColor:=Font.Color;
     oldFontCharset:=Font.Charset;
     Font.Size:=Round(10*FRamkaFontRatio); {  A4,      !!!! }
     Font.Name:='Times New Roman';
     Font.Charset:=RUSSIAN_CHARSET;
     oldColor:=Pen.Color;
     Pen.Color:=clBlack;
     w:=pw;
     h:=ph;
{     ppsmh:=Round(GetDeviceCaps(FPrinter.Canvas.Handle,LOGPIXELSX)*1.5/2.54);}
     ppsmh:=Round(((h+FPageBottom-FRamkaH)*1.5)/FPSizeH*FRamkaFontRatio);
     ppsmh2:=ppsmh div 2;
{     ppsmw:=Round(GetDeviceCaps(FPrinter.Canvas.Handle,LOGPIXELSX)/2.54);}
     ppsmw:=Round((w+FPageRight)/FPSizeW*FRamkaFontRatio);
     ppsmw2:=ppsmw div 2;
     { Draw Ramka }
     MoveTo(FPageLeft,FPageTop);
     LineTo(w-FPageRight,FPageTop);
     LineTo(w-FPageRight,h-FPageBottom);
     LineTo(FPageLeft,h-FPageBottom);
     LineTo(FPageLeft,FPageTop);
     { Draw foother}
     MoveTo(FPageLeft,h-FPageBottom-ppsmh2);
     LineTo(w-FPageRight,h-FPageBottom-ppsmh2);
     MoveTo(FPageLeft+5*ppsmw,h-FPageBottom-ppsmh2);
     LineTo(FPageLeft+5*ppsmw,h-FPageBottom);
     MoveTo(w-FPageRight-6*ppsmw,h-FPageBottom-ppsmh2);
     LineTo(w-FPageRight-6*ppsmw,h-FPageBottom);
     MoveTo(w-FPageRight,h-FPageBottom-Round(ppsmh*0.35));
     LineTo(w-FPageRight-2*ppsmw,h-FPageBottom-Round(ppsmh*0.35));
     LineTo(w-FPageRight-2*ppsmw,h-FPageBottom);
     { Draw header }
     MoveTo(FPageLeft,FPageTop+ppsmh);
     LineTo(w-FPageRight,FPageTop+ppsmh);
     MoveTo(FPageLeft+Round(4.5*ppsmw),FPageTop);
     LineTo(FPageLeft+Round(4.5*ppsmw),FPageTop+ppsmh);
     MoveTo(w-FPageRight-5*ppsmw,FPageTop);
     LineTo(w-FPageRight-5*ppsmw,FPageTop+ppsmh);
     MoveTo(w-FPageRight-11*ppsmw,FPageTop);
     LineTo(w-FPageRight-11*ppsmw,FPageTop+ppsmh);
     MoveTo(w-FPageRight-14*ppsmw,FPageTop);
     LineTo(w-FPageRight-14*ppsmw,FPageTop+ppsmh);
     MoveTo(w-FPageRight-Round(14.4*ppsmw),FPageTop);
     LineTo(w-FPageRight-Round(14.4*ppsmw),FPageTop+ppsmh);
     MoveTo(w-FPageRight-Round(14.4*ppsmw),FPageTop+(ppsmh2 div 2));
     LineTo(w-FPageRight-5*ppsmw,FPageTop+(ppsmh2 div 2));
     MoveTo(w-FPageRight-Round(14.4*ppsmw),FPageTop+ppsmh2);
     LineTo(w-FPageRight-5*ppsmw,FPageTop+ppsmh2);
     MoveTo(w-FPageRight-Round(14.4*ppsmw),FPageTop+(ppsmh2 div 2)+ppsmh2);
     LineTo(w-FPageRight-5*ppsmw,FPageTop+(ppsmh2 div 2)+ppsmh2);
     { DrawText }
       { Foother text }
     s:=':';
     TextOut(FPageLeft+ppsmw2,h-FPageBottom-((ppsmh2-Font.Height) div 2),s);
     if BPGraph.ssLevel<>'-1' then
      s:='A'+BPGraph.ssLevel+'/C'+IntToStr(BPGraph.FLevelPageNumber)
     else
      s:='A-0/C'+IntToStr(BPGraph.FLevelPageNumber);
     TextOut(FPageLeft+ppsmw2+ppsmw,h-FPageBottom-((ppsmh2-Font.Height) div 2),s);
     s:=':';
     TextOut(FPageLeft+5*ppsmw+ppsmw2,h-FPageBottom-((ppsmh2-Font.Height) div 2),s);
     if BPGraph.ssLevel<>'-1' then
      s:='A'+BPGraph.ssLevel+': '+BPGraph.FLevelCaption
     else
      s:=BPGraph.FLevelCaption;
{!!!} s:=CalcNewString(s,FPrinter.Canvas,(w-FPageRight-Round(6.5*ppsmw))-(FPageLeft+5*ppsmw+5*ppsmw2));
      TextOut(FPageLeft+5*ppsmw+5*ppsmw2,h-FPageBottom-((ppsmh2-Font.Height) div 2),s);
      s:=':';
     TextOut(w-FPageRight-6*ppsmw+ppsmw2,h-FPageBottom-((ppsmh2-Font.Height) div 2),s);
      s:='. '+IntToStr(BPGraph.FLevelPageNumber);
     TextOut(w-FPageRight-6*ppsmw+4*ppsmw2,h-FPageBottom-((ppsmh2-Font.Height) div 2),s);
     { header text }
      s:=' :';
      TextOut(FPageLeft+ppsmw2,FPageTop-(Font.Height div 2),s);
      s:=BPGraph.FHeader.ssCompany;
{!!!} TextRect(Rect(FPageLeft+ppsmw2,FPageTop+ppsmh2+(Font.Height div 2),FPageLeft+4*ppsmw,FPageTop+ppsmh+(Font.Height div 2))
               ,FPageLeft+ppsmw2,FPageTop+ppsmh2+(Font.Height div 2),s);
      s:=':';
      TextOut(FPageLeft+5*ppsmw,FPageTop+(ppsmh2 div 2)+((Font.Height*4) div 5),s);
      s:=BPGraph.FHeader.ssAuthor;
{!!!} s:=CalcNewString(s,FPrinter.Canvas,(w-FPageRight-Round(17.8*ppsmw))-(FPageLeft+7*ppsmw));
      TextOut(FPageLeft+7*ppsmw,FPageTop+(ppsmh2 div 2)+((Font.Height*4) div 5),s);
      s:=':';
      TextOut(FPageLeft+5*ppsmw,FPageTop+ppsmh2+((Font.Height*4) div 5),s);
      s:=BPGraph.FHeader.ssModel;
{!!!} s:=CalcNewString(s,FPrinter.Canvas,(w-FPageRight-Round(17.8*ppsmw))-(FPageLeft+7*ppsmw));
      TextOut(FPageLeft+7*ppsmw,FPageTop+ppsmh2+((Font.Height*4) div 5),s);
      s:=':';
     TextOut(FPageLeft+5*ppsmw,FPageTop+Round(ppsmh*0.9)+((Font.Height*4) div 5),s);
      s:=BPGraph.FLevelNotes;
{!!!} s:=CalcNewString(s,FPrinter.Canvas,(w-FPageRight-Round(17.8*ppsmw))-(FPageLeft+7*ppsmw));
      TextOut(FPageLeft+7*ppsmw,FPageTop+Round(ppsmh*0.9)+((Font.Height*4) div 5),s);
      s:=':';
     TextOut(w-FPageRight-Round(17.5*ppsmw),FPageTop+(ppsmh2 div 2)+((Font.Height*4) div 5),s);
      s:=DateToStr(BPGraph.FHeader.dfDateTime);
     TextOut(w-FPageRight-Round(16.1*ppsmw),FPageTop+(ppsmh2 div 2)+((Font.Height*4) div 5),s);
      s:=':';
     TextOut(w-FPageRight-Round(17.5*ppsmw),FPageTop+ppsmh2+((Font.Height*4) div 5),s);
      s:=IntToStr(BPGraph.FLevelRevision);
     TextOut(w-FPageRight-Round(16.1*ppsmw),FPageTop+ppsmh2+((Font.Height*4) div 5),s);
      s:=':';
     TextOut(w-FPageRight-Round(17.5*ppsmw),FPageTop+Round(ppsmh*0.9)+((Font.Height*4) div 5),s);
      s:=TimeToStr(BPGraph.FHeader.dfDateTime);
     TextOut(w-FPageRight-Round(16.1*ppsmw),FPageTop+Round(ppsmh*0.9)+((Font.Height*4) div 5),s);
     Font.Size:=Round(8*FRamkaFontRatio);
      s:=' ';
     TextOut(w-FPageRight-Round(13.8*ppsmw),FPageTop-(Font.Height div 5),s);
      s:='';
     TextOut(w-FPageRight-Round(13.8*ppsmw),FPageTop+(ppsmh2 div 2)-(Font.Height div 5),s);
      s:='';
     TextOut(w-FPageRight-Round(13.8*ppsmw),FPageTop+ppsmh2-(Font.Height div 5),s);
      s:='';
     TextOut(w-FPageRight-Round(13.8*ppsmw),FPageTop+3*(ppsmh2 div 2)-(Font.Height div 5),s);
     Font.Style:=[fsBold];
      s:='';
     TextOut(w-FPageRight-Round(10.8*ppsmw),FPageTop-(Font.Height div 5),s);
      s:='';
     TextOut(w-FPageRight-Round(7.0*ppsmw),FPageTop-(Font.Height div 5),s);
     Font.Style:=[];
      s:=':';
     TextOut(w-FPageRight-Round(3.5*ppsmw),FPageTop-(Font.Height div 5),s);
     { Draw context }
     if (BPGraph.ssLevel<>'-1') and (BPGraph.ssLevel<>'0') then
      begin
       Draw(Round(w-FPageRight-4.8*ppsmw),Round(FPageTop+ppsmh*0.05),FContextBitmap);
      s:=cl;
      Font.Size:=Round(16*FRamkaFontRatio);
      Font.Style:=[fsBold];
      TextOut(w-FPageRight-Round(3.5*ppsmw),FPageTop+(ppsmh2 div 2)-(Font.Height div 5),s);
      end
     else
      begin
       if (BPGraph.ssLevel='0') then
        s:=''
       else s:='';
        Font.Size:=Round(16*FRamkaFontRatio);
        Font.Style:=[fsBold];
       TextOut(w-FPageRight-Round(3.5*ppsmw),FPageTop+(ppsmh2 div 2)-(Font.Height div 5),s);
      end;
      { Draw Draft Status }
      Font.Size:=Round(8*FRamkaFontRatio);
      Font.Style:=[fsBold];
      s:='x';
      if dsWorking in BPGraph.FLevelDraftStatus then
       TextOut(w-FPageRight-Round(14.3*ppsmw),FPageTop-(Font.Height div 5),s);
      if dsDraft in BPGraph.FLevelDraftStatus then
       TextOut(w-FPageRight-Round(14.3*ppsmw),FPageTop+(ppsmh2 div 2)-(Font.Height div 5),s);
      if dsRecomended in BPGraph.FLevelDraftStatus then
       TextOut(w-FPageRight-Round(14.3*ppsmw),FPageTop+ppsmh2-(Font.Height div 5),s);
      if dsPublication in BPGraph.FLevelDraftStatus then
       TextOut(w-FPageRight-Round(14.3*ppsmw),FPageTop+3*(ppsmh2 div 2)-(Font.Height div 5),s);
     {EndDrawText}
     Pen.Color:=oldColor;
     Font.Size:=oldFontSize;
     Font.Name:=oldFontName;
     Font.Style:=oldFontStyle;
     Font.Color:=oldFontColor;
     Font.Charset:=oldFontCharset;
    end;
 end;

procedure TBPFrame.CreatePreviewAll(pb:TFlatProgressBar;Lbl:TLabel); { Checked }
Var savedOrd:TPrinterOrientation;
    pw,ph:Integer;
    fpl,fpr,fpt,fpb:Integer;
    ratio,fontRatio,LabelFontRatio,ioFontRatio:Double;
    rw,rh:Double;
    dc:HDC;
    scrppi:LongInt;
    ramkaH:Integer;
    nw,nh,mw,mh:Integer;
    oldLevel:Integer;
    tmpTree:PBPTree;
    i:Integer;
    oldScaled:Boolean;
    oldScaled2:Boolean;
    px,py:Integer;
    clrect:TRect;
    aSize:Integer;
    tmpi:TQRPaperSize;
    wc,hc:Double;
    bmsize:TPoint;
    pgalg:TBPPgAlg;
    cl:String;
begin
 { Create QRPreview Model }
   oldScaled:=BPGraph.Scaled;
   oldScaled2:=BPGraph.Scaled2;
   if FBPGraph.FTree=nil then Exit;
   FPreviewOrPrint:=True;
   FUpdatingNavigator:=True;
   FDrawCBitmap:=True;
   FBPGraph.Scaled2:=False;
   if FBPGraph.FScaled then FBPGraph.Scaled:=False;
   tmpTree:=FBPGraph.FTree;
   if (fPrinter<>nil) then fPrinter.Free;
   savedOrd:=Printer.Orientation;
   oldLevel:=FBPGraph.FLevel;
   FPrinter:=TQRPrinter.Create;
   try
    FPrinting:=True;
    FPrinter.Cleanup;
    FPrinter.BeginDoc;
    FPrinter.Orientation:=savedOrd;
    Printer.Orientation:=savedOrd;
    FPrinter.PrinterIndex:=Printer.PrinterIndex;
    aSize:=Printer.PaperSize;
    FPrinter.PaperSize:=Default;
    FRamkaFontRatio:=1.0;
    FPSizeH:=21;
    FPSizeW:=29.7;
    for tmpi:= Default to Custom do
     begin
      if aSize=cQRPaperTranslate[tmpI] then
         begin
           FPrinter.PaperSize := tmpI;
           FRamkaFontRatio:=cQRPaperSizeMetrics[tmpI,0]/cQRPaperSizeMetrics[A4,0];
           FPSizeH:=cQRPaperSizeMetrics[tmpI,0]/10;
           FPSizeW:=cQRPaperSizeMetrics[tmpI,1]/10;
         end;
     end;
    FPrinter.PaperLength:=Printer.PaperLength;
    FPrinter.PaperWidth:=Printer.PaperWidth;
    dc:=GetDC(0);
    scrppi:=GetDeviceCaps(dc,LOGPIXELSX);
    FFontCoof:=1;
    FBPGraph.UpdateMaxFontSize(1);
    ReleaseDC(0,dc);
    ramkaH:=Round(scrppi/2.54);
    FRamkaH:=ramkaH;
    FPrinter.NewPage;
   if SavedOrd=poPortrait then
   begin
    pw:= FPrinter.XSize(FPrinter.PaperWidth);
    ph:= FPrinter.YSize(FPrinter.PaperLength);
   end
   else
   begin
    pw:= FPrinter.XSize(FPrinter.PaperLength);
    ph:= FPrinter.YSize(FPrinter.PaperWidth);
   end;
   if ((FHorzPageCount=1) and (FVertPageCount=1)) then
     ph:=ph - ramkaH;
   fpl:=FPrinter.XSize(FPageLeft*10);
   fpr:=FPrinter.XSize(FPageRight*10);
   fpt:=FPrinter.YSize(FPageTop*10);
   fpb:=FPrinter.YSize(FPageBottom*10);
   i:=0;
   bmsize:=GetHeaderBitmapSizePreview(pw-FPageRight,ph-FPageBottom+ramkaH);
   FContextBitmap.Width:=bmsize.x;
   FContextBitmap.Height:=bmsize.y;
   while (tmpTree<>nil) and (not(FAborting)) do
    begin
     FBPGraph.OpenLevel(tmpTree^.dwLevel);
     FBPGraph.TraceRoute;
     Repaint;
     if (FBPGraph.FNodesCount>FNodesValue[0]) then
      begin
        if (FBPGraph.FNodesCount<FNodesValue[1]) then
          pgAlg:=pg_Middle
        else
          pgAlg:=pg_Max;
      end
     else pgalg:=pg_Min;
     cl:=FillBitmapWithSize(FContextBitmap,bmsize.x,bmsize.y,tmptree^.dwParent);
     inc(i);
     pb.Position:=Round((i-1)*100/FBPGraph.FRootEntries);
     lbl.Caption:=IntToStr(pb.Position);
     pb.Update;
     lbl.Update;
     Application.ProcessMessages;
     if FAborting then break;
     while (FPainting) do;
     if HorzScrollBar.Visible then HorzScrollBar.Position:=0;
     if VertScrollBar.Visible then VertScrollBar.Position:=0;
     rw:=(pw*FHorzPageCount)/FBPGraph.DefWidth;
     rh:=(ph*FVertPageCount)/FBPGraph.DefHeight;
     wc:=FBPGraph.DefWidth;
     hc:=FBPGraph.DefHeight;
     case pgAlg of
      pg_Min:     Ratio:=GetCoof(rw,rh,FFormatAlg[0]);
      pg_Middle:  Ratio:=GetCoof(rw,rh,FFormatAlg[1]);
      pg_Max:     Ratio:=GetCoof(rw,rh,FFormatAlg[2]);
     end; {case pgAlg }
     FBPGraph.SetDefaultConstants;
     FBPGraph.SetScaledConstants(rw,rh,ratio,ratio,ratio,ratio);
     FBPGraph.DefWidth:=(PW*FHorzPageCount-FPL*FHorzPageCount-FPR*FHorzPageCount);
     if ((FHorzPageCount=1) and (FVertPageCount=1)) then
      FBPGraph.DefHeight:=(PH*FVertPageCount-FPT*FVertPageCount-FPB*FVertPageCount-ramkaH*FVertPageCount)
     else
      FBPGraph.DefHeight:=(PH*FVertPageCount-FPT*FVertPageCount-FPB*FVertPageCount);
     wc:=FBPGraph.DefWidth/wc;
     hc:=FBPGraph.DefHeight/hc;
     FBPGraph.Printing:=True;
     FBPGraph.CreateGraphNodes(wc,hc);
     FBPGraph.CreateIPGraphNodes(wc,hc);
     FBPGraph.CreateGraphLinks(wc,hc);
     if FBPGraph.ShowDataWare then
        FBPGraph.CreateDGraphNodes(wc,hc)
     else
        FBPGraph.ClearDGraphNodes;
     FBPGraph.PresetupFrame(wc,hc);
     FBPGraph.TraceRoute;
     Repaint;
    while FPainting do;
    {}
    if (FBPGraph.FGlobalOperationSize/(FBPGraph.FDefHeight+1))>FBPGraph.FMaxGOS then
      ioFontRatio:=(FBPGraph.FDefHeight*FBPGraph.FMaxGOS)/(FBPGraph.FGlobalOperationSize+1)
     else
      ioFontRatio:=ratio;
    if ioFontRatio>ratio then ioFontRatio:=ratio;
    if ioFontRatio>hc then ioFontRatio:=hc;
    FBPGraph.DefWidth:=(PW*FHorzPageCount-FPL*FHorzPageCount-FPR*FHorzPageCount);
    if ((FHorzPageCount=1) and (FVertPageCount=1)) then
     FBPGraph.DefHeight:=(PH*FVertPageCount-FPT*FVertPageCount-FPB*FVertPageCount-ramkaH*FVertPageCount)
    else
    FBPGraph.DefHeight:=(PH*FVertPageCount-FPT*FVertPageCount-FPB*FVertPageCount);
    FBPGraph.SetDefaultConstants;
    FBPGraph.SetScaledConstants(wc,hc,ratio,ratio,ratio,iofontRatio);
    FBPGraph.CreateGraphNodes(wc,hc);
    FBPGraph.CreateIPGraphNodes(wc,hc);
    FBPGraph.CreateGraphLinks(wc,hc);
    if FBPGraph.ShowDataWare then
        FBPGraph.CreateDGraphNodes(wc,hc)
    else
        FBPGraph.ClearDGraphNodes;
    FBPGraph.PresetupFrame(wc,hc);
    FBPGraph.TraceRoute;
    Repaint;
    while FPainting do;
    {}
    nw:=FBPGraph.NodeWidth;
    nh:=FBPGraph.NodeHeight;
    mw:=FBPGraph.MaxWidth;
    mh:=FBPGraph.MaxHeight;
    rw:=ratio*nw/mw;
    rh:=ratio*nh/mh;
    case pgAlg of
       pg_Min:     fontRatio:=GetCoof(rw,rh,FFormatAlg[0]);
       pg_Middle:  fontRatio:=GetCoof(rw,rh,FFormatAlg[1]);
       pg_Max:     fontRatio:=GetCoof(rw,rh,FFormatAlg[2]);
     end;
    if fontRatio>ratio then fontRatio:=ratio;
    LabelFontRatio:=fontRatio*FBPGraph.FMaxCH;
    FBPGraph.DefWidth:=(PW*FHorzPageCount-FPL*FHorzPageCount-FPR*FHorzPageCount);
    if ((FHorzPageCount=1) and (FVertPageCount=1)) then
     FBPGraph.DefHeight:=(PH*FVertPageCount-FPT*FVertPageCount-FPB*FVertPageCount-ramkaH*FVertPageCount)
    else
    FBPGraph.DefHeight:=(PH*FVertPageCount-FPT*FVertPageCount-FPB*FVertPageCount);
    if (FBPGraph.FGlobalOperationSize/(FBPGraph.FDefHeight+1))>FBPGraph.FMaxGOS then
      ioFontRatio:=(FBPGraph.FDefHeight*FBPGraph.FMaxGOS)/(FBPGraph.FGlobalOperationSize+1)*fontRatio
    else
      ioFontRatio:=ioFontRatio*FontRatio;
    if ioFontRatio>ratio then ioFontRatio:=ratio;
    if ioFontRatio>hc then ioFontRatio:=hc;
    FBPGraph.SetDefaultConstants;
    FBPGraph.SetScaledConstants(wc,hc,ratio,fontRatio,LabelFontRatio,iofontRatio);
    FBPGraph.CreateGraphNodes(wc,hc);
    FBPGraph.CreateIPGraphNodes(wc,hc);
    FBPGraph.CreateGraphLinks(wc,hc);
    if FBPGraph.ShowDataWare then
        FBPGraph.CreateDGraphNodes(wc,hc)
    else
        FBPGraph.ClearDGraphNodes;
    FBPGraph.PresetupFrame(wc,hc);
    FBPGraph.TraceRoute;
    Repaint;
    while FPainting do;
    for px:=1 to FHorzPageCount do
     begin
      clRect.Left:=(px-1)*(pw-fpl-fpr);
      clRect.Right:=px*(pw-fpl-fpr);
      for py:=1 to FVertPageCount do
       begin
        clRect.Top:=(py-1)*(ph-fpt-fpb);
        clRect.Bottom:=py*(ph-fpt-fpb);
        if ((FHorzPageCount=1) and (FVertPageCount=1)) then
         begin
          PaintTo(FPrinter.Canvas.Handle,fpl,fpt+ramkaH);
          PreviewStandartRectangle(pw-FPageRight,ph-FPageBottom+ramkaH,cl);
         end
        else
         begin
          PaintPageTo(FPrinter.Canvas.Handle,fpl,fpt,clRect);
          PreviewPrintRect(fpl,pw-fpr,fpt,ph-fpb);
         end;
         if ((FHorzPageCount<>px) or (FVertPageCount<>py)) then
          FPrinter.NewPage;
       end;
     end;
    tmpTree:=tmpTree^.next;
    if tmpTree<>nil then FPrinter.NewPage;
    FBPGraph.SetDefaultConstants;
    FBPGraph.Printing:=False;
    FBPGraph.CreateGraphNodes(1,1);
    FBPGraph.CreateIPGraphNodes(1,1);
    FBPGraph.CreateGraphLinks(1,1);
    if FBPGraph.ShowDataWare then
        FBPGraph.CreateDGraphNodes(1,1)
    else
        FBPGraph.ClearDGraphNodes;
    FBPGraph.PresetupFrame(1,1);
    FBPGraph.TraceRoute;
    Invalidate;
   end;
   finally
    if FAborting then FPrinter.AbortDoc else
    FPrinter.EndDoc;
    FPrinting:=False;
    FUpdatingNavigator:=False;
    FPreviewOrPrint:=False;
    FBPGraph.SetDefaultConstants;
    FBPGraph.Printing:=False;
    FBPGraph.CreateGraphNodes(1,1);
    FBPGraph.CreateIPGraphNodes(1,1);
    FBPGraph.CreateGraphLinks(1,1);
    if FBPGraph.ShowDataWare then
        FBPGraph.CreateDGraphNodes(1,1)
    else
        FBPGraph.ClearDGraphNodes;
    FBPGraph.SetScaled2(oldScaled2);
    FBPGraph.SetScaled(oldScaled);
    if (not(oldScaled)) then FBPGraph.PresetupFrame(1,1);
    FBPGraph.TraceRoute;
    Invalidate;
    pb.Position:=100;
    lbl.Caption:=IntToStr(pb.Position);
    pb.Update;
    lbl.Update;
    FBPGraph.OpenLevel(oldLevel);
    FBPGraph.TraceRoute;
    Invalidate;
   end;
end;

procedure TBPFrame.PreviewPrintRect(left,right,top,bottom:Integer);  { Checked }
Var oldStyle:TPenStyle;
begin
 if FPrinter = nil then Exit;
 oldStyle:=FPrinter.Canvas.Pen.Style;
 FPrinter.Canvas.Pen.Style:=psDot;
 FPrinter.Canvas.MoveTo(Left,Top);
 FPrinter.Canvas.LineTo(Right,Top);
 FPrinter.Canvas.LineTo(Right,Bottom);
 FPrinter.Canvas.LineTo(Left,Bottom);
 FPrinter.Canvas.LineTo(Left,Top);
 FPrinter.Canvas.Pen.Style:=oldStyle;
end;

procedure TBPFrame.CreatePreview; { Checked }
Var savedOrd:TPrinterOrientation;
    pw,ph:Integer;
    fpl,fpr,fpt,fpb:Integer;
    ratio,fontRatio,LabelFontRatio,ioFontRatio:Double;
    dc:HDC;
    rw,rh:Double;
    scrppi:LongInt;
    ramkaH:Integer;
    nw,nh,mw,mh:Integer;
    oldScaled:Boolean;
    oldScaled2:Boolean;
    px,py:Integer;
    clRect:TRect;
    aSize:Integer;
    tmpi:TQRPaperSize;
    FTmp:Double;
    wc,hc:Double;
    bmsize:TPoint;
    pgalg:TBPPgAlg;
    cl:String;
begin
 { Create QRPreview }
   oldScaled:=BPGraph.Scaled;
   oldScaled2:=BPGraph.Scaled2;
   FPreviewOrPrint:=True;
   FUpdatingNavigator:=True;
   FDrawCBitmap:=True;
   FBPGraph.Scaled2:=False;
   if FBPGraph.FScaled then FBPGraph.Scaled:=False;
   if HorzScrollBar.Visible then HorzScrollBar.Position:=0;
   if VertScrollBar.Visible then VertScrollBar.Position:=0;
   if (fPrinter<>nil) then fPrinter.Free;
   savedOrd:=Printer.Orientation;
   FPrinter:=TQRPrinter.Create;
   try
    FPrinting:=True;
    FPrinter.Cleanup;
    FPrinter.BeginDoc;
    FPrinter.Orientation:=savedOrd;
    Printer.Orientation:=savedOrd;
    FPrinter.PrinterIndex:=Printer.PrinterIndex;
    aSize:=Printer.PaperSize;
    FPrinter.PaperSize:=Default;
    FRamkaFontRatio:=1.0;
    FPSizeH:=21;
    FPSizeW:=29.7;
    for tmpi:= Default to Custom do
     begin
      if aSize=cQRPaperTranslate[tmpI] then
         begin
           FPrinter.PaperSize := tmpI;
           FRamkaFontRatio:=cQRPaperSizeMetrics[tmpI,0]/cQRPaperSizeMetrics[A4,0];
           FPSizeH:=cQRPaperSizeMetrics[tmpI,0]/10;
           FPSizeW:=cQRPaperSizeMetrics[tmpI,1]/10;
         end;
     end;
   FPrinter.PaperLength:=Printer.PaperLength; {???}
   FPrinter.PaperWidth:=Printer.PaperWidth; {???}
   dc:=GetDC(0);
   scrppi:=GetDeviceCaps(dc,LOGPIXELSX);
   FFontCoof:=1;
   FBPGraph.UpdateMaxFontSize(1);
   ReleaseDC(0,dc);
   ramkaH:=Round(scrppi/2.54);
   FRamkaH:=ramkaH;
   FPrinter.NewPage;
  { FPrinter.Canvas.Font.PixelsPerInch:=GetDeviceCaps(Printer.Handle,LOGPIXELSX);}
   if SavedOrd=poPortrait then
   begin
    pw:= FPrinter.XSize(FPrinter.PaperWidth);
    ph:= FPrinter.YSize(FPrinter.PaperLength);
   end
   else
   begin
    pw:= FPrinter.XSize(FPrinter.PaperLength);
    ph:= FPrinter.YSize(FPrinter.PaperWidth);
   end;
   if ((FHorzPageCount=1) and (FVertPageCount=1)) then
    ph:=ph-ramkaH;
   if (FBPGraph.FNodesCount>FNodesValue[0]) then
      begin
        if (FBPGraph.FNodesCount<FNodesValue[1]) then
          pgAlg:=pg_Middle
        else
          pgAlg:=pg_Max;
      end
     else pgalg:=pg_Min;
   bmsize:=GetHeaderBitmapSizePreview(pw-FPageRight,ph+ramkaH-FPageBottom);
   FContextBitmap.Width:=bmsize.x;
   FContextBitmap.Height:=bmSize.y;
   cl:=FillBitmapWithSize(FContextBitmap,bmsize.x,bmsize.y,FBPGraph.FParentLevel);
   rw:=(pw*FHorzPageCount)/FBPGraph.DefWidth;
   rh:=(ph*FVertPageCount)/FBPGraph.DefHeight;
     case pgAlg of
      pg_Min:     Ratio:=GetCoof(rw,rh,FFormatAlg[0]);
      pg_Middle:  Ratio:=GetCoof(rw,rh,FFormatAlg[1]);
      pg_Max:     Ratio:=GetCoof(rw,rh,FFormatAlg[2]);
     end; {case pgAlg }
   fpl:=FPrinter.XSize(FPageLeft*10);
   fpr:=FPrinter.XSize(FPageRight*10);
   fpt:=FPrinter.YSize(FPageTop*10);
   fpb:=FPrinter.YSize(FPageBottom*10);
   wc:=FBPGraph.DefWidth;
   hc:=FBPGraph.DefHeight;
   FBPGraph.SetDefaultConstants;
   FBPGraph.SetScaledConstants(rw,rh,ratio,ratio,ratio,ratio);
   FBPGraph.DefWidth:=(PW*FHorzPageCount-FPL*FHorzPageCount-FPR*FHorzPageCount);
   if ((FHorzPageCount=1) and (FVertPageCount=1)) then
     FBPGraph.DefHeight:=(PH*FVertPageCount-FPT*FVertPageCount-FPB*FVertPageCount-ramkaH*FVertPageCount)
   else
     FBPGraph.DefHeight:=(PH*FVertPageCount-FPT*FVertPageCount-FPB*FVertPageCount);
   wc:=FBPGraph.DefWidth/wc;
   hc:=FBPGraph.DefHeight/hc;
   FBPGraph.Printing:=True;
   FBPGraph.CreateGraphNodes(wc,hc);
   FBPGraph.CreateIPGraphNodes(wc,hc);
   FBPGraph.CreateGraphLinks(wc,hc);
   if FBPGraph.ShowDataWare then
        FBPGraph.CreateDGraphNodes(wc,hc)
   else
        FBPGraph.ClearDGraphNodes;
   FBPGraph.PresetupFrame(wc,hc);
   FBPGraph.TraceRoute;
   Repaint;
   while FPainting do;
   {}
   if (FBPGraph.FGlobalOperationSize/(FBPGraph.FDefHeight+1))>FBPGraph.FMaxGOS then
    ioFontRatio:=(FBPGraph.FDefHeight*FBPGraph.FMaxGOS)/(FBPGraph.FGlobalOperationSize+1)
   else
    ioFontRatio:=ratio;
     if ioFontRatio>ratio then ioFontRatio:=ratio;
     if ioFontRatio>hc then ioFontRatio:=hc;
   FBPGraph.DefWidth:=(PW*FHorzPageCount-FPL*FHorzPageCount-FPR*FHorzPageCount);
    if ((FHorzPageCount=1) and (FVertPageCount=1)) then
      FBPGraph.DefHeight:=(PH*FVertPageCount-FPT*FVertPageCount-FPB*FVertPageCount-ramkaH*FVertPageCount)
    else
     FBPGraph.DefHeight:=(PH*FVertPageCount-FPT*FVertPageCount-FPB*FVertPageCount);
    FBPGraph.SetDefaultConstants;
    FBPGraph.SetScaledConstants(wc,hc,ratio,ratio,ratio,iofontRatio);
    FBPGraph.CreateGraphNodes(wc,hc);
    FBPGraph.CreateIPGraphNodes(wc,hc);
    FBPGraph.CreateGraphLinks(wc,hc);
    if FBPGraph.ShowDataWare then
        FBPGraph.CreateDGraphNodes(wc,hc)
    else
        FBPGraph.ClearDGraphNodes;
    FBPGraph.PresetupFrame(wc,hc);
    FBPGraph.TraceRoute;
    Repaint;
    while FPainting do;
   {}
    nw:=FBPGraph.NodeWidth;
    nh:=FBPGraph.NodeHeight;
    mw:=FBPGraph.MaxWidth;
    mh:=FBPGraph.MaxHeight;
    rw:=ratio*nw/mw;
    rh:=ratio*nh/mh;
    case pgAlg of
       pg_Min:     fontRatio:=GetCoof(rw,rh,FFormatAlg[0]);
       pg_Middle:  fontRatio:=GetCoof(rw,rh,FFormatAlg[1]);
       pg_Max:     fontRatio:=GetCoof(rw,rh,FFormatAlg[2]);
    end;
    if fontRatio>ratio then fontRatio:=ratio;
    LabelFontRatio:=fontRatio*FBPGraph.FMaxCH;
    FBPGraph.DefWidth:=(PW*FHorzPageCount-FPL*FHorzPageCount-FPR*FHorzPageCount);
    if ((FHorzPageCount=1) and (FVertPageCount=1)) then
      FBPGraph.DefHeight:=(PH*FVertPageCount-FPT*FVertPageCount-FPB*FVertPageCount-ramkaH*FVertPageCount)
    else
     FBPGraph.DefHeight:=(PH*FVertPageCount-FPT*FVertPageCount-FPB*FVertPageCount);
    if (FBPGraph.FGlobalOperationSize/(FBPGraph.FDefHeight+1))>FBPGraph.FMaxGOS then
      ioFontRatio:=(FBPGraph.FDefHeight*FBPGraph.FMaxGOS)/(FBPGraph.FGlobalOperationSize+1)*fontRatio
    else
      ioFontRatio:=ioFontRatio*FontRatio;
    if ioFontRatio>ratio then ioFontRatio:=ratio;
    if ioFontRatio>hc then ioFontRatio:=hc;
    FBPGraph.SetDefaultConstants;
    FBPGraph.SetScaledConstants(wc,hc,ratio,fontRatio,LabelFontRatio,iofontRatio);
    FBPGraph.CreateGraphNodes(wc,hc);
    FBPGraph.CreateIPGraphNodes(wc,hc);
    FBPGraph.CreateGraphLinks(wc,hc);
    if FBPGraph.ShowDataWare then
        FBPGraph.CreateDGraphNodes(wc,hc)
    else
        FBPGraph.ClearDGraphNodes;
    FBPGraph.PresetupFrame(wc,hc);
    FBPGraph.TraceRoute;
    Repaint;
    while FPainting do;
    for px:=1 to FHorzPageCount do
    begin
     clrect.Left:=(px-1)*(pw-fpl-fpr);
     clRect.Right:=px*(pw-fpl-fpr);
     for py:=1 to FVertPageCount do
     begin
      clrect.Top:=(py-1)*(ph-fpt-fpb);
      clrect.Bottom:=py*(ph-fpt-fpb);
      if ((FHorzPageCount=1) and (FVertPageCount=1)) then
       begin
         PaintTo(FPrinter.Canvas.Handle,fpl,fpt+ramkaH);
         PreviewStandartRectangle(pw-FPageRight,ph+ramkaH-FPageBottom,cl);
       end
       else
        begin
         PaintPageTo(FPrinter.Canvas.Handle,fpl,fpt{+ramkaH},clrect);
         PreviewPrintRect(fpl,pw-fpr,fpt,ph-fpb);
        end;
      if ((px<>FHorzPageCount) or (py<>FVertPageCount)) then FPrinter.NewPage;
     end;
    end;
   finally
    FPrinter.EndDoc;
    FPrinting:=False;
    FPreviewOrPrint:=False;
    FUpdatingNavigator:=False;
    FHorzPageCount:=1;
    FVertPageCount:=1;
    FBPGraph.SetDefaultConstants;
    FBPGraph.Printing:=False;
    FBPGraph.CreateGraphNodes(1,1);
    FBPGraph.CreateIPGraphNodes(1,1);
    FBPGraph.CreateGraphLinks(1,1);
    if FBPGraph.ShowDataWare then
        FBPGraph.CreateDGraphNodes(1,1)
    else
        FBPGraph.ClearDGraphNodes;
{    FBPGraph.CheckLinksAndNodes;}
    FBPGraph.SetScaled2(oldScaled2);
    FBPGraph.SetScaled(oldScaled);
    if (not(oldScaled)) then FBPGraph.PresetupFrame(1,1);
    FBPGraph.TraceRoute;
    Invalidate;
   end;
end;

procedure TBPFrame.CreateBitmap(var value:TBitmap;pf:TPixelFormat); { Checked }
 begin
  try
   FUpdatingNavigator:=True;
   FPreviewOrPrint:=True;
   FFontCoof:=1;
   FBPGraph.UpdateMaxFontSize(1);
   if HorzScrollBar.Visible then HorzScrollBar.Position:=0;
   if VertScrollBar.Visible then VertScrollBar.Position:=0;
   Visible:=False;
   value:=TBitmap.Create;
   value.PixelFormat:=pf;
   value.Width:=FBPGraph.FDefWidth;
   value.Height:=FBPGraph.FDefHeight;
   Repaint;
   while FPainting do;
   value.Canvas.Lock;
   PaintTo(value.Canvas.Handle,0,0);
   Value.Canvas.Unlock;
  finally
    FUpdatingNavigator:=False;
    FPreviewOrPrint:=False;
    Visible:=True;
  end;
 end;



procedure TBPFrame.CreateBitmapWithSize(var value:TBitmap;pf:TPixelFormat;iw,ih:Integer); { scaled bitmap } { Checked }
Var oldScaled:Boolean;
    oldScaled2:Boolean;
    oldPrinting:Boolean;
    rw,rh:Double;
    ratio,fontRatio,LabelFontRatio,ioFontRatio:Double;
    nw,nh:Integer;
    mw,mh:Integer;
    wc,hc:Double;
    hsp,vsp:Integer;
    pgalg:TBPPgAlg;
 begin
  try
   FUpdatingNavigator:=True;
   FPreviewOrPrint:=False;
   oldScaled:=FBPGraph.Scaled;
   oldScaled2:=FBPGraph.Scaled2;
   oldPrinting:=FBPGraph.Printing;
   if HorzScrollBar.Visible then
     begin
      hsp:=HorzScrollBar.Position;
      HorzScrollBar.Position:=0;
     end;
   if VertScrollBar.Visible then
     begin
      vsp:=VertScrollBar.Position;
      VertScrollBar.Position:=0;
     end;
   if (FBPGraph.FNodesCount>FNodesValue[0]) then
      begin
        if (FBPGraph.FNodesCount<FNodesValue[1]) then
          pgAlg:=pg_Middle
        else
          pgAlg:=pg_Max;
      end
     else pgalg:=pg_Min;
   Visible:=False;
   FBPGRaph.Scaled2:=False;
   if FBPGraph.Scaled then FBPGRaph.Scaled:=False;
   Visible:=False;
   FPrinting:=True;
   rw:=iw/FBPGraph.DefWidth;
   rh:=ih/FBPGraph.DefHeight;
   wc:=rw;
   hc:=rh;
     case pgAlg of
      pg_Min:     Ratio:=GetCoof(rw,rh,FFormatAlg[0]);
      pg_Middle:  Ratio:=GetCoof(rw,rh,FFormatAlg[1]);
      pg_Max:     Ratio:=GetCoof(rw,rh,FFormatAlg[2]);
     end; {case pgAlg }
   FBPGraph.SetDefaultConstants;
   FBPGraph.SetScaledConstants(rw,rh,ratio,ratio,ratio,ratio);
   FBPGraph.DefHeight:=ih;
   FBPGraph.DefWidth:=iw;
   FBPGraph.Printing:=True;
   FBPGraph.CreateGraphNodes(wc,hc);
   FBPGraph.CreateIPGraphNodes(wc,hc);
   FBPGraph.CreateGraphLinks(wc,hc);
   if FBPGraph.ShowDataWare then
        FBPGraph.CreateDGraphNodes(wc,hc)
   else
        FBPGraph.ClearDGraphNodes;
   FBPGraph.PresetupFrame(wc,hc);
   FBPGraph.TraceRoute;
   Repaint;
   while FPainting do;
   {}
   if (FBPGraph.FGlobalOperationSize/(FBPGraph.FDefHeight+1))>FBPGraph.FMaxGOS then
      ioFontRatio:=(FBPGraph.FDefHeight*FBPGraph.FMaxGOS)/(FBPGraph.FGlobalOperationSize+1)
     else
      ioFontRatio:=ratio;
   if ioFontRatio>ratio then ioFontRatio:=ratio;
   if ioFontRatio>hc then ioFontRatio:=hc;
   FBPGraph.DefHeight:=ih;
   FBPGraph.DefWidth:=iw;
   FBPGraph.SetDefaultConstants;
   FBPGraph.SetScaledConstants(wc,hc,ratio,Ratio,Ratio,iofontRatio);
   FBPGraph.CreateGraphNodes(wc,hc);
   FBPGraph.CreateIPGraphNodes(wc,hc);
   FBPGraph.CreateGraphLinks(wc,hc);
   if FBPGraph.ShowDataWare then
        FBPGraph.CreateDGraphNodes(wc,hc)
   else
        FBPGraph.ClearDGraphNodes;
   FBPGraph.PresetupFrame(wc,hc);
   FBPGraph.TraceRoute;
   Repaint;
   while FPainting do;
   {}
   nw:=FBPGraph.NodeWidth;
   nh:=FBPGraph.NodeHeight;
   mw:=FBPGraph.MaxWidth;
   mh:=FBPGraph.MaxHeight;
   rw:=ratio*nw/mw;
   rh:=ratio*nh/mh;
   case pgAlg of
       pg_Min:     fontRatio:=GetCoof(rw,rh,FFormatAlg[0]);
       pg_Middle:  fontRatio:=GetCoof(rw,rh,FFormatAlg[1]);
       pg_Max:     fontRatio:=GetCoof(rw,rh,FFormatAlg[2]);
   end;
   if fontRatio>ratio then fontRatio:=ratio;
   LabelFontRatio:=fontRatio*FBPGraph.FMaxCH;
   FBPGraph.DefHeight:=ih;
   FBPGraph.DefWidth:=iw;
   if (FBPGraph.FGlobalOperationSize/(FBPGraph.FDefHeight+1))>FBPGraph.FMaxGOS then
      ioFontRatio:=(FBPGraph.FDefHeight*FBPGraph.FMaxGOS)/(FBPGraph.FGlobalOperationSize+1)*fontRatio
    else
      ioFontRatio:=ioFontRatio*FontRatio;
   if ioFontRatio>ratio then ioFontRatio:=ratio;
   if ioFontRatio>hc then ioFontRatio:=hc;
   FBPGraph.SetDefaultConstants;
   FBPGraph.SetScaledConstants(wc,hc,ratio,fontRatio,LabelFontRatio,iofontRatio);
   FBPGraph.CreateGraphNodes(wc,hc);
   FBPGraph.CreateIPGraphNodes(wc,hc);
   FBPGraph.CreateGraphLinks(wc,hc);
   if FBPGraph.ShowDataWare then
        FBPGraph.CreateDGraphNodes(wc,hc)
   else
        FBPGraph.ClearDGraphNodes;
   FBPGraph.PresetupFrame(wc,hc);
   FBPGraph.TraceRoute;
   Repaint;
   while FPainting do;
   value:=TBitmap.Create;
   value.PixelFormat:=pf;
   value.Width:=iw;
   value.Height:=ih;
   while FPainting do;
   value.Canvas.Lock;
   PaintTo(value.Canvas.Handle,0,0);
   value.Canvas.Unlock;
  finally
   FPrinting:=False;
   FUpdatingNavigator:=False;
   FBPGraph.SetDefaultConstants;
   FBPGraph.Printing:=oldPrinting;
   FBPGraph.CreateGraphNodes(1,1);
   FBPGraph.CreateIPGraphNodes(1,1);
   FBPGraph.CreateGraphLinks(1,1);
   if FBPGraph.ShowDataWare then
        FBPGraph.CreateDGraphNodes(1,1)
   else
        FBPGraph.ClearDGraphNodes;
{   FBPGraph.CheckLinksAndNodes;}
   FBPGraph.SetScaled2(oldScaled2);
   FBPGraph.SetScaled(oldScaled);
   if (not(oldScaled)) then FBPGraph.PresetupFrame(1,1);
   FBPGraph.TraceRoute;
   if HorzScrollBar.Visible then
      HorzScrollBar.Position:=hsp;
   if VertScrollBar.Visible then
      VertScrollBar.Position:=vsp;
   Invalidate;
   Visible:=True;
  end;
 end; 

procedure TBPFrame.DrawNode(l,t,w,h:Integer;Canvas:TCanvas;PaintColor,DrawColor:TColor);
Var r1:TRect;
  oldPenColor:TColor;
  oldBrushColor:TColor;
 begin
    oldBrushColor:=Canvas.Brush.Color;
    oldPenColor:=Canvas.Pen.Color;
    Canvas.Brush.Color:=PaintColor;
    r1.Left:=l;
    r1.Top:=t;
    r1.Right:=l+w;
    r1.Bottom:=t+h;
    Canvas.FillRect(r1);
    Canvas.Pen.Color:=DrawColor;
    Canvas.MoveTo(l,t);
    Canvas.LineTo(l+w,t);
    Canvas.LineTo(l+w,t+h);
    Canvas.LineTo(l,t+h);
    Canvas.LineTo(l,t);
    Canvas.Brush.Color:=oldBrushColor;
    Canvas.Pen.Color:=oldPenColor;
end;

procedure TBPFrame.DrawLink(pl:PGraphLink;Canvas:TCanvas;RatioX,RatioY:Double;Wpos,Hpos:Integer);
Var i,cnt:Integer;
    oldPenColor:TColor;
    oldPenStyle:TPenStyle;
begin
{}
  if pl=nil then Exit;
  oldPenColor:=Canvas.Pen.Color;
  oldPenStyle:=Canvas.Pen.Style;
  Canvas.Pen.Color:=pl^.Color;
  Canvas.Pen.Style:=pl^.PenStyle;
  cnt:=pl^.LinePointCount-1;
  Canvas.MoveTo(Round((pl^.LineArrayX[0]+wPos)*RatioX),Round((pl^.LineArrayY[0]+HPos)*RatioY));
  for i:=1 to cnt do
   begin
      Canvas.LineTo(Round((pl.LineArrayX[i]+WPos)*RatioX),Round((pl^.LineArrayY[i]+HPos)*RatioY));
    end;
  Canvas.Pen.Color:=oldPenColor;
  Canvas.Pen.Style:=oldPenStyle;
end;

function TBPFrame.FillBitmapWithSize(var value:TBitmap;iw,ih:Integer;level_id:Integer):String;
Var oldLevel:Integer;
    oldssLevel:String;
    oldScaled:Boolean;
    oldPrinting:Boolean;
    rw,rh:Double;
    ratio,fontRatio,LabelFontRatio:Double;
    nw,nh:Integer;
    mw,mh:Integer;
    wc,hc:Double;
    node:TBPGraphNode;
    nodeD:TBPDGraphNode;
    link:PGraphLink;
    i:Integer;
    wl,wt,ww,wh:Integer;
    vsp,hsp:Integer;
    s:String;
 begin
  try
   FUpdatingNavigator:=True;
   FBPGraph.FScaled2:=False;
   Result:='A';
   if HorzScrollBar.Visible then
     begin
       hsp:=HorzScrollBar.Position;
       HorzScrollBar.Position:=0;
     end else hsp:=0;
   if VertScrollBar.Visible then
     begin
       vsp:=VertScrollBar.Position;
       VertScrollBar.Position:=0;
     end else vsp:=0;
   OldLevel:=FBPGraph.Level;
   oldSsLevel:=FBPGraph.FSSLevel;
   oldSSLevel:='A'+oldSSLevel;
   FBPGraph.OpenLevel(level_id);
   Result:=Result+FBPGraph.FSSLevel;
   FBPGraph.TraceRoute;
   Invalidate;
   FBPGraph.SetDefaultConstants;
   FBPGraph.CreateGraphNodes(1,1);
   FBPGraph.CreateIPGraphNodes(1,1);
   FBPGraph.CreateGraphLinks(1,1);
   if FBPGraph.ShowDataWare then
        FBPGraph.CreateDGraphNodes(1,1)
   else
        FBPGraph.ClearDGraphNodes;
   FBPGraph.PresetupFrame(1,1);
   FBPGraph.TraceRoute;
   Repaint;
   while FPainting do;
   rw:=iw/FBPGraph.DefWidth;
   rh:=ih/FBPGraph.DefHeight;
   if rw>=rh then ratio:=rh else ratio:=rw;
   value.Canvas.Lock;
   Value.Canvas.FillRect(Value.Canvas.ClipRect);
   for i:=0 to (FBPGraph.FNodesCount-1) do
    begin
     node:=FBPGraph.GetGraphNode(i);
     s:=Trim(node.SNodeNumber);
     wl:=Round(node.Left*ratio);
     wt:=Round(node.Top*ratio);
     ww:=Round(node.Width*ratio);
     wh:=Round(node.Height*ratio);
     if s=oldSSLevel then
       DrawNode(wl,wt,ww,wh,Value.Canvas,clBlack,node.RectColor)
     else
       DrawNode(wl,wt,ww,wh,Value.Canvas,clWhite,node.RectColor);
     {ni.dwPaintColor,ni.dwDrawColor);}
    end;
   if FBPGraph.ShowDataWare then
   begin
   for i:=0 to (FBPGraph.FDNodesCount-1) do
    begin
      nodeD:=FBPGraph.GetDGraphNode(i);
      wl:=Round(nodeD.Left*ratio);
      wt:=Round(nodeD.Top*ratio);
      ww:=Round(nodeD.Width*ratio);
      wh:=Round(nodeD.Height*ratio*0.65);
      DrawNode(wl,wt,ww,wh,Value.Canvas,nodeD.PaintColor,nodeD.RectColor);
    end;
    if FBPGraph.ShowDataWareLine then
     begin
      value.Canvas.MoveTo(0,Round((FBPGraph.FDefHeight-FBPGraph.FGlobalOperationSize)*ratio));
      value.Canvas.LineTo(Round(FBPGraph.FDefWidth*ratio),Round((FBPGraph.FDefHeight-FBPGraph.FGlobalOperationSize)*ratio));
     end;
   end;
   value.Canvas.Unlock;
  finally
   FBPGraph.SetDefaultConstants;
   FBPGraph.FScaled:=False;
   FBPGraph.OpenLevel(OldLevel);
   FBPGraph.TraceRoute;
   Repaint;
   if HorzScrollBar.Visible then HorzScrollBar.Position:=hsp;
   if VertScrollBar.Visible then VertScrollBar.Position:=vsp;
   while FPainting do;
  end;
 end;


procedure TBPFrame.GetBitmapWithSize(value:TBitmap;iw,ih:Integer); { scaled bitmap } { Checked }
Var rw,rh:Double;
    nw,nh:Integer;
    mw,mh:Integer;
    wc,hc:Double;
    node:TBPGraphNode;
    nodeD:TBPDGraphNode;
    link:PGraphLink;
    i:Integer;
    wl,wt,ww,wh:Integer;
    vsp,hsp:Integer;
    pgalg:TBPPgAlg;
 begin
  try
   FUpdatingNavigator:=True;
   Visible:=False;
   if HorzScrollBar.Visible then
     begin
       hsp:=HorzScrollBar.Position;
       HorzScrollBar.Position:=0;
     end else hsp:=0;
   if VertScrollBar.Visible then
     begin
       vsp:=VertScrollBar.Position;
       VertScrollBar.Position:=0;
     end else vsp:=0;
   while FPainting do;
   rw:=iw/(FBPGraph.DefWidth+1);
   rh:=ih/(FBPGraph.DefHeight+1);
   value.Canvas.Lock;
   Value.Canvas.Brush.Color:=clWhite;
   Value.Canvas.FillRect(Value.Canvas.ClipRect);
   for i:=0 to (FBPGraph.FNodesCount-1) do
    begin
     node:=FBPGraph.GetGraphNode(i);
     wl:=Round(node.Left*rw);
     wt:=Round(node.Top*rh);
     ww:=Round(node.Width*rw);
     wh:=Round(node.Height*rh);
     DrawNode(wl,wt,ww,wh,Value.Canvas,node.PaintColor,node.RectColor);
    end;
   if FBPGraph.ShowDataWare then
   begin
   for i:=0 to (FBPGraph.FDNodesCount-1) do
    begin
      nodeD:=FBPGraph.GetDGraphNode(i);
      wl:=Round(nodeD.Left*rw);
      wt:=Round(nodeD.Top*rh);
      ww:=Round(nodeD.Width*rw);
      wh:=Round(nodeD.Height*rh);
      DrawNode(wl,wt,ww,wh,Value.Canvas,nodeD.PaintColor,nodeD.RectColor);
    end;
    if FBPGraph.ShowDataWareLine and (FBPGraph.FDNodesCount>0) then
     begin
      value.Canvas.MoveTo(0,Round((FBPGraph.FDefHeight-FBPGraph.FGlobalOperationSize)*rh));
      value.Canvas.LineTo(Round(FBPGraph.FDefWidth*rw),Round((FBPGraph.FDefHeight-FBPGraph.FGlobalOperationSize)*rh));
     end;
   end;
   for i:=0 to(FBPGraph.FLinksCount-1) do
    begin
     link:=FBPGraph.GetGraphLink(i);
     if link^.Visible then DrawLink(link,value.Canvas,rw,rh,hsp,vsp);
    end;
   value.Canvas.Unlock;
  finally
   if HorzScrollBar.Visible then HorzScrollBar.Position:=hsp;
   if VertScrollBar.Visible then VertScrollBar.Position:=vsp;
   Visible:=True;
   FUpdatingNavigator:=False;
  end;
 end;


procedure TBPFrame.CreateBitmapForOneShit(var value:TBitmap;pf:TPixelFormat;iw,ih,shitw,shith,maxshitw,maxshith:Integer); { Checked }
Var oldScaled:Boolean;
    oldScaled2:Boolean;
    oldPrinting:Boolean;
    rw,rh:Double;
    ratio,fontRatio,LabelFontRatio,ioFontRatio:Double;
    nw,nh:Integer;
    mw,mh:Integer;
    clRect:TRect;
    wc,hc:Double;
    pgalg:TBPPgAlg;
 begin
    try
    FUpdatingNavigator:=True;
    FPreviewOrPrint:=False;
   oldScaled:=FBPGraph.Scaled;
   oldScaled2:=FBPGraph.Scaled2;
   oldPrinting:=FBPGraph.Printing;
   if HorzScrollBar.Visible then HorzScrollBar.Position:=0;
   if VertScrollBar.Visible then VertScrollBar.Position:=0;
   if (FBPGraph.FNodesCount>FNodesValue[0]) then
      begin
        if (FBPGraph.FNodesCount<FNodesValue[1]) then
          pgAlg:=pg_Middle
        else
          pgAlg:=pg_Max;
      end
     else pgalg:=pg_Min;
   Visible:=False;
   if FBPGraph.Scaled2 then FBPGraph.Scaled2:=False;
   if FBPGraph.Scaled then FBPGraph.Scaled:=False;
   FPrinting:=True;
   rw:=(iw*maxshitw)/FBPGraph.DefWidth;
   rh:=(ih*maxshith)/FBPGraph.DefHeight;
   wc:=rw;
   hc:=rh;
     case pgAlg of
      pg_Min:     Ratio:=GetCoof(rw,rh,FFormatAlg[0]);
      pg_Middle:  Ratio:=GetCoof(rw,rh,FFormatAlg[1]);
      pg_Max:     Ratio:=GetCoof(rw,rh,FFormatAlg[2]);
     end; {case pgAlg }
   FBPGraph.SetDefaultConstants;
   FBPGraph.SetScaledConstants(rw,rh,ratio,ratio,ratio,ratio);
   FBPGraph.DefHeight:=ih*maxshith;
   FBPGraph.DefWidth:=iw*maxshitw;
   FBPGraph.Printing:=True;
   FBPGraph.CreateGraphNodes(wc,hc);
   FBPGraph.CreateIPGraphNodes(wc,hc);
   FBPGraph.CreateGraphLinks(wc,hc);
   if FBPGraph.ShowDataWare then
        FBPGraph.CreateDGraphNodes(wc,hc)
   else
        FBPGraph.ClearDGraphNodes;
   FBPGraph.PresetupFrame(wc,hc);
   FBPGraph.TraceRoute;
   Repaint;
   while FPainting do;
   {}
   if (FBPGraph.FGlobalOperationSize/(FBPGraph.FDefHeight+1))>FBPGraph.FMaxGOS then
      ioFontRatio:=(FBPGraph.FDefHeight*FBPGraph.FMaxGOS)/(FBPGraph.FGlobalOperationSize+1)
     else
      ioFontRatio:=ratio;
   if ioFontRatio>ratio then ioFontRatio:=ratio;
   if ioFontRatio>hc then ioFontRatio:=hc;
   FBPGraph.DefHeight:=ih*maxshith;
   FBPGraph.DefWidth:=iw*maxshitw;
   FBPGraph.SetDefaultConstants;
   FBPGraph.SetScaledConstants(wc,hc,ratio,Ratio,Ratio,iofontRatio);
   FBPGraph.CreateGraphNodes(wc,hc);
   FBPGraph.CreateIPGraphNodes(wc,hc);
   FBPGraph.CreateGraphLinks(wc,hc);
   if FBPGraph.ShowDataWare then
        FBPGraph.CreateDGraphNodes(wc,hc)
   else
        FBPGraph.ClearDGraphNodes;
   FBPGraph.PresetupFrame(wc,hc);
   FBPGraph.TraceRoute;
   Repaint;
   while FPainting do;
   {}
   nw:=FBPGraph.NodeWidth;
   nh:=FBPGraph.NodeHeight;
   mw:=FBPGraph.MaxWidth;
   mh:=FBPGraph.MaxHeight;
   rw:=ratio*nw/mw;
   rh:=ratio*nh/mh;
   case pgAlg of
       pg_Min:     fontRatio:=GetCoof(rw,rh,FFormatAlg[0]);
       pg_Middle:  fontRatio:=GetCoof(rw,rh,FFormatAlg[1]);
       pg_Max:     fontRatio:=GetCoof(rw,rh,FFormatAlg[2]);
   end;
   if fontRatio>ratio then fontRatio:=ratio;
   LabelFontRatio:=fontRatio*FBPGraph.FMaxCH;
   FBPGraph.DefHeight:=ih*maxshith;
   FBPGraph.DefWidth:=iw*maxshitw;
   if (FBPGraph.FGlobalOperationSize/(FBPGraph.FDefHeight+1))>FBPGraph.FMaxGOS then
      ioFontRatio:=(FBPGraph.FDefHeight*FBPGraph.FMaxGOS)/(FBPGraph.FGlobalOperationSize+1)*fontRatio
    else
      ioFontRatio:=ioFontRatio*FontRatio;
   if ioFontRatio>ratio then ioFontRatio:=ratio;
   if ioFontRatio>hc then ioFontRatio:=hc;
   FBPGraph.SetDefaultConstants;
   FBPGraph.SetScaledConstants(wc,hc,ratio,fontRatio,LabelFontRatio,iofontRatio);
   FBPGraph.CreateGraphNodes(wc,hc);
   FBPGraph.CreateIPGraphNodes(wc,hc);
   FBPGraph.CreateGraphLinks(wc,hc);
   if FBPGraph.ShowDataWare then
        FBPGraph.CreateDGraphNodes(wc,hc)
   else
        FBPGraph.ClearDGraphNodes;
   FBPGraph.PresetupFrame(wc,hc);
   FBPGraph.TraceRoute;
   Repaint;
   while FPainting do;
   value:=TBitmap.Create;
   value.PixelFormat:=pf;
   value.Width:=iw;
   value.Height:=ih;
   while FPainting do;
   clrect.Left:=shitw*iw;
   clRect.Right:=(shitw+1)*iw;
   clrect.Top:=shith*ih;
   clrect.Bottom:=(shith+1)*ih;
   value.Canvas.Lock;
   PaintPageTo(Value.Canvas.Handle,0,0,clrect);
   value.Canvas.Unlock;
  finally
   FPrinting:=False;
   FBPGraph.SetDefaultConstants;
   FBPGraph.Printing:=oldPrinting;
   FBPGraph.CreateGraphNodes(1,1);
   FBPGraph.CreateIPGraphNodes(1,1);
   FBPGraph.CreateGraphLinks(1,1);
   if FBPGraph.ShowDataWare then
        FBPGraph.CreateDGraphNodes(1,1)
   else
        FBPGraph.ClearDGraphNodes;
{   FBPGraph.CheckLinksAndNodes;}
   FBPGraph.SetScaled2(oldScaled2);
   FBPGraph.SetScaled(oldScaled);
   if (not(oldScaled)) then FBPGraph.PresetupFrame(1,1);
   FUpdatingNavigator:=False;
   FBPGraph.TraceRoute;
   Invalidate;
   Visible:=True;
  end;
 end;

procedure TBPFrame.DoEnter; { Checked }
 begin
   ControlState:=ControlState+[csFocusing];
   inherited;
 end;

procedure TBPFrame.DoExit; { Checked }
 begin
   ControlState:=ControlState-[csFocusing];
   inherited;
 end;

procedure Register; { Checked }
begin
  RegisterComponents('DeadSouls', [TBPFrame]);
end;

end.