unit bppnd;

{ :   (BPView_lfs.exe) }
{ : -         }
{ :                      }
{  :  ..           }
{ (c) 1998-2003   "-"                }
{ (c) 1998-2003  "-"       }
{ :   09.10.2003                         }

interface

Uses Windows,SysUtils,Messages,Graphics,Controls,Forms,Classes,Printers,
     QRPrntr,BPDef,BPNode,TFlatProgressBarUnit,StdCtrls,MyUtils;

Type

  TBPPNDLinkType=(unknown_link,onelevel_up,onechild_left,onechild_right,manylevel_up,manychild_lr);
  TBPPNDLinkSubType=(unknown_sublink,left_left,left_leftspec,right_rightspec,right_right,left_rightspec,right_leftspec);

  PPNDGraphNode=^TPNDGraphNode;
  TPNDGraphNode=record
    BPNode:TBPLSAGraphNode; {   }
    llNode:PBPNode;         {      }
    FinalX:Integer;         {    Left      }
    FinalY:Integer;         {    Top      }
    LevelID:Integer;        {   -       }
    Finalized:Boolean;      {   -       }
    next:PPNDGraphNode;
  end;

  PPNDGraphLink=^TPNDGraphLink;
  TPNDGraphLink=record
     llLink:PBPLink;                       {        }
     FromNodeNumber:DWORD;
     ToNodeNumber:DWORD;
     dwFlags:DWORD;
     LineArrayX:Array[0..20] of Integer;
     LineArrayY:Array[0..20] of Integer;
     LinePointCount:DWORD;
     StartPoint:TPoint;
     EndPoint:TPoint;
     LinkFromCount:DWORD;
     LinkToCount:DWORD;
     MinimalXFrom:Integer;
     MinimalXTo:Integer;
     MinimalYFrom:Integer;
     MinimalYTo:Integer;
     Color:TColor;                          { T's LinkType }
     PenStyle:TPenStyle;                    { T's LinkType }
     LinkLeftCountFrom:Integer;
     LinkRightCountFrom:Integer;
     LinkTopCountFrom:Integer;
     LinkBottomCountFrom:Integer;
     LinkLeftCountTo:Integer;
     LinkRightCountTo:Integer;
     LinkTopCountTo:Integer;
     LinkBottomCountTo:Integer;
     LinkType:TBPPNDLinkType;
     LinkSubType:TBPPNDLinkSubType;
     Visible:Boolean;
     next:PPNDGraphLink;
  end;

 TBPPNDCoordinate=record
    Region:Array[0..100] of Integer;
    Count:Array[0..100] of Integer;
    RegionCount:Integer;
 end;

 TBPPNDNodeArray=record
    NodesXLeft:Array[0..100] of Integer;
    NodesXRight:Array[0..100] of Integer;
    NodesYTop:Array[0..100] of Integer;
    NodesYBottom:Array[0..100] of Integer;
    NodeNumber:Array[0..100] of DWORD;
    NodesCount:Integer;
  end;

  TBPPNDNodeDef=record
   NodeIndex:Integer;
   Level:Integer;
  end;

  TBPPNDNodeArrayEx=record
    Nodes:Array[0..100] of Integer;
    NodesCount:Integer;
  end;

  TBPPNDLinkArrayEx=record
    Links:Array[0..600] of PPNDGraphLink;
    LinksCount:Integer;
  end;


  TBPPNDLevelArray=record
   { NodeNum, Level }
    NodesCount:Array[0..100] of Integer;
    Nodes:Array[0..100,0..100] of PPNDGraphNode; { NodeIndex, Level }
    NodeType:Array[0..100,0..100] of TBPNodeTypes; { NodeType }
    IsTreeNode:Array[0..100,0..100] of Boolean; { Is ierarchy Tree NodeIndex,Level }
    ParentNode:Array[0..100,0..100] of TBPPNDNodeDef; { NodeIndex, Level }
    ChildNode:Array[0..100,0..100,0..100] of TBPPNDNodeDef; { ChildIndex,NodeIndex,Level}
    ChildCound:Array[0..100,0..100] of Integer; { NodeIndex, Level }
    LevelsCount:Integer;
  end;

 TBPPNDRegion=record
    LeftRegion:Integer;
    RightRegion:Integer;
    TopRegion:Integer;
    BottomRegion:Integer;
  end;


 TBPPNDFrame=class;
 TBPPNDGraph = class(TControl)
      private
       FOwner:TBPPNDFrame;
       FNodes:PBPNode;
       FLinks:PBPLink;
        FTree:PBPTree;     { Tree for model   }
        FNTTree:PBPNodeTypes; { NodeTypes Tree }
        FLTTree:PBPLinkTypes; { LinkTypes Tree }
        FOPTree:PBPOpTree;    { Operation Tree } { CurrentWork ! }
        FIPNode:PBPInProcessNode;
        FHeader:TBPHeader; { Header for model }
        FLevel:Integer;      { Level for model, model must have level -1 }
        FSSLevel:ShortString; { New level for model in x.x.x.x format }
                              { CurrentWork ! }
        FParentLevel:Integer;     { Parent level for model }
        FRootEntries:DWORD;
        FNodesCount:DWORD;
        FLinksCount:DWORD;
        FGNodesCount:Integer;
        FGLinksCount:Integer;
        FGraphNodes:PPNDGraphNode;
        FGraphLinks:PPNDGraphLink;
        FHaspFound:Boolean;
        FMaxWidth:Integer;
        FMaxHeight:Integer;
        FGlobalLeftSize:Integer;
        FGlobalRightSize:Integer;
        FGlobalTopSize:Integer;
        FGlobalBottomSize:Integer;
        { For printing and other }
        FDefWidth:Integer;
        FDefHeight:Integer;
        FPrinting:Boolean;
        FScreenFontName:TFontName;
        FPrinterFontName:TFontName;
        { Vars for mashtabing }
        FFontDPI:Integer;   { FontDPI }
        FFontSize:Integer;  { FontSize }
        FLabelFontSize:Integer;
        FMaxCh:Double;
         {lines mashtabing interval }
        FMinLineStep:Integer; { Line Step }
        FMinArcRadius:Integer;
        FMinLineEndPoint:Integer;
        { nodes mashtabing vars }
        FNodeLineWidth:Integer;
        FNodeDefWidth:Integer;
        FNodeDefHeight:Integer;
        FNodeHSpacing:Integer;
        FNodeVSpacing:Integer;
        FNodeShadowDepth:Integer;
        FNodeWidth:Integer;
        FNodeHeight:Integer;
          {}
        FCalcWidthHeight:Boolean;
          { Debug routines }
        FDebug:Boolean;
        { AF Options }
        FFirstNodeNumber:DWORD;
        FLastNodeNumber:DWORD;
        FScaled:Boolean;             { Clip Windows to fit into ClipRect }
        FScaled2:Boolean;
        FScaled2Ratio:Extended;
        FDiscardDrags:Boolean;
        FRatioWC:Double;             { Ratio for recalc widthcoof }
        FRatioHC:Double;             { Ratio for recalc heightcoof }
        FModified:Boolean;
        FAcceptDragRect:TRect;       { Rect for Accept Drags & Drop }
        FLinksPosRelative:Boolean;
        { Analize graph}
        FADefWidth:Integer;
        FADefHeight:Integer;
        FinalNodeX:Array[0..100] of Integer;
        FinalNodeY:Array[0..100] of Integer;
        FinalWidth:Integer;
        FinalHeight:Integer;
        FRatioX:Double;
        FRatioY:Double;
        FNWidth:Integer;
        FNHeight:Integer;
        FNodeXArray:TBPPNDNodeArray; { -+new }
        FCheckLevelsArray:TBPPNDLevelArray;
        FChangeTabVisible:Boolean;
        FMaxNodesCount:Integer;
        { Advanced regions trace arrays }
        FLeftArray:TBPPNDCoordinate;
        FRightArray:TBPPNDCoordinate;
        FTopArray:TBPPNDCoordinate;
        FBottomArray:TBPPNDCoordinate;
        { Nodes and Labels }
        FReplaceNodes:Boolean;
        FMaxWordLength:Integer;
        FMaxWordCount:Integer;
        { Barahlo}
        FDoOverrideFS:Boolean;
        FNodesFontSize:Integer;
        FDNodesFontSize:Integer;
        FDProjectionFontSize:Integer;
        FInProcessFontSize:Integer;
        FOverrideNodesFS:Boolean;
        FOverrideDNodesFS:Boolean;
        FOverrideInProcessFS:Boolean;
         {      }
        FMaxFontSize:Integer;
        FRealMaxFontSize:Integer;
        { New }
        FShowCaptions:Boolean;
        { For creating check graph only }
        FGNodesArray:TBPPNDNodeArrayEx;
        FGLinksArray:TBPPNDLinkArrayEx;
        { Changing algorithm }
        FUseNodeTypeLevels:Boolean;
        { New definition of classificator level }
        FMaxLevels:Integer;
        FLevDepth:Integer; { planka of depth analiz }
        { Analize network graph}
        procedure FillCheckLevelsArray;
        procedure FillCheckLevelsArray2;
        function  GetNodeLevelEx(index:DWORD):Integer;
        function  CompareTwoNodes(s1,s2:String):Boolean;
        function  GetNodeLevelIND(snumber:String):String;
        function  GetNodeNumberIND(snumber:String):String;
        function  GetNodeLevelPart(num:String):String;
        function  GetNodeDepthPart(num:String):String;
        procedure TranslateToNodesCoord;
        procedure InsertChildAt(id,parent:PPNDGraphNode;Level:Integer;IsTree:Boolean);
        function  CompareFromToNumbers(FromN,ToN:Integer):Boolean;
        function  FindCheckNode(node:PPNDGraphNode):TBPPNDNodeDef;
        function  HasParentEx(node:PPNDGraphNode):PPNDGraphNode;
        procedure MoveArray(nodeindex,level:Integer);
        function  IsTreeChild(node,pnode:PPNDGraphNode):Boolean;
        function  GetFreeLevel(node:PPNDGraphNode):Integer;
        function  CheckForSameParent(pr,tst:PPNDGraphNode):Boolean;
        function  GetNodeAtSameParent(node:PPNDGraphNode;var returnNode:PPNDGraphNode;AddonSearch:Boolean):Integer;
        function  CalcNodeDefWidth(var pw:Integer;px,x:Integer;node:TBPPNDNodeDef):Integer;
        procedure CalcNodesLinkType;
        procedure FillGNodesAndLinksArraysEx;
        procedure SortGLinksArray;
        function  GetLinkIndexEx(nodenum:Integer):Integer;

        procedure AnalizeStringsFonts;
        procedure SetMaxFontSize(Value:Integer);
        procedure UpdateMaxFontSize(Coof:Extended);
        function  GetNTFromIndex(index:DWORD):TBPNodeTypes;
        function  GetLTFromIndex(index:DWORD):TBPLinkTypes;
        procedure ClearGraphNodes;
        procedure ClearGraphLinks;
        procedure CreateGraphNodes(wc,hc:Double);
        procedure CreateGraphLinks(wc,hc:Double);
        { Internal subroutines }
        procedure  CalcMaxWidthHeight;
        function   GetGraphLink(index:DWORD):PPNDGraphLink;
        function   GetGraphNode(index:DWORD):TBPLSAGraphNode;
        function   GetGraphNumberedNode(NodeNumber:DWORD):PPNDGraphNode;
        function   GetGraphNodeRec(index:DWORD):PPNDGraphNode;
        procedure  InitGNodes;
        procedure  InitGLinks;
        { Scaled }
        procedure SetScaled(Value:Boolean);
        procedure SetScaled2(Value:Boolean);
        procedure SetScaled2Ratio(Value:Extended);
        procedure SetDefWidth(Value:Integer);
        procedure SetDefHeight(Value:Integer);
        procedure SetDiscardDrags(Value:Boolean);
        procedure SetUseNodeTypeLevels(Value:Boolean);
        function  GetNodeCaption(num,cap:String):String;
        function  GetMaxLevelsInNewDef:Integer;
        procedure SetLevDepth(Value:Integer);
        { Trace routines }
        procedure TraceNodes;
        procedure TraceLinksToNodeCounters;
        procedure TraceNodesToLinksCounters;
        procedure TraceLocalStartEndPoints;
        procedure  TraceLinks;
        procedure  DrawLinks;
        procedure  DrawArrow(dx,dy,sx,sy:Integer);

        procedure FillLeftArray;
        procedure FillRightArray;
        procedure FillTopArray;
        procedure FillBottomArray;
        function  IsLeftArray(value:Integer):Integer;
        function  IsRightArray(value:Integer):Integer;
        function  IsTopArray(value:Integer):Integer;
        function  IsBottomArray(value:Integer):Integer;
        function  GetNodeRegion(NodeNumber:DWORD):TBPPNDRegion;
        function   GetLinkFrom(const value:PPNDGraphLink):TLinkType;
        function   GetLinkTo(const value:PPNDGraphLink):TLinkType;

        procedure SetFontSize(Value:Integer);
        procedure SetShowCaptions(Value:Boolean);
      public
        FLang:TFontCharset;
        procedure   Optimize;
        function    OptimizeNodeFonts:Integer;
        procedure   SetMaxAll(BReplaceNodes:Boolean;IMaxWordLength,IMaxWordCount:Integer);
        procedure   SetOverrideFonts(NFS,DNFS,DPFS,IPFS,LFS:Integer;ONFS,ODFS,OIFS,OLFS:Boolean);
        procedure   SetOverrideFontsAll(NFS,DNFS,DPFS,IPFS,LFS:Integer;ONFS,ODFS,OIFS,OLFS:Boolean;
                                        CNFS,CDNFS,CDPFS,CIPFS,CLFS,CONFS,CODFS,COIFS,COLFS:Boolean);
        constructor Create(AOwner: TComponent); override;
        destructor  Destroy; override;
        procedure   TraceRoute; { Main Tracing Procedure }
        procedure   AssignModel(Tree:PBPTree;NTTree:PBPNodeTypes;LTTree:PBPLinkTypes;
                                OPTree:PBPOpTree;Header:TBPHeader;IPNode:PBPInProcessNode);
        procedure   ClearModel;
        procedure   OpenLevel(wLevel:Integer);
        procedure   PresetupFrame(widthcoof,heightcoof:Double);
        { Scale }
        procedure  SetDefaultConstants;
        procedure  SetScaledConstants(ratiox,ratioy,ratio:Double;fontSizeRatio:Double);
        { Drag & Drop }
        procedure  MyNodeMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer); { Checked }
        procedure  UpdateNodesModel(X,Y:Integer;node:TBPLSAGraphNode);
      published
       property Parent:TBPPNDFrame read FOwner write FOwner;
       property FontDPI:Integer read FFontDPI write FFontDPI;
       property DefWidth:Integer read FDefWidth write SetDefWidth;
       property DefHeight:Integer read FDefHeight write SetDefHeight;
       property MaxWidth:Integer read FMaxWidth;
       property MaxHeight:Integer read FMaxHeight;
       property NodeWidth:Integer read FNodeWidth;
       property NodeHeight:Integer read FNodeHeight;
       property Printing:Boolean read FPrinting write FPrinting;
       property MinLineStep:Integer read FMinLineStep write FMinLineStep default 6;
       property GlobalLeftSize:Integer read FGlobalLeftSize write FGlobalLeftSize default 80;
       property GlobalRightSize:Integer read FGlobalRightSize write FGlobalRightSize default 80;
       property GlobalTopSize:Integer read FGlobalTopSize write FGlobalTopSize default 80;
       property GlobalBottomSize:Integer read FGlobalBottomSize write FGlobalBottomSize default 80;

       property FontSize:Integer read FFontSize write SetFontSize;
       property GNodesCount:DWORD read FGNodesCount;
       property MinArcRadius:Integer read FMinArcRadius write FMinArcRadius;
       property MinLineEndPoint:Integer read  FMinLineEndPoint write FMinLineEndPoint;
       property Level:Integer read FLevel;
       property SSLevel:ShortString read FSSLevel; { CurrentWork !}
       property ParentLevel:Integer read FParentLevel;
       property HaspFound:Boolean read FHaspFound write FHaspFound default False;
       property ScreenFontName:TFontName read FScreenFontName write FScreenFontName;
       property PrinterFontName:TFontName read FPrinterFontName write FPrinterFontName;
       property Debug:Boolean read FDebug write FDebug;
       property Scaled:Boolean read FScaled write SetScaled;
       property Scaled2:Boolean read FScaled2 write SetScaled2;
       property Scaled2Ratio:Extended read FScaled2Ratio write SetScaled2Ratio;
       property DiscardDrags:Boolean read FDiscardDrags write SetDiscardDrags;
       property Modified:Boolean read FModified write FModified;
       property AcceptDragRect:TRect read FAcceptDragRect;
       property LinksPosRelative:Boolean read FLinksPosRelative write FLinksPosRelative default True;
       property RootEntries:Integer read FRootEntries;
       {New}
       property NodesFontSize:Integer read FNodesFontSize;
       property DNodesFontSize:Integer read FDNodesFontSize;
       property DProjectionFontSize:Integer read FDProjectionFontSize;
       property InProcessFontSize:Integer read FInProcessFontSize;
       property OverrideNodesFS:Boolean read FOverrideNodesFS;
       property OverrideDNodesFS:Boolean read FOverrideDNodesFS;
       property OverrideInProcessFS:Boolean read FOverrideInProcessFS;
       property MaxFontSize:Integer read FMaxFontSize write SetMaxFontSize;
       property ShowCaptions:Boolean read FShowCaptions write SetShowCaptions;
       property UseNodeTypeLevels:Boolean read FUseNodeTypeLevels write SetUseNodeTypeLevels;
       property MaxLevels:Integer read GetMaxLevelsInNewDef;
       property LevDepth:Integer read FLevDepth write SetLevDepth default 0;
      end;

 { TBPPNDFrame definition }
  TBPPNDFrame = class(TScrollingWinControl)
  private
    { Private declarations }
    FBPPNDGraph:TBPPNDGraph;                         { _++-+ +- }
    FCanvas: TCanvas;
    { Page Param Options }
    FPageTop:Integer;
    FPageBottom:Integer;
    FPageLeft:Integer;
    FPageRight:Integer;
    FPrinter:TQRPrinter;
    FPrinting:Boolean;
    FPainting:Boolean; { So disable double insert in painting module }
    FAborting:Boolean;
    { Vars for scaling diagrams }
    FHorzPageCount:Integer;
    FVertPageCount:Integer;
    { Vars for scaling ramka font }
    FRamkaFontRatio:Extended;
    FPSizeH:Extended;
    FPSizeW:Extended;
    FRamkaH:Integer;
    procedure WMPaint(var Message: TWMPaint); message WM_PAINT;
  protected
    { Protected declarations }
    procedure Paint; virtual;
    procedure PaintWindow(DC: HDC); override;
    procedure PaintTo(DC: HDC; X, Y: Integer);
    procedure PaintPageTo(DC: HDC; X, Y: Integer; PageClipRect:TRect);
    { printing routines }
    procedure  PreviewPrintRect(left,right,top,bottom:Integer);
    procedure  PrintRect(left,right,top,bottom:Integer);
    procedure  DrawNode(l,t,w,h:Integer;Canvas:TCanvas;PaintColor,DrawColor:TColor);
    procedure  DrawLink(pl:PPNDGraphLink;Canvas:TCanvas;RatioX,RatioY:Double;Wpos,Hpos:Integer);
    procedure  MyDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure  MyDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
    function   GetCoof(rw,rh:Double;Alg:TBPFormatAlg):Double;
  public
    { Public declarations }
    FUpdatingNavigator:Boolean;
    FPreviewOrPrint:Boolean;
    FFontCoof:Double;
    FNodesValue:Array[0..1] of Integer; { Min Max }
    FFormatAlg:array[0..2] of TBPFormatAlg; { Min Middle Max }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure SetPageParam(Var PageTop,PageBottom,PageLeft,PageRight:Integer;ShowWarning:Boolean);
    procedure SetPreviewPageParam(PageTop,PageBottom,PageLeft,PageRight:Integer);
    procedure Print;
    procedure CreateBitmap(var value:TBitmap;pf:TPixelFormat);
    procedure GetBitmapWithSize(value:TBitmap;iw,ih:Integer); { scaled bitmap }
    procedure CreateBitmapWithSize(var value:TBitmap;pf:TPixelFormat;iw,ih:Integer); { scaled bitmap }
    procedure CreateBitmapForOneShit(var value:TBitmap;pf:TPixelFormat;iw,ih,shitw,shith,maxshitw,maxshith:Integer);
    procedure CreatePreview;
    procedure PrintAll(pb:TFlatProgressBar;Lbl:TLabel;StartP,EndP:Integer);
    procedure CreatePreviewAll(pb:TFlatProgressBar;Lbl:TLabel);
  published
    { Published declarations }
    property BPPNDGraph:TBPPNDGraph read FBPPNDGraph;
    property HorzPages:Integer read FHorzPageCount write FHorzPageCount default 1;
    property VertPages:Integer read FVertPageCount write FVertPageCount default 1;
    property Align default alNone;
    property Width default 100;
    property Height default 100;
    property Enabled default True;
    property ShowHint;
    property Visible;
    property Ctl3D;
    property TabStop default True;
    property TabOrder;
    property Canvas:TCanvas read FCanvas;
    property QPrinter:TQRPrinter read FPrinter;
    property Printing:Boolean read FPrinting;
    property Aborting:Boolean read FAborting write FAborting;
    property OnKeyUp;
    property OnEnter;
    property OnExit;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnStartDrag;
    property PopupMenu;
  end;

function SignedVector(Sign,Value:Integer):Integer;

procedure Register;

Const StartMinLineStep=6;
      StartMinLabelX=8;
      StartMinLabelY=4;
      StartMinLabelY1=12; { Try to change }
      StartMinArcRadius=8;
      NodeRatio=4/3;
      StartMinGlobalLabel=10;
      StartMinLineEndPoint=4;
      StartMaxLines=4;

      A3Width=11.6929;  { Inch }
      A3Height=16.5354; { Inch }
      DefMaxLabelFontSize=14;

Var   CurPrinterOrientation:TPrinterOrientation;

implementation

Uses MainUnit,AnalizeGraphUnit;

function SignedVector(Sign,Value:Integer):Integer;
 begin
   if Sign>0 then Result:=1 else
   if Sign<0 then Result:=-1 else Result:=0;
   Result:=Result*Value;
 end;


{ TBPPNDGraph }

function  TBPPNDGraph.GetNodeLevelPart(num:String):String;
var i:Integer;
 begin
   Result:='';
   i:=0;
   while (length(num)>0) and (i<FLevDepth) do
    begin
      if pos('.',num)=0 then
        begin
          Result:=Result+num;
          num:='';
        end
      else
        begin
          Result:=Result+copy(num,1,pos('.',num));
          delete(num,1,pos('.',num));
        end;
      inc(i);
    end;
   if (Length(Result)>0) and (Result[length(Result)]='.') then delete(Result,length(Result),1);
 end;

function  TBPPNDGraph.GetNodeDepthPart(num:String):String;
Var i:Integer;
 begin
   Result:='';
   i:=0;
   while (length(num)>0) and (i<FLevDepth) do
    begin
      if pos('.',num)=0 then
           num:=''
      else
           delete(num,1,pos('.',num));
      inc(i);
    end;
    if length(num)>0 then
      begin
        i:=0;
        while (length(num)>0) do
          begin
            if pos('.',num)=0 then
              num:=''
            else
              delete(num,1,pos('.',num));
            inc(i);
          end;
        if (i>0) then Result:='D'+IntToStr(i);
      end;
 end;

function  TBPPNDGraph.GetNodeLevelIND(snumber:String):String;
Var s:String;
    i:Integer;
 begin
  s:=GetNodeNumberIND(snumber); { Get Node Number in new def }
  if pos('D',s)=0 then
    begin
      while (length(s)>0) and (s[length(s)] in ['0'..'9']) do delete(s,length(s),1);
      if (length(s)>0) and (s[length(s)]='.') then delete(s,length(s),1);
    end
  else
    begin
     { Has depth parameter }
     i:=StrToIntDef(copy(s,pos('D',s)+1,length(s)),1);
     if i=1 then
      begin
       delete(s,pos('D',s),length(s)-pos('D',s)+1);
       if (length(s)>0) and (s[length(s)]='.') then delete(s,length(s),1);
      end
     else
      begin
       delete(s,pos('D',s)+1,length(s)-pos('D',s));
       dec(i);
       s:=s+IntToStr(i);
      end;
    end;
  if s='' then s:='-1';
  Result:=s;
 end;

function  TBPPNDGraph.GetNodeNumberIND(snumber:String):String;
Var s,snl,snd:String;
 begin
  s:=Trim(snumber);
  if length(s)>0 then delete(s,1,1);
  snl:=GetNodeLevelPart(s); { Return '1.23.34' part of number }
  snd:=GetNodeDepthPart(s); { Return 'D3' but not return 'D0' }
  if (length(snd)>0)  and (length(snl)>0) then snd:='.'+snd;
  s:=snl+snd;
  Result:=s;
 end;

procedure TBPPNDGraph.FillGNodesAndLinksArraysEx;
Var tmpN:PPNDGraphNode;
    tmpL:PPNDGraphLink;
 begin
   FGNodesArray.NodesCount:=0;
   if FGNodesCOunt=0 then Exit;
   tmpN:=FGraphNodes;
   while (tmpN<>nil) do
    begin
      FGNodesArray.Nodes[FGNodesArray.NodesCount]:=tmpN^.BPNode.NodeNumber;
      inc(FGNodesArray.NodesCount);
      tmpN:=tmpN^.next;
    end;
   FGLinksArray.LinksCount:=0;
   if FGLinksCount=0 then Exit;
   tmpL:=FGraphLinks;
   while (tmpL<>nil) do
    begin
      FGLinksArray.Links[FGLinksArray.LinksCount]:=tmpL;
      inc(FGLinksArray.LinksCount);
      tmpL:=tmpL^.next;
    end;
 end;


function  TBPPNDGraph.GetLinkIndexEx(nodenum:Integer):Integer;
Var i:Integer;
 begin
   Result:=-1;
   if FGNodesArray.NodesCount=0 then Exit;
   for i:=0 to (FGNodesArray.NodesCount-1) do
     begin
       if FGNodesArray.Nodes[i]=nodenum then
         begin
           Result:=i;
           Exit;
         end;
     end;
 end;

procedure TBPPNDGraph.SortGLinksArray;
Var linkF,linkL:PPNDGraphLink;
    i,j,fni,lni:Integer;
    flag:Boolean;
 begin
   if FGLinksArray.LinksCount=0 then Exit;
   flag:=False;
    while (not(Flag)) do
     begin
       Flag:=True;
       for i:=0 to (FGLinksArray.LinksCount-2) do
        begin
        for j:=(i+1) to (FGLinksArray.LinksCount-1) do
         begin
          linkF:=FGLinksArray.Links[i];
          linkL:=FGLinksArray.Links[j];
          if ((linkF^.FromNodeNumber and BPGlobalMask)=0) and
             ((linkF^.ToNodeNumber and BPGlobalMask)=0) and
             ((linkL^.FromNodeNumber and BPGlobalMask)=0) and
             ((linkL^.ToNodeNumber and BPGlobalMAsk)=0) and
             ((linkF^.dwFlags and BP_FROMTOMASK)=BP_RIGHT_LEFT) and
             ((linkL^.dwFlags and BP_FROMTOMASK)=BP_RIGHT_LEFT) then
           begin
             if (linkF^.ToNodeNumber=linkL^.ToNodeNumber) then
              begin
               fni:=GetLinkIndexEx(linkF^.FromNodeNumber);
               lni:=GetLinkIndexEx(linkL^.FromNodeNumber);
               if (fni<lni) then
                begin
                  FGLinksArray.Links[j]:=linkF;
                  FGLinksArray.Links[i]:=linkL;
                  Flag:=False;
                end;
              end
             else
             begin
              fni:=GetLinkIndexEx(linkF^.ToNodeNumber);
              lni:=GetLinkIndexEx(linkL^.ToNodeNumber);
              if (fni<lni) then
                begin
                  FGLinksArray.Links[j]:=linkF;
                  FGLinksArray.Links[i]:=linkL;
                  Flag:=False;
                end;
             end;
           end
          else
           if ((linkF^.FromNodeNumber and BPGlobalMask)<>0) or
              ((linkF^.ToNodeNumber and BPGlobalMask)<>0) or
              ((linkF^.dwFlags and BP_FROMTOMASK)<>BP_RIGHT_LEFT) then linkF^.Visible:=False
           else
           if ((linkL^.FromNodeNumber and BPGlobalMask)<>0) or
              ((linkL^.ToNodeNumber and BPGlobalMask)<>0) or
              ((linkL^.dwFlags and BP_FROMTOMASK)<>BP_RIGHT_LEFT) then linkL^.Visible:=False;
         end;
        end;
     end;
 end;



function   TBPPNDGraph.GetLinkFrom(const value:PPNDGraphLink):TLinkType; { Checked }
  begin
    Result:=lt_Right;
    if value=nil then Exit;
    case (value^.dwFlags and BP_FROMMASK) of
     BP_FROMNODE_LEFT:   Result:=lt_Left;
     BP_FROMNODE_RIGHT:  Result:=lt_Right;
     BP_FROMNODE_TOP:    Result:=lt_Top;
     BP_FROMNODE_BOTTOM: Result:=lt_Bottom;
    end;
  end;

function   TBPPNDGraph.GetLinkTo(const value:PPNDGraphLink):TLinkType; { Checked }
  begin
   Result:=lt_Left;
    case (value^.dwFlags and BP_TOMASK) of
     BP_TONODE_LEFT:   Result:=lt_Left;
     BP_TONODE_RIGHT:  Result:=lt_Right;
     BP_TONODE_TOP:    Result:=lt_Top;
     BP_TONODE_BOTTOM: Result:=lt_Bottom;
    end;
  end;

function  TBPPNDGraph.GetNodeRegion(NodeNumber:DWORD):TBPPNDRegion;
Var i:Integer;
 begin
   Result.LeftRegion:=-1;
   Result.RightRegion:=-1;
   Result.TopRegion:=-1;
   Result.BottomRegion:=-1;
   for i:=0 to (FNodeXArray.NodesCount-1) do
     begin
       if NodeNumber=FNodeXArray.NodeNumber[i] then
         begin
           Result.LeftRegion:=FNodeXArray.NodesXLeft[i];
           Result.RightRegion:=FNodeXArray.NodesXRight[i];
           Result.TopRegion:=FNodeXArray.NodesYTop[i];
           Result.BottomRegion:=FNodeXArray.NodesYBottom[i];
           Exit;
         end;
     end;
 end;

procedure TBPPNDGraph.FillLeftArray;
Var tmpNode:PPNDGraphNode;
          p:TBPPNDRegion;
          lr:Integer;
        posx:Integer;
         ind:Integer;
 begin
  {}
   if (FGNodesCount=0) then Exit;
   FLeftArray.RegionCount:=0;
   tmpNode:=FGraphNodes;
   while (tmpNode<>nil) do
    begin
      p:=GetNodeRegion(tmpNode^.BPNode.NodeNumber);
      if FOwner.HorzScrollBar.Visible then posx:=FOwner.HorzScrollBar.ScrollPos else posx:=0;
      lr:=Round(p.LeftRegion*FRatioX)+FOwner.ClientRect.Left+FGlobalLeftSize-posx;
      ind:=IsLeftArray(lr);
      if ind=-1 then
        begin
         FLeftArray.Region[FLeftArray.RegionCount]:=lr;
         FLeftArray.Count[FLeftArray.RegionCount]:=0;
         inc(FLeftArray.RegionCount);
        end;
      tmpNode:=tmpNode^.next;
    end;
 end;

procedure TBPPNDGraph.FillTopArray;
Var tmpNode:PPNDGraphNode;
          p:TBPPNDRegion;
          lr:Integer;
        posy:Integer;
         ind:Integer;
 begin
  {}
   if (FGNodesCount=0) then Exit;
   FTopArray.RegionCount:=0;
   tmpNode:=FGraphNodes;
   while (tmpNode<>nil) do
    begin
      p:=GetNodeRegion(tmpNode^.BPNode.NodeNumber);
      if FOwner.VertScrollBar.Visible then posy:=FOwner.VertScrollBar.ScrollPos else posy:=0;
      lr:=Round(p.TopRegion*FRatioY)+FOwner.ClientRect.Top+FGlobalTopSize-posy;
      ind:=IsTopArray(lr);
      if ind=-1 then
        begin
         FTopArray.Region[FTopArray.RegionCount]:=lr;
         FTopArray.Count[FTopArray.RegionCount]:=0;
         inc(FTopArray.RegionCount);
        end;
      tmpNode:=tmpNode^.next;
    end;
 end;


procedure TBPPNDGraph.FillRightArray;
Var tmpNode:PPNDGraphNode;
          p:TBPPNDRegion;
          lr:Integer;
        posx:Integer;
         ind:Integer;
 begin
  {}
   if (FGNodesCount=0) then Exit;
   FRightArray.RegionCount:=0;
   tmpNode:=FGraphNodes;
   while (tmpNode<>nil) do
    begin
      p:=GetNodeRegion(tmpNode^.BPNode.NodeNumber);
      if FOwner.HorzScrollBar.Visible then posx:=FOwner.HorzScrollBar.ScrollPos else posx:=0;
      lr:=Round(p.RightRegion*FRatioX)+FOwner.ClientRect.Left+FGlobalLeftSize-posx;
      ind:=IsRightArray(lr);
      if ind=-1 then
        begin
         FRightArray.Region[FRightArray.RegionCount]:=lr;
         FRightArray.Count[FRightArray.RegionCount]:=0;
         inc(FRightArray.RegionCount);
        end;
      tmpNode:=tmpNode^.next;
    end;
 end;

procedure TBPPNDGraph.FillBottomArray;
Var tmpNode:PPNDGraphNode;
          p:TBPPNDRegion;
          lr:Integer;
        posy:Integer;
         ind:Integer;
 begin
  {}
   if (FGNodesCount=0) then Exit;
   FBottomArray.RegionCount:=0;
   tmpNode:=FGraphNodes;
   while (tmpNode<>nil) do
    begin
      p:=GetNodeRegion(tmpNode^.BPNode.NodeNumber);
      if FOwner.VertScrollBar.Visible then posy:=FOwner.VertScrollBar.ScrollPos else posy:=0;
      lr:=Round(p.BottomRegion*FRatioY)+FOwner.ClientRect.Top+FGlobalTopSize-posy;
      ind:=IsBottomArray(lr);
      if ind=-1 then
        begin
         FBottomArray.Region[FBottomArray.RegionCount]:=lr;
         FBottomArray.Count[FBottomArray.RegionCount]:=0;
         inc(FBottomArray.RegionCount);
        end;
      tmpNode:=tmpNode^.next;
    end;
 end;


function  TBPPNDGraph.IsLeftArray(value:Integer):Integer;
Var i:Integer;
 begin
   Result:=-1;
   for i:=0 to (FLeftArray.RegionCount-1) do
    begin
      if FLeftArray.Region[i]=value then Result:=i;
    end;
 end;

function  TBPPNDGraph.IsRightArray(value:Integer):Integer;
Var i:Integer;
 begin
   Result:=-1;
   for i:=0 to (FRightArray.RegionCount-1) do
    begin
      if FRightArray.Region[i]=value then Result:=i;
    end;
 end;

function  TBPPNDGraph.IsTopArray(value:Integer):Integer;
Var i:Integer;
 begin
   Result:=-1;
   for i:=0 to (FTopArray.RegionCount-1) do
    begin
      if FTopArray.Region[i]=value then Result:=i;
    end;
 end;           

function  TBPPNDGraph.IsBottomArray(value:Integer):Integer;
Var i:Integer;
 begin
   Result:=-1;
   for i:=0 to (FBottomArray.RegionCount-1) do
    begin
      if FBottomArray.Region[i]=value then Result:=i;
    end;
 end;



procedure TBPPNDGraph.CalcNodesLinkType;
Var tmpLink:PPNDGraphLink;
    tmpNodeF,tmpNodeT:PPNDGraphNode;
    nodeF,nodeT,nodeP,nodeP1,nodeX:TBPPNDNodeDef;
    i,cc:Integer;
    fc,tc:Integer;
 begin
   if FGraphNodes=nil then Exit;
   if FGraphLinks=nil then Exit;
   tmpLink:=FGraphLinks;
   while (tmpLink<>nil) do
     begin
       if tmpLink^.Visible then
         begin
           tmpNodeF:=GetGraphNumberedNode(tmpLink^.FromNodeNumber);
           tmpNodeT:=GetGraphNumberedNode(tmpLink^.ToNodeNumber);
           nodeF:=FindCheckNode(tmpNodeF);
           nodeT:=FindCheckNode(tmpNodeT);
           if not((nodeF.NodeIndex=-1) or (nodeF.Level=-1) or
              (nodeT.NodeIndex=-1) or (nodeT.Level=-1)) then
             begin
               nodeP:=FCheckLevelsArray.ParentNode[nodeF.NodeIndex,nodeF.Level];
               nodeP1:=FCheckLevelsArray.ParentNode[nodeT.NodeIndex,nodeT.Level];
               if (nodeP.NodeIndex=nodeT.NodeIndex) and (nodeP.Level=nodeT.Level) then
                begin
                 if (nodeF.Level=nodeT.Level) then
                  if ABS(nodeF.NodeIndex-nodeT.NodeIndex)=1 then
                  tmpLink^.LinkType:=onechild_right
                 else
                  tmpLink^.LinkType:=manychild_lr
                 else
                  if ABS(nodeF.Level-nodeT.Level)=1 then
                   tmpLink^.LinkType:=onelevel_up
                  else
                   tmpLink^.LinkType:=manylevel_up;
                end
               else
                if (nodeP.NodeIndex=nodeP1.NodeIndex) and (nodeP.Level=nodeP1.Level) then
                begin
                 { child nodes links }
                  if (nodeP.NodeIndex=-1) and (nodeP.Level=-1) then
                  begin
                   cc:=FCheckLevelsArray.NodesCount[0];
                   i:=0;
                   fc:=0;
                   tc:=0;
                   while (i<cc) do
                    begin
                     if FCheckLevelsArray.Nodes[i,0]=tmpNodeF then
                        fc:=i;
                     if FCheckLevelsArray.Nodes[i,0]=tmpNodeT then
                        tc:=i;
                      inc(i);
                    end;
                  end
                  else
                  begin
                  cc:=FCheckLevelsArray.ChildCound[nodeP.NodeIndex,nodeP.Level];
                  i:=0;
                  fc:=0;
                  tc:=0;
                  while (i<cc) do
                   begin
                     nodeX:=FCheckLevelsArray.ChildNode[i,nodeP.NodeIndex,nodeP.Level];
                     if (nodeX.NodeIndex=nodeF.NodeIndex) and (nodeX.Level=nodeF.Level) then
                        fc:=i;
                     if (nodeX.NodeIndex=nodeT.NodeIndex) and (nodeX.Level=nodeT.Level) then
                        tc:=i;
                     inc(i);
                   end;
                  end;
                  if ABS(fc-tc)=1 then
                    if fc>tc then
                     tmpLink^.LinkType:=onechild_left
                    else
                     tmpLink^.LinkType:=onechild_right
                  else
                    tmpLink^.LinkType:=manychild_lr;
                end
               else
                begin
                  tmpLink^.LinkType:=manylevel_up;
                end;
             end;
         end;
       tmpLink:=tmpLink^.next;
     end;
 end;

function  TBPPNDGraph.CalcNodeDefWidth(var pw:Integer;px,x:Integer;node:TBPPNDNodeDef):Integer;
Var tmpNode:PPNDGraphNode;
         cc:Integer;
        i:Integer;
      cnode:TBPPNDNodeDef;
          a:Integer;
          b:Integer;
         nw:Integer;
         pnode:TBPPNDNodeDef;
         pl:Integer;
 begin
   nw:=2*FMaxWidth;
   Result:=nw;
   if (node.NodeIndex=-1) or (node.Level=-1) then Exit;
   pnode:=FCheckLevelsArray.ParentNode[node.NodeIndex,node.Level];
   pl:=pnode.Level;
   tmpNode:=FCheckLevelsArray.Nodes[node.NodeIndex,node.Level];
   if tmpNode^.Finalized then Exit;
   cc:=FCheckLevelsArray.ChildCound[node.NodeIndex,node.Level];
   b:=0;
   if pl=node.Level then nw:=nw+FMaxWidth;
   for i:=0 to (cc-1) do
     begin
       cnode:=FCheckLevelsArray.ChildNode[i,node.NodeIndex,node.Level];
       a:=CalcNodeDefWidth(nw,x,b+x,cnode);
       b:=b+a;
     end;
   tmpNode^.FinalX:=x+((nw-FMaxWidth) div 2);
   tmpNode^.FinalY:=(node.Level*FMaxHeight*2+(FMaxHeight div 2));
   tmpNode^.BPNode.LeftRegion:=x;
   tmpNode^.BPNode.RightRegion:=x+nw;
   if pl=node.Level then tmpNode^.BPNode.RightRegion:=tmpNode^.BPNode.RightRegion-FMaxWidth;
   tmpNode^.BPNode.TopRegion:=node.Level*FMaxHeight*2;
   tmpNode^.BPNode.BottomRegion:=(node.Level+1)*FMaxHeight*2;
   tmpNode^.Finalized:=True;
   if ((pw+px-x)<nw) then
         pw:=x-px+nw;
   Result:=nw;
 end;

function  TBPPNDGraph.GetFreeLevel(node:PPNDGraphNode):Integer;
Var nd,nd1:TBPPNDNodeDef;
     cc,i,lev1:Integer;
 begin
   Result:=-1;
   if node=nil then Exit;
   nd:=FindCheckNode(node);
   if (nd.NodeIndex=-1) or (nd.Level=-1) then begin Result:=0; Exit; end;
   Result:=nd.Level+1;
   cc:=FCheckLevelsArray.ChildCound[nd.NodeIndex,nd.Level];
   for i:=0 to (cc-1) do
    begin
      nd1:=FCheckLevelsArray.ChildNode[i,nd.NodeIndex,nd.Level];
      lev1:=GetFreeLevel(FCheckLevelsArray.Nodes[nd1.NodeIndex,nd1.Level]);
      if lev1>Result then Result:=lev1;
    end;
 end;

function  TBPPNDGraph.CompareTwoNodes(s1,s2:String):Boolean;
Var i,j:Integer;
    s:String;
    s3,s4:String;
 begin
   Result:=False;
   s:=s1;
   i:=0;
   while (pos('.',s)>0) and (length(s)>0) do
     begin
       delete(s,1,pos('.',s));
       inc(i);
     end;
   j:=0;
   s:=s2;
   while (pos('.',s)>0) and (length(s)>0) do
     begin
       delete(s,1,pos('.',s));
       inc(j);
     end;
   if (pos('.',s1)>0) then  s3:=copy(s1,1,pos('.',s1)-1) else s3:=s1;
   if (pos('.',s2)>0) then  s4:=copy(s2,1,pos('.',s2)-1) else s4:=s2;
   if (i=j) and (s3=s4) then Result:=True;
 end;

function  TBPPNDGraph.GetNodeAtSameParent(node:PPNDGraphNode;var returnNode:PPNDGraphNode;AddonSearch:Boolean):Integer;
Var i,j,k,m:Integer;
    s,s1,s2,s3,s4,s5:String;
    flag:Boolean;
    newNode:PPNDGraphNode;
 begin
   Result:=-1;
   returnNode:=nil;
   if node=nil then Exit;
   s:=GetNodeLevelIND(node^.BPNode.SNodeNumber);
   s2:=Trim(node^.BPNode.SNodeNumber);
   delete(s2,1,1);
   while (length(s2)>0) and (s2[length(s2)] in ['0'..'9']) do delete(s2,length(s2),1);
   if (length(s2)>0) and (s2[length(s2)]='.') then delete(s2,length(s2),1);
   for i:=0 to (FCheckLevelsArray.LevelsCount-1) do
     for j:=0 to (FCheckLevelsArray.NodesCount[i]-1) do
       begin
       s1:=GetNodeLevelIND(FCheckLevelsArray.Nodes[j,i]^.BPNode.SNodeNumber);
       s3:=Trim(FCheckLevelsArray.Nodes[j,i]^.BPNode.SNodeNumber);
       delete(s3,1,1);
       while (length(s3)>0) and (s3[length(s3)] in ['0'..'9']) do delete(s3,length(s3),1);
       if (length(s3)>0) and (s3[length(s3)]='.') then delete(s3,length(s3),1);
      { if s=s1 then
          begin
            Result:=i;
            ReturnNode:=FCheckLevelsArray.Nodes[j,i];
            Exit;
          end;   }
       if s2=s3 then
          begin
            Result:=i;
            ReturnNode:=FCheckLevelsArray.Nodes[j,i];
            Exit;
          end;
        if AddonSearch and CompareTwoNodes(s2,s3) then
          begin
            Result:=i;
            ReturnNode:=FCheckLevelsArray.Nodes[j,i];
            Exit;
          end;
       end;
 end;

function  TBPPNDGraph.IsTreeChild(node,pnode:PPNDGraphNode):Boolean;
var s,s1:String;
 begin
   Result:=False;
   if node=nil then Exit;
   if pnode=nil then begin Result:=True; Exit; end;
{   s:=GetNodeLevelIND(node^.BPNode.SNodeNumber);}
   s:=Trim(node^.BPNode.SNodeNumber);
   delete(s,1,1);
   while (length(s)>0) and (s[length(s)] in ['0'..'9']) do delete(s,length(s),1);
   if (length(s)>0) and (s[length(s)]='.') then delete(s,length(s),1);
{   s1:=GetNodeNumberIND(pnode^.BPNode.SNodeNumber);}
   s1:=Trim(pnode^.BPNode.SNodeNumber);
   delete(s1,1,1);
   if s1=s then Result:=True;
 end;


function  TBPPNDGraph.CompareFromToNumbers(FromN,ToN:Integer):Boolean;
var tmpF,tmpT:PPNDGraphNode;
    sF,sT:String;
 begin
   Result:=False;
   tmpF:=GetGraphNumberedNode(FromN);
   tmpT:=GetGraphNumberedNode(ToN);
{   sF:=GetNodeNumberIND(tmpF^.BPNode.SNodeNumber);
   sT:=GetNodeNumberIND(tmpT^.BPNode.SNodeNumber);}
   sF:=Trim(tmpF^.BPNode.SNodeNumber);
   sT:=Trim(tmpT^.BPNode.SNodeNumber);
   delete(sF,1,1);
   delete(sT,1,1);
   if ( ((length(sT)<length(sF)) or (sF[1]>sT[1])) and  (sF[1]<>'-') and (sT[1]<>'-')) or
      ( (length(sT)>length(sF)) and  ((sF[1]='-') and (sT[1]<>'-')) ) or
      ((sT[1]>=sF[1]) and (sF[1]<>'-') and (sT[1]<>'-')) then Result:=True;
 end;

function  TBPPNDGraph.HasParentEx(node:PPNDGraphNode):PPNDGraphNode;
Var s,s1:String;
    tmp:PPNDGraphNode;
    tmpL:PPNDGraphLink;
    num:Integer;
    nd:TBPPNDNodeDef;
    i:Integer;
 begin
   Result:=nil;
   if node=nil then Exit;
   num:=node^.BPNode.NodeNumber;
{   s:=GetNodeLevelIND(node^.BPNode.SNodeNumber);}
   s:=Trim(node^.BPNode.SNodeNumber);
   delete(s,1,1);
   while (length(s)>0) and (s[length(s)] in ['0'..'9']) do delete(s,length(s),1);
   if (length(s)>0) and (s[length(s)]='.') then delete(s,length(s),1);
   tmp:=FGraphNodes;
   if tmp=nil then Exit;
   while (tmp<>nil) do
     begin
       if (tmp<>node) then
         begin
{           s1:=GetNodeNumberIND(tmp^.BPNode.SNodeNumber);}
           s1:=Trim(tmp^.BPNode.SNodeNumber);
           delete(s1,1,1);
           if (s1=s) and (node^.BPNode.Tag>tmp^.BPNode.Tag) then
             begin
               Result:=tmp;
               Exit;
             end;
         end;
       tmp:=tmp^.next;
     end;
   { Now links parent in FCheckLevelsArray }
   if FGLinksArray.LinksCount=0 then Exit;
   for i:=0 to (FGLinksArray.LinksCount-1) do
     begin { for i}
       tmpL:=FGLinksArray.Links[i];
       if tmpL^.Visible then
       begin { visible }
       if (tmpL^.FromNodeNumber=num) and
          ((tmpL^.dwFlags and BP_FROMTOMASK)=BP_RIGHT_LEFT) and
           CompareFromToNumbers(tmpL^.FromNodeNumber,tmpL^.ToNodeNumber) then
           begin
             tmp:=GetGraphNumberedNode(tmpL^.ToNodeNumber);
             if tmp<>nil then
               begin
                 nd:=FindCheckNode(tmp);
                 if (nd.NodeIndex<>-1) and (nd.Level<>-1) then
                  begin
                   Result:=tmp;
                   Exit;
                  end;
               end;
           end;
       end; { Visible }
     end; { for }
 end;

function  TBPPNDGraph.FindCheckNode(node:PPNDGraphNode):TBPPNDNodeDef;
var i,j:Integer;
 begin
   Result.NodeIndex:=-1;
   Result.Level:=-1;
   for i:=0 to (FCheckLevelsArray.LevelsCount-1) do
     for j:=0 to (FCheckLevelsArray.NodesCount[i]-1) do
       if FCheckLevelsArray.Nodes[j,i]=node then
          begin
            Result.NodeIndex:=j;
            Result.Level:=i;
            Exit;
          end;
 end;

procedure TBPPNDGraph.MoveArray(nodeindex,level:Integer);
var i,j,nc,cc:Integer;
    node:TBPPNDNodeDef;
 begin
   nc:=FCheckLevelsArray.NodesCount[level];
   { Change childs }
   for i:=nodeindex to (nc-1) do
     begin
       cc:=FCheckLevelsArray.ChildCound[i,level];
       for j:=0 to (cc-1) do
         begin
          node:=FCheckLevelsArray.ChildNode[j,i,level];
          FCheckLevelsArray.ParentNode[node.NodeIndex,node.Level].NodeIndex:=FCheckLevelsArray.ParentNode[node.NodeIndex,node.Level].NodeIndex+1;
         end;
     end;
   for i:=nc downto (nodeIndex+1) do
     begin
      FCheckLevelsArray.Nodes[i,level]:=FCheckLevelsArray.Nodes[i-1,level];
      FCheckLevelsArray.IsTreeNode[i,level]:=FCheckLevelsArray.IsTreeNode[i-1,level];
      FCheckLevelsArray.ParentNode[i,level]:=FCheckLevelsArray.ParentNode[i-1,level];
      cc:=FCheckLevelsArray.ChildCound[i-1,level];
      for j:=0 to (cc-1) do
        begin
          FCheckLevelsArray.ChildNode[j,i,level]:=FCheckLevelsArray.ChildNode[j,i-1,level];
        end;
      FCheckLevelsArray.ChildCound[i,level]:=cc;
     end;
   FCheckLevelsArray.NodesCount[level]:=FCheckLevelsArray.NodesCount[level]+1;
 end;

procedure TBPPNDGraph.InsertChildAt(id,parent:PPNDGraphNode;Level:Integer;IsTree:Boolean);
Var node,node1:TBPPNDNodeDef;
  nc,cc:Integer;
   i:Integer;
   flag1:Boolean;
   eflag:Boolean;
   nt:TBPNodeTypes;
 begin
   if (FCheckLevelsArray.LevelsCount<(level+1)) then
       FCheckLevelsArray.LevelsCount:=level+1;
   node:=FindCheckNode(parent);
   if (node.NodeIndex=-1) or (node.Level=-1) then
     begin
       nc:=FCheckLevelsArray.NodesCount[level];
       FCheckLevelsArray.Nodes[nc,level]:=id;
       id^.LevelID:=level;
       FCheckLevelsArray.ChildCound[nc,level]:=0;
       FCheckLevelsArray.IsTreeNode[nc,level]:=IsTree;
       FCheckLevelsArray.ParentNode[nc,level]:=node;
       nt:=GetNTFromIndex(id^.llNode.dwNodeIndex);
       FCheckLevelsArray.NodeType[nc,level]:=nt;
       FCheckLevelsArray.NodesCount[level]:=FCheckLevelsArray.NodesCount[level]+1;
     end
   else
     begin
       { Insert at lastpos}
       i:=0;
       cc:=FCheckLevelsArray.NodesCount[level];
       flag1:=False;
       eflag:=True;
       while (i<cc) and (eflag) do
        begin
          node1:=FCheckLevelsArray.ParentNode[i,level];
          if (node1.NodeIndex=node.NodeIndex) and (node1.Level=node.Level) then flag1:=True;
          if flag1 and ((node.NodeIndex<>node1.NodeIndex) or(node.Level<>node1.Level)) then
            eflag:=False
          else
            inc(i);
        end;
       MoveArray(i,level); { dont forget inc nodescount at level }
       node1.NodeIndex:=i;
       node1.Level:=level;
       FCheckLevelsArray.Nodes[i,level]:=id;
       id^.LevelID:=level;
       nt:=GetNTFromIndex(id^.llNode.dwNodeIndex);
       FCheckLevelsArray.NodeType[i,level]:=nt;
       FCheckLevelsArray.IsTreeNode[i,level]:=IsTree;
       FCheckLevelsArray.ParentNode[i,level]:=node;
       FCheckLevelsArray.ChildCound[i,level]:=0;
       { Add child to parent node }
       cc:=FCheckLevelsArray.ChildCound[node.NodeIndex,node.Level];
       FCheckLevelsArray.ChildNode[cc,node.NodeIndex,node.Level]:=node1;
       FCheckLevelsArray.ChildCound[node.NodeIndex,node.Level]:=FCheckLevelsArray.ChildCound[node.NodeIndex,node.Level]+1;
     end;
 end;

function TBPPNDGraph.CheckForSameParent(pr,tst:PPNDGraphNode):Boolean;
var i,j:Integer;
    eflag:Boolean;
    tmp2:PPNDGraphNode;
Const MaxIterration=1000;
 begin
   Result:=False;
   if (pr=nil) or (tst=nil) then Exit;
   tmp2:=tst;
   j:=0;
   eflag:=True;
   while (eflag) and  (j<MaxIterration) do
    begin
      if tmp2=pr then begin Result:=True; Exit; end;
      tmp2:=HasParentEx(tmp2);
      if tmp2=nil then eflag:=false else  inc(j);
     end;
 end;


procedure TBPPNDGraph.FillCheckLevelsArray;
var i,j,l:Integer;
    eflag,eflag1:Boolean;
    tflag:Boolean;
    tmp,tmp1,tmp2,tmp3,tmp4:PPNDGraphNode;
    lev,lev1:Integer;
    lev2:Integer;
    f:TextFile;
    flDiscard:Boolean;
    levOfs:Integer;

Const MaxIterration=1000;

 begin
   { Analize and fill levels }
   { First fill ierarchy tree }
   FCheckLevelsArray.LevelsCount:=0;
   for i:=0 to 100 do FCheckLevelsArray.NodesCount[i]:=0; { Nodes at levels }
   for i:=0 to 100 do for j:=0 to 100 do FCheckLevelsArray.ChildCound[i,j]:=0; { Child at levels }
   eflag:=True;
   i:=0;
   tmp:=FGraphNodes;
   levOfs:=10000;  { zum beischpiel }
   while (tmp<>nil) do
    begin
      l:=GetNodeLevelEx(tmp^.llNode.dwNodeIndex);
      if levOfs>l then levOfs:=l;
      tmp:=tmp^.next;
    end;
   tmp:=FGraphNodes;
   while ((eflag) and (i<FGNodesCount)) do
     begin
       tmp1:=HasParentEx(tmp);
       lev:=GetNodeLevelEx(tmp^.llNode.dwNodeIndex)-levOfs;
       if tmp1<>nil then lev2:=GetNodeLevelEx(tmp1^.llNode.dwNodeIndex) else lev2:=0;
       if lev<>0 then
         begin
           if lev2=lev then
             begin
               j:=0;
               while (lev2=lev) and (j<MaxIterration) do
                 begin
                   tmp2:=HasParentEx(tmp1);
                   if tmp2<>nil then
                    begin
                     tmp1:=tmp2;
                     lev2:=GetNodeLevelEx(tmp2^.llNode.dwNodeIndex);
                     end
                     else lev2:=0;
                   inc(j);
                 end;
             end;
         end
       else
        begin
          if (lev=0) and (tmp1<>nil) then
            begin
              while (tmp1<>nil) do
               begin
                tmp1:=HasParentEx(tmp1);
               end;
            end;
         end;
       if (tmp1<>nil) then
          InsertChildAt(tmp,tmp1,lev,False)
       else
          InsertChildAt(tmp,nil,lev,False);
       tmp:=tmp^.next;
       inc(i);
       Application.ProcessMessages;
     end;
    if FDebug then
     begin
       AssignFile(f,'pnd.dbg');
       Rewrite(f);
       for i:=0 to (FCheckLevelsArray.LevelsCount-1) do
        begin
         WriteLn(f,'Level:'+IntToStr(i));
        for j:=0 to (FCheckLevelsArray.NodesCount[i]-1) do
          begin
            WriteLn(f,FCheckLevelsArray.Nodes[j,i]^.BPNode.SNodeNumber);
          end;
        end;
       CloseFile(f);
     end;
 end;

procedure TBPPNDGraph.FillCheckLevelsArray2;
var i,j,k:Integer;
    eflag,eflag1:Boolean;
    tflag:Boolean;
    tmp,tmp1,tmp2,tmp3,tmp4:PPNDGraphNode;
    lev,lev1:Integer;
    f:TextFile;
    flDiscard:Boolean;
    levelsType:Array[0..100] of DWORD;

Const MaxIterration=1000;

 begin
   { Analize and fill levels }
   { First fill ierarchy tree }
   FCheckLevelsArray.LevelsCount:=0;
   for i:=0 to 100 do
     begin
      FCheckLevelsArray.NodesCount[i]:=0; { Nodes at levels }
      levelsType[i]:=$FFFFFFFF;
     end;
   for i:=0 to 100 do for j:=0 to 100 do FCheckLevelsArray.ChildCound[i,j]:=0; { Child at levels }
   eflag:=True;
   i:=0;
   tmp:=FGraphNodes;
   while ((eflag) and (i<FGNodesCount)) do
     begin
       if tmp^.BPNode.SNodeNumber='A4.3' then
         begin
           inc(k);
         end;
       tmp1:=HasParentEx(tmp);
       if IsTreeChild(tmp,tmp1) then
         begin
          if tmp1<>nil then
               lev:=tmp1^.LevelID+1
            else
               lev:=0;
          tflag:=True;
         end
       else
         begin
          tflag:=false;
          eflag1:=True;
          flDiscard:=True;
          lev1:=GetNodeAtSameParent(tmp,tmp4,True);
          tmp2:=tmp1;
          tmp3:=tmp1;
          j:=0;
          while (eflag1) and  (j<MaxIterration) do
           begin
            if tmp4=tmp2 then flDiscard:=False;
            tmp2:=HasParentEx(tmp2);
            if tmp2=nil then eflag1:=false else tmp3:=tmp2;
            inc(j);
           end;
          if j=MaxIterration then tmp3:=tmp1;
          lev:=GetFreeLevel(tmp3);
          if (lev1<>-1) {and flDiscard} then lev:=lev1;
         end;
       if (tmp1<>nil) then
          InsertChildAt(tmp,tmp1,lev,tflag)
       else
          InsertChildAt(tmp,nil,0,True);
       tmp:=tmp^.next;
       inc(i);
       Application.ProcessMessages;
     end;
    if True{FDebug} then
     begin
       AssignFile(f,'pnd.dbg');
       Rewrite(f);
       for i:=0 to (FCheckLevelsArray.LevelsCount-1) do
        begin
         WriteLn(f,'Level:'+IntToStr(i));
        for j:=0 to (FCheckLevelsArray.NodesCount[i]-1) do
          begin
            WriteLn(f,FCheckLevelsArray.Nodes[j,i]^.BPNode.SNodeNumber);
          end;
        end;
       CloseFile(f);
     end;
 end;


procedure TBPPNDGraph.TranslateToNodesCoord;
Var w:Integer;
    cc,i,j:Integer;
    node:TBPPNDNodeDef;
    f:TextFile;
    tmpN:PPNDGraphNode;
 begin
   { translate levels to nodes coords }
    FADefWidth:=0;
    FADefHeight:=0;
    w:=0;
    if FCheckLevelsArray.LevelsCount=0 then Exit;
    FADefHeight:=FCheckLevelsArray.LevelsCount*2*FMaxHeight;
    cc:=FCheckLevelsArray.NodesCount[0];
    node.Level:=0;
    for i:=0 to (cc-1) do
      begin
       node.NodeIndex:=i;
       w:=0;
       FADefWidth:=FADefWidth+CalcNodeDefWidth(w,FADefWidth,FADefWidth,node);
      end;
    if FDebug then
     begin
       AssignFile(f,'pnd.dbg');
       Rewrite(f);
       for i:=0 to (FCheckLevelsArray.LevelsCount-1) do
        begin
         WriteLn(f,'Level:'+IntToStr(i+1));
         for j:=0 to (FCheckLevelsArray.NodesCount[i]-1) do
           begin
             tmpN:=FCheckLevelsArray.Nodes[j,i];
             WriteLn(f,tmpN^.BPNode.SNodeNumber);
             WriteLn(f,'LR: '+IntToStr(tmpN^.BPNode.LeftRegion));
             WriteLn(f,'RR: '+IntToStr(tmpN^.BPNode.RightRegion));
             WriteLn(f,'TR: '+IntToStr(tmpN^.BPNode.TopRegion));
             WriteLn(f,'BR: '+IntToStr(tmpN^.BPNode.BottomRegion));
           end;
        end;
       CloseFile(f);
     end;
 end;

procedure  TBPPNDGraph.TraceNodesToLinksCounters; { Checked }
  Var linkP:PPNDGraphLink;
         i:Integer;
 begin
   if (FGLinksCount=0) then Exit;
   for i:=0 to (FGLinksCount-1) do
    begin
     linkP:=GetGraphLink(i);
     linkP^.LinkFromCount:=0;
     linkP^.LinkToCount:=0;
     linkP^.MinimalXFrom:=0;
     linkP^.MinimalXTo:=0;
     linkP^.MinimalYFrom:=0;
     linkP^.MinimalYTo:=0;
     linkP^.LinkLeftCountFrom:=0;
     linkP^.LinkRightCountFrom:=0;
     linkP^.LinkTopCountFrom:=0;
     linkP^.LinkBottomCountFrom:=0;
     linkP^.LinkLeftCountTo:=0;
     linkP^.LinkRightCountTo:=0;
     linkP^.LinkTopCountTo:=0;
     linkP^.LinkBottomCountTo:=0;
  end;
 end;


procedure  TBPPNDGraph.TraceNodes; { Checked }
 Var i:Integer;
     gnode:PPNDGraphNode;
     w1,h1:Integer;
  begin
    if (FGNodesCount=0) then Exit;
    { We get max node width & height for drawing text, but }
    w1:=FMaxWidth;
    h1:=FMaxHeight;
{    if w1>h1 then h1:=Round(w1/NodeRatio) else
     w1:=Round(h1*NodeRatio);}
    { Printing ! }
     if FPrinting then
     begin
      FRatioX:=(FDefWidth-FGlobalLeftSize-FGlobalRightSize)/(FinalWidth+1);
      FRatioY:=(FDefHeight-FGlobalTopSize-FGlobalBottomSize)/(FinalHeight+1);
      w1:=Round(FNWidth*FRatioX);
      h1:=Round(FNHeight*FRatioY);
     end
      else
     begin
      FinalWidth:=FADefWidth;
      FinalHeight:=FADefHeight;
      FNWidth:=w1;
      FNHeight:=h1;
      FRatioX:=1.0;
      FRatioY:=1.0;
      gnode:=FGraphNodes;
      FNodeXArray.NodesCount:=0;
      for i:=0 to (FGNodesCount-1) do
       begin
         FinalNodeX[i]:=gnode^.FinalX;
         FinalNodeY[i]:=gnode^.FinalY;
         FNodeXArray.NodeNumber[i]:=gnode^.BPNode.NodeNumber;
         FNodeXArray.NodesXLeft[i]:=gnode^.BPNode.LeftRegion;
         FNodeXArray.NodesXRight[i]:=gnode^.BPNode.RightRegion;
         FNodeXArray.NodesYTop[i]:=gnode^.BPNode.TopRegion;
         FNodeXArray.NodesYBottom[i]:=gnode^.BPNode.BottomRegion;
         gnode:=gnode^.next;
         FNodeXArray.NodesCount:=FNodeXArray.NodesCount+1;
       end;
      FDefWidth:=FGlobalLeftSize+FGlobalRightSize+FinalWidth+(w1 div 2);
      FDefHeight:=FGlobalTopSize+FGlobalBottomSize+FinalHeight+(h1 div 2);
     end;
      FAcceptDragRect.Left:=FGlobalLeftSize;
      FAcceptDragRect.Top:=FGlobalTopSize;
      FAcceptDragRect.Bottom:=FDefHeight-FGlobalBottomSize;
      FAcceptDragRect.Right:=FDefWidth-FGlobalRightSize;
      if Parent.HorzScrollBar.Range<>FDefWidth then
       Parent.HorzScrollBar.Range:=FDefWidth;
      if Parent.VertScrollBar.Range<>FDefHeight then
       Parent.VertScrollBar.Range:=FDefHeight;
    FNodeWidth:=w1;
    FNodeHeight:=h1;
    for i:=0 to (FGNodesCount-1) do
     begin
       gnode:=GetGraphNodeRec(i);
       if gnode=nil then Exit;
       gnode^.BPNode.AutoHeight:=False;
       gnode^.BPNode.AutoWidth:=False;
       gnode^.BPNode.DefWidth:=w1;
       gnode^.BPNode.DefHeight:=h1;
       if ((FDiscardDrags) or (not(gnode^.BPNode.AcceptPosition))) then
        begin
         gnode^.BPNode.Top:=FOwner.ClientRect.Top+FGlobalTopSize+Round(FinalNodeY[i]*FRatioY)-Parent.VertScrollBar.Position;
         gnode^.BPNode.Left:=FOwner.ClientRect.Left+FGlobalLeftSize+Round(FinalNodeX[i]*FRatioX)-Parent.HorzScrollBar.Position;
         gnode^.BPNode.AcceptPosition:=False;
        end;
       gnode^.BPNode.LeftLinksCount:=0;
       gnode^.BPNode.RightLinksCount:=0;
       gnode^.BPNode.TopLinksCount:=0;
       gnode^.BPNode.BottomLinksCount:=0;
     end;
  end;



function   TBPPNDGraph.GetGraphNodeRec(index:DWORD):PPNDGraphNode;
 Var tmpN:PPNDGraphNode;
     i:DWORD;
  begin
   Result:=nil;
   if FGraphNodes=nil then Exit;
   if (index>=FGNodesCount) then Exit;
   tmpN:=FGraphNodes;
   for i:=0 to index do
    begin
      Result:=tmpN;
      tmpN:=tmpN^.Next;
    end;
  end;


procedure TBPPNDGraph.InitGNodes;
Var tmpN:PPNDGraphNode;
 begin
   if (FGNodesCount=0) then Exit;
   tmpN:=FGraphNodes;
   while (tmpN<>nil) do
    begin
      tmpN^.BPNode.RightRegion:=0;
      tmpN^.BPNode.LeftRegion:=0;
      tmpN^.BPNode.TopRegion:=0;
      tmpN^.BPNode.BottomRegion:=0;
      tmpN^.BPNode.OutputCount:=0;
      tmpN^.FinalX:=0;
      tmpN^.FinalY:=0;
      tmpN^.LevelID:=0;
      tmpN^.Finalized:=False;
      tmpN:=tmpN^.next;
    end;
 end;

procedure TBPPNDGraph.InitGLinks;
Var tmpL:PPNDGraphLink;
 begin
   if (FGLinksCount=0) then Exit;
   tmpL:=FGraphLinks;
   while (tmpL<>nil) do
    begin
      tmpL^.LinkType:=unknown_link;
      tmpL^.LinkSubType:=unknown_sublink;
      tmpL:=tmpL^.next;
    end;
 end;


 function   TBPPNDGraph.GetGraphNode(index:DWORD):TBPLSAGraphNode; { Checked }
 Var tmpN:PPNDGraphNode;
     i:DWORD;
  begin
   Result:=nil;
   if FGraphNodes=nil then Exit;
   if (index>=FGNodesCount) then Exit;
   tmpN:=FGraphNodes;
   for i:=0 to index do
    begin
      Result:=tmpN^.BPNode;
      tmpN:=tmpN^.Next;
    end;
  end;

 function   TBPPNDGraph.GetGraphNumberedNode(NodeNumber:DWORD):PPNDGraphNode; { Checked }
 Var tmpN:PPNDGraphNode;
  begin
   Result:=nil;
   if FGraphNodes=nil then Exit;
   tmpN:=FGraphNodes;
   while ((tmpN<>nil) and (tmpN^.BPNode.NodeNumber<>NodeNumber)) do
    begin
      tmpN:=tmpN^.Next;
    end;
   if (tmpN<>nil) then Result:=tmpN;
  end;

function   TBPPNDGraph.GetGraphLink(index:DWORD):PPNDGraphLink; { Checked }
 Var tmpN:PPNDGraphLink;
     i:DWORD;
  begin
   Result:=nil;
   if FGraphLinks=nil then Exit;
   if (index>=FGLinksCount) then Exit;
   tmpN:=FGraphLinks;
   for i:=0 to index do
    begin
      Result:=tmpN;
      tmpN:=tmpN^.Next;
    end;
  end;


procedure TBPPNDGraph.AnalizeStringsFonts;
Var len,i:Integer;
  node:TBPLSAGraphNode;
  nodeP:PPNDGraphNode;
  flag:Boolean;
  fs:Integer;
 begin
   if not(BPViewMainForm.EnableAnalizForm.Checked) then Exit;
   if (AnalizeGraphForm=nil) then Exit;
   if (FGNodesCount=0) then Exit;
   if (FGraphNodes=nil) then Exit;
   if FOverrideNodesFS then Exit;
   fs:=Round(FFontSize/FScaled2Ratio*100);
   with AnalizeGraphForm do
    begin
      if (not(FReplaceNodes) and (fs<BP_MINFONT_SIZE)) then
       begin
        flag:=False;
        ResultEditor.Clear;
        len:=(FMaxWordLength+1)*FMaxWordCount;
        for i:=0 to (FGNodesCount-1) do
         begin
          node:=GetGraphNode(i);
          if (length(node.Caption)>len) then
           begin
            ResultEditor.Lines.Append(': '+node.SNodeNumber+' "'+node.Caption+'"');
            flag:=True;
           end;
         end;
        if flag then
           begin
            ResultEditor.Lines.Append(' ');
            ResultEditor.Lines.Append('    '+IntToStr(len)+' ');
            ResultEditor.Lines.Append('         -');
            ResultEditor.Lines.Append('   "  "  ""');
            ResultEditor.Lines.Append(' ');
            ResultEditor.Lines.Append(':    ( )');
            ResultEditor.Lines.Append(' ');
            ResultEditor.Lines.Append('  ='+IntToStr(fs)+' pt.');
            ShowModal;
           end;
       end
      else
       if (FReplaceNodes and (fs<BP_MINFONT_SIZE)) then
        begin
          flag:=False;
          ResultEditor.Clear;
          nodeP:=FGraphNodes;
          for i:=0 to (FGNodesCount-1) do
           begin
             if length(nodeP^.BPNode.Caption)<length(nodeP^.llNode^.ssCaption) then
              begin
               ResultEditor.Lines.Append(': '+nodeP^.BPNode.SNodeNumber+' "'+nodeP^.llNode^.ssCaption+'"');
               ResultEditor.Lines.Append(': "'+nodeP^.BPNode.Caption+'"');
               ResultEditor.Lines.Append(' ');
               flag:=True;
              end;
             nodeP:=nodeP^.Next;
           end;
          if flag then
          begin
           ResultEditor.Lines.Append(':  ,        "  "  ""');
           ResultEditor.Lines.Append('         -');
           ResultEditor.Lines.Append(' ');
           ResultEditor.Lines.Append('  ='+IntToStr(fs)+' pt.');
           ShowModal;
          end;
        end;
      if (FReplaceNodes) and (fs<BP_MINFONT_SIZE) and (not(flag)) then
        begin
         if (FMaxNodesCount>6) then
          begin
          ResultEditor.Clear;
          ResultEditor.Lines.Append(':   -         ');
          ResultEditor.Lines.Append('       ');
          ResultEditor.Lines.Append(' ');
          ResultEditor.Lines.Append('  ='+IntToStr(fs)+' pt.');
          ShowModal;
          end
         else
          begin
          ResultEditor.Clear;
          ResultEditor.Lines.Append(':  ,        "  "  ""');
          ResultEditor.Lines.Append('         -');
          ResultEditor.Lines.Append(' ');
          ResultEditor.Lines.Append('  ='+IntToStr(fs)+' pt.');
          ShowModal;
         end;
        end
      else
      if (not(FReplaceNodes)) and (fs<BP_MINFONT_SIZE) and (not(flag)) then
        begin
         if (FMaxNodesCount>6) then
          begin
          ResultEditor.Clear;
          ResultEditor.Lines.Append(':   -         ');
          ResultEditor.Lines.Append('       ');
          ResultEditor.Lines.Append(' ');
          ResultEditor.Lines.Append('  ='+IntToStr(fs)+' pt.');
          ShowModal;
          end
         else
          begin
          ResultEditor.Clear;
          ResultEditor.Lines.Append(':  ,        "  "  ""');
          ResultEditor.Lines.Append('         -');
          ResultEditor.Lines.Append(' ');
          ResultEditor.Lines.Append('  ='+IntToStr(fs)+' pt.');
          ShowModal;
          end;
        end;
    end;
 end;


procedure  TBPPNDGraph.CalcMaxWidthHeight;  { Checked }
 Var nodeP:PPNDGraphNode;
     i:Integer;
  begin
   if FGNodesCount=0 then Exit;
   FMaxWidth:=0;
   FMaxHeight:=0;
   nodeP:=FGraphNodes;
    for i:=0 to (FGNodesCount-1) do
     begin
       nodeP^.BPNode.AutoHeight:=True;
       nodeP^.BPNode.AutoWidth:=True;
       nodeP^.BPNode.Repaint;
       if nodeP^.BPNode.MaxWidth>FMaxWidth then
               FMaxWidth:=nodeP^.BPNode.MaxWidth;
       if nodeP^.BPNode.MaxHeight>FMaxHeight then
               FMaxHeight:=nodeP^.BPNode.MaxHeight;
       nodeP^.BPNode.AutoHeight:=False;
       nodeP^.BPNode.AutoWidth:=False;
       nodeP^.BPNode.Repaint;
       nodeP:=nodeP^.next;
     end;
  end;


procedure   TBPPNDGraph.PresetupFrame(widthcoof,heightcoof:Double); { Checked }
  begin
   FCalcWidthHeight:=True;
   CalcMaxWidthHeight;
   FCalcWidthHeight:=False;
   FRatioWC:=widthcoof;
   FRatioHC:=heightcoof;
   InitGNodes;
   InitGLinks;
   FillGNodesAndLinksArraysEx;
   SortGLinksArray;
   if FUseNodeTypeLevels then FillCheckLevelsArray else
   FillCheckLevelsArray2;  { analize and fill levels }
   TranslateToNodesCoord; { translate to nodes coordinates }
   CalcNodesLinkType;
  end;

procedure   TBPPNDGraph.OpenLevel(wLevel:Integer); { Checked }
 Var tmpTree:PBPTree;
     Flag:Boolean;
  begin
     if (FTree=nil) then Exit;
     tmpTree:=FTree;
     Flag:=True;
     while (tmpTree<>nil) and (flag) do
      begin
       if (tmpTree^.dwLevel=wLevel) then
         begin
          FNodesCount:=tmpTree^.dwNodesCount;
          FLinksCount:=tmpTree^.dwLinksCount;
          FNodes:=tmpTree^.lpNodes;
          FLinks:=tmpTree^.lpLinks;
          FLevel:=tmpTree^.dwLevel;
          FSSLevel:=tmpTree^.ssLevel;
          Caption:=tmpTree^.ssCaption;
          FParentLevel:=tmpTree^.dwParent;
          FNodesFontSize:=tmpTree^.dwNodesFontSize;
          FDNodesFontSize:=tmpTree^.dwDNodesFontSize;
          FDProjectionFontSize:=tmpTree^.dwDProjectionFontSize;
          FInProcessFontSize:=tmpTree^.dwInProcessFontSize;
          FOverrideNodesFS:=tmpTree^.dbOverrideNodesFS;
          FOverrideDNodesFS:=tmpTree^.dbOverrideDNodesFS;
          FOverrideInProcessFS:=tmpTree^.dbOverrideInProcessFS;
          Flag:=False;
         end;
       tmpTree:=tmpTree^.next;
      end;
    if (Flag) then
     begin
          FNodesCount:=FTree^.dwNodesCount;
          FLinksCount:=FTree^.dwLinksCount;
          FNodes:=FTree^.lpNodes;
          FLinks:=FTree^.lpLinks;
          FLevel:=FTree^.dwLevel;
          FSSLevel:=FTree^.ssLevel;
          FParentLevel:=FTree^.dwParent;
          Caption:=FTree^.ssCaption;
          FNodesFontSize:=FTree^.dwNodesFontSize;
          FDNodesFontSize:=FTree^.dwDNodesFontSize;
          FDProjectionFontSize:=FTree^.dwDProjectionFontSize;
          FInProcessFontSize:=FTree^.dwInProcessFontSize;
          FOverrideNodesFS:=FTree^.dbOverrideNodesFS;
          FOverrideDNodesFS:=FTree^.dbOverrideDNodesFS;
          FOverrideInProcessFS:=FTree^.dbOverrideInProcessFS;
          Flag:=False;
     end;
    SetDefaultConstants;
    CreateGraphNodes(1,1);
    CreateGraphLinks(1,1);
    Scaled:=Scaled;
    if (not(FScaled)) then PresetupFrame(1,1);
{    TraceRoute;}
    if (BPViewMainForm.BPNavigator.Height>1) and
       (BPViewMainForm.PageControl1.ActivePage=BPViewMainForm.TabSheet6) then
      begin
       AnalizeStringsFonts;
       BPViewMainFOrm.BPGetBitmapTimer.Enabled:=True;
      end;
  end;


procedure TBPPNDGraph.ClearModel;
 begin
   FTree:=nil;
   FNTTree:=nil;
   FLTTree:=nil;
   FOPTree:=nil;
   FIPNode:=nil;
   FHeader.dwNodesTypesCount:=0;
   FHeader.dwLinksTypesCount:=0;
   FHeader.dwOpEntries:=0;
   FHeader.dwIPEntries:=0;
 end;


 procedure TBPPNDGraph.AssignModel(Tree:PBPTree;NTTree:PBPNodeTypes;LTTree:PBPLinkTypes;
                                OPTree:PBPOpTree;Header:TBPHeader;IPNode:PBPInProcessNode);
 begin
   FTree:=Tree;
   FNTTree:=NTTree;
   FLTTree:=LTTree;
   FOPTree:=OPTree;
   FHeader:=Header;
   FIPNode:=IPNode;
   FRootEntries:=1;
   FChangeTabVisible:=True;
   OpenLevel(-1);
   FLevDepth:=GetMaxLevelsInNewDef;
   OpenLevel(-1);
   TraceRoute;
   FOwner.Invalidate;
 end;


 procedure TBPPNDGraph.SetMaxAll(BReplaceNodes:Boolean;IMaxWordLength,IMaxWordCount:Integer);
  begin
   FReplaceNodes:=BReplaceNodes;
   FMaxWordLength:=IMaxWordLength;
   FMaxWordCount:=IMaxWordCount;
   FOwner.Visible:=False;
   OpenLevel(FLevel);
   FOwner.Invalidate;
   FOwner.Visible:=True;
  end;



function  TBPPNDGraph.OptimizeNodeFonts:Integer;
Var       i:Integer;
  OptFSize,FS:Integer;
     gNode:PPNDGraphNode;
         h:Integer;
         w:Integer;
         dc:HDC;
         ppi:Integer;
 begin
   if FNodesCount=0 then Exit;
   if (FFontSize>=FRealMaxFontSize) then Exit;
   dc:=GetDC(0);
   ppi:=GetDeviceCaps(dc,LOGPIXELSX);
   ReleaseDC(0,dc);
   gNode:=FGraphNodes;
   OptFSize:=100000;
   for i:=0 to (FGNodesCount-1) do
     begin
       h:=gnode^.BPNode.Height;
       w:=gnode^.BPNode.Width;
       fs:=Round(FFontSize/FScaled2Ratio*100);
       gnode^.BPNode.AutoHeight:=True;
       gnode^.BPNode.DefWidth:=Round(w/1.1);
       gnode^.BPNode.Font.PixelsPerInch:=ppi;
       while (gnode^.BPNode.Height<=h) do
         begin
           inc(fs);
           gnode^.BPNode.Font.Size:=fs;
           gnode^.BPNode.PaintImmediate;
           while gnode^.BPNode.Updating do;
         end;
       dec(fs);
       if (OptFSize>fs) then OptFSize:=fs;
       gnode^.BPNode.AutoHeight:=False;
       gnode:=gnode^.next;
     end;
   Result:=OptFSize;
 end;

procedure TBPPNDGraph.Optimize;
Var tmptree:PBPTree;
    fs:Integer;
   lfs:Integer;
 begin
   if (FTree=nil) then Exit;
   fs:=OptimizeNodeFOnts;
   lfs:=Round(fs*FMaxCH);
   if fs>FRealMaxFontSize then fs:=FRealMaxFontSize;
   if lfs>FRealMaxFontSize then lfs:=FRealMaxFontSize;
   FNodesFontSize:=fs;
   FOverrideNodesFS:=True;
   tmpTree:=FTree;
   while (tmpTree<>nil) and (tmpTree^.dwLevel<>FLevel) do tmpTree:=tmpTree^.next;
   if (tmpTree<>nil) then
   begin
     tmpTree^.dwNodesFontSize:=fs;
     tmpTree^.dbOverrideNodesFS:=True;
     FModified:=True;
   end;
 end;


procedure TBPPNDGraph.SetOverrideFontsAll(NFS,DNFS,DPFS,IPFS,LFS:Integer;ONFS,ODFS,OIFS,OLFS:Boolean;
                                          CNFS,CDNFS,CDPFS,CIPFS,CLFS,CONFS,CODFS,COIFS,COLFS:Boolean);
Var tmptree:PBPTree;
 begin
  if CNFS then  FNodesFontSize:=NFS;
  if CDNFS then FDNodesFontSize:=DNFS;
  if CDPFS then FDProjectionFontSize:=DPFS;
  if CIPFS then FInProcessFontSize:=IPFS;
  if CONFS then FOverrideNodesFS:=ONFS;
  if CODFS then FOverrideDNodesFS:=ODFS;
  if COIFS then FOverrideInProcessFS:=OIFS;
  if (FTree=nil) then Exit;
  tmpTree:=FTree;
  while (tmpTree<>nil) do
   begin
     if CNFS then tmpTree^.dwNodesFontSize:=NFS;
     if CONFS then tmpTree^.dbOverrideNodesFS:=ONFS;
     if CDNFS then  tmpTree^.dwDNodesFontSize:=DNFS;
     if CODFS then tmpTree^.dbOverrideDNodesFS:=ODFS;
     if CDPFS then tmpTree^.dwDProjectionFontSize:=DPFS;
     if CIPFS then tmpTree^.dwInProcessFontSize:=IPFS;
     if COIFS then tmpTree^.dbOverrideInProcessFS:=OIFS;
     FModified:=True;
     tmpTree:=tmpTree^.next;
   end;
 end;


procedure TBPPNDGraph.SetOverrideFonts(NFS,DNFS,DPFS,IPFS,LFS:Integer;ONFS,ODFS,OIFS,OLFS:Boolean);
 begin
  FNodesFontSize:=NFS;
  FDNodesFontSize:=DNFS;
  FDProjectionFontSize:=DPFS;
  FInProcessFontSize:=IPFS;
  FOverrideNodesFS:=ONFS;
  FOverrideDNodesFS:=ODFS;
  FOverrideInProcessFS:=OIFS;
 end;


procedure TBPPNDGraph.SetDiscardDrags(Value:Boolean); { Checked }
var i:Integer;
    nodePtr:PBPNode;
    linkPtr:PBPLink;
 begin
  { Disable all drags in context diagram }
   FDiscardDrags:=True;
   FOwner.Repaint;
   if FNodesCount=0 then Exit;
   nodePtr:=FNodes;
   for i:=0 to (FNodesCount-1) do
     begin
       nodePtr^.AcceptPosition[5]:=False;
       FModified:=True;
       inc(nodePtr);
     end;
   if FLinksCount=0 then Exit;
   linkPtr:=FLinks;
   for i:=0 to (FLinksCount-1) do
     begin
       LinkPtr^.FromAcceptPosition[5]:=False;
       linkPtr^.ToAcceptPosition[5]:=False;
       FModified:=True;
       inc(linkPtr);
     end;
 end;


function  TBPPNDGraph.GetNodeCaption(num,cap:String):String;
 begin
   if length(num)>0 then delete(num,1,1);
   if FShowCaptions then
     Result:=cap
   else
     Result:=num;
 end;

procedure  TBPPNDGraph.CreateGraphLinks(wc,hc:Double); { Checked }
 Var linkP:PBPLink;
     linkG:PPNDGraphLink;
     curLinkG:PPNDGraphLink;
     i:Integer;
     tmp:TBPLinkTypes;
     fngm,tngm:Boolean;
     linkVisible:Boolean;
     sfc:Boolean;
     stc:Boolean;


procedure SetShowFromToCaption(var Flags:DWORD;showFrom,showTo:Boolean);
 begin
   if not(showFrom) then
     Flags:=Flags and BP_DONTSHOW_FROMCAPTION;
   if not(showTo) then
     Flags:=Flags and BP_DONTSHOW_TOCAPTION;
 end;

  begin
   if (FGraphLinks<>nil) then ClearGraphLinks;
   if (FLinks=nil) then Exit;
   linkP:=FLinks;
   FGLinksCount:=0;
   curLinkG:=nil;
   for i:=0 to (FLinksCount-1) do
    begin
      tmp:=GetLTFromIndex(linkP^.dwLinkIndex);
      fngm:=((linkp^.dwFromNodeNumber and BPGlobalMask)<>0);
      tngm:=((linkp^.dwToNodeNumber and BPGlobalMask)<>0);
      linkVisible:=((not(fngm or tngm)));
      linkVisible:=linkVisible and tmp.dbShowLinkType;
      if linkVisible then
      begin
      if (curLinkG=nil) then
          begin
            curLinkG:=PPNDGraphLink(AllocMem(sizeof(TPNDGraphLink)));
            curLinkG^.llLink:=linkP;
            stc:=True;
            sfc:=True;
            curLinkG^.FromNodeNumber:=linkP^.dwFromNodeNumber;
            curLinkG^.ToNodeNumber:=linkP^.dwToNodeNumber;
            curLinkG^.dwFlags:=linkP^.dwFlags;
            SetShowFromToCaption(curLinkG^.dwFlags,sfc,stc);
            curLinkG^.StartPoint.x:=0;
            curLinkG^.StartPoint.y:=0;
            curLinkG^.EndPoint.x:=0;
            curLinkG^.EndPoint.y:=0;
            curLinkG^.LinkFromCount:=0;
            curLinkG^.LinkToCount:=0;
            curLinkG^.MinimalXFrom:=0;
            curLinkG^.MinimalXTo:=0;
            curLinkG^.MinimalYFrom:=0;
            curLinkG^.MinimalYTo:=0;
            FillChar(curLinkG^.LineArrayX,sizeof(curLinkG^.LineArrayX),0);
            FillChar(curLinkG^.LineArrayY,sizeof(curLinkG^.LineArrayY),0);
            curLinkG^.LinePointCount:=0;
            curLinkG^.Color:=tmp.dwColor;
            curLinkG^.PenStyle:=tmp.dwPenStyle;
            curLinkG^.Visible:=linkVisible;
            curLinkG^.next:=nil;
            FGraphLinks:=curLinkG;
            Inc(FGLinksCount);
          end
       else
          begin
            linkG:=PPNDGraphLink(AllocMem(sizeof(TPNDGraphLink)));
            linkG^.llLink:=linkP;
            stc:=True;
            sfc:=True;
            linkG^.FromNodeNumber:=linkP^.dwFromNodeNumber;
            linkG^.ToNodeNumber:=linkP^.dwToNodeNumber;
            LinkG^.dwFlags:=linkP^.dwFlags;
            SetShowFromToCaption(LinkG^.dwFlags,sfc,stc);
            linkG^.StartPoint.x:=0;
            linkG^.StartPoint.y:=0;
            linkG^.EndPoint.x:=0;
            linkG^.EndPoint.y:=0;
            linkG^.LinkFromCount:=0;
            linkG^.LinkToCount:=0;
            linkG^.MinimalXFrom:=0;
            linkG^.MinimalXTo:=0;
            linkG^.MinimalYFrom:=0;
            linkG^.MinimalYTo:=0;
            FillChar(linkG^.LineArrayX,sizeof(linkG^.LineArrayX),0);
            FillChar(linkG^.LineArrayY,sizeof(linkG^.LineArrayY),0);
            linkG^.LinePointCount:=0;
            LinkG^.Color:=tmp.dwColor;
            LinkG^.PenStyle:=tmp.dwPenStyle;
            LinkG^.Visible:=linkVisible;
            linkG^.next:=nil;
            curLinkG^.next:=linkG;
            curLinkG:=linkG;
            Inc(FGLinksCount);
          end;
      end; { linkVisible }
      Inc(linkP);
    end; { for }
  end;


procedure  TBPPNDGraph.CreateGraphNodes(wc,hc:Double); { Checked }
 Var nodeP:PBPNode;
     nodeG:PPNDGraphNode;
     curNodeG:PPNDGraphNode;
     i,j:Integer;
     tmp:TBPNodeTypes;
     s:String;
     nc:String;
  begin
   if (FGraphNodes<>nil) then ClearGraphNodes;
   if (FNodes=nil) then Exit;
   FGNodesCount:=0;
   nodeP:=FNodes;
   j:=-1;
   for i:=0 to (FNodesCount-1) do
    begin
      tmp:=GetNTFromIndex(nodeP^.dwNodeIndex);
      nc:=MyUtils.MyReplaceNodeCaption(nodeP^.ssCaption,FMAxWordLength,FMaxWordCount,FReplaceNodes);
      nc:=GetNodeCaption(nodeP^.ssNodeNumber,nc);
      if (j=-1) then
          begin
            j:=1;
            curNodeG:=PPNDGraphNode(AllocMem(sizeof(TPNDGraphNode)));
            curNodeG^.BPNode:=TBPLSAGraphNode.Create(Parent);
            curNodeG^.BPNode.Parent:=Parent as TWinControl;
            curNodeG^.BPNode.Caption:=nc;
            curNodeG^.BPNode.NodeNumber:=nodeP^.dwNodeNumber;
            curNodeG^.BPNode.SNodeNumber:=nodeP^.ssNodeNumber;
            curNodeG^.BPNode.AutoHeight:=False;
            curNodeG^.BPNode.AutoWidth:=False;
            if not(FScaled2) then
            begin
            s:=Format('%f',[nodeP^.fABCValue]);
            curNodeG^.BPNode.Hint:=nodeP^.ssNodeNumber+': '+nodeP^.ssCaption+' ['+s+']';
            end
            else
            begin
            if (Length(nodeP^.ssComment)>0) then
              curNodeG^.BPNode.Hint:=nodeP^.ssComment
            else
             begin
              s:=Format('%f',[nodeP^.fABCValue]);
              curNodeG^.BPNode.Hint:=nodeP^.ssNodeNumber+': '+nodeP^.ssCaption+' ['+s+']';
             end;
            end;
            { New }
            curNodeG^.BPNode.ShowHint:=True;
            curNodeG^.BPNode.Font.Color:=tmp.dwFontColor;
            curNodeG^.BPNode.Font.Charset:=FLang;
            curNodeG^.BPNode.PaintColor:=tmp.dwPaintColor;
            curNodeG^.BPNode.ShadowType:=TDSShadowType(tmp.dwShadowStyle);
            curNodeG^.BPNode.RectStyle:=TDSRectStyle(tmp.dwRectStyle);
            curNodeG^.BPNode.ShadowColor:=tmp.dwShadowColor;
            curNodeG^.BPNode.RectColor:=tmp.dwDrawColor;
            { End New }
            curNodeG^.BPNode.Font.Name:=FPrinterFontName;
            if FDoOverrideFS and FOverrideNodesFS then
             if FOwner.FPreviewOrPrint then
               curNodeG^.BPNode.Font.Size:=Round(FNodesFontSize*FOwner.FFOntCoof)
             else
               curNodeG^.BPNode.Font.Size:=Round(FNodesFontSize*FScaled2Ratio/100)
            else
            curNodeG^.BPNode.Font.Size:=FFontSize;
            curNodeG^.BPNode.Font.Style:=[fsBold];
            curNodeG^.BPNode.LeftLinksCount:=0;
            curNodeG^.BPNode.RightLinksCount:=0;
            curNodeG^.BPNode.ShadowDepth:=FNodeShadowDepth;
            curNodeG^.BPNode.SetFontDPI(FFontDPI);
            curNodeG^.BPNode.LineWidth:=FNodeLineWidth;
            curNodeG^.BPNode.DefWidth:=FNodeDefWidth;
            curNodeG^.BPNode.DefHeight:=FNodeDefHeight;
            curNodeG^.BPNode.HSpacing:=FNodeHSpacing;
            curNodeG^.BPNode.VSpacing:=FNodeVSpacing;
            if nodeP^.AcceptPosition[5] then
            begin
            curNodeG^.BPNode.Top:=Round(nodeP^.Top[5]*hc);
            curNodeG^.BPNode.Left:=Round(nodeP^.Left[5]*wc);
            end;
            curNodeG^.BPNode.AcceptPosition:=nodeP^.AcceptPosition[5];
            curNodeG^.BPNode.DragMode:=dmManual;
            curNodeG^.BPNode.OnMouseDown:=MyNodeMouseDown;
            curNodeG^.BPNode.PopupMenu:=BPViewMainForm.LSANodesPopupMenu;
            curNodeG^.BPNode.Tag:=i;
            curNodeG^.next:=nil;
            curNodeG^.llNode:=nodeP;
            FGraphNodes:=curNodeG;
            inc(FGNodesCount);
          end
       else
          begin
            nodeG:=PPNDGraphNode(AllocMem(sizeof(TPNDGraphNode)));
            nodeG^.BPNode:=TBPLSAGraphNode.Create(Parent);
            nodeG^.BPNode.Parent:=Parent as TWinControl;
            nodeG^.BPNode.Caption:=nc;
            nodeG^.BPNode.SNodeNumber:=nodeP^.ssNodeNumber;
            nodeG^.BPNode.NodeNumber:=nodeP^.dwNodeNumber;
            nodeG^.BPNode.AutoHeight:=False;
            nodeG^.BPNode.AutoWidth:=False;
            if not(FScaled2) then
            begin
            s:=Format('%f',[nodeP^.fABCValue]);
            nodeG^.BPNode.Hint:=nodeP^.ssNodeNumber+': '+nodeP^.ssCaption+' ['+s+']';
            end
            else
            begin
             if (Length(nodeP^.ssComment)>0) then
               nodeG^.BPNode.Hint:=nodeP^.ssComment
             else
              begin
               s:=Format('%f',[nodeP^.fABCValue]);
               nodeG^.BPNode.Hint:=nodeP^.ssNodeNumber+': '+nodeP^.ssCaption+' ['+s+']';
              end;
            end;
            { New }
            nodeG^.BPNode.ShowHint:=True;
            nodeG^.BPNode.Font.Color:=tmp.dwFontColor;
            NodeG^.BPNode.Font.Charset:=FLang;
            nodeG^.BPNode.PaintColor:=tmp.dwPaintColor;
            nodeG^.BPNode.ShadowType:=TDSShadowType(tmp.dwShadowStyle);
            nodeG^.BPNode.RectStyle:=TDSRectStyle(tmp.dwRectStyle);
            nodeG^.BPNode.ShadowColor:=tmp.dwShadowColor;
            nodeG^.BPNode.RectColor:=tmp.dwDrawColor;
            { End New }
            nodeG^.BPNode.Font.Name:=FPrinterFontName;
            if FDoOverrideFS and FOverrideNodesFS then
             if FOwner.FPreviewOrPrint then
               NodeG^.BPNode.Font.Size:=Round(FNodesFontSize*FOwner.FFOntCoof)
             else
               NodeG^.BPNode.Font.Size:=Round(FNodesFontSize*FScaled2Ratio/100)
            else
            nodeG^.BPNode.Font.Size:=FFontSize;
            nodeG^.BPNode.Font.Style:=[fsBold];
            nodeG^.BPNode.LeftLinksCount:=0;
            nodeG^.BPNode.RightLinksCount:=0;
            nodeG^.BPNode.ShadowDepth:=FNodeShadowDepth;
            nodeG^.BPNode.SetFontDPI(FFontDPI);
            nodeG^.BPNode.LineWidth:=FNodeLineWidth;
            nodeG^.BPNode.DefWidth:=FNodeDefWidth;
            nodeG^.BPNode.DefHeight:=FNodeDefHeight;
            nodeG^.BPNode.HSpacing:=FNodeHSpacing;
            nodeG^.BPNode.VSpacing:=FNodeVSpacing;
            if nodeP^.AcceptPosition[5] then
            begin
            nodeG^.BPNode.Top:=Round(nodeP^.Top[5]*hc);
            nodeG^.BPNode.Left:=Round(nodeP^.Left[5]*wc);
            end;
            nodeG^.BPNode.AcceptPosition:=nodeP^.AcceptPosition[5];
            nodeG^.BPNode.DragMode:=dmManual;
            nodeG^.BPNode.OnMouseDown:=MyNodeMouseDown;
            nodeG^.BPNode.PopupMenu:=BPViewMainForm.LSANodesPopupMenu;
            nodeG^.BPNode.Tag:=i;
            nodeG^.llNode:=nodeP;
            nodeG^.next:=nil;
            curNodeG^.next:=nodeG;
            curNodeG:=nodeG;
            inc(FGNodesCount);
            FLastNodeNumber:=nodeP^.dwNodeNumber;
          end;
     if (FGNodesCount=1) then FFirstNodeNumber:=nodeP^.dwNodeNumber;
     Inc(nodeP);
    end; { for }
  end;


procedure  TBPPNDGraph.ClearGraphNodes; { Checked }
 Var tmpN,tmpN1:PPNDGraphNode;
  begin
   if FGraphNodes=nil then Exit;
   tmpN:=FGraphNodes;
   tmpN1:=nil;
   while tmpN<>nil do
    begin
      if tmpN1<>nil then
        begin
{         tmpN1^.BPNode.OnDblClick:=nil; }
         tmpN1^.BPNode.OnMouseDown:=nil;
         tmpN1^.BPNode.PopupMenu:=nil;
         tmpN1^.BPNode.Destroy;
         FreeMem(tmpN1);
        end;
      tmpN1:=tmpN;
      tmpN:=tmpN.Next;
    end;
    if tmpN1<>nil then
       begin
{         tmpN1^.BPNode.OnDblClick:=nil; }
         tmpN1^.BPNode.OnMouseDown:=nil;
         tmpN1^.BPNode.PopupMenu:=nil;
         tmpN1^.BPNode.Destroy;
         FreeMem(tmpN1);
       end;
   FGraphNodes:=nil;
   FGNodesCount:=0;
   FMaxWidth:=0;
   FMaxHeight:=0;
  end;

procedure  TBPPNDGraph.ClearGraphLinks; { Checked }
  Var tmpN,tmpN1:PPNDGraphLink;
  begin
   { Clears graphics links list }
   if FGraphLinks=nil then Exit;
   tmpN:=FGraphLinks;
   tmpN1:=nil;
   while tmpN<>nil do
    begin
      if tmpN1<>nil then
        begin
         tmpN1^.llLink:=nil;
         FreeMem(tmpN1);
        end;
      tmpN1:=tmpN;
      tmpN:=tmpN.Next;
    end;
    if tmpN1<>nil then
       begin
         tmpN1^.llLink:=nil;
         FreeMem(tmpN1);
       end;
   FGraphLinks:=nil;
   FGLinksCount:=0;
  end;


constructor TBPPNDGraph.Create(AOwner: TComponent); { Checked }
  begin
    inherited Create(AOwner);
    FOwner:=AOwner as TBPPNDFrame;
    FNodes:=nil;
    FLinks:=nil;
    FNodesCount:=0;
    FLinksCount:=0;
    FGNodesCount:=0;
    FGLinksCount:=0;
    FGraphNodes:=nil;
    FGraphLinks:=nil;
    FLang:=RUSSIAN_CHARSET;
    FTree:=nil;
    FOpTree:=nil;     { CurrentWork ! }
    FLTTree:=nil;
    FNTTree:=nil;
    FIPNode:=nil;
    FLevel:=-1;
    FSSLevel:='-1';   { CurrentWork ! }
    FParentLevel:=-2; { Disabled }
    FHaspFound:=True;
    FillChar(FHeader,sizeof(FHeader),0);
    FMaxWidth:=0;
    FMaxHeight:=0;
    FRootEntries:=0;
    FGlobalLeftSize:=80;
    FGlobalRightSize:=80;
    FGlobalTopSize:=80;
    FGlobalBottomSize:=80;
    FFontDPI:=96;
    FFontSize:=8;
    FLabelFontSize:=8;
    FMinLineStep:=StartMinLineStep;
    FNodeLineWidth:=1;
    FNodeDefWidth:=100;
    FNodeDefHeight:=100;
    FNodeHSpacing:=8;
    FNodeVSpacing:=8;
    FNodeShadowDepth:=4;
    FMinArcRadius:=StartMinArcRadius;
    FMinLineEndPoint:=StartMinLineEndPoint;
    FNodeWidth:=0;
    FNodeHeight:=0;
    FCalcWidthHeight:=False;
    FDebug:=False;
    FScaled:=False;
    FScreenFontName:='Times New Roman';
    FPrinterFontName:='Times New Roman';
    FFirstNodeNumber:=0;
    FLastNodeNumber:=0;
    FDiscardDrags:=False;
    FRatioWC:=1;
    FRatioHC:=1;
    FModified:=False;
    FLinksPosRelative:=True;
    FScaled2Ratio:=100;
    FScaled2:=True;
    FReplaceNodes:=False;
    FMaxWordLength:=8;
    FMaxWordCount:=5;
    FUseNodeTypeLevels:=True;
    FMaxFontSize:=DefMaxLabelFontSize;
    FRealMaxFontSize:=DefMaxLabelFontSize;
    FShowCaptions:=True;
    FMaxLevels:=0;
    FLevDepth:=0; { planka of depth analiz }
    Scaled:=True;
  end;

destructor  TBPPNDGraph.Destroy;  { Checked }
  begin
    if (FGraphNodes<>nil) then ClearGraphNodes;
    if (FGraphLinks<>nil) then ClearGraphLinks;
    if (FTree<>nil) then FTree:=nil;
    if (FNTTree<>nil) then FNTTree:=nil;
    if (FLTTree<>nil) then FLTTree:=nil;
    if (FOPTree<>nil) then FOPTree:=nil; { CurrentWork ! }
    if (FIPNode<>nil) then FIPNode:=nil;
    inherited Destroy;
  end;





procedure TBPPNDGraph.UpdateNodesModel(X,Y:Integer;node:TBPLSAGraphNode);
Var xc,yc:Integer;
    nodePtr:PPNDGraphNode;
    i:Integer;
 begin
   if FGNodesCount=0 then Exit;
   if node=nil then Exit;
   if FRatioWC=0 then Exit;
   if FRatioHC=0 then Exit;
  { Recalc X and Y coord to not scaled model }
   if FScaled or FPrinting then
    begin
     xc:=Round(X/FRatioWC);
     yc:=Round(Y/FRatioHC);
    end
   else
    begin
     xc:=x;
     yc:=y;
    end;
  { Update nodes model }
   nodePtr:=FGraphNodes;
   for i:=0 to (FGNodesCount-1) do
     begin
       if  (node<>nil) and
           (nodePtr^.BPNode=node) then
         begin
           nodePtr^.llNode^.Left[5]:=xc;
           nodePtr^.llNode^.Top[5]:=yc;
           nodePtr^.llNode^.AcceptPosition[5]:=True;
           FModified:=True;
         end;
       nodePtr:=nodePtr^.next;
     end;
 end;


procedure TBPPNDGraph.MyNodeMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer); { Checked }
 begin
  if (Sender is TBPLSAGraphNode) and (Button=mbLeft) then
   (Sender as TBPLSAGraphNode).BeginDrag(False);
 end;


function  TBPPNDGraph.GetNodeLevelEx(index:DWORD):Integer;
 Var flag:Boolean;
     i,ic:Integer;
     tmpPtr:PBPNodeTypes;
  begin
     flag:=True;
     tmpPtr:=FNTTree;
     ic:=FHeader.dwNodesTypesCount;
     if (ic>0) then
       begin
         i:=0;
         while ((i<ic) and (flag)) do
           begin
              if tmpPtr^.dwNodeIndex=index then
                 begin
                   flag:=False;
                   Result:=i;
                   Exit;
                 end
               else
                begin
                 inc(tmpPtr);
                 inc(i);
                end;
           end;
       end;
      Result:=0;
  end;

function  TBPPNDGraph.GetNTFromIndex(index:DWORD):TBPNodeTypes; { Checked }
 Var flag:Boolean;
     i,ic:Integer;
     tmpPtr:PBPNodeTypes;
  begin
     flag:=True;
     tmpPtr:=FNTTree;
     ic:=FHeader.dwNodesTypesCount;
     if (ic>0) then
       begin
         i:=0;
         while ((i<ic) and (flag)) do
           begin
              if tmpPtr^.dwNodeIndex=index then
                 begin
                   flag:=False;
                   Result:=tmpPtr^;
                   Exit;
                 end
               else
                begin
                 inc(tmpPtr);
                 inc(i);
                end;
           end;
       end;
      Result.dwNodeIndex:=index;
      Result.ssCaption:='Default';
      Result.dwFontColor:=clBlack;
      Result.dwPaintColor:=clWhite;
      Result.dwDrawColor:=clBlack;
      Result.dwShadowColor:=clBlack;
      Result.dwShadowStyle:=6;
      Result.dwRectStyle:=2;
  end;

function  TBPPNDGraph.GetLTFromIndex(index:DWORD):TBPLinkTypes; { Checked }
 Var flag:Boolean;
     i,ic:Integer;
     tmpPtr:PBPLinkTypes;
  begin
     flag:=True;
     tmpPtr:=FLTTree;
     ic:=FHeader.dwLinksTypesCount;
     if (ic>0) then
       begin
         i:=0;
         while ((i<ic) and (flag)) do
           begin
              if tmpPtr^.dwLinkIndex=index then
                 begin
                   flag:=False;
                   Result:=tmpPtr^;
                   Exit;
                 end
               else
                begin
                 inc(tmpPtr);
                 inc(i);
                end;
           end;
       end;
      Result.dwLinkIndex:=index;
      Result.ssCaption:='Default';
      Result.dwPenStyle:=psSolid;
      Result.dwColor:=clBlack;
  end;


procedure TBPPNDGraph.SetScaled(Value:Boolean);  { Checked }
Var r1,r2,ratio,fontRatio:Double;
    nw,nh,mw,mh:Integer;
    rw,rh:Double;
    dc:HDC;
    ws2,hs2:Extended;
    pgAlg:TBPPgAlg;
    {New}
    wca3,hca3:Extended;
    aSize:Integer;
    tmpi:TQRPaperSize;
 begin
   FScaled:=Value;
   if FTree=nil then Exit;
   if FScaled then
    begin
    if FOwner.VertScrollBar.Visible then FOwner.VertScrollBar.Position:=0;
    if FOwner.HorzScrollBar.Visible then FOwner.HorzScrollBar.Position:=0;
    Repaint;
    SetDefaultConstants;
    Printing:=False;
    SetDefaultConstants;
    CreateGraphNodes(1,1); { read x,y,acceptposition }
    CreateGraphLinks(1,1); { read x,y,acceptposition }
    PresetupFrame(1,1); { Scale x,y to widthcoof,heightcoof }
    TraceRoute;
    if FMaxNodesCount>FOwner.FNodesValue[0] then
     begin
       if FMaxNodesCount>FOwner.FNodesValue[1] then
         pgAlg:=pg_Max
       else
         pgAlg:=pg_Middle;
     end
    else pgAlg:=pg_Min;
    FOwner.Invalidate;
   end;
   if FScaled2 then
    begin { if FScaled2 }
      wca3:=1.0;
      hca3:=1.0;
      if MainUnit.HasPrnDevice then
      begin
       aSize:=Printer.PaperSize;
       for tmpi:= Default to Custom do
        begin
         if aSize=cQRPaperTranslate[tmpI] then
           begin
            hca3:=cQRPaperSizeMetrics[tmpI,0]/cQRPaperSizeMetrics[A3,0];
            wca3:=cQRPaperSizeMetrics[tmpI,1]/cQRPaperSizeMetrics[A3,1];
           end;
        end;
       end;
      dc:=GetDC(0);
      if CurPrinterOrientation=poPortrait then
       begin
        ws2:=GetDeviceCaps(dc,LOGPIXELSX)*A3Width*hca3*FScaled2Ratio/100.0;
        hs2:=GetDeviceCaps(dc,LOGPIXELSY)*A3Height*wca3*FScaled2Ratio/100.0;
       end
      else
       begin
        ws2:=GetDeviceCaps(dc,LOGPIXELSX)*A3Height*hca3*FScaled2Ratio/100.0;
        hs2:=GetDeviceCaps(dc,LOGPIXELSY)*A3Width*wca3*FScaled2Ratio/100.0;
       end;
      UpdateMaxFontSize(1);
      ReleaseDC(0,dc);
      if (FOwner.HorzScrollBar.Range>0) and
         (FOwner.HorzScrollBar.Visible) then
       begin
        FOwner.HorzScrollBar.Position:=0;
        r1:=ws2/(FOwner.HorzScrollBar.Range);
       end
      else r1:=ws2/FOwner.ClientWidth;
      if (FOwner.VertScrollBar.Visible) and
         (FOwner.VertScrollBar.Range>0) then
       begin
         FOwner.VertScrollBar.Position:=0;
         r2:=hs2/(FOwner.VertScrollBar.Range);
       end
      else r2:=hs2/FOwner.ClientHeight;
    end { if FScaled2 }
   else
   begin { if not FScaled2 }
   if FOwner.HorzScrollBar.Visible then
    begin
     FOwner.HorzScrollBar.Position:=0;
     r1:=FOwner.ClientWidth/(FOwner.HorzScrollBar.Range+1);
    end
   else r1:=1;
   if FOwner.VertScrollBar.Visible then
    begin
     FOwner.VertScrollBar.Position:=0;
     r2:=FOwner.ClientHeight/(FOwner.VertScrollBar.Range+1);
    end
   else r2:=1;
   UpdateMaxFontSize(r2);
   end; { if not FScaled2 }
   if FScaled then
    begin
     case pgAlg of
      pg_Min:     ratio:=FOwner.GetCoof(r1,r2,FOwner.FFormatAlg[0]);
      pg_Middle:  ratio:=FOwner.GetCoof(r1,r2,FOwner.FFormatAlg[1]);
      pg_Max:     ratio:=FOwner.GetCoof(r1,r2,FOwner.FFormatAlg[2]);
     end;
     SetDefaultConstants;
     SetScaledConstants(r1,r2,ratio,ratio);
     if FScaled2 then
      begin
       DefWidth:=Round(ws2);
       DefHeight:=Round(hs2);
      end
     else
      begin
       DefWidth:=FOwner.ClientWidth;
       DefHeight:=FOwner.ClientHeight;
      end;
     Printing:=True;
     CreateGraphNodes(r1,r2); { read x,y,acceptposition }
     CreateGraphLinks(r1,r2); { read x,y,acceptposition }
     PresetupFrame(r1,r2); { Scale x,y to widthcoof,heightcoof }
     TraceRoute;
     FOwner.Invalidate;
     while FOwner.FPainting do;
     nw:=NodeWidth;
     nh:=NodeHeight;
     mw:=MaxWidth;
     mh:=MaxHeight;
     rw:=ratio*nw/(mw+1);
     rh:=ratio*nh/(mh+1);
     case pgAlg of
       pg_Min:    fontRatio:=FOwner.GetCoof(rw,rh,FOwner.FFormatAlg[0]);
       pg_Middle: fontRatio:=FOwner.GetCoof(rw,rh,FOwner.FFormatAlg[1]);
       pg_Max:    fontRatio:=FOwner.GetCoof(rw,rh,FOwner.FFormatAlg[2]);
     end;
{     if fontRatio>ratio then fontRatio:=ratio;}
     FOwner.Canvas.FillRect(FOwner.Canvas.ClipRect);
     if FScaled2 then
      begin
       DefWidth:=Round(ws2);
       DefHeight:=Round(hs2);
      end
     else
      begin
       DefWidth:=FOwner.ClientWidth;
       DefHeight:=FOwner.ClientHeight;
      end;
     SetDefaultConstants;
     SetScaledConstants(r1,r2,ratio,fontRatio);
     CreateGraphNodes(r1,r2); { read x,y,acceptposition }
     CreateGraphLinks(r1,r2); { read x,y,acceptposition }
     PresetupFrame(r1,r2);   { Scale x,y to widthcoof,heightcoof }
     TraceRoute;
     FOwner.Invalidate;
    end
   else
    begin
     UpdateMaxFontSize(1);
     SetDefaultConstants;
     Printing:=False;
     SetDefaultConstants;
     CreateGraphNodes(1,1); { read x,y,acceptposition }
     CreateGraphLinks(1,1); { read x,y,acceptposition }
     PresetupFrame(1,1); { Scale x,y to widthcoof,heightcoof }
     TraceRoute;
     FOwner.Invalidate;
    end;
 end;

 procedure  TBPPNDGraph.SetDefaultConstants; { Checked }
 Var dc:HDC;
  begin
   FDoOverrideFS:=False;
   dc:=GetDC(FOwner.Handle);
   FFontDPI:=96;{GetDeviceCaps(dc,LOGPIXELSX);}
   ReleaseDC(FOwner.Handle,dc);
   FFontSize:=8;
   FLabelFontSize:=8;
   FMinLineStep:=StartMinLineStep;
   FNodeLineWidth:=1;
   FNodeDefWidth:=100;
   FNodeDefHeight:=100;
   FNodeHSpacing:=1;
   FNodeVSpacing:=1;
   FGlobalLeftSize:=80;
   FGlobalRightSize:=80;
   FGlobalTopSize:=80;
   FGlobalBottomSize:=80;
   FMinArcRadius:=StartMinArcRadius;
   FNodeShadowDepth:=4;
   FMinLineEndPoint:=StartMinLineEndPoint;
  end;

 procedure  TBPPNDGraph.SetScaledConstants(ratiox,ratioy,ratio:Double;fontSizeRatio:Double); { Checked }


  begin
   FDoOverrideFS:=True;
   FFontDPI:=Round(FFontDPI*ratio);
   FFontSize:=Round(FFontSize*fontSizeRatio);
   if FFontSize=0 then FFontSize:=1;
   if FFontSize>FRealMaxFontSize then FFontSize:=FRealMaxFontSize;
{   FMinLineStep:=(FNodeWidth div 4) div StartMaxLines;}
   FMinLineStep:=FNodeWidth div 8;
   FNodeLineWidth:=Round(FNodeLineWidth*ratio);
   if FNodeLineWidth=0 then FNodeLineWidth:=1;
   FNodeDefWidth:=Round(FNodeDefWidth*ratiox);
   FNodeDefHeight:=Round(FNodeDefHeight*ratioy);
   FNodeHSpacing:=Round(FNodeHSpacing*ratiox);
   FNodeVSpacing:=Round(FNodeVSpacing*ratioy);
   FGlobalLeftSize:=Round(FGlobalLeftSize*ratiox);
   FGlobalRightSize:=Round(FGlobalRightSize*ratiox);
   FGlobalTopSize:=Round(FGlobalTopSize*ratioy);
   FGlobalBottomSize:=Round(FGlobalBottomSize*ratioy);
   FMinArcRadius:=Round(FMinArcRadius*ratio);
   FNodeShadowDepth:=Round(FNodeShadowDepth*ratio);
   if FNodeShadowDepth=0 then FNodeShadowDepth:=1;
   FMinLineEndPoint:=Round(FMinLineEndPoint*ratio);
  end;


procedure  TBPPNDGraph.SetFontSize(Value:Integer);  { Checked }
  begin
   if Value=FFontSize then Exit;
   FFontSize:=Value;
   CreateGraphNodes(FRatioWC,FRatioHC);
   CreateGraphLinks(FRatioWC,FRatioHC);
  end;

function  TBPPNDGraph.GetMaxLevelsInNewDef:Integer;
Var node:PPNDGraphNode;
       s:String;
    i,cpos,slen,nml:Integer;
 begin
   FMaxLevels:=0;
   if FGraphNodes=nil then Exit;
   node:=FGraphNodes;
   while (node<>nil) do
    begin
      nml:=0;
      s:=Node^.BPNode.SNodeNumber;
      delete(s,1,1);
      cpos:=pos('.',s);
      slen:=Length(s);
      while (slen>0) and (cpos<>0) do
        begin
          inc(nml);
          delete(s,1,cpos);
          cpos:=pos('.',s);
          slen:=Length(s);
        end;
      inc(nml);
      if nml>FMaxLevels then FMaxLevels:=nml;
      node:=node^.next;
    end;
   Result:=FMaxLevels;
 end;

procedure TBPPNDGraph.SetLevDepth(Value:Integer);
 Var oldPosX,oldPosY:Integer;
 begin
    FLevDepth:=Value;
    FOwner.Visible:=False;
   if FOwner.HorzScrollBar.Visible and
     (FOwner.HorzScrollBar.Range>0) then
       oldPosX:=FOwner.HorzScrollBar.Position
   else
       oldPosX:=0;
   if FOwner.VertScrollBar.Visible and
     (FOwner.VertScrollBar.Range>0) then
       oldPosY:=FOwner.VertScrollBar.Position
   else
       oldPosY:=0;
   OpenLevel(FLevel);
   FOwner.Invalidate;
   if FOwner.HorzScrollBar.Visible and
     (FOwner.HorzScrollBar.Range>0) then
       FOwner.HorzScrollBar.Position:=oldPosX;
   if FOwner.VertScrollBar.Visible and
     (FOwner.VertScrollBar.Range>0) then
       FOwner.VertScrollBar.Position:=oldPosY;
   FOwner.Visible:=True;
 end;


procedure TBPPNDGraph.SetUseNodeTypeLevels(Value:Boolean);
 Var oldPosX,oldPosY:Integer;
 begin
   FUseNodeTypeLevels:=Value;
   FOwner.Visible:=False;
   if FOwner.HorzScrollBar.Visible and
     (FOwner.HorzScrollBar.Range>0) then
       oldPosX:=FOwner.HorzScrollBar.Position
   else
       oldPosX:=0;
   if FOwner.VertScrollBar.Visible and
     (FOwner.VertScrollBar.Range>0) then
       oldPosY:=FOwner.VertScrollBar.Position
   else
       oldPosY:=0;
   OpenLevel(FLevel);
   FOwner.Invalidate;
   if FOwner.HorzScrollBar.Visible and
     (FOwner.HorzScrollBar.Range>0) then
       FOwner.HorzScrollBar.Position:=oldPosX;
   if FOwner.VertScrollBar.Visible and
     (FOwner.VertScrollBar.Range>0) then
       FOwner.VertScrollBar.Position:=oldPosY;
   FOwner.Visible:=True;
 end;

procedure TBPPNDGraph.SetShowCaptions(Value:Boolean);
 Var oldPosX,oldPosY:Integer;
 begin
   FShowCaptions:=Value;
   FOwner.Visible:=False;
   if FOwner.HorzScrollBar.Visible and
     (FOwner.HorzScrollBar.Range>0) then
       oldPosX:=FOwner.HorzScrollBar.Position
   else
       oldPosX:=0;
   if FOwner.VertScrollBar.Visible and
     (FOwner.VertScrollBar.Range>0) then
       oldPosY:=FOwner.VertScrollBar.Position
   else
       oldPosY:=0;
   OpenLevel(FLevel);
   FOwner.Invalidate;
   if FOwner.HorzScrollBar.Visible and
     (FOwner.HorzScrollBar.Range>0) then
       FOwner.HorzScrollBar.Position:=oldPosX;
   if FOwner.VertScrollBar.Visible and
     (FOwner.VertScrollBar.Range>0) then
       FOwner.VertScrollBar.Position:=oldPosY;
   FOwner.Visible:=True;
 end;

procedure TBPPNDGraph.SetMaxFontSize(Value:Integer);
 Var oldPosX,oldPosY:Integer;
 begin
   FMaxFontSize:=Value;
   FOwner.Visible:=False;
   if FOwner.HorzScrollBar.Visible and
     (FOwner.HorzScrollBar.Range>0) then
       oldPosX:=FOwner.HorzScrollBar.Position
   else
       oldPosX:=0;
   if FOwner.VertScrollBar.Visible and
     (FOwner.VertScrollBar.Range>0) then
       oldPosY:=FOwner.VertScrollBar.Position
   else
       oldPosY:=0;
   OpenLevel(FLevel);
   FOwner.Invalidate;
   if FOwner.HorzScrollBar.Visible and
     (FOwner.HorzScrollBar.Range>0) then
       FOwner.HorzScrollBar.Position:=oldPosX;
   if FOwner.VertScrollBar.Visible and
     (FOwner.VertScrollBar.Range>0) then
       FOwner.VertScrollBar.Position:=oldPosY;
   FOwner.Visible:=True;
 end;


procedure TBPPNDGraph.SetDefWidth(Value:Integer);  { Checked }
 begin
  FDefWidth:=Value;
 end;

procedure TBPPNDGraph.SetDefHeight(Value:Integer);  { Checked }
 begin
  FDefHeight:=Value;
 end;

procedure TBPPNDGraph.SetScaled2(Value:Boolean);
  begin
   {}
    FScaled2:=Value;
  end;

procedure TBPPNDGraph.SetScaled2Ratio(Value:Extended);
 Var posx,posy:Double;
  begin
   {}
{!} posx:=FScaled2Ratio;
{!} posy:=FScaled2Ratio;
{!} if (FOwner.HorzScrollBar.Range>0) and
       (FOwner.HorzScrollBar.Visible) then
     posx:=Value/(posx+0.01)*FOwner.HorzScrollBar.Position
    else
     posx:=0;
{!} if (FOwner.VertScrollBar.Range>0) and
       (FOwner.VertScrollBar.Visible) then
     posy:=Value/(posy+0.01)*FOwner.VertScrollBar.Position
    else
     posy:=0;
    FScaled2Ratio:=Value;
    FOwner.Visible:=False;
    Scaled:=Scaled;
    FOwner.Invalidate;
{!} if (FOwner.HorzScrollBar.Range>0) then
        FOwner.HorzScrollBar.Position:=Round(posx);
{!} if (FOwner.VertScrollBar.Range>0) then
        FOwner.VertScrollBar.Position:=Round(posy);
    FOwner.Visible:=True;
  end;


procedure TBPPNDGraph.UpdateMaxFontSize(Coof:Extended);
Var hca3:Extended;
    aSize:Integer;
    tmpi:TQRPaperSize;
 begin
  { Update & calc real max font size }
  hca3:=1.0;
  if MainUnit.HasPrnDevice then
   begin
    aSize:=Printer.PaperSize;
    for tmpi:= Default to Custom do
      begin
       if aSize=cQRPaperTranslate[tmpI] then
        begin
         hca3:=cQRPaperSizeMetrics[tmpI,0]/cQRPaperSizeMetrics[A3,0];
        end;
      end;
   end;
  if FScaled then
    begin
      if FScaled2 then
       begin { if FScaled2 }
        FRealMaxFontSize:=Round(FMaxFontSize*hca3*FScaled2Ratio/100.0);
       end
      else
       begin
        FRealMaxFontSize:=Round(FMaxFontSize/coof*hca3);
       end;
    end
   else
    begin
      FRealMaxFontSize:=Round(FMaxFontSize*FOwner.FFontCoof*hca3);
    end;
 end;




procedure  TBPPNDGraph.TraceLinksToNodeCounters; { Checked }
 Var linkP:PPNDGraphLink;
     gnode:TBPLSAGraphNode;
     gdnode,gnode1:PPNDGraphNode;
       i,j:Integer;
    lr:TBPPNDRegion;
    lrx,rrx:Integer;
    trx,brx:Integer;
    lre,rre:Integer;
    tre,bre:Integer;
       llis:Integer;
       rlis:Integer;
       tlis:Integer;
       blis:Integer;
       posx,posy:Integer;
       centerx:Integer;
  begin
   { Calc links count for every node }
   if (FGLinksCount=0) then Exit;
   if (FGNodesCount=0) then Exit;
   { New code - filling Left,Right,Bottom regions arrays }
   if FOwner.HorzScrollBar.Visible then posx:=FOwner.HorzScrollBar.ScrollPos else posx:=0;
   if FOwner.VertScrollBar.Visible then posy:=FOwner.VertScrollBar.ScrollPos else posy:=0;
   centerx:=FDefWidth div 2;
   FillLeftArray;
   FillRightArray;
   FillTopArray;
   FillBottomArray;
   for i:=0 to (FGNodesCount-1) do
    begin
     gnode:=GetGraphNode(i);
     if (gnode<>nil) then
      begin
       for j:=0 to (FGLinksCount-1) do
        begin
         linkP:=GetGraphLink(j);
          if linkP<>nil then
            begin
              if linkP^.Visible then
              begin
              if (linkP^.FromNodeNumber=gnode.NodeNumber) and
                 ((linkP^.dwFlags and BP_FROMMASK)=BP_FROMNODE_RIGHT) then
                begin
                 { if not multiple link from or first multiple link }
                 lr:=GetNodeRegion(linkP^.FromNodeNumber);
                 lrx:=Round(lr.LeftRegion*FRatioX)+FOwner.ClientRect.Left+FGlobalLeftSize-posx;
                 rrx:=Round(lr.RightRegion*FRatioX)+FOwner.ClientRect.Left+FGlobalLeftSize-posx;
                 trx:=Round(lr.TopRegion*FRatioY)+FOwner.ClientRect.Top+FGlobalTopSize-posy;
                 brx:=Round(lr.BottomRegion*FRatioY)+FOwner.ClientRect.Top+FGlobalTopSize-posy;
                 lr:=GetNodeRegion(linkP^.ToNodeNumber);
                 lre:=Round(lr.LeftRegion*FRatioX)+FOwner.ClientRect.Left+FGlobalLeftSize-posx;
                 rre:=Round(lr.RightRegion*FRatioX)+FOwner.ClientRect.Left+FGlobalLeftSize-posx;
                 tre:=Round(lr.TopRegion*FRatioY)+FOwner.ClientRect.Top+FGlobalTopSize-posy;
                 bre:=Round(lr.BottomRegion*FRatioY)+FOwner.ClientRect.Top+FGlobalTopSize-posy;
                 llis:=IsLeftArray(lrx);
                 rlis:=IsRightArray(rrx);
                 tlis:=IsTopArray(trx);
                 blis:=IsBottomArray(brx);
                               case linkP^.LinkType of
                                 unknown_link,onechild_right,manychild_lr:   begin
                                                                              gnode.RightLinksCount:=gnode.RightLinksCount+1;
                                                                              linkP^.LinkFromCount:=gnode.RightLinksCount;
                                                                              FRightArray.Count[rlis]:=FRightArray.Count[rlis]+1;
                                                                              if linkP^.linkType=manychild_lr then
                                                                               FBottomArray.Count[blis]:=FBottomArray.Count[blis]+1;
                                                                             end;
                                 onelevel_up:                                begin
                                                                              gnode.TopLinksCount:=gnode.TopLinksCount+1;
                                                                              linkP^.LinkFromCount:=gnode.TopLinksCount;
                                                                              FTopArray.Count[tlis]:=FTopArray.Count[tlis]+1;
                                                                             end;
                                 manylevel_up:                                begin
                                                                                if lre=lrx then
                                                                                 begin
                                                                                   {  -  }
                                                                                   gnode.LeftLinksCount:=gnode.LeftLinksCount+1;
                                                                                   linkP^.LinkFromCount:=gnode.LeftLinksCount;
                                                                                   linkP^.LinkSubType:=left_left;
                                                                                   FLeftArray.Count[llis]:=FLeftArray.Count[llis]+1;
                                                                                 end
                                                                                else
                                                                                if rrx=rre then
                                                                                 begin
                                                                                  {  -  }
                                                                                  gnode.RightLinksCount:=gnode.RightLinksCount+1;
                                                                                  linkP^.LinkFromCount:=gnode.RightLinksCount;
                                                                                  linkP^.LinkSubType:=right_right;
                                                                                  FRightArray.Count[rlis]:=FRightArray.Count[rlis]+1;
                                                                                 end
                                                                                else
                                                                                 begin
                                                                                  gdnode:=GetGraphNumberedNode(linkP^.ToNodeNumber);
                                                                                  if  (gdnode^.BPNode.Left-gnode.Left)>gnode.Width then
                                                                                  begin
                                                                                   {right-left}
                                                                                   gnode.RightLinksCount:=gnode.RightLinksCount+1;
                                                                                   linkP^.LinkFromCount:=gnode.RightLinksCount;
                                                                                   linkP^.LinkSubType:=right_leftspec;
                                                                                   FRightArray.Count[rlis]:=FRightArray.Count[rlis]+1;
                                                                                   FTopArray.Count[tlis]:=FTopArray.Count[tlis]+1;
                                                                                  end
                                                                                  else
                                                                                  begin
                                                                                  if (gnode.Left-gdnode^.BPNode.Left)>gnode.Width then
                                                                                  begin
                                                                                   {left-right}
                                                                                   gnode.LeftLinksCount:=gnode.LeftLinksCount+1;
                                                                                   linkP^.LinkFromCount:=gnode.LeftLinksCount;
                                                                                   linkP^.LinkSubType:=left_rightspec;
                                                                                   FLeftArray.Count[llis]:=FLeftArray.Count[llis]+1;
                                                                                   FTopArray.Count[tlis]:=FTopArray.Count[tlis]+1;
                                                                                  end
                                                                                  else
                                                                                  begin
                                                                                  if  (gnode.Left+(gnode.Width div 2))<=(gdnode^.BPNode.Left+(gdnode^.BPNode.Width div 2)) then
                                                                                   begin
                                                                                     {  }
                                                                                     gnode.LeftLinksCount:=gnode.LeftLinksCount+1;
                                                                                     linkP^.LinkFromCount:=gnode.LeftLinksCount;
                                                                                     linkP^.LinkSubType:=left_leftspec;
                                                                                     FLeftArray.Count[llis]:=FLeftArray.Count[llis]+1;
                                                                                     FTopArray.Count[tlis]:=FTopArray.Count[tlis]+1;
                                                                                   end
                                                                                  else
                                                                                   begin
                                                                                     {  }
                                                                                     gnode.RightLinksCount:=gnode.RightLinksCount+1;
                                                                                     linkP^.LinkFromCount:=gnode.RightLinksCount;
                                                                                     linkP^.LinkSubType:=right_rightspec;
                                                                                     FRightArray.Count[rlis]:=FRightArray.Count[rlis]+1;
                                                                                     FTopArray.Count[tlis]:=FTopArray.Count[tlis]+1;
                                                                                   end;
                                                                                  end;
                                                                                 end;
                                                                                 end;
                                                                              end;

                                 onechild_left:                               begin
                                                                               gnode.LeftLinksCount:=gnode.LeftLinksCount+1;
                                                                               linkP^.LinkFromCount:=gnode.LeftLinksCount;
                                                                               FLeftArray.Count[llis]:=FLeftArray.Count[llis]+1;
                                                                              end;
                               end; { case }
                               gnode.OutputCount:=0;
                               linkP^.LinkLeftCountFrom:=FLeftArray.Count[llis];
                               linkP^.LinkRightCountFrom:=FRightArray.Count[rlis];
                               linkP^.LinkTopCountFrom:=FTopArray.Count[tlis];
                               linkP^.LinkBottomCountFrom:=FBottomArray.Count[blis];
                   end; { if  FromNodeNumber }
              if (linkP^.ToNodeNumber=gnode.NodeNumber) and
                 ((linkP^.dwFlags and BP_TOMASK)=BP_TONODE_LEFT)  then
                begin
                 lr:=GetNodeRegion(linkP^.ToNodeNumber);
                 lrx:=Round(lr.LeftRegion*FRatioX)+FOwner.ClientRect.Left+FGlobalLeftSize-posx;
                 rrx:=Round(lr.RightRegion*FRatioX)+FOwner.ClientRect.Left+FGlobalLeftSize-posx;
                 trx:=Round(lr.TopRegion*FRatioY)+FOwner.ClientRect.Top+FGlobalTopSize-posy;
                 brx:=Round(lr.BottomRegion*FRatioY)+FOwner.ClientRect.Top+FGlobalTopSize-posy;
                 lr:=GetNodeRegion(linkP^.FromNodeNumber);
                 lre:=Round(lr.LeftRegion*FRatioX)+FOwner.ClientRect.Left+FGlobalLeftSize-posx;
                 rre:=Round(lr.RightRegion*FRatioX)+FOwner.ClientRect.Left+FGlobalLeftSize-posx;
                 tre:=Round(lr.TopRegion*FRatioY)+FOwner.ClientRect.Top+FGlobalTopSize-posy;
                 bre:=Round(lr.BottomRegion*FRatioY)+FOwner.ClientRect.Top+FGlobalTopSize-posy;
                 llis:=IsLeftArray(lrx);
                 rlis:=IsRightArray(rrx);
                 tlis:=IsTopArray(trx);
                 blis:=IsBottomArray(brx);
                              case linkP^.LinkType of
                                unknown_link,onechild_right,manychild_lr:    begin
                                                                             gnode.LeftLinksCount:=gnode.LeftLinksCount+1;
                                                                             linkP^.LinkToCount:=gnode.LeftLinksCount;
                                                                             FLeftArray.Count[llis]:=FLeftArray.Count[llis]+1;
                                                                             end;
                                onelevel_up:                                 begin
                                                                             gnode.BottomLinksCount:=gnode.BottomLinksCount+1;
                                                                             linkP^.LinkToCount:=gnode.BottomLinksCount;
                                                                             FBottomArray.Count[blis]:=FBottomArray.Count[blis]+1;
                                                                             end;
                                manylevel_up:                                begin
                                                                                if lre=lrx then
                                                                                 begin
                                                                                   { - }
                                                                                   gnode.LeftLinksCount:=gnode.LeftLinksCount+1;
                                                                                   linkP^.LinkToCount:=gnode.LeftLinksCount;
                                                                                   linkP^.LinkSubType:=left_left;
                                                                                   FLeftArray.Count[llis]:=FLeftArray.Count[llis]+1;
                                                                                 end
                                                                                else
                                                                                if rre=rrx then
                                                                                 begin
                                                                                   { - }
                                                                                   gnode.RightLinksCount:=gnode.RightLinksCount+1;
                                                                                   linkP^.LinkToCount:=gnode.RightLinksCount;
                                                                                   linkP^.LinkSubType:=right_right;
                                                                                   FRightArray.Count[rlis]:=FRightArray.Count[rlis]+1;
                                                                                 end
                                                                                else
                                                                                 begin
                                                                                  gdnode:=GetGraphNumberedNode(linkP^.FromNodeNumber);
                                                                                  if  (gdnode^.BPNode.Left-gnode.Left)>gnode.Width then
                                                                                  begin
                                                                                    {left-right}
                                                                                    gnode.RightLinksCount:=gnode.RightLinksCount+1;
                                                                                    linkP^.LinkToCount:=gnode.RightLinksCount;
                                                                                    linkP^.LinkSubType:=left_rightspec;
                                                                                    FRightArray.Count[rlis]:=FRightArray.Count[rlis]+1;
                                                                                  end
                                                                                  else
                                                                                  begin
                                                                                  if  (gnode.Left-gdnode^.BPNode.Left)>gnode.Width then
                                                                                  begin
                                                                                   {right-left}
                                                                                   gnode.LeftLinksCount:=gnode.LeftLinksCount+1;
                                                                                   linkP^.LinkToCount:=gnode.LeftLinksCount;
                                                                                   linkP^.LinkSubType:=right_leftspec;
                                                                                   FLeftArray.Count[llis]:=FLeftArray.Count[llis]+1;
                                                                                  end
                                                                                  else
                                                                                  begin
                                                                                  if  (gnode.Left+(gnode.Width div 2))>=(gdnode^.BPNode.Left+(gdnode^.BPNode.Width div 2)) then
                                                                                   begin
                                                                                     {  }
                                                                                     gnode.LeftLinksCount:=gnode.LeftLinksCount+1;
                                                                                     linkP^.LinkToCount:=gnode.LeftLinksCount;
                                                                                     linkP^.LinkSubType:=left_leftspec;
                                                                                     FLeftArray.Count[llis]:=FLeftArray.Count[llis]+1;
                                                                                   end
                                                                                  else
                                                                                   begin
                                                                                     {  }
                                                                                     gnode.RightLinksCount:=gnode.RightLinksCount+1;
                                                                                     linkP^.LinkToCount:=gnode.RightLinksCount;
                                                                                     linkP^.LinkSubType:=right_rightspec;
                                                                                     FRightArray.Count[rlis]:=FRightArray.Count[rlis]+1;
                                                                                   end;
                                                                                  end;
                                                                                  end;
                                                                                 end;
                                                                              end;
                                onechild_left:                               begin
                                                                               gnode.RightLinksCount:=gnode.RightLinksCount+1;
                                                                               linkP^.LinkToCount:=gnode.RightLinksCount;
                                                                               FRightArray.Count[rlis]:=FRightArray.Count[rlis]+1;
                                                                             end;
                              end; { case }
                              gnode.OutputCount:=0;
                              linkP^.LinkLeftCountTo:=FLeftArray.Count[llis];
                              linkP^.LinkRightCountTo:=FRightArray.Count[rlis];
                              linkP^.LinkTopCountTo:=FTopArray.Count[tlis];
                              linkP^.LinkBottomCountTo:=FBottomArray.Count[blis];
                 end; { if ToNodeNumber }
               end; { Visible link }
            end; { link<>nil}
        end; { for links }
      end; { node<>nil}
    end; { for nodes }
  end;

procedure  TBPPNDGraph.TraceLocalStartEndPoints; { Checked }
 Var linkP:PPNDGraphLink;
     gnode:PPNDGraphNode;
     gdnode:PPNDGraphNode;
         i:Integer;
       w,h:Integer;
       w1,h1:Integer;
       posx,posy:Integer;
       lc:Integer;
       centerx:Integer;
  begin
   { SetUp Start & End points of Links }
   if (FGLinksCount=0) then Exit;
   if (FGNodesCount=0) then Exit;
   if FOwner.HorzScrollBar.Visible then
     posx:=FOwner.HorzScrollBar.ScrollPos
   else
     posx:=0;
   if FOwner.VertScrollBar.Visible then
     posy:=FOwner.VertScrollBar.ScrollPos
   else
     posy:=0;
   if FPrinting then
    begin
     if not(FScaled2) then
      begin
       posx:=0;
       posy:=0;
      end;
    end;
   centerx:=FDefWidth div 2;
   for i:=0 to (FGLinksCount-1) do
    begin
      linkP:=GetGraphLink(i);
      if linkP^.Visible then
      begin
      gnode:= GetGraphNumberedNode(linkP^.FromNodeNumber);
      { begin StartPoint }
      if (gnode<>nil) and
         ((linkP^.dwFlags and BP_FROMMASK)=BP_FROMNODE_RIGHT) then
       begin
         { local node }
         lc:=linkP^.LinkFromCount;
         case linkP^.LinkType of
            unknown_link,onechild_right,manychild_lr:     begin
                                                           h1:=gnode^.BPNode.height div (gnode^.BPNode.RightLinksCount+1);
                                                           h:=gnode^.BPNode.top+{gnode^.BPNode.height div 2}h1*lc;
                                                           w:=gnode^.BPNode.Left+gnode^.BPNode.Width;
                                                          end;
            onelevel_up:                                  begin
                                                          { w1:=gnode^.BPNode.width div (gnode^.BPNode.TopLinksCount+1);}
                                                           w:=gnode^.BPNode.left+gnode^.BPNode.width div 2{w1*lc};
                                                           h:=gnode^.BPNode.top;
                                                          end;
            manylevel_up:                                begin
                                                           case linkP^.LinkSubType of
                                                             unknown_sublink,left_left,left_leftspec,left_rightspec: begin
                                                                                                     h1:=gnode^.BPNode.height div (gnode^.BPNode.LeftLinksCount+1);
                                                                                                     h:=gnode^.BPNode.top+{gnode^.BPNode.height div 2}h1*lc;
                                                                                                     w:=gnode^.BPNode.Left;
                                                                                                   end;
                                                             right_rightspec,right_right,right_leftspec:     begin
                                                                                                     h1:=gnode^.BPNode.height div (gnode^.BPNode.RightLinksCount+1);
                                                                                                     h:=gnode^.BPNode.top+{gnode^.BPNode.height div 2}h1*lc;
                                                                                                     w:=gnode^.BPNode.Left+gnode^.BPNode.Width;
                                                                                                   end;
                                                           end;
                                                         end;
            onechild_left:                               begin
                                                              h1:=gnode^.BPNode.height div (gnode^.BPNode.LeftLinksCount+1);
                                                              h:=gnode^.BPNode.top+{gnode^.BPNode.height div 2}h1*lc;
                                                              w:=gnode^.BPNode.Left;
                                                         end;
         end;
         linkP^.StartPoint.x:=w;
         linkP^.StartPoint.y:=h;
       end;
      { End StartPoint }
      gnode:=GetGraphNumberedNode(linkP^.ToNodeNumber);
      { begin EndPoint }
      if (gnode<>nil) and
         ((linkP^.dwFlags and BP_TOMASK)=BP_TONODE_LEFT) then
       begin
         { local node }
        lc:=linkP^.LinkToCount;
         case linkP^.LinkType of
            unknown_link,onechild_right,manychild_lr:     begin
                                                              h1:=gnode^.BPNode.height div (gnode^.BPNode.LeftLinksCount+1);
                                                              h:=gnode^.BPNode.top+{gnode^.BPNode.height div 2}h1*lc;
                                                              w:=gnode^.BPNode.Left;
                                                          end;
            onelevel_up:                                  begin
                                                          { w1:=gnode^.BPNode.width div (gnode^.BPNode.BottomLinksCount+1);}
                                                           w:=gnode^.BPNode.left+ gnode^.BPNode.Width div 2{w1*lc};
                                                           h:=gnode^.BPNode.top+gnode^.BPNode.Height;
                                                          end;
            manylevel_up:                                begin
                                                           case linkP^.LinkSubType of
                                                             unknown_sublink,left_leftspec,left_left,right_leftspec: begin
                                                                                                     h1:=gnode^.BPNode.height div (gnode^.BPNode.LeftLinksCount+1);
                                                                                                     h:=gnode^.BPNode.top+{gnode^.BPNode.height div 2}h1*lc;
                                                                                                     w:=gnode^.BPNode.Left;
                                                                                                   end;
                                                             right_rightspec,right_right,left_rightspec:          begin
                                                                                                     h1:=gnode^.BPNode.height div (gnode^.BPNode.RightLinksCount+1);
                                                                                                     h:=gnode^.BPNode.top+{gnode^.BPNode.height div 2}h1*lc;
                                                                                                     w:=gnode^.BPNode.Left+gnode^.BPNode.Width;
                                                                                                   end;
                                                           end;
                                                         end;
            onechild_left:                               begin
                                                           h1:=gnode^.BPNode.height div (gnode^.BPNode.RightLinksCount+1);
                                                           h:=gnode^.BPNode.Top+{gnode^.BPNode.height div 2}h1*lc;
                                                           w:=gnode^.BPNode.Left+gnode^.BPNode.Width;
                                                         end;
         end;
         linkP^.EndPoint.x:=w;
         linkP^.EndPoint.y:=h;
       end;
       { End EndPoint }
      end; { LinkP^.Visible }
    end; { for i }
  end;




 procedure   TBPPNDGraph.TraceLinks;  { Checked }
 Var    linkP:PPNDGraphLink;
        i:Integer;
        sx,sy:Integer;
        ex,ey:Integer;
        hw,hh:Integer;
        fc,tc:DWORD;
        fdc,tdc:DWORD;
        gnode:TBPLSAGraphNode;
        nodeP:PPNDGraphNode;
        tx,ty:Integer;
        nfcd,ntcd:DWORD;
        lineWidth:Integer;
        hhh:Integer;
        coffy,coffx:Integer;
        flrx,frrx:Integer;
        ftrx,fbrx:Integer;
        tlrx,trrx:Integer;
        ttrx,tbrx:Integer;
        posx,posy:Integer;
        centerx:Integer;
        lr:TBPPNDRegion;
        tmptmp:Integer;
        llcf,lrcf:Integer;
        ltcf,lbcf:Integer;
        llct,lrct:Integer;
        ltct,lbct:Integer;
        levelsUp:Integer;
        nodeDefS,nodeDefE:TBPPNDNodeDef;
  begin
    if (FGNodesCount=0) then Exit;
    if (FGLinksCount=0) then Exit;
    gnode:=GetGraphNode(0);
    hw:=gnode.Width div 2;
    hh:=gnode.Height div 2;
    coffy:=hh div 12; { hm ? }
    coffx:=hw div 12; { hm ? }
    if FOwner.HorzScrollBar.Visible then posx:=FOwner.HorzScrollBar.ScrollPos else posx:=0;
    if FOwner.VertScrollBar.Visible then posy:=FOwner.VertScrollBar.ScrollPos else posy:=0;
    if FPrinting and (not(FScaled2)) then
      begin
       posx:=0;
       posy:=0;
      end;
    centerx:=(FDefWidth div 2);
{    posx:=FOwner.ClientRect.Left+FGlobalLeftSize+posx;}
    for i:=0 to (FGLinksCount-1) do
     begin
       linkP:=GetGraphLink(i);
       if linkP^.Visible then
       begin
       lr:=GetNodeRegion(linkP^.FromNodeNumber);
       flrx:=Round(lr.LeftRegion{nodeP^.BPNode.LeftRegion}*FRatioX)+FOwner.ClientRect.Left+FGlobalLeftSize-posx;
       frrx:=Round(lr.RightRegion{nodeP^.BPNode.RightRegion}*FRatioX)+FOwner.ClientRect.Left+FGlobalLeftSize-posx;
       ftrx:=Round(lr.TopRegion{nodeP^.BPNode.LeftRegion}*FRatioY)+FOwner.ClientRect.Top+FGlobalTopSize-posy;
       fbrx:=Round(lr.BottomRegion{nodeP^.BPNode.RightRegion}*FRatioY)+FOwner.ClientRect.Top+FGlobalTopSize-posy;
       lr:=GetNodeRegion(linkP^.ToNodeNumber);
       tlrx:=Round(lr.LeftRegion{nodeP^.BPNode.LeftRegion}*FRatioX)+FOwner.ClientRect.Left+FGlobalLeftSize-posx;
       trrx:=Round(lr.RightRegion{nodeP^.BPNode.RightRegion}*FRatioX)+FOwner.ClientRect.Left+FGlobalLeftSize-posx;
       ttrx:=Round(lr.TopRegion{nodeP^.BPNode.LeftRegion}*FRatioY)+FOwner.ClientRect.Top+FGlobalTopSize-posy;
       tbrx:=Round(lr.BottomRegion{nodeP^.BPNode.RightRegion}*FRatioY)+FOwner.ClientRect.Top+FGlobalTopSize-posy;
       sx:=linkP^.StartPoint.X;
       sy:=linkP^.StartPoint.Y;
       ex:=linkP^.EndPoint.X;
       ey:=linkP^.EndPoint.Y;
       fc:=linkP^.LinkFromCount;
       tc:=linkP^.LinkToCount;
       llcf:=linkP^.LinkLeftCountFrom;
       lrcf:=linkP^.LinkRightCountFrom;
       ltcf:=LinkP^.LinkTopCountFrom;
       lbcf:=LinkP^.LinkBottomCountFrom;
       llct:=linkP^.LinkLeftCountTo;
       lrct:=linkP^.LinkRightCountTo;
       ltct:=LinkP^.LinkTopCountTo;
       lbct:=LinkP^.LinkBottomCountTo;
       { Set First dot }
       linkP^.LineArrayX[0]:=sx;
       linkP^.LineArrayY[0]:=sy;
       linkP^.LinePointCount:=1;
       case (linkP^.dwFlags and BP_FROMTOMASK) of
        BP_RIGHT_LEFT: begin
                         case (linkP^.LinkType) of
                           unknown_link,onelevel_up,onechild_left,onechild_right:
                                 begin
                                  linkP^.LineArrayX[1]:=ex;
                                  linkP^.LineArrayY[1]:=ey;
                                  linkP^.LinePointCount:=2;
                                 end;
                           manylevel_up:
                                 begin
                                  nodeP:=GetGraphNumberedNode(linkP^.ToNodeNumber);
                                  if nodep<>nil then
                                   begin
                                      { Get Start And End Node Info }
                                       nodeDefS:=FindCheckNode(GetGraphNumberedNode(linkP^.FromNodeNumber));
                                       nodeDefE:=FindCheckNode(GetGraphNumberedNode(linkP^.ToNodeNumber));
                                       if (nodeDefS.NodeIndex=-1) or (nodeDefS.Level=-1) or
                                       (nodeDefE.NodeIndex=-1) or (nodeDefE.Level=-1) then
                                         begin
                                          linkP^.LinePointCount:=0;
                                         end
                                       else
                                         begin
                                          levelsUp:=nodeDefS.Level-nodeDefE.Level;
                                          if levelsUp<0 then
                                           begin
                                            {     }
                                            linkP^.LinePointCount:=0;
                                           end
                                          else
                                           begin
                                             if flrx=tlrx then
                                               begin
                                                 linkP^.LineArrayX[1]:=flrx-llcf*coffx;
                                                 linkP^.LineArrayY[1]:=sy;
                                                 linkP^.LineArrayX[2]:=flrx-llcf*coffx;
                                                 linkP^.LineArrayY[2]:=ey;
                                                 linkP^.LineArrayX[3]:=ex;
                                                 linkP^.LineArrayY[3]:=ey;
                                                 linkP^.LinePointCount:=4;
                                               end
                                             else
                                               begin
                                             if frrx=trrx then
                                               begin
                                                linkP^.LineArrayX[1]:=frrx+lrcf*coffx;
                                                linkP^.LineArrayY[1]:=sy;
                                                linkP^.LineArrayX[2]:=frrx+lrcf*coffx;
                                                linkP^.LineArrayY[2]:=ey;
                                                linkP^.LineArrayX[3]:=ex;
                                                linkP^.LineArrayY[3]:=ey;
                                                linkP^.LinePointCount:=4;
                                               end
                                             else
                                               begin
                                             if linkP^.LinkSubType=left_leftspec then
                                               begin
                                                linkP^.LineArrayX[1]:=flrx-llcf*coffx;
                                                linkP^.LineArrayY[1]:=sy;
                                                linkP^.LineArrayX[2]:=flrx-llcf*coffx;
                                                linkP^.LineArrayY[2]:=ftrx+ltcf*coffy;
                                                linkP^.LineArrayX[3]:=tlrx-llct*coffx;
                                                linkP^.LineArrayY[3]:=ftrx+ltcf*coffy;
                                                linkP^.LineArrayX[4]:=tlrx-llct*coffx;
                                                linkP^.LineArrayY[4]:=ey;
                                                linkP^.LineArrayX[5]:=ex;
                                                linkP^.LineArrayY[5]:=ey;
                                                linkP^.LinePointCount:=6;
                                               end
                                              else
                                               begin
                                                if linkP^.LinkSubType=right_rightspec then
                                                  begin
                                                   linkP^.LineArrayX[1]:=frrx+lrcf*coffx;
                                                   linkP^.LineArrayY[1]:=sy;
                                                   linkP^.LineArrayX[2]:=frrx+lrcf*coffx;
                                                   linkP^.LineArrayY[2]:=ftrx+ltcf*coffy;
                                                   linkP^.LineArrayX[3]:=trrx+lrct*coffx;
                                                   linkP^.LineArrayY[3]:=ftrx+ltcf*coffy;
                                                   linkP^.LineArrayX[4]:=trrx+lrct*coffx;
                                                   linkP^.LineArrayY[4]:=ey;
                                                   linkP^.LineArrayX[5]:=ex;
                                                   linkP^.LineArrayY[5]:=ey;
                                                   linkP^.LinePointCount:=6;
                                                  end
                                                 else
                                                  begin
                                                   if  linkP^.LinkSubType=left_rightspec then
                                                     begin
                                                      linkP^.LineArrayX[1]:=flrx-llcf*coffx;
                                                      linkP^.LineArrayY[1]:=sy;
                                                      linkP^.LineArrayX[2]:=flrx-llcf*coffx;
                                                      linkP^.LineArrayY[2]:=ftrx+ltcf*coffy;
                                                      linkP^.LineArrayX[3]:=trrx+lrct*coffx;
                                                      linkP^.LineArrayY[3]:=ftrx+ltcf*coffy;
                                                      linkP^.LineArrayX[4]:=trrx+lrct*coffx;
                                                      linkP^.LineArrayY[4]:=ey;
                                                      linkP^.LineArrayX[5]:=ex;
                                                      linkP^.LineArrayY[5]:=ey;
                                                      linkP^.LinePointCount:=6;
                                                     end
                                                    else
                                                     begin
                                                     if  linkP^.LinkSubType=right_leftspec then
                                                       begin
                                                        linkP^.LineArrayX[1]:=frrx+lrcf*coffx;
                                                        linkP^.LineArrayY[1]:=sy;
                                                        linkP^.LineArrayX[2]:=frrx+lrcf*coffx;
                                                        linkP^.LineArrayY[2]:=ftrx+ltcf*coffy;
                                                        linkP^.LineArrayX[3]:=tlrx-llct*coffx;
                                                        linkP^.LineArrayY[3]:=ftrx+ltcf*coffy;
                                                        linkP^.LineArrayX[4]:=tlrx-llct*coffx;
                                                        linkP^.LineArrayY[4]:=ey;
                                                        linkP^.LineArrayX[5]:=ex;
                                                        linkP^.LineArrayY[5]:=ey;
                                                        linkP^.LinePointCount:=6;
                                                       end
                                                      else
                                                       begin
                                                        LinkP^.LinePointCount:=0;
                                                       end;
                                                     end;
                                                  end;
                                               end;
                                               end;
                                               end;
                                           end;
                                         end;
                                   end
                                  else
                                   begin
                                    linkP^.LineArrayX[1]:=ex;
                                    linkP^.LineArrayY[1]:=ey;
                                    linkP^.LinePointCount:=0;
                                   end;
                                 end;
                           manychild_lr:
                                 begin
                                   linkP^.LineArrayX[1]:=sx+fc*coffx+FMinLineStep;
                                   linkP^.LineArrayY[1]:=sy;
                                   linkP^.LineArrayX[2]:=sx+fc*coffx+FMinLineStep;
                                   linkP^.LineArrayY[2]:=fbrx-lbcf*coffy;
                                   linkP^.LineArrayX[3]:=ex-tc*coffx-FMinLineStep;
                                   linkP^.LineArrayY[3]:=fbrx-lbcf*coffy;
                                   linkP^.LineArrayX[4]:=ex-tc*coffx-FMinLineStep;
                                   linkP^.LineArrayY[4]:=ey;
                                   linkP^.LineArrayX[5]:=ex;
                                   linkP^.LineArrayY[5]:=ey;
                                   linkP^.LinePointCount:=6;
                                 end;
                         end;
                       end;
        else  begin
               { Main error link - not traced }
               linkP^.LineArrayX[1]:=ex;
               linkP^.LineArrayY[1]:=ey;
               linkP^.LinePointCount:=0;
              end;
       end; { case }
      end { Visible link }
     else
      begin
        linkP^.LineArrayX[0]:=linkP^.StartPoint.x;
        linkP^.LineArrayY[0]:=linkP^.StartPoint.y;
        linkP^.LineArrayX[1]:=linkP^.EndPoint.x;
        linkP^.LineArrayY[1]:=linkP^.EndPoint.y;
        linkP^.LinePointCount:=0;
      end;
     end; { for links }
  end;


procedure  TBPPNDGraph.DrawArrow(dx,dy,sx,sy:Integer);
Var d:Integer;
    x1,y1,x2,y2:Integer;
    zx,zy:Integer;
    f1,f2:Double;
    normaz,normad:Integer;
    sizex,sizey:Integer;
    dd:Double;
    i:Integer;
 begin
  {}
   d:=Round(MinLineEndPoint*0.57735);
   if (d=0) and (MinLineEndPoint=0) then Exit;
   if (d=0) then d:=1;
   with FOwner.Canvas do
    begin
       normad:=Round(Sqrt((dx-sx)*(dx-sx)+(dy-sy)*(dy-sy)));
       dd:=1+(3*MinLineEndPoint)/normad;
       zx:=Round((dx-sx)/dd);
       zy:=Round((dy-sy)/dd);
       normaz:=Round(Sqrt(zx*zx+zy*zy));
       f1:=3.14/2;
       f2:=-3.14/2;
       for i:=2*d downto 1 do
       begin
       sizex:=i;
       sizey:=sizex;
       if (normaz=0) then normaz:=1;
       if (sizex=0) then sizex:=1;
       if (sizey=0) then sizey:=1;
       x1:=Round((cos(f1)*zx+sin(f1)*zy)/normaz*sizex)+sx+zx;
       y1:=Round((cos(f1)*zy-sin(f1)*zx)/normaz*sizey)+sy+zy;
       x2:=Round((cos(f2)*zx+sin(f2)*zy)/normaz*sizex)+sx+zx;
       y2:=Round((cos(f2)*zy-sin(f2)*zx)/normaz*sizey)+sy+zy;
       if i=2*d then
        begin
         MoveTo(x1,y1);
         LineTo(x2,y2);
        end;
       MoveTo(x1,y1);
       LineTo(dx,dy);
       MoveTo(x2,y2);
       LineTo(dx,dy);
     end; { for }
   end;
 end;


procedure  TBPPNDGraph.DrawLinks; { Checked }
  Var linkP:PPNDGraphLink;
         i,j:Integer;
         fx,fy,lx,ly:Integer;
         dx,dy,dx1,dy1,tx,ty:Integer;
         oldColor,cl:TColor;
         mls:Integer;
         ops,ps:TPenStyle;
         c:Integer;
         NewMinArcRadius:Integer;
         NDelta,nd1,nd2:Integer;
         ox,oy,nx,ny:Integer;
  begin
   if (FGLinksCount=0) then Exit;
   oldColor:=FOwner.Canvas.Pen.Color;
   ops:=FOwner.Canvas.Pen.Style;
   mls:=MinLineStep div 2;
    for i:=0 to (FGLinksCount-1) do
     begin
       linkP:=GetGraphLink(i);
       if linkP^.Visible then
       begin
       cl:=LinkP^.Color;
       FOwner.Canvas.Pen.Color:=cl;
       ps:=LinkP^.PenStyle;
       FOwner.Canvas.Pen.Style:=ps;
       if (LinkP^.LinePointCount>1) and
          ((linkP^.dwFlags and BP_TOMASK)=BP_TONODE_LEFT) then
         begin
          c:=LinkP^.LinePointCount-2;
          DrawArrow(linkP^.EndPoint.x,linkP^.EndPoint.y,linkP^.LineArrayX[c],linkP^.LineArrayY[c]);
         end;
{       FOwner.Canvas.Pen.Color:=cl;
       FOwner.Canvas.Pen.Style:=ps;}
       { Draw labels here}
       { End draw labels }
       FOwner.Canvas.Pen.Color:=cl;
       FOwner.Canvas.Pen.Style:=ps;
        for j:=0 to (linkP^.LinePointCount-1) do
         begin
          tx:=linkP^.LineArrayX[j];
          ty:=linkP^.LineArrayY[j];
          NewMinArcRadius:=MinArcRadius;
          if j=0 then FOwner.Canvas.MoveTo(tx,ty);
          if (j=(linkP^.LinePointCount-1)) then FOwner.Canvas.LineTo(tx,ty);
          if (j<>0) and (j<>(linkP^.LinePointCount-1)) then
           begin
            ox:=linkP^.LineArrayX[j-1];
            oy:=linkP^.LineArrayY[j-1];
            nx:=linkP^.LineArrayX[j+1];
            ny:=linkP^.LineArrayY[j+1];
            if nx=tx then
              nd1:=ABS(ny-ty)
            else
              nd1:=ABS(nx-tx);
            if ox=tx then
              nd2:=ABS(ty-oy)
            else
              nd2:=ABS(tx-ox);
            if nd1<nd2 then nDelta:=nd1 else nDelta:=nd2;
            if (NewMinArcRadius>(nDelta div 2)) then NewMinArcRadius:=nDelta div 2;
            dx:=SignedVector(linkP^.LineArrayX[j+1]-tx,NewMinArcRadius);
            dy:=SignedVector(linkP^.LineArrayY[j+1]-ty,NewMinArcRadius);
            dx1:=SignedVector(linkP^.LineArrayX[j-1]-tx,NewMinArcRadius);
            dy1:=SignedVector(linkP^.LineArrayY[j-1]-ty,NewMinArcRadius);
            if (dx*dy1-dx1*dy)>0 then
             begin
            fx:=tx+dx;
            fy:=ty+dy;
            lx:=tx+dx1;
            ly:=ty+dy1;
             end
            else
             begin
            fx:=tx+dx1;
            fy:=ty+dy1;
            lx:=tx+dx;
            ly:=ty+dy;
             end;
            FOwner.Canvas.Arc(tx+2*dx,ty+2*dy,tx+2*dx1,ty+2*dy1,fx,fy,lx,ly);
             if (dx*dy1-dx1*dy)<0 then
              begin
                 FOwner.Canvas.LineTo(fx,fy);
                 FOwner.Canvas.MoveTo(lx,ly);
              end
              else
              begin
                 FOwner.Canvas.LineTo(lx,ly);
                 FOwner.Canvas.MoveTo(fx,fy);
              end;
           end;
         end;
     end; { Visible link }
    end; { For }

    FOwner.Canvas.Pen.Color:=oldColor;
    FOwner.Canvas.Pen.Style:=ops;
  end;


 procedure  TBPPNDGraph.TraceRoute; { Main Tracing Procedure } { Checked }
  begin
    { Lets Trace graph }

    if (FCalcWidthHeight) then Exit;      { Disable Reenter to routine }
     TraceNodes;                           { Trace Nodes }

     TraceNodesToLinksCounters;             { Hm }
     TraceLinksToNodeCounters;              { Hm }
     TraceLocalStartEndPoints;              { OK }
     TraceLinks;                           { Yes }
     DrawLinks;                            { Yes }
     FDiscardDrags:=False;
  end;


{ TBPPNDFrame }

procedure TBPPNDFrame.SetPageParam(Var PageTop,PageBottom,PageLeft,PageRight:Integer;ShowWarning:Boolean); { Checked }
Var px,py,plofs,ptofs,pbofs,profs:Integer;
    s:String;
    pw,ph,hw,hh:Integer;
    po:TPrinterOrientation;
Const   es='      .    ';
        se=' ';
begin
 po:=Printer.Orientation;
 case po of
 poPortrait:
   begin
    px:=GetDeviceCaps(Printer.Handle,LOGPIXELSX);
    py:=GetDeviceCaps(Printer.Handle,LOGPIXELSY);
    plofs:=GetDeviceCaps(Printer.Handle,PHYSICALOFFSETX);
    ptofs:=GetDeviceCaps(Printer.Handle,PHYSICALOFFSETY);
    pw:=GetDeviceCaps(Printer.Handle,PHYSICALWIDTH);
    hw:=GetDeviceCaps(Printer.Handle,HORZRES);
    ph:=GetDeviceCaps(Printer.Handle,PHYSICALHEIGHT);
    hh:=GetDeviceCaps(Printer.Handle,VERTRES);
   end;
  poLandscape:
   begin
    py:=GetDeviceCaps(Printer.Handle,LOGPIXELSX);
    px:=GetDeviceCaps(Printer.Handle,LOGPIXELSY);
    ptofs:=GetDeviceCaps(Printer.Handle,PHYSICALOFFSETX);
    plofs:=GetDeviceCaps(Printer.Handle,PHYSICALOFFSETY);
    ph:=GetDeviceCaps(Printer.Handle,PHYSICALWIDTH);
    hh:=GetDeviceCaps(Printer.Handle,HORZRES);
    pw:=GetDeviceCaps(Printer.Handle,PHYSICALHEIGHT);
    hw:=GetDeviceCaps(Printer.Handle,VERTRES);
   end;
 end;
 pbofs:=ph-hh-ptofs;
 profs:=pw-hw-plofs;
 FPageTop:=Round(PageTop*py/25.4)-ptofs;
 FPageBottom:=Round(PageBottom*py/25.4)-pbofs;
 FPageLeft:=Round(PageLeft*px/25.4)-plofs;
 FPageRight:=Round(PageRight*px/25.4)-profs;
 if ShowWarning then
 begin
 if FPageTop<0 then
   begin
   s:=se+''+es;
   Application.MessageBox(PChar(s),' !',MB_OK);
   FPageTop:=0;
   PageTop:=Round(ptofs*25.4/py)+1;
   end;
  if FPageBottom<0 then
   begin
   s:=se+''+es;
   Application.MessageBox(PChar(s),' !',MB_OK);
   FPageBottom:=0;
   PageBottom:=Round(pbofs*25.4/py)+1;
   end;
  if FPageLeft<0 then
   begin
   s:=se+''+es;
   Application.MessageBox(PChar(s),' !',MB_OK);
   FPageLeft:=0;
   PageLeft:=Round(plofs*25.4/px)+1;
   end;
  if FPageRight<0 then
   begin
   s:=se+''+es;
   Application.MessageBox(PChar(s),' !',MB_OK);
   FPageRight:=0;
   PageRight:=Round(profs*25.4/px)+1;
   end;
  end;
end;

procedure TBPPNDFrame.SetPreviewPageParam(PageTop,PageBottom,PageLeft,PageRight:Integer); { Checked }
begin
 FPageTop:=PageTop;
 FPageBottom:=PageBottom;
 FPageLeft:=PageLeft;
 FPageRight:=PageRight;
end;


constructor TBPPNDFrame.Create(AOwner: TComponent); { Checked }
begin
 inherited Create(AOwner);
 FPainting:=False;
 FPrinting:=False;
 FAborting:=False;
 FPreviewOrPrint:=False;
 FFontCoof:=1;
 FBPPNDGraph:=TBPPNDGraph.Create(self);
 FBPPNDGraph.Parent:=self;
 FCanvas := TControlCanvas.Create;
 TControlCanvas(FCanvas).Control := Self;
 Canvas.Brush.Color:=clWhite;
 DragCursor:=crMyCursor;
 OnDragDrop:=MyDragDrop;
 OnDragOver:=MyDragOver;
 FPageTop:=15;
 FPageBottom:=15;
 FPageLeft:=25;
 FPageRight:=15;
 FHorzPageCount:=1;
 FVertPageCount:=1;
 FRamkaFontRatio:=1.0;
 FPSizeH:=21;
 FPSizeW:=29.7;
 FRamkaH:=0;
 TabStop:=True;
 Enabled:=True;
 FUpdatingNavigator:=False;
 FFormatAlg[0]:=fa_Min;
 FFormatAlg[1]:=fa_Sqrt;
 FFormatAlg[2]:=fa_Max;
 FNodesValue[0]:=4;
 FNodesValue[1]:=6;
 if MainUnit.HasPrnDevice then SetPageParam(FPageTop,FPageBottom,FPageLeft,FPageRight,False);
end;

destructor TBPPNDFrame.Destroy; { Checked }
begin
 OnDragDrop:=nil;
 OnDragOver:=nil;
 if (FPrinter<>nil) then FPrinter.Free;
 if (FCanvas<>nil) then FCanvas.Free;
 if (FBPPNDGraph<>nil) then FBPPNDGraph.Destroy; { +-+ +- }
 inherited Destroy;
end;

procedure TBPPNDFrame.WMPaint(var Message: TWMPaint); { Checked }
begin
   PaintHandler(Message);
end;

procedure TBPPNDFrame.PaintWindow(DC: HDC); { Checked }
begin
  if FPainting then Exit;
  FPainting:=True;
  inherited PaintWindow(DC);
  FCanvas.Lock;
  try
    FCanvas.Handle := DC;
    try
      Paint;
    finally
      FCanvas.Handle := 0;
    end;
  finally
    FCanvas.Unlock;
    FPainting:=False;
  end;
end;

procedure TBPPNDFrame.Paint; { Checked }
Var oldcr:TCursor;
begin
  oldcr:=Cursor;
  Cursor:=crHourGlass;
  Canvas.FillRect(ClientRect);
  FBPPNDGraph.TraceRoute;
  if (not(FUpdatingNavigator)) and
  (BPViewMainFOrm.PageControl1.ActivePage=BPViewMainFOrm.TabSheet6) then
  if (BPViewMainFOrm.BPNavigator.Height>1) then
      BPViewMainFOrm.BPNavigator.ScrollBarChanged(self);
  Cursor:=oldcr;
end;

procedure TBPPNDFrame.PaintTo(DC: HDC; X, Y: Integer); { Checked }
var
  SaveIndex: Integer;
begin
  SaveIndex := SaveDC(DC);
  MoveWindowOrg(DC, X, Y);
  Perform(WM_ERASEBKGND, DC, 0);
  Perform(WM_PAINT, DC, 0);
  RestoreDC(DC, SaveIndex);
end;

procedure TBPPNDFrame.PaintPageTo(DC: HDC; X, Y: Integer; PageClipRect:TRect); { Checked }
var
  SaveIndex: Integer;
begin
  SaveIndex := SaveDC(DC);
  MoveWindowOrg(DC, X-PageClipRect.Left, Y-PageClipRect.Top);
  IntersectClipRect(DC, PageClipRect.Left, PageClipRect.Top, PageClipRect.Right, PageClipRect.Bottom);
  Perform(WM_ERASEBKGND, DC, 0);
  Perform(WM_PAINT, DC, 0);
  RestoreDC(DC, SaveIndex);
end;

procedure  TBPPNDFrame.PreviewPrintRect(left,right,top,bottom:Integer); { Checked }
Var oldStyle:TPenStyle;
    oldSize:Integer;
    w,h:Integer;
    s:String;
 begin
  if FPrinter = nil then Exit;
  with FPrinter.Canvas do
  begin
   oldStyle:=Pen.Style;
   Pen.Style:=psSolid;
   oldSize:=Font.Size;
   Font.Size:=16;
   s:=FBPPNDGraph.Caption;
   w:=TextWidth(s);
   h:=TextHeight(s);
   TextOut(Left+((Right-Left-w) div 2),Top+2*h,s);
   Font.Size:=oldSize;
   Pen.Style:=psDot;
   MoveTo(Left,Top);
   LineTo(Right,Top);
   LineTo(Right,Bottom);
   LineTo(Left,Bottom);
   LineTo(Left,Top);
   Pen.Style:=oldStyle;
  end;
 end;

procedure  TBPPNDFrame.PrintRect(left,right,top,bottom:Integer); { Checked }
Var oldStyle:TPenStyle;
    oldSize,w,h:Integer;
    s:String;
 begin
  with Printer.Canvas do
  begin
   oldStyle:=Pen.Style;
   Pen.Style:=psSolid;
   oldSize:=Font.Size;
   Font.Size:=16;
   s:=FBPPNDGraph.Caption;
   w:=TextWidth(s);
   h:=TextHeight(s);
   TextOut(Left+((Right-Left-w) div 2),Top+2*h,s);
   Font.Size:=oldSize;
   Pen.Style:=psDot;
   MoveTo(Left,Top);
   LineTo(Right,Top);
   LineTo(Right,Bottom);
   LineTo(Left,Bottom);
   LineTo(Left,Top);
   Pen.Style:=oldStyle;
  end;
 end;

procedure  TBPPNDFrame.DrawNode(l,t,w,h:Integer;Canvas:TCanvas;PaintColor,DrawColor:TColor); { Checked }
Var r1:TRect;
  oldPenColor:TColor;
  oldBrushColor:TColor;
 begin
   oldBrushColor:=Canvas.Brush.Color;
   oldPenColor:=Canvas.Pen.Color;
   Canvas.Brush.Color:=PaintColor;
   Canvas.Pen.Color:=DrawColor;
   r1.Left:=l;
   r1.Top:=t;
   r1.Right:=l+w;
   r1.Bottom:=t+h;
   Canvas.FillRect(r1);
   Canvas.MoveTo(l,t);
   Canvas.LineTo(l+w,t);
   Canvas.LineTo(l+w,t+h);
   Canvas.LineTo(l,t+h);
   Canvas.LineTo(l,t);
   Canvas.Brush.Color:=oldBrushColor;
   Canvas.Pen.Color:=oldPenColor;
 end;

procedure  TBPPNDFrame.DrawLink(pl:PPNDGraphLink;Canvas:TCanvas;RatioX,RatioY:Double;Wpos,Hpos:Integer); { Checked }
Var i,cnt:Integer;
    oldPenColor:TColor;
    oldPenStyle:TPenStyle;
 begin
  if pl=nil then Exit;
  oldPenColor:=Canvas.Pen.Color;
  oldPenStyle:=Canvas.Pen.Style;
  Canvas.Pen.Color:=pl^.Color;
  Canvas.Pen.Style:=pl^.PenStyle;
  cnt:=pl^.LinePointCount-1;
  Canvas.MoveTo(Round((pl^.LineArrayX[0]+wpos)*RatioX),Round((pl^.LineArrayY[0]+hpos)*RatioY));
  for i:=1 to cnt do
   begin
      Canvas.LineTo(Round((pl.LineArrayX[i]+wpos)*RatioX),Round((pl^.LineArrayY[i]+hpos)*RatioY));
    end;
  Canvas.Pen.Color:=oldPenColor;
  Canvas.Pen.Style:=oldPenStyle;
 end;

procedure  TBPPNDFrame.MyDragDrop(Sender, Source: TObject; X, Y: Integer);
var p:TPoint;
    vpos,hpos:Integer;
 begin
  if HorzScrollBar.Visible then hpos:=HorzScrollBar.Position;
  if VertScrollBar.Visible then vpos:=VertScrollBar.Position;
  if (Sender is TBPPNDFrame) and (Source is TBPLSAGraphCustomNode) then
  begin
    with Source as TBPLSAGraphNode do
    begin
      p.x:=X-Left;
      p.y:=Y-Top;
      Left:=X;
      Top:=Y;
      if VertScrollBar.Visible then
       TopDragPos:=Y+VertScrollBar.Position
      else
       TopDragPos:=Y;
      if HorzScrollBar.Visible then
       LeftDragPos:=X+HorzScrollBar.Position
      else
       LeftDragPos:=X;
      AcceptPosition:=True;
      FBPPNDGraph.UpdateNodesModel(LeftDragPos,TopDragPos,Source as TBPLSAGraphNode);
      BringToFront;
    end;
    with (Sender as TBPPNDFrame) do
      begin
       Visible:=False;
       FBPPNDGraph.TraceRoute;
       Repaint;
       Visible:=True;
       if HorzScrollBar.Visible then HorzScrollBar.Position:=hpos;
       if VertScrollBar.Visible then VertScrollBar.Position:=vpos;
       BPViewMainForm.BPGetBitmapTimer.Enabled:=True;
      end;
  end;
 end;

procedure  TBPPNDFrame.MyDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
 begin
 end;

function   TBPPNDFrame.GetCoof(rw,rh:Double;Alg:TBPFormatAlg):Double;
 begin
   case Alg of
     fa_Min:  if rw>=rh then Result:=rh else Result:=rw;
     fa_Max:  if rw>=rh then Result:=rw else Result:=rh;
     fa_Sqrt: Result:=Sqrt(rw*rh);
     fa_Sum:  Result:=(rw+rh)/2;
     fa_Width:  Result:=rw;
     fa_Height: Result:=rh;
   end;
 end;

procedure  TBPPNDFrame.Print;
Var  prnppi,scrppi:Integer;
     prnx,prny:Integer;
     dc:HDC;
     ratio,fontRatio:Double;
     rw,rh:Double;
     pw,ph:Double;
     ramkaH:Integer;
     nw,nh,mw,mh:Integer;
     oldScaled:Boolean;
     oldScaled2:Boolean;
     clRect:TRect;
     px,py:Integer;
     tmpI:TQRPaperSize;
     asize:Integer;
     wc,hc:Double;
     pgalg:TBPPgAlg;
 begin
  try
  oldScaled:=BPPNDGraph.Scaled;
  oldScaled2:=BPPNDGraph.Scaled2;
  FUpdatingNavigator:=True;
  FPreviewOrPrint:=True;
  if (FBPPNDGraph.FMaxNodesCount>FNodesValue[0]) then
      begin
        if (FBPPNDGraph.FMaxNodesCount<FNodesValue[1]) then
          pgAlg:=pg_Middle
        else
          pgAlg:=pg_Max;
      end
     else pgalg:=pg_Min;
  FBPPNDGraph.Scaled2:=False;
  if FBPPNDGraph.FScaled then FBPPNDGraph.Scaled:=False;
  FPrinting:=True;
  if HorzScrollBar.Visible then HorzScrollBar.Position:=0;
  if VertScrollBar.Visible then VertScrollBar.Position:=0;
  prnppi:=GetDeviceCaps(Printer.Handle,LOGPIXELSX);
  dc:=GetDC(self.Handle);
  scrppi:=GetDeviceCaps(dc,LOGPIXELSX);
  FFontCoof:=GetDeviceCaps(Printer.Handle,LOGPIXELSX)/GetDeviceCaps(dc,LOGPIXELSX);
  FBPPNDGraph.UpdateMaxFontSize(1);
  ReleaseDC(self.Handle,dc);
  aSize:=Printer.PaperSize;
  FRamkaFontRatio:=1.0;
  FPSizeH:=21;
  FPSizeW:=29.7;
  for tmpi:= Default to Custom do
     begin
      if aSize=cQRPaperTranslate[tmpI] then
         begin
           FRamkaFontRatio:=cQRPaperSizeMetrics[tmpI,0]/cQRPaperSizeMetrics[A4,0];
           FPSizeH:=cQRPaperSizeMetrics[tmpI,0]/10;
           FPSizeW:=cQRPaperSizeMetrics[tmpI,1]/10;
         end;
     end;
  ramkaH:=Round(prnppi/2.54);
  FRamkaH:=ramkaH;
  { New Code }
  pw:= GetDeviceCaps(Printer.Handle,VERTRES);
  ph:= GetDeviceCaps(Printer.Handle,HORZRES);
  if ((FHorzPageCount=1) and (FVertPageCount=1)) then
   ph:= ph-ramkaH;
  { End New Code }
{  ratio:=(prnppi*FHorzPageCount) / scrppi;}
  { New Code }
  rw:=(pw*FHorzPageCount)/FBPPNDGraph.DefWidth;
  rh:=(ph*FVertPageCount)/FBPPNDGraph.DefHeight;
  wc:=FBPPNDGraph.DefWidth;
  hc:=FBPPNDGraph.DefHeight;
  case pgAlg of
      pg_Min:     Ratio:=GetCoof(rw,rh,FFormatAlg[0]);
      pg_Middle:  Ratio:=GetCoof(rw,rh,FFormatAlg[1]);
      pg_Max:     Ratio:=GetCoof(rw,rh,FFormatAlg[2]);
  end; {case pgAlg }
  { End New Code }
  Printer.BeginDoc;
  FBPPNDGraph.SetDefaultConstants;
  FBPPNDGraph.SetScaledConstants(rw,rh,ratio,ratio);
  FBPPNDGraph.DefWidth:=(Printer.PageWidth*FHorzPageCount-FPageLeft*FHorzPageCount-FPageRight*FHorzPageCount);
  if ((FHorzPageCount=1) and (FVertPageCount=1)) then
   FBPPNDGraph.DefHeight:=(Printer.PageHeight*FVertPageCount-FPageTop*FVertPageCount-FPageBottom*FVertPageCount-ramkaH*FVertPageCount)
  else
   FBPPNDGraph.DefHeight:=(Printer.PageHeight*FVertPageCount-FPageTop*FVertPageCount-FPageBottom*FVertPageCount);
   wc:=FBPPNDGraph.DefWidth/wc;
   hc:=FBPPNDGraph.DefHeight/hc;
  FBPPNDGraph.Printing:=True;
  FBPPNDGraph.CreateGraphNodes(wc,hc);
  FBPPNDGraph.CreateGraphLinks(wc,hc);
  FBPPNDGraph.PresetupFrame(wc,hc);
  FBPPNDGraph.TraceRoute;
  Repaint;
  while FPainting do;
  nw:=FBPPNDGraph.NodeWidth;
  nh:=FBPPNDGraph.NodeHeight;
  mw:=FBPPNDGraph.MaxWidth;
  mh:=FBPPNDGraph.MaxHeight;
  rw:=ratio*nw/mw;
  rh:=ratio*nh/mh;
  case pgAlg of
       pg_Min:     fontRatio:=GetCoof(rw,rh,FFormatAlg[0]);
       pg_Middle:  fontRatio:=GetCoof(rw,rh,FFormatAlg[1]);
       pg_Max:     fontRatio:=GetCoof(rw,rh,FFormatAlg[2]);
  end;
{  if fontRatio>ratio then fontRatio:=ratio;}
  FBPPNDGraph.DefWidth:=(Printer.PageWidth*FHorzPageCount-FPageLeft*FHorzPageCount-FPageRight*FHorzPageCount);
  if ((FHorzPageCount=1) and (FVertPageCount=1)) then
   FBPPNDGraph.DefHeight:=(Printer.PageHeight*FVertPageCount-FPageTop*FVertPageCount-FPageBottom*FVertPageCount-ramkaH*FVertPageCount)
  else
   FBPPNDGraph.DefHeight:=(Printer.PageHeight*FVertPageCount-FPageTop*FVertPageCount-FPageBottom*FVertPageCount);
  FBPPNDGraph.SetDefaultConstants;
  FBPPNDGraph.SetScaledConstants(wc,hc,ratio,fontRatio);
  FBPPNDGraph.CreateGraphNodes(wc,hc);
  FBPPNDGraph.CreateGraphLinks(wc,hc);
  FBPPNDGraph.PresetupFrame(wc,hc);
  FBPPNDGraph.TraceRoute;
  Repaint;
  while FPainting do;
   for px:=1 to FHorzPageCount do
    begin
     clRect.Left:=(px-1)*(Printer.PageWidth-FPageRight-FPageLeft);
     clRect.Right:=px*(Printer.PageWidth-FPageRight-FPageLeft);
    for py:=1 to FVertPageCount do
     begin
     clRect.Top:=(py-1)*(Printer.PageHeight-FPageTop-FPageBottom);
     clRect.Bottom:=py*(Printer.PageHeight-FPageTop-FPageBottom);
     if ((FHorzPageCount=1) and (FVertPageCount=1)) then
       begin
        PaintTo(Printer.Handle,FPageLeft,FPageTop+ramkaH);
        PrintRect(FPageLeft,Printer.PageWidth-FPageRight,
                           FPageTop,Printer.PageHeight-FPageBottom);
       end
      else
       begin
        PaintPageTo(Printer.Handle,FPageLeft,FPageTop,clRect);
        PrintRect(FPageLeft,Printer.PageWidth-FPageRight,
                           FPageTop,Printer.PageHeight-FPageBottom);
       end;
       if ((FHorzPageCount<>px) or (FVertPageCount<>py)) then
        Printer.NewPage;
     end;
    end;
  finally
   Printer.EndDoc;
   FPrinting:=False;
   FUpdatingNavigator:=False;
   FPreviewOrPrint:=False;
   FBPPNDGraph.SetDefaultConstants;
   FBPPNDGraph.Printing:=False;
   FBPPNDGraph.CreateGraphNodes(1,1);
   FBPPNDGraph.CreateGraphLinks(1,1);
{   FBPPNDGraph.CheckLinksAndNodes;}
   FBPPNDGraph.SetScaled2(oldScaled2);
   FBPPNDGraph.SetScaled(oldScaled);
   if (not(oldScaled)) then FBPPNDGraph.PresetupFrame(1,1);
   FBPPNDGraph.TraceRoute;
   Invalidate;
  end;
 end;

procedure  TBPPNDFrame.CreateBitmap(var value:TBitmap;pf:TPixelFormat);
 begin
   try
   FUpdatingNavigator:=True;
   FPreviewOrPrint:=True;
   FFontCoof:=1;
   FBPPNDGraph.UpdateMaxFontSize(1);
   if HorzScrollBar.Visible then HorzScrollBar.Position:=0;
   if VertScrollBar.Visible then VertScrollBar.Position:=0;
   Visible:=False;
   value:=TBitmap.Create;
   value.PixelFormat:=pf;
   value.Width:=FBPPNDGraph.FDefWidth;
   value.Height:=FBPPNDGraph.FDefHeight;
   Repaint;
   while FPainting do;
   value.Canvas.Lock;
   PaintTo(value.Canvas.Handle,0,0);
   Value.Canvas.Unlock;
  finally
    FUpdatingNavigator:=False;
    FPreviewOrPrint:=False;
    Visible:=True;
  end;
 end;

procedure  TBPPNDFrame.GetBitmapWithSize(value:TBitmap;iw,ih:Integer); { scaled bitmap }
Var rw,rh:Double;
    i:Integer;
    wl,wt,ww,wh:Integer;
    node:PPNDGraphNode;
    link:PPNDGraphLink;
    hpos,vpos:Integer;
 begin
   try
   FUpdatingNavigator:=True;
   if HorzScrollBar.Visible then hpos:=HorzScrollBar.Position;
   if VertScrollBar.Visible then vpos:=VertScrollBar.Position;
   Visible:=False;
   if HorzScrollBar.Visible then HorzScrollBar.Position:=0;
   if VertScrollBar.Visible then VertScrollBar.Position:=0;
   while FPainting do;
   rw:=iw/(FBPPNDGraph.DefWidth+1);
   rh:=ih/(FBPPNDGraph.DefHeight+1);
   value.Canvas.Lock;
   Value.Canvas.FillRect(Value.Canvas.ClipRect);
   { Draw Node}
     node:=FBPPNDGraph.FGraphNodes;
    for i:=0 to (FBPPNDGraph.FGNodesCount-1) do
    begin
     wl:=Round(node^.BPNode.Left*rw);
     wt:=Round(node^.BPNode.Top*rh);
     ww:=Round(node^.BPNode.Width*rw);
     wh:=Round(node^.BPNode.Height*rh);
     DrawNode(wl,wt,ww,wh,Value.Canvas,node^.BPNode.PaintColor,node^.BPNode.RectColor);
     node:=node^.next;
    end;
     { Draw Links}
    link:=BPPNDGraph.FGraphLinks;
    for i:=0 to(BPPNDGraph.FGLinksCount-1) do
    begin
     if link^.Visible then  DrawLink(link,value.Canvas,rw,rh,hpos,vpos);
     link:=link^.next;
    end;
   value.Canvas.Unlock;
  finally
   if HorzScrollBar.Visible then HorzScrollBar.Position:=hpos;
   if VertScrollBar.Visible then VertScrollBar.Position:=vpos;
   Visible:=True;
   FUpdatingNavigator:=False;
  end;
 end;

procedure  TBPPNDFrame.CreateBitmapWithSize(var value:TBitmap;pf:TPixelFormat;iw,ih:Integer); { scaled bitmap }
Var oldScaled:Boolean;
    oldScaled2:Boolean;
    oldPrinting:Boolean;
    rw,rh:Double;
    ratio,fontRatio:Double;
    nw,nh:Integer;
    mw,mh:Integer;
    wc,hc:Double;
    pgalg:TBPPgAlg;
 begin
   try
   FUpdatingNavigator:=True;
   if (FBPPNDGraph.FMaxNodesCount>FNodesValue[0]) then
      begin
        if (FBPPNDGraph.FMaxNodesCount<FNodesValue[1]) then
          pgAlg:=pg_Middle
        else
          pgAlg:=pg_Max;
      end
     else pgalg:=pg_Min;
   oldScaled:=FBPPNDGraph.Scaled;
   oldScaled2:=FBPPNDGraph.Scaled2;
   oldPrinting:=FBPPNDGraph.Printing;
   if HorzScrollBar.Visible then HorzScrollBar.Position:=0;
   if VertScrollBar.Visible then VertScrollBar.Position:=0;
   Visible:=False;
   if FBPPNDGraph.Scaled2 then FBPPNDGraph.Scaled2:=False;
   if FBPPNDGraph.Scaled then FBPPNDGraph.Scaled:=False;
   FPrinting:=True;
   rw:=iw/FBPPNDGraph.DefWidth;
   rh:=ih/FBPPNDGraph.DefHeight;
   wc:=rw;
   hc:=rh;
   case pgAlg of
      pg_Min:     Ratio:=GetCoof(rw,rh,FFormatAlg[0]);
      pg_Middle:  Ratio:=GetCoof(rw,rh,FFormatAlg[1]);
      pg_Max:     Ratio:=GetCoof(rw,rh,FFormatAlg[2]);
   end; {case pgAlg }
   FBPPNDGraph.SetDefaultConstants;
   FBPPNDGraph.SetScaledConstants(rw,rh,ratio,ratio);
   FBPPNDGraph.DefHeight:=ih;
   FBPPNDGraph.DefWidth:=iw;
   FBPPNDGraph.Printing:=True;
   FBPPNDGraph.CreateGraphNodes(wc,hc);
   FBPPNDGraph.CreateGraphLinks(wc,hc);
   FBPPNDGraph.PresetupFrame(wc,hc);
   FBPPNDGraph.TraceRoute;
   Repaint;
   while FPainting do;
   nw:=FBPPNDGraph.NodeWidth;
   nh:=FBPPNDGraph.NodeHeight;
   mw:=FBPPNDGraph.MaxWidth;
   mh:=FBPPNDGraph.MaxHeight;
   rw:=ratio*nw/mw;
   rh:=ratio*nh/mh;
   case pgAlg of
       pg_Min:     fontRatio:=GetCoof(rw,rh,FFormatAlg[0]);
       pg_Middle:  fontRatio:=GetCoof(rw,rh,FFormatAlg[1]);
       pg_Max:     fontRatio:=GetCoof(rw,rh,FFormatAlg[2]);
   end;
{   if fontRatio>ratio then fontRatio:=ratio;}
   FBPPNDGraph.DefHeight:=ih;
   FBPPNDGraph.DefWidth:=iw;
   FBPPNDGraph.SetDefaultConstants;
   FBPPNDGraph.SetScaledConstants(wc,hc,ratio,fontRatio);
   FBPPNDGraph.CreateGraphNodes(wc,hc);
   FBPPNDGraph.CreateGraphLinks(wc,hc);
   FBPPNDGraph.PresetupFrame(wc,hc);
   FBPPNDGraph.TraceRoute;
   Repaint;
   while FPainting do;
   value:=TBitmap.Create;
   value.PixelFormat:=pf;
   value.Width:=iw;
   value.Height:=ih;
   while FPainting do;
   value.Canvas.Lock;
   PaintTo(value.Canvas.Handle,0,0);
   value.Canvas.Unlock;
  finally
   FPrinting:=False;
   FBPPNDGraph.SetDefaultConstants;
   FBPPNDGraph.Printing:=oldPrinting;
   FBPPNDGraph.CreateGraphNodes(1,1);
   FBPPNDGraph.CreateGraphLinks(1,1);
{   FBPPNDGraph.CheckLinksAndNodes;}
   FBPPNDGraph.SetScaled2(oldScaled2);
   FBPPNDGraph.SetScaled(oldScaled);
   if (not(oldScaled)) then FBPPNDGraph.PresetupFrame(1,1);
   FUpdatingNavigator:=False;
   FBPPNDGraph.TraceRoute;
   Invalidate;
   Visible:=True;
  end;
 end;

procedure  TBPPNDFrame.CreateBitmapForOneShit(var value:TBitmap;pf:TPixelFormat;iw,ih,shitw,shith,maxshitw,maxshith:Integer);
Var oldScaled:Boolean;
    oldScaled2:Boolean;
    oldPrinting:Boolean;
    rw,rh:Double;
    ratio,fontRatio:Double;
    nw,nh:Integer;
    mw,mh:Integer;
    clRect:TRect;
    wc,hc:Double;
    pgalg:TBPPgAlg;
 begin
     try
   FUpdatingNavigator:=True;
   if (FBPPNDGraph.FMaxNodesCount>FNodesValue[0]) then
      begin
        if (FBPPNDGraph.FMaxNodesCount<FNodesValue[1]) then
          pgAlg:=pg_Middle
        else
          pgAlg:=pg_Max;
      end
     else pgalg:=pg_Min;
   oldScaled:=FBPPNDGraph.Scaled;
   oldScaled2:=FBPPNDGraph.Scaled2;
   oldPrinting:=FBPPNDGraph.Printing;
   if HorzScrollBar.Visible then HorzScrollBar.Position:=0;
   if VertScrollBar.Visible then VertScrollBar.Position:=0;
   Visible:=False;
   if FBPPNDGraph.Scaled2 then FBPPNDGraph.Scaled2:=False;
   if FBPPNDGraph.Scaled then FBPPNDGraph.Scaled:=False;
   FPrinting:=True;
   rw:=(iw*maxshitw)/FBPPNDGraph.DefWidth;
   rh:=(ih*maxshith)/FBPPNDGraph.DefHeight;
   wc:=rw;
   hc:=rh;
   case pgAlg of
      pg_Min:     Ratio:=GetCoof(rw,rh,FFormatAlg[0]);
      pg_Middle:  Ratio:=GetCoof(rw,rh,FFormatAlg[1]);
      pg_Max:     Ratio:=GetCoof(rw,rh,FFormatAlg[2]);
   end; {case pgAlg }
   FBPPNDGraph.SetDefaultConstants;
   FBPPNDGraph.SetScaledConstants(rw,rh,ratio,ratio);
   FBPPNDGraph.DefHeight:=ih*maxshith;
   FBPPNDGraph.DefWidth:=iw*maxshitw;
   FBPPNDGraph.Printing:=True;
   FBPPNDGraph.CreateGraphNodes(wc,hc);
   FBPPNDGraph.CreateGraphLinks(wc,hc);
   FBPPNDGraph.PresetupFrame(wc,hc);
   FBPPNDGraph.TraceRoute;
   Repaint;
   while FPainting do;
   nw:=FBPPNDGraph.NodeWidth;
   nh:=FBPPNDGraph.NodeHeight;
   mw:=FBPPNDGraph.MaxWidth;
   mh:=FBPPNDGraph.MaxHeight;
   rw:=ratio*nw/mw;
   rh:=ratio*nh/mh;
   case pgAlg of
       pg_Min:     fontRatio:=GetCoof(rw,rh,FFormatAlg[0]);
       pg_Middle:  fontRatio:=GetCoof(rw,rh,FFormatAlg[1]);
       pg_Max:     fontRatio:=GetCoof(rw,rh,FFormatAlg[2]);
   end;
{   if fontRatio>ratio then fontRatio:=ratio;}
   FBPPNDGraph.DefHeight:=ih*maxshith;
   FBPPNDGraph.DefWidth:=iw*maxshitw;
   FBPPNDGraph.SetDefaultConstants;
   FBPPNDGraph.SetScaledConstants(wc,hc,ratio,fontRatio);
   FBPPNDGraph.CreateGraphNodes(wc,hc);
   FBPPNDGraph.CreateGraphLinks(wc,hc);
   FBPPNDGraph.PresetupFrame(wc,hc);
   FBPPNDGraph.TraceRoute;
   Repaint;
   while FPainting do;
   value:=TBitmap.Create;
   value.PixelFormat:=pf;
   value.Width:=iw;
   value.Height:=ih;
   while FPainting do;
   clrect.Left:=shitw*iw;
   clRect.Right:=(shitw+1)*iw;
   clrect.Top:=shith*ih;
   clrect.Bottom:=(shith+1)*ih;
   value.Canvas.Lock;
   PaintPageTo(Value.Canvas.Handle,0,0,clrect);
   value.Canvas.Unlock;
  finally
   FPrinting:=False;
   FBPPNDGraph.SetDefaultConstants;
   FBPPNDGraph.Printing:=oldPrinting;
   FBPPNDGraph.CreateGraphNodes(1,1);
   FBPPNDGraph.CreateGraphLinks(1,1);
   FBPPNDGraph.SetScaled2(oldScaled2);
   FBPPNDGraph.SetScaled(oldScaled);
   if (not(oldScaled)) then FBPPNDGraph.PresetupFrame(1,1);
   FUpdatingNavigator:=False;
   FBPPNDGraph.TraceRoute;
   Invalidate;
   Visible:=True;
  end;
 end;

procedure  TBPPNDFrame.CreatePreview;
Var savedOrd:TPrinterOrientation;
    pw,ph:Integer;
    fpl,fpr,fpt,fpb:Integer;
    ratio,fontRatio:Double;
    dc:HDC;
    rw,rh:Double;
    scrppi:LongInt;
    ramkaH:Integer;
    nw,nh,mw,mh:Integer;
    oldScaled:Boolean;
    oldScaled2:Boolean;
    px,py:Integer;
    clRect:TRect;
    aSize:Integer;
    tmpi:TQRPaperSize;
    FTmp:Double;
    wc,hc:Double;
    pgalg:TBPPgAlg;
 begin
  { Create QRPreview }
   oldScaled:=BPPNDGraph.Scaled;
   oldScaled2:=BPPNDGraph.Scaled2;
   FUpdatingNavigator:=True;
   FPreviewOrPrint:=True;
   if (FBPPNDGraph.FMaxNodesCount>FNodesValue[0]) then
      begin
        if (FBPPNDGraph.FMaxNodesCount<FNodesValue[1]) then
          pgAlg:=pg_Middle
        else
          pgAlg:=pg_Max;
      end
     else pgalg:=pg_Min;
   FBPPNDGraph.Scaled2:=False;
   if FBPPNDGraph.FScaled then FBPPNDGraph.Scaled:=False;
   if HorzScrollBar.Visible then HorzScrollBar.Position:=0;
   if VertScrollBar.Visible then VertScrollBar.Position:=0;
   if (fPrinter<>nil) then fPrinter.Free;
   savedOrd:=Printer.Orientation;
   Printer.Orientation:=CurPrinterOrientation;
   FPrinter:=TQRPrinter.Create;
   FPrinter.Orientation:=CurPrinterOrientation;
   try
    FPrinting:=True;
    FPrinter.Cleanup;
    FPrinter.BeginDoc;
    FPrinter.Orientation:=CurPrinterOrientation;
    Printer.Orientation:=CurPrinterOrientation;
    FPrinter.PrinterIndex:=Printer.PrinterIndex;
    aSize:=Printer.PaperSize;
    FPrinter.PaperSize:=Default;
    FRamkaFontRatio:=1.0;
    FPSizeH:=21;
    FPSizeW:=29.7;
    for tmpi:= Default to Custom do
     begin
      if aSize=cQRPaperTranslate[tmpI] then
         begin
           FPrinter.PaperSize := tmpI;
           FRamkaFontRatio:=cQRPaperSizeMetrics[tmpI,0]/cQRPaperSizeMetrics[A4,0];
           FPSizeH:=cQRPaperSizeMetrics[tmpI,0]/10;
           FPSizeW:=cQRPaperSizeMetrics[tmpI,1]/10;
         end;
     end;
     FPrinter.PaperLength:=Printer.PaperLength;
     FPrinter.PaperWidth:=Printer.PaperWidth;
   dc:=GetDC(0);
   scrppi:=GetDeviceCaps(dc,LOGPIXELSX);
   FFontCoof:=1;
   FBPPNDGraph.UpdateMaxFontSize(1);
   ReleaseDC(0,dc);
   ramkaH:=Round(scrppi/2.54);
   FRamkaH:=ramkaH;
    FPrinter.NewPage;
   if CurPrinterOrientation=poPortrait then
   begin
    pw:= FPrinter.XSize(FPrinter.PaperWidth);
    ph:= FPrinter.YSize(FPrinter.PaperLength);
   end
   else
   begin
    pw:= FPrinter.XSize(FPrinter.PaperLength);
    ph:= FPrinter.YSize(FPrinter.PaperWidth);
   end;
   if ((FHorzPageCount=1) and (FVertPageCount=1)) then
    ph:=ph-ramkaH;
   rw:=(pw*FHorzPageCount)/FBPPNDGraph.DefWidth;
   rh:=(ph*FVertPageCount)/FBPPNDGraph.DefHeight;
{   wc:=rw;
    hc:=rh; }
   case pgAlg of
      pg_Min:     Ratio:=GetCoof(rw,rh,FFormatAlg[0]);
      pg_Middle:  Ratio:=GetCoof(rw,rh,FFormatAlg[1]);
      pg_Max:     Ratio:=GetCoof(rw,rh,FFormatAlg[2]);
   end; {case pgAlg }
   fpl:=FPrinter.XSize(FPageLeft*10);
   fpr:=FPrinter.XSize(FPageRight*10);
   fpt:=FPrinter.YSize(FPageTop*10);
   fpb:=FPrinter.YSize(FPageBottom*10);
   wc:=FBPPNDGraph.DefWidth;
   hc:=FBPPNDGraph.DefHeight;
   FBPPNDGraph.SetDefaultConstants;
   FBPPNDGraph.SetScaledConstants(rw,rh,ratio,ratio);
   FBPPNDGraph.DefWidth:=(PW*FHorzPageCount-FPL*FHorzPageCount-FPR*FHorzPageCount);
   if ((FHorzPageCount=1) and (FVertPageCount=1)) then
     FBPPNDGraph.DefHeight:=(PH*FVertPageCount-FPT*FVertPageCount-FPB*FVertPageCount-ramkaH*FVertPageCount)
   else
     FBPPNDGraph.DefHeight:=(PH*FVertPageCount-FPT*FVertPageCount-FPB*FVertPageCount);
   wc:=FBPPNDGraph.DefWidth/wc;
   hc:=FBPPNDGraph.DefHeight/hc;
   FBPPNDGraph.Printing:=True;
   FBPPNDGraph.CreateGraphNodes(wc,hc);
   FBPPNDGraph.CreateGraphLinks(wc,hc);
   FBPPNDGraph.PresetupFrame(wc,hc);
   FBPPNDGraph.TraceRoute;
   Repaint;
   while FPainting do;
    nw:=FBPPNDGraph.NodeWidth;
    nh:=FBPPNDGraph.NodeHeight;
    mw:=FBPPNDGraph.MaxWidth;
    mh:=FBPPNDGraph.MaxHeight;
    rw:=ratio*nw/mw;
    rh:=ratio*nh/mh;
    case pgAlg of
       pg_Min:     fontRatio:=GetCoof(rw,rh,FFormatAlg[0]);
       pg_Middle:  fontRatio:=GetCoof(rw,rh,FFormatAlg[1]);
       pg_Max:     fontRatio:=GetCoof(rw,rh,FFormatAlg[2]);
     end;
{    if fontRatio>ratio then fontRatio:=ratio;}
    FBPPNDGraph.DefWidth:=(PW*FHorzPageCount-FPL*FHorzPageCount-FPR*FHorzPageCount);
    if ((FHorzPageCount=1) and (FVertPageCount=1)) then
      FBPPNDGraph.DefHeight:=(PH*FVertPageCount-FPT*FVertPageCount-FPB*FVertPageCount-ramkaH*FVertPageCount)
    else
     FBPPNDGraph.DefHeight:=(PH*FVertPageCount-FPT*FVertPageCount-FPB*FVertPageCount);
    FBPPNDGraph.SetDefaultConstants;
    FBPPNDGraph.SetScaledConstants(wc,hc,ratio,fontRatio);
    FBPPNDGraph.CreateGraphNodes(wc,hc);
    FBPPNDGraph.CreateGraphLinks(wc,hc);
    FBPPNDGraph.PresetupFrame(wc,hc);
    FBPPNDGraph.TraceRoute;
    Repaint;
    while FPainting do;
    for px:=1 to FHorzPageCount do
    begin
     clrect.Left:=(px-1)*(pw-fpl-fpr);
     clRect.Right:=px*(pw-fpl-fpr);
     for py:=1 to FVertPageCount do
     begin
      clrect.Top:=(py-1)*(ph-fpt-fpb);
      clrect.Bottom:=py*(ph-fpt-fpb);
      if ((FHorzPageCount=1) and (FVertPageCount=1)) then
       begin
         PaintTo(FPrinter.Canvas.Handle,fpl,fpt+ramkaH);
         PreviewPrintRect(FPageLeft,pw-FPageRight,FPageTop,ph+ramkaH-FPageBottom);
       end
       else
        begin
         PaintPageTo(FPrinter.Canvas.Handle,fpl,fpt{+ramkaH},clrect);
         PreviewPrintRect(fpl,pw-fpr,fpt,ph-fpb);
        end;
      if ((px<>FHorzPageCount) or (py<>FVertPageCount)) then FPrinter.NewPage;
     end;
    end;
   finally
    FPrinter.EndDoc;
    FPrinting:=False;
    FUpdatingNavigator:=False;
    FPreviewOrPrint:=False;
    FHorzPageCount:=1;
    FVertPageCount:=1;
    FBPPNDGraph.SetDefaultConstants;
    FBPPNDGraph.Printing:=False;
    FBPPNDGraph.CreateGraphNodes(1,1);
    FBPPNDGraph.CreateGraphLinks(1,1);
{    FBPPNDGraph.CheckLinksAndNodes;}
    FBPPNDGraph.SetScaled2(oldScaled2);
    FBPPNDGraph.SetScaled(oldScaled);
    if (not(oldScaled)) then FBPPNDGraph.PresetupFrame(1,1);
    FBPPNDGraph.TraceRoute;
    Invalidate;
   end;
 end;

procedure  TBPPNDFrame.PrintAll(pb:TFlatProgressBar;Lbl:TLabel;StartP,EndP:Integer);
Var  oldLevel:Integer;
     tmpTree:PBPTree;
     i,j:Integer;
     prnppi,scrppi:Integer;
     w,h:Integer;
     prnx,prny:Integer;
     dc:HDC;
     ratio,fontRatio:Double;
     rw,rh:Double;
     ramkaH:Integer;
     nw,nh,mw,mh:Integer;
     oldScaled:Boolean;
     oldScaled2:Boolean;
     clRect:TRect;
     px,py:Integer;
     pw,ph:Double;
     tmpI:TQRPaperSize;
     asize:Integer;
     wc,hc:Double;
     pc:Integer;
     pgalg:TBPPgAlg;
 begin
   { Print All Pages }
  oldScaled:=BPPNDGraph.Scaled;
  oldScaled2:=BPPNDGraph.Scaled2;
  oldLevel:=-1;
  if FBPPNDGraph.FTree=nil then Exit;
  FUpdatingNavigator:=True;
  FPreviewOrPrint:=True;
  FBPPNDGraph.Scaled2:=False;
  if FBPPNDGraph.FScaled then FBPPNDGraph.Scaled:=False;
  tmpTree:=FBPPNDGraph.FTree;
  try
   FPrinting:=True;
  { Store old viewing level }
   oldLevel:=FBPPNDGraph.FLevel;
   i:=0;
   pc:=0;
   prnppi:=GetDeviceCaps(Printer.Handle,LOGPIXELSX);
   ramkaH:=Round(prnppi/2.54);
   FRamkaH:=ramkaH;
   dc:=GetDC(self.Handle);
   scrppi:=GetDeviceCaps(dc,LOGPIXELSX);
   FFontCoof:=GetDeviceCaps(Printer.Handle,LOGPIXELSX)/GetDeviceCaps(dc,LOGPIXELSX);
   FBPPNDGraph.UpdateMaxFontSize(1);
   ReleaseDC(self.Handle,dc);
   aSize:=Printer.PaperSize;
   FRamkaFontRatio:=1.0;
   FPSizeH:=21;
   FPSizeW:=29.7;
   for tmpi:= Default to Custom do
     begin
      if aSize=cQRPaperTranslate[tmpI] then
         begin
           FRamkaFontRatio:=cQRPaperSizeMetrics[tmpI,0]/cQRPaperSizeMetrics[A4,0];
           FPSizeH:=cQRPaperSizeMetrics[tmpI,0]/10;
           FPSizeW:=cQRPaperSizeMetrics[tmpI,1]/10;
         end;
     end;
   { New Code }
   pw:= GetDeviceCaps(Printer.Handle,VERTRES);
   ph:= GetDeviceCaps(Printer.Handle,HORZRES);
   if ((FHorzPageCount=1) and (FVertPageCount=1)) then
    ph:=ph - ramkaH;
   { End New Code }
  { ratio:=(prnppi*FHorzPageCount) / scrppi;}
   Printer.BeginDoc;
   while (tmpTree<>nil) and (not(FAborting)) do
    begin
     FBPPNDGraph.OpenLevel(tmpTree^.dwLevel);
     FBPPNDGraph.TraceRoute;
     if (FBPPNDGraph.FMaxNodesCount>FNodesValue[0]) then
      begin
        if (FBPPNDGraph.FMaxNodesCount<FNodesValue[1]) then
          pgAlg:=pg_Middle
        else
          pgAlg:=pg_Max;
      end
     else pgalg:=pg_Min;
     if HorzScrollBar.Visible then HorzScrollBar.Position:=0;
     if VertScrollBar.Visible then VertScrollBar.Position:=0;
     Repaint;
     for j:=0 to 0 do
     begin
     FBPPNDGraph.OpenLevel(tmpTree^.dwLevel);
     FBPPNDGraph.TraceRoute;
     if (pc>=StartP) and (pc<=EndP)  then
     begin
     inc(i);
     pb.Position:=Round((i-1)*100/(EndP-StartP+1));
     Lbl.Caption:=IntToStr(pb.Position);
     pb.Update;
     lbl.Update;
     Application.ProcessMessages;
     if FAborting then break;
     while (FPainting) do;
     { New Code }
     rw:=(pw*FHorzPageCount)/FBPPNDGraph.DefWidth;
     rh:=(ph*FVertPageCount)/FBPPNDGraph.DefHeight;
     wc:=FBPPNDGraph.DefWidth;
     hc:=FBPPNDGraph.DefHeight;
     case pgAlg of
      pg_Min:     Ratio:=GetCoof(rw,rh,FFormatAlg[0]);
      pg_Middle:  Ratio:=GetCoof(rw,rh,FFormatAlg[1]);
      pg_Max:     Ratio:=GetCoof(rw,rh,FFormatAlg[2]);
     end; {case pgAlg }
    { End New Code }
     FBPPNDGraph.SetScaledConstants(rw,rh,ratio,ratio);
     FBPPNDGraph.DefWidth:=FHorzPageCount*(Printer.PageWidth-FPageLeft-FPageRight);
     if ((FHorzPageCount=1) and (FVertPageCount=1)) then
      FBPPNDGraph.DefHeight:=FVertPageCount*(Printer.PageHeight-FPageTop-FPageBottom-ramkaH)
     else
      FBPPNDGraph.DefHeight:=FVertPageCount*(Printer.PageHeight-FPageTop-FPageBottom);
     wc:=FBPPNDGraph.DefWidth/wc;
     hc:=FBPPNDGraph.DefHeight/hc;
     FBPPNDGraph.Printing:=True;
     FBPPNDGraph.CreateGraphNodes(wc,hc);
     FBPPNDGraph.CreateGraphLinks(wc,hc);
     FBPPNDGraph.PresetupFrame(wc,hc);
     FBPPNDGraph.TraceRoute;
     Repaint;
     while FPainting do;
     nw:=FBPPNDGraph.NodeWidth;
     nh:=FBPPNDGraph.NodeHeight;
     mw:=FBPPNDGraph.MaxWidth;
     mh:=FBPPNDGraph.MaxHeight;
     rw:=ratio*nw/mw;
     rh:=ratio*nh/mh;
     case pgAlg of
       pg_Min:     fontRatio:=GetCoof(rw,rh,FFormatAlg[0]);
       pg_Middle:  fontRatio:=GetCoof(rw,rh,FFormatAlg[1]);
       pg_Max:     fontRatio:=GetCoof(rw,rh,FFormatAlg[2]);
     end;
{     if fontRatio>ratio then fontRatio:=ratio;}
     FBPPNDGraph.DefWidth:=FHorzPageCount*(Printer.PageWidth-FPageLeft-FPageRight);
     if ((FHorzPageCount=1) and (FVertPageCount=1)) then
      FBPPNDGraph.DefHeight:=FVertPageCount*(Printer.PageHeight-FPageTop-FPageBottom-ramkaH)
     else
      FBPPNDGraph.DefHeight:=FVertPageCount*(Printer.PageHeight-FPageTop-FPageBottom);
     FBPPNDGraph.SetDefaultConstants;
     FBPPNDGraph.SetScaledConstants(wc,hc,ratio,fontRatio);
     FBPPNDGraph.CreateGraphNodes(wc,hc);
     FBPPNDGraph.CreateGraphLinks(wc,hc);
     FBPPNDGraph.PresetupFrame(wc,hc);
     FBPPNDGraph.TraceRoute;
     Repaint;
     while FPainting do;
    for px:=1 to FHorzPageCount do
    begin
     clRect.Left:=(px-1)*(Printer.PageWidth-FPageRight-FPageLeft);
     clRect.Right:=px*(Printer.PageWidth-FPageRight-FPageLeft);
    for py:=1 to FVertPageCount do
     begin
     clRect.Top:=(py-1)*(Printer.PageHeight-FPageTop-FPageBottom);
     clRect.Bottom:=py*(Printer.PageHeight-FPageTop-FPageBottom);
     if ((FHorzPageCount=1) and (FVertPageCount=1)) then
       begin
        PaintTo(Printer.Handle,FPageLeft,FPageTop+ramkaH);
        PrintRect(FPageLeft,Printer.PageWidth-FPageRight,
                           FPageTop,Printer.PageHeight-FPageBottom);
       end
      else
       begin
        PaintPageTo(Printer.Handle,FPageLeft,FPageTop,clRect);
        PrintRect(FPageLeft,Printer.PageWidth-FPageRight,
                           FPageTop,Printer.PageHeight-FPageBottom);
       end;
       if ((FHorzPageCount<>px) or (FVertPageCount<>py)) then
        Printer.NewPage;
     end;
    end;
     FBPPNDGraph.SetDefaultConstants;
     FBPPNDGraph.Printing:=False;
     FBPPNDGraph.CreateGraphNodes(1,1);
     FBPPNDGraph.CreateGraphLinks(1,1);
     FBPPNDGraph.PresetupFrame(1,1);
     FBPPNDGraph.TraceRoute;
     Invalidate;
     if ((tmpTree^.next<>nil) and (pc<EndP))
      or ((j<>0) and (pc<EndP))  then Printer.NewPage; { Wrong !!! }
     end; { StartP, EndP}
     inc(pc);
     end; { For Diags do }
      tmpTree:=tmpTree^.next;
    end;  { while }
   if FAborting then Printer.Abort
   else Printer.EndDoc;
  finally
   { Restore old viewing level}
   FPrinting:=False;
   FUpdatingNavigator:=False;
   FPreviewOrPrint:=False;
   FBPPNDGraph.SetDefaultConstants;
   FBPPNDGraph.Printing:=False;
   FBPPNDGraph.CreateGraphNodes(1,1);
   FBPPNDGraph.CreateGraphLinks(1,1);
   FBPPNDGraph.SetScaled2(oldScaled2);
   FBPPNDGraph.SetScaled(oldScaled);
   if (not(oldScaled)) then FBPPNDGraph.PresetupFrame(1,1);
   FBPPNDGraph.TraceRoute;
   Invalidate;
   pb.Position:=100;
   lbl.Caption:=IntToStr(pb.Position);
   pb.Update;
   lbl.Update;
   FBPPNDGraph.OpenLevel(oldLevel);
   FBPPNDGraph.TraceRoute;
   Invalidate;
  end;
 end;

procedure  TBPPNDFrame.CreatePreviewAll(pb:TFlatProgressBar;Lbl:TLabel);
Var savedOrd:TPrinterOrientation;
    pw,ph:Integer;
    fpl,fpr,fpt,fpb:Integer;
    ratio,fontRatio:Double;
    rw,rh:Double;
    dc:HDC;
    scrppi:LongInt;
    ramkaH:Integer;
    nw,nh,mw,mh:Integer;
    oldLevel:Integer;
    tmpTree:PBPTree;
    i,j:Integer;
    oldScaled:Boolean;
    oldScaled2:Boolean;
    px,py:Integer;
    clrect:TRect;
    aSize:Integer;
    tmpi:TQRPaperSize;
    wc,hc:Double;
    pgalg:TBPPgAlg;
 begin
  { Create QRPreview Model }
   oldScaled:=BPPNDGraph.Scaled;
   oldScaled2:=BPPNDGraph.Scaled2;
   if FBPPNDGraph.FTree=nil then Exit;
   FUpdatingNavigator:=True;
   FPreviewOrPrint:=True;
   FBPPNDGraph.Scaled2:=False;
   if FBPPNDGraph.FScaled then FBPPNDGraph.Scaled:=False;
   tmpTree:=FBPPNDGraph.FTree;
   if (fPrinter<>nil) then fPrinter.Free;
   savedOrd:=Printer.Orientation;
   Printer.Orientation:=CurPrinterOrientation;
   oldLevel:=FBPPNDGraph.FLevel;
   FPrinter:=TQRPrinter.Create;
   FPrinter.Orientation:=CurPrinterOrientation;
   try
    FPrinting:=True;
    FPrinter.Cleanup;
    FPrinter.BeginDoc;
    FPrinter.Orientation:=CurPrinterOrientation;
    Printer.Orientation:=CurPrinterOrientation;
    FPrinter.PrinterIndex:=Printer.PrinterIndex;
    aSize:=Printer.PaperSize;
    FPrinter.PaperSize:=Default;
    FRamkaFontRatio:=1.0;
    FPSizeH:=21;
    FPSizeW:=29.7;
    for tmpi:= Default to Custom do
     begin
      if aSize=cQRPaperTranslate[tmpI] then
         begin
           FPrinter.PaperSize := tmpI;
           FRamkaFontRatio:=cQRPaperSizeMetrics[tmpI,0]/cQRPaperSizeMetrics[A4,0];
           FPSizeH:=cQRPaperSizeMetrics[tmpI,0]/10;
           FPSizeW:=cQRPaperSizeMetrics[tmpI,1]/10;
         end;
     end;
    FPrinter.PaperLength:=Printer.PaperLength;
    FPrinter.PaperWidth:=Printer.PaperWidth;
    dc:=GetDC(0);
    scrppi:=GetDeviceCaps(dc,LOGPIXELSX);
    FFontCoof:=1;
    FBPPNDGraph.UpdateMaxFontSize(1);
    ReleaseDC(0,dc);
    ramkaH:=Round(scrppi/2.54);
    FRamkaH:=ramkaH;
    FPrinter.NewPage;
   if CurPrinterOrientation=poPortrait then
   begin
    pw:= FPrinter.XSize(FPrinter.PaperWidth);
    ph:= FPrinter.YSize(FPrinter.PaperLength);
   end
   else
   begin
    pw:= FPrinter.XSize(FPrinter.PaperLength);
    ph:= FPrinter.YSize(FPrinter.PaperWidth);
   end;
   if ((FHorzPageCount=1) and (FVertPageCount=1)) then
     ph:=ph - ramkaH;
   fpl:=FPrinter.XSize(FPageLeft*10);
   fpr:=FPrinter.XSize(FPageRight*10);
   fpt:=FPrinter.YSize(FPageTop*10);
   fpb:=FPrinter.YSize(FPageBottom*10);
   i:=0;
   while (tmpTree<>nil) and (not(FAborting)) do
    begin  { while }
     FBPPNDGraph.OpenLevel(tmpTree^.dwLevel);
     FBPPNDGraph.TraceRoute;
     Repaint;
     if (FBPPNDGraph.FMaxNodesCount>FNodesValue[0]) then
      begin
        if (FBPPNDGraph.FMaxNodesCount<FNodesValue[1]) then
          pgAlg:=pg_Middle
        else
          pgAlg:=pg_Max;
      end
     else pgalg:=pg_Min;
     for j:=0 to 0 do
      begin
       FBPPNDGraph.OpenLevel(tmpTree^.dwLevel);
       FBPPNDGraph.TraceRoute;
       Repaint;
     inc(i);
     pb.Position:=Round((i-1)*100/FBPPNDGraph.FRootEntries);
     lbl.Caption:=IntToStr(pb.Position);
     pb.Update;
     lbl.Update;
     Application.ProcessMessages;
     if FAborting then break;
     while (FPainting) do;
     if HorzScrollBar.Visible then HorzScrollBar.Position:=0;
     if VertScrollBar.Visible then VertScrollBar.Position:=0;
     rw:=(pw*FHorzPageCount)/FBPPNDGraph.DefWidth;
     rh:=(ph*FVertPageCount)/FBPPNDGraph.DefHeight;
     wc:=FBPPNDGraph.DefWidth;
     hc:=FBPPNDGraph.DefHeight;
     case pgAlg of
      pg_Min:     Ratio:=GetCoof(rw,rh,FFormatAlg[0]);
      pg_Middle:  Ratio:=GetCoof(rw,rh,FFormatAlg[1]);
      pg_Max:     Ratio:=GetCoof(rw,rh,FFormatAlg[2]);
     end; {case pgAlg }
     FBPPNDGraph.SetDefaultConstants;
     FBPPNDGraph.SetScaledConstants(rw,rh,ratio,ratio);
     FBPPNDGraph.DefWidth:=(PW*FHorzPageCount-FPL*FHorzPageCount-FPR*FHorzPageCount);
     if ((FHorzPageCount=1) and (FVertPageCount=1)) then
      FBPPNDGraph.DefHeight:=(PH*FVertPageCount-FPT*FVertPageCount-FPB*FVertPageCount-ramkaH*FVertPageCount)
     else
      FBPPNDGraph.DefHeight:=(PH*FVertPageCount-FPT*FVertPageCount-FPB*FVertPageCount);
     wc:=FBPPNDGraph.DefWidth/wc;
     hc:=FBPPNDGraph.DefHeight/hc;
     FBPPNDGraph.Printing:=True;
     FBPPNDGraph.CreateGraphNodes(wc,hc);
     FBPPNDGraph.CreateGraphLinks(wc,hc);
     FBPPNDGraph.PresetupFrame(wc,hc);
     FBPPNDGraph.TraceRoute;
     Repaint;
    while FPainting do;
    nw:=FBPPNDGraph.NodeWidth;
    nh:=FBPPNDGraph.NodeHeight;
    mw:=FBPPNDGraph.MaxWidth;
    mh:=FBPPNDGraph.MaxHeight;
    rw:=ratio*nw/mw;
    rh:=ratio*nh/mh;
    case pgAlg of
       pg_Min:     fontRatio:=GetCoof(rw,rh,FFormatAlg[0]);
       pg_Middle:  fontRatio:=GetCoof(rw,rh,FFormatAlg[1]);
       pg_Max:     fontRatio:=GetCoof(rw,rh,FFormatAlg[2]);
    end;
{    if fontRatio>ratio then fontRatio:=ratio;}
    FBPPNDGraph.DefWidth:=(PW*FHorzPageCount-FPL*FHorzPageCount-FPR*FHorzPageCount);
    if ((FHorzPageCount=1) and (FVertPageCount=1)) then
     FBPPNDGraph.DefHeight:=(PH*FVertPageCount-FPT*FVertPageCount-FPB*FVertPageCount-ramkaH*FVertPageCount)
    else
    FBPPNDGraph.DefHeight:=(PH*FVertPageCount-FPT*FVertPageCount-FPB*FVertPageCount);
    FBPPNDGraph.SetDefaultConstants;
    FBPPNDGraph.SetScaledConstants(wc,hc,ratio,fontRatio);
    FBPPNDGraph.CreateGraphNodes(wc,hc);
    FBPPNDGraph.CreateGraphLinks(wc,hc);
    FBPPNDGraph.PresetupFrame(wc,hc);
    FBPPNDGraph.TraceRoute;
    Repaint;
    while FPainting do;
    for px:=1 to FHorzPageCount do
     begin
      clRect.Left:=(px-1)*(pw-fpl-fpr);
      clRect.Right:=px*(pw-fpl-fpr);
      for py:=1 to FVertPageCount do
       begin
        clRect.Top:=(py-1)*(ph-fpt-fpb);
        clRect.Bottom:=py*(ph-fpt-fpb);
        if ((FHorzPageCount=1) and (FVertPageCount=1)) then
         begin
          PaintTo(FPrinter.Canvas.Handle,fpl,fpt+ramkaH);
          PreviewPrintRect(fpl,pw-fpr,fpt,ph-fpb);
         end
        else
         begin
          PaintPageTo(FPrinter.Canvas.Handle,fpl,fpt,clRect);
          PreviewPrintRect(fpl,pw-fpr,fpt,ph-fpb);
         end;
         if ((FHorzPageCount<>px) or (FVertPageCount<>py)) then
          FPrinter.NewPage;
       end;
     end;
     if (j<>0) then FPrinter.NewPage;
    end; { For Diags }
    tmpTree:=tmpTree^.next;
    if tmpTree<>nil then FPrinter.NewPage;
   end; { while }
   finally
    if FAborting then FPrinter.AbortDoc else
    FPrinter.EndDoc;
    FPrinting:=False;
    FUpdatingNavigator:=False;
    FPreviewOrPrint:=False;
    FBPPNDGraph.SetDefaultConstants;
    FBPPNDGraph.Printing:=False;
    FBPPNDGraph.CreateGraphNodes(1,1);
    FBPPNDGraph.CreateGraphLinks(1,1);
    FBPPNDGraph.SetScaled2(oldScaled2);
    FBPPNDGraph.SetScaled(oldScaled);
    if (not(oldScaled)) then FBPPNDGraph.PresetupFrame(1,1);
    FBPPNDGraph.TraceRoute;
    Invalidate;
    pb.Position:=100;
    lbl.Caption:=IntToStr(pb.Position);
    pb.Update;
    lbl.Update;
    FBPPNDGraph.OpenLevel(oldLevel);
    FBPPNDGraph.TraceRoute;
    Invalidate;
   end;
 end;

procedure Register;
 begin
   RegisterComponents('DeadSouls',[TBPPNDFrame]);
 end;

initialization
 CurPrinterOrientation:=poPortrait;

end.
